{"version":3,"file":"swiper-bundle.js.map","sources":["../node_modules/ssr-window/ssr-window.esm.js","../node_modules/dom7/dom7.esm.js","../src/utils/dom.js","../src/utils/utils.js","../src/utils/get-support.js","../src/utils/get-device.js","../src/utils/get-browser.js","../src/modules/resize/resize.js","../src/modules/observer/observer.js","../src/components/core/modular.js","../src/components/core/events-emitter.js","../src/components/core/update/updateSize.js","../src/components/core/update/updateSlides.js","../src/components/core/update/updateAutoHeight.js","../src/components/core/update/updateSlidesOffset.js","../src/components/core/update/updateSlidesProgress.js","../src/components/core/update/updateProgress.js","../src/components/core/update/updateSlidesClasses.js","../src/components/core/update/updateActiveIndex.js","../src/components/core/update/updateClickedSlide.js","../src/components/core/update/index.js","../src/components/core/translate/getTranslate.js","../src/components/core/translate/setTranslate.js","../src/components/core/translate/minTranslate.js","../src/components/core/translate/maxTranslate.js","../src/components/core/translate/translateTo.js","../src/components/core/translate/index.js","../src/components/core/transition/setTransition.js","../src/components/core/transition/transitionStart.js","../src/components/core/transition/transitionEnd.js","../src/components/core/transition/index.js","../src/components/core/slide/slideTo.js","../src/components/core/slide/slideToLoop.js","../src/components/core/slide/slideNext.js","../src/components/core/slide/slidePrev.js","../src/components/core/slide/slideReset.js","../src/components/core/slide/slideToClosest.js","../src/components/core/slide/slideToClickedSlide.js","../src/components/core/slide/index.js","../src/components/core/loop/loopCreate.js","../src/components/core/loop/loopFix.js","../src/components/core/loop/loopDestroy.js","../src/components/core/loop/index.js","../src/components/core/grab-cursor/setGrabCursor.js","../src/components/core/grab-cursor/unsetGrabCursor.js","../src/components/core/grab-cursor/index.js","../src/components/core/manipulation/appendSlide.js","../src/components/core/manipulation/prependSlide.js","../src/components/core/manipulation/addSlide.js","../src/components/core/manipulation/removeSlide.js","../src/components/core/manipulation/removeAllSlides.js","../src/components/core/manipulation/index.js","../src/components/core/events/onTouchStart.js","../src/components/core/events/onTouchMove.js","../src/components/core/events/onTouchEnd.js","../src/components/core/events/onResize.js","../src/components/core/events/onClick.js","../src/components/core/events/onScroll.js","../src/components/core/events/index.js","../src/components/core/breakpoints/setBreakpoint.js","../src/components/core/breakpoints/getBreakpoint.js","../src/components/core/breakpoints/index.js","../src/components/core/classes/addClasses.js","../src/components/core/classes/removeClasses.js","../src/components/core/classes/index.js","../src/components/core/images/loadImage.js","../src/components/core/images/preloadImages.js","../src/components/core/images/index.js","../src/components/core/check-overflow/index.js","../src/components/core/defaults.js","../src/components/core/core-class.js","../src/components/virtual/virtual.js","../src/components/keyboard/keyboard.js","../src/components/mousewheel/mousewheel.js","../src/components/navigation/navigation.js","../src/components/pagination/pagination.js","../src/components/scrollbar/scrollbar.js","../src/components/parallax/parallax.js","../src/components/zoom/zoom.js","../src/components/lazy/lazy.js","../src/components/controller/controller.js","../src/components/a11y/a11y.js","../src/components/history/history.js","../src/components/hash-navigation/hash-navigation.js","../src/components/autoplay/autoplay.js","../src/components/effect-fade/effect-fade.js","../src/components/effect-cube/effect-cube.js","../src/components/effect-flip/effect-flip.js","../src/components/effect-coverflow/effect-coverflow.js","../src/components/thumbs/thumbs.js","../src/swiper.js"],"sourcesContent":["/**\n * SSR Window 3.0.0\n * Better handling for window object in SSR environment\n * https://github.com/nolimits4web/ssr-window\n *\n * Copyright 2020, Vladimir Kharlampidi\n *\n * Licensed under MIT\n *\n * Released on: November 9, 2020\n */\n/* eslint-disable no-param-reassign */\nfunction isObject(obj) {\n    return (obj !== null &&\n        typeof obj === 'object' &&\n        'constructor' in obj &&\n        obj.constructor === Object);\n}\nfunction extend(target, src) {\n    if (target === void 0) { target = {}; }\n    if (src === void 0) { src = {}; }\n    Object.keys(src).forEach(function (key) {\n        if (typeof target[key] === 'undefined')\n            target[key] = src[key];\n        else if (isObject(src[key]) &&\n            isObject(target[key]) &&\n            Object.keys(src[key]).length > 0) {\n            extend(target[key], src[key]);\n        }\n    });\n}\n\nvar ssrDocument = {\n    body: {},\n    addEventListener: function () { },\n    removeEventListener: function () { },\n    activeElement: {\n        blur: function () { },\n        nodeName: '',\n    },\n    querySelector: function () {\n        return null;\n    },\n    querySelectorAll: function () {\n        return [];\n    },\n    getElementById: function () {\n        return null;\n    },\n    createEvent: function () {\n        return {\n            initEvent: function () { },\n        };\n    },\n    createElement: function () {\n        return {\n            children: [],\n            childNodes: [],\n            style: {},\n            setAttribute: function () { },\n            getElementsByTagName: function () {\n                return [];\n            },\n        };\n    },\n    createElementNS: function () {\n        return {};\n    },\n    importNode: function () {\n        return null;\n    },\n    location: {\n        hash: '',\n        host: '',\n        hostname: '',\n        href: '',\n        origin: '',\n        pathname: '',\n        protocol: '',\n        search: '',\n    },\n};\nfunction getDocument() {\n    var doc = typeof document !== 'undefined' ? document : {};\n    extend(doc, ssrDocument);\n    return doc;\n}\n\nvar ssrWindow = {\n    document: ssrDocument,\n    navigator: {\n        userAgent: '',\n    },\n    location: {\n        hash: '',\n        host: '',\n        hostname: '',\n        href: '',\n        origin: '',\n        pathname: '',\n        protocol: '',\n        search: '',\n    },\n    history: {\n        replaceState: function () { },\n        pushState: function () { },\n        go: function () { },\n        back: function () { },\n    },\n    CustomEvent: function CustomEvent() {\n        return this;\n    },\n    addEventListener: function () { },\n    removeEventListener: function () { },\n    getComputedStyle: function () {\n        return {\n            getPropertyValue: function () {\n                return '';\n            },\n        };\n    },\n    Image: function () { },\n    Date: function () { },\n    screen: {},\n    setTimeout: function () { },\n    clearTimeout: function () { },\n    matchMedia: function () {\n        return {};\n    },\n    requestAnimationFrame: function (callback) {\n        if (typeof setTimeout === 'undefined') {\n            callback();\n            return null;\n        }\n        return setTimeout(callback, 0);\n    },\n    cancelAnimationFrame: function (id) {\n        if (typeof setTimeout === 'undefined') {\n            return;\n        }\n        clearTimeout(id);\n    },\n};\nfunction getWindow() {\n    var win = typeof window !== 'undefined' ? window : {};\n    extend(win, ssrWindow);\n    return win;\n}\n\nexport { extend, getDocument, getWindow, ssrDocument, ssrWindow };\n","/**\n * Dom7 3.0.0\n * Minimalistic JavaScript library for DOM manipulation, with a jQuery-compatible API\n * https://framework7.io/docs/dom7.html\n *\n * Copyright 2020, Vladimir Kharlampidi\n *\n * Licensed under MIT\n *\n * Released on: November 9, 2020\n */\nimport { getWindow, getDocument } from 'ssr-window';\n\nfunction _inheritsLoose(subClass, superClass) {\n  subClass.prototype = Object.create(superClass.prototype);\n  subClass.prototype.constructor = subClass;\n  subClass.__proto__ = superClass;\n}\n\nfunction _getPrototypeOf(o) {\n  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {\n    return o.__proto__ || Object.getPrototypeOf(o);\n  };\n  return _getPrototypeOf(o);\n}\n\nfunction _setPrototypeOf(o, p) {\n  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {\n    o.__proto__ = p;\n    return o;\n  };\n\n  return _setPrototypeOf(o, p);\n}\n\nfunction _isNativeReflectConstruct() {\n  if (typeof Reflect === \"undefined\" || !Reflect.construct) return false;\n  if (Reflect.construct.sham) return false;\n  if (typeof Proxy === \"function\") return true;\n\n  try {\n    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));\n    return true;\n  } catch (e) {\n    return false;\n  }\n}\n\nfunction _construct(Parent, args, Class) {\n  if (_isNativeReflectConstruct()) {\n    _construct = Reflect.construct;\n  } else {\n    _construct = function _construct(Parent, args, Class) {\n      var a = [null];\n      a.push.apply(a, args);\n      var Constructor = Function.bind.apply(Parent, a);\n      var instance = new Constructor();\n      if (Class) _setPrototypeOf(instance, Class.prototype);\n      return instance;\n    };\n  }\n\n  return _construct.apply(null, arguments);\n}\n\nfunction _isNativeFunction(fn) {\n  return Function.toString.call(fn).indexOf(\"[native code]\") !== -1;\n}\n\nfunction _wrapNativeSuper(Class) {\n  var _cache = typeof Map === \"function\" ? new Map() : undefined;\n\n  _wrapNativeSuper = function _wrapNativeSuper(Class) {\n    if (Class === null || !_isNativeFunction(Class)) return Class;\n\n    if (typeof Class !== \"function\") {\n      throw new TypeError(\"Super expression must either be null or a function\");\n    }\n\n    if (typeof _cache !== \"undefined\") {\n      if (_cache.has(Class)) return _cache.get(Class);\n\n      _cache.set(Class, Wrapper);\n    }\n\n    function Wrapper() {\n      return _construct(Class, arguments, _getPrototypeOf(this).constructor);\n    }\n\n    Wrapper.prototype = Object.create(Class.prototype, {\n      constructor: {\n        value: Wrapper,\n        enumerable: false,\n        writable: true,\n        configurable: true\n      }\n    });\n    return _setPrototypeOf(Wrapper, Class);\n  };\n\n  return _wrapNativeSuper(Class);\n}\n\nfunction _assertThisInitialized(self) {\n  if (self === void 0) {\n    throw new ReferenceError(\"this hasn't been initialised - super() hasn't been called\");\n  }\n\n  return self;\n}\n\n/* eslint-disable no-proto */\nfunction makeReactive(obj) {\n  var proto = obj.__proto__;\n  Object.defineProperty(obj, '__proto__', {\n    get: function get() {\n      return proto;\n    },\n    set: function set(value) {\n      proto.__proto__ = value;\n    }\n  });\n}\n\nvar Dom7 = /*#__PURE__*/function (_Array) {\n  _inheritsLoose(Dom7, _Array);\n\n  function Dom7(items) {\n    var _this;\n\n    _this = _Array.call.apply(_Array, [this].concat(items)) || this;\n    makeReactive(_assertThisInitialized(_this));\n    return _this;\n  }\n\n  return Dom7;\n}( /*#__PURE__*/_wrapNativeSuper(Array));\n\nfunction arrayFlat(arr) {\n  if (arr === void 0) {\n    arr = [];\n  }\n\n  var res = [];\n  arr.forEach(function (el) {\n    if (Array.isArray(el)) {\n      res.push.apply(res, arrayFlat(el));\n    } else {\n      res.push(el);\n    }\n  });\n  return res;\n}\nfunction arrayFilter(arr, callback) {\n  return Array.prototype.filter.call(arr, callback);\n}\nfunction arrayUnique(arr) {\n  var uniqueArray = [];\n\n  for (var i = 0; i < arr.length; i += 1) {\n    if (uniqueArray.indexOf(arr[i]) === -1) uniqueArray.push(arr[i]);\n  }\n\n  return uniqueArray;\n}\nfunction toCamelCase(string) {\n  return string.toLowerCase().replace(/-(.)/g, function (match, group) {\n    return group.toUpperCase();\n  });\n}\n\nfunction qsa(selector, context) {\n  if (typeof selector !== 'string') {\n    return [selector];\n  }\n\n  var a = [];\n  var res = context.querySelectorAll(selector);\n\n  for (var i = 0; i < res.length; i += 1) {\n    a.push(res[i]);\n  }\n\n  return a;\n}\n\nfunction $(selector, context) {\n  var window = getWindow();\n  var document = getDocument();\n  var arr = [];\n\n  if (!context && selector instanceof Dom7) {\n    return selector;\n  }\n\n  if (!selector) {\n    return new Dom7(arr);\n  }\n\n  if (typeof selector === 'string') {\n    var html = selector.trim();\n\n    if (html.indexOf('<') >= 0 && html.indexOf('>') >= 0) {\n      var toCreate = 'div';\n      if (html.indexOf('<li') === 0) toCreate = 'ul';\n      if (html.indexOf('<tr') === 0) toCreate = 'tbody';\n      if (html.indexOf('<td') === 0 || html.indexOf('<th') === 0) toCreate = 'tr';\n      if (html.indexOf('<tbody') === 0) toCreate = 'table';\n      if (html.indexOf('<option') === 0) toCreate = 'select';\n      var tempParent = document.createElement(toCreate);\n      tempParent.innerHTML = html;\n\n      for (var i = 0; i < tempParent.childNodes.length; i += 1) {\n        arr.push(tempParent.childNodes[i]);\n      }\n    } else {\n      arr = qsa(selector.trim(), context || document);\n    } // arr = qsa(selector, document);\n\n  } else if (selector.nodeType || selector === window || selector === document) {\n    arr.push(selector);\n  } else if (Array.isArray(selector)) {\n    if (selector instanceof Dom7) return selector;\n    arr = selector;\n  }\n\n  return new Dom7(arrayUnique(arr));\n}\n\n$.fn = Dom7.prototype;\n\nfunction addClass() {\n  for (var _len = arguments.length, classes = new Array(_len), _key = 0; _key < _len; _key++) {\n    classes[_key] = arguments[_key];\n  }\n\n  var classNames = arrayFlat(classes.map(function (c) {\n    return c.split(' ');\n  }));\n  this.forEach(function (el) {\n    var _el$classList;\n\n    (_el$classList = el.classList).add.apply(_el$classList, classNames);\n  });\n  return this;\n}\n\nfunction removeClass() {\n  for (var _len2 = arguments.length, classes = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {\n    classes[_key2] = arguments[_key2];\n  }\n\n  var classNames = arrayFlat(classes.map(function (c) {\n    return c.split(' ');\n  }));\n  this.forEach(function (el) {\n    var _el$classList2;\n\n    (_el$classList2 = el.classList).remove.apply(_el$classList2, classNames);\n  });\n  return this;\n}\n\nfunction toggleClass() {\n  for (var _len3 = arguments.length, classes = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {\n    classes[_key3] = arguments[_key3];\n  }\n\n  var classNames = arrayFlat(classes.map(function (c) {\n    return c.split(' ');\n  }));\n  this.forEach(function (el) {\n    classNames.forEach(function (className) {\n      el.classList.toggle(className);\n    });\n  });\n}\n\nfunction hasClass() {\n  for (var _len4 = arguments.length, classes = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {\n    classes[_key4] = arguments[_key4];\n  }\n\n  var classNames = arrayFlat(classes.map(function (c) {\n    return c.split(' ');\n  }));\n  return arrayFilter(this, function (el) {\n    return classNames.filter(function (className) {\n      return el.classList.contains(className);\n    }).length > 0;\n  }).length > 0;\n}\n\nfunction attr(attrs, value) {\n  if (arguments.length === 1 && typeof attrs === 'string') {\n    // Get attr\n    if (this[0]) return this[0].getAttribute(attrs);\n    return undefined;\n  } // Set attrs\n\n\n  for (var i = 0; i < this.length; i += 1) {\n    if (arguments.length === 2) {\n      // String\n      this[i].setAttribute(attrs, value);\n    } else {\n      // Object\n      for (var attrName in attrs) {\n        this[i][attrName] = attrs[attrName];\n        this[i].setAttribute(attrName, attrs[attrName]);\n      }\n    }\n  }\n\n  return this;\n}\n\nfunction removeAttr(attr) {\n  for (var i = 0; i < this.length; i += 1) {\n    this[i].removeAttribute(attr);\n  }\n\n  return this;\n}\n\nfunction prop(props, value) {\n  if (arguments.length === 1 && typeof props === 'string') {\n    // Get prop\n    if (this[0]) return this[0][props];\n  } else {\n    // Set props\n    for (var i = 0; i < this.length; i += 1) {\n      if (arguments.length === 2) {\n        // String\n        this[i][props] = value;\n      } else {\n        // Object\n        for (var propName in props) {\n          this[i][propName] = props[propName];\n        }\n      }\n    }\n\n    return this;\n  }\n\n  return this;\n}\n\nfunction data(key, value) {\n  var el;\n\n  if (typeof value === 'undefined') {\n    el = this[0];\n    if (!el) return undefined; // Get value\n\n    if (el.dom7ElementDataStorage && key in el.dom7ElementDataStorage) {\n      return el.dom7ElementDataStorage[key];\n    }\n\n    var dataKey = el.getAttribute(\"data-\" + key);\n\n    if (dataKey) {\n      return dataKey;\n    }\n\n    return undefined;\n  } // Set value\n\n\n  for (var i = 0; i < this.length; i += 1) {\n    el = this[i];\n    if (!el.dom7ElementDataStorage) el.dom7ElementDataStorage = {};\n    el.dom7ElementDataStorage[key] = value;\n  }\n\n  return this;\n}\n\nfunction removeData(key) {\n  for (var i = 0; i < this.length; i += 1) {\n    var el = this[i];\n\n    if (el.dom7ElementDataStorage && el.dom7ElementDataStorage[key]) {\n      el.dom7ElementDataStorage[key] = null;\n      delete el.dom7ElementDataStorage[key];\n    }\n  }\n}\n\nfunction dataset() {\n  var el = this[0];\n  if (!el) return undefined;\n  var dataset = {}; // eslint-disable-line\n\n  if (el.dataset) {\n    for (var dataKey in el.dataset) {\n      dataset[dataKey] = el.dataset[dataKey];\n    }\n  } else {\n    for (var i = 0; i < el.attributes.length; i += 1) {\n      var _attr = el.attributes[i];\n\n      if (_attr.name.indexOf('data-') >= 0) {\n        dataset[toCamelCase(_attr.name.split('data-')[1])] = _attr.value;\n      }\n    }\n  }\n\n  for (var key in dataset) {\n    if (dataset[key] === 'false') dataset[key] = false;else if (dataset[key] === 'true') dataset[key] = true;else if (parseFloat(dataset[key]) === dataset[key] * 1) dataset[key] *= 1;\n  }\n\n  return dataset;\n}\n\nfunction val(value) {\n  if (typeof value === 'undefined') {\n    // get value\n    var el = this[0];\n    if (!el) return undefined;\n\n    if (el.multiple && el.nodeName.toLowerCase() === 'select') {\n      var values = [];\n\n      for (var i = 0; i < el.selectedOptions.length; i += 1) {\n        values.push(el.selectedOptions[i].value);\n      }\n\n      return values;\n    }\n\n    return el.value;\n  } // set value\n\n\n  for (var _i = 0; _i < this.length; _i += 1) {\n    var _el = this[_i];\n\n    if (Array.isArray(value) && _el.multiple && _el.nodeName.toLowerCase() === 'select') {\n      for (var j = 0; j < _el.options.length; j += 1) {\n        _el.options[j].selected = value.indexOf(_el.options[j].value) >= 0;\n      }\n    } else {\n      _el.value = value;\n    }\n  }\n\n  return this;\n}\n\nfunction value(value) {\n  return this.val(value);\n}\n\nfunction transform(transform) {\n  for (var i = 0; i < this.length; i += 1) {\n    this[i].style.transform = transform;\n  }\n\n  return this;\n}\n\nfunction transition(duration) {\n  for (var i = 0; i < this.length; i += 1) {\n    this[i].style.transitionDuration = typeof duration !== 'string' ? duration + \"ms\" : duration;\n  }\n\n  return this;\n}\n\nfunction on() {\n  for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {\n    args[_key5] = arguments[_key5];\n  }\n\n  var eventType = args[0],\n      targetSelector = args[1],\n      listener = args[2],\n      capture = args[3];\n\n  if (typeof args[1] === 'function') {\n    eventType = args[0];\n    listener = args[1];\n    capture = args[2];\n    targetSelector = undefined;\n  }\n\n  if (!capture) capture = false;\n\n  function handleLiveEvent(e) {\n    var target = e.target;\n    if (!target) return;\n    var eventData = e.target.dom7EventData || [];\n\n    if (eventData.indexOf(e) < 0) {\n      eventData.unshift(e);\n    }\n\n    if ($(target).is(targetSelector)) listener.apply(target, eventData);else {\n      var _parents = $(target).parents(); // eslint-disable-line\n\n\n      for (var k = 0; k < _parents.length; k += 1) {\n        if ($(_parents[k]).is(targetSelector)) listener.apply(_parents[k], eventData);\n      }\n    }\n  }\n\n  function handleEvent(e) {\n    var eventData = e && e.target ? e.target.dom7EventData || [] : [];\n\n    if (eventData.indexOf(e) < 0) {\n      eventData.unshift(e);\n    }\n\n    listener.apply(this, eventData);\n  }\n\n  var events = eventType.split(' ');\n  var j;\n\n  for (var i = 0; i < this.length; i += 1) {\n    var el = this[i];\n\n    if (!targetSelector) {\n      for (j = 0; j < events.length; j += 1) {\n        var event = events[j];\n        if (!el.dom7Listeners) el.dom7Listeners = {};\n        if (!el.dom7Listeners[event]) el.dom7Listeners[event] = [];\n        el.dom7Listeners[event].push({\n          listener: listener,\n          proxyListener: handleEvent\n        });\n        el.addEventListener(event, handleEvent, capture);\n      }\n    } else {\n      // Live events\n      for (j = 0; j < events.length; j += 1) {\n        var _event = events[j];\n        if (!el.dom7LiveListeners) el.dom7LiveListeners = {};\n        if (!el.dom7LiveListeners[_event]) el.dom7LiveListeners[_event] = [];\n\n        el.dom7LiveListeners[_event].push({\n          listener: listener,\n          proxyListener: handleLiveEvent\n        });\n\n        el.addEventListener(_event, handleLiveEvent, capture);\n      }\n    }\n  }\n\n  return this;\n}\n\nfunction off() {\n  for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {\n    args[_key6] = arguments[_key6];\n  }\n\n  var eventType = args[0],\n      targetSelector = args[1],\n      listener = args[2],\n      capture = args[3];\n\n  if (typeof args[1] === 'function') {\n    eventType = args[0];\n    listener = args[1];\n    capture = args[2];\n    targetSelector = undefined;\n  }\n\n  if (!capture) capture = false;\n  var events = eventType.split(' ');\n\n  for (var i = 0; i < events.length; i += 1) {\n    var event = events[i];\n\n    for (var j = 0; j < this.length; j += 1) {\n      var el = this[j];\n      var handlers = void 0;\n\n      if (!targetSelector && el.dom7Listeners) {\n        handlers = el.dom7Listeners[event];\n      } else if (targetSelector && el.dom7LiveListeners) {\n        handlers = el.dom7LiveListeners[event];\n      }\n\n      if (handlers && handlers.length) {\n        for (var k = handlers.length - 1; k >= 0; k -= 1) {\n          var handler = handlers[k];\n\n          if (listener && handler.listener === listener) {\n            el.removeEventListener(event, handler.proxyListener, capture);\n            handlers.splice(k, 1);\n          } else if (listener && handler.listener && handler.listener.dom7proxy && handler.listener.dom7proxy === listener) {\n            el.removeEventListener(event, handler.proxyListener, capture);\n            handlers.splice(k, 1);\n          } else if (!listener) {\n            el.removeEventListener(event, handler.proxyListener, capture);\n            handlers.splice(k, 1);\n          }\n        }\n      }\n    }\n  }\n\n  return this;\n}\n\nfunction once() {\n  var dom = this;\n\n  for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {\n    args[_key7] = arguments[_key7];\n  }\n\n  var eventName = args[0],\n      targetSelector = args[1],\n      listener = args[2],\n      capture = args[3];\n\n  if (typeof args[1] === 'function') {\n    eventName = args[0];\n    listener = args[1];\n    capture = args[2];\n    targetSelector = undefined;\n  }\n\n  function onceHandler() {\n    for (var _len8 = arguments.length, eventArgs = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {\n      eventArgs[_key8] = arguments[_key8];\n    }\n\n    listener.apply(this, eventArgs);\n    dom.off(eventName, targetSelector, onceHandler, capture);\n\n    if (onceHandler.dom7proxy) {\n      delete onceHandler.dom7proxy;\n    }\n  }\n\n  onceHandler.dom7proxy = listener;\n  return dom.on(eventName, targetSelector, onceHandler, capture);\n}\n\nfunction trigger() {\n  var window = getWindow();\n\n  for (var _len9 = arguments.length, args = new Array(_len9), _key9 = 0; _key9 < _len9; _key9++) {\n    args[_key9] = arguments[_key9];\n  }\n\n  var events = args[0].split(' ');\n  var eventData = args[1];\n\n  for (var i = 0; i < events.length; i += 1) {\n    var event = events[i];\n\n    for (var j = 0; j < this.length; j += 1) {\n      var el = this[j];\n\n      if (window.CustomEvent) {\n        var evt = new window.CustomEvent(event, {\n          detail: eventData,\n          bubbles: true,\n          cancelable: true\n        });\n        el.dom7EventData = args.filter(function (data, dataIndex) {\n          return dataIndex > 0;\n        });\n        el.dispatchEvent(evt);\n        el.dom7EventData = [];\n        delete el.dom7EventData;\n      }\n    }\n  }\n\n  return this;\n}\n\nfunction transitionEnd(callback) {\n  var dom = this;\n\n  function fireCallBack(e) {\n    if (e.target !== this) return;\n    callback.call(this, e);\n    dom.off('transitionend', fireCallBack);\n  }\n\n  if (callback) {\n    dom.on('transitionend', fireCallBack);\n  }\n\n  return this;\n}\n\nfunction animationEnd(callback) {\n  var dom = this;\n\n  function fireCallBack(e) {\n    if (e.target !== this) return;\n    callback.call(this, e);\n    dom.off('animationend', fireCallBack);\n  }\n\n  if (callback) {\n    dom.on('animationend', fireCallBack);\n  }\n\n  return this;\n}\n\nfunction width() {\n  var window = getWindow();\n\n  if (this[0] === window) {\n    return window.innerWidth;\n  }\n\n  if (this.length > 0) {\n    return parseFloat(this.css('width'));\n  }\n\n  return null;\n}\n\nfunction outerWidth(includeMargins) {\n  if (this.length > 0) {\n    if (includeMargins) {\n      var _styles = this.styles();\n\n      return this[0].offsetWidth + parseFloat(_styles.getPropertyValue('margin-right')) + parseFloat(_styles.getPropertyValue('margin-left'));\n    }\n\n    return this[0].offsetWidth;\n  }\n\n  return null;\n}\n\nfunction height() {\n  var window = getWindow();\n\n  if (this[0] === window) {\n    return window.innerHeight;\n  }\n\n  if (this.length > 0) {\n    return parseFloat(this.css('height'));\n  }\n\n  return null;\n}\n\nfunction outerHeight(includeMargins) {\n  if (this.length > 0) {\n    if (includeMargins) {\n      var _styles2 = this.styles();\n\n      return this[0].offsetHeight + parseFloat(_styles2.getPropertyValue('margin-top')) + parseFloat(_styles2.getPropertyValue('margin-bottom'));\n    }\n\n    return this[0].offsetHeight;\n  }\n\n  return null;\n}\n\nfunction offset() {\n  if (this.length > 0) {\n    var window = getWindow();\n    var document = getDocument();\n    var el = this[0];\n    var box = el.getBoundingClientRect();\n    var body = document.body;\n    var clientTop = el.clientTop || body.clientTop || 0;\n    var clientLeft = el.clientLeft || body.clientLeft || 0;\n    var scrollTop = el === window ? window.scrollY : el.scrollTop;\n    var scrollLeft = el === window ? window.scrollX : el.scrollLeft;\n    return {\n      top: box.top + scrollTop - clientTop,\n      left: box.left + scrollLeft - clientLeft\n    };\n  }\n\n  return null;\n}\n\nfunction hide() {\n  for (var i = 0; i < this.length; i += 1) {\n    this[i].style.display = 'none';\n  }\n\n  return this;\n}\n\nfunction show() {\n  var window = getWindow();\n\n  for (var i = 0; i < this.length; i += 1) {\n    var el = this[i];\n\n    if (el.style.display === 'none') {\n      el.style.display = '';\n    }\n\n    if (window.getComputedStyle(el, null).getPropertyValue('display') === 'none') {\n      // Still not visible\n      el.style.display = 'block';\n    }\n  }\n\n  return this;\n}\n\nfunction styles() {\n  var window = getWindow();\n  if (this[0]) return window.getComputedStyle(this[0], null);\n  return {};\n}\n\nfunction css(props, value) {\n  var window = getWindow();\n  var i;\n\n  if (arguments.length === 1) {\n    if (typeof props === 'string') {\n      // .css('width')\n      if (this[0]) return window.getComputedStyle(this[0], null).getPropertyValue(props);\n    } else {\n      // .css({ width: '100px' })\n      for (i = 0; i < this.length; i += 1) {\n        for (var _prop in props) {\n          this[i].style[_prop] = props[_prop];\n        }\n      }\n\n      return this;\n    }\n  }\n\n  if (arguments.length === 2 && typeof props === 'string') {\n    // .css('width', '100px')\n    for (i = 0; i < this.length; i += 1) {\n      this[i].style[props] = value;\n    }\n\n    return this;\n  }\n\n  return this;\n}\n\nfunction each(callback) {\n  if (!callback) return this;\n  this.forEach(function (el, index) {\n    callback.apply(el, [el, index]);\n  });\n  return this;\n}\n\nfunction filter(callback) {\n  var result = arrayFilter(this, callback);\n  return $(result);\n}\n\nfunction html(html) {\n  if (typeof html === 'undefined') {\n    return this[0] ? this[0].innerHTML : null;\n  }\n\n  for (var i = 0; i < this.length; i += 1) {\n    this[i].innerHTML = html;\n  }\n\n  return this;\n}\n\nfunction text(text) {\n  if (typeof text === 'undefined') {\n    return this[0] ? this[0].textContent.trim() : null;\n  }\n\n  for (var i = 0; i < this.length; i += 1) {\n    this[i].textContent = text;\n  }\n\n  return this;\n}\n\nfunction is(selector) {\n  var window = getWindow();\n  var document = getDocument();\n  var el = this[0];\n  var compareWith;\n  var i;\n  if (!el || typeof selector === 'undefined') return false;\n\n  if (typeof selector === 'string') {\n    if (el.matches) return el.matches(selector);\n    if (el.webkitMatchesSelector) return el.webkitMatchesSelector(selector);\n    if (el.msMatchesSelector) return el.msMatchesSelector(selector);\n    compareWith = $(selector);\n\n    for (i = 0; i < compareWith.length; i += 1) {\n      if (compareWith[i] === el) return true;\n    }\n\n    return false;\n  }\n\n  if (selector === document) {\n    return el === document;\n  }\n\n  if (selector === window) {\n    return el === window;\n  }\n\n  if (selector.nodeType || selector instanceof Dom7) {\n    compareWith = selector.nodeType ? [selector] : selector;\n\n    for (i = 0; i < compareWith.length; i += 1) {\n      if (compareWith[i] === el) return true;\n    }\n\n    return false;\n  }\n\n  return false;\n}\n\nfunction index() {\n  var child = this[0];\n  var i;\n\n  if (child) {\n    i = 0; // eslint-disable-next-line\n\n    while ((child = child.previousSibling) !== null) {\n      if (child.nodeType === 1) i += 1;\n    }\n\n    return i;\n  }\n\n  return undefined;\n}\n\nfunction eq(index) {\n  if (typeof index === 'undefined') return this;\n  var length = this.length;\n\n  if (index > length - 1) {\n    return $([]);\n  }\n\n  if (index < 0) {\n    var returnIndex = length + index;\n    if (returnIndex < 0) return $([]);\n    return $([this[returnIndex]]);\n  }\n\n  return $([this[index]]);\n}\n\nfunction append() {\n  var newChild;\n  var document = getDocument();\n\n  for (var k = 0; k < arguments.length; k += 1) {\n    newChild = k < 0 || arguments.length <= k ? undefined : arguments[k];\n\n    for (var i = 0; i < this.length; i += 1) {\n      if (typeof newChild === 'string') {\n        var tempDiv = document.createElement('div');\n        tempDiv.innerHTML = newChild;\n\n        while (tempDiv.firstChild) {\n          this[i].appendChild(tempDiv.firstChild);\n        }\n      } else if (newChild instanceof Dom7) {\n        for (var j = 0; j < newChild.length; j += 1) {\n          this[i].appendChild(newChild[j]);\n        }\n      } else {\n        this[i].appendChild(newChild);\n      }\n    }\n  }\n\n  return this;\n}\n\nfunction appendTo(parent) {\n  $(parent).append(this);\n  return this;\n}\n\nfunction prepend(newChild) {\n  var document = getDocument();\n  var i;\n  var j;\n\n  for (i = 0; i < this.length; i += 1) {\n    if (typeof newChild === 'string') {\n      var tempDiv = document.createElement('div');\n      tempDiv.innerHTML = newChild;\n\n      for (j = tempDiv.childNodes.length - 1; j >= 0; j -= 1) {\n        this[i].insertBefore(tempDiv.childNodes[j], this[i].childNodes[0]);\n      }\n    } else if (newChild instanceof Dom7) {\n      for (j = 0; j < newChild.length; j += 1) {\n        this[i].insertBefore(newChild[j], this[i].childNodes[0]);\n      }\n    } else {\n      this[i].insertBefore(newChild, this[i].childNodes[0]);\n    }\n  }\n\n  return this;\n}\n\nfunction prependTo(parent) {\n  $(parent).prepend(this);\n  return this;\n}\n\nfunction insertBefore(selector) {\n  var before = $(selector);\n\n  for (var i = 0; i < this.length; i += 1) {\n    if (before.length === 1) {\n      before[0].parentNode.insertBefore(this[i], before[0]);\n    } else if (before.length > 1) {\n      for (var j = 0; j < before.length; j += 1) {\n        before[j].parentNode.insertBefore(this[i].cloneNode(true), before[j]);\n      }\n    }\n  }\n}\n\nfunction insertAfter(selector) {\n  var after = $(selector);\n\n  for (var i = 0; i < this.length; i += 1) {\n    if (after.length === 1) {\n      after[0].parentNode.insertBefore(this[i], after[0].nextSibling);\n    } else if (after.length > 1) {\n      for (var j = 0; j < after.length; j += 1) {\n        after[j].parentNode.insertBefore(this[i].cloneNode(true), after[j].nextSibling);\n      }\n    }\n  }\n}\n\nfunction next(selector) {\n  if (this.length > 0) {\n    if (selector) {\n      if (this[0].nextElementSibling && $(this[0].nextElementSibling).is(selector)) {\n        return $([this[0].nextElementSibling]);\n      }\n\n      return $([]);\n    }\n\n    if (this[0].nextElementSibling) return $([this[0].nextElementSibling]);\n    return $([]);\n  }\n\n  return $([]);\n}\n\nfunction nextAll(selector) {\n  var nextEls = [];\n  var el = this[0];\n  if (!el) return $([]);\n\n  while (el.nextElementSibling) {\n    var _next = el.nextElementSibling; // eslint-disable-line\n\n    if (selector) {\n      if ($(_next).is(selector)) nextEls.push(_next);\n    } else nextEls.push(_next);\n\n    el = _next;\n  }\n\n  return $(nextEls);\n}\n\nfunction prev(selector) {\n  if (this.length > 0) {\n    var el = this[0];\n\n    if (selector) {\n      if (el.previousElementSibling && $(el.previousElementSibling).is(selector)) {\n        return $([el.previousElementSibling]);\n      }\n\n      return $([]);\n    }\n\n    if (el.previousElementSibling) return $([el.previousElementSibling]);\n    return $([]);\n  }\n\n  return $([]);\n}\n\nfunction prevAll(selector) {\n  var prevEls = [];\n  var el = this[0];\n  if (!el) return $([]);\n\n  while (el.previousElementSibling) {\n    var _prev = el.previousElementSibling; // eslint-disable-line\n\n    if (selector) {\n      if ($(_prev).is(selector)) prevEls.push(_prev);\n    } else prevEls.push(_prev);\n\n    el = _prev;\n  }\n\n  return $(prevEls);\n}\n\nfunction siblings(selector) {\n  return this.nextAll(selector).add(this.prevAll(selector));\n}\n\nfunction parent(selector) {\n  var parents = []; // eslint-disable-line\n\n  for (var i = 0; i < this.length; i += 1) {\n    if (this[i].parentNode !== null) {\n      if (selector) {\n        if ($(this[i].parentNode).is(selector)) parents.push(this[i].parentNode);\n      } else {\n        parents.push(this[i].parentNode);\n      }\n    }\n  }\n\n  return $(parents);\n}\n\nfunction parents(selector) {\n  var parents = []; // eslint-disable-line\n\n  for (var i = 0; i < this.length; i += 1) {\n    var _parent = this[i].parentNode; // eslint-disable-line\n\n    while (_parent) {\n      if (selector) {\n        if ($(_parent).is(selector)) parents.push(_parent);\n      } else {\n        parents.push(_parent);\n      }\n\n      _parent = _parent.parentNode;\n    }\n  }\n\n  return $(parents);\n}\n\nfunction closest(selector) {\n  var closest = this; // eslint-disable-line\n\n  if (typeof selector === 'undefined') {\n    return $([]);\n  }\n\n  if (!closest.is(selector)) {\n    closest = closest.parents(selector).eq(0);\n  }\n\n  return closest;\n}\n\nfunction find(selector) {\n  var foundElements = [];\n\n  for (var i = 0; i < this.length; i += 1) {\n    var found = this[i].querySelectorAll(selector);\n\n    for (var j = 0; j < found.length; j += 1) {\n      foundElements.push(found[j]);\n    }\n  }\n\n  return $(foundElements);\n}\n\nfunction children(selector) {\n  var children = []; // eslint-disable-line\n\n  for (var i = 0; i < this.length; i += 1) {\n    var childNodes = this[i].children;\n\n    for (var j = 0; j < childNodes.length; j += 1) {\n      if (!selector || $(childNodes[j]).is(selector)) {\n        children.push(childNodes[j]);\n      }\n    }\n  }\n\n  return $(children);\n}\n\nfunction remove() {\n  for (var i = 0; i < this.length; i += 1) {\n    if (this[i].parentNode) this[i].parentNode.removeChild(this[i]);\n  }\n\n  return this;\n}\n\nfunction detach() {\n  return this.remove();\n}\n\nfunction add() {\n  var dom = this;\n  var i;\n  var j;\n\n  for (var _len10 = arguments.length, els = new Array(_len10), _key10 = 0; _key10 < _len10; _key10++) {\n    els[_key10] = arguments[_key10];\n  }\n\n  for (i = 0; i < els.length; i += 1) {\n    var toAdd = $(els[i]);\n\n    for (j = 0; j < toAdd.length; j += 1) {\n      dom.push(toAdd[j]);\n    }\n  }\n\n  return dom;\n}\n\nfunction empty() {\n  for (var i = 0; i < this.length; i += 1) {\n    var el = this[i];\n\n    if (el.nodeType === 1) {\n      for (var j = 0; j < el.childNodes.length; j += 1) {\n        if (el.childNodes[j].parentNode) {\n          el.childNodes[j].parentNode.removeChild(el.childNodes[j]);\n        }\n      }\n\n      el.textContent = '';\n    }\n  }\n\n  return this;\n}\n\nfunction scrollTo() {\n  var window = getWindow();\n\n  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {\n    args[_key] = arguments[_key];\n  }\n\n  var left = args[0],\n      top = args[1],\n      duration = args[2],\n      easing = args[3],\n      callback = args[4];\n\n  if (args.length === 4 && typeof easing === 'function') {\n    callback = easing;\n    left = args[0];\n    top = args[1];\n    duration = args[2];\n    callback = args[3];\n    easing = args[4];\n  }\n\n  if (typeof easing === 'undefined') easing = 'swing';\n  return this.each(function animate() {\n    var el = this;\n    var currentTop;\n    var currentLeft;\n    var maxTop;\n    var maxLeft;\n    var newTop;\n    var newLeft;\n    var scrollTop; // eslint-disable-line\n\n    var scrollLeft; // eslint-disable-line\n\n    var animateTop = top > 0 || top === 0;\n    var animateLeft = left > 0 || left === 0;\n\n    if (typeof easing === 'undefined') {\n      easing = 'swing';\n    }\n\n    if (animateTop) {\n      currentTop = el.scrollTop;\n\n      if (!duration) {\n        el.scrollTop = top;\n      }\n    }\n\n    if (animateLeft) {\n      currentLeft = el.scrollLeft;\n\n      if (!duration) {\n        el.scrollLeft = left;\n      }\n    }\n\n    if (!duration) return;\n\n    if (animateTop) {\n      maxTop = el.scrollHeight - el.offsetHeight;\n      newTop = Math.max(Math.min(top, maxTop), 0);\n    }\n\n    if (animateLeft) {\n      maxLeft = el.scrollWidth - el.offsetWidth;\n      newLeft = Math.max(Math.min(left, maxLeft), 0);\n    }\n\n    var startTime = null;\n    if (animateTop && newTop === currentTop) animateTop = false;\n    if (animateLeft && newLeft === currentLeft) animateLeft = false;\n\n    function render(time) {\n      if (time === void 0) {\n        time = new Date().getTime();\n      }\n\n      if (startTime === null) {\n        startTime = time;\n      }\n\n      var progress = Math.max(Math.min((time - startTime) / duration, 1), 0);\n      var easeProgress = easing === 'linear' ? progress : 0.5 - Math.cos(progress * Math.PI) / 2;\n      var done;\n      if (animateTop) scrollTop = currentTop + easeProgress * (newTop - currentTop);\n      if (animateLeft) scrollLeft = currentLeft + easeProgress * (newLeft - currentLeft);\n\n      if (animateTop && newTop > currentTop && scrollTop >= newTop) {\n        el.scrollTop = newTop;\n        done = true;\n      }\n\n      if (animateTop && newTop < currentTop && scrollTop <= newTop) {\n        el.scrollTop = newTop;\n        done = true;\n      }\n\n      if (animateLeft && newLeft > currentLeft && scrollLeft >= newLeft) {\n        el.scrollLeft = newLeft;\n        done = true;\n      }\n\n      if (animateLeft && newLeft < currentLeft && scrollLeft <= newLeft) {\n        el.scrollLeft = newLeft;\n        done = true;\n      }\n\n      if (done) {\n        if (callback) callback();\n        return;\n      }\n\n      if (animateTop) el.scrollTop = scrollTop;\n      if (animateLeft) el.scrollLeft = scrollLeft;\n      window.requestAnimationFrame(render);\n    }\n\n    window.requestAnimationFrame(render);\n  });\n} // scrollTop(top, duration, easing, callback) {\n\n\nfunction scrollTop() {\n  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {\n    args[_key2] = arguments[_key2];\n  }\n\n  var top = args[0],\n      duration = args[1],\n      easing = args[2],\n      callback = args[3];\n\n  if (args.length === 3 && typeof easing === 'function') {\n    top = args[0];\n    duration = args[1];\n    callback = args[2];\n    easing = args[3];\n  }\n\n  var dom = this;\n\n  if (typeof top === 'undefined') {\n    if (dom.length > 0) return dom[0].scrollTop;\n    return null;\n  }\n\n  return dom.scrollTo(undefined, top, duration, easing, callback);\n}\n\nfunction scrollLeft() {\n  for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {\n    args[_key3] = arguments[_key3];\n  }\n\n  var left = args[0],\n      duration = args[1],\n      easing = args[2],\n      callback = args[3];\n\n  if (args.length === 3 && typeof easing === 'function') {\n    left = args[0];\n    duration = args[1];\n    callback = args[2];\n    easing = args[3];\n  }\n\n  var dom = this;\n\n  if (typeof left === 'undefined') {\n    if (dom.length > 0) return dom[0].scrollLeft;\n    return null;\n  }\n\n  return dom.scrollTo(left, undefined, duration, easing, callback);\n}\n\nfunction animate(initialProps, initialParams) {\n  var window = getWindow();\n  var els = this;\n  var a = {\n    props: Object.assign({}, initialProps),\n    params: Object.assign({\n      duration: 300,\n      easing: 'swing' // or 'linear'\n\n      /* Callbacks\n      begin(elements)\n      complete(elements)\n      progress(elements, complete, remaining, start, tweenValue)\n      */\n\n    }, initialParams),\n    elements: els,\n    animating: false,\n    que: [],\n    easingProgress: function easingProgress(easing, progress) {\n      if (easing === 'swing') {\n        return 0.5 - Math.cos(progress * Math.PI) / 2;\n      }\n\n      if (typeof easing === 'function') {\n        return easing(progress);\n      }\n\n      return progress;\n    },\n    stop: function stop() {\n      if (a.frameId) {\n        window.cancelAnimationFrame(a.frameId);\n      }\n\n      a.animating = false;\n      a.elements.each(function (el) {\n        var element = el;\n        delete element.dom7AnimateInstance;\n      });\n      a.que = [];\n    },\n    done: function done(complete) {\n      a.animating = false;\n      a.elements.each(function (el) {\n        var element = el;\n        delete element.dom7AnimateInstance;\n      });\n      if (complete) complete(els);\n\n      if (a.que.length > 0) {\n        var que = a.que.shift();\n        a.animate(que[0], que[1]);\n      }\n    },\n    animate: function animate(props, params) {\n      if (a.animating) {\n        a.que.push([props, params]);\n        return a;\n      }\n\n      var elements = []; // Define & Cache Initials & Units\n\n      a.elements.each(function (el, index) {\n        var initialFullValue;\n        var initialValue;\n        var unit;\n        var finalValue;\n        var finalFullValue;\n        if (!el.dom7AnimateInstance) a.elements[index].dom7AnimateInstance = a;\n        elements[index] = {\n          container: el\n        };\n        Object.keys(props).forEach(function (prop) {\n          initialFullValue = window.getComputedStyle(el, null).getPropertyValue(prop).replace(',', '.');\n          initialValue = parseFloat(initialFullValue);\n          unit = initialFullValue.replace(initialValue, '');\n          finalValue = parseFloat(props[prop]);\n          finalFullValue = props[prop] + unit;\n          elements[index][prop] = {\n            initialFullValue: initialFullValue,\n            initialValue: initialValue,\n            unit: unit,\n            finalValue: finalValue,\n            finalFullValue: finalFullValue,\n            currentValue: initialValue\n          };\n        });\n      });\n      var startTime = null;\n      var time;\n      var elementsDone = 0;\n      var propsDone = 0;\n      var done;\n      var began = false;\n      a.animating = true;\n\n      function render() {\n        time = new Date().getTime();\n        var progress;\n        var easeProgress; // let el;\n\n        if (!began) {\n          began = true;\n          if (params.begin) params.begin(els);\n        }\n\n        if (startTime === null) {\n          startTime = time;\n        }\n\n        if (params.progress) {\n          // eslint-disable-next-line\n          params.progress(els, Math.max(Math.min((time - startTime) / params.duration, 1), 0), startTime + params.duration - time < 0 ? 0 : startTime + params.duration - time, startTime);\n        }\n\n        elements.forEach(function (element) {\n          var el = element;\n          if (done || el.done) return;\n          Object.keys(props).forEach(function (prop) {\n            if (done || el.done) return;\n            progress = Math.max(Math.min((time - startTime) / params.duration, 1), 0);\n            easeProgress = a.easingProgress(params.easing, progress);\n            var _el$prop = el[prop],\n                initialValue = _el$prop.initialValue,\n                finalValue = _el$prop.finalValue,\n                unit = _el$prop.unit;\n            el[prop].currentValue = initialValue + easeProgress * (finalValue - initialValue);\n            var currentValue = el[prop].currentValue;\n\n            if (finalValue > initialValue && currentValue >= finalValue || finalValue < initialValue && currentValue <= finalValue) {\n              el.container.style[prop] = finalValue + unit;\n              propsDone += 1;\n\n              if (propsDone === Object.keys(props).length) {\n                el.done = true;\n                elementsDone += 1;\n              }\n\n              if (elementsDone === elements.length) {\n                done = true;\n              }\n            }\n\n            if (done) {\n              a.done(params.complete);\n              return;\n            }\n\n            el.container.style[prop] = currentValue + unit;\n          });\n        });\n        if (done) return; // Then call\n\n        a.frameId = window.requestAnimationFrame(render);\n      }\n\n      a.frameId = window.requestAnimationFrame(render);\n      return a;\n    }\n  };\n\n  if (a.elements.length === 0) {\n    return els;\n  }\n\n  var animateInstance;\n\n  for (var i = 0; i < a.elements.length; i += 1) {\n    if (a.elements[i].dom7AnimateInstance) {\n      animateInstance = a.elements[i].dom7AnimateInstance;\n    } else a.elements[i].dom7AnimateInstance = a;\n  }\n\n  if (!animateInstance) {\n    animateInstance = a;\n  }\n\n  if (initialProps === 'stop') {\n    animateInstance.stop();\n  } else {\n    animateInstance.animate(a.props, a.params);\n  }\n\n  return els;\n}\n\nfunction stop() {\n  var els = this;\n\n  for (var i = 0; i < els.length; i += 1) {\n    if (els[i].dom7AnimateInstance) {\n      els[i].dom7AnimateInstance.stop();\n    }\n  }\n}\n\nvar noTrigger = 'resize scroll'.split(' ');\n\nfunction shortcut(name) {\n  function eventHandler() {\n    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {\n      args[_key] = arguments[_key];\n    }\n\n    if (typeof args[0] === 'undefined') {\n      for (var i = 0; i < this.length; i += 1) {\n        if (noTrigger.indexOf(name) < 0) {\n          if (name in this[i]) this[i][name]();else {\n            $(this[i]).trigger(name);\n          }\n        }\n      }\n\n      return this;\n    }\n\n    return this.on.apply(this, [name].concat(args));\n  }\n\n  return eventHandler;\n}\n\nvar click = shortcut('click');\nvar blur = shortcut('blur');\nvar focus = shortcut('focus');\nvar focusin = shortcut('focusin');\nvar focusout = shortcut('focusout');\nvar keyup = shortcut('keyup');\nvar keydown = shortcut('keydown');\nvar keypress = shortcut('keypress');\nvar submit = shortcut('submit');\nvar change = shortcut('change');\nvar mousedown = shortcut('mousedown');\nvar mousemove = shortcut('mousemove');\nvar mouseup = shortcut('mouseup');\nvar mouseenter = shortcut('mouseenter');\nvar mouseleave = shortcut('mouseleave');\nvar mouseout = shortcut('mouseout');\nvar mouseover = shortcut('mouseover');\nvar touchstart = shortcut('touchstart');\nvar touchend = shortcut('touchend');\nvar touchmove = shortcut('touchmove');\nvar resize = shortcut('resize');\nvar scroll = shortcut('scroll');\n\nexport default $;\nexport { $, add, addClass, animate, animationEnd, append, appendTo, attr, blur, change, children, click, closest, css, data, dataset, detach, each, empty, eq, filter, find, focus, focusin, focusout, hasClass, height, hide, html, index, insertAfter, insertBefore, is, keydown, keypress, keyup, mousedown, mouseenter, mouseleave, mousemove, mouseout, mouseover, mouseup, next, nextAll, off, offset, on, once, outerHeight, outerWidth, parent, parents, prepend, prependTo, prev, prevAll, prop, remove, removeAttr, removeClass, removeData, resize, scroll, scrollLeft, scrollTo, scrollTop, show, siblings, stop, styles, submit, text, toggleClass, touchend, touchmove, touchstart, transform, transition, transitionEnd, trigger, val, value, width };\n","import {\n  $,\n  addClass,\n  removeClass,\n  hasClass,\n  toggleClass,\n  attr,\n  removeAttr,\n  transform,\n  transition,\n  on,\n  off,\n  trigger,\n  transitionEnd,\n  outerWidth,\n  outerHeight,\n  styles,\n  offset,\n  css,\n  each,\n  html,\n  text,\n  is,\n  index,\n  eq,\n  append,\n  prepend,\n  next,\n  nextAll,\n  prev,\n  prevAll,\n  parent,\n  parents,\n  closest,\n  find,\n  children,\n  filter,\n  remove,\n} from 'dom7';\n\nconst Methods = {\n  addClass,\n  removeClass,\n  hasClass,\n  toggleClass,\n  attr,\n  removeAttr,\n  transform,\n  transition,\n  on,\n  off,\n  trigger,\n  transitionEnd,\n  outerWidth,\n  outerHeight,\n  styles,\n  offset,\n  css,\n  each,\n  html,\n  text,\n  is,\n  index,\n  eq,\n  append,\n  prepend,\n  next,\n  nextAll,\n  prev,\n  prevAll,\n  parent,\n  parents,\n  closest,\n  find,\n  children,\n  filter,\n  remove,\n};\n\nObject.keys(Methods).forEach((methodName) => {\n  $.fn[methodName] = Methods[methodName];\n});\n\nexport default $;\n","import { getWindow } from 'ssr-window';\n\nfunction deleteProps(obj) {\n  const object = obj;\n  Object.keys(object).forEach((key) => {\n    try {\n      object[key] = null;\n    } catch (e) {\n      // no getter for object\n    }\n    try {\n      delete object[key];\n    } catch (e) {\n      // something got wrong\n    }\n  });\n}\nfunction nextTick(callback, delay = 0) {\n  return setTimeout(callback, delay);\n}\nfunction now() {\n  return Date.now();\n}\nfunction getComputedStyle(el) {\n  const window = getWindow();\n  let style;\n  if (window.getComputedStyle) {\n    style = window.getComputedStyle(el, null);\n  }\n  if (!style && el.currentStyle) {\n    style = el.currentStyle;\n  }\n  if (!style) {\n    style = el.style;\n  }\n\n  return style;\n}\nfunction getTranslate(el, axis = 'x') {\n  const window = getWindow();\n  let matrix;\n  let curTransform;\n  let transformMatrix;\n\n  const curStyle = getComputedStyle(el, null);\n\n  if (window.WebKitCSSMatrix) {\n    curTransform = curStyle.transform || curStyle.webkitTransform;\n    if (curTransform.split(',').length > 6) {\n      curTransform = curTransform\n        .split(', ')\n        .map((a) => a.replace(',', '.'))\n        .join(', ');\n    }\n    // Some old versions of Webkit choke when 'none' is passed; pass\n    // empty string instead in this case\n    transformMatrix = new window.WebKitCSSMatrix(curTransform === 'none' ? '' : curTransform);\n  } else {\n    transformMatrix =\n      curStyle.MozTransform ||\n      curStyle.OTransform ||\n      curStyle.MsTransform ||\n      curStyle.msTransform ||\n      curStyle.transform ||\n      curStyle.getPropertyValue('transform').replace('translate(', 'matrix(1, 0, 0, 1,');\n    matrix = transformMatrix.toString().split(',');\n  }\n\n  if (axis === 'x') {\n    // Latest Chrome and webkits Fix\n    if (window.WebKitCSSMatrix) curTransform = transformMatrix.m41;\n    // Crazy IE10 Matrix\n    else if (matrix.length === 16) curTransform = parseFloat(matrix[12]);\n    // Normal Browsers\n    else curTransform = parseFloat(matrix[4]);\n  }\n  if (axis === 'y') {\n    // Latest Chrome and webkits Fix\n    if (window.WebKitCSSMatrix) curTransform = transformMatrix.m42;\n    // Crazy IE10 Matrix\n    else if (matrix.length === 16) curTransform = parseFloat(matrix[13]);\n    // Normal Browsers\n    else curTransform = parseFloat(matrix[5]);\n  }\n  return curTransform || 0;\n}\nfunction isObject(o) {\n  return (\n    typeof o === 'object' &&\n    o !== null &&\n    o.constructor &&\n    Object.prototype.toString.call(o).slice(8, -1) === 'Object'\n  );\n}\nfunction extend(...args) {\n  const to = Object(args[0]);\n  const noExtend = ['__proto__', 'constructor', 'prototype'];\n  for (let i = 1; i < args.length; i += 1) {\n    const nextSource = args[i];\n    if (nextSource !== undefined && nextSource !== null) {\n      const keysArray = Object.keys(Object(nextSource)).filter((key) => noExtend.indexOf(key) < 0);\n      for (let nextIndex = 0, len = keysArray.length; nextIndex < len; nextIndex += 1) {\n        const nextKey = keysArray[nextIndex];\n        const desc = Object.getOwnPropertyDescriptor(nextSource, nextKey);\n        if (desc !== undefined && desc.enumerable) {\n          if (isObject(to[nextKey]) && isObject(nextSource[nextKey])) {\n            if (nextSource[nextKey].__swiper__) {\n              to[nextKey] = nextSource[nextKey];\n            } else {\n              extend(to[nextKey], nextSource[nextKey]);\n            }\n          } else if (!isObject(to[nextKey]) && isObject(nextSource[nextKey])) {\n            to[nextKey] = {};\n            if (nextSource[nextKey].__swiper__) {\n              to[nextKey] = nextSource[nextKey];\n            } else {\n              extend(to[nextKey], nextSource[nextKey]);\n            }\n          } else {\n            to[nextKey] = nextSource[nextKey];\n          }\n        }\n      }\n    }\n  }\n  return to;\n}\n\nfunction bindModuleMethods(instance, obj) {\n  Object.keys(obj).forEach((key) => {\n    if (isObject(obj[key])) {\n      Object.keys(obj[key]).forEach((subKey) => {\n        if (typeof obj[key][subKey] === 'function') {\n          obj[key][subKey] = obj[key][subKey].bind(instance);\n        }\n      });\n    }\n    instance[key] = obj[key];\n  });\n}\n\nexport {\n  deleteProps,\n  nextTick,\n  now,\n  getTranslate,\n  isObject,\n  extend,\n  bindModuleMethods,\n  getComputedStyle,\n};\n","import { getWindow, getDocument } from 'ssr-window';\n\nlet support;\n\nfunction calcSupport() {\n  const window = getWindow();\n  const document = getDocument();\n\n  return {\n    touch: !!(\n      'ontouchstart' in window ||\n      (window.DocumentTouch && document instanceof window.DocumentTouch)\n    ),\n\n    pointerEvents:\n      !!window.PointerEvent &&\n      'maxTouchPoints' in window.navigator &&\n      window.navigator.maxTouchPoints >= 0,\n\n    observer: (function checkObserver() {\n      return 'MutationObserver' in window || 'WebkitMutationObserver' in window;\n    })(),\n\n    passiveListener: (function checkPassiveListener() {\n      let supportsPassive = false;\n      try {\n        const opts = Object.defineProperty({}, 'passive', {\n          // eslint-disable-next-line\n          get() {\n            supportsPassive = true;\n          },\n        });\n        window.addEventListener('testPassiveListener', null, opts);\n      } catch (e) {\n        // No support\n      }\n      return supportsPassive;\n    })(),\n\n    gestures: (function checkGestures() {\n      return 'ongesturestart' in window;\n    })(),\n  };\n}\n\nfunction getSupport() {\n  if (!support) {\n    support = calcSupport();\n  }\n  return support;\n}\n\nexport { getSupport };\n","import { getWindow } from 'ssr-window';\nimport { getSupport } from './get-support';\n\nlet device;\n\nfunction calcDevice({ userAgent } = {}) {\n  const support = getSupport();\n  const window = getWindow();\n  const platform = window.navigator.platform;\n  const ua = userAgent || window.navigator.userAgent;\n\n  const device = {\n    ios: false,\n    android: false,\n  };\n\n  const screenWidth = window.screen.width;\n  const screenHeight = window.screen.height;\n\n  const android = ua.match(/(Android);?[\\s\\/]+([\\d.]+)?/); // eslint-disable-line\n  let ipad = ua.match(/(iPad).*OS\\s([\\d_]+)/);\n  const ipod = ua.match(/(iPod)(.*OS\\s([\\d_]+))?/);\n  const iphone = !ipad && ua.match(/(iPhone\\sOS|iOS)\\s([\\d_]+)/);\n  const windows = platform === 'Win32';\n  let macos = platform === 'MacIntel';\n\n  // iPadOs 13 fix\n  const iPadScreens = [\n    '1024x1366',\n    '1366x1024',\n    '834x1194',\n    '1194x834',\n    '834x1112',\n    '1112x834',\n    '768x1024',\n    '1024x768',\n    '820x1180',\n    '1180x820',\n    '810x1080',\n    '1080x810',\n  ];\n  if (\n    !ipad &&\n    macos &&\n    support.touch &&\n    iPadScreens.indexOf(`${screenWidth}x${screenHeight}`) >= 0\n  ) {\n    ipad = ua.match(/(Version)\\/([\\d.]+)/);\n    if (!ipad) ipad = [0, 1, '13_0_0'];\n    macos = false;\n  }\n\n  // Android\n  if (android && !windows) {\n    device.os = 'android';\n    device.android = true;\n  }\n  if (ipad || iphone || ipod) {\n    device.os = 'ios';\n    device.ios = true;\n  }\n\n  // Export object\n  return device;\n}\n\nfunction getDevice(overrides = {}) {\n  if (!device) {\n    device = calcDevice(overrides);\n  }\n  return device;\n}\n\nexport { getDevice };\n","import { getWindow } from 'ssr-window';\n\nlet browser;\n\nfunction calcBrowser() {\n  const window = getWindow();\n  function isSafari() {\n    const ua = window.navigator.userAgent.toLowerCase();\n    return ua.indexOf('safari') >= 0 && ua.indexOf('chrome') < 0 && ua.indexOf('android') < 0;\n  }\n  return {\n    isEdge: !!window.navigator.userAgent.match(/Edge/g),\n    isSafari: isSafari(),\n    isWebView: /(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)/i.test(window.navigator.userAgent),\n  };\n}\n\nfunction getBrowser() {\n  if (!browser) {\n    browser = calcBrowser();\n  }\n  return browser;\n}\n\nexport { getBrowser };\n","import { getWindow } from 'ssr-window';\nimport { extend } from '../../utils/utils';\n\nconst supportsResizeObserver = () => {\n  const window = getWindow();\n  return typeof window.ResizeObserver !== 'undefined';\n};\n\nexport default {\n  name: 'resize',\n  create() {\n    const swiper = this;\n    extend(swiper, {\n      resize: {\n        observer: null,\n        createObserver() {\n          if (!swiper || swiper.destroyed || !swiper.initialized) return;\n          swiper.resize.observer = new ResizeObserver((entries) => {\n            const { width, height } = swiper;\n            let newWidth = width;\n            let newHeight = height;\n            entries.forEach(({ contentBoxSize, contentRect, target }) => {\n              if (target && target !== swiper.el) return;\n              newWidth = contentRect\n                ? contentRect.width\n                : (contentBoxSize[0] || contentBoxSize).inlineSize;\n              newHeight = contentRect\n                ? contentRect.height\n                : (contentBoxSize[0] || contentBoxSize).blockSize;\n            });\n            if (newWidth !== width || newHeight !== height) {\n              swiper.resize.resizeHandler();\n            }\n          });\n          swiper.resize.observer.observe(swiper.el);\n        },\n        removeObserver() {\n          if (swiper.resize.observer && swiper.resize.observer.unobserve && swiper.el) {\n            swiper.resize.observer.unobserve(swiper.el);\n            swiper.resize.observer = null;\n          }\n        },\n        resizeHandler() {\n          if (!swiper || swiper.destroyed || !swiper.initialized) return;\n          swiper.emit('beforeResize');\n          swiper.emit('resize');\n        },\n        orientationChangeHandler() {\n          if (!swiper || swiper.destroyed || !swiper.initialized) return;\n          swiper.emit('orientationchange');\n        },\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      const window = getWindow();\n      if (swiper.params.resizeObserver && supportsResizeObserver()) {\n        swiper.resize.createObserver();\n        return;\n      }\n      // Emit resize\n      window.addEventListener('resize', swiper.resize.resizeHandler);\n\n      // Emit orientationchange\n      window.addEventListener('orientationchange', swiper.resize.orientationChangeHandler);\n    },\n    destroy(swiper) {\n      const window = getWindow();\n      swiper.resize.removeObserver();\n      window.removeEventListener('resize', swiper.resize.resizeHandler);\n      window.removeEventListener('orientationchange', swiper.resize.orientationChangeHandler);\n    },\n  },\n};\n","import { getWindow } from 'ssr-window';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst Observer = {\n  attach(target, options = {}) {\n    const window = getWindow();\n    const swiper = this;\n\n    const ObserverFunc = window.MutationObserver || window.WebkitMutationObserver;\n    const observer = new ObserverFunc((mutations) => {\n      // The observerUpdate event should only be triggered\n      // once despite the number of mutations.  Additional\n      // triggers are redundant and are very costly\n      if (mutations.length === 1) {\n        swiper.emit('observerUpdate', mutations[0]);\n        return;\n      }\n      const observerUpdate = function observerUpdate() {\n        swiper.emit('observerUpdate', mutations[0]);\n      };\n\n      if (window.requestAnimationFrame) {\n        window.requestAnimationFrame(observerUpdate);\n      } else {\n        window.setTimeout(observerUpdate, 0);\n      }\n    });\n\n    observer.observe(target, {\n      attributes: typeof options.attributes === 'undefined' ? true : options.attributes,\n      childList: typeof options.childList === 'undefined' ? true : options.childList,\n      characterData: typeof options.characterData === 'undefined' ? true : options.characterData,\n    });\n\n    swiper.observer.observers.push(observer);\n  },\n  init() {\n    const swiper = this;\n    if (!swiper.support.observer || !swiper.params.observer) return;\n    if (swiper.params.observeParents) {\n      const containerParents = swiper.$el.parents();\n      for (let i = 0; i < containerParents.length; i += 1) {\n        swiper.observer.attach(containerParents[i]);\n      }\n    }\n    // Observe container\n    swiper.observer.attach(swiper.$el[0], {\n      childList: swiper.params.observeSlideChildren,\n    });\n\n    // Observe wrapper\n    swiper.observer.attach(swiper.$wrapperEl[0], { attributes: false });\n  },\n  destroy() {\n    const swiper = this;\n    swiper.observer.observers.forEach((observer) => {\n      observer.disconnect();\n    });\n    swiper.observer.observers = [];\n  },\n};\n\nexport default {\n  name: 'observer',\n  params: {\n    observer: false,\n    observeParents: false,\n    observeSlideChildren: false,\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      observer: {\n        ...Observer,\n        observers: [],\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      swiper.observer.init();\n    },\n    destroy(swiper) {\n      swiper.observer.destroy();\n    },\n  },\n};\n","import { extend } from '../../utils/utils';\n\nexport default {\n  useParams(instanceParams) {\n    const instance = this;\n    if (!instance.modules) return;\n    Object.keys(instance.modules).forEach((moduleName) => {\n      const module = instance.modules[moduleName];\n      // Extend params\n      if (module.params) {\n        extend(instanceParams, module.params);\n      }\n    });\n  },\n\n  useModules(modulesParams = {}) {\n    const instance = this;\n    if (!instance.modules) return;\n    Object.keys(instance.modules).forEach((moduleName) => {\n      const module = instance.modules[moduleName];\n      const moduleParams = modulesParams[moduleName] || {};\n\n      // Add event listeners\n      if (module.on && instance.on) {\n        Object.keys(module.on).forEach((moduleEventName) => {\n          instance.on(moduleEventName, module.on[moduleEventName]);\n        });\n      }\n\n      // Module create callback\n      if (module.create) {\n        module.create.bind(instance)(moduleParams);\n      }\n    });\n  },\n};\n","/* eslint-disable no-underscore-dangle */\n\nexport default {\n  on(events, handler, priority) {\n    const self = this;\n    if (typeof handler !== 'function') return self;\n    const method = priority ? 'unshift' : 'push';\n    events.split(' ').forEach((event) => {\n      if (!self.eventsListeners[event]) self.eventsListeners[event] = [];\n      self.eventsListeners[event][method](handler);\n    });\n    return self;\n  },\n\n  once(events, handler, priority) {\n    const self = this;\n    if (typeof handler !== 'function') return self;\n    function onceHandler(...args) {\n      self.off(events, onceHandler);\n      if (onceHandler.__emitterProxy) {\n        delete onceHandler.__emitterProxy;\n      }\n      handler.apply(self, args);\n    }\n    onceHandler.__emitterProxy = handler;\n    return self.on(events, onceHandler, priority);\n  },\n\n  onAny(handler, priority) {\n    const self = this;\n    if (typeof handler !== 'function') return self;\n    const method = priority ? 'unshift' : 'push';\n    if (self.eventsAnyListeners.indexOf(handler) < 0) {\n      self.eventsAnyListeners[method](handler);\n    }\n    return self;\n  },\n\n  offAny(handler) {\n    const self = this;\n    if (!self.eventsAnyListeners) return self;\n    const index = self.eventsAnyListeners.indexOf(handler);\n    if (index >= 0) {\n      self.eventsAnyListeners.splice(index, 1);\n    }\n    return self;\n  },\n\n  off(events, handler) {\n    const self = this;\n    if (!self.eventsListeners) return self;\n    events.split(' ').forEach((event) => {\n      if (typeof handler === 'undefined') {\n        self.eventsListeners[event] = [];\n      } else if (self.eventsListeners[event]) {\n        self.eventsListeners[event].forEach((eventHandler, index) => {\n          if (\n            eventHandler === handler ||\n            (eventHandler.__emitterProxy && eventHandler.__emitterProxy === handler)\n          ) {\n            self.eventsListeners[event].splice(index, 1);\n          }\n        });\n      }\n    });\n    return self;\n  },\n\n  emit(...args) {\n    const self = this;\n    if (!self.eventsListeners) return self;\n    let events;\n    let data;\n    let context;\n    if (typeof args[0] === 'string' || Array.isArray(args[0])) {\n      events = args[0];\n      data = args.slice(1, args.length);\n      context = self;\n    } else {\n      events = args[0].events;\n      data = args[0].data;\n      context = args[0].context || self;\n    }\n    data.unshift(context);\n    const eventsArray = Array.isArray(events) ? events : events.split(' ');\n\n    eventsArray.forEach((event) => {\n      if (self.eventsAnyListeners && self.eventsAnyListeners.length) {\n        self.eventsAnyListeners.forEach((eventHandler) => {\n          eventHandler.apply(context, [event, ...data]);\n        });\n      }\n      if (self.eventsListeners && self.eventsListeners[event]) {\n        self.eventsListeners[event].forEach((eventHandler) => {\n          eventHandler.apply(context, data);\n        });\n      }\n    });\n    return self;\n  },\n};\n","import { extend } from '../../../utils/utils';\n\nexport default function updateSize() {\n  const swiper = this;\n  let width;\n  let height;\n  const $el = swiper.$el;\n  if (typeof swiper.params.width !== 'undefined' && swiper.params.width !== null) {\n    width = swiper.params.width;\n  } else {\n    width = $el[0].clientWidth;\n  }\n  if (typeof swiper.params.height !== 'undefined' && swiper.params.height !== null) {\n    height = swiper.params.height;\n  } else {\n    height = $el[0].clientHeight;\n  }\n  if ((width === 0 && swiper.isHorizontal()) || (height === 0 && swiper.isVertical())) {\n    return;\n  }\n\n  // Subtract paddings\n  width =\n    width -\n    parseInt($el.css('padding-left') || 0, 10) -\n    parseInt($el.css('padding-right') || 0, 10);\n  height =\n    height -\n    parseInt($el.css('padding-top') || 0, 10) -\n    parseInt($el.css('padding-bottom') || 0, 10);\n\n  if (Number.isNaN(width)) width = 0;\n  if (Number.isNaN(height)) height = 0;\n\n  extend(swiper, {\n    width,\n    height,\n    size: swiper.isHorizontal() ? width : height,\n  });\n}\n","import { extend } from '../../../utils/utils';\n\nexport default function updateSlides() {\n  const swiper = this;\n  const getDirectionLabel = (property) => {\n    if (swiper.isHorizontal()) {\n      return property;\n    }\n    // prettier-ignore\n    return {\n      'width': 'height',\n      'margin-top': 'margin-left',\n      'margin-bottom ': 'margin-right',\n      'margin-left': 'margin-top',\n      'margin-right': 'margin-bottom',\n      'padding-left': 'padding-top',\n      'padding-right': 'padding-bottom',\n      'marginRight': 'marginBottom',\n    }[property];\n  };\n  const getDirectionPropertyValue = (node, label) => {\n    return parseFloat(node.getPropertyValue(getDirectionLabel(label)) || 0);\n  };\n\n  const params = swiper.params;\n\n  const { $wrapperEl, size: swiperSize, rtlTranslate: rtl, wrongRTL } = swiper;\n  const isVirtual = swiper.virtual && params.virtual.enabled;\n  const previousSlidesLength = isVirtual ? swiper.virtual.slides.length : swiper.slides.length;\n  const slides = $wrapperEl.children(`.${swiper.params.slideClass}`);\n  const slidesLength = isVirtual ? swiper.virtual.slides.length : slides.length;\n  let snapGrid = [];\n  const slidesGrid = [];\n  const slidesSizesGrid = [];\n\n  function slidesForMargin(slideEl, slideIndex) {\n    if (!params.cssMode) return true;\n    if (slideIndex === slides.length - 1) {\n      return false;\n    }\n    return true;\n  }\n\n  let offsetBefore = params.slidesOffsetBefore;\n  if (typeof offsetBefore === 'function') {\n    offsetBefore = params.slidesOffsetBefore.call(swiper);\n  }\n\n  let offsetAfter = params.slidesOffsetAfter;\n  if (typeof offsetAfter === 'function') {\n    offsetAfter = params.slidesOffsetAfter.call(swiper);\n  }\n\n  const previousSnapGridLength = swiper.snapGrid.length;\n  const previousSlidesGridLength = swiper.slidesGrid.length;\n\n  let spaceBetween = params.spaceBetween;\n  let slidePosition = -offsetBefore;\n  let prevSlideSize = 0;\n  let index = 0;\n  if (typeof swiperSize === 'undefined') {\n    return;\n  }\n  if (typeof spaceBetween === 'string' && spaceBetween.indexOf('%') >= 0) {\n    spaceBetween = (parseFloat(spaceBetween.replace('%', '')) / 100) * swiperSize;\n  }\n\n  swiper.virtualSize = -spaceBetween;\n\n  // reset margins\n  if (rtl) slides.css({ marginLeft: '', marginTop: '' });\n  else slides.css({ marginRight: '', marginBottom: '' });\n\n  let slidesNumberEvenToRows;\n  if (params.slidesPerColumn > 1) {\n    if (\n      Math.floor(slidesLength / params.slidesPerColumn) ===\n      slidesLength / swiper.params.slidesPerColumn\n    ) {\n      slidesNumberEvenToRows = slidesLength;\n    } else {\n      slidesNumberEvenToRows =\n        Math.ceil(slidesLength / params.slidesPerColumn) * params.slidesPerColumn;\n    }\n    if (params.slidesPerView !== 'auto' && params.slidesPerColumnFill === 'row') {\n      slidesNumberEvenToRows = Math.max(\n        slidesNumberEvenToRows,\n        params.slidesPerView * params.slidesPerColumn,\n      );\n    }\n  }\n\n  // Calc slides\n  let slideSize;\n  const slidesPerColumn = params.slidesPerColumn;\n  const slidesPerRow = slidesNumberEvenToRows / slidesPerColumn;\n  const numFullColumns = Math.floor(slidesLength / params.slidesPerColumn);\n  for (let i = 0; i < slidesLength; i += 1) {\n    slideSize = 0;\n    const slide = slides.eq(i);\n    if (params.slidesPerColumn > 1) {\n      // Set slides order\n      let newSlideOrderIndex;\n      let column;\n      let row;\n      if (params.slidesPerColumnFill === 'row' && params.slidesPerGroup > 1) {\n        const groupIndex = Math.floor(i / (params.slidesPerGroup * params.slidesPerColumn));\n        const slideIndexInGroup = i - params.slidesPerColumn * params.slidesPerGroup * groupIndex;\n        const columnsInGroup =\n          groupIndex === 0\n            ? params.slidesPerGroup\n            : Math.min(\n                Math.ceil(\n                  (slidesLength - groupIndex * slidesPerColumn * params.slidesPerGroup) /\n                    slidesPerColumn,\n                ),\n                params.slidesPerGroup,\n              );\n        row = Math.floor(slideIndexInGroup / columnsInGroup);\n        column = slideIndexInGroup - row * columnsInGroup + groupIndex * params.slidesPerGroup;\n\n        newSlideOrderIndex = column + (row * slidesNumberEvenToRows) / slidesPerColumn;\n        slide.css({\n          '-webkit-box-ordinal-group': newSlideOrderIndex,\n          '-moz-box-ordinal-group': newSlideOrderIndex,\n          '-ms-flex-order': newSlideOrderIndex,\n          '-webkit-order': newSlideOrderIndex,\n          order: newSlideOrderIndex,\n        });\n      } else if (params.slidesPerColumnFill === 'column') {\n        column = Math.floor(i / slidesPerColumn);\n        row = i - column * slidesPerColumn;\n        if (column > numFullColumns || (column === numFullColumns && row === slidesPerColumn - 1)) {\n          row += 1;\n          if (row >= slidesPerColumn) {\n            row = 0;\n            column += 1;\n          }\n        }\n      } else {\n        row = Math.floor(i / slidesPerRow);\n        column = i - row * slidesPerRow;\n      }\n      slide.css(\n        getDirectionLabel('margin-top'),\n        row !== 0 && params.spaceBetween && `${params.spaceBetween}px`,\n      );\n    }\n    if (slide.css('display') === 'none') continue; // eslint-disable-line\n\n    if (params.slidesPerView === 'auto') {\n      const slideStyles = getComputedStyle(slide[0]);\n      const currentTransform = slide[0].style.transform;\n      const currentWebKitTransform = slide[0].style.webkitTransform;\n      if (currentTransform) {\n        slide[0].style.transform = 'none';\n      }\n      if (currentWebKitTransform) {\n        slide[0].style.webkitTransform = 'none';\n      }\n      if (params.roundLengths) {\n        slideSize = swiper.isHorizontal() ? slide.outerWidth(true) : slide.outerHeight(true);\n      } else {\n        // eslint-disable-next-line\n        const width = getDirectionPropertyValue(slideStyles, 'width');\n        const paddingLeft = getDirectionPropertyValue(slideStyles, 'padding-left');\n        const paddingRight = getDirectionPropertyValue(slideStyles, 'padding-right');\n        const marginLeft = getDirectionPropertyValue(slideStyles, 'margin-left');\n        const marginRight = getDirectionPropertyValue(slideStyles, 'margin-right');\n        const boxSizing = slideStyles.getPropertyValue('box-sizing');\n        if (boxSizing && boxSizing === 'border-box') {\n          slideSize = width + marginLeft + marginRight;\n        } else {\n          const { clientWidth, offsetWidth } = slide[0];\n          slideSize =\n            width +\n            paddingLeft +\n            paddingRight +\n            marginLeft +\n            marginRight +\n            (offsetWidth - clientWidth);\n        }\n      }\n      if (currentTransform) {\n        slide[0].style.transform = currentTransform;\n      }\n      if (currentWebKitTransform) {\n        slide[0].style.webkitTransform = currentWebKitTransform;\n      }\n      if (params.roundLengths) slideSize = Math.floor(slideSize);\n    } else {\n      slideSize = (swiperSize - (params.slidesPerView - 1) * spaceBetween) / params.slidesPerView;\n      if (params.roundLengths) slideSize = Math.floor(slideSize);\n\n      if (slides[i]) {\n        slides[i].style[getDirectionLabel('width')] = `${slideSize}px`;\n      }\n    }\n    if (slides[i]) {\n      slides[i].swiperSlideSize = slideSize;\n    }\n    slidesSizesGrid.push(slideSize);\n\n    if (params.centeredSlides) {\n      slidePosition = slidePosition + slideSize / 2 + prevSlideSize / 2 + spaceBetween;\n      if (prevSlideSize === 0 && i !== 0)\n        slidePosition = slidePosition - swiperSize / 2 - spaceBetween;\n      if (i === 0) slidePosition = slidePosition - swiperSize / 2 - spaceBetween;\n      if (Math.abs(slidePosition) < 1 / 1000) slidePosition = 0;\n      if (params.roundLengths) slidePosition = Math.floor(slidePosition);\n      if (index % params.slidesPerGroup === 0) snapGrid.push(slidePosition);\n      slidesGrid.push(slidePosition);\n    } else {\n      if (params.roundLengths) slidePosition = Math.floor(slidePosition);\n      if (\n        (index - Math.min(swiper.params.slidesPerGroupSkip, index)) %\n          swiper.params.slidesPerGroup ===\n        0\n      )\n        snapGrid.push(slidePosition);\n      slidesGrid.push(slidePosition);\n      slidePosition = slidePosition + slideSize + spaceBetween;\n    }\n\n    swiper.virtualSize += slideSize + spaceBetween;\n\n    prevSlideSize = slideSize;\n\n    index += 1;\n  }\n  swiper.virtualSize = Math.max(swiper.virtualSize, swiperSize) + offsetAfter;\n  let newSlidesGrid;\n\n  if (rtl && wrongRTL && (params.effect === 'slide' || params.effect === 'coverflow')) {\n    $wrapperEl.css({ width: `${swiper.virtualSize + params.spaceBetween}px` });\n  }\n  if (params.setWrapperSize) {\n    $wrapperEl.css({\n      [getDirectionLabel('width')]: `${swiper.virtualSize + params.spaceBetween}px`,\n    });\n  }\n\n  if (params.slidesPerColumn > 1) {\n    swiper.virtualSize = (slideSize + params.spaceBetween) * slidesNumberEvenToRows;\n    swiper.virtualSize =\n      Math.ceil(swiper.virtualSize / params.slidesPerColumn) - params.spaceBetween;\n    $wrapperEl.css({\n      [getDirectionLabel('width')]: `${swiper.virtualSize + params.spaceBetween}px`,\n    });\n    if (params.centeredSlides) {\n      newSlidesGrid = [];\n      for (let i = 0; i < snapGrid.length; i += 1) {\n        let slidesGridItem = snapGrid[i];\n        if (params.roundLengths) slidesGridItem = Math.floor(slidesGridItem);\n        if (snapGrid[i] < swiper.virtualSize + snapGrid[0]) newSlidesGrid.push(slidesGridItem);\n      }\n      snapGrid = newSlidesGrid;\n    }\n  }\n\n  // Remove last grid elements depending on width\n  if (!params.centeredSlides) {\n    newSlidesGrid = [];\n    for (let i = 0; i < snapGrid.length; i += 1) {\n      let slidesGridItem = snapGrid[i];\n      if (params.roundLengths) slidesGridItem = Math.floor(slidesGridItem);\n      if (snapGrid[i] <= swiper.virtualSize - swiperSize) {\n        newSlidesGrid.push(slidesGridItem);\n      }\n    }\n    snapGrid = newSlidesGrid;\n\n    if (\n      Math.floor(swiper.virtualSize - swiperSize) - Math.floor(snapGrid[snapGrid.length - 1]) >\n      1\n    ) {\n      snapGrid.push(swiper.virtualSize - swiperSize);\n    }\n  }\n  if (snapGrid.length === 0) snapGrid = [0];\n\n  if (params.spaceBetween !== 0) {\n    const key = swiper.isHorizontal() && rtl ? 'marginLeft' : getDirectionLabel('marginRight');\n    slides.filter(slidesForMargin).css({ [key]: `${spaceBetween}px` });\n  }\n\n  if (params.centeredSlides && params.centeredSlidesBounds) {\n    let allSlidesSize = 0;\n    slidesSizesGrid.forEach((slideSizeValue) => {\n      allSlidesSize += slideSizeValue + (params.spaceBetween ? params.spaceBetween : 0);\n    });\n    allSlidesSize -= params.spaceBetween;\n    const maxSnap = allSlidesSize - swiperSize;\n    snapGrid = snapGrid.map((snap) => {\n      if (snap < 0) return -offsetBefore;\n      if (snap > maxSnap) return maxSnap + offsetAfter;\n      return snap;\n    });\n  }\n\n  if (params.centerInsufficientSlides) {\n    let allSlidesSize = 0;\n    slidesSizesGrid.forEach((slideSizeValue) => {\n      allSlidesSize += slideSizeValue + (params.spaceBetween ? params.spaceBetween : 0);\n    });\n    allSlidesSize -= params.spaceBetween;\n    if (allSlidesSize < swiperSize) {\n      const allSlidesOffset = (swiperSize - allSlidesSize) / 2;\n      snapGrid.forEach((snap, snapIndex) => {\n        snapGrid[snapIndex] = snap - allSlidesOffset;\n      });\n      slidesGrid.forEach((snap, snapIndex) => {\n        slidesGrid[snapIndex] = snap + allSlidesOffset;\n      });\n    }\n  }\n\n  extend(swiper, {\n    slides,\n    snapGrid,\n    slidesGrid,\n    slidesSizesGrid,\n  });\n\n  if (slidesLength !== previousSlidesLength) {\n    swiper.emit('slidesLengthChange');\n  }\n  if (snapGrid.length !== previousSnapGridLength) {\n    if (swiper.params.watchOverflow) swiper.checkOverflow();\n    swiper.emit('snapGridLengthChange');\n  }\n  if (slidesGrid.length !== previousSlidesGridLength) {\n    swiper.emit('slidesGridLengthChange');\n  }\n\n  if (params.watchSlidesProgress || params.watchSlidesVisibility) {\n    swiper.updateSlidesOffset();\n  }\n}\n","export default function updateAutoHeight(speed) {\n  const swiper = this;\n  const activeSlides = [];\n  let newHeight = 0;\n  let i;\n  if (typeof speed === 'number') {\n    swiper.setTransition(speed);\n  } else if (speed === true) {\n    swiper.setTransition(swiper.params.speed);\n  }\n  // Find slides currently in view\n  if (swiper.params.slidesPerView !== 'auto' && swiper.params.slidesPerView > 1) {\n    if (swiper.params.centeredSlides) {\n      swiper.visibleSlides.each((slide) => {\n        activeSlides.push(slide);\n      });\n    } else {\n      for (i = 0; i < Math.ceil(swiper.params.slidesPerView); i += 1) {\n        const index = swiper.activeIndex + i;\n        if (index > swiper.slides.length) break;\n        activeSlides.push(swiper.slides.eq(index)[0]);\n      }\n    }\n  } else {\n    activeSlides.push(swiper.slides.eq(swiper.activeIndex)[0]);\n  }\n\n  // Find new height from highest slide in view\n  for (i = 0; i < activeSlides.length; i += 1) {\n    if (typeof activeSlides[i] !== 'undefined') {\n      const height = activeSlides[i].offsetHeight;\n      newHeight = height > newHeight ? height : newHeight;\n    }\n  }\n\n  // Update Height\n  if (newHeight) swiper.$wrapperEl.css('height', `${newHeight}px`);\n}\n","export default function updateSlidesOffset() {\n  const swiper = this;\n  const slides = swiper.slides;\n  for (let i = 0; i < slides.length; i += 1) {\n    slides[i].swiperSlideOffset = swiper.isHorizontal()\n      ? slides[i].offsetLeft\n      : slides[i].offsetTop;\n  }\n}\n","import $ from '../../../utils/dom';\n\nexport default function updateSlidesProgress(translate = (this && this.translate) || 0) {\n  const swiper = this;\n  const params = swiper.params;\n\n  const { slides, rtlTranslate: rtl } = swiper;\n\n  if (slides.length === 0) return;\n  if (typeof slides[0].swiperSlideOffset === 'undefined') swiper.updateSlidesOffset();\n\n  let offsetCenter = -translate;\n  if (rtl) offsetCenter = translate;\n\n  // Visible Slides\n  slides.removeClass(params.slideVisibleClass);\n\n  swiper.visibleSlidesIndexes = [];\n  swiper.visibleSlides = [];\n\n  for (let i = 0; i < slides.length; i += 1) {\n    const slide = slides[i];\n    const slideProgress =\n      (offsetCenter +\n        (params.centeredSlides ? swiper.minTranslate() : 0) -\n        slide.swiperSlideOffset) /\n      (slide.swiperSlideSize + params.spaceBetween);\n    if (params.watchSlidesVisibility || (params.centeredSlides && params.autoHeight)) {\n      const slideBefore = -(offsetCenter - slide.swiperSlideOffset);\n      const slideAfter = slideBefore + swiper.slidesSizesGrid[i];\n      const isVisible =\n        (slideBefore >= 0 && slideBefore < swiper.size - 1) ||\n        (slideAfter > 1 && slideAfter <= swiper.size) ||\n        (slideBefore <= 0 && slideAfter >= swiper.size);\n      if (isVisible) {\n        swiper.visibleSlides.push(slide);\n        swiper.visibleSlidesIndexes.push(i);\n        slides.eq(i).addClass(params.slideVisibleClass);\n      }\n    }\n    slide.progress = rtl ? -slideProgress : slideProgress;\n  }\n  swiper.visibleSlides = $(swiper.visibleSlides);\n}\n","import { extend } from '../../../utils/utils';\n\nexport default function updateProgress(translate) {\n  const swiper = this;\n  if (typeof translate === 'undefined') {\n    const multiplier = swiper.rtlTranslate ? -1 : 1;\n    // eslint-disable-next-line\n    translate = (swiper && swiper.translate && swiper.translate * multiplier) || 0;\n  }\n  const params = swiper.params;\n  const translatesDiff = swiper.maxTranslate() - swiper.minTranslate();\n  let { progress, isBeginning, isEnd } = swiper;\n  const wasBeginning = isBeginning;\n  const wasEnd = isEnd;\n  if (translatesDiff === 0) {\n    progress = 0;\n    isBeginning = true;\n    isEnd = true;\n  } else {\n    progress = (translate - swiper.minTranslate()) / translatesDiff;\n    isBeginning = progress <= 0;\n    isEnd = progress >= 1;\n  }\n  extend(swiper, {\n    progress,\n    isBeginning,\n    isEnd,\n  });\n\n  if (\n    params.watchSlidesProgress ||\n    params.watchSlidesVisibility ||\n    (params.centeredSlides && params.autoHeight)\n  )\n    swiper.updateSlidesProgress(translate);\n\n  if (isBeginning && !wasBeginning) {\n    swiper.emit('reachBeginning toEdge');\n  }\n  if (isEnd && !wasEnd) {\n    swiper.emit('reachEnd toEdge');\n  }\n  if ((wasBeginning && !isBeginning) || (wasEnd && !isEnd)) {\n    swiper.emit('fromEdge');\n  }\n\n  swiper.emit('progress', progress);\n}\n","export default function updateSlidesClasses() {\n  const swiper = this;\n\n  const { slides, params, $wrapperEl, activeIndex, realIndex } = swiper;\n  const isVirtual = swiper.virtual && params.virtual.enabled;\n\n  slides.removeClass(\n    `${params.slideActiveClass} ${params.slideNextClass} ${params.slidePrevClass} ${params.slideDuplicateActiveClass} ${params.slideDuplicateNextClass} ${params.slideDuplicatePrevClass}`,\n  );\n\n  let activeSlide;\n  if (isVirtual) {\n    activeSlide = swiper.$wrapperEl.find(\n      `.${params.slideClass}[data-swiper-slide-index=\"${activeIndex}\"]`,\n    );\n  } else {\n    activeSlide = slides.eq(activeIndex);\n  }\n\n  // Active classes\n  activeSlide.addClass(params.slideActiveClass);\n\n  if (params.loop) {\n    // Duplicate to all looped slides\n    if (activeSlide.hasClass(params.slideDuplicateClass)) {\n      $wrapperEl\n        .children(\n          `.${params.slideClass}:not(.${params.slideDuplicateClass})[data-swiper-slide-index=\"${realIndex}\"]`,\n        )\n        .addClass(params.slideDuplicateActiveClass);\n    } else {\n      $wrapperEl\n        .children(\n          `.${params.slideClass}.${params.slideDuplicateClass}[data-swiper-slide-index=\"${realIndex}\"]`,\n        )\n        .addClass(params.slideDuplicateActiveClass);\n    }\n  }\n  // Next Slide\n  let nextSlide = activeSlide\n    .nextAll(`.${params.slideClass}`)\n    .eq(0)\n    .addClass(params.slideNextClass);\n  if (params.loop && nextSlide.length === 0) {\n    nextSlide = slides.eq(0);\n    nextSlide.addClass(params.slideNextClass);\n  }\n  // Prev Slide\n  let prevSlide = activeSlide\n    .prevAll(`.${params.slideClass}`)\n    .eq(0)\n    .addClass(params.slidePrevClass);\n  if (params.loop && prevSlide.length === 0) {\n    prevSlide = slides.eq(-1);\n    prevSlide.addClass(params.slidePrevClass);\n  }\n  if (params.loop) {\n    // Duplicate to all looped slides\n    if (nextSlide.hasClass(params.slideDuplicateClass)) {\n      $wrapperEl\n        .children(\n          `.${params.slideClass}:not(.${\n            params.slideDuplicateClass\n          })[data-swiper-slide-index=\"${nextSlide.attr('data-swiper-slide-index')}\"]`,\n        )\n        .addClass(params.slideDuplicateNextClass);\n    } else {\n      $wrapperEl\n        .children(\n          `.${params.slideClass}.${\n            params.slideDuplicateClass\n          }[data-swiper-slide-index=\"${nextSlide.attr('data-swiper-slide-index')}\"]`,\n        )\n        .addClass(params.slideDuplicateNextClass);\n    }\n    if (prevSlide.hasClass(params.slideDuplicateClass)) {\n      $wrapperEl\n        .children(\n          `.${params.slideClass}:not(.${\n            params.slideDuplicateClass\n          })[data-swiper-slide-index=\"${prevSlide.attr('data-swiper-slide-index')}\"]`,\n        )\n        .addClass(params.slideDuplicatePrevClass);\n    } else {\n      $wrapperEl\n        .children(\n          `.${params.slideClass}.${\n            params.slideDuplicateClass\n          }[data-swiper-slide-index=\"${prevSlide.attr('data-swiper-slide-index')}\"]`,\n        )\n        .addClass(params.slideDuplicatePrevClass);\n    }\n  }\n  swiper.emitSlidesClasses();\n}\n","import { extend } from '../../../utils/utils';\n\nexport default function updateActiveIndex(newActiveIndex) {\n  const swiper = this;\n  const translate = swiper.rtlTranslate ? swiper.translate : -swiper.translate;\n  const {\n    slidesGrid,\n    snapGrid,\n    params,\n    activeIndex: previousIndex,\n    realIndex: previousRealIndex,\n    snapIndex: previousSnapIndex,\n  } = swiper;\n  let activeIndex = newActiveIndex;\n  let snapIndex;\n  if (typeof activeIndex === 'undefined') {\n    for (let i = 0; i < slidesGrid.length; i += 1) {\n      if (typeof slidesGrid[i + 1] !== 'undefined') {\n        if (\n          translate >= slidesGrid[i] &&\n          translate < slidesGrid[i + 1] - (slidesGrid[i + 1] - slidesGrid[i]) / 2\n        ) {\n          activeIndex = i;\n        } else if (translate >= slidesGrid[i] && translate < slidesGrid[i + 1]) {\n          activeIndex = i + 1;\n        }\n      } else if (translate >= slidesGrid[i]) {\n        activeIndex = i;\n      }\n    }\n    // Normalize slideIndex\n    if (params.normalizeSlideIndex) {\n      if (activeIndex < 0 || typeof activeIndex === 'undefined') activeIndex = 0;\n    }\n  }\n  if (snapGrid.indexOf(translate) >= 0) {\n    snapIndex = snapGrid.indexOf(translate);\n  } else {\n    const skip = Math.min(params.slidesPerGroupSkip, activeIndex);\n    snapIndex = skip + Math.floor((activeIndex - skip) / params.slidesPerGroup);\n  }\n  if (snapIndex >= snapGrid.length) snapIndex = snapGrid.length - 1;\n  if (activeIndex === previousIndex) {\n    if (snapIndex !== previousSnapIndex) {\n      swiper.snapIndex = snapIndex;\n      swiper.emit('snapIndexChange');\n    }\n    return;\n  }\n\n  // Get real index\n  const realIndex = parseInt(\n    swiper.slides.eq(activeIndex).attr('data-swiper-slide-index') || activeIndex,\n    10,\n  );\n\n  extend(swiper, {\n    snapIndex,\n    realIndex,\n    previousIndex,\n    activeIndex,\n  });\n  swiper.emit('activeIndexChange');\n  swiper.emit('snapIndexChange');\n  if (previousRealIndex !== realIndex) {\n    swiper.emit('realIndexChange');\n  }\n  if (swiper.initialized || swiper.params.runCallbacksOnInit) {\n    swiper.emit('slideChange');\n  }\n}\n","import $ from '../../../utils/dom';\n\nexport default function updateClickedSlide(e) {\n  const swiper = this;\n  const params = swiper.params;\n  const slide = $(e.target).closest(`.${params.slideClass}`)[0];\n  let slideFound = false;\n  let slideIndex;\n\n  if (slide) {\n    for (let i = 0; i < swiper.slides.length; i += 1) {\n      if (swiper.slides[i] === slide) {\n        slideFound = true;\n        slideIndex = i;\n        break;\n      }\n    }\n  }\n\n  if (slide && slideFound) {\n    swiper.clickedSlide = slide;\n    if (swiper.virtual && swiper.params.virtual.enabled) {\n      swiper.clickedIndex = parseInt($(slide).attr('data-swiper-slide-index'), 10);\n    } else {\n      swiper.clickedIndex = slideIndex;\n    }\n  } else {\n    swiper.clickedSlide = undefined;\n    swiper.clickedIndex = undefined;\n    return;\n  }\n  if (\n    params.slideToClickedSlide &&\n    swiper.clickedIndex !== undefined &&\n    swiper.clickedIndex !== swiper.activeIndex\n  ) {\n    swiper.slideToClickedSlide();\n  }\n}\n","import updateSize from './updateSize';\nimport updateSlides from './updateSlides';\nimport updateAutoHeight from './updateAutoHeight';\nimport updateSlidesOffset from './updateSlidesOffset';\nimport updateSlidesProgress from './updateSlidesProgress';\nimport updateProgress from './updateProgress';\nimport updateSlidesClasses from './updateSlidesClasses';\nimport updateActiveIndex from './updateActiveIndex';\nimport updateClickedSlide from './updateClickedSlide';\n\nexport default {\n  updateSize,\n  updateSlides,\n  updateAutoHeight,\n  updateSlidesOffset,\n  updateSlidesProgress,\n  updateProgress,\n  updateSlidesClasses,\n  updateActiveIndex,\n  updateClickedSlide,\n};\n","import { getTranslate } from '../../../utils/utils';\n\nexport default function getSwiperTranslate(axis = this.isHorizontal() ? 'x' : 'y') {\n  const swiper = this;\n\n  const { params, rtlTranslate: rtl, translate, $wrapperEl } = swiper;\n\n  if (params.virtualTranslate) {\n    return rtl ? -translate : translate;\n  }\n  if (params.cssMode) {\n    return translate;\n  }\n\n  let currentTranslate = getTranslate($wrapperEl[0], axis);\n  if (rtl) currentTranslate = -currentTranslate;\n\n  return currentTranslate || 0;\n}\n","export default function setTranslate(translate, byController) {\n  const swiper = this;\n  const { rtlTranslate: rtl, params, $wrapperEl, wrapperEl, progress } = swiper;\n  let x = 0;\n  let y = 0;\n  const z = 0;\n\n  if (swiper.isHorizontal()) {\n    x = rtl ? -translate : translate;\n  } else {\n    y = translate;\n  }\n\n  if (params.roundLengths) {\n    x = Math.floor(x);\n    y = Math.floor(y);\n  }\n\n  if (params.cssMode) {\n    wrapperEl[swiper.isHorizontal() ? 'scrollLeft' : 'scrollTop'] = swiper.isHorizontal() ? -x : -y;\n  } else if (!params.virtualTranslate) {\n    $wrapperEl.transform(`translate3d(${x}px, ${y}px, ${z}px)`);\n  }\n  swiper.previousTranslate = swiper.translate;\n  swiper.translate = swiper.isHorizontal() ? x : y;\n\n  // Check if we need to update progress\n  let newProgress;\n  const translatesDiff = swiper.maxTranslate() - swiper.minTranslate();\n  if (translatesDiff === 0) {\n    newProgress = 0;\n  } else {\n    newProgress = (translate - swiper.minTranslate()) / translatesDiff;\n  }\n  if (newProgress !== progress) {\n    swiper.updateProgress(translate);\n  }\n\n  swiper.emit('setTranslate', swiper.translate, byController);\n}\n","export default function minTranslate() {\n  return -this.snapGrid[0];\n}\n","export default function maxTranslate() {\n  return -this.snapGrid[this.snapGrid.length - 1];\n}\n","export default function translateTo(\n  translate = 0,\n  speed = this.params.speed,\n  runCallbacks = true,\n  translateBounds = true,\n  internal,\n) {\n  const swiper = this;\n\n  const { params, wrapperEl } = swiper;\n\n  if (swiper.animating && params.preventInteractionOnTransition) {\n    return false;\n  }\n\n  const minTranslate = swiper.minTranslate();\n  const maxTranslate = swiper.maxTranslate();\n  let newTranslate;\n  if (translateBounds && translate > minTranslate) newTranslate = minTranslate;\n  else if (translateBounds && translate < maxTranslate) newTranslate = maxTranslate;\n  else newTranslate = translate;\n\n  // Update progress\n  swiper.updateProgress(newTranslate);\n\n  if (params.cssMode) {\n    const isH = swiper.isHorizontal();\n    if (speed === 0) {\n      wrapperEl[isH ? 'scrollLeft' : 'scrollTop'] = -newTranslate;\n    } else {\n      // eslint-disable-next-line\n      if (wrapperEl.scrollTo) {\n        wrapperEl.scrollTo({\n          [isH ? 'left' : 'top']: -newTranslate,\n          behavior: 'smooth',\n        });\n      } else {\n        wrapperEl[isH ? 'scrollLeft' : 'scrollTop'] = -newTranslate;\n      }\n    }\n    return true;\n  }\n\n  if (speed === 0) {\n    swiper.setTransition(0);\n    swiper.setTranslate(newTranslate);\n    if (runCallbacks) {\n      swiper.emit('beforeTransitionStart', speed, internal);\n      swiper.emit('transitionEnd');\n    }\n  } else {\n    swiper.setTransition(speed);\n    swiper.setTranslate(newTranslate);\n    if (runCallbacks) {\n      swiper.emit('beforeTransitionStart', speed, internal);\n      swiper.emit('transitionStart');\n    }\n    if (!swiper.animating) {\n      swiper.animating = true;\n      if (!swiper.onTranslateToWrapperTransitionEnd) {\n        swiper.onTranslateToWrapperTransitionEnd = function transitionEnd(e) {\n          if (!swiper || swiper.destroyed) return;\n          if (e.target !== this) return;\n          swiper.$wrapperEl[0].removeEventListener(\n            'transitionend',\n            swiper.onTranslateToWrapperTransitionEnd,\n          );\n          swiper.$wrapperEl[0].removeEventListener(\n            'webkitTransitionEnd',\n            swiper.onTranslateToWrapperTransitionEnd,\n          );\n          swiper.onTranslateToWrapperTransitionEnd = null;\n          delete swiper.onTranslateToWrapperTransitionEnd;\n          if (runCallbacks) {\n            swiper.emit('transitionEnd');\n          }\n        };\n      }\n      swiper.$wrapperEl[0].addEventListener(\n        'transitionend',\n        swiper.onTranslateToWrapperTransitionEnd,\n      );\n      swiper.$wrapperEl[0].addEventListener(\n        'webkitTransitionEnd',\n        swiper.onTranslateToWrapperTransitionEnd,\n      );\n    }\n  }\n\n  return true;\n}\n","import getTranslate from './getTranslate';\nimport setTranslate from './setTranslate';\nimport minTranslate from './minTranslate';\nimport maxTranslate from './maxTranslate';\nimport translateTo from './translateTo';\n\nexport default {\n  getTranslate,\n  setTranslate,\n  minTranslate,\n  maxTranslate,\n  translateTo,\n};\n","export default function setTransition(duration, byController) {\n  const swiper = this;\n\n  if (!swiper.params.cssMode) {\n    swiper.$wrapperEl.transition(duration);\n  }\n\n  swiper.emit('setTransition', duration, byController);\n}\n","export default function transitionStart(runCallbacks = true, direction) {\n  const swiper = this;\n  const { activeIndex, params, previousIndex } = swiper;\n  if (params.cssMode) return;\n  if (params.autoHeight) {\n    swiper.updateAutoHeight();\n  }\n\n  let dir = direction;\n  if (!dir) {\n    if (activeIndex > previousIndex) dir = 'next';\n    else if (activeIndex < previousIndex) dir = 'prev';\n    else dir = 'reset';\n  }\n\n  swiper.emit('transitionStart');\n\n  if (runCallbacks && activeIndex !== previousIndex) {\n    if (dir === 'reset') {\n      swiper.emit('slideResetTransitionStart');\n      return;\n    }\n    swiper.emit('slideChangeTransitionStart');\n    if (dir === 'next') {\n      swiper.emit('slideNextTransitionStart');\n    } else {\n      swiper.emit('slidePrevTransitionStart');\n    }\n  }\n}\n","export default function transitionEnd(runCallbacks = true, direction) {\n  const swiper = this;\n  const { activeIndex, previousIndex, params } = swiper;\n  swiper.animating = false;\n  if (params.cssMode) return;\n  swiper.setTransition(0);\n\n  let dir = direction;\n  if (!dir) {\n    if (activeIndex > previousIndex) dir = 'next';\n    else if (activeIndex < previousIndex) dir = 'prev';\n    else dir = 'reset';\n  }\n\n  swiper.emit('transitionEnd');\n\n  if (runCallbacks && activeIndex !== previousIndex) {\n    if (dir === 'reset') {\n      swiper.emit('slideResetTransitionEnd');\n      return;\n    }\n    swiper.emit('slideChangeTransitionEnd');\n    if (dir === 'next') {\n      swiper.emit('slideNextTransitionEnd');\n    } else {\n      swiper.emit('slidePrevTransitionEnd');\n    }\n  }\n}\n","import setTransition from './setTransition';\nimport transitionStart from './transitionStart';\nimport transitionEnd from './transitionEnd';\n\nexport default {\n  setTransition,\n  transitionStart,\n  transitionEnd,\n};\n","export default function slideTo(\n  index = 0,\n  speed = this.params.speed,\n  runCallbacks = true,\n  internal,\n) {\n  if (typeof index !== 'number' && typeof index !== 'string') {\n    throw new Error(\n      `The 'index' argument cannot have type other than 'number' or 'string'. [${typeof index}] given.`,\n    );\n  }\n\n  if (typeof index === 'string') {\n    /**\n     * The `index` argument converted from `string` to `number`.\n     * @type {number}\n     */\n    const indexAsNumber = parseInt(index, 10);\n\n    /**\n     * Determines whether the `index` argument is a valid `number`\n     * after being converted from the `string` type.\n     * @type {boolean}\n     */\n    const isValidNumber = isFinite(indexAsNumber);\n\n    if (!isValidNumber) {\n      throw new Error(\n        `The passed-in 'index' (string) couldn't be converted to 'number'. [${index}] given.`,\n      );\n    }\n\n    // Knowing that the converted `index` is a valid number,\n    // we can update the original argument's value.\n    index = indexAsNumber;\n  }\n\n  const swiper = this;\n  let slideIndex = index;\n  if (slideIndex < 0) slideIndex = 0;\n\n  const {\n    params,\n    snapGrid,\n    slidesGrid,\n    previousIndex,\n    activeIndex,\n    rtlTranslate: rtl,\n    wrapperEl,\n  } = swiper;\n  if (swiper.animating && params.preventInteractionOnTransition) {\n    return false;\n  }\n\n  const skip = Math.min(swiper.params.slidesPerGroupSkip, slideIndex);\n  let snapIndex = skip + Math.floor((slideIndex - skip) / swiper.params.slidesPerGroup);\n  if (snapIndex >= snapGrid.length) snapIndex = snapGrid.length - 1;\n\n  if ((activeIndex || params.initialSlide || 0) === (previousIndex || 0) && runCallbacks) {\n    swiper.emit('beforeSlideChangeStart');\n  }\n\n  const translate = -snapGrid[snapIndex];\n\n  // Update progress\n  swiper.updateProgress(translate);\n\n  // Normalize slideIndex\n  if (params.normalizeSlideIndex) {\n    for (let i = 0; i < slidesGrid.length; i += 1) {\n      const normalizedTranslate = -Math.floor(translate * 100);\n      const normalizedGird = Math.floor(slidesGrid[i] * 100);\n      const normalizedGridNext = Math.floor(slidesGrid[i + 1] * 100);\n      if (typeof slidesGrid[i + 1] !== 'undefined') {\n        if (\n          normalizedTranslate >= normalizedGird &&\n          normalizedTranslate < normalizedGridNext - (normalizedGridNext - normalizedGird) / 2\n        ) {\n          slideIndex = i;\n        } else if (\n          normalizedTranslate >= normalizedGird &&\n          normalizedTranslate < normalizedGridNext\n        ) {\n          slideIndex = i + 1;\n        }\n      } else if (normalizedTranslate >= normalizedGird) {\n        slideIndex = i;\n      }\n    }\n  }\n  // Directions locks\n  if (swiper.initialized && slideIndex !== activeIndex) {\n    if (\n      !swiper.allowSlideNext &&\n      translate < swiper.translate &&\n      translate < swiper.minTranslate()\n    ) {\n      return false;\n    }\n    if (\n      !swiper.allowSlidePrev &&\n      translate > swiper.translate &&\n      translate > swiper.maxTranslate()\n    ) {\n      if ((activeIndex || 0) !== slideIndex) return false;\n    }\n  }\n\n  let direction;\n  if (slideIndex > activeIndex) direction = 'next';\n  else if (slideIndex < activeIndex) direction = 'prev';\n  else direction = 'reset';\n\n  // Update Index\n  if ((rtl && -translate === swiper.translate) || (!rtl && translate === swiper.translate)) {\n    swiper.updateActiveIndex(slideIndex);\n    // Update Height\n    if (params.autoHeight) {\n      swiper.updateAutoHeight();\n    }\n    swiper.updateSlidesClasses();\n    if (params.effect !== 'slide') {\n      swiper.setTranslate(translate);\n    }\n    if (direction !== 'reset') {\n      swiper.transitionStart(runCallbacks, direction);\n      swiper.transitionEnd(runCallbacks, direction);\n    }\n    return false;\n  }\n  if (params.cssMode) {\n    const isH = swiper.isHorizontal();\n    let t = -translate;\n    if (rtl) {\n      t = wrapperEl.scrollWidth - wrapperEl.offsetWidth - t;\n    }\n    if (speed === 0) {\n      wrapperEl[isH ? 'scrollLeft' : 'scrollTop'] = t;\n    } else {\n      // eslint-disable-next-line\n      if (wrapperEl.scrollTo) {\n        wrapperEl.scrollTo({\n          [isH ? 'left' : 'top']: t,\n          behavior: 'smooth',\n        });\n      } else {\n        wrapperEl[isH ? 'scrollLeft' : 'scrollTop'] = t;\n      }\n    }\n    return true;\n  }\n\n  if (speed === 0) {\n    swiper.setTransition(0);\n    swiper.setTranslate(translate);\n    swiper.updateActiveIndex(slideIndex);\n    swiper.updateSlidesClasses();\n    swiper.emit('beforeTransitionStart', speed, internal);\n    swiper.transitionStart(runCallbacks, direction);\n    swiper.transitionEnd(runCallbacks, direction);\n  } else {\n    swiper.setTransition(speed);\n    swiper.setTranslate(translate);\n    swiper.updateActiveIndex(slideIndex);\n    swiper.updateSlidesClasses();\n    swiper.emit('beforeTransitionStart', speed, internal);\n    swiper.transitionStart(runCallbacks, direction);\n    if (!swiper.animating) {\n      swiper.animating = true;\n      if (!swiper.onSlideToWrapperTransitionEnd) {\n        swiper.onSlideToWrapperTransitionEnd = function transitionEnd(e) {\n          if (!swiper || swiper.destroyed) return;\n          if (e.target !== this) return;\n          swiper.$wrapperEl[0].removeEventListener(\n            'transitionend',\n            swiper.onSlideToWrapperTransitionEnd,\n          );\n          swiper.$wrapperEl[0].removeEventListener(\n            'webkitTransitionEnd',\n            swiper.onSlideToWrapperTransitionEnd,\n          );\n          swiper.onSlideToWrapperTransitionEnd = null;\n          delete swiper.onSlideToWrapperTransitionEnd;\n          swiper.transitionEnd(runCallbacks, direction);\n        };\n      }\n      swiper.$wrapperEl[0].addEventListener('transitionend', swiper.onSlideToWrapperTransitionEnd);\n      swiper.$wrapperEl[0].addEventListener(\n        'webkitTransitionEnd',\n        swiper.onSlideToWrapperTransitionEnd,\n      );\n    }\n  }\n\n  return true;\n}\n","export default function slideToLoop(\n  index = 0,\n  speed = this.params.speed,\n  runCallbacks = true,\n  internal,\n) {\n  const swiper = this;\n  let newIndex = index;\n  if (swiper.params.loop) {\n    newIndex += swiper.loopedSlides;\n  }\n\n  return swiper.slideTo(newIndex, speed, runCallbacks, internal);\n}\n","/* eslint no-unused-vars: \"off\" */\nexport default function slideNext(speed = this.params.speed, runCallbacks = true, internal) {\n  const swiper = this;\n  const { params, animating } = swiper;\n  const increment = swiper.activeIndex < params.slidesPerGroupSkip ? 1 : params.slidesPerGroup;\n  if (params.loop) {\n    if (animating && params.loopPreventsSlide) return false;\n    swiper.loopFix();\n    // eslint-disable-next-line\n    swiper._clientLeft = swiper.$wrapperEl[0].clientLeft;\n  }\n  return swiper.slideTo(swiper.activeIndex + increment, speed, runCallbacks, internal);\n}\n","/* eslint no-unused-vars: \"off\" */\nexport default function slidePrev(speed = this.params.speed, runCallbacks = true, internal) {\n  const swiper = this;\n  const { params, animating, snapGrid, slidesGrid, rtlTranslate } = swiper;\n\n  if (params.loop) {\n    if (animating && params.loopPreventsSlide) return false;\n    swiper.loopFix();\n    // eslint-disable-next-line\n    swiper._clientLeft = swiper.$wrapperEl[0].clientLeft;\n  }\n  const translate = rtlTranslate ? swiper.translate : -swiper.translate;\n  function normalize(val) {\n    if (val < 0) return -Math.floor(Math.abs(val));\n    return Math.floor(val);\n  }\n  const normalizedTranslate = normalize(translate);\n  const normalizedSnapGrid = snapGrid.map((val) => normalize(val));\n\n  const currentSnap = snapGrid[normalizedSnapGrid.indexOf(normalizedTranslate)];\n  let prevSnap = snapGrid[normalizedSnapGrid.indexOf(normalizedTranslate) - 1];\n  if (typeof prevSnap === 'undefined' && params.cssMode) {\n    snapGrid.forEach((snap) => {\n      if (!prevSnap && normalizedTranslate >= snap) prevSnap = snap;\n    });\n  }\n  let prevIndex;\n  if (typeof prevSnap !== 'undefined') {\n    prevIndex = slidesGrid.indexOf(prevSnap);\n    if (prevIndex < 0) prevIndex = swiper.activeIndex - 1;\n  }\n  return swiper.slideTo(prevIndex, speed, runCallbacks, internal);\n}\n","/* eslint no-unused-vars: \"off\" */\nexport default function slideReset(speed = this.params.speed, runCallbacks = true, internal) {\n  const swiper = this;\n  return swiper.slideTo(swiper.activeIndex, speed, runCallbacks, internal);\n}\n","/* eslint no-unused-vars: \"off\" */\nexport default function slideToClosest(\n  speed = this.params.speed,\n  runCallbacks = true,\n  internal,\n  threshold = 0.5,\n) {\n  const swiper = this;\n  let index = swiper.activeIndex;\n  const skip = Math.min(swiper.params.slidesPerGroupSkip, index);\n  const snapIndex = skip + Math.floor((index - skip) / swiper.params.slidesPerGroup);\n\n  const translate = swiper.rtlTranslate ? swiper.translate : -swiper.translate;\n\n  if (translate >= swiper.snapGrid[snapIndex]) {\n    // The current translate is on or after the current snap index, so the choice\n    // is between the current index and the one after it.\n    const currentSnap = swiper.snapGrid[snapIndex];\n    const nextSnap = swiper.snapGrid[snapIndex + 1];\n    if (translate - currentSnap > (nextSnap - currentSnap) * threshold) {\n      index += swiper.params.slidesPerGroup;\n    }\n  } else {\n    // The current translate is before the current snap index, so the choice\n    // is between the current index and the one before it.\n    const prevSnap = swiper.snapGrid[snapIndex - 1];\n    const currentSnap = swiper.snapGrid[snapIndex];\n    if (translate - prevSnap <= (currentSnap - prevSnap) * threshold) {\n      index -= swiper.params.slidesPerGroup;\n    }\n  }\n  index = Math.max(index, 0);\n  index = Math.min(index, swiper.slidesGrid.length - 1);\n\n  return swiper.slideTo(index, speed, runCallbacks, internal);\n}\n","import $ from '../../../utils/dom';\nimport { nextTick } from '../../../utils/utils';\n\nexport default function slideToClickedSlide() {\n  const swiper = this;\n  const { params, $wrapperEl } = swiper;\n\n  const slidesPerView =\n    params.slidesPerView === 'auto' ? swiper.slidesPerViewDynamic() : params.slidesPerView;\n  let slideToIndex = swiper.clickedIndex;\n  let realIndex;\n  if (params.loop) {\n    if (swiper.animating) return;\n    realIndex = parseInt($(swiper.clickedSlide).attr('data-swiper-slide-index'), 10);\n    if (params.centeredSlides) {\n      if (\n        slideToIndex < swiper.loopedSlides - slidesPerView / 2 ||\n        slideToIndex > swiper.slides.length - swiper.loopedSlides + slidesPerView / 2\n      ) {\n        swiper.loopFix();\n        slideToIndex = $wrapperEl\n          .children(\n            `.${params.slideClass}[data-swiper-slide-index=\"${realIndex}\"]:not(.${params.slideDuplicateClass})`,\n          )\n          .eq(0)\n          .index();\n\n        nextTick(() => {\n          swiper.slideTo(slideToIndex);\n        });\n      } else {\n        swiper.slideTo(slideToIndex);\n      }\n    } else if (slideToIndex > swiper.slides.length - slidesPerView) {\n      swiper.loopFix();\n      slideToIndex = $wrapperEl\n        .children(\n          `.${params.slideClass}[data-swiper-slide-index=\"${realIndex}\"]:not(.${params.slideDuplicateClass})`,\n        )\n        .eq(0)\n        .index();\n\n      nextTick(() => {\n        swiper.slideTo(slideToIndex);\n      });\n    } else {\n      swiper.slideTo(slideToIndex);\n    }\n  } else {\n    swiper.slideTo(slideToIndex);\n  }\n}\n","import slideTo from './slideTo';\nimport slideToLoop from './slideToLoop';\nimport slideNext from './slideNext';\nimport slidePrev from './slidePrev';\nimport slideReset from './slideReset';\nimport slideToClosest from './slideToClosest';\nimport slideToClickedSlide from './slideToClickedSlide';\n\nexport default {\n  slideTo,\n  slideToLoop,\n  slideNext,\n  slidePrev,\n  slideReset,\n  slideToClosest,\n  slideToClickedSlide,\n};\n","import { getDocument } from 'ssr-window';\nimport $ from '../../../utils/dom';\n\nexport default function loopCreate() {\n  const swiper = this;\n  const document = getDocument();\n  const { params, $wrapperEl } = swiper;\n  // Remove duplicated slides\n  $wrapperEl.children(`.${params.slideClass}.${params.slideDuplicateClass}`).remove();\n\n  let slides = $wrapperEl.children(`.${params.slideClass}`);\n\n  if (params.loopFillGroupWithBlank) {\n    const blankSlidesNum = params.slidesPerGroup - (slides.length % params.slidesPerGroup);\n    if (blankSlidesNum !== params.slidesPerGroup) {\n      for (let i = 0; i < blankSlidesNum; i += 1) {\n        const blankNode = $(document.createElement('div')).addClass(\n          `${params.slideClass} ${params.slideBlankClass}`,\n        );\n        $wrapperEl.append(blankNode);\n      }\n      slides = $wrapperEl.children(`.${params.slideClass}`);\n    }\n  }\n\n  if (params.slidesPerView === 'auto' && !params.loopedSlides) params.loopedSlides = slides.length;\n\n  swiper.loopedSlides = Math.ceil(parseFloat(params.loopedSlides || params.slidesPerView, 10));\n  swiper.loopedSlides += params.loopAdditionalSlides;\n  if (swiper.loopedSlides > slides.length) {\n    swiper.loopedSlides = slides.length;\n  }\n\n  const prependSlides = [];\n  const appendSlides = [];\n  slides.each((el, index) => {\n    const slide = $(el);\n    if (index < swiper.loopedSlides) {\n      appendSlides.push(el);\n    }\n    if (index < slides.length && index >= slides.length - swiper.loopedSlides) {\n      prependSlides.push(el);\n    }\n    slide.attr('data-swiper-slide-index', index);\n  });\n  for (let i = 0; i < appendSlides.length; i += 1) {\n    $wrapperEl.append($(appendSlides[i].cloneNode(true)).addClass(params.slideDuplicateClass));\n  }\n  for (let i = prependSlides.length - 1; i >= 0; i -= 1) {\n    $wrapperEl.prepend($(prependSlides[i].cloneNode(true)).addClass(params.slideDuplicateClass));\n  }\n}\n","export default function loopFix() {\n  const swiper = this;\n\n  swiper.emit('beforeLoopFix');\n\n  const {\n    activeIndex,\n    slides,\n    loopedSlides,\n    allowSlidePrev,\n    allowSlideNext,\n    snapGrid,\n    rtlTranslate: rtl,\n  } = swiper;\n  let newIndex;\n  swiper.allowSlidePrev = true;\n  swiper.allowSlideNext = true;\n\n  const snapTranslate = -snapGrid[activeIndex];\n  const diff = snapTranslate - swiper.getTranslate();\n\n  // Fix For Negative Oversliding\n  if (activeIndex < loopedSlides) {\n    newIndex = slides.length - loopedSlides * 3 + activeIndex;\n    newIndex += loopedSlides;\n    const slideChanged = swiper.slideTo(newIndex, 0, false, true);\n    if (slideChanged && diff !== 0) {\n      swiper.setTranslate((rtl ? -swiper.translate : swiper.translate) - diff);\n    }\n  } else if (activeIndex >= slides.length - loopedSlides) {\n    // Fix For Positive Oversliding\n    newIndex = -slides.length + activeIndex + loopedSlides;\n    newIndex += loopedSlides;\n    const slideChanged = swiper.slideTo(newIndex, 0, false, true);\n    if (slideChanged && diff !== 0) {\n      swiper.setTranslate((rtl ? -swiper.translate : swiper.translate) - diff);\n    }\n  }\n  swiper.allowSlidePrev = allowSlidePrev;\n  swiper.allowSlideNext = allowSlideNext;\n\n  swiper.emit('loopFix');\n}\n","export default function loopDestroy() {\n  const swiper = this;\n  const { $wrapperEl, params, slides } = swiper;\n  $wrapperEl\n    .children(\n      `.${params.slideClass}.${params.slideDuplicateClass},.${params.slideClass}.${params.slideBlankClass}`,\n    )\n    .remove();\n  slides.removeAttr('data-swiper-slide-index');\n}\n","import loopCreate from './loopCreate';\nimport loopFix from './loopFix';\nimport loopDestroy from './loopDestroy';\n\nexport default {\n  loopCreate,\n  loopFix,\n  loopDestroy,\n};\n","export default function setGrabCursor(moving) {\n  const swiper = this;\n  if (\n    swiper.support.touch ||\n    !swiper.params.simulateTouch ||\n    (swiper.params.watchOverflow && swiper.isLocked) ||\n    swiper.params.cssMode\n  )\n    return;\n  const el = swiper.el;\n  el.style.cursor = 'move';\n  el.style.cursor = moving ? '-webkit-grabbing' : '-webkit-grab';\n  el.style.cursor = moving ? '-moz-grabbin' : '-moz-grab';\n  el.style.cursor = moving ? 'grabbing' : 'grab';\n}\n","export default function unsetGrabCursor() {\n  const swiper = this;\n  if (\n    swiper.support.touch ||\n    (swiper.params.watchOverflow && swiper.isLocked) ||\n    swiper.params.cssMode\n  ) {\n    return;\n  }\n  swiper.el.style.cursor = '';\n}\n","import setGrabCursor from './setGrabCursor';\nimport unsetGrabCursor from './unsetGrabCursor';\n\nexport default {\n  setGrabCursor,\n  unsetGrabCursor,\n};\n","export default function appendSlide(slides) {\n  const swiper = this;\n  const { $wrapperEl, params } = swiper;\n  if (params.loop) {\n    swiper.loopDestroy();\n  }\n  if (typeof slides === 'object' && 'length' in slides) {\n    for (let i = 0; i < slides.length; i += 1) {\n      if (slides[i]) $wrapperEl.append(slides[i]);\n    }\n  } else {\n    $wrapperEl.append(slides);\n  }\n  if (params.loop) {\n    swiper.loopCreate();\n  }\n  if (!(params.observer && swiper.support.observer)) {\n    swiper.update();\n  }\n}\n","export default function prependSlide(slides) {\n  const swiper = this;\n  const { params, $wrapperEl, activeIndex } = swiper;\n\n  if (params.loop) {\n    swiper.loopDestroy();\n  }\n  let newActiveIndex = activeIndex + 1;\n  if (typeof slides === 'object' && 'length' in slides) {\n    for (let i = 0; i < slides.length; i += 1) {\n      if (slides[i]) $wrapperEl.prepend(slides[i]);\n    }\n    newActiveIndex = activeIndex + slides.length;\n  } else {\n    $wrapperEl.prepend(slides);\n  }\n  if (params.loop) {\n    swiper.loopCreate();\n  }\n  if (!(params.observer && swiper.support.observer)) {\n    swiper.update();\n  }\n  swiper.slideTo(newActiveIndex, 0, false);\n}\n","export default function addSlide(index, slides) {\n  const swiper = this;\n  const { $wrapperEl, params, activeIndex } = swiper;\n  let activeIndexBuffer = activeIndex;\n  if (params.loop) {\n    activeIndexBuffer -= swiper.loopedSlides;\n    swiper.loopDestroy();\n    swiper.slides = $wrapperEl.children(`.${params.slideClass}`);\n  }\n  const baseLength = swiper.slides.length;\n  if (index <= 0) {\n    swiper.prependSlide(slides);\n    return;\n  }\n  if (index >= baseLength) {\n    swiper.appendSlide(slides);\n    return;\n  }\n  let newActiveIndex = activeIndexBuffer > index ? activeIndexBuffer + 1 : activeIndexBuffer;\n\n  const slidesBuffer = [];\n  for (let i = baseLength - 1; i >= index; i -= 1) {\n    const currentSlide = swiper.slides.eq(i);\n    currentSlide.remove();\n    slidesBuffer.unshift(currentSlide);\n  }\n\n  if (typeof slides === 'object' && 'length' in slides) {\n    for (let i = 0; i < slides.length; i += 1) {\n      if (slides[i]) $wrapperEl.append(slides[i]);\n    }\n    newActiveIndex =\n      activeIndexBuffer > index ? activeIndexBuffer + slides.length : activeIndexBuffer;\n  } else {\n    $wrapperEl.append(slides);\n  }\n\n  for (let i = 0; i < slidesBuffer.length; i += 1) {\n    $wrapperEl.append(slidesBuffer[i]);\n  }\n\n  if (params.loop) {\n    swiper.loopCreate();\n  }\n  if (!(params.observer && swiper.support.observer)) {\n    swiper.update();\n  }\n  if (params.loop) {\n    swiper.slideTo(newActiveIndex + swiper.loopedSlides, 0, false);\n  } else {\n    swiper.slideTo(newActiveIndex, 0, false);\n  }\n}\n","export default function removeSlide(slidesIndexes) {\n  const swiper = this;\n  const { params, $wrapperEl, activeIndex } = swiper;\n\n  let activeIndexBuffer = activeIndex;\n  if (params.loop) {\n    activeIndexBuffer -= swiper.loopedSlides;\n    swiper.loopDestroy();\n    swiper.slides = $wrapperEl.children(`.${params.slideClass}`);\n  }\n  let newActiveIndex = activeIndexBuffer;\n  let indexToRemove;\n\n  if (typeof slidesIndexes === 'object' && 'length' in slidesIndexes) {\n    for (let i = 0; i < slidesIndexes.length; i += 1) {\n      indexToRemove = slidesIndexes[i];\n      if (swiper.slides[indexToRemove]) swiper.slides.eq(indexToRemove).remove();\n      if (indexToRemove < newActiveIndex) newActiveIndex -= 1;\n    }\n    newActiveIndex = Math.max(newActiveIndex, 0);\n  } else {\n    indexToRemove = slidesIndexes;\n    if (swiper.slides[indexToRemove]) swiper.slides.eq(indexToRemove).remove();\n    if (indexToRemove < newActiveIndex) newActiveIndex -= 1;\n    newActiveIndex = Math.max(newActiveIndex, 0);\n  }\n\n  if (params.loop) {\n    swiper.loopCreate();\n  }\n\n  if (!(params.observer && swiper.support.observer)) {\n    swiper.update();\n  }\n  if (params.loop) {\n    swiper.slideTo(newActiveIndex + swiper.loopedSlides, 0, false);\n  } else {\n    swiper.slideTo(newActiveIndex, 0, false);\n  }\n}\n","export default function removeAllSlides() {\n  const swiper = this;\n\n  const slidesIndexes = [];\n  for (let i = 0; i < swiper.slides.length; i += 1) {\n    slidesIndexes.push(i);\n  }\n  swiper.removeSlide(slidesIndexes);\n}\n","import appendSlide from './appendSlide';\nimport prependSlide from './prependSlide';\nimport addSlide from './addSlide';\nimport removeSlide from './removeSlide';\nimport removeAllSlides from './removeAllSlides';\n\nexport default {\n  appendSlide,\n  prependSlide,\n  addSlide,\n  removeSlide,\n  removeAllSlides,\n};\n","import { getWindow, getDocument } from 'ssr-window';\nimport $ from '../../../utils/dom';\nimport { extend, now } from '../../../utils/utils';\n\nexport default function onTouchStart(event) {\n  const swiper = this;\n  const document = getDocument();\n  const window = getWindow();\n\n  const data = swiper.touchEventsData;\n  const { params, touches } = swiper;\n\n  if (swiper.animating && params.preventInteractionOnTransition) {\n    return;\n  }\n  let e = event;\n  if (e.originalEvent) e = e.originalEvent;\n  let $targetEl = $(e.target);\n\n  if (params.touchEventsTarget === 'wrapper') {\n    if (!$targetEl.closest(swiper.wrapperEl).length) return;\n  }\n  data.isTouchEvent = e.type === 'touchstart';\n  if (!data.isTouchEvent && 'which' in e && e.which === 3) return;\n  if (!data.isTouchEvent && 'button' in e && e.button > 0) return;\n  if (data.isTouched && data.isMoved) return;\n\n  // change target el for shadow root componenet\n  const swipingClassHasValue = !!params.noSwipingClass && params.noSwipingClass !== '';\n  if (swipingClassHasValue && e.target && e.target.shadowRoot && event.path && event.path[0]) {\n    $targetEl = $(event.path[0]);\n  }\n\n  if (\n    params.noSwiping &&\n    $targetEl.closest(\n      params.noSwipingSelector ? params.noSwipingSelector : `.${params.noSwipingClass}`,\n    )[0]\n  ) {\n    swiper.allowClick = true;\n    return;\n  }\n\n  if (params.swipeHandler) {\n    if (!$targetEl.closest(params.swipeHandler)[0]) return;\n  }\n\n  touches.currentX = e.type === 'touchstart' ? e.targetTouches[0].pageX : e.pageX;\n  touches.currentY = e.type === 'touchstart' ? e.targetTouches[0].pageY : e.pageY;\n  const startX = touches.currentX;\n  const startY = touches.currentY;\n\n  // Do NOT start if iOS edge swipe is detected. Otherwise iOS app cannot swipe-to-go-back anymore\n\n  const edgeSwipeDetection = params.edgeSwipeDetection || params.iOSEdgeSwipeDetection;\n  const edgeSwipeThreshold = params.edgeSwipeThreshold || params.iOSEdgeSwipeThreshold;\n  if (\n    edgeSwipeDetection &&\n    (startX <= edgeSwipeThreshold || startX >= window.innerWidth - edgeSwipeThreshold)\n  ) {\n    if (edgeSwipeDetection === 'prevent') {\n      event.preventDefault();\n    } else {\n      return;\n    }\n  }\n\n  extend(data, {\n    isTouched: true,\n    isMoved: false,\n    allowTouchCallbacks: true,\n    isScrolling: undefined,\n    startMoving: undefined,\n  });\n\n  touches.startX = startX;\n  touches.startY = startY;\n  data.touchStartTime = now();\n  swiper.allowClick = true;\n  swiper.updateSize();\n  swiper.swipeDirection = undefined;\n  if (params.threshold > 0) data.allowThresholdMove = false;\n  if (e.type !== 'touchstart') {\n    let preventDefault = true;\n    if ($targetEl.is(data.formElements)) preventDefault = false;\n    if (\n      document.activeElement &&\n      $(document.activeElement).is(data.formElements) &&\n      document.activeElement !== $targetEl[0]\n    ) {\n      document.activeElement.blur();\n    }\n\n    const shouldPreventDefault =\n      preventDefault && swiper.allowTouchMove && params.touchStartPreventDefault;\n    if (\n      (params.touchStartForcePreventDefault || shouldPreventDefault) &&\n      !$targetEl[0].isContentEditable\n    ) {\n      e.preventDefault();\n    }\n  }\n  swiper.emit('touchStart', e);\n}\n","import { getDocument } from 'ssr-window';\nimport $ from '../../../utils/dom';\nimport { extend, now } from '../../../utils/utils';\n\nexport default function onTouchMove(event) {\n  const document = getDocument();\n  const swiper = this;\n  const data = swiper.touchEventsData;\n  const { params, touches, rtlTranslate: rtl } = swiper;\n  let e = event;\n  if (e.originalEvent) e = e.originalEvent;\n  if (!data.isTouched) {\n    if (data.startMoving && data.isScrolling) {\n      swiper.emit('touchMoveOpposite', e);\n    }\n    return;\n  }\n  if (data.isTouchEvent && e.type !== 'touchmove') return;\n  const targetTouch =\n    e.type === 'touchmove' && e.targetTouches && (e.targetTouches[0] || e.changedTouches[0]);\n  const pageX = e.type === 'touchmove' ? targetTouch.pageX : e.pageX;\n  const pageY = e.type === 'touchmove' ? targetTouch.pageY : e.pageY;\n  if (e.preventedByNestedSwiper) {\n    touches.startX = pageX;\n    touches.startY = pageY;\n    return;\n  }\n  if (!swiper.allowTouchMove) {\n    // isMoved = true;\n    swiper.allowClick = false;\n    if (data.isTouched) {\n      extend(touches, {\n        startX: pageX,\n        startY: pageY,\n        currentX: pageX,\n        currentY: pageY,\n      });\n      data.touchStartTime = now();\n    }\n    return;\n  }\n  if (data.isTouchEvent && params.touchReleaseOnEdges && !params.loop) {\n    if (swiper.isVertical()) {\n      // Vertical\n      if (\n        (pageY < touches.startY && swiper.translate <= swiper.maxTranslate()) ||\n        (pageY > touches.startY && swiper.translate >= swiper.minTranslate())\n      ) {\n        data.isTouched = false;\n        data.isMoved = false;\n        return;\n      }\n    } else if (\n      (pageX < touches.startX && swiper.translate <= swiper.maxTranslate()) ||\n      (pageX > touches.startX && swiper.translate >= swiper.minTranslate())\n    ) {\n      return;\n    }\n  }\n  if (data.isTouchEvent && document.activeElement) {\n    if (e.target === document.activeElement && $(e.target).is(data.formElements)) {\n      data.isMoved = true;\n      swiper.allowClick = false;\n      return;\n    }\n  }\n  if (data.allowTouchCallbacks) {\n    swiper.emit('touchMove', e);\n  }\n  if (e.targetTouches && e.targetTouches.length > 1) return;\n\n  touches.currentX = pageX;\n  touches.currentY = pageY;\n\n  const diffX = touches.currentX - touches.startX;\n  const diffY = touches.currentY - touches.startY;\n  if (swiper.params.threshold && Math.sqrt(diffX ** 2 + diffY ** 2) < swiper.params.threshold)\n    return;\n\n  if (typeof data.isScrolling === 'undefined') {\n    let touchAngle;\n    if (\n      (swiper.isHorizontal() && touches.currentY === touches.startY) ||\n      (swiper.isVertical() && touches.currentX === touches.startX)\n    ) {\n      data.isScrolling = false;\n    } else {\n      // eslint-disable-next-line\n      if (diffX * diffX + diffY * diffY >= 25) {\n        touchAngle = (Math.atan2(Math.abs(diffY), Math.abs(diffX)) * 180) / Math.PI;\n        data.isScrolling = swiper.isHorizontal()\n          ? touchAngle > params.touchAngle\n          : 90 - touchAngle > params.touchAngle;\n      }\n    }\n  }\n  if (data.isScrolling) {\n    swiper.emit('touchMoveOpposite', e);\n  }\n  if (typeof data.startMoving === 'undefined') {\n    if (touches.currentX !== touches.startX || touches.currentY !== touches.startY) {\n      data.startMoving = true;\n    }\n  }\n  if (data.isScrolling) {\n    data.isTouched = false;\n    return;\n  }\n  if (!data.startMoving) {\n    return;\n  }\n  swiper.allowClick = false;\n  if (!params.cssMode && e.cancelable) {\n    e.preventDefault();\n  }\n  if (params.touchMoveStopPropagation && !params.nested) {\n    e.stopPropagation();\n  }\n\n  if (!data.isMoved) {\n    if (params.loop) {\n      swiper.loopFix();\n    }\n    data.startTranslate = swiper.getTranslate();\n    swiper.setTransition(0);\n    if (swiper.animating) {\n      swiper.$wrapperEl.trigger('webkitTransitionEnd transitionend');\n    }\n    data.allowMomentumBounce = false;\n    // Grab Cursor\n    if (params.grabCursor && (swiper.allowSlideNext === true || swiper.allowSlidePrev === true)) {\n      swiper.setGrabCursor(true);\n    }\n    swiper.emit('sliderFirstMove', e);\n  }\n  swiper.emit('sliderMove', e);\n  data.isMoved = true;\n\n  let diff = swiper.isHorizontal() ? diffX : diffY;\n  touches.diff = diff;\n\n  diff *= params.touchRatio;\n  if (rtl) diff = -diff;\n\n  swiper.swipeDirection = diff > 0 ? 'prev' : 'next';\n  data.currentTranslate = diff + data.startTranslate;\n\n  let disableParentSwiper = true;\n  let resistanceRatio = params.resistanceRatio;\n  if (params.touchReleaseOnEdges) {\n    resistanceRatio = 0;\n  }\n  if (diff > 0 && data.currentTranslate > swiper.minTranslate()) {\n    disableParentSwiper = false;\n    if (params.resistance)\n      data.currentTranslate =\n        swiper.minTranslate() -\n        1 +\n        (-swiper.minTranslate() + data.startTranslate + diff) ** resistanceRatio;\n  } else if (diff < 0 && data.currentTranslate < swiper.maxTranslate()) {\n    disableParentSwiper = false;\n    if (params.resistance)\n      data.currentTranslate =\n        swiper.maxTranslate() +\n        1 -\n        (swiper.maxTranslate() - data.startTranslate - diff) ** resistanceRatio;\n  }\n\n  if (disableParentSwiper) {\n    e.preventedByNestedSwiper = true;\n  }\n\n  // Directions locks\n  if (\n    !swiper.allowSlideNext &&\n    swiper.swipeDirection === 'next' &&\n    data.currentTranslate < data.startTranslate\n  ) {\n    data.currentTranslate = data.startTranslate;\n  }\n  if (\n    !swiper.allowSlidePrev &&\n    swiper.swipeDirection === 'prev' &&\n    data.currentTranslate > data.startTranslate\n  ) {\n    data.currentTranslate = data.startTranslate;\n  }\n  if (!swiper.allowSlidePrev && !swiper.allowSlideNext) {\n    data.currentTranslate = data.startTranslate;\n  }\n\n  // Threshold\n  if (params.threshold > 0) {\n    if (Math.abs(diff) > params.threshold || data.allowThresholdMove) {\n      if (!data.allowThresholdMove) {\n        data.allowThresholdMove = true;\n        touches.startX = touches.currentX;\n        touches.startY = touches.currentY;\n        data.currentTranslate = data.startTranslate;\n        touches.diff = swiper.isHorizontal()\n          ? touches.currentX - touches.startX\n          : touches.currentY - touches.startY;\n        return;\n      }\n    } else {\n      data.currentTranslate = data.startTranslate;\n      return;\n    }\n  }\n\n  if (!params.followFinger || params.cssMode) return;\n\n  // Update active index in free mode\n  if (params.freeMode || params.watchSlidesProgress || params.watchSlidesVisibility) {\n    swiper.updateActiveIndex();\n    swiper.updateSlidesClasses();\n  }\n  if (params.freeMode) {\n    // Velocity\n    if (data.velocities.length === 0) {\n      data.velocities.push({\n        position: touches[swiper.isHorizontal() ? 'startX' : 'startY'],\n        time: data.touchStartTime,\n      });\n    }\n    data.velocities.push({\n      position: touches[swiper.isHorizontal() ? 'currentX' : 'currentY'],\n      time: now(),\n    });\n  }\n  // Update progress\n  swiper.updateProgress(data.currentTranslate);\n  // Update translate\n  swiper.setTranslate(data.currentTranslate);\n}\n","import { now, nextTick } from '../../../utils/utils';\n\nexport default function onTouchEnd(event) {\n  const swiper = this;\n  const data = swiper.touchEventsData;\n\n  const { params, touches, rtlTranslate: rtl, $wrapperEl, slidesGrid, snapGrid } = swiper;\n  let e = event;\n  if (e.originalEvent) e = e.originalEvent;\n  if (data.allowTouchCallbacks) {\n    swiper.emit('touchEnd', e);\n  }\n  data.allowTouchCallbacks = false;\n  if (!data.isTouched) {\n    if (data.isMoved && params.grabCursor) {\n      swiper.setGrabCursor(false);\n    }\n    data.isMoved = false;\n    data.startMoving = false;\n    return;\n  }\n  // Return Grab Cursor\n  if (\n    params.grabCursor &&\n    data.isMoved &&\n    data.isTouched &&\n    (swiper.allowSlideNext === true || swiper.allowSlidePrev === true)\n  ) {\n    swiper.setGrabCursor(false);\n  }\n\n  // Time diff\n  const touchEndTime = now();\n  const timeDiff = touchEndTime - data.touchStartTime;\n\n  // Tap, doubleTap, Click\n  if (swiper.allowClick) {\n    swiper.updateClickedSlide(e);\n    swiper.emit('tap click', e);\n    if (timeDiff < 300 && touchEndTime - data.lastClickTime < 300) {\n      swiper.emit('doubleTap doubleClick', e);\n    }\n  }\n\n  data.lastClickTime = now();\n  nextTick(() => {\n    if (!swiper.destroyed) swiper.allowClick = true;\n  });\n\n  if (\n    !data.isTouched ||\n    !data.isMoved ||\n    !swiper.swipeDirection ||\n    touches.diff === 0 ||\n    data.currentTranslate === data.startTranslate\n  ) {\n    data.isTouched = false;\n    data.isMoved = false;\n    data.startMoving = false;\n    return;\n  }\n  data.isTouched = false;\n  data.isMoved = false;\n  data.startMoving = false;\n\n  let currentPos;\n  if (params.followFinger) {\n    currentPos = rtl ? swiper.translate : -swiper.translate;\n  } else {\n    currentPos = -data.currentTranslate;\n  }\n\n  if (params.cssMode) {\n    return;\n  }\n\n  if (params.freeMode) {\n    if (currentPos < -swiper.minTranslate()) {\n      swiper.slideTo(swiper.activeIndex);\n      return;\n    }\n    if (currentPos > -swiper.maxTranslate()) {\n      if (swiper.slides.length < snapGrid.length) {\n        swiper.slideTo(snapGrid.length - 1);\n      } else {\n        swiper.slideTo(swiper.slides.length - 1);\n      }\n      return;\n    }\n\n    if (params.freeModeMomentum) {\n      if (data.velocities.length > 1) {\n        const lastMoveEvent = data.velocities.pop();\n        const velocityEvent = data.velocities.pop();\n\n        const distance = lastMoveEvent.position - velocityEvent.position;\n        const time = lastMoveEvent.time - velocityEvent.time;\n        swiper.velocity = distance / time;\n        swiper.velocity /= 2;\n        if (Math.abs(swiper.velocity) < params.freeModeMinimumVelocity) {\n          swiper.velocity = 0;\n        }\n        // this implies that the user stopped moving a finger then released.\n        // There would be no events with distance zero, so the last event is stale.\n        if (time > 150 || now() - lastMoveEvent.time > 300) {\n          swiper.velocity = 0;\n        }\n      } else {\n        swiper.velocity = 0;\n      }\n      swiper.velocity *= params.freeModeMomentumVelocityRatio;\n\n      data.velocities.length = 0;\n      let momentumDuration = 1000 * params.freeModeMomentumRatio;\n      const momentumDistance = swiper.velocity * momentumDuration;\n\n      let newPosition = swiper.translate + momentumDistance;\n      if (rtl) newPosition = -newPosition;\n\n      let doBounce = false;\n      let afterBouncePosition;\n      const bounceAmount = Math.abs(swiper.velocity) * 20 * params.freeModeMomentumBounceRatio;\n      let needsLoopFix;\n      if (newPosition < swiper.maxTranslate()) {\n        if (params.freeModeMomentumBounce) {\n          if (newPosition + swiper.maxTranslate() < -bounceAmount) {\n            newPosition = swiper.maxTranslate() - bounceAmount;\n          }\n          afterBouncePosition = swiper.maxTranslate();\n          doBounce = true;\n          data.allowMomentumBounce = true;\n        } else {\n          newPosition = swiper.maxTranslate();\n        }\n        if (params.loop && params.centeredSlides) needsLoopFix = true;\n      } else if (newPosition > swiper.minTranslate()) {\n        if (params.freeModeMomentumBounce) {\n          if (newPosition - swiper.minTranslate() > bounceAmount) {\n            newPosition = swiper.minTranslate() + bounceAmount;\n          }\n          afterBouncePosition = swiper.minTranslate();\n          doBounce = true;\n          data.allowMomentumBounce = true;\n        } else {\n          newPosition = swiper.minTranslate();\n        }\n        if (params.loop && params.centeredSlides) needsLoopFix = true;\n      } else if (params.freeModeSticky) {\n        let nextSlide;\n        for (let j = 0; j < snapGrid.length; j += 1) {\n          if (snapGrid[j] > -newPosition) {\n            nextSlide = j;\n            break;\n          }\n        }\n\n        if (\n          Math.abs(snapGrid[nextSlide] - newPosition) <\n            Math.abs(snapGrid[nextSlide - 1] - newPosition) ||\n          swiper.swipeDirection === 'next'\n        ) {\n          newPosition = snapGrid[nextSlide];\n        } else {\n          newPosition = snapGrid[nextSlide - 1];\n        }\n        newPosition = -newPosition;\n      }\n      if (needsLoopFix) {\n        swiper.once('transitionEnd', () => {\n          swiper.loopFix();\n        });\n      }\n      // Fix duration\n      if (swiper.velocity !== 0) {\n        if (rtl) {\n          momentumDuration = Math.abs((-newPosition - swiper.translate) / swiper.velocity);\n        } else {\n          momentumDuration = Math.abs((newPosition - swiper.translate) / swiper.velocity);\n        }\n        if (params.freeModeSticky) {\n          // If freeModeSticky is active and the user ends a swipe with a slow-velocity\n          // event, then durations can be 20+ seconds to slide one (or zero!) slides.\n          // It's easy to see this when simulating touch with mouse events. To fix this,\n          // limit single-slide swipes to the default slide duration. This also has the\n          // nice side effect of matching slide speed if the user stopped moving before\n          // lifting finger or mouse vs. moving slowly before lifting the finger/mouse.\n          // For faster swipes, also apply limits (albeit higher ones).\n          const moveDistance = Math.abs((rtl ? -newPosition : newPosition) - swiper.translate);\n          const currentSlideSize = swiper.slidesSizesGrid[swiper.activeIndex];\n          if (moveDistance < currentSlideSize) {\n            momentumDuration = params.speed;\n          } else if (moveDistance < 2 * currentSlideSize) {\n            momentumDuration = params.speed * 1.5;\n          } else {\n            momentumDuration = params.speed * 2.5;\n          }\n        }\n      } else if (params.freeModeSticky) {\n        swiper.slideToClosest();\n        return;\n      }\n\n      if (params.freeModeMomentumBounce && doBounce) {\n        swiper.updateProgress(afterBouncePosition);\n        swiper.setTransition(momentumDuration);\n        swiper.setTranslate(newPosition);\n        swiper.transitionStart(true, swiper.swipeDirection);\n        swiper.animating = true;\n        $wrapperEl.transitionEnd(() => {\n          if (!swiper || swiper.destroyed || !data.allowMomentumBounce) return;\n          swiper.emit('momentumBounce');\n          swiper.setTransition(params.speed);\n          setTimeout(() => {\n            swiper.setTranslate(afterBouncePosition);\n            $wrapperEl.transitionEnd(() => {\n              if (!swiper || swiper.destroyed) return;\n              swiper.transitionEnd();\n            });\n          }, 0);\n        });\n      } else if (swiper.velocity) {\n        swiper.updateProgress(newPosition);\n        swiper.setTransition(momentumDuration);\n        swiper.setTranslate(newPosition);\n        swiper.transitionStart(true, swiper.swipeDirection);\n        if (!swiper.animating) {\n          swiper.animating = true;\n          $wrapperEl.transitionEnd(() => {\n            if (!swiper || swiper.destroyed) return;\n            swiper.transitionEnd();\n          });\n        }\n      } else {\n        swiper.emit('_freeModeNoMomentumRelease');\n        swiper.updateProgress(newPosition);\n      }\n\n      swiper.updateActiveIndex();\n      swiper.updateSlidesClasses();\n    } else if (params.freeModeSticky) {\n      swiper.slideToClosest();\n      return;\n    } else if (params.freeMode) {\n      swiper.emit('_freeModeNoMomentumRelease');\n    }\n\n    if (!params.freeModeMomentum || timeDiff >= params.longSwipesMs) {\n      swiper.updateProgress();\n      swiper.updateActiveIndex();\n      swiper.updateSlidesClasses();\n    }\n    return;\n  }\n\n  // Find current slide\n  let stopIndex = 0;\n  let groupSize = swiper.slidesSizesGrid[0];\n  for (\n    let i = 0;\n    i < slidesGrid.length;\n    i += i < params.slidesPerGroupSkip ? 1 : params.slidesPerGroup\n  ) {\n    const increment = i < params.slidesPerGroupSkip - 1 ? 1 : params.slidesPerGroup;\n    if (typeof slidesGrid[i + increment] !== 'undefined') {\n      if (currentPos >= slidesGrid[i] && currentPos < slidesGrid[i + increment]) {\n        stopIndex = i;\n        groupSize = slidesGrid[i + increment] - slidesGrid[i];\n      }\n    } else if (currentPos >= slidesGrid[i]) {\n      stopIndex = i;\n      groupSize = slidesGrid[slidesGrid.length - 1] - slidesGrid[slidesGrid.length - 2];\n    }\n  }\n\n  // Find current slide size\n  const ratio = (currentPos - slidesGrid[stopIndex]) / groupSize;\n  const increment = stopIndex < params.slidesPerGroupSkip - 1 ? 1 : params.slidesPerGroup;\n\n  if (timeDiff > params.longSwipesMs) {\n    // Long touches\n    if (!params.longSwipes) {\n      swiper.slideTo(swiper.activeIndex);\n      return;\n    }\n    if (swiper.swipeDirection === 'next') {\n      if (ratio >= params.longSwipesRatio) swiper.slideTo(stopIndex + increment);\n      else swiper.slideTo(stopIndex);\n    }\n    if (swiper.swipeDirection === 'prev') {\n      if (ratio > 1 - params.longSwipesRatio) swiper.slideTo(stopIndex + increment);\n      else swiper.slideTo(stopIndex);\n    }\n  } else {\n    // Short swipes\n    if (!params.shortSwipes) {\n      swiper.slideTo(swiper.activeIndex);\n      return;\n    }\n    const isNavButtonTarget =\n      swiper.navigation &&\n      (e.target === swiper.navigation.nextEl || e.target === swiper.navigation.prevEl);\n    if (!isNavButtonTarget) {\n      if (swiper.swipeDirection === 'next') {\n        swiper.slideTo(stopIndex + increment);\n      }\n      if (swiper.swipeDirection === 'prev') {\n        swiper.slideTo(stopIndex);\n      }\n    } else if (e.target === swiper.navigation.nextEl) {\n      swiper.slideTo(stopIndex + increment);\n    } else {\n      swiper.slideTo(stopIndex);\n    }\n  }\n}\n","export default function onResize() {\n  const swiper = this;\n\n  const { params, el } = swiper;\n\n  if (el && el.offsetWidth === 0) return;\n\n  // Breakpoints\n  if (params.breakpoints) {\n    swiper.setBreakpoint();\n  }\n\n  // Save locks\n  const { allowSlideNext, allowSlidePrev, snapGrid } = swiper;\n\n  // Disable locks on resize\n  swiper.allowSlideNext = true;\n  swiper.allowSlidePrev = true;\n\n  swiper.updateSize();\n  swiper.updateSlides();\n\n  swiper.updateSlidesClasses();\n  if (\n    (params.slidesPerView === 'auto' || params.slidesPerView > 1) &&\n    swiper.isEnd &&\n    !swiper.isBeginning &&\n    !swiper.params.centeredSlides\n  ) {\n    swiper.slideTo(swiper.slides.length - 1, 0, false, true);\n  } else {\n    swiper.slideTo(swiper.activeIndex, 0, false, true);\n  }\n\n  if (swiper.autoplay && swiper.autoplay.running && swiper.autoplay.paused) {\n    swiper.autoplay.run();\n  }\n  // Return locks after resize\n  swiper.allowSlidePrev = allowSlidePrev;\n  swiper.allowSlideNext = allowSlideNext;\n\n  if (swiper.params.watchOverflow && snapGrid !== swiper.snapGrid) {\n    swiper.checkOverflow();\n  }\n}\n","export default function onClick(e) {\n  const swiper = this;\n  if (!swiper.allowClick) {\n    if (swiper.params.preventClicks) e.preventDefault();\n    if (swiper.params.preventClicksPropagation && swiper.animating) {\n      e.stopPropagation();\n      e.stopImmediatePropagation();\n    }\n  }\n}\n","export default function onScroll() {\n  const swiper = this;\n  const { wrapperEl, rtlTranslate } = swiper;\n  swiper.previousTranslate = swiper.translate;\n  if (swiper.isHorizontal()) {\n    if (rtlTranslate) {\n      swiper.translate = wrapperEl.scrollWidth - wrapperEl.offsetWidth - wrapperEl.scrollLeft;\n    } else {\n      swiper.translate = -wrapperEl.scrollLeft;\n    }\n  } else {\n    swiper.translate = -wrapperEl.scrollTop;\n  }\n  // eslint-disable-next-line\n  if (swiper.translate === -0) swiper.translate = 0;\n\n  swiper.updateActiveIndex();\n  swiper.updateSlidesClasses();\n\n  let newProgress;\n  const translatesDiff = swiper.maxTranslate() - swiper.minTranslate();\n  if (translatesDiff === 0) {\n    newProgress = 0;\n  } else {\n    newProgress = (swiper.translate - swiper.minTranslate()) / translatesDiff;\n  }\n  if (newProgress !== swiper.progress) {\n    swiper.updateProgress(rtlTranslate ? -swiper.translate : swiper.translate);\n  }\n\n  swiper.emit('setTranslate', swiper.translate, false);\n}\n","import { getDocument } from 'ssr-window';\n\nimport onTouchStart from './onTouchStart';\nimport onTouchMove from './onTouchMove';\nimport onTouchEnd from './onTouchEnd';\nimport onResize from './onResize';\nimport onClick from './onClick';\nimport onScroll from './onScroll';\n\nlet dummyEventAttached = false;\nfunction dummyEventListener() {}\n\nfunction attachEvents() {\n  const swiper = this;\n  const document = getDocument();\n  const { params, touchEvents, el, wrapperEl, device, support } = swiper;\n\n  swiper.onTouchStart = onTouchStart.bind(swiper);\n  swiper.onTouchMove = onTouchMove.bind(swiper);\n  swiper.onTouchEnd = onTouchEnd.bind(swiper);\n  if (params.cssMode) {\n    swiper.onScroll = onScroll.bind(swiper);\n  }\n\n  swiper.onClick = onClick.bind(swiper);\n\n  const capture = !!params.nested;\n\n  // Touch Events\n  if (!support.touch && support.pointerEvents) {\n    el.addEventListener(touchEvents.start, swiper.onTouchStart, false);\n    document.addEventListener(touchEvents.move, swiper.onTouchMove, capture);\n    document.addEventListener(touchEvents.end, swiper.onTouchEnd, false);\n  } else {\n    if (support.touch) {\n      const passiveListener =\n        touchEvents.start === 'touchstart' && support.passiveListener && params.passiveListeners\n          ? { passive: true, capture: false }\n          : false;\n      el.addEventListener(touchEvents.start, swiper.onTouchStart, passiveListener);\n      el.addEventListener(\n        touchEvents.move,\n        swiper.onTouchMove,\n        support.passiveListener ? { passive: false, capture } : capture,\n      );\n      el.addEventListener(touchEvents.end, swiper.onTouchEnd, passiveListener);\n      if (touchEvents.cancel) {\n        el.addEventListener(touchEvents.cancel, swiper.onTouchEnd, passiveListener);\n      }\n      if (!dummyEventAttached) {\n        document.addEventListener('touchstart', dummyEventListener);\n        dummyEventAttached = true;\n      }\n    }\n    if (\n      (params.simulateTouch && !device.ios && !device.android) ||\n      (params.simulateTouch && !support.touch && device.ios)\n    ) {\n      el.addEventListener('mousedown', swiper.onTouchStart, false);\n      document.addEventListener('mousemove', swiper.onTouchMove, capture);\n      document.addEventListener('mouseup', swiper.onTouchEnd, false);\n    }\n  }\n  // Prevent Links Clicks\n  if (params.preventClicks || params.preventClicksPropagation) {\n    el.addEventListener('click', swiper.onClick, true);\n  }\n  if (params.cssMode) {\n    wrapperEl.addEventListener('scroll', swiper.onScroll);\n  }\n\n  // Resize handler\n  if (params.updateOnWindowResize) {\n    swiper.on(\n      device.ios || device.android\n        ? 'resize orientationchange observerUpdate'\n        : 'resize observerUpdate',\n      onResize,\n      true,\n    );\n  } else {\n    swiper.on('observerUpdate', onResize, true);\n  }\n}\n\nfunction detachEvents() {\n  const swiper = this;\n  const document = getDocument();\n\n  const { params, touchEvents, el, wrapperEl, device, support } = swiper;\n\n  const capture = !!params.nested;\n\n  // Touch Events\n  if (!support.touch && support.pointerEvents) {\n    el.removeEventListener(touchEvents.start, swiper.onTouchStart, false);\n    document.removeEventListener(touchEvents.move, swiper.onTouchMove, capture);\n    document.removeEventListener(touchEvents.end, swiper.onTouchEnd, false);\n  } else {\n    if (support.touch) {\n      const passiveListener =\n        touchEvents.start === 'onTouchStart' && support.passiveListener && params.passiveListeners\n          ? { passive: true, capture: false }\n          : false;\n      el.removeEventListener(touchEvents.start, swiper.onTouchStart, passiveListener);\n      el.removeEventListener(touchEvents.move, swiper.onTouchMove, capture);\n      el.removeEventListener(touchEvents.end, swiper.onTouchEnd, passiveListener);\n      if (touchEvents.cancel) {\n        el.removeEventListener(touchEvents.cancel, swiper.onTouchEnd, passiveListener);\n      }\n    }\n    if (\n      (params.simulateTouch && !device.ios && !device.android) ||\n      (params.simulateTouch && !support.touch && device.ios)\n    ) {\n      el.removeEventListener('mousedown', swiper.onTouchStart, false);\n      document.removeEventListener('mousemove', swiper.onTouchMove, capture);\n      document.removeEventListener('mouseup', swiper.onTouchEnd, false);\n    }\n  }\n  // Prevent Links Clicks\n  if (params.preventClicks || params.preventClicksPropagation) {\n    el.removeEventListener('click', swiper.onClick, true);\n  }\n\n  if (params.cssMode) {\n    wrapperEl.removeEventListener('scroll', swiper.onScroll);\n  }\n\n  // Resize handler\n  swiper.off(\n    device.ios || device.android\n      ? 'resize orientationchange observerUpdate'\n      : 'resize observerUpdate',\n    onResize,\n  );\n}\n\nexport default {\n  attachEvents,\n  detachEvents,\n};\n","import { extend } from '../../../utils/utils';\n\nexport default function setBreakpoint() {\n  const swiper = this;\n  const { activeIndex, initialized, loopedSlides = 0, params, $el } = swiper;\n  const breakpoints = params.breakpoints;\n  if (!breakpoints || (breakpoints && Object.keys(breakpoints).length === 0)) return;\n\n  // Get breakpoint for window width and update parameters\n  const breakpoint = swiper.getBreakpoint(breakpoints, swiper.params.breakpointsBase, swiper.el);\n\n  if (breakpoint && swiper.currentBreakpoint !== breakpoint) {\n    const breakpointOnlyParams = breakpoint in breakpoints ? breakpoints[breakpoint] : undefined;\n    if (breakpointOnlyParams) {\n      [\n        'slidesPerView',\n        'spaceBetween',\n        'slidesPerGroup',\n        'slidesPerGroupSkip',\n        'slidesPerColumn',\n      ].forEach((param) => {\n        const paramValue = breakpointOnlyParams[param];\n        if (typeof paramValue === 'undefined') return;\n        if (param === 'slidesPerView' && (paramValue === 'AUTO' || paramValue === 'auto')) {\n          breakpointOnlyParams[param] = 'auto';\n        } else if (param === 'slidesPerView') {\n          breakpointOnlyParams[param] = parseFloat(paramValue);\n        } else {\n          breakpointOnlyParams[param] = parseInt(paramValue, 10);\n        }\n      });\n    }\n\n    const breakpointParams = breakpointOnlyParams || swiper.originalParams;\n    const wasMultiRow = params.slidesPerColumn > 1;\n    const isMultiRow = breakpointParams.slidesPerColumn > 1;\n    if (wasMultiRow && !isMultiRow) {\n      $el.removeClass(\n        `${params.containerModifierClass}multirow ${params.containerModifierClass}multirow-column`,\n      );\n      swiper.emitContainerClasses();\n    } else if (!wasMultiRow && isMultiRow) {\n      $el.addClass(`${params.containerModifierClass}multirow`);\n      if (breakpointParams.slidesPerColumnFill === 'column') {\n        $el.addClass(`${params.containerModifierClass}multirow-column`);\n      }\n      swiper.emitContainerClasses();\n    }\n\n    const directionChanged =\n      breakpointParams.direction && breakpointParams.direction !== params.direction;\n    const needsReLoop =\n      params.loop && (breakpointParams.slidesPerView !== params.slidesPerView || directionChanged);\n\n    if (directionChanged && initialized) {\n      swiper.changeDirection();\n    }\n\n    extend(swiper.params, breakpointParams);\n\n    extend(swiper, {\n      allowTouchMove: swiper.params.allowTouchMove,\n      allowSlideNext: swiper.params.allowSlideNext,\n      allowSlidePrev: swiper.params.allowSlidePrev,\n    });\n\n    swiper.currentBreakpoint = breakpoint;\n\n    swiper.emit('_beforeBreakpoint', breakpointParams);\n\n    if (needsReLoop && initialized) {\n      swiper.loopDestroy();\n      swiper.loopCreate();\n      swiper.updateSlides();\n      swiper.slideTo(activeIndex - loopedSlides + swiper.loopedSlides, 0, false);\n    }\n\n    swiper.emit('breakpoint', breakpointParams);\n  }\n}\n","import { getWindow } from 'ssr-window';\n\nexport default function getBreakpoint(breakpoints, base = 'window', containerEl) {\n  if (!breakpoints || (base === 'container' && !containerEl)) return undefined;\n  let breakpoint = false;\n\n  const window = getWindow();\n  const currentWidth = base === 'window' ? window.innerWidth : containerEl.clientWidth;\n  const currentHeight = base === 'window' ? window.innerHeight : containerEl.clientHeight;\n\n  const points = Object.keys(breakpoints).map((point) => {\n    if (typeof point === 'string' && point.indexOf('@') === 0) {\n      const minRatio = parseFloat(point.substr(1));\n      const value = currentHeight * minRatio;\n      return { value, point };\n    }\n    return { value: point, point };\n  });\n\n  points.sort((a, b) => parseInt(a.value, 10) - parseInt(b.value, 10));\n  for (let i = 0; i < points.length; i += 1) {\n    const { point, value } = points[i];\n    if (value <= currentWidth) {\n      breakpoint = point;\n    }\n  }\n  return breakpoint || 'max';\n}\n","import setBreakpoint from './setBreakpoint';\nimport getBreakpoint from './getBreakpoint';\n\nexport default { setBreakpoint, getBreakpoint };\n","function prepareClasses(entries, prefix) {\n  const resultClasses = [];\n  entries.forEach((item) => {\n    if (typeof item === 'object') {\n      Object.keys(item).forEach((classNames) => {\n        if (item[classNames]) {\n          resultClasses.push(prefix + classNames);\n        }\n      });\n    } else if (typeof item === 'string') {\n      resultClasses.push(prefix + item);\n    }\n  });\n  return resultClasses;\n}\n\nexport default function addClasses() {\n  const swiper = this;\n  const { classNames, params, rtl, $el, device, support } = swiper;\n  // prettier-ignore\n  const suffixes = prepareClasses([\n    'initialized',\n    params.direction,\n    { 'pointer-events': support.pointerEvents && !support.touch },\n    { 'free-mode': params.freeMode },\n    { 'autoheight': params.autoHeight },\n    { 'rtl': rtl },\n    { 'multirow': params.slidesPerColumn > 1 },\n    { 'multirow-column': params.slidesPerColumn > 1 && params.slidesPerColumnFill === 'column' },\n    { 'android': device.android },\n    { 'ios': device.ios },\n    { 'css-mode': params.cssMode },\n  ], params.containerModifierClass);\n  classNames.push(...suffixes);\n  $el.addClass([...classNames].join(' '));\n  swiper.emitContainerClasses();\n}\n","export default function removeClasses() {\n  const swiper = this;\n  const { $el, classNames } = swiper;\n\n  $el.removeClass(classNames.join(' '));\n  swiper.emitContainerClasses();\n}\n","import addClasses from './addClasses';\nimport removeClasses from './removeClasses';\n\nexport default { addClasses, removeClasses };\n","import { getWindow } from 'ssr-window';\nimport $ from '../../../utils/dom';\n\nexport default function loadImage(imageEl, src, srcset, sizes, checkForComplete, callback) {\n  const window = getWindow();\n  let image;\n  function onReady() {\n    if (callback) callback();\n  }\n  const isPicture = $(imageEl).parent('picture')[0];\n\n  if (!isPicture && (!imageEl.complete || !checkForComplete)) {\n    if (src) {\n      image = new window.Image();\n      image.onload = onReady;\n      image.onerror = onReady;\n      if (sizes) {\n        image.sizes = sizes;\n      }\n      if (srcset) {\n        image.srcset = srcset;\n      }\n      if (src) {\n        image.src = src;\n      }\n    } else {\n      onReady();\n    }\n  } else {\n    // image already loaded...\n    onReady();\n  }\n}\n","export default function preloadImages() {\n  const swiper = this;\n  swiper.imagesToLoad = swiper.$el.find('img');\n  function onReady() {\n    if (typeof swiper === 'undefined' || swiper === null || !swiper || swiper.destroyed) return;\n    if (swiper.imagesLoaded !== undefined) swiper.imagesLoaded += 1;\n    if (swiper.imagesLoaded === swiper.imagesToLoad.length) {\n      if (swiper.params.updateOnImagesReady) swiper.update();\n      swiper.emit('imagesReady');\n    }\n  }\n  for (let i = 0; i < swiper.imagesToLoad.length; i += 1) {\n    const imageEl = swiper.imagesToLoad[i];\n    swiper.loadImage(\n      imageEl,\n      imageEl.currentSrc || imageEl.getAttribute('src'),\n      imageEl.srcset || imageEl.getAttribute('srcset'),\n      imageEl.sizes || imageEl.getAttribute('sizes'),\n      true,\n      onReady,\n    );\n  }\n}\n","import loadImage from './loadImage';\nimport preloadImages from './preloadImages';\n\nexport default {\n  loadImage,\n  preloadImages,\n};\n","function checkOverflow() {\n  const swiper = this;\n  const params = swiper.params;\n  const wasLocked = swiper.isLocked;\n  const lastSlidePosition =\n    swiper.slides.length > 0 &&\n    params.slidesOffsetBefore +\n      params.spaceBetween * (swiper.slides.length - 1) +\n      swiper.slides[0].offsetWidth * swiper.slides.length;\n\n  if (params.slidesOffsetBefore && params.slidesOffsetAfter && lastSlidePosition) {\n    swiper.isLocked = lastSlidePosition <= swiper.size;\n  } else {\n    swiper.isLocked = swiper.snapGrid.length === 1;\n  }\n\n  swiper.allowSlideNext = !swiper.isLocked;\n  swiper.allowSlidePrev = !swiper.isLocked;\n\n  // events\n  if (wasLocked !== swiper.isLocked) swiper.emit(swiper.isLocked ? 'lock' : 'unlock');\n\n  if (wasLocked && wasLocked !== swiper.isLocked) {\n    swiper.isEnd = false;\n    if (swiper.navigation) swiper.navigation.update();\n  }\n}\n\nexport default { checkOverflow };\n","export default {\n  init: true,\n  direction: 'horizontal',\n  touchEventsTarget: 'container',\n  initialSlide: 0,\n  speed: 300,\n  cssMode: false,\n  updateOnWindowResize: true,\n  resizeObserver: false,\n  nested: false,\n\n  // Overrides\n  width: null,\n  height: null,\n\n  //\n  preventInteractionOnTransition: false,\n\n  // ssr\n  userAgent: null,\n  url: null,\n\n  // To support iOS's swipe-to-go-back gesture (when being used in-app).\n  edgeSwipeDetection: false,\n  edgeSwipeThreshold: 20,\n\n  // Free mode\n  freeMode: false,\n  freeModeMomentum: true,\n  freeModeMomentumRatio: 1,\n  freeModeMomentumBounce: true,\n  freeModeMomentumBounceRatio: 1,\n  freeModeMomentumVelocityRatio: 1,\n  freeModeSticky: false,\n  freeModeMinimumVelocity: 0.02,\n\n  // Autoheight\n  autoHeight: false,\n\n  // Set wrapper width\n  setWrapperSize: false,\n\n  // Virtual Translate\n  virtualTranslate: false,\n\n  // Effects\n  effect: 'slide', // 'slide' or 'fade' or 'cube' or 'coverflow' or 'flip'\n\n  // Breakpoints\n  breakpoints: undefined,\n  breakpointsBase: 'window',\n\n  // Slides grid\n  spaceBetween: 0,\n  slidesPerView: 1,\n  slidesPerColumn: 1,\n  slidesPerColumnFill: 'column',\n  slidesPerGroup: 1,\n  slidesPerGroupSkip: 0,\n  centeredSlides: false,\n  centeredSlidesBounds: false,\n  slidesOffsetBefore: 0, // in px\n  slidesOffsetAfter: 0, // in px\n  normalizeSlideIndex: true,\n  centerInsufficientSlides: false,\n\n  // Disable swiper and hide navigation when container not overflow\n  watchOverflow: false,\n\n  // Round length\n  roundLengths: false,\n\n  // Touches\n  touchRatio: 1,\n  touchAngle: 45,\n  simulateTouch: true,\n  shortSwipes: true,\n  longSwipes: true,\n  longSwipesRatio: 0.5,\n  longSwipesMs: 300,\n  followFinger: true,\n  allowTouchMove: true,\n  threshold: 0,\n  touchMoveStopPropagation: false,\n  touchStartPreventDefault: true,\n  touchStartForcePreventDefault: false,\n  touchReleaseOnEdges: false,\n\n  // Unique Navigation Elements\n  uniqueNavElements: true,\n\n  // Resistance\n  resistance: true,\n  resistanceRatio: 0.85,\n\n  // Progress\n  watchSlidesProgress: false,\n  watchSlidesVisibility: false,\n\n  // Cursor\n  grabCursor: false,\n\n  // Clicks\n  preventClicks: true,\n  preventClicksPropagation: true,\n  slideToClickedSlide: false,\n\n  // Images\n  preloadImages: true,\n  updateOnImagesReady: true,\n\n  // loop\n  loop: false,\n  loopAdditionalSlides: 0,\n  loopedSlides: null,\n  loopFillGroupWithBlank: false,\n  loopPreventsSlide: true,\n\n  // Swiping/no swiping\n  allowSlidePrev: true,\n  allowSlideNext: true,\n  swipeHandler: null, // '.swipe-handler',\n  noSwiping: true,\n  noSwipingClass: 'swiper-no-swiping',\n  noSwipingSelector: null,\n\n  // Passive Listeners\n  passiveListeners: true,\n\n  // NS\n  containerModifierClass: 'swiper-container-', // NEW\n  slideClass: 'swiper-slide',\n  slideBlankClass: 'swiper-slide-invisible-blank',\n  slideActiveClass: 'swiper-slide-active',\n  slideDuplicateActiveClass: 'swiper-slide-duplicate-active',\n  slideVisibleClass: 'swiper-slide-visible',\n  slideDuplicateClass: 'swiper-slide-duplicate',\n  slideNextClass: 'swiper-slide-next',\n  slideDuplicateNextClass: 'swiper-slide-duplicate-next',\n  slidePrevClass: 'swiper-slide-prev',\n  slideDuplicatePrevClass: 'swiper-slide-duplicate-prev',\n  wrapperClass: 'swiper-wrapper',\n\n  // Callbacks\n  runCallbacksOnInit: true,\n\n  // Internals\n  _emitClasses: false,\n};\n","/* eslint no-param-reassign: \"off\" */\nimport $ from '../../utils/dom';\nimport { extend, now, deleteProps } from '../../utils/utils';\nimport { getSupport } from '../../utils/get-support';\nimport { getDevice } from '../../utils/get-device';\nimport { getBrowser } from '../../utils/get-browser';\n\nimport Resize from '../../modules/resize/resize';\nimport Observer from '../../modules/observer/observer';\n\nimport modular from './modular';\nimport eventsEmitter from './events-emitter';\n\nimport update from './update/index';\nimport translate from './translate/index';\nimport transition from './transition/index';\nimport slide from './slide/index';\nimport loop from './loop/index';\nimport grabCursor from './grab-cursor/index';\nimport manipulation from './manipulation/index';\nimport events from './events/index';\nimport breakpoints from './breakpoints/index';\nimport classes from './classes/index';\nimport images from './images/index';\nimport checkOverflow from './check-overflow/index';\n\nimport defaults from './defaults';\n\nconst prototypes = {\n  modular,\n  eventsEmitter,\n  update,\n  translate,\n  transition,\n  slide,\n  loop,\n  grabCursor,\n  manipulation,\n  events,\n  breakpoints,\n  checkOverflow,\n  classes,\n  images,\n};\n\nconst extendedDefaults = {};\n\nclass Swiper {\n  constructor(...args) {\n    let el;\n    let params;\n    if (\n      args.length === 1 &&\n      args[0].constructor &&\n      Object.prototype.toString.call(args[0]).slice(8, -1) === 'Object'\n    ) {\n      params = args[0];\n    } else {\n      [el, params] = args;\n    }\n    if (!params) params = {};\n\n    params = extend({}, params);\n    if (el && !params.el) params.el = el;\n\n    if (params.el && $(params.el).length > 1) {\n      const swipers = [];\n      $(params.el).each((containerEl) => {\n        const newParams = extend({}, params, { el: containerEl });\n        swipers.push(new Swiper(newParams));\n      });\n      return swipers;\n    }\n\n    // Swiper Instance\n    const swiper = this;\n    swiper.__swiper__ = true;\n    swiper.support = getSupport();\n    swiper.device = getDevice({ userAgent: params.userAgent });\n    swiper.browser = getBrowser();\n\n    swiper.eventsListeners = {};\n    swiper.eventsAnyListeners = [];\n\n    if (typeof swiper.modules === 'undefined') {\n      swiper.modules = {};\n    }\n    Object.keys(swiper.modules).forEach((moduleName) => {\n      const module = swiper.modules[moduleName];\n      if (module.params) {\n        const moduleParamName = Object.keys(module.params)[0];\n        const moduleParams = module.params[moduleParamName];\n        if (typeof moduleParams !== 'object' || moduleParams === null) return;\n        if (!(moduleParamName in params && 'enabled' in moduleParams)) return;\n        if (params[moduleParamName] === true) {\n          params[moduleParamName] = { enabled: true };\n        }\n        if (\n          typeof params[moduleParamName] === 'object' &&\n          !('enabled' in params[moduleParamName])\n        ) {\n          params[moduleParamName].enabled = true;\n        }\n        if (!params[moduleParamName]) params[moduleParamName] = { enabled: false };\n      }\n    });\n\n    // Extend defaults with modules params\n    const swiperParams = extend({}, defaults);\n    swiper.useParams(swiperParams);\n\n    // Extend defaults with passed params\n    swiper.params = extend({}, swiperParams, extendedDefaults, params);\n    swiper.originalParams = extend({}, swiper.params);\n    swiper.passedParams = extend({}, params);\n\n    // add event listeners\n    if (swiper.params && swiper.params.on) {\n      Object.keys(swiper.params.on).forEach((eventName) => {\n        swiper.on(eventName, swiper.params.on[eventName]);\n      });\n    }\n    if (swiper.params && swiper.params.onAny) {\n      swiper.onAny(swiper.params.onAny);\n    }\n\n    // Save Dom lib\n    swiper.$ = $;\n\n    // Extend Swiper\n    extend(swiper, {\n      el,\n\n      // Classes\n      classNames: [],\n\n      // Slides\n      slides: $(),\n      slidesGrid: [],\n      snapGrid: [],\n      slidesSizesGrid: [],\n\n      // isDirection\n      isHorizontal() {\n        return swiper.params.direction === 'horizontal';\n      },\n      isVertical() {\n        return swiper.params.direction === 'vertical';\n      },\n\n      // Indexes\n      activeIndex: 0,\n      realIndex: 0,\n\n      //\n      isBeginning: true,\n      isEnd: false,\n\n      // Props\n      translate: 0,\n      previousTranslate: 0,\n      progress: 0,\n      velocity: 0,\n      animating: false,\n\n      // Locks\n      allowSlideNext: swiper.params.allowSlideNext,\n      allowSlidePrev: swiper.params.allowSlidePrev,\n\n      // Touch Events\n      touchEvents: (function touchEvents() {\n        const touch = ['touchstart', 'touchmove', 'touchend', 'touchcancel'];\n        let desktop = ['mousedown', 'mousemove', 'mouseup'];\n        if (swiper.support.pointerEvents) {\n          desktop = ['pointerdown', 'pointermove', 'pointerup'];\n        }\n        swiper.touchEventsTouch = {\n          start: touch[0],\n          move: touch[1],\n          end: touch[2],\n          cancel: touch[3],\n        };\n        swiper.touchEventsDesktop = {\n          start: desktop[0],\n          move: desktop[1],\n          end: desktop[2],\n        };\n        return swiper.support.touch || !swiper.params.simulateTouch\n          ? swiper.touchEventsTouch\n          : swiper.touchEventsDesktop;\n      })(),\n      touchEventsData: {\n        isTouched: undefined,\n        isMoved: undefined,\n        allowTouchCallbacks: undefined,\n        touchStartTime: undefined,\n        isScrolling: undefined,\n        currentTranslate: undefined,\n        startTranslate: undefined,\n        allowThresholdMove: undefined,\n        // Form elements to match\n        formElements: 'input, select, option, textarea, button, video, label',\n        // Last click time\n        lastClickTime: now(),\n        clickTimeout: undefined,\n        // Velocities\n        velocities: [],\n        allowMomentumBounce: undefined,\n        isTouchEvent: undefined,\n        startMoving: undefined,\n      },\n\n      // Clicks\n      allowClick: true,\n\n      // Touches\n      allowTouchMove: swiper.params.allowTouchMove,\n\n      touches: {\n        startX: 0,\n        startY: 0,\n        currentX: 0,\n        currentY: 0,\n        diff: 0,\n      },\n\n      // Images\n      imagesToLoad: [],\n      imagesLoaded: 0,\n    });\n\n    // Install Modules\n    swiper.useModules();\n\n    swiper.emit('_swiper');\n\n    // Init\n    if (swiper.params.init) {\n      swiper.init();\n    }\n\n    // Return app instance\n    return swiper;\n  }\n\n  emitContainerClasses() {\n    const swiper = this;\n    if (!swiper.params._emitClasses || !swiper.el) return;\n    const classes = swiper.el.className.split(' ').filter((className) => {\n      return (\n        className.indexOf('swiper-container') === 0 ||\n        className.indexOf(swiper.params.containerModifierClass) === 0\n      );\n    });\n    swiper.emit('_containerClasses', classes.join(' '));\n  }\n\n  getSlideClasses(slideEl) {\n    const swiper = this;\n\n    return slideEl.className\n      .split(' ')\n      .filter((className) => {\n        return (\n          className.indexOf('swiper-slide') === 0 ||\n          className.indexOf(swiper.params.slideClass) === 0\n        );\n      })\n      .join(' ');\n  }\n\n  emitSlidesClasses() {\n    const swiper = this;\n    if (!swiper.params._emitClasses || !swiper.el) return;\n    const updates = [];\n    swiper.slides.each((slideEl) => {\n      const classNames = swiper.getSlideClasses(slideEl);\n      updates.push({ slideEl, classNames });\n      swiper.emit('_slideClass', slideEl, classNames);\n    });\n    swiper.emit('_slideClasses', updates);\n  }\n\n  slidesPerViewDynamic() {\n    const swiper = this;\n    const { params, slides, slidesGrid, size: swiperSize, activeIndex } = swiper;\n    let spv = 1;\n    if (params.centeredSlides) {\n      let slideSize = slides[activeIndex].swiperSlideSize;\n      let breakLoop;\n      for (let i = activeIndex + 1; i < slides.length; i += 1) {\n        if (slides[i] && !breakLoop) {\n          slideSize += slides[i].swiperSlideSize;\n          spv += 1;\n          if (slideSize > swiperSize) breakLoop = true;\n        }\n      }\n      for (let i = activeIndex - 1; i >= 0; i -= 1) {\n        if (slides[i] && !breakLoop) {\n          slideSize += slides[i].swiperSlideSize;\n          spv += 1;\n          if (slideSize > swiperSize) breakLoop = true;\n        }\n      }\n    } else {\n      for (let i = activeIndex + 1; i < slides.length; i += 1) {\n        if (slidesGrid[i] - slidesGrid[activeIndex] < swiperSize) {\n          spv += 1;\n        }\n      }\n    }\n    return spv;\n  }\n\n  update() {\n    const swiper = this;\n    if (!swiper || swiper.destroyed) return;\n    const { snapGrid, params } = swiper;\n    // Breakpoints\n    if (params.breakpoints) {\n      swiper.setBreakpoint();\n    }\n    swiper.updateSize();\n    swiper.updateSlides();\n    swiper.updateProgress();\n    swiper.updateSlidesClasses();\n\n    function setTranslate() {\n      const translateValue = swiper.rtlTranslate ? swiper.translate * -1 : swiper.translate;\n      const newTranslate = Math.min(\n        Math.max(translateValue, swiper.maxTranslate()),\n        swiper.minTranslate(),\n      );\n      swiper.setTranslate(newTranslate);\n      swiper.updateActiveIndex();\n      swiper.updateSlidesClasses();\n    }\n    let translated;\n    if (swiper.params.freeMode) {\n      setTranslate();\n      if (swiper.params.autoHeight) {\n        swiper.updateAutoHeight();\n      }\n    } else {\n      if (\n        (swiper.params.slidesPerView === 'auto' || swiper.params.slidesPerView > 1) &&\n        swiper.isEnd &&\n        !swiper.params.centeredSlides\n      ) {\n        translated = swiper.slideTo(swiper.slides.length - 1, 0, false, true);\n      } else {\n        translated = swiper.slideTo(swiper.activeIndex, 0, false, true);\n      }\n      if (!translated) {\n        setTranslate();\n      }\n    }\n    if (params.watchOverflow && snapGrid !== swiper.snapGrid) {\n      swiper.checkOverflow();\n    }\n    swiper.emit('update');\n  }\n\n  changeDirection(newDirection, needUpdate = true) {\n    const swiper = this;\n    const currentDirection = swiper.params.direction;\n    if (!newDirection) {\n      // eslint-disable-next-line\n      newDirection = currentDirection === 'horizontal' ? 'vertical' : 'horizontal';\n    }\n    if (\n      newDirection === currentDirection ||\n      (newDirection !== 'horizontal' && newDirection !== 'vertical')\n    ) {\n      return swiper;\n    }\n\n    swiper.$el\n      .removeClass(`${swiper.params.containerModifierClass}${currentDirection}`)\n      .addClass(`${swiper.params.containerModifierClass}${newDirection}`);\n    swiper.emitContainerClasses();\n\n    swiper.params.direction = newDirection;\n\n    swiper.slides.each((slideEl) => {\n      if (newDirection === 'vertical') {\n        slideEl.style.width = '';\n      } else {\n        slideEl.style.height = '';\n      }\n    });\n\n    swiper.emit('changeDirection');\n    if (needUpdate) swiper.update();\n\n    return swiper;\n  }\n\n  mount(el) {\n    const swiper = this;\n    if (swiper.mounted) return true;\n\n    // Find el\n    const $el = $(el || swiper.params.el);\n    el = $el[0];\n\n    if (!el) {\n      return false;\n    }\n\n    el.swiper = swiper;\n\n    // Find Wrapper\n    let $wrapperEl;\n    if (el && el.shadowRoot && el.shadowRoot.querySelector) {\n      $wrapperEl = $(el.shadowRoot.querySelector(`.${swiper.params.wrapperClass}`));\n      // Children needs to return slot items\n      $wrapperEl.children = (options) => $el.children(options);\n    } else {\n      $wrapperEl = $el.children(`.${swiper.params.wrapperClass}`);\n    }\n\n    extend(swiper, {\n      $el,\n      el,\n      $wrapperEl,\n      wrapperEl: $wrapperEl[0],\n      mounted: true,\n\n      // RTL\n      rtl: el.dir.toLowerCase() === 'rtl' || $el.css('direction') === 'rtl',\n      rtlTranslate:\n        swiper.params.direction === 'horizontal' &&\n        (el.dir.toLowerCase() === 'rtl' || $el.css('direction') === 'rtl'),\n      wrongRTL: $wrapperEl.css('display') === '-webkit-box',\n    });\n\n    return true;\n  }\n\n  init(el) {\n    const swiper = this;\n    if (swiper.initialized) return swiper;\n\n    const mounted = swiper.mount(el);\n    if (mounted === false) return swiper;\n\n    swiper.emit('beforeInit');\n\n    // Set breakpoint\n    if (swiper.params.breakpoints) {\n      swiper.setBreakpoint();\n    }\n\n    // Add Classes\n    swiper.addClasses();\n\n    // Create loop\n    if (swiper.params.loop) {\n      swiper.loopCreate();\n    }\n\n    // Update size\n    swiper.updateSize();\n\n    // Update slides\n    swiper.updateSlides();\n\n    if (swiper.params.watchOverflow) {\n      swiper.checkOverflow();\n    }\n\n    // Set Grab Cursor\n    if (swiper.params.grabCursor) {\n      swiper.setGrabCursor();\n    }\n\n    if (swiper.params.preloadImages) {\n      swiper.preloadImages();\n    }\n\n    // Slide To Initial Slide\n    if (swiper.params.loop) {\n      swiper.slideTo(\n        swiper.params.initialSlide + swiper.loopedSlides,\n        0,\n        swiper.params.runCallbacksOnInit,\n      );\n    } else {\n      swiper.slideTo(swiper.params.initialSlide, 0, swiper.params.runCallbacksOnInit);\n    }\n\n    // Attach events\n    swiper.attachEvents();\n\n    // Init Flag\n    swiper.initialized = true;\n\n    // Emit\n    swiper.emit('init');\n    swiper.emit('afterInit');\n\n    return swiper;\n  }\n\n  destroy(deleteInstance = true, cleanStyles = true) {\n    const swiper = this;\n    const { params, $el, $wrapperEl, slides } = swiper;\n\n    if (typeof swiper.params === 'undefined' || swiper.destroyed) {\n      return null;\n    }\n\n    swiper.emit('beforeDestroy');\n\n    // Init Flag\n    swiper.initialized = false;\n\n    // Detach events\n    swiper.detachEvents();\n\n    // Destroy loop\n    if (params.loop) {\n      swiper.loopDestroy();\n    }\n\n    // Cleanup styles\n    if (cleanStyles) {\n      swiper.removeClasses();\n      $el.removeAttr('style');\n      $wrapperEl.removeAttr('style');\n      if (slides && slides.length) {\n        slides\n          .removeClass(\n            [\n              params.slideVisibleClass,\n              params.slideActiveClass,\n              params.slideNextClass,\n              params.slidePrevClass,\n            ].join(' '),\n          )\n          .removeAttr('style')\n          .removeAttr('data-swiper-slide-index');\n      }\n    }\n\n    swiper.emit('destroy');\n\n    // Detach emitter events\n    Object.keys(swiper.eventsListeners).forEach((eventName) => {\n      swiper.off(eventName);\n    });\n\n    if (deleteInstance !== false) {\n      swiper.$el[0].swiper = null;\n      deleteProps(swiper);\n    }\n    swiper.destroyed = true;\n\n    return null;\n  }\n\n  static extendDefaults(newDefaults) {\n    extend(extendedDefaults, newDefaults);\n  }\n\n  static get extendedDefaults() {\n    return extendedDefaults;\n  }\n\n  static get defaults() {\n    return defaults;\n  }\n\n  static installModule(module) {\n    if (!Swiper.prototype.modules) Swiper.prototype.modules = {};\n    const name = module.name || `${Object.keys(Swiper.prototype.modules).length}_${now()}`;\n    Swiper.prototype.modules[name] = module;\n  }\n\n  static use(module) {\n    if (Array.isArray(module)) {\n      module.forEach((m) => Swiper.installModule(m));\n      return Swiper;\n    }\n    Swiper.installModule(module);\n    return Swiper;\n  }\n}\n\nObject.keys(prototypes).forEach((prototypeGroup) => {\n  Object.keys(prototypes[prototypeGroup]).forEach((protoMethod) => {\n    Swiper.prototype[protoMethod] = prototypes[prototypeGroup][protoMethod];\n  });\n});\n\nSwiper.use([Resize, Observer]);\n\nexport default Swiper;\n","import $ from '../../utils/dom';\nimport { extend, bindModuleMethods } from '../../utils/utils';\n\nconst Virtual = {\n  update(force) {\n    const swiper = this;\n    const { slidesPerView, slidesPerGroup, centeredSlides } = swiper.params;\n    const { addSlidesBefore, addSlidesAfter } = swiper.params.virtual;\n    const {\n      from: previousFrom,\n      to: previousTo,\n      slides,\n      slidesGrid: previousSlidesGrid,\n      renderSlide,\n      offset: previousOffset,\n    } = swiper.virtual;\n    swiper.updateActiveIndex();\n    const activeIndex = swiper.activeIndex || 0;\n\n    let offsetProp;\n    if (swiper.rtlTranslate) offsetProp = 'right';\n    else offsetProp = swiper.isHorizontal() ? 'left' : 'top';\n\n    let slidesAfter;\n    let slidesBefore;\n    if (centeredSlides) {\n      slidesAfter = Math.floor(slidesPerView / 2) + slidesPerGroup + addSlidesAfter;\n      slidesBefore = Math.floor(slidesPerView / 2) + slidesPerGroup + addSlidesBefore;\n    } else {\n      slidesAfter = slidesPerView + (slidesPerGroup - 1) + addSlidesAfter;\n      slidesBefore = slidesPerGroup + addSlidesBefore;\n    }\n    const from = Math.max((activeIndex || 0) - slidesBefore, 0);\n    const to = Math.min((activeIndex || 0) + slidesAfter, slides.length - 1);\n    const offset = (swiper.slidesGrid[from] || 0) - (swiper.slidesGrid[0] || 0);\n\n    extend(swiper.virtual, {\n      from,\n      to,\n      offset,\n      slidesGrid: swiper.slidesGrid,\n    });\n\n    function onRendered() {\n      swiper.updateSlides();\n      swiper.updateProgress();\n      swiper.updateSlidesClasses();\n      if (swiper.lazy && swiper.params.lazy.enabled) {\n        swiper.lazy.load();\n      }\n    }\n\n    if (previousFrom === from && previousTo === to && !force) {\n      if (swiper.slidesGrid !== previousSlidesGrid && offset !== previousOffset) {\n        swiper.slides.css(offsetProp, `${offset}px`);\n      }\n      swiper.updateProgress();\n      return;\n    }\n    if (swiper.params.virtual.renderExternal) {\n      swiper.params.virtual.renderExternal.call(swiper, {\n        offset,\n        from,\n        to,\n        slides: (function getSlides() {\n          const slidesToRender = [];\n          for (let i = from; i <= to; i += 1) {\n            slidesToRender.push(slides[i]);\n          }\n          return slidesToRender;\n        })(),\n      });\n      if (swiper.params.virtual.renderExternalUpdate) {\n        onRendered();\n      }\n      return;\n    }\n    const prependIndexes = [];\n    const appendIndexes = [];\n    if (force) {\n      swiper.$wrapperEl.find(`.${swiper.params.slideClass}`).remove();\n    } else {\n      for (let i = previousFrom; i <= previousTo; i += 1) {\n        if (i < from || i > to) {\n          swiper.$wrapperEl\n            .find(`.${swiper.params.slideClass}[data-swiper-slide-index=\"${i}\"]`)\n            .remove();\n        }\n      }\n    }\n    for (let i = 0; i < slides.length; i += 1) {\n      if (i >= from && i <= to) {\n        if (typeof previousTo === 'undefined' || force) {\n          appendIndexes.push(i);\n        } else {\n          if (i > previousTo) appendIndexes.push(i);\n          if (i < previousFrom) prependIndexes.push(i);\n        }\n      }\n    }\n    appendIndexes.forEach((index) => {\n      swiper.$wrapperEl.append(renderSlide(slides[index], index));\n    });\n    prependIndexes\n      .sort((a, b) => b - a)\n      .forEach((index) => {\n        swiper.$wrapperEl.prepend(renderSlide(slides[index], index));\n      });\n    swiper.$wrapperEl.children('.swiper-slide').css(offsetProp, `${offset}px`);\n    onRendered();\n  },\n  renderSlide(slide, index) {\n    const swiper = this;\n    const params = swiper.params.virtual;\n    if (params.cache && swiper.virtual.cache[index]) {\n      return swiper.virtual.cache[index];\n    }\n    const $slideEl = params.renderSlide\n      ? $(params.renderSlide.call(swiper, slide, index))\n      : $(\n          `<div class=\"${swiper.params.slideClass}\" data-swiper-slide-index=\"${index}\">${slide}</div>`,\n        );\n    if (!$slideEl.attr('data-swiper-slide-index')) $slideEl.attr('data-swiper-slide-index', index);\n    if (params.cache) swiper.virtual.cache[index] = $slideEl;\n    return $slideEl;\n  },\n  appendSlide(slides) {\n    const swiper = this;\n    if (typeof slides === 'object' && 'length' in slides) {\n      for (let i = 0; i < slides.length; i += 1) {\n        if (slides[i]) swiper.virtual.slides.push(slides[i]);\n      }\n    } else {\n      swiper.virtual.slides.push(slides);\n    }\n    swiper.virtual.update(true);\n  },\n  prependSlide(slides) {\n    const swiper = this;\n    const activeIndex = swiper.activeIndex;\n    let newActiveIndex = activeIndex + 1;\n    let numberOfNewSlides = 1;\n\n    if (Array.isArray(slides)) {\n      for (let i = 0; i < slides.length; i += 1) {\n        if (slides[i]) swiper.virtual.slides.unshift(slides[i]);\n      }\n      newActiveIndex = activeIndex + slides.length;\n      numberOfNewSlides = slides.length;\n    } else {\n      swiper.virtual.slides.unshift(slides);\n    }\n    if (swiper.params.virtual.cache) {\n      const cache = swiper.virtual.cache;\n      const newCache = {};\n      Object.keys(cache).forEach((cachedIndex) => {\n        const $cachedEl = cache[cachedIndex];\n        const cachedElIndex = $cachedEl.attr('data-swiper-slide-index');\n        if (cachedElIndex) {\n          $cachedEl.attr('data-swiper-slide-index', parseInt(cachedElIndex, 10) + 1);\n        }\n        newCache[parseInt(cachedIndex, 10) + numberOfNewSlides] = $cachedEl;\n      });\n      swiper.virtual.cache = newCache;\n    }\n    swiper.virtual.update(true);\n    swiper.slideTo(newActiveIndex, 0);\n  },\n  removeSlide(slidesIndexes) {\n    const swiper = this;\n    if (typeof slidesIndexes === 'undefined' || slidesIndexes === null) return;\n    let activeIndex = swiper.activeIndex;\n    if (Array.isArray(slidesIndexes)) {\n      for (let i = slidesIndexes.length - 1; i >= 0; i -= 1) {\n        swiper.virtual.slides.splice(slidesIndexes[i], 1);\n        if (swiper.params.virtual.cache) {\n          delete swiper.virtual.cache[slidesIndexes[i]];\n        }\n        if (slidesIndexes[i] < activeIndex) activeIndex -= 1;\n        activeIndex = Math.max(activeIndex, 0);\n      }\n    } else {\n      swiper.virtual.slides.splice(slidesIndexes, 1);\n      if (swiper.params.virtual.cache) {\n        delete swiper.virtual.cache[slidesIndexes];\n      }\n      if (slidesIndexes < activeIndex) activeIndex -= 1;\n      activeIndex = Math.max(activeIndex, 0);\n    }\n    swiper.virtual.update(true);\n    swiper.slideTo(activeIndex, 0);\n  },\n  removeAllSlides() {\n    const swiper = this;\n    swiper.virtual.slides = [];\n    if (swiper.params.virtual.cache) {\n      swiper.virtual.cache = {};\n    }\n    swiper.virtual.update(true);\n    swiper.slideTo(0, 0);\n  },\n};\n\nexport default {\n  name: 'virtual',\n  params: {\n    virtual: {\n      enabled: false,\n      slides: [],\n      cache: true,\n      renderSlide: null,\n      renderExternal: null,\n      renderExternalUpdate: true,\n      addSlidesBefore: 0,\n      addSlidesAfter: 0,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      virtual: {\n        ...Virtual,\n        slides: swiper.params.virtual.slides,\n        cache: {},\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      if (!swiper.params.virtual.enabled) return;\n      swiper.classNames.push(`${swiper.params.containerModifierClass}virtual`);\n      const overwriteParams = {\n        watchSlidesProgress: true,\n      };\n      extend(swiper.params, overwriteParams);\n      extend(swiper.originalParams, overwriteParams);\n\n      if (!swiper.params.initialSlide) {\n        swiper.virtual.update();\n      }\n    },\n    setTranslate(swiper) {\n      if (!swiper.params.virtual.enabled) return;\n      swiper.virtual.update();\n    },\n  },\n};\n","import { getWindow, getDocument } from 'ssr-window';\nimport $ from '../../utils/dom';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst Keyboard = {\n  handle(event) {\n    const swiper = this;\n    const window = getWindow();\n    const document = getDocument();\n    const { rtlTranslate: rtl } = swiper;\n    let e = event;\n    if (e.originalEvent) e = e.originalEvent; // jquery fix\n    const kc = e.keyCode || e.charCode;\n    const pageUpDown = swiper.params.keyboard.pageUpDown;\n    const isPageUp = pageUpDown && kc === 33;\n    const isPageDown = pageUpDown && kc === 34;\n    const isArrowLeft = kc === 37;\n    const isArrowRight = kc === 39;\n    const isArrowUp = kc === 38;\n    const isArrowDown = kc === 40;\n    // Directions locks\n    if (\n      !swiper.allowSlideNext &&\n      ((swiper.isHorizontal() && isArrowRight) ||\n        (swiper.isVertical() && isArrowDown) ||\n        isPageDown)\n    ) {\n      return false;\n    }\n    if (\n      !swiper.allowSlidePrev &&\n      ((swiper.isHorizontal() && isArrowLeft) || (swiper.isVertical() && isArrowUp) || isPageUp)\n    ) {\n      return false;\n    }\n    if (e.shiftKey || e.altKey || e.ctrlKey || e.metaKey) {\n      return undefined;\n    }\n    if (\n      document.activeElement &&\n      document.activeElement.nodeName &&\n      (document.activeElement.nodeName.toLowerCase() === 'input' ||\n        document.activeElement.nodeName.toLowerCase() === 'textarea')\n    ) {\n      return undefined;\n    }\n    if (\n      swiper.params.keyboard.onlyInViewport &&\n      (isPageUp || isPageDown || isArrowLeft || isArrowRight || isArrowUp || isArrowDown)\n    ) {\n      let inView = false;\n      // Check that swiper should be inside of visible area of window\n      if (\n        swiper.$el.parents(`.${swiper.params.slideClass}`).length > 0 &&\n        swiper.$el.parents(`.${swiper.params.slideActiveClass}`).length === 0\n      ) {\n        return undefined;\n      }\n\n      const $el = swiper.$el;\n      const swiperWidth = $el[0].clientWidth;\n      const swiperHeight = $el[0].clientHeight;\n      const windowWidth = window.innerWidth;\n      const windowHeight = window.innerHeight;\n      const swiperOffset = swiper.$el.offset();\n      if (rtl) swiperOffset.left -= swiper.$el[0].scrollLeft;\n      const swiperCoord = [\n        [swiperOffset.left, swiperOffset.top],\n        [swiperOffset.left + swiperWidth, swiperOffset.top],\n        [swiperOffset.left, swiperOffset.top + swiperHeight],\n        [swiperOffset.left + swiperWidth, swiperOffset.top + swiperHeight],\n      ];\n      for (let i = 0; i < swiperCoord.length; i += 1) {\n        const point = swiperCoord[i];\n        if (point[0] >= 0 && point[0] <= windowWidth && point[1] >= 0 && point[1] <= windowHeight) {\n          if (point[0] === 0 && point[1] === 0) continue; // eslint-disable-line\n          inView = true;\n        }\n      }\n      if (!inView) return undefined;\n    }\n    if (swiper.isHorizontal()) {\n      if (isPageUp || isPageDown || isArrowLeft || isArrowRight) {\n        if (e.preventDefault) e.preventDefault();\n        else e.returnValue = false;\n      }\n      if (((isPageDown || isArrowRight) && !rtl) || ((isPageUp || isArrowLeft) && rtl))\n        swiper.slideNext();\n      if (((isPageUp || isArrowLeft) && !rtl) || ((isPageDown || isArrowRight) && rtl))\n        swiper.slidePrev();\n    } else {\n      if (isPageUp || isPageDown || isArrowUp || isArrowDown) {\n        if (e.preventDefault) e.preventDefault();\n        else e.returnValue = false;\n      }\n      if (isPageDown || isArrowDown) swiper.slideNext();\n      if (isPageUp || isArrowUp) swiper.slidePrev();\n    }\n    swiper.emit('keyPress', kc);\n    return undefined;\n  },\n  enable() {\n    const swiper = this;\n    const document = getDocument();\n    if (swiper.keyboard.enabled) return;\n    $(document).on('keydown', swiper.keyboard.handle);\n    swiper.keyboard.enabled = true;\n  },\n  disable() {\n    const swiper = this;\n    const document = getDocument();\n    if (!swiper.keyboard.enabled) return;\n    $(document).off('keydown', swiper.keyboard.handle);\n    swiper.keyboard.enabled = false;\n  },\n};\n\nexport default {\n  name: 'keyboard',\n  params: {\n    keyboard: {\n      enabled: false,\n      onlyInViewport: true,\n      pageUpDown: true,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      keyboard: {\n        enabled: false,\n        ...Keyboard,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      if (swiper.params.keyboard.enabled) {\n        swiper.keyboard.enable();\n      }\n    },\n    destroy(swiper) {\n      if (swiper.keyboard.enabled) {\n        swiper.keyboard.disable();\n      }\n    },\n  },\n};\n","import { getWindow, getDocument } from 'ssr-window';\nimport $ from '../../utils/dom';\nimport { now, nextTick, bindModuleMethods } from '../../utils/utils';\n\nfunction isEventSupported() {\n  const document = getDocument();\n  const eventName = 'onwheel';\n  let isSupported = eventName in document;\n\n  if (!isSupported) {\n    const element = document.createElement('div');\n    element.setAttribute(eventName, 'return;');\n    isSupported = typeof element[eventName] === 'function';\n  }\n\n  if (\n    !isSupported &&\n    document.implementation &&\n    document.implementation.hasFeature &&\n    // always returns true in newer browsers as per the standard.\n    // @see http://dom.spec.whatwg.org/#dom-domimplementation-hasfeature\n    document.implementation.hasFeature('', '') !== true\n  ) {\n    // This is the only way to test support for the `wheel` event in IE9+.\n    isSupported = document.implementation.hasFeature('Events.wheel', '3.0');\n  }\n\n  return isSupported;\n}\nconst Mousewheel = {\n  lastScrollTime: now(),\n  lastEventBeforeSnap: undefined,\n  recentWheelEvents: [],\n  event() {\n    const window = getWindow();\n    if (window.navigator.userAgent.indexOf('firefox') > -1) return 'DOMMouseScroll';\n    return isEventSupported() ? 'wheel' : 'mousewheel';\n  },\n  normalize(e) {\n    // Reasonable defaults\n    const PIXEL_STEP = 10;\n    const LINE_HEIGHT = 40;\n    const PAGE_HEIGHT = 800;\n\n    let sX = 0;\n    let sY = 0; // spinX, spinY\n    let pX = 0;\n    let pY = 0; // pixelX, pixelY\n\n    // Legacy\n    if ('detail' in e) {\n      sY = e.detail;\n    }\n    if ('wheelDelta' in e) {\n      sY = -e.wheelDelta / 120;\n    }\n    if ('wheelDeltaY' in e) {\n      sY = -e.wheelDeltaY / 120;\n    }\n    if ('wheelDeltaX' in e) {\n      sX = -e.wheelDeltaX / 120;\n    }\n\n    // side scrolling on FF with DOMMouseScroll\n    if ('axis' in e && e.axis === e.HORIZONTAL_AXIS) {\n      sX = sY;\n      sY = 0;\n    }\n\n    pX = sX * PIXEL_STEP;\n    pY = sY * PIXEL_STEP;\n\n    if ('deltaY' in e) {\n      pY = e.deltaY;\n    }\n    if ('deltaX' in e) {\n      pX = e.deltaX;\n    }\n\n    if (e.shiftKey && !pX) {\n      // if user scrolls with shift he wants horizontal scroll\n      pX = pY;\n      pY = 0;\n    }\n\n    if ((pX || pY) && e.deltaMode) {\n      if (e.deltaMode === 1) {\n        // delta in LINE units\n        pX *= LINE_HEIGHT;\n        pY *= LINE_HEIGHT;\n      } else {\n        // delta in PAGE units\n        pX *= PAGE_HEIGHT;\n        pY *= PAGE_HEIGHT;\n      }\n    }\n\n    // Fall-back if spin cannot be determined\n    if (pX && !sX) {\n      sX = pX < 1 ? -1 : 1;\n    }\n    if (pY && !sY) {\n      sY = pY < 1 ? -1 : 1;\n    }\n\n    return {\n      spinX: sX,\n      spinY: sY,\n      pixelX: pX,\n      pixelY: pY,\n    };\n  },\n  handleMouseEnter() {\n    const swiper = this;\n    swiper.mouseEntered = true;\n  },\n  handleMouseLeave() {\n    const swiper = this;\n    swiper.mouseEntered = false;\n  },\n  handle(event) {\n    let e = event;\n    let disableParentSwiper = true;\n    const swiper = this;\n    const params = swiper.params.mousewheel;\n\n    if (swiper.params.cssMode) {\n      e.preventDefault();\n    }\n\n    let target = swiper.$el;\n    if (swiper.params.mousewheel.eventsTarget !== 'container') {\n      target = $(swiper.params.mousewheel.eventsTarget);\n    }\n    if (!swiper.mouseEntered && !target[0].contains(e.target) && !params.releaseOnEdges)\n      return true;\n\n    if (e.originalEvent) e = e.originalEvent; // jquery fix\n    let delta = 0;\n    const rtlFactor = swiper.rtlTranslate ? -1 : 1;\n\n    const data = Mousewheel.normalize(e);\n\n    if (params.forceToAxis) {\n      if (swiper.isHorizontal()) {\n        if (Math.abs(data.pixelX) > Math.abs(data.pixelY)) delta = -data.pixelX * rtlFactor;\n        else return true;\n      } else if (Math.abs(data.pixelY) > Math.abs(data.pixelX)) delta = -data.pixelY;\n      else return true;\n    } else {\n      delta =\n        Math.abs(data.pixelX) > Math.abs(data.pixelY) ? -data.pixelX * rtlFactor : -data.pixelY;\n    }\n\n    if (delta === 0) return true;\n\n    if (params.invert) delta = -delta;\n\n    // Get the scroll positions\n    let positions = swiper.getTranslate() + delta * params.sensitivity;\n\n    if (positions >= swiper.minTranslate()) positions = swiper.minTranslate();\n    if (positions <= swiper.maxTranslate()) positions = swiper.maxTranslate();\n\n    // When loop is true:\n    //     the disableParentSwiper will be true.\n    // When loop is false:\n    //     if the scroll positions is not on edge,\n    //     then the disableParentSwiper will be true.\n    //     if the scroll on edge positions,\n    //     then the disableParentSwiper will be false.\n    disableParentSwiper = swiper.params.loop\n      ? true\n      : !(positions === swiper.minTranslate() || positions === swiper.maxTranslate());\n\n    if (disableParentSwiper && swiper.params.nested) e.stopPropagation();\n\n    if (!swiper.params.freeMode) {\n      // Register the new event in a variable which stores the relevant data\n      const newEvent = {\n        time: now(),\n        delta: Math.abs(delta),\n        direction: Math.sign(delta),\n        raw: event,\n      };\n\n      // Keep the most recent events\n      const recentWheelEvents = swiper.mousewheel.recentWheelEvents;\n      if (recentWheelEvents.length >= 2) {\n        recentWheelEvents.shift(); // only store the last N events\n      }\n      const prevEvent = recentWheelEvents.length\n        ? recentWheelEvents[recentWheelEvents.length - 1]\n        : undefined;\n      recentWheelEvents.push(newEvent);\n\n      // If there is at least one previous recorded event:\n      //   If direction has changed or\n      //   if the scroll is quicker than the previous one:\n      //     Animate the slider.\n      // Else (this is the first time the wheel is moved):\n      //     Animate the slider.\n      if (prevEvent) {\n        if (\n          newEvent.direction !== prevEvent.direction ||\n          newEvent.delta > prevEvent.delta ||\n          newEvent.time > prevEvent.time + 150\n        ) {\n          swiper.mousewheel.animateSlider(newEvent);\n        }\n      } else {\n        swiper.mousewheel.animateSlider(newEvent);\n      }\n\n      // If it's time to release the scroll:\n      //   Return now so you don't hit the preventDefault.\n      if (swiper.mousewheel.releaseScroll(newEvent)) {\n        return true;\n      }\n    } else {\n      // Freemode or scrollContainer:\n\n      // If we recently snapped after a momentum scroll, then ignore wheel events\n      // to give time for the deceleration to finish. Stop ignoring after 500 msecs\n      // or if it's a new scroll (larger delta or inverse sign as last event before\n      // an end-of-momentum snap).\n      const newEvent = {\n        time: now(),\n        delta: Math.abs(delta),\n        direction: Math.sign(delta),\n      };\n      const { lastEventBeforeSnap } = swiper.mousewheel;\n      const ignoreWheelEvents =\n        lastEventBeforeSnap &&\n        newEvent.time < lastEventBeforeSnap.time + 500 &&\n        newEvent.delta <= lastEventBeforeSnap.delta &&\n        newEvent.direction === lastEventBeforeSnap.direction;\n      if (!ignoreWheelEvents) {\n        swiper.mousewheel.lastEventBeforeSnap = undefined;\n\n        if (swiper.params.loop) {\n          swiper.loopFix();\n        }\n        let position = swiper.getTranslate() + delta * params.sensitivity;\n        const wasBeginning = swiper.isBeginning;\n        const wasEnd = swiper.isEnd;\n\n        if (position >= swiper.minTranslate()) position = swiper.minTranslate();\n        if (position <= swiper.maxTranslate()) position = swiper.maxTranslate();\n\n        swiper.setTransition(0);\n        swiper.setTranslate(position);\n        swiper.updateProgress();\n        swiper.updateActiveIndex();\n        swiper.updateSlidesClasses();\n\n        if ((!wasBeginning && swiper.isBeginning) || (!wasEnd && swiper.isEnd)) {\n          swiper.updateSlidesClasses();\n        }\n\n        if (swiper.params.freeModeSticky) {\n          // When wheel scrolling starts with sticky (aka snap) enabled, then detect\n          // the end of a momentum scroll by storing recent (N=15?) wheel events.\n          // 1. do all N events have decreasing or same (absolute value) delta?\n          // 2. did all N events arrive in the last M (M=500?) msecs?\n          // 3. does the earliest event have an (absolute value) delta that's\n          //    at least P (P=1?) larger than the most recent event's delta?\n          // 4. does the latest event have a delta that's smaller than Q (Q=6?) pixels?\n          // If 1-4 are \"yes\" then we're near the end of a momentum scroll deceleration.\n          // Snap immediately and ignore remaining wheel events in this scroll.\n          // See comment above for \"remaining wheel events in this scroll\" determination.\n          // If 1-4 aren't satisfied, then wait to snap until 500ms after the last event.\n          clearTimeout(swiper.mousewheel.timeout);\n          swiper.mousewheel.timeout = undefined;\n          const recentWheelEvents = swiper.mousewheel.recentWheelEvents;\n          if (recentWheelEvents.length >= 15) {\n            recentWheelEvents.shift(); // only store the last N events\n          }\n          const prevEvent = recentWheelEvents.length\n            ? recentWheelEvents[recentWheelEvents.length - 1]\n            : undefined;\n          const firstEvent = recentWheelEvents[0];\n          recentWheelEvents.push(newEvent);\n          if (\n            prevEvent &&\n            (newEvent.delta > prevEvent.delta || newEvent.direction !== prevEvent.direction)\n          ) {\n            // Increasing or reverse-sign delta means the user started scrolling again. Clear the wheel event log.\n            recentWheelEvents.splice(0);\n          } else if (\n            recentWheelEvents.length >= 15 &&\n            newEvent.time - firstEvent.time < 500 &&\n            firstEvent.delta - newEvent.delta >= 1 &&\n            newEvent.delta <= 6\n          ) {\n            // We're at the end of the deceleration of a momentum scroll, so there's no need\n            // to wait for more events. Snap ASAP on the next tick.\n            // Also, because there's some remaining momentum we'll bias the snap in the\n            // direction of the ongoing scroll because it's better UX for the scroll to snap\n            // in the same direction as the scroll instead of reversing to snap.  Therefore,\n            // if it's already scrolled more than 20% in the current direction, keep going.\n            const snapToThreshold = delta > 0 ? 0.8 : 0.2;\n            swiper.mousewheel.lastEventBeforeSnap = newEvent;\n            recentWheelEvents.splice(0);\n            swiper.mousewheel.timeout = nextTick(() => {\n              swiper.slideToClosest(swiper.params.speed, true, undefined, snapToThreshold);\n            }, 0); // no delay; move on next tick\n          }\n          if (!swiper.mousewheel.timeout) {\n            // if we get here, then we haven't detected the end of a momentum scroll, so\n            // we'll consider a scroll \"complete\" when there haven't been any wheel events\n            // for 500ms.\n            swiper.mousewheel.timeout = nextTick(() => {\n              const snapToThreshold = 0.5;\n              swiper.mousewheel.lastEventBeforeSnap = newEvent;\n              recentWheelEvents.splice(0);\n              swiper.slideToClosest(swiper.params.speed, true, undefined, snapToThreshold);\n            }, 500);\n          }\n        }\n\n        // Emit event\n        if (!ignoreWheelEvents) swiper.emit('scroll', e);\n\n        // Stop autoplay\n        if (swiper.params.autoplay && swiper.params.autoplayDisableOnInteraction)\n          swiper.autoplay.stop();\n        // Return page scroll on edge positions\n        if (position === swiper.minTranslate() || position === swiper.maxTranslate()) return true;\n      }\n    }\n\n    if (e.preventDefault) e.preventDefault();\n    else e.returnValue = false;\n    return false;\n  },\n  animateSlider(newEvent) {\n    const swiper = this;\n    const window = getWindow();\n\n    if (\n      this.params.mousewheel.thresholdDelta &&\n      newEvent.delta < this.params.mousewheel.thresholdDelta\n    ) {\n      // Prevent if delta of wheel scroll delta is below configured threshold\n      return false;\n    }\n\n    if (\n      this.params.mousewheel.thresholdTime &&\n      now() - swiper.mousewheel.lastScrollTime < this.params.mousewheel.thresholdTime\n    ) {\n      // Prevent if time between scrolls is below configured threshold\n      return false;\n    }\n\n    // If the movement is NOT big enough and\n    // if the last time the user scrolled was too close to the current one (avoid continuously triggering the slider):\n    //   Don't go any further (avoid insignificant scroll movement).\n    if (newEvent.delta >= 6 && now() - swiper.mousewheel.lastScrollTime < 60) {\n      // Return false as a default\n      return true;\n    }\n    // If user is scrolling towards the end:\n    //   If the slider hasn't hit the latest slide or\n    //   if the slider is a loop and\n    //   if the slider isn't moving right now:\n    //     Go to next slide and\n    //     emit a scroll event.\n    // Else (the user is scrolling towards the beginning) and\n    // if the slider hasn't hit the first slide or\n    // if the slider is a loop and\n    // if the slider isn't moving right now:\n    //   Go to prev slide and\n    //   emit a scroll event.\n    if (newEvent.direction < 0) {\n      if ((!swiper.isEnd || swiper.params.loop) && !swiper.animating) {\n        swiper.slideNext();\n        swiper.emit('scroll', newEvent.raw);\n      }\n    } else if ((!swiper.isBeginning || swiper.params.loop) && !swiper.animating) {\n      swiper.slidePrev();\n      swiper.emit('scroll', newEvent.raw);\n    }\n    // If you got here is because an animation has been triggered so store the current time\n    swiper.mousewheel.lastScrollTime = new window.Date().getTime();\n    // Return false as a default\n    return false;\n  },\n  releaseScroll(newEvent) {\n    const swiper = this;\n    const params = swiper.params.mousewheel;\n    if (newEvent.direction < 0) {\n      if (swiper.isEnd && !swiper.params.loop && params.releaseOnEdges) {\n        // Return true to animate scroll on edges\n        return true;\n      }\n    } else if (swiper.isBeginning && !swiper.params.loop && params.releaseOnEdges) {\n      // Return true to animate scroll on edges\n      return true;\n    }\n    return false;\n  },\n  enable() {\n    const swiper = this;\n    const event = Mousewheel.event();\n    if (swiper.params.cssMode) {\n      swiper.wrapperEl.removeEventListener(event, swiper.mousewheel.handle);\n      return true;\n    }\n    if (!event) return false;\n    if (swiper.mousewheel.enabled) return false;\n    let target = swiper.$el;\n    if (swiper.params.mousewheel.eventsTarget !== 'container') {\n      target = $(swiper.params.mousewheel.eventsTarget);\n    }\n    target.on('mouseenter', swiper.mousewheel.handleMouseEnter);\n    target.on('mouseleave', swiper.mousewheel.handleMouseLeave);\n    target.on(event, swiper.mousewheel.handle);\n    swiper.mousewheel.enabled = true;\n    return true;\n  },\n  disable() {\n    const swiper = this;\n    const event = Mousewheel.event();\n    if (swiper.params.cssMode) {\n      swiper.wrapperEl.addEventListener(event, swiper.mousewheel.handle);\n      return true;\n    }\n    if (!event) return false;\n    if (!swiper.mousewheel.enabled) return false;\n    let target = swiper.$el;\n    if (swiper.params.mousewheel.eventsTarget !== 'container') {\n      target = $(swiper.params.mousewheel.eventsTarget);\n    }\n    target.off(event, swiper.mousewheel.handle);\n    swiper.mousewheel.enabled = false;\n    return true;\n  },\n};\n\nexport default {\n  name: 'mousewheel',\n  params: {\n    mousewheel: {\n      enabled: false,\n      releaseOnEdges: false,\n      invert: false,\n      forceToAxis: false,\n      sensitivity: 1,\n      eventsTarget: 'container',\n      thresholdDelta: null,\n      thresholdTime: null,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      mousewheel: {\n        enabled: false,\n        lastScrollTime: now(),\n        lastEventBeforeSnap: undefined,\n        recentWheelEvents: [],\n\n        enable: Mousewheel.enable,\n        disable: Mousewheel.disable,\n        handle: Mousewheel.handle,\n        handleMouseEnter: Mousewheel.handleMouseEnter,\n        handleMouseLeave: Mousewheel.handleMouseLeave,\n        animateSlider: Mousewheel.animateSlider,\n        releaseScroll: Mousewheel.releaseScroll,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      if (!swiper.params.mousewheel.enabled && swiper.params.cssMode) {\n        swiper.mousewheel.disable();\n      }\n      if (swiper.params.mousewheel.enabled) swiper.mousewheel.enable();\n    },\n    destroy(swiper) {\n      if (swiper.params.cssMode) {\n        swiper.mousewheel.enable();\n      }\n      if (swiper.mousewheel.enabled) swiper.mousewheel.disable();\n    },\n  },\n};\n","import $ from '../../utils/dom';\nimport { extend, bindModuleMethods } from '../../utils/utils';\n\nconst Navigation = {\n  toggleEl($el, disabled) {\n    $el[disabled ? 'addClass' : 'removeClass'](this.params.navigation.disabledClass);\n    if ($el[0] && $el[0].tagName === 'BUTTON') $el[0].disabled = disabled;\n  },\n  update() {\n    // Update Navigation Buttons\n    const swiper = this;\n    const params = swiper.params.navigation;\n    const toggleEl = swiper.navigation.toggleEl;\n\n    if (swiper.params.loop) return;\n    const { $nextEl, $prevEl } = swiper.navigation;\n\n    if ($prevEl && $prevEl.length > 0) {\n      if (swiper.isBeginning) {\n        toggleEl($prevEl, true);\n      } else {\n        toggleEl($prevEl, false);\n      }\n      $prevEl[swiper.params.watchOverflow && swiper.isLocked ? 'addClass' : 'removeClass'](\n        params.lockClass,\n      );\n    }\n    if ($nextEl && $nextEl.length > 0) {\n      if (swiper.isEnd) {\n        toggleEl($nextEl, true);\n      } else {\n        toggleEl($nextEl, false);\n      }\n      $nextEl[swiper.params.watchOverflow && swiper.isLocked ? 'addClass' : 'removeClass'](\n        params.lockClass,\n      );\n    }\n  },\n  onPrevClick(e) {\n    const swiper = this;\n    e.preventDefault();\n    if (swiper.isBeginning && !swiper.params.loop) return;\n    swiper.slidePrev();\n  },\n  onNextClick(e) {\n    const swiper = this;\n    e.preventDefault();\n    if (swiper.isEnd && !swiper.params.loop) return;\n    swiper.slideNext();\n  },\n  init() {\n    const swiper = this;\n    const params = swiper.params.navigation;\n    if (!(params.nextEl || params.prevEl)) return;\n\n    let $nextEl;\n    let $prevEl;\n    if (params.nextEl) {\n      $nextEl = $(params.nextEl);\n      if (\n        swiper.params.uniqueNavElements &&\n        typeof params.nextEl === 'string' &&\n        $nextEl.length > 1 &&\n        swiper.$el.find(params.nextEl).length === 1\n      ) {\n        $nextEl = swiper.$el.find(params.nextEl);\n      }\n    }\n    if (params.prevEl) {\n      $prevEl = $(params.prevEl);\n      if (\n        swiper.params.uniqueNavElements &&\n        typeof params.prevEl === 'string' &&\n        $prevEl.length > 1 &&\n        swiper.$el.find(params.prevEl).length === 1\n      ) {\n        $prevEl = swiper.$el.find(params.prevEl);\n      }\n    }\n\n    if ($nextEl && $nextEl.length > 0) {\n      $nextEl.on('click', swiper.navigation.onNextClick);\n    }\n    if ($prevEl && $prevEl.length > 0) {\n      $prevEl.on('click', swiper.navigation.onPrevClick);\n    }\n\n    extend(swiper.navigation, {\n      $nextEl,\n      nextEl: $nextEl && $nextEl[0],\n      $prevEl,\n      prevEl: $prevEl && $prevEl[0],\n    });\n  },\n  destroy() {\n    const swiper = this;\n    const { $nextEl, $prevEl } = swiper.navigation;\n    if ($nextEl && $nextEl.length) {\n      $nextEl.off('click', swiper.navigation.onNextClick);\n      $nextEl.removeClass(swiper.params.navigation.disabledClass);\n    }\n    if ($prevEl && $prevEl.length) {\n      $prevEl.off('click', swiper.navigation.onPrevClick);\n      $prevEl.removeClass(swiper.params.navigation.disabledClass);\n    }\n  },\n};\n\nexport default {\n  name: 'navigation',\n  params: {\n    navigation: {\n      nextEl: null,\n      prevEl: null,\n\n      hideOnClick: false,\n      disabledClass: 'swiper-button-disabled',\n      hiddenClass: 'swiper-button-hidden',\n      lockClass: 'swiper-button-lock',\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      navigation: {\n        ...Navigation,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      swiper.navigation.init();\n      swiper.navigation.update();\n    },\n    toEdge(swiper) {\n      swiper.navigation.update();\n    },\n    fromEdge(swiper) {\n      swiper.navigation.update();\n    },\n    destroy(swiper) {\n      swiper.navigation.destroy();\n    },\n    click(swiper, e) {\n      const { $nextEl, $prevEl } = swiper.navigation;\n      const targetEl = e.target;\n      if (\n        swiper.params.navigation.hideOnClick &&\n        !$(targetEl).is($prevEl) &&\n        !$(targetEl).is($nextEl)\n      ) {\n        if (\n          swiper.pagination &&\n          swiper.params.pagination &&\n          swiper.params.pagination.clickable &&\n          (swiper.pagination.el === targetEl || swiper.pagination.el.contains(targetEl))\n        )\n          return;\n        let isHidden;\n        if ($nextEl) {\n          isHidden = $nextEl.hasClass(swiper.params.navigation.hiddenClass);\n        } else if ($prevEl) {\n          isHidden = $prevEl.hasClass(swiper.params.navigation.hiddenClass);\n        }\n        if (isHidden === true) {\n          swiper.emit('navigationShow');\n        } else {\n          swiper.emit('navigationHide');\n        }\n        if ($nextEl) {\n          $nextEl.toggleClass(swiper.params.navigation.hiddenClass);\n        }\n        if ($prevEl) {\n          $prevEl.toggleClass(swiper.params.navigation.hiddenClass);\n        }\n      }\n    },\n  },\n};\n","import $ from '../../utils/dom';\nimport { extend, bindModuleMethods } from '../../utils/utils';\n\nconst Pagination = {\n  update() {\n    // Render || Update Pagination bullets/items\n    const swiper = this;\n    const rtl = swiper.rtl;\n    const params = swiper.params.pagination;\n    if (\n      !params.el ||\n      !swiper.pagination.el ||\n      !swiper.pagination.$el ||\n      swiper.pagination.$el.length === 0\n    )\n      return;\n    const slidesLength =\n      swiper.virtual && swiper.params.virtual.enabled\n        ? swiper.virtual.slides.length\n        : swiper.slides.length;\n    const $el = swiper.pagination.$el;\n    // Current/Total\n    let current;\n    const total = swiper.params.loop\n      ? Math.ceil((slidesLength - swiper.loopedSlides * 2) / swiper.params.slidesPerGroup)\n      : swiper.snapGrid.length;\n    if (swiper.params.loop) {\n      current = Math.ceil(\n        (swiper.activeIndex - swiper.loopedSlides) / swiper.params.slidesPerGroup,\n      );\n      if (current > slidesLength - 1 - swiper.loopedSlides * 2) {\n        current -= slidesLength - swiper.loopedSlides * 2;\n      }\n      if (current > total - 1) current -= total;\n      if (current < 0 && swiper.params.paginationType !== 'bullets') current = total + current;\n    } else if (typeof swiper.snapIndex !== 'undefined') {\n      current = swiper.snapIndex;\n    } else {\n      current = swiper.activeIndex || 0;\n    }\n    // Types\n    if (\n      params.type === 'bullets' &&\n      swiper.pagination.bullets &&\n      swiper.pagination.bullets.length > 0\n    ) {\n      const bullets = swiper.pagination.bullets;\n      let firstIndex;\n      let lastIndex;\n      let midIndex;\n      if (params.dynamicBullets) {\n        swiper.pagination.bulletSize = bullets\n          .eq(0)\n          [swiper.isHorizontal() ? 'outerWidth' : 'outerHeight'](true);\n        $el.css(\n          swiper.isHorizontal() ? 'width' : 'height',\n          `${swiper.pagination.bulletSize * (params.dynamicMainBullets + 4)}px`,\n        );\n        if (params.dynamicMainBullets > 1 && swiper.previousIndex !== undefined) {\n          swiper.pagination.dynamicBulletIndex += current - swiper.previousIndex;\n          if (swiper.pagination.dynamicBulletIndex > params.dynamicMainBullets - 1) {\n            swiper.pagination.dynamicBulletIndex = params.dynamicMainBullets - 1;\n          } else if (swiper.pagination.dynamicBulletIndex < 0) {\n            swiper.pagination.dynamicBulletIndex = 0;\n          }\n        }\n        firstIndex = current - swiper.pagination.dynamicBulletIndex;\n        lastIndex = firstIndex + (Math.min(bullets.length, params.dynamicMainBullets) - 1);\n        midIndex = (lastIndex + firstIndex) / 2;\n      }\n      bullets.removeClass(\n        `${params.bulletActiveClass} ${params.bulletActiveClass}-next ${params.bulletActiveClass}-next-next ${params.bulletActiveClass}-prev ${params.bulletActiveClass}-prev-prev ${params.bulletActiveClass}-main`,\n      );\n      if ($el.length > 1) {\n        bullets.each((bullet) => {\n          const $bullet = $(bullet);\n          const bulletIndex = $bullet.index();\n          if (bulletIndex === current) {\n            $bullet.addClass(params.bulletActiveClass);\n          }\n          if (params.dynamicBullets) {\n            if (bulletIndex >= firstIndex && bulletIndex <= lastIndex) {\n              $bullet.addClass(`${params.bulletActiveClass}-main`);\n            }\n            if (bulletIndex === firstIndex) {\n              $bullet\n                .prev()\n                .addClass(`${params.bulletActiveClass}-prev`)\n                .prev()\n                .addClass(`${params.bulletActiveClass}-prev-prev`);\n            }\n            if (bulletIndex === lastIndex) {\n              $bullet\n                .next()\n                .addClass(`${params.bulletActiveClass}-next`)\n                .next()\n                .addClass(`${params.bulletActiveClass}-next-next`);\n            }\n          }\n        });\n      } else {\n        const $bullet = bullets.eq(current);\n        const bulletIndex = $bullet.index();\n        $bullet.addClass(params.bulletActiveClass);\n        if (params.dynamicBullets) {\n          const $firstDisplayedBullet = bullets.eq(firstIndex);\n          const $lastDisplayedBullet = bullets.eq(lastIndex);\n          for (let i = firstIndex; i <= lastIndex; i += 1) {\n            bullets.eq(i).addClass(`${params.bulletActiveClass}-main`);\n          }\n          if (swiper.params.loop) {\n            if (bulletIndex >= bullets.length - params.dynamicMainBullets) {\n              for (let i = params.dynamicMainBullets; i >= 0; i -= 1) {\n                bullets.eq(bullets.length - i).addClass(`${params.bulletActiveClass}-main`);\n              }\n              bullets\n                .eq(bullets.length - params.dynamicMainBullets - 1)\n                .addClass(`${params.bulletActiveClass}-prev`);\n            } else {\n              $firstDisplayedBullet\n                .prev()\n                .addClass(`${params.bulletActiveClass}-prev`)\n                .prev()\n                .addClass(`${params.bulletActiveClass}-prev-prev`);\n              $lastDisplayedBullet\n                .next()\n                .addClass(`${params.bulletActiveClass}-next`)\n                .next()\n                .addClass(`${params.bulletActiveClass}-next-next`);\n            }\n          } else {\n            $firstDisplayedBullet\n              .prev()\n              .addClass(`${params.bulletActiveClass}-prev`)\n              .prev()\n              .addClass(`${params.bulletActiveClass}-prev-prev`);\n            $lastDisplayedBullet\n              .next()\n              .addClass(`${params.bulletActiveClass}-next`)\n              .next()\n              .addClass(`${params.bulletActiveClass}-next-next`);\n          }\n        }\n      }\n      if (params.dynamicBullets) {\n        const dynamicBulletsLength = Math.min(bullets.length, params.dynamicMainBullets + 4);\n        const bulletsOffset =\n          (swiper.pagination.bulletSize * dynamicBulletsLength - swiper.pagination.bulletSize) / 2 -\n          midIndex * swiper.pagination.bulletSize;\n        const offsetProp = rtl ? 'right' : 'left';\n        bullets.css(swiper.isHorizontal() ? offsetProp : 'top', `${bulletsOffset}px`);\n      }\n    }\n    if (params.type === 'fraction') {\n      $el.find(`.${params.currentClass}`).text(params.formatFractionCurrent(current + 1));\n      $el.find(`.${params.totalClass}`).text(params.formatFractionTotal(total));\n    }\n    if (params.type === 'progressbar') {\n      let progressbarDirection;\n      if (params.progressbarOpposite) {\n        progressbarDirection = swiper.isHorizontal() ? 'vertical' : 'horizontal';\n      } else {\n        progressbarDirection = swiper.isHorizontal() ? 'horizontal' : 'vertical';\n      }\n      const scale = (current + 1) / total;\n      let scaleX = 1;\n      let scaleY = 1;\n      if (progressbarDirection === 'horizontal') {\n        scaleX = scale;\n      } else {\n        scaleY = scale;\n      }\n      $el\n        .find(`.${params.progressbarFillClass}`)\n        .transform(`translate3d(0,0,0) scaleX(${scaleX}) scaleY(${scaleY})`)\n        .transition(swiper.params.speed);\n    }\n    if (params.type === 'custom' && params.renderCustom) {\n      $el.html(params.renderCustom(swiper, current + 1, total));\n      swiper.emit('paginationRender', $el[0]);\n    } else {\n      swiper.emit('paginationUpdate', $el[0]);\n    }\n    $el[swiper.params.watchOverflow && swiper.isLocked ? 'addClass' : 'removeClass'](\n      params.lockClass,\n    );\n  },\n  render() {\n    // Render Container\n    const swiper = this;\n    const params = swiper.params.pagination;\n    if (\n      !params.el ||\n      !swiper.pagination.el ||\n      !swiper.pagination.$el ||\n      swiper.pagination.$el.length === 0\n    )\n      return;\n    const slidesLength =\n      swiper.virtual && swiper.params.virtual.enabled\n        ? swiper.virtual.slides.length\n        : swiper.slides.length;\n\n    const $el = swiper.pagination.$el;\n    let paginationHTML = '';\n    if (params.type === 'bullets') {\n      let numberOfBullets = swiper.params.loop\n        ? Math.ceil((slidesLength - swiper.loopedSlides * 2) / swiper.params.slidesPerGroup)\n        : swiper.snapGrid.length;\n      if (swiper.params.freeMode && !swiper.params.loop && numberOfBullets > slidesLength) {\n        numberOfBullets = slidesLength;\n      }\n      for (let i = 0; i < numberOfBullets; i += 1) {\n        if (params.renderBullet) {\n          paginationHTML += params.renderBullet.call(swiper, i, params.bulletClass);\n        } else {\n          paginationHTML += `<${params.bulletElement} class=\"${params.bulletClass}\"></${params.bulletElement}>`;\n        }\n      }\n      $el.html(paginationHTML);\n      swiper.pagination.bullets = $el.find(`.${params.bulletClass.replace(/ /g, '.')}`);\n    }\n    if (params.type === 'fraction') {\n      if (params.renderFraction) {\n        paginationHTML = params.renderFraction.call(swiper, params.currentClass, params.totalClass);\n      } else {\n        paginationHTML =\n          `<span class=\"${params.currentClass}\"></span>` +\n          ' / ' +\n          `<span class=\"${params.totalClass}\"></span>`;\n      }\n      $el.html(paginationHTML);\n    }\n    if (params.type === 'progressbar') {\n      if (params.renderProgressbar) {\n        paginationHTML = params.renderProgressbar.call(swiper, params.progressbarFillClass);\n      } else {\n        paginationHTML = `<span class=\"${params.progressbarFillClass}\"></span>`;\n      }\n      $el.html(paginationHTML);\n    }\n    if (params.type !== 'custom') {\n      swiper.emit('paginationRender', swiper.pagination.$el[0]);\n    }\n  },\n  init() {\n    const swiper = this;\n    const params = swiper.params.pagination;\n    if (!params.el) return;\n\n    let $el = $(params.el);\n    if ($el.length === 0) return;\n\n    if (swiper.params.uniqueNavElements && typeof params.el === 'string' && $el.length > 1) {\n      $el = swiper.$el.find(params.el);\n    }\n\n    if (params.type === 'bullets' && params.clickable) {\n      $el.addClass(params.clickableClass);\n    }\n\n    $el.addClass(params.modifierClass + params.type);\n\n    if (params.type === 'bullets' && params.dynamicBullets) {\n      $el.addClass(`${params.modifierClass}${params.type}-dynamic`);\n      swiper.pagination.dynamicBulletIndex = 0;\n      if (params.dynamicMainBullets < 1) {\n        params.dynamicMainBullets = 1;\n      }\n    }\n    if (params.type === 'progressbar' && params.progressbarOpposite) {\n      $el.addClass(params.progressbarOppositeClass);\n    }\n\n    if (params.clickable) {\n      $el.on('click', `.${params.bulletClass.replace(/ /g, '.')}`, function onClick(e) {\n        e.preventDefault();\n        let index = $(this).index() * swiper.params.slidesPerGroup;\n        if (swiper.params.loop) index += swiper.loopedSlides;\n        swiper.slideTo(index);\n      });\n    }\n\n    extend(swiper.pagination, {\n      $el,\n      el: $el[0],\n    });\n  },\n  destroy() {\n    const swiper = this;\n    const params = swiper.params.pagination;\n    if (\n      !params.el ||\n      !swiper.pagination.el ||\n      !swiper.pagination.$el ||\n      swiper.pagination.$el.length === 0\n    )\n      return;\n    const $el = swiper.pagination.$el;\n\n    $el.removeClass(params.hiddenClass);\n    $el.removeClass(params.modifierClass + params.type);\n    if (swiper.pagination.bullets) swiper.pagination.bullets.removeClass(params.bulletActiveClass);\n    if (params.clickable) {\n      $el.off('click', `.${params.bulletClass.replace(/ /g, '.')}`);\n    }\n  },\n};\n\nexport default {\n  name: 'pagination',\n  params: {\n    pagination: {\n      el: null,\n      bulletElement: 'span',\n      clickable: false,\n      hideOnClick: false,\n      renderBullet: null,\n      renderProgressbar: null,\n      renderFraction: null,\n      renderCustom: null,\n      progressbarOpposite: false,\n      type: 'bullets', // 'bullets' or 'progressbar' or 'fraction' or 'custom'\n      dynamicBullets: false,\n      dynamicMainBullets: 1,\n      formatFractionCurrent: (number) => number,\n      formatFractionTotal: (number) => number,\n      bulletClass: 'swiper-pagination-bullet',\n      bulletActiveClass: 'swiper-pagination-bullet-active',\n      modifierClass: 'swiper-pagination-', // NEW\n      currentClass: 'swiper-pagination-current',\n      totalClass: 'swiper-pagination-total',\n      hiddenClass: 'swiper-pagination-hidden',\n      progressbarFillClass: 'swiper-pagination-progressbar-fill',\n      progressbarOppositeClass: 'swiper-pagination-progressbar-opposite',\n      clickableClass: 'swiper-pagination-clickable', // NEW\n      lockClass: 'swiper-pagination-lock',\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      pagination: {\n        dynamicBulletIndex: 0,\n        ...Pagination,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      swiper.pagination.init();\n      swiper.pagination.render();\n      swiper.pagination.update();\n    },\n    activeIndexChange(swiper) {\n      if (swiper.params.loop) {\n        swiper.pagination.update();\n      } else if (typeof swiper.snapIndex === 'undefined') {\n        swiper.pagination.update();\n      }\n    },\n    snapIndexChange(swiper) {\n      if (!swiper.params.loop) {\n        swiper.pagination.update();\n      }\n    },\n    slidesLengthChange(swiper) {\n      if (swiper.params.loop) {\n        swiper.pagination.render();\n        swiper.pagination.update();\n      }\n    },\n    snapGridLengthChange(swiper) {\n      if (!swiper.params.loop) {\n        swiper.pagination.render();\n        swiper.pagination.update();\n      }\n    },\n    destroy(swiper) {\n      swiper.pagination.destroy();\n    },\n    click(swiper, e) {\n      const targetEl = e.target;\n      if (\n        swiper.params.pagination.el &&\n        swiper.params.pagination.hideOnClick &&\n        swiper.pagination.$el.length > 0 &&\n        !$(targetEl).hasClass(swiper.params.pagination.bulletClass)\n      ) {\n        if (\n          swiper.navigation &&\n          ((swiper.navigation.nextEl && targetEl === swiper.navigation.nextEl) ||\n            (swiper.navigation.prevEl && targetEl === swiper.navigation.prevEl))\n        )\n          return;\n        const isHidden = swiper.pagination.$el.hasClass(swiper.params.pagination.hiddenClass);\n        if (isHidden === true) {\n          swiper.emit('paginationShow');\n        } else {\n          swiper.emit('paginationHide');\n        }\n        swiper.pagination.$el.toggleClass(swiper.params.pagination.hiddenClass);\n      }\n    },\n  },\n};\n","import { getDocument } from 'ssr-window';\nimport $ from '../../utils/dom';\nimport { extend, nextTick, bindModuleMethods } from '../../utils/utils';\n\nconst Scrollbar = {\n  setTranslate() {\n    const swiper = this;\n    if (!swiper.params.scrollbar.el || !swiper.scrollbar.el) return;\n    const { scrollbar, rtlTranslate: rtl, progress } = swiper;\n    const { dragSize, trackSize, $dragEl, $el } = scrollbar;\n    const params = swiper.params.scrollbar;\n\n    let newSize = dragSize;\n    let newPos = (trackSize - dragSize) * progress;\n    if (rtl) {\n      newPos = -newPos;\n      if (newPos > 0) {\n        newSize = dragSize - newPos;\n        newPos = 0;\n      } else if (-newPos + dragSize > trackSize) {\n        newSize = trackSize + newPos;\n      }\n    } else if (newPos < 0) {\n      newSize = dragSize + newPos;\n      newPos = 0;\n    } else if (newPos + dragSize > trackSize) {\n      newSize = trackSize - newPos;\n    }\n    if (swiper.isHorizontal()) {\n      $dragEl.transform(`translate3d(${newPos}px, 0, 0)`);\n      $dragEl[0].style.width = `${newSize}px`;\n    } else {\n      $dragEl.transform(`translate3d(0px, ${newPos}px, 0)`);\n      $dragEl[0].style.height = `${newSize}px`;\n    }\n    if (params.hide) {\n      clearTimeout(swiper.scrollbar.timeout);\n      $el[0].style.opacity = 1;\n      swiper.scrollbar.timeout = setTimeout(() => {\n        $el[0].style.opacity = 0;\n        $el.transition(400);\n      }, 1000);\n    }\n  },\n  setTransition(duration) {\n    const swiper = this;\n    if (!swiper.params.scrollbar.el || !swiper.scrollbar.el) return;\n    swiper.scrollbar.$dragEl.transition(duration);\n  },\n  updateSize() {\n    const swiper = this;\n    if (!swiper.params.scrollbar.el || !swiper.scrollbar.el) return;\n\n    const { scrollbar } = swiper;\n    const { $dragEl, $el } = scrollbar;\n\n    $dragEl[0].style.width = '';\n    $dragEl[0].style.height = '';\n    const trackSize = swiper.isHorizontal() ? $el[0].offsetWidth : $el[0].offsetHeight;\n\n    const divider = swiper.size / swiper.virtualSize;\n    const moveDivider = divider * (trackSize / swiper.size);\n    let dragSize;\n    if (swiper.params.scrollbar.dragSize === 'auto') {\n      dragSize = trackSize * divider;\n    } else {\n      dragSize = parseInt(swiper.params.scrollbar.dragSize, 10);\n    }\n\n    if (swiper.isHorizontal()) {\n      $dragEl[0].style.width = `${dragSize}px`;\n    } else {\n      $dragEl[0].style.height = `${dragSize}px`;\n    }\n\n    if (divider >= 1) {\n      $el[0].style.display = 'none';\n    } else {\n      $el[0].style.display = '';\n    }\n    if (swiper.params.scrollbar.hide) {\n      $el[0].style.opacity = 0;\n    }\n    extend(scrollbar, {\n      trackSize,\n      divider,\n      moveDivider,\n      dragSize,\n    });\n    scrollbar.$el[swiper.params.watchOverflow && swiper.isLocked ? 'addClass' : 'removeClass'](\n      swiper.params.scrollbar.lockClass,\n    );\n  },\n  getPointerPosition(e) {\n    const swiper = this;\n    if (swiper.isHorizontal()) {\n      return e.type === 'touchstart' || e.type === 'touchmove'\n        ? e.targetTouches[0].clientX\n        : e.clientX;\n    }\n    return e.type === 'touchstart' || e.type === 'touchmove'\n      ? e.targetTouches[0].clientY\n      : e.clientY;\n  },\n  setDragPosition(e) {\n    const swiper = this;\n    const { scrollbar, rtlTranslate: rtl } = swiper;\n    const { $el, dragSize, trackSize, dragStartPos } = scrollbar;\n\n    let positionRatio;\n    positionRatio =\n      (scrollbar.getPointerPosition(e) -\n        $el.offset()[swiper.isHorizontal() ? 'left' : 'top'] -\n        (dragStartPos !== null ? dragStartPos : dragSize / 2)) /\n      (trackSize - dragSize);\n    positionRatio = Math.max(Math.min(positionRatio, 1), 0);\n    if (rtl) {\n      positionRatio = 1 - positionRatio;\n    }\n\n    const position =\n      swiper.minTranslate() + (swiper.maxTranslate() - swiper.minTranslate()) * positionRatio;\n\n    swiper.updateProgress(position);\n    swiper.setTranslate(position);\n    swiper.updateActiveIndex();\n    swiper.updateSlidesClasses();\n  },\n  onDragStart(e) {\n    const swiper = this;\n    const params = swiper.params.scrollbar;\n    const { scrollbar, $wrapperEl } = swiper;\n    const { $el, $dragEl } = scrollbar;\n    swiper.scrollbar.isTouched = true;\n    swiper.scrollbar.dragStartPos =\n      e.target === $dragEl[0] || e.target === $dragEl\n        ? scrollbar.getPointerPosition(e) -\n          e.target.getBoundingClientRect()[swiper.isHorizontal() ? 'left' : 'top']\n        : null;\n    e.preventDefault();\n    e.stopPropagation();\n\n    $wrapperEl.transition(100);\n    $dragEl.transition(100);\n    scrollbar.setDragPosition(e);\n\n    clearTimeout(swiper.scrollbar.dragTimeout);\n\n    $el.transition(0);\n    if (params.hide) {\n      $el.css('opacity', 1);\n    }\n    if (swiper.params.cssMode) {\n      swiper.$wrapperEl.css('scroll-snap-type', 'none');\n    }\n    swiper.emit('scrollbarDragStart', e);\n  },\n  onDragMove(e) {\n    const swiper = this;\n    const { scrollbar, $wrapperEl } = swiper;\n    const { $el, $dragEl } = scrollbar;\n\n    if (!swiper.scrollbar.isTouched) return;\n    if (e.preventDefault) e.preventDefault();\n    else e.returnValue = false;\n    scrollbar.setDragPosition(e);\n    $wrapperEl.transition(0);\n    $el.transition(0);\n    $dragEl.transition(0);\n    swiper.emit('scrollbarDragMove', e);\n  },\n  onDragEnd(e) {\n    const swiper = this;\n\n    const params = swiper.params.scrollbar;\n    const { scrollbar, $wrapperEl } = swiper;\n    const { $el } = scrollbar;\n\n    if (!swiper.scrollbar.isTouched) return;\n    swiper.scrollbar.isTouched = false;\n    if (swiper.params.cssMode) {\n      swiper.$wrapperEl.css('scroll-snap-type', '');\n      $wrapperEl.transition('');\n    }\n    if (params.hide) {\n      clearTimeout(swiper.scrollbar.dragTimeout);\n      swiper.scrollbar.dragTimeout = nextTick(() => {\n        $el.css('opacity', 0);\n        $el.transition(400);\n      }, 1000);\n    }\n    swiper.emit('scrollbarDragEnd', e);\n    if (params.snapOnRelease) {\n      swiper.slideToClosest();\n    }\n  },\n  enableDraggable() {\n    const swiper = this;\n    if (!swiper.params.scrollbar.el) return;\n    const document = getDocument();\n    const { scrollbar, touchEventsTouch, touchEventsDesktop, params, support } = swiper;\n    const $el = scrollbar.$el;\n    const target = $el[0];\n    const activeListener =\n      support.passiveListener && params.passiveListeners\n        ? { passive: false, capture: false }\n        : false;\n    const passiveListener =\n      support.passiveListener && params.passiveListeners\n        ? { passive: true, capture: false }\n        : false;\n    if (!target) return;\n    if (!support.touch) {\n      target.addEventListener(\n        touchEventsDesktop.start,\n        swiper.scrollbar.onDragStart,\n        activeListener,\n      );\n      document.addEventListener(\n        touchEventsDesktop.move,\n        swiper.scrollbar.onDragMove,\n        activeListener,\n      );\n      document.addEventListener(\n        touchEventsDesktop.end,\n        swiper.scrollbar.onDragEnd,\n        passiveListener,\n      );\n    } else {\n      target.addEventListener(touchEventsTouch.start, swiper.scrollbar.onDragStart, activeListener);\n      target.addEventListener(touchEventsTouch.move, swiper.scrollbar.onDragMove, activeListener);\n      target.addEventListener(touchEventsTouch.end, swiper.scrollbar.onDragEnd, passiveListener);\n    }\n  },\n  disableDraggable() {\n    const swiper = this;\n    if (!swiper.params.scrollbar.el) return;\n    const document = getDocument();\n    const { scrollbar, touchEventsTouch, touchEventsDesktop, params, support } = swiper;\n    const $el = scrollbar.$el;\n    const target = $el[0];\n    const activeListener =\n      support.passiveListener && params.passiveListeners\n        ? { passive: false, capture: false }\n        : false;\n    const passiveListener =\n      support.passiveListener && params.passiveListeners\n        ? { passive: true, capture: false }\n        : false;\n    if (!target) return;\n    if (!support.touch) {\n      target.removeEventListener(\n        touchEventsDesktop.start,\n        swiper.scrollbar.onDragStart,\n        activeListener,\n      );\n      document.removeEventListener(\n        touchEventsDesktop.move,\n        swiper.scrollbar.onDragMove,\n        activeListener,\n      );\n      document.removeEventListener(\n        touchEventsDesktop.end,\n        swiper.scrollbar.onDragEnd,\n        passiveListener,\n      );\n    } else {\n      target.removeEventListener(\n        touchEventsTouch.start,\n        swiper.scrollbar.onDragStart,\n        activeListener,\n      );\n      target.removeEventListener(\n        touchEventsTouch.move,\n        swiper.scrollbar.onDragMove,\n        activeListener,\n      );\n      target.removeEventListener(touchEventsTouch.end, swiper.scrollbar.onDragEnd, passiveListener);\n    }\n  },\n  init() {\n    const swiper = this;\n    if (!swiper.params.scrollbar.el) return;\n    const { scrollbar, $el: $swiperEl } = swiper;\n    const params = swiper.params.scrollbar;\n\n    let $el = $(params.el);\n    if (\n      swiper.params.uniqueNavElements &&\n      typeof params.el === 'string' &&\n      $el.length > 1 &&\n      $swiperEl.find(params.el).length === 1\n    ) {\n      $el = $swiperEl.find(params.el);\n    }\n\n    let $dragEl = $el.find(`.${swiper.params.scrollbar.dragClass}`);\n    if ($dragEl.length === 0) {\n      $dragEl = $(`<div class=\"${swiper.params.scrollbar.dragClass}\"></div>`);\n      $el.append($dragEl);\n    }\n\n    extend(scrollbar, {\n      $el,\n      el: $el[0],\n      $dragEl,\n      dragEl: $dragEl[0],\n    });\n\n    if (params.draggable) {\n      scrollbar.enableDraggable();\n    }\n  },\n  destroy() {\n    const swiper = this;\n    swiper.scrollbar.disableDraggable();\n  },\n};\n\nexport default {\n  name: 'scrollbar',\n  params: {\n    scrollbar: {\n      el: null,\n      dragSize: 'auto',\n      hide: false,\n      draggable: false,\n      snapOnRelease: true,\n      lockClass: 'swiper-scrollbar-lock',\n      dragClass: 'swiper-scrollbar-drag',\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      scrollbar: {\n        isTouched: false,\n        timeout: null,\n        dragTimeout: null,\n        ...Scrollbar,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      swiper.scrollbar.init();\n      swiper.scrollbar.updateSize();\n      swiper.scrollbar.setTranslate();\n    },\n    update(swiper) {\n      swiper.scrollbar.updateSize();\n    },\n    resize(swiper) {\n      swiper.scrollbar.updateSize();\n    },\n    observerUpdate(swiper) {\n      swiper.scrollbar.updateSize();\n    },\n    setTranslate(swiper) {\n      swiper.scrollbar.setTranslate();\n    },\n    setTransition(swiper, duration) {\n      swiper.scrollbar.setTransition(duration);\n    },\n    destroy(swiper) {\n      swiper.scrollbar.destroy();\n    },\n  },\n};\n","import $ from '../../utils/dom';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst Parallax = {\n  setTransform(el, progress) {\n    const swiper = this;\n    const { rtl } = swiper;\n\n    const $el = $(el);\n    const rtlFactor = rtl ? -1 : 1;\n\n    const p = $el.attr('data-swiper-parallax') || '0';\n    let x = $el.attr('data-swiper-parallax-x');\n    let y = $el.attr('data-swiper-parallax-y');\n    const scale = $el.attr('data-swiper-parallax-scale');\n    const opacity = $el.attr('data-swiper-parallax-opacity');\n\n    if (x || y) {\n      x = x || '0';\n      y = y || '0';\n    } else if (swiper.isHorizontal()) {\n      x = p;\n      y = '0';\n    } else {\n      y = p;\n      x = '0';\n    }\n\n    if (x.indexOf('%') >= 0) {\n      x = `${parseInt(x, 10) * progress * rtlFactor}%`;\n    } else {\n      x = `${x * progress * rtlFactor}px`;\n    }\n    if (y.indexOf('%') >= 0) {\n      y = `${parseInt(y, 10) * progress}%`;\n    } else {\n      y = `${y * progress}px`;\n    }\n\n    if (typeof opacity !== 'undefined' && opacity !== null) {\n      const currentOpacity = opacity - (opacity - 1) * (1 - Math.abs(progress));\n      $el[0].style.opacity = currentOpacity;\n    }\n    if (typeof scale === 'undefined' || scale === null) {\n      $el.transform(`translate3d(${x}, ${y}, 0px)`);\n    } else {\n      const currentScale = scale - (scale - 1) * (1 - Math.abs(progress));\n      $el.transform(`translate3d(${x}, ${y}, 0px) scale(${currentScale})`);\n    }\n  },\n  setTranslate() {\n    const swiper = this;\n    const { $el, slides, progress, snapGrid } = swiper;\n    $el\n      .children(\n        '[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y], [data-swiper-parallax-opacity], [data-swiper-parallax-scale]',\n      )\n      .each((el) => {\n        swiper.parallax.setTransform(el, progress);\n      });\n    slides.each((slideEl, slideIndex) => {\n      let slideProgress = slideEl.progress;\n      if (swiper.params.slidesPerGroup > 1 && swiper.params.slidesPerView !== 'auto') {\n        slideProgress += Math.ceil(slideIndex / 2) - progress * (snapGrid.length - 1);\n      }\n      slideProgress = Math.min(Math.max(slideProgress, -1), 1);\n      $(slideEl)\n        .find(\n          '[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y], [data-swiper-parallax-opacity], [data-swiper-parallax-scale]',\n        )\n        .each((el) => {\n          swiper.parallax.setTransform(el, slideProgress);\n        });\n    });\n  },\n  setTransition(duration = this.params.speed) {\n    const swiper = this;\n    const { $el } = swiper;\n    $el\n      .find(\n        '[data-swiper-parallax], [data-swiper-parallax-x], [data-swiper-parallax-y], [data-swiper-parallax-opacity], [data-swiper-parallax-scale]',\n      )\n      .each((parallaxEl) => {\n        const $parallaxEl = $(parallaxEl);\n        let parallaxDuration =\n          parseInt($parallaxEl.attr('data-swiper-parallax-duration'), 10) || duration;\n        if (duration === 0) parallaxDuration = 0;\n        $parallaxEl.transition(parallaxDuration);\n      });\n  },\n};\n\nexport default {\n  name: 'parallax',\n  params: {\n    parallax: {\n      enabled: false,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      parallax: {\n        ...Parallax,\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      if (!swiper.params.parallax.enabled) return;\n      swiper.params.watchSlidesProgress = true;\n      swiper.originalParams.watchSlidesProgress = true;\n    },\n    init(swiper) {\n      if (!swiper.params.parallax.enabled) return;\n      swiper.parallax.setTranslate();\n    },\n    setTranslate(swiper) {\n      if (!swiper.params.parallax.enabled) return;\n      swiper.parallax.setTranslate();\n    },\n    setTransition(swiper, duration) {\n      if (!swiper.params.parallax.enabled) return;\n      swiper.parallax.setTransition(duration);\n    },\n  },\n};\n","import { getWindow } from 'ssr-window';\nimport $ from '../../utils/dom';\nimport { bindModuleMethods, getTranslate } from '../../utils/utils';\n\nconst Zoom = {\n  // Calc Scale From Multi-touches\n  getDistanceBetweenTouches(e) {\n    if (e.targetTouches.length < 2) return 1;\n    const x1 = e.targetTouches[0].pageX;\n    const y1 = e.targetTouches[0].pageY;\n    const x2 = e.targetTouches[1].pageX;\n    const y2 = e.targetTouches[1].pageY;\n    const distance = Math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2);\n    return distance;\n  },\n  // Events\n  onGestureStart(e) {\n    const swiper = this;\n    const support = swiper.support;\n    const params = swiper.params.zoom;\n    const zoom = swiper.zoom;\n    const { gesture } = zoom;\n    zoom.fakeGestureTouched = false;\n    zoom.fakeGestureMoved = false;\n    if (!support.gestures) {\n      if (e.type !== 'touchstart' || (e.type === 'touchstart' && e.targetTouches.length < 2)) {\n        return;\n      }\n      zoom.fakeGestureTouched = true;\n      gesture.scaleStart = Zoom.getDistanceBetweenTouches(e);\n    }\n    if (!gesture.$slideEl || !gesture.$slideEl.length) {\n      gesture.$slideEl = $(e.target).closest(`.${swiper.params.slideClass}`);\n      if (gesture.$slideEl.length === 0) gesture.$slideEl = swiper.slides.eq(swiper.activeIndex);\n      gesture.$imageEl = gesture.$slideEl.find('img, svg, canvas, picture, .swiper-zoom-target');\n      gesture.$imageWrapEl = gesture.$imageEl.parent(`.${params.containerClass}`);\n      gesture.maxRatio = gesture.$imageWrapEl.attr('data-swiper-zoom') || params.maxRatio;\n      if (gesture.$imageWrapEl.length === 0) {\n        gesture.$imageEl = undefined;\n        return;\n      }\n    }\n    if (gesture.$imageEl) {\n      gesture.$imageEl.transition(0);\n    }\n    swiper.zoom.isScaling = true;\n  },\n  onGestureChange(e) {\n    const swiper = this;\n    const support = swiper.support;\n    const params = swiper.params.zoom;\n    const zoom = swiper.zoom;\n    const gesture = zoom.gesture;\n    if (!support.gestures) {\n      if (e.type !== 'touchmove' || (e.type === 'touchmove' && e.targetTouches.length < 2)) {\n        return;\n      }\n      zoom.fakeGestureMoved = true;\n      gesture.scaleMove = Zoom.getDistanceBetweenTouches(e);\n    }\n\n    if (!gesture.$imageEl || gesture.$imageEl.length === 0) {\n      if (e.type === 'gesturechange') zoom.onGestureStart(e);\n      return;\n    }\n    if (support.gestures) {\n      zoom.scale = e.scale * zoom.currentScale;\n    } else {\n      zoom.scale = (gesture.scaleMove / gesture.scaleStart) * zoom.currentScale;\n    }\n    if (zoom.scale > gesture.maxRatio) {\n      zoom.scale = gesture.maxRatio - 1 + (zoom.scale - gesture.maxRatio + 1) ** 0.5;\n    }\n    if (zoom.scale < params.minRatio) {\n      zoom.scale = params.minRatio + 1 - (params.minRatio - zoom.scale + 1) ** 0.5;\n    }\n    gesture.$imageEl.transform(`translate3d(0,0,0) scale(${zoom.scale})`);\n  },\n  onGestureEnd(e) {\n    const swiper = this;\n    const device = swiper.device;\n    const support = swiper.support;\n    const params = swiper.params.zoom;\n    const zoom = swiper.zoom;\n    const { gesture } = zoom;\n    if (!support.gestures) {\n      if (!zoom.fakeGestureTouched || !zoom.fakeGestureMoved) {\n        return;\n      }\n      if (\n        e.type !== 'touchend' ||\n        (e.type === 'touchend' && e.changedTouches.length < 2 && !device.android)\n      ) {\n        return;\n      }\n      zoom.fakeGestureTouched = false;\n      zoom.fakeGestureMoved = false;\n    }\n    if (!gesture.$imageEl || gesture.$imageEl.length === 0) return;\n    zoom.scale = Math.max(Math.min(zoom.scale, gesture.maxRatio), params.minRatio);\n    gesture.$imageEl\n      .transition(swiper.params.speed)\n      .transform(`translate3d(0,0,0) scale(${zoom.scale})`);\n    zoom.currentScale = zoom.scale;\n    zoom.isScaling = false;\n    if (zoom.scale === 1) gesture.$slideEl = undefined;\n  },\n  onTouchStart(e) {\n    const swiper = this;\n    const device = swiper.device;\n    const zoom = swiper.zoom;\n    const { gesture, image } = zoom;\n    if (!gesture.$imageEl || gesture.$imageEl.length === 0) return;\n    if (image.isTouched) return;\n    if (device.android && e.cancelable) e.preventDefault();\n    image.isTouched = true;\n    image.touchesStart.x = e.type === 'touchstart' ? e.targetTouches[0].pageX : e.pageX;\n    image.touchesStart.y = e.type === 'touchstart' ? e.targetTouches[0].pageY : e.pageY;\n  },\n  onTouchMove(e) {\n    const swiper = this;\n    const zoom = swiper.zoom;\n    const { gesture, image, velocity } = zoom;\n    if (!gesture.$imageEl || gesture.$imageEl.length === 0) return;\n    swiper.allowClick = false;\n    if (!image.isTouched || !gesture.$slideEl) return;\n\n    if (!image.isMoved) {\n      image.width = gesture.$imageEl[0].offsetWidth;\n      image.height = gesture.$imageEl[0].offsetHeight;\n      image.startX = getTranslate(gesture.$imageWrapEl[0], 'x') || 0;\n      image.startY = getTranslate(gesture.$imageWrapEl[0], 'y') || 0;\n      gesture.slideWidth = gesture.$slideEl[0].offsetWidth;\n      gesture.slideHeight = gesture.$slideEl[0].offsetHeight;\n      gesture.$imageWrapEl.transition(0);\n      if (swiper.rtl) {\n        image.startX = -image.startX;\n        image.startY = -image.startY;\n      }\n    }\n    // Define if we need image drag\n    const scaledWidth = image.width * zoom.scale;\n    const scaledHeight = image.height * zoom.scale;\n\n    if (scaledWidth < gesture.slideWidth && scaledHeight < gesture.slideHeight) return;\n\n    image.minX = Math.min(gesture.slideWidth / 2 - scaledWidth / 2, 0);\n    image.maxX = -image.minX;\n    image.minY = Math.min(gesture.slideHeight / 2 - scaledHeight / 2, 0);\n    image.maxY = -image.minY;\n\n    image.touchesCurrent.x = e.type === 'touchmove' ? e.targetTouches[0].pageX : e.pageX;\n    image.touchesCurrent.y = e.type === 'touchmove' ? e.targetTouches[0].pageY : e.pageY;\n\n    if (!image.isMoved && !zoom.isScaling) {\n      if (\n        swiper.isHorizontal() &&\n        ((Math.floor(image.minX) === Math.floor(image.startX) &&\n          image.touchesCurrent.x < image.touchesStart.x) ||\n          (Math.floor(image.maxX) === Math.floor(image.startX) &&\n            image.touchesCurrent.x > image.touchesStart.x))\n      ) {\n        image.isTouched = false;\n        return;\n      }\n      if (\n        !swiper.isHorizontal() &&\n        ((Math.floor(image.minY) === Math.floor(image.startY) &&\n          image.touchesCurrent.y < image.touchesStart.y) ||\n          (Math.floor(image.maxY) === Math.floor(image.startY) &&\n            image.touchesCurrent.y > image.touchesStart.y))\n      ) {\n        image.isTouched = false;\n        return;\n      }\n    }\n    if (e.cancelable) {\n      e.preventDefault();\n    }\n    e.stopPropagation();\n\n    image.isMoved = true;\n    image.currentX = image.touchesCurrent.x - image.touchesStart.x + image.startX;\n    image.currentY = image.touchesCurrent.y - image.touchesStart.y + image.startY;\n\n    if (image.currentX < image.minX) {\n      image.currentX = image.minX + 1 - (image.minX - image.currentX + 1) ** 0.8;\n    }\n    if (image.currentX > image.maxX) {\n      image.currentX = image.maxX - 1 + (image.currentX - image.maxX + 1) ** 0.8;\n    }\n\n    if (image.currentY < image.minY) {\n      image.currentY = image.minY + 1 - (image.minY - image.currentY + 1) ** 0.8;\n    }\n    if (image.currentY > image.maxY) {\n      image.currentY = image.maxY - 1 + (image.currentY - image.maxY + 1) ** 0.8;\n    }\n\n    // Velocity\n    if (!velocity.prevPositionX) velocity.prevPositionX = image.touchesCurrent.x;\n    if (!velocity.prevPositionY) velocity.prevPositionY = image.touchesCurrent.y;\n    if (!velocity.prevTime) velocity.prevTime = Date.now();\n    velocity.x =\n      (image.touchesCurrent.x - velocity.prevPositionX) / (Date.now() - velocity.prevTime) / 2;\n    velocity.y =\n      (image.touchesCurrent.y - velocity.prevPositionY) / (Date.now() - velocity.prevTime) / 2;\n    if (Math.abs(image.touchesCurrent.x - velocity.prevPositionX) < 2) velocity.x = 0;\n    if (Math.abs(image.touchesCurrent.y - velocity.prevPositionY) < 2) velocity.y = 0;\n    velocity.prevPositionX = image.touchesCurrent.x;\n    velocity.prevPositionY = image.touchesCurrent.y;\n    velocity.prevTime = Date.now();\n\n    gesture.$imageWrapEl.transform(`translate3d(${image.currentX}px, ${image.currentY}px,0)`);\n  },\n  onTouchEnd() {\n    const swiper = this;\n    const zoom = swiper.zoom;\n    const { gesture, image, velocity } = zoom;\n    if (!gesture.$imageEl || gesture.$imageEl.length === 0) return;\n    if (!image.isTouched || !image.isMoved) {\n      image.isTouched = false;\n      image.isMoved = false;\n      return;\n    }\n    image.isTouched = false;\n    image.isMoved = false;\n    let momentumDurationX = 300;\n    let momentumDurationY = 300;\n    const momentumDistanceX = velocity.x * momentumDurationX;\n    const newPositionX = image.currentX + momentumDistanceX;\n    const momentumDistanceY = velocity.y * momentumDurationY;\n    const newPositionY = image.currentY + momentumDistanceY;\n\n    // Fix duration\n    if (velocity.x !== 0)\n      momentumDurationX = Math.abs((newPositionX - image.currentX) / velocity.x);\n    if (velocity.y !== 0)\n      momentumDurationY = Math.abs((newPositionY - image.currentY) / velocity.y);\n    const momentumDuration = Math.max(momentumDurationX, momentumDurationY);\n\n    image.currentX = newPositionX;\n    image.currentY = newPositionY;\n\n    // Define if we need image drag\n    const scaledWidth = image.width * zoom.scale;\n    const scaledHeight = image.height * zoom.scale;\n    image.minX = Math.min(gesture.slideWidth / 2 - scaledWidth / 2, 0);\n    image.maxX = -image.minX;\n    image.minY = Math.min(gesture.slideHeight / 2 - scaledHeight / 2, 0);\n    image.maxY = -image.minY;\n    image.currentX = Math.max(Math.min(image.currentX, image.maxX), image.minX);\n    image.currentY = Math.max(Math.min(image.currentY, image.maxY), image.minY);\n\n    gesture.$imageWrapEl\n      .transition(momentumDuration)\n      .transform(`translate3d(${image.currentX}px, ${image.currentY}px,0)`);\n  },\n  onTransitionEnd() {\n    const swiper = this;\n    const zoom = swiper.zoom;\n    const { gesture } = zoom;\n    if (gesture.$slideEl && swiper.previousIndex !== swiper.activeIndex) {\n      if (gesture.$imageEl) {\n        gesture.$imageEl.transform('translate3d(0,0,0) scale(1)');\n      }\n      if (gesture.$imageWrapEl) {\n        gesture.$imageWrapEl.transform('translate3d(0,0,0)');\n      }\n\n      zoom.scale = 1;\n      zoom.currentScale = 1;\n\n      gesture.$slideEl = undefined;\n      gesture.$imageEl = undefined;\n      gesture.$imageWrapEl = undefined;\n    }\n  },\n  // Toggle Zoom\n  toggle(e) {\n    const swiper = this;\n    const zoom = swiper.zoom;\n\n    if (zoom.scale && zoom.scale !== 1) {\n      // Zoom Out\n      zoom.out();\n    } else {\n      // Zoom In\n      zoom.in(e);\n    }\n  },\n  in(e) {\n    const swiper = this;\n    const window = getWindow();\n\n    const zoom = swiper.zoom;\n    const params = swiper.params.zoom;\n    const { gesture, image } = zoom;\n\n    if (!gesture.$slideEl) {\n      if (swiper.params.virtual && swiper.params.virtual.enabled && swiper.virtual) {\n        gesture.$slideEl = swiper.$wrapperEl.children(`.${swiper.params.slideActiveClass}`);\n      } else {\n        gesture.$slideEl = swiper.slides.eq(swiper.activeIndex);\n      }\n      gesture.$imageEl = gesture.$slideEl.find('img, svg, canvas, picture, .swiper-zoom-target');\n      gesture.$imageWrapEl = gesture.$imageEl.parent(`.${params.containerClass}`);\n    }\n    if (!gesture.$imageEl || gesture.$imageEl.length === 0) return;\n\n    gesture.$slideEl.addClass(`${params.zoomedSlideClass}`);\n\n    let touchX;\n    let touchY;\n    let offsetX;\n    let offsetY;\n    let diffX;\n    let diffY;\n    let translateX;\n    let translateY;\n    let imageWidth;\n    let imageHeight;\n    let scaledWidth;\n    let scaledHeight;\n    let translateMinX;\n    let translateMinY;\n    let translateMaxX;\n    let translateMaxY;\n    let slideWidth;\n    let slideHeight;\n\n    if (typeof image.touchesStart.x === 'undefined' && e) {\n      touchX = e.type === 'touchend' ? e.changedTouches[0].pageX : e.pageX;\n      touchY = e.type === 'touchend' ? e.changedTouches[0].pageY : e.pageY;\n    } else {\n      touchX = image.touchesStart.x;\n      touchY = image.touchesStart.y;\n    }\n\n    zoom.scale = gesture.$imageWrapEl.attr('data-swiper-zoom') || params.maxRatio;\n    zoom.currentScale = gesture.$imageWrapEl.attr('data-swiper-zoom') || params.maxRatio;\n    if (e) {\n      slideWidth = gesture.$slideEl[0].offsetWidth;\n      slideHeight = gesture.$slideEl[0].offsetHeight;\n      offsetX = gesture.$slideEl.offset().left + window.scrollX;\n      offsetY = gesture.$slideEl.offset().top + window.scrollY;\n      diffX = offsetX + slideWidth / 2 - touchX;\n      diffY = offsetY + slideHeight / 2 - touchY;\n\n      imageWidth = gesture.$imageEl[0].offsetWidth;\n      imageHeight = gesture.$imageEl[0].offsetHeight;\n      scaledWidth = imageWidth * zoom.scale;\n      scaledHeight = imageHeight * zoom.scale;\n\n      translateMinX = Math.min(slideWidth / 2 - scaledWidth / 2, 0);\n      translateMinY = Math.min(slideHeight / 2 - scaledHeight / 2, 0);\n      translateMaxX = -translateMinX;\n      translateMaxY = -translateMinY;\n\n      translateX = diffX * zoom.scale;\n      translateY = diffY * zoom.scale;\n\n      if (translateX < translateMinX) {\n        translateX = translateMinX;\n      }\n      if (translateX > translateMaxX) {\n        translateX = translateMaxX;\n      }\n\n      if (translateY < translateMinY) {\n        translateY = translateMinY;\n      }\n      if (translateY > translateMaxY) {\n        translateY = translateMaxY;\n      }\n    } else {\n      translateX = 0;\n      translateY = 0;\n    }\n    gesture.$imageWrapEl\n      .transition(300)\n      .transform(`translate3d(${translateX}px, ${translateY}px,0)`);\n    gesture.$imageEl.transition(300).transform(`translate3d(0,0,0) scale(${zoom.scale})`);\n  },\n  out() {\n    const swiper = this;\n\n    const zoom = swiper.zoom;\n    const params = swiper.params.zoom;\n    const { gesture } = zoom;\n\n    if (!gesture.$slideEl) {\n      if (swiper.params.virtual && swiper.params.virtual.enabled && swiper.virtual) {\n        gesture.$slideEl = swiper.$wrapperEl.children(`.${swiper.params.slideActiveClass}`);\n      } else {\n        gesture.$slideEl = swiper.slides.eq(swiper.activeIndex);\n      }\n      gesture.$imageEl = gesture.$slideEl.find('img, svg, canvas, picture, .swiper-zoom-target');\n      gesture.$imageWrapEl = gesture.$imageEl.parent(`.${params.containerClass}`);\n    }\n    if (!gesture.$imageEl || gesture.$imageEl.length === 0) return;\n\n    zoom.scale = 1;\n    zoom.currentScale = 1;\n    gesture.$imageWrapEl.transition(300).transform('translate3d(0,0,0)');\n    gesture.$imageEl.transition(300).transform('translate3d(0,0,0) scale(1)');\n    gesture.$slideEl.removeClass(`${params.zoomedSlideClass}`);\n    gesture.$slideEl = undefined;\n  },\n\n  toggleGestures(method) {\n    const swiper = this;\n    const zoom = swiper.zoom;\n    const { slideSelector: selector, passiveListener: passive } = zoom;\n    swiper.$wrapperEl[method]('gesturestart', selector, zoom.onGestureStart, passive);\n    swiper.$wrapperEl[method]('gesturechange', selector, zoom.onGestureChange, passive);\n    swiper.$wrapperEl[method]('gestureend', selector, zoom.onGestureEnd, passive);\n  },\n  enableGestures() {\n    if (this.zoom.gesturesEnabled) return;\n    this.zoom.gesturesEnabled = true;\n    this.zoom.toggleGestures('on');\n  },\n  disableGestures() {\n    if (!this.zoom.gesturesEnabled) return;\n    this.zoom.gesturesEnabled = false;\n    this.zoom.toggleGestures('off');\n  },\n  // Attach/Detach Events\n  enable() {\n    const swiper = this;\n    const support = swiper.support;\n    const zoom = swiper.zoom;\n    if (zoom.enabled) return;\n    zoom.enabled = true;\n\n    const passiveListener =\n      swiper.touchEvents.start === 'touchstart' &&\n      support.passiveListener &&\n      swiper.params.passiveListeners\n        ? { passive: true, capture: false }\n        : false;\n    const activeListenerWithCapture = support.passiveListener\n      ? { passive: false, capture: true }\n      : true;\n\n    const slideSelector = `.${swiper.params.slideClass}`;\n\n    swiper.zoom.passiveListener = passiveListener;\n    swiper.zoom.slideSelector = slideSelector;\n\n    // Scale image\n    if (support.gestures) {\n      swiper.$wrapperEl.on(swiper.touchEvents.start, swiper.zoom.enableGestures, passiveListener);\n      swiper.$wrapperEl.on(swiper.touchEvents.end, swiper.zoom.disableGestures, passiveListener);\n    } else if (swiper.touchEvents.start === 'touchstart') {\n      swiper.$wrapperEl.on(\n        swiper.touchEvents.start,\n        slideSelector,\n        zoom.onGestureStart,\n        passiveListener,\n      );\n      swiper.$wrapperEl.on(\n        swiper.touchEvents.move,\n        slideSelector,\n        zoom.onGestureChange,\n        activeListenerWithCapture,\n      );\n      swiper.$wrapperEl.on(\n        swiper.touchEvents.end,\n        slideSelector,\n        zoom.onGestureEnd,\n        passiveListener,\n      );\n      if (swiper.touchEvents.cancel) {\n        swiper.$wrapperEl.on(\n          swiper.touchEvents.cancel,\n          slideSelector,\n          zoom.onGestureEnd,\n          passiveListener,\n        );\n      }\n    }\n\n    // Move image\n    swiper.$wrapperEl.on(\n      swiper.touchEvents.move,\n      `.${swiper.params.zoom.containerClass}`,\n      zoom.onTouchMove,\n      activeListenerWithCapture,\n    );\n  },\n  disable() {\n    const swiper = this;\n    const zoom = swiper.zoom;\n    if (!zoom.enabled) return;\n    const support = swiper.support;\n\n    swiper.zoom.enabled = false;\n\n    const passiveListener =\n      swiper.touchEvents.start === 'touchstart' &&\n      support.passiveListener &&\n      swiper.params.passiveListeners\n        ? { passive: true, capture: false }\n        : false;\n    const activeListenerWithCapture = support.passiveListener\n      ? { passive: false, capture: true }\n      : true;\n\n    const slideSelector = `.${swiper.params.slideClass}`;\n\n    // Scale image\n    if (support.gestures) {\n      swiper.$wrapperEl.off(swiper.touchEvents.start, swiper.zoom.enableGestures, passiveListener);\n      swiper.$wrapperEl.off(swiper.touchEvents.end, swiper.zoom.disableGestures, passiveListener);\n    } else if (swiper.touchEvents.start === 'touchstart') {\n      swiper.$wrapperEl.off(\n        swiper.touchEvents.start,\n        slideSelector,\n        zoom.onGestureStart,\n        passiveListener,\n      );\n      swiper.$wrapperEl.off(\n        swiper.touchEvents.move,\n        slideSelector,\n        zoom.onGestureChange,\n        activeListenerWithCapture,\n      );\n      swiper.$wrapperEl.off(\n        swiper.touchEvents.end,\n        slideSelector,\n        zoom.onGestureEnd,\n        passiveListener,\n      );\n      if (swiper.touchEvents.cancel) {\n        swiper.$wrapperEl.off(\n          swiper.touchEvents.cancel,\n          slideSelector,\n          zoom.onGestureEnd,\n          passiveListener,\n        );\n      }\n    }\n\n    // Move image\n    swiper.$wrapperEl.off(\n      swiper.touchEvents.move,\n      `.${swiper.params.zoom.containerClass}`,\n      zoom.onTouchMove,\n      activeListenerWithCapture,\n    );\n  },\n};\n\nexport default {\n  name: 'zoom',\n  params: {\n    zoom: {\n      enabled: false,\n      maxRatio: 3,\n      minRatio: 1,\n      toggle: true,\n      containerClass: 'swiper-zoom-container',\n      zoomedSlideClass: 'swiper-slide-zoomed',\n    },\n  },\n  create() {\n    const swiper = this;\n\n    bindModuleMethods(swiper, {\n      zoom: {\n        enabled: false,\n        scale: 1,\n        currentScale: 1,\n        isScaling: false,\n        gesture: {\n          $slideEl: undefined,\n          slideWidth: undefined,\n          slideHeight: undefined,\n          $imageEl: undefined,\n          $imageWrapEl: undefined,\n          maxRatio: 3,\n        },\n        image: {\n          isTouched: undefined,\n          isMoved: undefined,\n          currentX: undefined,\n          currentY: undefined,\n          minX: undefined,\n          minY: undefined,\n          maxX: undefined,\n          maxY: undefined,\n          width: undefined,\n          height: undefined,\n          startX: undefined,\n          startY: undefined,\n          touchesStart: {},\n          touchesCurrent: {},\n        },\n        velocity: {\n          x: undefined,\n          y: undefined,\n          prevPositionX: undefined,\n          prevPositionY: undefined,\n          prevTime: undefined,\n        },\n        ...Zoom,\n      },\n    });\n\n    let scale = 1;\n    Object.defineProperty(swiper.zoom, 'scale', {\n      get() {\n        return scale;\n      },\n      set(value) {\n        if (scale !== value) {\n          const imageEl = swiper.zoom.gesture.$imageEl\n            ? swiper.zoom.gesture.$imageEl[0]\n            : undefined;\n          const slideEl = swiper.zoom.gesture.$slideEl\n            ? swiper.zoom.gesture.$slideEl[0]\n            : undefined;\n          swiper.emit('zoomChange', value, imageEl, slideEl);\n        }\n        scale = value;\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      if (swiper.params.zoom.enabled) {\n        swiper.zoom.enable();\n      }\n    },\n    destroy(swiper) {\n      swiper.zoom.disable();\n    },\n    touchStart(swiper, e) {\n      if (!swiper.zoom.enabled) return;\n      swiper.zoom.onTouchStart(e);\n    },\n    touchEnd(swiper, e) {\n      if (!swiper.zoom.enabled) return;\n      swiper.zoom.onTouchEnd(e);\n    },\n    doubleTap(swiper, e) {\n      if (\n        !swiper.animating &&\n        swiper.params.zoom.enabled &&\n        swiper.zoom.enabled &&\n        swiper.params.zoom.toggle\n      ) {\n        swiper.zoom.toggle(e);\n      }\n    },\n    transitionEnd(swiper) {\n      if (swiper.zoom.enabled && swiper.params.zoom.enabled) {\n        swiper.zoom.onTransitionEnd();\n      }\n    },\n    slideChange(swiper) {\n      if (swiper.zoom.enabled && swiper.params.zoom.enabled && swiper.params.cssMode) {\n        swiper.zoom.onTransitionEnd();\n      }\n    },\n  },\n};\n","import { getWindow } from 'ssr-window';\nimport $ from '../../utils/dom';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst Lazy = {\n  loadInSlide(index, loadInDuplicate = true) {\n    const swiper = this;\n    const params = swiper.params.lazy;\n    if (typeof index === 'undefined') return;\n    if (swiper.slides.length === 0) return;\n    const isVirtual = swiper.virtual && swiper.params.virtual.enabled;\n\n    const $slideEl = isVirtual\n      ? swiper.$wrapperEl.children(\n          `.${swiper.params.slideClass}[data-swiper-slide-index=\"${index}\"]`,\n        )\n      : swiper.slides.eq(index);\n\n    const $images = $slideEl.find(\n      `.${params.elementClass}:not(.${params.loadedClass}):not(.${params.loadingClass})`,\n    );\n    if (\n      $slideEl.hasClass(params.elementClass) &&\n      !$slideEl.hasClass(params.loadedClass) &&\n      !$slideEl.hasClass(params.loadingClass)\n    ) {\n      $images.push($slideEl[0]);\n    }\n    if ($images.length === 0) return;\n\n    $images.each((imageEl) => {\n      const $imageEl = $(imageEl);\n      $imageEl.addClass(params.loadingClass);\n\n      const background = $imageEl.attr('data-background');\n      const src = $imageEl.attr('data-src');\n      const srcset = $imageEl.attr('data-srcset');\n      const sizes = $imageEl.attr('data-sizes');\n      const $pictureEl = $imageEl.parent('picture');\n\n      swiper.loadImage($imageEl[0], src || background, srcset, sizes, false, () => {\n        if (\n          typeof swiper === 'undefined' ||\n          swiper === null ||\n          !swiper ||\n          (swiper && !swiper.params) ||\n          swiper.destroyed\n        )\n          return;\n        if (background) {\n          $imageEl.css('background-image', `url(\"${background}\")`);\n          $imageEl.removeAttr('data-background');\n        } else {\n          if (srcset) {\n            $imageEl.attr('srcset', srcset);\n            $imageEl.removeAttr('data-srcset');\n          }\n          if (sizes) {\n            $imageEl.attr('sizes', sizes);\n            $imageEl.removeAttr('data-sizes');\n          }\n          if ($pictureEl.length) {\n            $pictureEl.children('source').each((sourceEl) => {\n              const $source = $(sourceEl);\n\n              if ($source.attr('data-srcset')) {\n                $source.attr('srcset', $source.attr('data-srcset'));\n                $source.removeAttr('data-srcset');\n              }\n            });\n          }\n          if (src) {\n            $imageEl.attr('src', src);\n            $imageEl.removeAttr('data-src');\n          }\n        }\n\n        $imageEl.addClass(params.loadedClass).removeClass(params.loadingClass);\n        $slideEl.find(`.${params.preloaderClass}`).remove();\n        if (swiper.params.loop && loadInDuplicate) {\n          const slideOriginalIndex = $slideEl.attr('data-swiper-slide-index');\n          if ($slideEl.hasClass(swiper.params.slideDuplicateClass)) {\n            const originalSlide = swiper.$wrapperEl.children(\n              `[data-swiper-slide-index=\"${slideOriginalIndex}\"]:not(.${swiper.params.slideDuplicateClass})`,\n            );\n            swiper.lazy.loadInSlide(originalSlide.index(), false);\n          } else {\n            const duplicatedSlide = swiper.$wrapperEl.children(\n              `.${swiper.params.slideDuplicateClass}[data-swiper-slide-index=\"${slideOriginalIndex}\"]`,\n            );\n            swiper.lazy.loadInSlide(duplicatedSlide.index(), false);\n          }\n        }\n        swiper.emit('lazyImageReady', $slideEl[0], $imageEl[0]);\n        if (swiper.params.autoHeight) {\n          swiper.updateAutoHeight();\n        }\n      });\n\n      swiper.emit('lazyImageLoad', $slideEl[0], $imageEl[0]);\n    });\n  },\n  load() {\n    const swiper = this;\n    const { $wrapperEl, params: swiperParams, slides, activeIndex } = swiper;\n    const isVirtual = swiper.virtual && swiperParams.virtual.enabled;\n    const params = swiperParams.lazy;\n\n    let slidesPerView = swiperParams.slidesPerView;\n    if (slidesPerView === 'auto') {\n      slidesPerView = 0;\n    }\n\n    function slideExist(index) {\n      if (isVirtual) {\n        if (\n          $wrapperEl.children(`.${swiperParams.slideClass}[data-swiper-slide-index=\"${index}\"]`)\n            .length\n        ) {\n          return true;\n        }\n      } else if (slides[index]) return true;\n      return false;\n    }\n\n    function slideIndex(slideEl) {\n      if (isVirtual) {\n        return $(slideEl).attr('data-swiper-slide-index');\n      }\n      return $(slideEl).index();\n    }\n\n    if (!swiper.lazy.initialImageLoaded) swiper.lazy.initialImageLoaded = true;\n    if (swiper.params.watchSlidesVisibility) {\n      $wrapperEl.children(`.${swiperParams.slideVisibleClass}`).each((slideEl) => {\n        const index = isVirtual ? $(slideEl).attr('data-swiper-slide-index') : $(slideEl).index();\n        swiper.lazy.loadInSlide(index);\n      });\n    } else if (slidesPerView > 1) {\n      for (let i = activeIndex; i < activeIndex + slidesPerView; i += 1) {\n        if (slideExist(i)) swiper.lazy.loadInSlide(i);\n      }\n    } else {\n      swiper.lazy.loadInSlide(activeIndex);\n    }\n    if (params.loadPrevNext) {\n      if (slidesPerView > 1 || (params.loadPrevNextAmount && params.loadPrevNextAmount > 1)) {\n        const amount = params.loadPrevNextAmount;\n        const spv = slidesPerView;\n        const maxIndex = Math.min(activeIndex + spv + Math.max(amount, spv), slides.length);\n        const minIndex = Math.max(activeIndex - Math.max(spv, amount), 0);\n        // Next Slides\n        for (let i = activeIndex + slidesPerView; i < maxIndex; i += 1) {\n          if (slideExist(i)) swiper.lazy.loadInSlide(i);\n        }\n        // Prev Slides\n        for (let i = minIndex; i < activeIndex; i += 1) {\n          if (slideExist(i)) swiper.lazy.loadInSlide(i);\n        }\n      } else {\n        const nextSlide = $wrapperEl.children(`.${swiperParams.slideNextClass}`);\n        if (nextSlide.length > 0) swiper.lazy.loadInSlide(slideIndex(nextSlide));\n\n        const prevSlide = $wrapperEl.children(`.${swiperParams.slidePrevClass}`);\n        if (prevSlide.length > 0) swiper.lazy.loadInSlide(slideIndex(prevSlide));\n      }\n    }\n  },\n  checkInViewOnLoad() {\n    const window = getWindow();\n    const swiper = this;\n    if (!swiper || swiper.destroyed) return;\n    const $scrollElement = swiper.params.lazy.scrollingElement\n      ? $(swiper.params.lazy.scrollingElement)\n      : $(window);\n    const isWindow = $scrollElement[0] === window;\n    const scrollElementWidth = isWindow ? window.innerWidth : $scrollElement[0].offsetWidth;\n    const scrollElementHeight = isWindow ? window.innerHeight : $scrollElement[0].offsetHeight;\n    const swiperOffset = swiper.$el.offset();\n    const { rtlTranslate: rtl } = swiper;\n\n    let inView = false;\n\n    if (rtl) swiperOffset.left -= swiper.$el[0].scrollLeft;\n    const swiperCoord = [\n      [swiperOffset.left, swiperOffset.top],\n      [swiperOffset.left + swiper.width, swiperOffset.top],\n      [swiperOffset.left, swiperOffset.top + swiper.height],\n      [swiperOffset.left + swiper.width, swiperOffset.top + swiper.height],\n    ];\n    for (let i = 0; i < swiperCoord.length; i += 1) {\n      const point = swiperCoord[i];\n      if (\n        point[0] >= 0 &&\n        point[0] <= scrollElementWidth &&\n        point[1] >= 0 &&\n        point[1] <= scrollElementHeight\n      ) {\n        if (point[0] === 0 && point[1] === 0) continue; // eslint-disable-line\n        inView = true;\n      }\n    }\n\n    if (inView) {\n      swiper.lazy.load();\n      $scrollElement.off('scroll', swiper.lazy.checkInViewOnLoad);\n    } else if (!swiper.lazy.scrollHandlerAttached) {\n      swiper.lazy.scrollHandlerAttached = true;\n      $scrollElement.on('scroll', swiper.lazy.checkInViewOnLoad);\n    }\n  },\n};\n\nexport default {\n  name: 'lazy',\n  params: {\n    lazy: {\n      checkInView: false,\n      enabled: false,\n      loadPrevNext: false,\n      loadPrevNextAmount: 1,\n      loadOnTransitionStart: false,\n      scrollingElement: '',\n\n      elementClass: 'swiper-lazy',\n      loadingClass: 'swiper-lazy-loading',\n      loadedClass: 'swiper-lazy-loaded',\n      preloaderClass: 'swiper-lazy-preloader',\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      lazy: {\n        initialImageLoaded: false,\n        ...Lazy,\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      if (swiper.params.lazy.enabled && swiper.params.preloadImages) {\n        swiper.params.preloadImages = false;\n      }\n    },\n    init(swiper) {\n      if (swiper.params.lazy.enabled && !swiper.params.loop && swiper.params.initialSlide === 0) {\n        if (swiper.params.lazy.checkInView) {\n          swiper.lazy.checkInViewOnLoad();\n        } else {\n          swiper.lazy.load();\n        }\n      }\n    },\n    scroll(swiper) {\n      if (swiper.params.freeMode && !swiper.params.freeModeSticky) {\n        swiper.lazy.load();\n      }\n    },\n    'scrollbarDragMove resize _freeModeNoMomentumRelease': function lazyLoad(swiper) {\n      if (swiper.params.lazy.enabled) {\n        swiper.lazy.load();\n      }\n    },\n    transitionStart(swiper) {\n      if (swiper.params.lazy.enabled) {\n        if (\n          swiper.params.lazy.loadOnTransitionStart ||\n          (!swiper.params.lazy.loadOnTransitionStart && !swiper.lazy.initialImageLoaded)\n        ) {\n          swiper.lazy.load();\n        }\n      }\n    },\n    transitionEnd(swiper) {\n      if (swiper.params.lazy.enabled && !swiper.params.lazy.loadOnTransitionStart) {\n        swiper.lazy.load();\n      }\n    },\n    slideChange(swiper) {\n      if (swiper.params.lazy.enabled && swiper.params.cssMode) {\n        swiper.lazy.load();\n      }\n    },\n  },\n};\n","/* eslint no-bitwise: [\"error\", { \"allow\": [\">>\"] }] */\nimport { nextTick, bindModuleMethods } from '../../utils/utils';\n\nconst Controller = {\n  LinearSpline: function LinearSpline(x, y) {\n    const binarySearch = (function search() {\n      let maxIndex;\n      let minIndex;\n      let guess;\n      return (array, val) => {\n        minIndex = -1;\n        maxIndex = array.length;\n        while (maxIndex - minIndex > 1) {\n          guess = (maxIndex + minIndex) >> 1;\n          if (array[guess] <= val) {\n            minIndex = guess;\n          } else {\n            maxIndex = guess;\n          }\n        }\n        return maxIndex;\n      };\n    })();\n    this.x = x;\n    this.y = y;\n    this.lastIndex = x.length - 1;\n    // Given an x value (x2), return the expected y2 value:\n    // (x1,y1) is the known point before given value,\n    // (x3,y3) is the known point after given value.\n    let i1;\n    let i3;\n\n    this.interpolate = function interpolate(x2) {\n      if (!x2) return 0;\n\n      // Get the indexes of x1 and x3 (the array indexes before and after given x2):\n      i3 = binarySearch(this.x, x2);\n      i1 = i3 - 1;\n\n      // We have our indexes i1 & i3, so we can calculate already:\n      // y2 := ((x2−x1) × (y3−y1)) ÷ (x3−x1) + y1\n      return (\n        ((x2 - this.x[i1]) * (this.y[i3] - this.y[i1])) / (this.x[i3] - this.x[i1]) + this.y[i1]\n      );\n    };\n    return this;\n  },\n  // xxx: for now i will just save one spline function to to\n  getInterpolateFunction(c) {\n    const swiper = this;\n    if (!swiper.controller.spline) {\n      swiper.controller.spline = swiper.params.loop\n        ? new Controller.LinearSpline(swiper.slidesGrid, c.slidesGrid)\n        : new Controller.LinearSpline(swiper.snapGrid, c.snapGrid);\n    }\n  },\n  setTranslate(setTranslate, byController) {\n    const swiper = this;\n    const controlled = swiper.controller.control;\n    let multiplier;\n    let controlledTranslate;\n    const Swiper = swiper.constructor;\n    function setControlledTranslate(c) {\n      // this will create an Interpolate function based on the snapGrids\n      // x is the Grid of the scrolled scroller and y will be the controlled scroller\n      // it makes sense to create this only once and recall it for the interpolation\n      // the function does a lot of value caching for performance\n      const translate = swiper.rtlTranslate ? -swiper.translate : swiper.translate;\n      if (swiper.params.controller.by === 'slide') {\n        swiper.controller.getInterpolateFunction(c);\n        // i am not sure why the values have to be multiplicated this way, tried to invert the snapGrid\n        // but it did not work out\n        controlledTranslate = -swiper.controller.spline.interpolate(-translate);\n      }\n\n      if (!controlledTranslate || swiper.params.controller.by === 'container') {\n        multiplier =\n          (c.maxTranslate() - c.minTranslate()) / (swiper.maxTranslate() - swiper.minTranslate());\n        controlledTranslate = (translate - swiper.minTranslate()) * multiplier + c.minTranslate();\n      }\n\n      if (swiper.params.controller.inverse) {\n        controlledTranslate = c.maxTranslate() - controlledTranslate;\n      }\n      c.updateProgress(controlledTranslate);\n      c.setTranslate(controlledTranslate, swiper);\n      c.updateActiveIndex();\n      c.updateSlidesClasses();\n    }\n    if (Array.isArray(controlled)) {\n      for (let i = 0; i < controlled.length; i += 1) {\n        if (controlled[i] !== byController && controlled[i] instanceof Swiper) {\n          setControlledTranslate(controlled[i]);\n        }\n      }\n    } else if (controlled instanceof Swiper && byController !== controlled) {\n      setControlledTranslate(controlled);\n    }\n  },\n  setTransition(duration, byController) {\n    const swiper = this;\n    const Swiper = swiper.constructor;\n    const controlled = swiper.controller.control;\n    let i;\n    function setControlledTransition(c) {\n      c.setTransition(duration, swiper);\n      if (duration !== 0) {\n        c.transitionStart();\n        if (c.params.autoHeight) {\n          nextTick(() => {\n            c.updateAutoHeight();\n          });\n        }\n        c.$wrapperEl.transitionEnd(() => {\n          if (!controlled) return;\n          if (c.params.loop && swiper.params.controller.by === 'slide') {\n            c.loopFix();\n          }\n          c.transitionEnd();\n        });\n      }\n    }\n    if (Array.isArray(controlled)) {\n      for (i = 0; i < controlled.length; i += 1) {\n        if (controlled[i] !== byController && controlled[i] instanceof Swiper) {\n          setControlledTransition(controlled[i]);\n        }\n      }\n    } else if (controlled instanceof Swiper && byController !== controlled) {\n      setControlledTransition(controlled);\n    }\n  },\n};\nexport default {\n  name: 'controller',\n  params: {\n    controller: {\n      control: undefined,\n      inverse: false,\n      by: 'slide', // or 'container'\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      controller: {\n        control: swiper.params.controller.control,\n        ...Controller,\n      },\n    });\n  },\n  on: {\n    update(swiper) {\n      if (!swiper.controller.control) return;\n      if (swiper.controller.spline) {\n        swiper.controller.spline = undefined;\n        delete swiper.controller.spline;\n      }\n    },\n    resize(swiper) {\n      if (!swiper.controller.control) return;\n      if (swiper.controller.spline) {\n        swiper.controller.spline = undefined;\n        delete swiper.controller.spline;\n      }\n    },\n    observerUpdate(swiper) {\n      if (!swiper.controller.control) return;\n      if (swiper.controller.spline) {\n        swiper.controller.spline = undefined;\n        delete swiper.controller.spline;\n      }\n    },\n    setTranslate(swiper, translate, byController) {\n      if (!swiper.controller.control) return;\n      swiper.controller.setTranslate(translate, byController);\n    },\n    setTransition(swiper, duration, byController) {\n      if (!swiper.controller.control) return;\n      swiper.controller.setTransition(duration, byController);\n    },\n  },\n};\n","import $ from '../../utils/dom';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst A11y = {\n  getRandomNumber(size = 16) {\n    const randomChar = () => Math.round(16 * Math.random()).toString(16);\n    return 'x'.repeat(size).replace(/x/g, randomChar);\n  },\n  makeElFocusable($el) {\n    $el.attr('tabIndex', '0');\n    return $el;\n  },\n  makeElNotFocusable($el) {\n    $el.attr('tabIndex', '-1');\n    return $el;\n  },\n  addElRole($el, role) {\n    $el.attr('role', role);\n    return $el;\n  },\n  addElRoleDescription($el, description) {\n    $el.attr('aria-roledescription', description);\n    return $el;\n  },\n  addElControls($el, controls) {\n    $el.attr('aria-controls', controls);\n    return $el;\n  },\n  addElLabel($el, label) {\n    $el.attr('aria-label', label);\n    return $el;\n  },\n  addElId($el, id) {\n    $el.attr('id', id);\n    return $el;\n  },\n  addElLive($el, live) {\n    $el.attr('aria-live', live);\n    return $el;\n  },\n  disableEl($el) {\n    $el.attr('aria-disabled', true);\n    return $el;\n  },\n  enableEl($el) {\n    $el.attr('aria-disabled', false);\n    return $el;\n  },\n  onEnterOrSpaceKey(e) {\n    if (e.keyCode !== 13 && e.keyCode !== 32) return;\n    const swiper = this;\n    const params = swiper.params.a11y;\n    const $targetEl = $(e.target);\n    if (swiper.navigation && swiper.navigation.$nextEl && $targetEl.is(swiper.navigation.$nextEl)) {\n      if (!(swiper.isEnd && !swiper.params.loop)) {\n        swiper.slideNext();\n      }\n      if (swiper.isEnd) {\n        swiper.a11y.notify(params.lastSlideMessage);\n      } else {\n        swiper.a11y.notify(params.nextSlideMessage);\n      }\n    }\n    if (swiper.navigation && swiper.navigation.$prevEl && $targetEl.is(swiper.navigation.$prevEl)) {\n      if (!(swiper.isBeginning && !swiper.params.loop)) {\n        swiper.slidePrev();\n      }\n      if (swiper.isBeginning) {\n        swiper.a11y.notify(params.firstSlideMessage);\n      } else {\n        swiper.a11y.notify(params.prevSlideMessage);\n      }\n    }\n    if (\n      swiper.pagination &&\n      $targetEl.is(`.${swiper.params.pagination.bulletClass.replace(/ /g, '.')}`)\n    ) {\n      $targetEl[0].click();\n    }\n  },\n  notify(message) {\n    const swiper = this;\n    const notification = swiper.a11y.liveRegion;\n    if (notification.length === 0) return;\n    notification.html('');\n    notification.html(message);\n  },\n  updateNavigation() {\n    const swiper = this;\n\n    if (swiper.params.loop || !swiper.navigation) return;\n    const { $nextEl, $prevEl } = swiper.navigation;\n\n    if ($prevEl && $prevEl.length > 0) {\n      if (swiper.isBeginning) {\n        swiper.a11y.disableEl($prevEl);\n        swiper.a11y.makeElNotFocusable($prevEl);\n      } else {\n        swiper.a11y.enableEl($prevEl);\n        swiper.a11y.makeElFocusable($prevEl);\n      }\n    }\n    if ($nextEl && $nextEl.length > 0) {\n      if (swiper.isEnd) {\n        swiper.a11y.disableEl($nextEl);\n        swiper.a11y.makeElNotFocusable($nextEl);\n      } else {\n        swiper.a11y.enableEl($nextEl);\n        swiper.a11y.makeElFocusable($nextEl);\n      }\n    }\n  },\n  updatePagination() {\n    const swiper = this;\n    const params = swiper.params.a11y;\n    if (\n      swiper.pagination &&\n      swiper.params.pagination.clickable &&\n      swiper.pagination.bullets &&\n      swiper.pagination.bullets.length\n    ) {\n      swiper.pagination.bullets.each((bulletEl) => {\n        const $bulletEl = $(bulletEl);\n        swiper.a11y.makeElFocusable($bulletEl);\n        if (!swiper.params.pagination.renderBullet) {\n          swiper.a11y.addElRole($bulletEl, 'button');\n          swiper.a11y.addElLabel(\n            $bulletEl,\n            params.paginationBulletMessage.replace(/\\{\\{index\\}\\}/, $bulletEl.index() + 1),\n          );\n        }\n      });\n    }\n  },\n  init() {\n    const swiper = this;\n    const params = swiper.params.a11y;\n\n    swiper.$el.append(swiper.a11y.liveRegion);\n\n    // Container\n    const $containerEl = swiper.$el;\n    if (params.containerRoleDescriptionMessage) {\n      swiper.a11y.addElRoleDescription($containerEl, params.containerRoleDescriptionMessage);\n    }\n    if (params.containerMessage) {\n      swiper.a11y.addElLabel($containerEl, params.containerMessage);\n    }\n\n    // Wrapper\n    const $wrapperEl = swiper.$wrapperEl;\n    const wrapperId = $wrapperEl.attr('id') || `swiper-wrapper-${swiper.a11y.getRandomNumber(16)}`;\n    let live;\n    swiper.a11y.addElId($wrapperEl, wrapperId);\n\n    if (swiper.params.autoplay && swiper.params.autoplay.enabled) {\n      live = 'off';\n    } else {\n      live = 'polite';\n    }\n    swiper.a11y.addElLive($wrapperEl, live);\n\n    // Slide\n    if (params.itemRoleDescriptionMessage) {\n      swiper.a11y.addElRoleDescription($(swiper.slides), params.itemRoleDescriptionMessage);\n    }\n    swiper.a11y.addElRole($(swiper.slides), 'group');\n    swiper.slides.each((slideEl) => {\n      const $slideEl = $(slideEl);\n      const ariaLabelMessage = params.slideLabelMessage\n        .replace(/\\{\\{index\\}\\}/, $slideEl.index() + 1)\n        .replace(/\\{\\{slidesLength\\}\\}/, swiper.slides.length);\n      swiper.a11y.addElLabel($slideEl, ariaLabelMessage);\n    });\n\n    // Navigation\n    let $nextEl;\n    let $prevEl;\n    if (swiper.navigation && swiper.navigation.$nextEl) {\n      $nextEl = swiper.navigation.$nextEl;\n    }\n    if (swiper.navigation && swiper.navigation.$prevEl) {\n      $prevEl = swiper.navigation.$prevEl;\n    }\n\n    if ($nextEl && $nextEl.length) {\n      swiper.a11y.makeElFocusable($nextEl);\n      if ($nextEl[0].tagName !== 'BUTTON') {\n        swiper.a11y.addElRole($nextEl, 'button');\n        $nextEl.on('keydown', swiper.a11y.onEnterOrSpaceKey);\n      }\n      swiper.a11y.addElLabel($nextEl, params.nextSlideMessage);\n      swiper.a11y.addElControls($nextEl, wrapperId);\n    }\n    if ($prevEl && $prevEl.length) {\n      swiper.a11y.makeElFocusable($prevEl);\n      if ($prevEl[0].tagName !== 'BUTTON') {\n        swiper.a11y.addElRole($prevEl, 'button');\n        $prevEl.on('keydown', swiper.a11y.onEnterOrSpaceKey);\n      }\n      swiper.a11y.addElLabel($prevEl, params.prevSlideMessage);\n      swiper.a11y.addElControls($prevEl, wrapperId);\n    }\n\n    // Pagination\n    if (\n      swiper.pagination &&\n      swiper.params.pagination.clickable &&\n      swiper.pagination.bullets &&\n      swiper.pagination.bullets.length\n    ) {\n      swiper.pagination.$el.on(\n        'keydown',\n        `.${swiper.params.pagination.bulletClass.replace(/ /g, '.')}`,\n        swiper.a11y.onEnterOrSpaceKey,\n      );\n    }\n  },\n  destroy() {\n    const swiper = this;\n    if (swiper.a11y.liveRegion && swiper.a11y.liveRegion.length > 0)\n      swiper.a11y.liveRegion.remove();\n\n    let $nextEl;\n    let $prevEl;\n    if (swiper.navigation && swiper.navigation.$nextEl) {\n      $nextEl = swiper.navigation.$nextEl;\n    }\n    if (swiper.navigation && swiper.navigation.$prevEl) {\n      $prevEl = swiper.navigation.$prevEl;\n    }\n    if ($nextEl) {\n      $nextEl.off('keydown', swiper.a11y.onEnterOrSpaceKey);\n    }\n    if ($prevEl) {\n      $prevEl.off('keydown', swiper.a11y.onEnterOrSpaceKey);\n    }\n\n    // Pagination\n    if (\n      swiper.pagination &&\n      swiper.params.pagination.clickable &&\n      swiper.pagination.bullets &&\n      swiper.pagination.bullets.length\n    ) {\n      swiper.pagination.$el.off(\n        'keydown',\n        `.${swiper.params.pagination.bulletClass.replace(/ /g, '.')}`,\n        swiper.a11y.onEnterOrSpaceKey,\n      );\n    }\n  },\n};\nexport default {\n  name: 'a11y',\n  params: {\n    a11y: {\n      enabled: true,\n      notificationClass: 'swiper-notification',\n      prevSlideMessage: 'Previous slide',\n      nextSlideMessage: 'Next slide',\n      firstSlideMessage: 'This is the first slide',\n      lastSlideMessage: 'This is the last slide',\n      paginationBulletMessage: 'Go to slide {{index}}',\n      slideLabelMessage: '{{index}} / {{slidesLength}}',\n      containerMessage: null,\n      containerRoleDescriptionMessage: null,\n      itemRoleDescriptionMessage: null,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      a11y: {\n        ...A11y,\n        liveRegion: $(\n          `<span class=\"${swiper.params.a11y.notificationClass}\" aria-live=\"assertive\" aria-atomic=\"true\"></span>`,\n        ),\n      },\n    });\n  },\n  on: {\n    afterInit(swiper) {\n      if (!swiper.params.a11y.enabled) return;\n      swiper.a11y.init();\n      swiper.a11y.updateNavigation();\n    },\n    toEdge(swiper) {\n      if (!swiper.params.a11y.enabled) return;\n      swiper.a11y.updateNavigation();\n    },\n    fromEdge(swiper) {\n      if (!swiper.params.a11y.enabled) return;\n      swiper.a11y.updateNavigation();\n    },\n    paginationUpdate(swiper) {\n      if (!swiper.params.a11y.enabled) return;\n      swiper.a11y.updatePagination();\n    },\n    destroy(swiper) {\n      if (!swiper.params.a11y.enabled) return;\n      swiper.a11y.destroy();\n    },\n  },\n};\n","import { getWindow } from 'ssr-window';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst History = {\n  init() {\n    const swiper = this;\n    const window = getWindow();\n    if (!swiper.params.history) return;\n    if (!window.history || !window.history.pushState) {\n      swiper.params.history.enabled = false;\n      swiper.params.hashNavigation.enabled = true;\n      return;\n    }\n    const history = swiper.history;\n    history.initialized = true;\n    history.paths = History.getPathValues(swiper.params.url);\n    if (!history.paths.key && !history.paths.value) return;\n    history.scrollToSlide(0, history.paths.value, swiper.params.runCallbacksOnInit);\n    if (!swiper.params.history.replaceState) {\n      window.addEventListener('popstate', swiper.history.setHistoryPopState);\n    }\n  },\n  destroy() {\n    const swiper = this;\n    const window = getWindow();\n    if (!swiper.params.history.replaceState) {\n      window.removeEventListener('popstate', swiper.history.setHistoryPopState);\n    }\n  },\n  setHistoryPopState() {\n    const swiper = this;\n    swiper.history.paths = History.getPathValues(swiper.params.url);\n    swiper.history.scrollToSlide(swiper.params.speed, swiper.history.paths.value, false);\n  },\n  getPathValues(urlOverride) {\n    const window = getWindow();\n    let location;\n    if (urlOverride) {\n      location = new URL(urlOverride);\n    } else {\n      location = window.location;\n    }\n    const pathArray = location.pathname\n      .slice(1)\n      .split('/')\n      .filter((part) => part !== '');\n    const total = pathArray.length;\n    const key = pathArray[total - 2];\n    const value = pathArray[total - 1];\n    return { key, value };\n  },\n  setHistory(key, index) {\n    const swiper = this;\n    const window = getWindow();\n    if (!swiper.history.initialized || !swiper.params.history.enabled) return;\n    let location;\n    if (swiper.params.url) {\n      location = new URL(swiper.params.url);\n    } else {\n      location = window.location;\n    }\n    const slide = swiper.slides.eq(index);\n    let value = History.slugify(slide.attr('data-history'));\n    if (!location.pathname.includes(key)) {\n      value = `${key}/${value}`;\n    }\n    const currentState = window.history.state;\n    if (currentState && currentState.value === value) {\n      return;\n    }\n    if (swiper.params.history.replaceState) {\n      window.history.replaceState({ value }, null, value);\n    } else {\n      window.history.pushState({ value }, null, value);\n    }\n  },\n  slugify(text) {\n    return text\n      .toString()\n      .replace(/\\s+/g, '-')\n      .replace(/[^\\w-]+/g, '')\n      .replace(/--+/g, '-')\n      .replace(/^-+/, '')\n      .replace(/-+$/, '');\n  },\n  scrollToSlide(speed, value, runCallbacks) {\n    const swiper = this;\n    if (value) {\n      for (let i = 0, length = swiper.slides.length; i < length; i += 1) {\n        const slide = swiper.slides.eq(i);\n        const slideHistory = History.slugify(slide.attr('data-history'));\n        if (slideHistory === value && !slide.hasClass(swiper.params.slideDuplicateClass)) {\n          const index = slide.index();\n          swiper.slideTo(index, speed, runCallbacks);\n        }\n      }\n    } else {\n      swiper.slideTo(0, speed, runCallbacks);\n    }\n  },\n};\n\nexport default {\n  name: 'history',\n  params: {\n    history: {\n      enabled: false,\n      replaceState: false,\n      key: 'slides',\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      history: {\n        ...History,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      if (swiper.params.history.enabled) {\n        swiper.history.init();\n      }\n    },\n    destroy(swiper) {\n      if (swiper.params.history.enabled) {\n        swiper.history.destroy();\n      }\n    },\n    transitionEnd(swiper) {\n      if (swiper.history.initialized) {\n        swiper.history.setHistory(swiper.params.history.key, swiper.activeIndex);\n      }\n    },\n    slideChange(swiper) {\n      if (swiper.history.initialized && swiper.params.cssMode) {\n        swiper.history.setHistory(swiper.params.history.key, swiper.activeIndex);\n      }\n    },\n  },\n};\n","import { getWindow, getDocument } from 'ssr-window';\nimport $ from '../../utils/dom';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst HashNavigation = {\n  onHashCange() {\n    const swiper = this;\n    const document = getDocument();\n    swiper.emit('hashChange');\n    const newHash = document.location.hash.replace('#', '');\n    const activeSlideHash = swiper.slides.eq(swiper.activeIndex).attr('data-hash');\n    if (newHash !== activeSlideHash) {\n      const newIndex = swiper.$wrapperEl\n        .children(`.${swiper.params.slideClass}[data-hash=\"${newHash}\"]`)\n        .index();\n      if (typeof newIndex === 'undefined') return;\n      swiper.slideTo(newIndex);\n    }\n  },\n  setHash() {\n    const swiper = this;\n    const window = getWindow();\n    const document = getDocument();\n    if (!swiper.hashNavigation.initialized || !swiper.params.hashNavigation.enabled) return;\n    if (\n      swiper.params.hashNavigation.replaceState &&\n      window.history &&\n      window.history.replaceState\n    ) {\n      window.history.replaceState(\n        null,\n        null,\n        `#${swiper.slides.eq(swiper.activeIndex).attr('data-hash')}` || '',\n      );\n      swiper.emit('hashSet');\n    } else {\n      const slide = swiper.slides.eq(swiper.activeIndex);\n      const hash = slide.attr('data-hash') || slide.attr('data-history');\n      document.location.hash = hash || '';\n      swiper.emit('hashSet');\n    }\n  },\n  init() {\n    const swiper = this;\n    const document = getDocument();\n    const window = getWindow();\n    if (\n      !swiper.params.hashNavigation.enabled ||\n      (swiper.params.history && swiper.params.history.enabled)\n    )\n      return;\n    swiper.hashNavigation.initialized = true;\n    const hash = document.location.hash.replace('#', '');\n    if (hash) {\n      const speed = 0;\n      for (let i = 0, length = swiper.slides.length; i < length; i += 1) {\n        const slide = swiper.slides.eq(i);\n        const slideHash = slide.attr('data-hash') || slide.attr('data-history');\n        if (slideHash === hash && !slide.hasClass(swiper.params.slideDuplicateClass)) {\n          const index = slide.index();\n          swiper.slideTo(index, speed, swiper.params.runCallbacksOnInit, true);\n        }\n      }\n    }\n    if (swiper.params.hashNavigation.watchState) {\n      $(window).on('hashchange', swiper.hashNavigation.onHashCange);\n    }\n  },\n  destroy() {\n    const swiper = this;\n    const window = getWindow();\n    if (swiper.params.hashNavigation.watchState) {\n      $(window).off('hashchange', swiper.hashNavigation.onHashCange);\n    }\n  },\n};\nexport default {\n  name: 'hash-navigation',\n  params: {\n    hashNavigation: {\n      enabled: false,\n      replaceState: false,\n      watchState: false,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      hashNavigation: {\n        initialized: false,\n        ...HashNavigation,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      if (swiper.params.hashNavigation.enabled) {\n        swiper.hashNavigation.init();\n      }\n    },\n    destroy(swiper) {\n      if (swiper.params.hashNavigation.enabled) {\n        swiper.hashNavigation.destroy();\n      }\n    },\n    transitionEnd(swiper) {\n      if (swiper.hashNavigation.initialized) {\n        swiper.hashNavigation.setHash();\n      }\n    },\n    slideChange(swiper) {\n      if (swiper.hashNavigation.initialized && swiper.params.cssMode) {\n        swiper.hashNavigation.setHash();\n      }\n    },\n  },\n};\n","/* eslint no-underscore-dangle: \"off\" */\nimport { getDocument } from 'ssr-window';\nimport { nextTick, bindModuleMethods } from '../../utils/utils';\n\nconst Autoplay = {\n  run() {\n    const swiper = this;\n    const $activeSlideEl = swiper.slides.eq(swiper.activeIndex);\n    let delay = swiper.params.autoplay.delay;\n    if ($activeSlideEl.attr('data-swiper-autoplay')) {\n      delay = $activeSlideEl.attr('data-swiper-autoplay') || swiper.params.autoplay.delay;\n    }\n    clearTimeout(swiper.autoplay.timeout);\n    swiper.autoplay.timeout = nextTick(() => {\n      let autoplayResult;\n      if (swiper.params.autoplay.reverseDirection) {\n        if (swiper.params.loop) {\n          swiper.loopFix();\n          autoplayResult = swiper.slidePrev(swiper.params.speed, true, true);\n          swiper.emit('autoplay');\n        } else if (!swiper.isBeginning) {\n          autoplayResult = swiper.slidePrev(swiper.params.speed, true, true);\n          swiper.emit('autoplay');\n        } else if (!swiper.params.autoplay.stopOnLastSlide) {\n          autoplayResult = swiper.slideTo(\n            swiper.slides.length - 1,\n            swiper.params.speed,\n            true,\n            true,\n          );\n          swiper.emit('autoplay');\n        } else {\n          swiper.autoplay.stop();\n        }\n      } else if (swiper.params.loop) {\n        swiper.loopFix();\n        autoplayResult = swiper.slideNext(swiper.params.speed, true, true);\n        swiper.emit('autoplay');\n      } else if (!swiper.isEnd) {\n        autoplayResult = swiper.slideNext(swiper.params.speed, true, true);\n        swiper.emit('autoplay');\n      } else if (!swiper.params.autoplay.stopOnLastSlide) {\n        autoplayResult = swiper.slideTo(0, swiper.params.speed, true, true);\n        swiper.emit('autoplay');\n      } else {\n        swiper.autoplay.stop();\n      }\n      if (swiper.params.cssMode && swiper.autoplay.running) swiper.autoplay.run();\n      else if (autoplayResult === false) {\n        swiper.autoplay.run();\n      }\n    }, delay);\n  },\n  start() {\n    const swiper = this;\n    if (typeof swiper.autoplay.timeout !== 'undefined') return false;\n    if (swiper.autoplay.running) return false;\n    swiper.autoplay.running = true;\n    swiper.emit('autoplayStart');\n    swiper.autoplay.run();\n    return true;\n  },\n  stop() {\n    const swiper = this;\n    if (!swiper.autoplay.running) return false;\n    if (typeof swiper.autoplay.timeout === 'undefined') return false;\n\n    if (swiper.autoplay.timeout) {\n      clearTimeout(swiper.autoplay.timeout);\n      swiper.autoplay.timeout = undefined;\n    }\n    swiper.autoplay.running = false;\n    swiper.emit('autoplayStop');\n    return true;\n  },\n  pause(speed) {\n    const swiper = this;\n    if (!swiper.autoplay.running) return;\n    if (swiper.autoplay.paused) return;\n    if (swiper.autoplay.timeout) clearTimeout(swiper.autoplay.timeout);\n    swiper.autoplay.paused = true;\n    if (speed === 0 || !swiper.params.autoplay.waitForTransition) {\n      swiper.autoplay.paused = false;\n      swiper.autoplay.run();\n    } else {\n      swiper.$wrapperEl[0].addEventListener('transitionend', swiper.autoplay.onTransitionEnd);\n      swiper.$wrapperEl[0].addEventListener('webkitTransitionEnd', swiper.autoplay.onTransitionEnd);\n    }\n  },\n  onVisibilityChange() {\n    const swiper = this;\n    const document = getDocument();\n    if (document.visibilityState === 'hidden' && swiper.autoplay.running) {\n      swiper.autoplay.pause();\n    }\n    if (document.visibilityState === 'visible' && swiper.autoplay.paused) {\n      swiper.autoplay.run();\n      swiper.autoplay.paused = false;\n    }\n  },\n  onTransitionEnd(e) {\n    const swiper = this;\n    if (!swiper || swiper.destroyed || !swiper.$wrapperEl) return;\n    if (e.target !== swiper.$wrapperEl[0]) return;\n    swiper.$wrapperEl[0].removeEventListener('transitionend', swiper.autoplay.onTransitionEnd);\n    swiper.$wrapperEl[0].removeEventListener(\n      'webkitTransitionEnd',\n      swiper.autoplay.onTransitionEnd,\n    );\n    swiper.autoplay.paused = false;\n    if (!swiper.autoplay.running) {\n      swiper.autoplay.stop();\n    } else {\n      swiper.autoplay.run();\n    }\n  },\n};\n\nexport default {\n  name: 'autoplay',\n  params: {\n    autoplay: {\n      enabled: false,\n      delay: 3000,\n      waitForTransition: true,\n      disableOnInteraction: true,\n      stopOnLastSlide: false,\n      reverseDirection: false,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      autoplay: {\n        ...Autoplay,\n        running: false,\n        paused: false,\n      },\n    });\n  },\n  on: {\n    init(swiper) {\n      if (swiper.params.autoplay.enabled) {\n        swiper.autoplay.start();\n        const document = getDocument();\n        document.addEventListener('visibilitychange', swiper.autoplay.onVisibilityChange);\n      }\n    },\n    beforeTransitionStart(swiper, speed, internal) {\n      if (swiper.autoplay.running) {\n        if (internal || !swiper.params.autoplay.disableOnInteraction) {\n          swiper.autoplay.pause(speed);\n        } else {\n          swiper.autoplay.stop();\n        }\n      }\n    },\n    sliderFirstMove(swiper) {\n      if (swiper.autoplay.running) {\n        if (swiper.params.autoplay.disableOnInteraction) {\n          swiper.autoplay.stop();\n        } else {\n          swiper.autoplay.pause();\n        }\n      }\n    },\n    touchEnd(swiper) {\n      if (\n        swiper.params.cssMode &&\n        swiper.autoplay.paused &&\n        !swiper.params.autoplay.disableOnInteraction\n      ) {\n        swiper.autoplay.run();\n      }\n    },\n    destroy(swiper) {\n      if (swiper.autoplay.running) {\n        swiper.autoplay.stop();\n      }\n      const document = getDocument();\n      document.removeEventListener('visibilitychange', swiper.autoplay.onVisibilityChange);\n    },\n  },\n};\n","import { extend, bindModuleMethods } from '../../utils/utils';\n\nconst Fade = {\n  setTranslate() {\n    const swiper = this;\n    const { slides } = swiper;\n    for (let i = 0; i < slides.length; i += 1) {\n      const $slideEl = swiper.slides.eq(i);\n      const offset = $slideEl[0].swiperSlideOffset;\n      let tx = -offset;\n      if (!swiper.params.virtualTranslate) tx -= swiper.translate;\n      let ty = 0;\n      if (!swiper.isHorizontal()) {\n        ty = tx;\n        tx = 0;\n      }\n      const slideOpacity = swiper.params.fadeEffect.crossFade\n        ? Math.max(1 - Math.abs($slideEl[0].progress), 0)\n        : 1 + Math.min(Math.max($slideEl[0].progress, -1), 0);\n      $slideEl\n        .css({\n          opacity: slideOpacity,\n        })\n        .transform(`translate3d(${tx}px, ${ty}px, 0px)`);\n    }\n  },\n  setTransition(duration) {\n    const swiper = this;\n    const { slides, $wrapperEl } = swiper;\n    slides.transition(duration);\n    if (swiper.params.virtualTranslate && duration !== 0) {\n      let eventTriggered = false;\n      slides.transitionEnd(() => {\n        if (eventTriggered) return;\n        if (!swiper || swiper.destroyed) return;\n        eventTriggered = true;\n        swiper.animating = false;\n        const triggerEvents = ['webkitTransitionEnd', 'transitionend'];\n        for (let i = 0; i < triggerEvents.length; i += 1) {\n          $wrapperEl.trigger(triggerEvents[i]);\n        }\n      });\n    }\n  },\n};\n\nexport default {\n  name: 'effect-fade',\n  params: {\n    fadeEffect: {\n      crossFade: false,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      fadeEffect: {\n        ...Fade,\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      if (swiper.params.effect !== 'fade') return;\n      swiper.classNames.push(`${swiper.params.containerModifierClass}fade`);\n      const overwriteParams = {\n        slidesPerView: 1,\n        slidesPerColumn: 1,\n        slidesPerGroup: 1,\n        watchSlidesProgress: true,\n        spaceBetween: 0,\n        virtualTranslate: true,\n      };\n      extend(swiper.params, overwriteParams);\n      extend(swiper.originalParams, overwriteParams);\n    },\n    setTranslate(swiper) {\n      if (swiper.params.effect !== 'fade') return;\n      swiper.fadeEffect.setTranslate();\n    },\n    setTransition(swiper, duration) {\n      if (swiper.params.effect !== 'fade') return;\n      swiper.fadeEffect.setTransition(duration);\n    },\n  },\n};\n","import $ from '../../utils/dom';\nimport { extend, bindModuleMethods } from '../../utils/utils';\n\nconst Cube = {\n  setTranslate() {\n    const swiper = this;\n    const {\n      $el,\n      $wrapperEl,\n      slides,\n      width: swiperWidth,\n      height: swiperHeight,\n      rtlTranslate: rtl,\n      size: swiperSize,\n      browser,\n    } = swiper;\n    const params = swiper.params.cubeEffect;\n    const isHorizontal = swiper.isHorizontal();\n    const isVirtual = swiper.virtual && swiper.params.virtual.enabled;\n    let wrapperRotate = 0;\n    let $cubeShadowEl;\n    if (params.shadow) {\n      if (isHorizontal) {\n        $cubeShadowEl = $wrapperEl.find('.swiper-cube-shadow');\n        if ($cubeShadowEl.length === 0) {\n          $cubeShadowEl = $('<div class=\"swiper-cube-shadow\"></div>');\n          $wrapperEl.append($cubeShadowEl);\n        }\n        $cubeShadowEl.css({ height: `${swiperWidth}px` });\n      } else {\n        $cubeShadowEl = $el.find('.swiper-cube-shadow');\n        if ($cubeShadowEl.length === 0) {\n          $cubeShadowEl = $('<div class=\"swiper-cube-shadow\"></div>');\n          $el.append($cubeShadowEl);\n        }\n      }\n    }\n    for (let i = 0; i < slides.length; i += 1) {\n      const $slideEl = slides.eq(i);\n      let slideIndex = i;\n      if (isVirtual) {\n        slideIndex = parseInt($slideEl.attr('data-swiper-slide-index'), 10);\n      }\n      let slideAngle = slideIndex * 90;\n      let round = Math.floor(slideAngle / 360);\n      if (rtl) {\n        slideAngle = -slideAngle;\n        round = Math.floor(-slideAngle / 360);\n      }\n      const progress = Math.max(Math.min($slideEl[0].progress, 1), -1);\n      let tx = 0;\n      let ty = 0;\n      let tz = 0;\n      if (slideIndex % 4 === 0) {\n        tx = -round * 4 * swiperSize;\n        tz = 0;\n      } else if ((slideIndex - 1) % 4 === 0) {\n        tx = 0;\n        tz = -round * 4 * swiperSize;\n      } else if ((slideIndex - 2) % 4 === 0) {\n        tx = swiperSize + round * 4 * swiperSize;\n        tz = swiperSize;\n      } else if ((slideIndex - 3) % 4 === 0) {\n        tx = -swiperSize;\n        tz = 3 * swiperSize + swiperSize * 4 * round;\n      }\n      if (rtl) {\n        tx = -tx;\n      }\n\n      if (!isHorizontal) {\n        ty = tx;\n        tx = 0;\n      }\n\n      const transform = `rotateX(${isHorizontal ? 0 : -slideAngle}deg) rotateY(${\n        isHorizontal ? slideAngle : 0\n      }deg) translate3d(${tx}px, ${ty}px, ${tz}px)`;\n      if (progress <= 1 && progress > -1) {\n        wrapperRotate = slideIndex * 90 + progress * 90;\n        if (rtl) wrapperRotate = -slideIndex * 90 - progress * 90;\n      }\n      $slideEl.transform(transform);\n      if (params.slideShadows) {\n        // Set shadows\n        let shadowBefore = isHorizontal\n          ? $slideEl.find('.swiper-slide-shadow-left')\n          : $slideEl.find('.swiper-slide-shadow-top');\n        let shadowAfter = isHorizontal\n          ? $slideEl.find('.swiper-slide-shadow-right')\n          : $slideEl.find('.swiper-slide-shadow-bottom');\n        if (shadowBefore.length === 0) {\n          shadowBefore = $(\n            `<div class=\"swiper-slide-shadow-${isHorizontal ? 'left' : 'top'}\"></div>`,\n          );\n          $slideEl.append(shadowBefore);\n        }\n        if (shadowAfter.length === 0) {\n          shadowAfter = $(\n            `<div class=\"swiper-slide-shadow-${isHorizontal ? 'right' : 'bottom'}\"></div>`,\n          );\n          $slideEl.append(shadowAfter);\n        }\n        if (shadowBefore.length) shadowBefore[0].style.opacity = Math.max(-progress, 0);\n        if (shadowAfter.length) shadowAfter[0].style.opacity = Math.max(progress, 0);\n      }\n    }\n    $wrapperEl.css({\n      '-webkit-transform-origin': `50% 50% -${swiperSize / 2}px`,\n      '-moz-transform-origin': `50% 50% -${swiperSize / 2}px`,\n      '-ms-transform-origin': `50% 50% -${swiperSize / 2}px`,\n      'transform-origin': `50% 50% -${swiperSize / 2}px`,\n    });\n\n    if (params.shadow) {\n      if (isHorizontal) {\n        $cubeShadowEl.transform(\n          `translate3d(0px, ${swiperWidth / 2 + params.shadowOffset}px, ${\n            -swiperWidth / 2\n          }px) rotateX(90deg) rotateZ(0deg) scale(${params.shadowScale})`,\n        );\n      } else {\n        const shadowAngle = Math.abs(wrapperRotate) - Math.floor(Math.abs(wrapperRotate) / 90) * 90;\n        const multiplier =\n          1.5 -\n          (Math.sin((shadowAngle * 2 * Math.PI) / 360) / 2 +\n            Math.cos((shadowAngle * 2 * Math.PI) / 360) / 2);\n        const scale1 = params.shadowScale;\n        const scale2 = params.shadowScale / multiplier;\n        const offset = params.shadowOffset;\n        $cubeShadowEl.transform(\n          `scale3d(${scale1}, 1, ${scale2}) translate3d(0px, ${swiperHeight / 2 + offset}px, ${\n            -swiperHeight / 2 / scale2\n          }px) rotateX(-90deg)`,\n        );\n      }\n    }\n    const zFactor = browser.isSafari || browser.isWebView ? -swiperSize / 2 : 0;\n    $wrapperEl.transform(\n      `translate3d(0px,0,${zFactor}px) rotateX(${\n        swiper.isHorizontal() ? 0 : wrapperRotate\n      }deg) rotateY(${swiper.isHorizontal() ? -wrapperRotate : 0}deg)`,\n    );\n  },\n  setTransition(duration) {\n    const swiper = this;\n    const { $el, slides } = swiper;\n    slides\n      .transition(duration)\n      .find(\n        '.swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left',\n      )\n      .transition(duration);\n    if (swiper.params.cubeEffect.shadow && !swiper.isHorizontal()) {\n      $el.find('.swiper-cube-shadow').transition(duration);\n    }\n  },\n};\n\nexport default {\n  name: 'effect-cube',\n  params: {\n    cubeEffect: {\n      slideShadows: true,\n      shadow: true,\n      shadowOffset: 20,\n      shadowScale: 0.94,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      cubeEffect: {\n        ...Cube,\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      if (swiper.params.effect !== 'cube') return;\n      swiper.classNames.push(`${swiper.params.containerModifierClass}cube`);\n      swiper.classNames.push(`${swiper.params.containerModifierClass}3d`);\n      const overwriteParams = {\n        slidesPerView: 1,\n        slidesPerColumn: 1,\n        slidesPerGroup: 1,\n        watchSlidesProgress: true,\n        resistanceRatio: 0,\n        spaceBetween: 0,\n        centeredSlides: false,\n        virtualTranslate: true,\n      };\n      extend(swiper.params, overwriteParams);\n      extend(swiper.originalParams, overwriteParams);\n    },\n    setTranslate(swiper) {\n      if (swiper.params.effect !== 'cube') return;\n      swiper.cubeEffect.setTranslate();\n    },\n    setTransition(swiper, duration) {\n      if (swiper.params.effect !== 'cube') return;\n      swiper.cubeEffect.setTransition(duration);\n    },\n  },\n};\n","import $ from '../../utils/dom';\nimport { extend, bindModuleMethods } from '../../utils/utils';\n\nconst Flip = {\n  setTranslate() {\n    const swiper = this;\n    const { slides, rtlTranslate: rtl } = swiper;\n    for (let i = 0; i < slides.length; i += 1) {\n      const $slideEl = slides.eq(i);\n      let progress = $slideEl[0].progress;\n      if (swiper.params.flipEffect.limitRotation) {\n        progress = Math.max(Math.min($slideEl[0].progress, 1), -1);\n      }\n      const offset = $slideEl[0].swiperSlideOffset;\n      const rotate = -180 * progress;\n      let rotateY = rotate;\n      let rotateX = 0;\n      let tx = -offset;\n      let ty = 0;\n      if (!swiper.isHorizontal()) {\n        ty = tx;\n        tx = 0;\n        rotateX = -rotateY;\n        rotateY = 0;\n      } else if (rtl) {\n        rotateY = -rotateY;\n      }\n\n      $slideEl[0].style.zIndex = -Math.abs(Math.round(progress)) + slides.length;\n\n      if (swiper.params.flipEffect.slideShadows) {\n        // Set shadows\n        let shadowBefore = swiper.isHorizontal()\n          ? $slideEl.find('.swiper-slide-shadow-left')\n          : $slideEl.find('.swiper-slide-shadow-top');\n        let shadowAfter = swiper.isHorizontal()\n          ? $slideEl.find('.swiper-slide-shadow-right')\n          : $slideEl.find('.swiper-slide-shadow-bottom');\n        if (shadowBefore.length === 0) {\n          shadowBefore = $(\n            `<div class=\"swiper-slide-shadow-${swiper.isHorizontal() ? 'left' : 'top'}\"></div>`,\n          );\n          $slideEl.append(shadowBefore);\n        }\n        if (shadowAfter.length === 0) {\n          shadowAfter = $(\n            `<div class=\"swiper-slide-shadow-${swiper.isHorizontal() ? 'right' : 'bottom'}\"></div>`,\n          );\n          $slideEl.append(shadowAfter);\n        }\n        if (shadowBefore.length) shadowBefore[0].style.opacity = Math.max(-progress, 0);\n        if (shadowAfter.length) shadowAfter[0].style.opacity = Math.max(progress, 0);\n      }\n      $slideEl.transform(\n        `translate3d(${tx}px, ${ty}px, 0px) rotateX(${rotateX}deg) rotateY(${rotateY}deg)`,\n      );\n    }\n  },\n  setTransition(duration) {\n    const swiper = this;\n    const { slides, activeIndex, $wrapperEl } = swiper;\n    slides\n      .transition(duration)\n      .find(\n        '.swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left',\n      )\n      .transition(duration);\n    if (swiper.params.virtualTranslate && duration !== 0) {\n      let eventTriggered = false;\n      // eslint-disable-next-line\n      slides.eq(activeIndex).transitionEnd(function onTransitionEnd() {\n        if (eventTriggered) return;\n        if (!swiper || swiper.destroyed) return;\n        // if (!$(this).hasClass(swiper.params.slideActiveClass)) return;\n        eventTriggered = true;\n        swiper.animating = false;\n        const triggerEvents = ['webkitTransitionEnd', 'transitionend'];\n        for (let i = 0; i < triggerEvents.length; i += 1) {\n          $wrapperEl.trigger(triggerEvents[i]);\n        }\n      });\n    }\n  },\n};\n\nexport default {\n  name: 'effect-flip',\n  params: {\n    flipEffect: {\n      slideShadows: true,\n      limitRotation: true,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      flipEffect: {\n        ...Flip,\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      if (swiper.params.effect !== 'flip') return;\n      swiper.classNames.push(`${swiper.params.containerModifierClass}flip`);\n      swiper.classNames.push(`${swiper.params.containerModifierClass}3d`);\n      const overwriteParams = {\n        slidesPerView: 1,\n        slidesPerColumn: 1,\n        slidesPerGroup: 1,\n        watchSlidesProgress: true,\n        spaceBetween: 0,\n        virtualTranslate: true,\n      };\n      extend(swiper.params, overwriteParams);\n      extend(swiper.originalParams, overwriteParams);\n    },\n    setTranslate(swiper) {\n      if (swiper.params.effect !== 'flip') return;\n      swiper.flipEffect.setTranslate();\n    },\n    setTransition(swiper, duration) {\n      if (swiper.params.effect !== 'flip') return;\n      swiper.flipEffect.setTransition(duration);\n    },\n  },\n};\n","import $ from '../../utils/dom';\nimport { bindModuleMethods } from '../../utils/utils';\n\nconst Coverflow = {\n  setTranslate() {\n    const swiper = this;\n    const { width: swiperWidth, height: swiperHeight, slides, slidesSizesGrid } = swiper;\n    const params = swiper.params.coverflowEffect;\n    const isHorizontal = swiper.isHorizontal();\n    const transform = swiper.translate;\n    const center = isHorizontal ? -transform + swiperWidth / 2 : -transform + swiperHeight / 2;\n    const rotate = isHorizontal ? params.rotate : -params.rotate;\n    const translate = params.depth;\n    // Each slide offset from center\n    for (let i = 0, length = slides.length; i < length; i += 1) {\n      const $slideEl = slides.eq(i);\n      const slideSize = slidesSizesGrid[i];\n      const slideOffset = $slideEl[0].swiperSlideOffset;\n      const offsetMultiplier =\n        ((center - slideOffset - slideSize / 2) / slideSize) * params.modifier;\n\n      let rotateY = isHorizontal ? rotate * offsetMultiplier : 0;\n      let rotateX = isHorizontal ? 0 : rotate * offsetMultiplier;\n      // var rotateZ = 0\n      let translateZ = -translate * Math.abs(offsetMultiplier);\n\n      let stretch = params.stretch;\n      // Allow percentage to make a relative stretch for responsive sliders\n      if (typeof stretch === 'string' && stretch.indexOf('%') !== -1) {\n        stretch = (parseFloat(params.stretch) / 100) * slideSize;\n      }\n      let translateY = isHorizontal ? 0 : stretch * offsetMultiplier;\n      let translateX = isHorizontal ? stretch * offsetMultiplier : 0;\n\n      let scale = 1 - (1 - params.scale) * Math.abs(offsetMultiplier);\n\n      // Fix for ultra small values\n      if (Math.abs(translateX) < 0.001) translateX = 0;\n      if (Math.abs(translateY) < 0.001) translateY = 0;\n      if (Math.abs(translateZ) < 0.001) translateZ = 0;\n      if (Math.abs(rotateY) < 0.001) rotateY = 0;\n      if (Math.abs(rotateX) < 0.001) rotateX = 0;\n      if (Math.abs(scale) < 0.001) scale = 0;\n\n      const slideTransform = `translate3d(${translateX}px,${translateY}px,${translateZ}px)  rotateX(${rotateX}deg) rotateY(${rotateY}deg) scale(${scale})`;\n\n      $slideEl.transform(slideTransform);\n      $slideEl[0].style.zIndex = -Math.abs(Math.round(offsetMultiplier)) + 1;\n      if (params.slideShadows) {\n        // Set shadows\n        let $shadowBeforeEl = isHorizontal\n          ? $slideEl.find('.swiper-slide-shadow-left')\n          : $slideEl.find('.swiper-slide-shadow-top');\n        let $shadowAfterEl = isHorizontal\n          ? $slideEl.find('.swiper-slide-shadow-right')\n          : $slideEl.find('.swiper-slide-shadow-bottom');\n        if ($shadowBeforeEl.length === 0) {\n          $shadowBeforeEl = $(\n            `<div class=\"swiper-slide-shadow-${isHorizontal ? 'left' : 'top'}\"></div>`,\n          );\n          $slideEl.append($shadowBeforeEl);\n        }\n        if ($shadowAfterEl.length === 0) {\n          $shadowAfterEl = $(\n            `<div class=\"swiper-slide-shadow-${isHorizontal ? 'right' : 'bottom'}\"></div>`,\n          );\n          $slideEl.append($shadowAfterEl);\n        }\n        if ($shadowBeforeEl.length)\n          $shadowBeforeEl[0].style.opacity = offsetMultiplier > 0 ? offsetMultiplier : 0;\n        if ($shadowAfterEl.length)\n          $shadowAfterEl[0].style.opacity = -offsetMultiplier > 0 ? -offsetMultiplier : 0;\n      }\n    }\n  },\n  setTransition(duration) {\n    const swiper = this;\n    swiper.slides\n      .transition(duration)\n      .find(\n        '.swiper-slide-shadow-top, .swiper-slide-shadow-right, .swiper-slide-shadow-bottom, .swiper-slide-shadow-left',\n      )\n      .transition(duration);\n  },\n};\n\nexport default {\n  name: 'effect-coverflow',\n  params: {\n    coverflowEffect: {\n      rotate: 50,\n      stretch: 0,\n      depth: 100,\n      scale: 1,\n      modifier: 1,\n      slideShadows: true,\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      coverflowEffect: {\n        ...Coverflow,\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      if (swiper.params.effect !== 'coverflow') return;\n\n      swiper.classNames.push(`${swiper.params.containerModifierClass}coverflow`);\n      swiper.classNames.push(`${swiper.params.containerModifierClass}3d`);\n\n      swiper.params.watchSlidesProgress = true;\n      swiper.originalParams.watchSlidesProgress = true;\n    },\n    setTranslate(swiper) {\n      if (swiper.params.effect !== 'coverflow') return;\n      swiper.coverflowEffect.setTranslate();\n    },\n    setTransition(swiper, duration) {\n      if (swiper.params.effect !== 'coverflow') return;\n      swiper.coverflowEffect.setTransition(duration);\n    },\n  },\n};\n","import { extend, isObject, bindModuleMethods } from '../../utils/utils';\nimport $ from '../../utils/dom';\n\nconst Thumbs = {\n  init() {\n    const swiper = this;\n    const { thumbs: thumbsParams } = swiper.params;\n    if (swiper.thumbs.initialized) return false;\n    swiper.thumbs.initialized = true;\n    const SwiperClass = swiper.constructor;\n    if (thumbsParams.swiper instanceof SwiperClass) {\n      swiper.thumbs.swiper = thumbsParams.swiper;\n      extend(swiper.thumbs.swiper.originalParams, {\n        watchSlidesProgress: true,\n        slideToClickedSlide: false,\n      });\n      extend(swiper.thumbs.swiper.params, {\n        watchSlidesProgress: true,\n        slideToClickedSlide: false,\n      });\n    } else if (isObject(thumbsParams.swiper)) {\n      swiper.thumbs.swiper = new SwiperClass(\n        extend({}, thumbsParams.swiper, {\n          watchSlidesVisibility: true,\n          watchSlidesProgress: true,\n          slideToClickedSlide: false,\n        }),\n      );\n      swiper.thumbs.swiperCreated = true;\n    }\n    swiper.thumbs.swiper.$el.addClass(swiper.params.thumbs.thumbsContainerClass);\n    swiper.thumbs.swiper.on('tap', swiper.thumbs.onThumbClick);\n    return true;\n  },\n  onThumbClick() {\n    const swiper = this;\n    const thumbsSwiper = swiper.thumbs.swiper;\n    if (!thumbsSwiper) return;\n    const clickedIndex = thumbsSwiper.clickedIndex;\n    const clickedSlide = thumbsSwiper.clickedSlide;\n    if (clickedSlide && $(clickedSlide).hasClass(swiper.params.thumbs.slideThumbActiveClass))\n      return;\n    if (typeof clickedIndex === 'undefined' || clickedIndex === null) return;\n    let slideToIndex;\n    if (thumbsSwiper.params.loop) {\n      slideToIndex = parseInt($(thumbsSwiper.clickedSlide).attr('data-swiper-slide-index'), 10);\n    } else {\n      slideToIndex = clickedIndex;\n    }\n    if (swiper.params.loop) {\n      let currentIndex = swiper.activeIndex;\n      if (swiper.slides.eq(currentIndex).hasClass(swiper.params.slideDuplicateClass)) {\n        swiper.loopFix();\n        // eslint-disable-next-line\n        swiper._clientLeft = swiper.$wrapperEl[0].clientLeft;\n        currentIndex = swiper.activeIndex;\n      }\n      const prevIndex = swiper.slides\n        .eq(currentIndex)\n        .prevAll(`[data-swiper-slide-index=\"${slideToIndex}\"]`)\n        .eq(0)\n        .index();\n      const nextIndex = swiper.slides\n        .eq(currentIndex)\n        .nextAll(`[data-swiper-slide-index=\"${slideToIndex}\"]`)\n        .eq(0)\n        .index();\n      if (typeof prevIndex === 'undefined') slideToIndex = nextIndex;\n      else if (typeof nextIndex === 'undefined') slideToIndex = prevIndex;\n      else if (nextIndex - currentIndex < currentIndex - prevIndex) slideToIndex = nextIndex;\n      else slideToIndex = prevIndex;\n    }\n    swiper.slideTo(slideToIndex);\n  },\n  update(initial) {\n    const swiper = this;\n    const thumbsSwiper = swiper.thumbs.swiper;\n    if (!thumbsSwiper) return;\n\n    const slidesPerView =\n      thumbsSwiper.params.slidesPerView === 'auto'\n        ? thumbsSwiper.slidesPerViewDynamic()\n        : thumbsSwiper.params.slidesPerView;\n\n    const autoScrollOffset = swiper.params.thumbs.autoScrollOffset;\n    const useOffset = autoScrollOffset && !thumbsSwiper.params.loop;\n    if (swiper.realIndex !== thumbsSwiper.realIndex || useOffset) {\n      let currentThumbsIndex = thumbsSwiper.activeIndex;\n      let newThumbsIndex;\n      let direction;\n      if (thumbsSwiper.params.loop) {\n        if (\n          thumbsSwiper.slides\n            .eq(currentThumbsIndex)\n            .hasClass(thumbsSwiper.params.slideDuplicateClass)\n        ) {\n          thumbsSwiper.loopFix();\n          // eslint-disable-next-line\n          thumbsSwiper._clientLeft = thumbsSwiper.$wrapperEl[0].clientLeft;\n          currentThumbsIndex = thumbsSwiper.activeIndex;\n        }\n        // Find actual thumbs index to slide to\n        const prevThumbsIndex = thumbsSwiper.slides\n          .eq(currentThumbsIndex)\n          .prevAll(`[data-swiper-slide-index=\"${swiper.realIndex}\"]`)\n          .eq(0)\n          .index();\n        const nextThumbsIndex = thumbsSwiper.slides\n          .eq(currentThumbsIndex)\n          .nextAll(`[data-swiper-slide-index=\"${swiper.realIndex}\"]`)\n          .eq(0)\n          .index();\n        if (typeof prevThumbsIndex === 'undefined') newThumbsIndex = nextThumbsIndex;\n        else if (typeof nextThumbsIndex === 'undefined') newThumbsIndex = prevThumbsIndex;\n        else if (nextThumbsIndex - currentThumbsIndex === currentThumbsIndex - prevThumbsIndex)\n          newThumbsIndex = currentThumbsIndex;\n        else if (nextThumbsIndex - currentThumbsIndex < currentThumbsIndex - prevThumbsIndex)\n          newThumbsIndex = nextThumbsIndex;\n        else newThumbsIndex = prevThumbsIndex;\n        direction = swiper.activeIndex > swiper.previousIndex ? 'next' : 'prev';\n      } else {\n        newThumbsIndex = swiper.realIndex;\n        direction = newThumbsIndex > swiper.previousIndex ? 'next' : 'prev';\n      }\n      if (useOffset) {\n        newThumbsIndex += direction === 'next' ? autoScrollOffset : -1 * autoScrollOffset;\n      }\n\n      if (\n        thumbsSwiper.visibleSlidesIndexes &&\n        thumbsSwiper.visibleSlidesIndexes.indexOf(newThumbsIndex) < 0\n      ) {\n        if (thumbsSwiper.params.centeredSlides) {\n          if (newThumbsIndex > currentThumbsIndex) {\n            newThumbsIndex = newThumbsIndex - Math.floor(slidesPerView / 2) + 1;\n          } else {\n            newThumbsIndex = newThumbsIndex + Math.floor(slidesPerView / 2) - 1;\n          }\n        } else if (newThumbsIndex > currentThumbsIndex) {\n          newThumbsIndex = newThumbsIndex - slidesPerView + 1;\n        }\n        thumbsSwiper.slideTo(newThumbsIndex, initial ? 0 : undefined);\n      }\n    }\n\n    // Activate thumbs\n    let thumbsToActivate = 1;\n    const thumbActiveClass = swiper.params.thumbs.slideThumbActiveClass;\n\n    if (swiper.params.slidesPerView > 1 && !swiper.params.centeredSlides) {\n      thumbsToActivate = swiper.params.slidesPerView;\n    }\n\n    if (!swiper.params.thumbs.multipleActiveThumbs) {\n      thumbsToActivate = 1;\n    }\n\n    thumbsToActivate = Math.floor(thumbsToActivate);\n\n    thumbsSwiper.slides.removeClass(thumbActiveClass);\n    if (\n      thumbsSwiper.params.loop ||\n      (thumbsSwiper.params.virtual && thumbsSwiper.params.virtual.enabled)\n    ) {\n      for (let i = 0; i < thumbsToActivate; i += 1) {\n        thumbsSwiper.$wrapperEl\n          .children(`[data-swiper-slide-index=\"${swiper.realIndex + i}\"]`)\n          .addClass(thumbActiveClass);\n      }\n    } else {\n      for (let i = 0; i < thumbsToActivate; i += 1) {\n        thumbsSwiper.slides.eq(swiper.realIndex + i).addClass(thumbActiveClass);\n      }\n    }\n  },\n};\nexport default {\n  name: 'thumbs',\n  params: {\n    thumbs: {\n      swiper: null,\n      multipleActiveThumbs: true,\n      autoScrollOffset: 0,\n      slideThumbActiveClass: 'swiper-slide-thumb-active',\n      thumbsContainerClass: 'swiper-container-thumbs',\n    },\n  },\n  create() {\n    const swiper = this;\n    bindModuleMethods(swiper, {\n      thumbs: {\n        swiper: null,\n        initialized: false,\n        ...Thumbs,\n      },\n    });\n  },\n  on: {\n    beforeInit(swiper) {\n      const { thumbs } = swiper.params;\n      if (!thumbs || !thumbs.swiper) return;\n      swiper.thumbs.init();\n      swiper.thumbs.update(true);\n    },\n    slideChange(swiper) {\n      if (!swiper.thumbs.swiper) return;\n      swiper.thumbs.update();\n    },\n    update(swiper) {\n      if (!swiper.thumbs.swiper) return;\n      swiper.thumbs.update();\n    },\n    resize(swiper) {\n      if (!swiper.thumbs.swiper) return;\n      swiper.thumbs.update();\n    },\n    observerUpdate(swiper) {\n      if (!swiper.thumbs.swiper) return;\n      swiper.thumbs.update();\n    },\n    setTransition(swiper, duration) {\n      const thumbsSwiper = swiper.thumbs.swiper;\n      if (!thumbsSwiper) return;\n      thumbsSwiper.setTransition(duration);\n    },\n    beforeDestroy(swiper) {\n      const thumbsSwiper = swiper.thumbs.swiper;\n      if (!thumbsSwiper) return;\n      if (swiper.thumbs.swiperCreated && thumbsSwiper) {\n        thumbsSwiper.destroy();\n      }\n    },\n  },\n};\n","// Swiper Class\nimport Swiper from './components/core/core-class';\n\n//IMPORT_COMPONENTS\n\nconst components = [\n  //INSTALL_COMPONENTS\n];\n\nSwiper.use(components);\n\n//EXPORT\n"],"names":["isObject","obj","constructor","Object","extend","target","src","keys","forEach","key","length","ssrDocument","body","addEventListener","removeEventListener","activeElement","blur","nodeName","querySelector","querySelectorAll","getElementById","createEvent","initEvent","createElement","children","childNodes","style","setAttribute","getElementsByTagName","createElementNS","importNode","location","hash","host","hostname","href","origin","pathname","protocol","search","getDocument","doc","document","ssrWindow","navigator","userAgent","history","replaceState","pushState","go","back","CustomEvent","getComputedStyle","getPropertyValue","Image","Date","screen","setTimeout","clearTimeout","matchMedia","requestAnimationFrame","callback","cancelAnimationFrame","id","getWindow","win","window","_inheritsLoose","subClass","superClass","prototype","create","__proto__","_getPrototypeOf","o","setPrototypeOf","getPrototypeOf","_setPrototypeOf","p","_isNativeReflectConstruct","Reflect","construct","sham","Proxy","toString","call","e","_construct","Parent","args","Class","a","push","apply","Constructor","Function","bind","instance","arguments","_isNativeFunction","fn","indexOf","_wrapNativeSuper","_cache","Map","undefined","TypeError","has","get","set","Wrapper","value","enumerable","writable","configurable","_assertThisInitialized","self","ReferenceError","makeReactive","proto","defineProperty","Dom7","_Array","items","_this","concat","Array","arrayFlat","arr","res","el","isArray","arrayFilter","filter","arrayUnique","uniqueArray","i","qsa","selector","context","$","html","trim","toCreate","tempParent","innerHTML","nodeType","addClass","_len","classes","_key","classNames","map","c","split","_el$classList","classList","add","removeClass","_len2","_key2","_el$classList2","remove","toggleClass","_len3","_key3","className","toggle","hasClass","_len4","_key4","contains","attr","attrs","getAttribute","attrName","removeAttr","removeAttribute","transform","transition","duration","transitionDuration","on","_len5","_key5","eventType","targetSelector","listener","capture","handleLiveEvent","eventData","dom7EventData","unshift","is","_parents","parents","k","handleEvent","events","j","event","dom7Listeners","proxyListener","_event","dom7LiveListeners","off","_len6","_key6","handlers","handler","splice","dom7proxy","trigger","_len9","_key9","evt","detail","bubbles","cancelable","data","dataIndex","dispatchEvent","transitionEnd","dom","fireCallBack","outerWidth","includeMargins","_styles","styles","offsetWidth","parseFloat","outerHeight","_styles2","offsetHeight","offset","box","getBoundingClientRect","clientTop","clientLeft","scrollTop","scrollY","scrollLeft","scrollX","top","left","css","props","_prop","each","index","result","text","textContent","compareWith","matches","webkitMatchesSelector","msMatchesSelector","child","previousSibling","eq","returnIndex","append","newChild","tempDiv","firstChild","appendChild","prepend","insertBefore","next","nextElementSibling","nextAll","nextEls","_next","prev","previousElementSibling","prevAll","prevEls","_prev","parent","parentNode","_parent","closest","find","foundElements","found","removeChild","Methods","methodName","deleteProps","object","nextTick","delay","now","currentStyle","getTranslate","axis","matrix","curTransform","transformMatrix","curStyle","WebKitCSSMatrix","webkitTransform","replace","join","MozTransform","OTransform","MsTransform","msTransform","m41","m42","slice","to","noExtend","nextSource","keysArray","nextIndex","len","nextKey","desc","getOwnPropertyDescriptor","__swiper__","bindModuleMethods","subKey","support","calcSupport","touch","DocumentTouch","pointerEvents","PointerEvent","maxTouchPoints","observer","checkObserver","passiveListener","checkPassiveListener","supportsPassive","opts","gestures","checkGestures","getSupport","device","calcDevice","platform","ua","ios","android","screenWidth","width","screenHeight","height","match","ipad","ipod","iphone","windows","macos","iPadScreens","os","getDevice","overrides","browser","calcBrowser","isSafari","toLowerCase","isEdge","isWebView","test","getBrowser","supportsResizeObserver","ResizeObserver","name","swiper","resize","createObserver","destroyed","initialized","entries","newWidth","newHeight","contentBoxSize","contentRect","inlineSize","blockSize","resizeHandler","observe","removeObserver","unobserve","emit","orientationChangeHandler","init","params","resizeObserver","destroy","Observer","attach","options","ObserverFunc","MutationObserver","WebkitMutationObserver","mutations","observerUpdate","attributes","childList","characterData","observers","observeParents","containerParents","$el","observeSlideChildren","$wrapperEl","disconnect","useParams","instanceParams","modules","moduleName","module","useModules","modulesParams","moduleParams","moduleEventName","priority","method","eventsListeners","once","onceHandler","__emitterProxy","onAny","eventsAnyListeners","offAny","eventHandler","eventsArray","updateSize","clientWidth","clientHeight","isHorizontal","isVertical","parseInt","Number","isNaN","size","updateSlides","getDirectionLabel","property","getDirectionPropertyValue","node","label","swiperSize","rtl","rtlTranslate","wrongRTL","isVirtual","virtual","enabled","previousSlidesLength","slides","slideClass","slidesLength","snapGrid","slidesGrid","slidesSizesGrid","slidesForMargin","slideEl","slideIndex","cssMode","offsetBefore","slidesOffsetBefore","offsetAfter","slidesOffsetAfter","previousSnapGridLength","previousSlidesGridLength","spaceBetween","slidePosition","prevSlideSize","virtualSize","marginLeft","marginTop","marginRight","marginBottom","slidesNumberEvenToRows","slidesPerColumn","Math","floor","ceil","slidesPerView","slidesPerColumnFill","max","slideSize","slidesPerRow","numFullColumns","slide","newSlideOrderIndex","column","row","slidesPerGroup","groupIndex","slideIndexInGroup","columnsInGroup","min","order","slideStyles","currentTransform","currentWebKitTransform","roundLengths","paddingLeft","paddingRight","boxSizing","swiperSlideSize","centeredSlides","abs","slidesPerGroupSkip","newSlidesGrid","effect","setWrapperSize","slidesGridItem","centeredSlidesBounds","allSlidesSize","slideSizeValue","maxSnap","snap","centerInsufficientSlides","allSlidesOffset","snapIndex","watchOverflow","checkOverflow","watchSlidesProgress","watchSlidesVisibility","updateSlidesOffset","updateAutoHeight","speed","activeSlides","setTransition","visibleSlides","activeIndex","swiperSlideOffset","offsetLeft","offsetTop","updateSlidesProgress","translate","offsetCenter","slideVisibleClass","visibleSlidesIndexes","slideProgress","minTranslate","autoHeight","slideBefore","slideAfter","isVisible","progress","updateProgress","multiplier","translatesDiff","maxTranslate","isBeginning","isEnd","wasBeginning","wasEnd","updateSlidesClasses","realIndex","slideActiveClass","slideNextClass","slidePrevClass","slideDuplicateActiveClass","slideDuplicateNextClass","slideDuplicatePrevClass","activeSlide","loop","slideDuplicateClass","nextSlide","prevSlide","emitSlidesClasses","updateActiveIndex","newActiveIndex","previousIndex","previousRealIndex","previousSnapIndex","normalizeSlideIndex","skip","runCallbacksOnInit","updateClickedSlide","slideFound","clickedSlide","clickedIndex","slideToClickedSlide","getSwiperTranslate","virtualTranslate","currentTranslate","setTranslate","byController","wrapperEl","x","y","z","previousTranslate","newProgress","translateTo","runCallbacks","translateBounds","internal","animating","preventInteractionOnTransition","newTranslate","isH","scrollTo","behavior","onTranslateToWrapperTransitionEnd","transitionStart","direction","dir","slideTo","Error","indexAsNumber","isValidNumber","isFinite","initialSlide","normalizedTranslate","normalizedGird","normalizedGridNext","allowSlideNext","allowSlidePrev","t","scrollWidth","onSlideToWrapperTransitionEnd","slideToLoop","newIndex","loopedSlides","slideNext","increment","loopPreventsSlide","loopFix","_clientLeft","slidePrev","normalize","val","normalizedSnapGrid","prevSnap","prevIndex","slideReset","slideToClosest","threshold","currentSnap","nextSnap","slidesPerViewDynamic","slideToIndex","loopCreate","loopFillGroupWithBlank","blankSlidesNum","blankNode","slideBlankClass","loopAdditionalSlides","prependSlides","appendSlides","cloneNode","snapTranslate","diff","slideChanged","loopDestroy","setGrabCursor","moving","simulateTouch","isLocked","cursor","unsetGrabCursor","appendSlide","update","prependSlide","addSlide","activeIndexBuffer","baseLength","slidesBuffer","currentSlide","removeSlide","slidesIndexes","indexToRemove","removeAllSlides","onTouchStart","touchEventsData","touches","originalEvent","$targetEl","touchEventsTarget","isTouchEvent","type","which","button","isTouched","isMoved","swipingClassHasValue","noSwipingClass","shadowRoot","path","noSwiping","noSwipingSelector","allowClick","swipeHandler","currentX","targetTouches","pageX","currentY","pageY","startX","startY","edgeSwipeDetection","iOSEdgeSwipeDetection","edgeSwipeThreshold","iOSEdgeSwipeThreshold","innerWidth","preventDefault","allowTouchCallbacks","isScrolling","startMoving","touchStartTime","swipeDirection","allowThresholdMove","formElements","shouldPreventDefault","allowTouchMove","touchStartPreventDefault","touchStartForcePreventDefault","isContentEditable","onTouchMove","targetTouch","changedTouches","preventedByNestedSwiper","touchReleaseOnEdges","diffX","diffY","sqrt","touchAngle","atan2","PI","touchMoveStopPropagation","nested","stopPropagation","startTranslate","allowMomentumBounce","grabCursor","touchRatio","disableParentSwiper","resistanceRatio","resistance","followFinger","freeMode","velocities","position","time","onTouchEnd","touchEndTime","timeDiff","lastClickTime","currentPos","freeModeMomentum","lastMoveEvent","pop","velocityEvent","distance","velocity","freeModeMinimumVelocity","freeModeMomentumVelocityRatio","momentumDuration","freeModeMomentumRatio","momentumDistance","newPosition","doBounce","afterBouncePosition","bounceAmount","freeModeMomentumBounceRatio","needsLoopFix","freeModeMomentumBounce","freeModeSticky","moveDistance","currentSlideSize","longSwipesMs","stopIndex","groupSize","ratio","longSwipes","longSwipesRatio","shortSwipes","isNavButtonTarget","navigation","nextEl","prevEl","onResize","breakpoints","setBreakpoint","autoplay","running","paused","run","onClick","preventClicks","preventClicksPropagation","stopImmediatePropagation","onScroll","dummyEventAttached","dummyEventListener","attachEvents","touchEvents","start","move","end","passiveListeners","passive","cancel","updateOnWindowResize","detachEvents","breakpoint","getBreakpoint","breakpointsBase","currentBreakpoint","breakpointOnlyParams","param","paramValue","breakpointParams","originalParams","wasMultiRow","isMultiRow","containerModifierClass","emitContainerClasses","directionChanged","needsReLoop","changeDirection","base","containerEl","currentWidth","currentHeight","innerHeight","points","point","minRatio","substr","sort","b","prepareClasses","prefix","resultClasses","item","addClasses","suffixes","removeClasses","loadImage","imageEl","srcset","sizes","checkForComplete","image","onReady","isPicture","complete","onload","onerror","preloadImages","imagesToLoad","imagesLoaded","updateOnImagesReady","currentSrc","wasLocked","lastSlidePosition","url","uniqueNavElements","wrapperClass","_emitClasses","prototypes","modular","eventsEmitter","manipulation","images","extendedDefaults","Swiper","swipers","newParams","moduleParamName","swiperParams","defaults","passedParams","eventName","desktop","touchEventsTouch","touchEventsDesktop","clickTimeout","getSlideClasses","updates","spv","breakLoop","translateValue","translated","newDirection","needUpdate","currentDirection","mount","mounted","deleteInstance","cleanStyles","extendDefaults","newDefaults","installModule","use","m","prototypeGroup","protoMethod","Resize","Virtual","force","addSlidesBefore","addSlidesAfter","previousFrom","from","previousTo","previousSlidesGrid","renderSlide","previousOffset","offsetProp","slidesAfter","slidesBefore","onRendered","lazy","load","renderExternal","getSlides","slidesToRender","renderExternalUpdate","prependIndexes","appendIndexes","cache","$slideEl","numberOfNewSlides","newCache","cachedIndex","$cachedEl","cachedElIndex","beforeInit","overwriteParams","Keyboard","handle","kc","keyCode","charCode","pageUpDown","keyboard","isPageUp","isPageDown","isArrowLeft","isArrowRight","isArrowUp","isArrowDown","shiftKey","altKey","ctrlKey","metaKey","onlyInViewport","inView","swiperWidth","swiperHeight","windowWidth","windowHeight","swiperOffset","swiperCoord","returnValue","enable","disable","isEventSupported","isSupported","element","implementation","hasFeature","Mousewheel","lastScrollTime","lastEventBeforeSnap","recentWheelEvents","PIXEL_STEP","LINE_HEIGHT","PAGE_HEIGHT","sX","sY","pX","pY","wheelDelta","wheelDeltaY","wheelDeltaX","HORIZONTAL_AXIS","deltaY","deltaX","deltaMode","spinX","spinY","pixelX","pixelY","handleMouseEnter","mouseEntered","handleMouseLeave","mousewheel","eventsTarget","releaseOnEdges","delta","rtlFactor","forceToAxis","invert","positions","sensitivity","newEvent","sign","raw","shift","prevEvent","animateSlider","releaseScroll","ignoreWheelEvents","timeout","firstEvent","snapToThreshold","autoplayDisableOnInteraction","stop","thresholdDelta","thresholdTime","getTime","Navigation","toggleEl","disabled","disabledClass","tagName","$nextEl","$prevEl","lockClass","onPrevClick","onNextClick","hideOnClick","hiddenClass","toEdge","fromEdge","click","targetEl","pagination","clickable","isHidden","Pagination","current","total","paginationType","bullets","firstIndex","lastIndex","midIndex","dynamicBullets","bulletSize","dynamicMainBullets","dynamicBulletIndex","bulletActiveClass","bullet","$bullet","bulletIndex","$firstDisplayedBullet","$lastDisplayedBullet","dynamicBulletsLength","bulletsOffset","currentClass","formatFractionCurrent","totalClass","formatFractionTotal","progressbarDirection","progressbarOpposite","scale","scaleX","scaleY","progressbarFillClass","renderCustom","render","paginationHTML","numberOfBullets","renderBullet","bulletClass","bulletElement","renderFraction","renderProgressbar","clickableClass","modifierClass","progressbarOppositeClass","number","activeIndexChange","snapIndexChange","slidesLengthChange","snapGridLengthChange","Scrollbar","scrollbar","dragSize","trackSize","$dragEl","newSize","newPos","hide","opacity","divider","moveDivider","display","getPointerPosition","clientX","clientY","setDragPosition","dragStartPos","positionRatio","onDragStart","dragTimeout","onDragMove","onDragEnd","snapOnRelease","enableDraggable","activeListener","disableDraggable","$swiperEl","dragClass","dragEl","draggable","Parallax","setTransform","currentOpacity","currentScale","parallax","parallaxEl","$parallaxEl","parallaxDuration","Zoom","getDistanceBetweenTouches","x1","y1","x2","y2","onGestureStart","zoom","gesture","fakeGestureTouched","fakeGestureMoved","scaleStart","$imageEl","$imageWrapEl","containerClass","maxRatio","isScaling","onGestureChange","scaleMove","onGestureEnd","touchesStart","slideWidth","slideHeight","scaledWidth","scaledHeight","minX","maxX","minY","maxY","touchesCurrent","prevPositionX","prevPositionY","prevTime","momentumDurationX","momentumDurationY","momentumDistanceX","newPositionX","momentumDistanceY","newPositionY","onTransitionEnd","out","in","zoomedSlideClass","touchX","touchY","offsetX","offsetY","translateX","translateY","imageWidth","imageHeight","translateMinX","translateMinY","translateMaxX","translateMaxY","toggleGestures","slideSelector","enableGestures","gesturesEnabled","disableGestures","activeListenerWithCapture","touchStart","touchEnd","doubleTap","slideChange","Lazy","loadInSlide","loadInDuplicate","$images","elementClass","loadedClass","loadingClass","background","$pictureEl","sourceEl","$source","preloaderClass","slideOriginalIndex","originalSlide","duplicatedSlide","slideExist","initialImageLoaded","loadPrevNext","loadPrevNextAmount","amount","maxIndex","minIndex","checkInViewOnLoad","$scrollElement","scrollingElement","isWindow","scrollElementWidth","scrollElementHeight","scrollHandlerAttached","checkInView","loadOnTransitionStart","scroll","lazyLoad","Controller","LinearSpline","binarySearch","guess","array","i1","i3","interpolate","getInterpolateFunction","controller","spline","controlled","control","controlledTranslate","setControlledTranslate","by","inverse","setControlledTransition","A11y","getRandomNumber","randomChar","round","random","repeat","makeElFocusable","makeElNotFocusable","addElRole","role","addElRoleDescription","description","addElControls","controls","addElLabel","addElId","addElLive","live","disableEl","enableEl","onEnterOrSpaceKey","a11y","notify","lastSlideMessage","nextSlideMessage","firstSlideMessage","prevSlideMessage","message","notification","liveRegion","updateNavigation","updatePagination","bulletEl","$bulletEl","paginationBulletMessage","$containerEl","containerRoleDescriptionMessage","containerMessage","wrapperId","itemRoleDescriptionMessage","ariaLabelMessage","slideLabelMessage","notificationClass","afterInit","paginationUpdate","History","hashNavigation","paths","getPathValues","scrollToSlide","setHistoryPopState","urlOverride","URL","pathArray","part","setHistory","slugify","includes","currentState","state","slideHistory","HashNavigation","onHashCange","newHash","activeSlideHash","setHash","slideHash","watchState","Autoplay","$activeSlideEl","autoplayResult","reverseDirection","stopOnLastSlide","pause","waitForTransition","onVisibilityChange","visibilityState","disableOnInteraction","beforeTransitionStart","sliderFirstMove","Fade","tx","ty","slideOpacity","fadeEffect","crossFade","eventTriggered","triggerEvents","Cube","cubeEffect","wrapperRotate","$cubeShadowEl","shadow","slideAngle","tz","slideShadows","shadowBefore","shadowAfter","shadowOffset","shadowScale","shadowAngle","sin","cos","scale1","scale2","zFactor","Flip","flipEffect","limitRotation","rotate","rotateY","rotateX","zIndex","Coverflow","coverflowEffect","center","depth","slideOffset","offsetMultiplier","modifier","translateZ","stretch","slideTransform","$shadowBeforeEl","$shadowAfterEl","Thumbs","thumbsParams","thumbs","SwiperClass","swiperCreated","thumbsContainerClass","onThumbClick","thumbsSwiper","slideThumbActiveClass","currentIndex","initial","autoScrollOffset","useOffset","currentThumbsIndex","newThumbsIndex","prevThumbsIndex","nextThumbsIndex","thumbsToActivate","thumbActiveClass","multipleActiveThumbs","beforeDestroy","components"],"mappings":";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;EAAA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;;EACA;EACA,SAASA,QAAT,CAAkBC,GAAlB,EAAuB;EACnB,SAAQA,GAAG,KAAK,IAAR,IACJ,OAAOA,GAAP,KAAe,QADX,IAEJ,iBAAiBA,GAFb,IAGJA,GAAG,CAACC,WAAJ,KAAoBC,MAHxB;EAIH;;EACD,SAASC,MAAT,CAAgBC,MAAhB,EAAwBC,GAAxB,EAA6B;EACzB,MAAID,MAAM,KAAK,KAAK,CAApB,EAAuB;EAAEA,IAAAA,MAAM,GAAG,EAAT;EAAc;;EACvC,MAAIC,GAAG,KAAK,KAAK,CAAjB,EAAoB;EAAEA,IAAAA,GAAG,GAAG,EAAN;EAAW;;EACjCH,EAAAA,MAAM,CAACI,IAAP,CAAYD,GAAZ,EAAiBE,OAAjB,CAAyB,UAAUC,GAAV,EAAe;EACpC,QAAI,OAAOJ,MAAM,CAACI,GAAD,CAAb,KAAuB,WAA3B,EACIJ,MAAM,CAACI,GAAD,CAAN,GAAcH,GAAG,CAACG,GAAD,CAAjB,CADJ,KAEK,IAAIT,QAAQ,CAACM,GAAG,CAACG,GAAD,CAAJ,CAAR,IACLT,QAAQ,CAACK,MAAM,CAACI,GAAD,CAAP,CADH,IAELN,MAAM,CAACI,IAAP,CAAYD,GAAG,CAACG,GAAD,CAAf,EAAsBC,MAAtB,GAA+B,CAF9B,EAEiC;EAClCN,MAAAA,MAAM,CAACC,MAAM,CAACI,GAAD,CAAP,EAAcH,GAAG,CAACG,GAAD,CAAjB,CAAN;EACH;EACJ,GARD;EASH;;EAED,IAAIE,WAAW,GAAG;EACdC,EAAAA,IAAI,EAAE,EADQ;EAEdC,EAAAA,gBAAgB,EAAE,4BAAY,EAFhB;EAGdC,EAAAA,mBAAmB,EAAE,+BAAY,EAHnB;EAIdC,EAAAA,aAAa,EAAE;EACXC,IAAAA,IAAI,EAAE,gBAAY,EADP;EAEXC,IAAAA,QAAQ,EAAE;EAFC,GAJD;EAQdC,EAAAA,aAAa,EAAE,yBAAY;EACvB,WAAO,IAAP;EACH,GAVa;EAWdC,EAAAA,gBAAgB,EAAE,4BAAY;EAC1B,WAAO,EAAP;EACH,GAba;EAcdC,EAAAA,cAAc,EAAE,0BAAY;EACxB,WAAO,IAAP;EACH,GAhBa;EAiBdC,EAAAA,WAAW,EAAE,uBAAY;EACrB,WAAO;EACHC,MAAAA,SAAS,EAAE,qBAAY;EADpB,KAAP;EAGH,GArBa;EAsBdC,EAAAA,aAAa,EAAE,yBAAY;EACvB,WAAO;EACHC,MAAAA,QAAQ,EAAE,EADP;EAEHC,MAAAA,UAAU,EAAE,EAFT;EAGHC,MAAAA,KAAK,EAAE,EAHJ;EAIHC,MAAAA,YAAY,EAAE,wBAAY,EAJvB;EAKHC,MAAAA,oBAAoB,EAAE,gCAAY;EAC9B,eAAO,EAAP;EACH;EAPE,KAAP;EASH,GAhCa;EAiCdC,EAAAA,eAAe,EAAE,2BAAY;EACzB,WAAO,EAAP;EACH,GAnCa;EAoCdC,EAAAA,UAAU,EAAE,sBAAY;EACpB,WAAO,IAAP;EACH,GAtCa;EAuCdC,EAAAA,QAAQ,EAAE;EACNC,IAAAA,IAAI,EAAE,EADA;EAENC,IAAAA,IAAI,EAAE,EAFA;EAGNC,IAAAA,QAAQ,EAAE,EAHJ;EAINC,IAAAA,IAAI,EAAE,EAJA;EAKNC,IAAAA,MAAM,EAAE,EALF;EAMNC,IAAAA,QAAQ,EAAE,EANJ;EAONC,IAAAA,QAAQ,EAAE,EAPJ;EAQNC,IAAAA,MAAM,EAAE;EARF;EAvCI,CAAlB;;EAkDA,SAASC,WAAT,GAAuB;EACnB,MAAIC,GAAG,GAAG,OAAOC,QAAP,KAAoB,WAApB,GAAkCA,QAAlC,GAA6C,EAAvD;EACAtC,EAAAA,MAAM,CAACqC,GAAD,EAAM9B,WAAN,CAAN;EACA,SAAO8B,GAAP;EACH;;EAED,IAAIE,SAAS,GAAG;EACZD,EAAAA,QAAQ,EAAE/B,WADE;EAEZiC,EAAAA,SAAS,EAAE;EACPC,IAAAA,SAAS,EAAE;EADJ,GAFC;EAKZd,EAAAA,QAAQ,EAAE;EACNC,IAAAA,IAAI,EAAE,EADA;EAENC,IAAAA,IAAI,EAAE,EAFA;EAGNC,IAAAA,QAAQ,EAAE,EAHJ;EAINC,IAAAA,IAAI,EAAE,EAJA;EAKNC,IAAAA,MAAM,EAAE,EALF;EAMNC,IAAAA,QAAQ,EAAE,EANJ;EAONC,IAAAA,QAAQ,EAAE,EAPJ;EAQNC,IAAAA,MAAM,EAAE;EARF,GALE;EAeZO,EAAAA,OAAO,EAAE;EACLC,IAAAA,YAAY,EAAE,wBAAY,EADrB;EAELC,IAAAA,SAAS,EAAE,qBAAY,EAFlB;EAGLC,IAAAA,EAAE,EAAE,cAAY,EAHX;EAILC,IAAAA,IAAI,EAAE,gBAAY;EAJb,GAfG;EAqBZC,EAAAA,WAAW,EAAE,SAASA,WAAT,GAAuB;EAChC,WAAO,IAAP;EACH,GAvBW;EAwBZtC,EAAAA,gBAAgB,EAAE,4BAAY,EAxBlB;EAyBZC,EAAAA,mBAAmB,EAAE,+BAAY,EAzBrB;EA0BZsC,EAAAA,gBAAgB,EAAE,4BAAY;EAC1B,WAAO;EACHC,MAAAA,gBAAgB,EAAE,4BAAY;EAC1B,eAAO,EAAP;EACH;EAHE,KAAP;EAKH,GAhCW;EAiCZC,EAAAA,KAAK,EAAE,iBAAY,EAjCP;EAkCZC,EAAAA,IAAI,EAAE,gBAAY,EAlCN;EAmCZC,EAAAA,MAAM,EAAE,EAnCI;EAoCZC,EAAAA,UAAU,EAAE,sBAAY,EApCZ;EAqCZC,EAAAA,YAAY,EAAE,wBAAY,EArCd;EAsCZC,EAAAA,UAAU,EAAE,sBAAY;EACpB,WAAO,EAAP;EACH,GAxCW;EAyCZC,EAAAA,qBAAqB,EAAE,+BAAUC,QAAV,EAAoB;EACvC,QAAI,OAAOJ,UAAP,KAAsB,WAA1B,EAAuC;EACnCI,MAAAA,QAAQ;EACR,aAAO,IAAP;EACH;;EACD,WAAOJ,UAAU,CAACI,QAAD,EAAW,CAAX,CAAjB;EACH,GA/CW;EAgDZC,EAAAA,oBAAoB,EAAE,8BAAUC,EAAV,EAAc;EAChC,QAAI,OAAON,UAAP,KAAsB,WAA1B,EAAuC;EACnC;EACH;;EACDC,IAAAA,YAAY,CAACK,EAAD,CAAZ;EACH;EArDW,CAAhB;;EAuDA,SAASC,SAAT,GAAqB;EACjB,MAAIC,GAAG,GAAG,OAAOC,MAAP,KAAkB,WAAlB,GAAgCA,MAAhC,GAAyC,EAAnD;EACA9D,EAAAA,MAAM,CAAC6D,GAAD,EAAMtB,SAAN,CAAN;EACA,SAAOsB,GAAP;EACH;;ECnJD;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;;EAGA,SAASE,cAAT,CAAwBC,QAAxB,EAAkCC,UAAlC,EAA8C;EAC5CD,EAAAA,QAAQ,CAACE,SAAT,GAAqBnE,MAAM,CAACoE,MAAP,CAAcF,UAAU,CAACC,SAAzB,CAArB;EACAF,EAAAA,QAAQ,CAACE,SAAT,CAAmBpE,WAAnB,GAAiCkE,QAAjC;EACAA,EAAAA,QAAQ,CAACI,SAAT,GAAqBH,UAArB;EACD;;EAED,SAASI,eAAT,CAAyBC,CAAzB,EAA4B;EAC1BD,EAAAA,eAAe,GAAGtE,MAAM,CAACwE,cAAP,GAAwBxE,MAAM,CAACyE,cAA/B,GAAgD,SAASH,eAAT,CAAyBC,CAAzB,EAA4B;EAC5F,WAAOA,CAAC,CAACF,SAAF,IAAerE,MAAM,CAACyE,cAAP,CAAsBF,CAAtB,CAAtB;EACD,GAFD;EAGA,SAAOD,eAAe,CAACC,CAAD,CAAtB;EACD;;EAED,SAASG,eAAT,CAAyBH,CAAzB,EAA4BI,CAA5B,EAA+B;EAC7BD,EAAAA,eAAe,GAAG1E,MAAM,CAACwE,cAAP,IAAyB,SAASE,eAAT,CAAyBH,CAAzB,EAA4BI,CAA5B,EAA+B;EACxEJ,IAAAA,CAAC,CAACF,SAAF,GAAcM,CAAd;EACA,WAAOJ,CAAP;EACD,GAHD;;EAKA,SAAOG,eAAe,CAACH,CAAD,EAAII,CAAJ,CAAtB;EACD;;EAED,SAASC,yBAAT,GAAqC;EACnC,MAAI,OAAOC,OAAP,KAAmB,WAAnB,IAAkC,CAACA,OAAO,CAACC,SAA/C,EAA0D,OAAO,KAAP;EAC1D,MAAID,OAAO,CAACC,SAAR,CAAkBC,IAAtB,EAA4B,OAAO,KAAP;EAC5B,MAAI,OAAOC,KAAP,KAAiB,UAArB,EAAiC,OAAO,IAAP;;EAEjC,MAAI;EACF5B,IAAAA,IAAI,CAACe,SAAL,CAAec,QAAf,CAAwBC,IAAxB,CAA6BL,OAAO,CAACC,SAAR,CAAkB1B,IAAlB,EAAwB,EAAxB,EAA4B,YAAY,EAAxC,CAA7B;EACA,WAAO,IAAP;EACD,GAHD,CAGE,OAAO+B,CAAP,EAAU;EACV,WAAO,KAAP;EACD;EACF;;EAED,SAASC,UAAT,CAAoBC,MAApB,EAA4BC,IAA5B,EAAkCC,KAAlC,EAAyC;EACvC,MAAIX,yBAAyB,EAA7B,EAAiC;EAC/BQ,IAAAA,UAAU,GAAGP,OAAO,CAACC,SAArB;EACD,GAFD,MAEO;EACLM,IAAAA,UAAU,GAAG,SAASA,UAAT,CAAoBC,MAApB,EAA4BC,IAA5B,EAAkCC,KAAlC,EAAyC;EACpD,UAAIC,CAAC,GAAG,CAAC,IAAD,CAAR;EACAA,MAAAA,CAAC,CAACC,IAAF,CAAOC,KAAP,CAAaF,CAAb,EAAgBF,IAAhB;EACA,UAAIK,WAAW,GAAGC,QAAQ,CAACC,IAAT,CAAcH,KAAd,CAAoBL,MAApB,EAA4BG,CAA5B,CAAlB;EACA,UAAIM,QAAQ,GAAG,IAAIH,WAAJ,EAAf;EACA,UAAIJ,KAAJ,EAAWb,eAAe,CAACoB,QAAD,EAAWP,KAAK,CAACpB,SAAjB,CAAf;EACX,aAAO2B,QAAP;EACD,KAPD;EAQD;;EAED,SAAOV,UAAU,CAACM,KAAX,CAAiB,IAAjB,EAAuBK,SAAvB,CAAP;EACD;;EAED,SAASC,iBAAT,CAA2BC,EAA3B,EAA+B;EAC7B,SAAOL,QAAQ,CAACX,QAAT,CAAkBC,IAAlB,CAAuBe,EAAvB,EAA2BC,OAA3B,CAAmC,eAAnC,MAAwD,CAAC,CAAhE;EACD;;EAED,SAASC,gBAAT,CAA0BZ,KAA1B,EAAiC;EAC/B,MAAIa,MAAM,GAAG,OAAOC,GAAP,KAAe,UAAf,GAA4B,IAAIA,GAAJ,EAA5B,GAAwCC,SAArD;;EAEAH,EAAAA,gBAAgB,GAAG,SAASA,gBAAT,CAA0BZ,KAA1B,EAAiC;EAClD,QAAIA,KAAK,KAAK,IAAV,IAAkB,CAACS,iBAAiB,CAACT,KAAD,CAAxC,EAAiD,OAAOA,KAAP;;EAEjD,QAAI,OAAOA,KAAP,KAAiB,UAArB,EAAiC;EAC/B,YAAM,IAAIgB,SAAJ,CAAc,oDAAd,CAAN;EACD;;EAED,QAAI,OAAOH,MAAP,KAAkB,WAAtB,EAAmC;EACjC,UAAIA,MAAM,CAACI,GAAP,CAAWjB,KAAX,CAAJ,EAAuB,OAAOa,MAAM,CAACK,GAAP,CAAWlB,KAAX,CAAP;;EAEvBa,MAAAA,MAAM,CAACM,GAAP,CAAWnB,KAAX,EAAkBoB,OAAlB;EACD;;EAED,aAASA,OAAT,GAAmB;EACjB,aAAOvB,UAAU,CAACG,KAAD,EAAQQ,SAAR,EAAmBzB,eAAe,CAAC,IAAD,CAAf,CAAsBvE,WAAzC,CAAjB;EACD;;EAED4G,IAAAA,OAAO,CAACxC,SAAR,GAAoBnE,MAAM,CAACoE,MAAP,CAAcmB,KAAK,CAACpB,SAApB,EAA+B;EACjDpE,MAAAA,WAAW,EAAE;EACX6G,QAAAA,KAAK,EAAED,OADI;EAEXE,QAAAA,UAAU,EAAE,KAFD;EAGXC,QAAAA,QAAQ,EAAE,IAHC;EAIXC,QAAAA,YAAY,EAAE;EAJH;EADoC,KAA/B,CAApB;EAQA,WAAOrC,eAAe,CAACiC,OAAD,EAAUpB,KAAV,CAAtB;EACD,GA1BD;;EA4BA,SAAOY,gBAAgB,CAACZ,KAAD,CAAvB;EACD;;EAED,SAASyB,sBAAT,CAAgCC,IAAhC,EAAsC;EACpC,MAAIA,IAAI,KAAK,KAAK,CAAlB,EAAqB;EACnB,UAAM,IAAIC,cAAJ,CAAmB,2DAAnB,CAAN;EACD;;EAED,SAAOD,IAAP;EACD;EAED;;;EACA,SAASE,YAAT,CAAsBrH,GAAtB,EAA2B;EACzB,MAAIsH,KAAK,GAAGtH,GAAG,CAACuE,SAAhB;EACArE,EAAAA,MAAM,CAACqH,cAAP,CAAsBvH,GAAtB,EAA2B,WAA3B,EAAwC;EACtC2G,IAAAA,GAAG,EAAE,SAASA,GAAT,GAAe;EAClB,aAAOW,KAAP;EACD,KAHqC;EAItCV,IAAAA,GAAG,EAAE,SAASA,GAAT,CAAaE,KAAb,EAAoB;EACvBQ,MAAAA,KAAK,CAAC/C,SAAN,GAAkBuC,KAAlB;EACD;EANqC,GAAxC;EAQD;;EAED,IAAIU,IAAI,gBAAgB,UAAUC,MAAV,EAAkB;EACxCvD,EAAAA,cAAc,CAACsD,IAAD,EAAOC,MAAP,CAAd;;EAEA,WAASD,IAAT,CAAcE,KAAd,EAAqB;EACnB,QAAIC,KAAJ;;EAEAA,IAAAA,KAAK,GAAGF,MAAM,CAACrC,IAAP,CAAYQ,KAAZ,CAAkB6B,MAAlB,EAA0B,CAAC,IAAD,EAAOG,MAAP,CAAcF,KAAd,CAA1B,KAAmD,IAA3D;EACAL,IAAAA,YAAY,CAACH,sBAAsB,CAACS,KAAD,CAAvB,CAAZ;EACA,WAAOA,KAAP;EACD;;EAED,SAAOH,IAAP;EACD,CAZuB,eAYRnB,gBAAgB,CAACwB,KAAD,CAZR,CAAxB;;EAcA,SAASC,SAAT,CAAmBC,GAAnB,EAAwB;EACtB,MAAIA,GAAG,KAAK,KAAK,CAAjB,EAAoB;EAClBA,IAAAA,GAAG,GAAG,EAAN;EACD;;EAED,MAAIC,GAAG,GAAG,EAAV;EACAD,EAAAA,GAAG,CAACxH,OAAJ,CAAY,UAAU0H,EAAV,EAAc;EACxB,QAAIJ,KAAK,CAACK,OAAN,CAAcD,EAAd,CAAJ,EAAuB;EACrBD,MAAAA,GAAG,CAACrC,IAAJ,CAASC,KAAT,CAAeoC,GAAf,EAAoBF,SAAS,CAACG,EAAD,CAA7B;EACD,KAFD,MAEO;EACLD,MAAAA,GAAG,CAACrC,IAAJ,CAASsC,EAAT;EACD;EACF,GAND;EAOA,SAAOD,GAAP;EACD;;EACD,SAASG,WAAT,CAAqBJ,GAArB,EAA0BnE,QAA1B,EAAoC;EAClC,SAAOiE,KAAK,CAACxD,SAAN,CAAgB+D,MAAhB,CAAuBhD,IAAvB,CAA4B2C,GAA5B,EAAiCnE,QAAjC,CAAP;EACD;;EACD,SAASyE,WAAT,CAAqBN,GAArB,EAA0B;EACxB,MAAIO,WAAW,GAAG,EAAlB;;EAEA,OAAK,IAAIC,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGR,GAAG,CAACtH,MAAxB,EAAgC8H,CAAC,IAAI,CAArC,EAAwC;EACtC,QAAID,WAAW,CAAClC,OAAZ,CAAoB2B,GAAG,CAACQ,CAAD,CAAvB,MAAgC,CAAC,CAArC,EAAwCD,WAAW,CAAC3C,IAAZ,CAAiBoC,GAAG,CAACQ,CAAD,CAApB;EACzC;;EAED,SAAOD,WAAP;EACD;;EAOD,SAASE,GAAT,CAAaC,QAAb,EAAuBC,OAAvB,EAAgC;EAC9B,MAAI,OAAOD,QAAP,KAAoB,QAAxB,EAAkC;EAChC,WAAO,CAACA,QAAD,CAAP;EACD;;EAED,MAAI/C,CAAC,GAAG,EAAR;EACA,MAAIsC,GAAG,GAAGU,OAAO,CAACxH,gBAAR,CAAyBuH,QAAzB,CAAV;;EAEA,OAAK,IAAIF,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGP,GAAG,CAACvH,MAAxB,EAAgC8H,CAAC,IAAI,CAArC,EAAwC;EACtC7C,IAAAA,CAAC,CAACC,IAAF,CAAOqC,GAAG,CAACO,CAAD,CAAV;EACD;;EAED,SAAO7C,CAAP;EACD;;EAED,SAASiD,CAAT,CAAWF,QAAX,EAAqBC,OAArB,EAA8B;EAC5B,MAAIzE,MAAM,GAAGF,SAAS,EAAtB;EACA,MAAItB,QAAQ,GAAGF,WAAW,EAA1B;EACA,MAAIwF,GAAG,GAAG,EAAV;;EAEA,MAAI,CAACW,OAAD,IAAYD,QAAQ,YAAYjB,IAApC,EAA0C;EACxC,WAAOiB,QAAP;EACD;;EAED,MAAI,CAACA,QAAL,EAAe;EACb,WAAO,IAAIjB,IAAJ,CAASO,GAAT,CAAP;EACD;;EAED,MAAI,OAAOU,QAAP,KAAoB,QAAxB,EAAkC;EAChC,QAAIG,IAAI,GAAGH,QAAQ,CAACI,IAAT,EAAX;;EAEA,QAAID,IAAI,CAACxC,OAAL,CAAa,GAAb,KAAqB,CAArB,IAA0BwC,IAAI,CAACxC,OAAL,CAAa,GAAb,KAAqB,CAAnD,EAAsD;EACpD,UAAI0C,QAAQ,GAAG,KAAf;EACA,UAAIF,IAAI,CAACxC,OAAL,CAAa,KAAb,MAAwB,CAA5B,EAA+B0C,QAAQ,GAAG,IAAX;EAC/B,UAAIF,IAAI,CAACxC,OAAL,CAAa,KAAb,MAAwB,CAA5B,EAA+B0C,QAAQ,GAAG,OAAX;EAC/B,UAAIF,IAAI,CAACxC,OAAL,CAAa,KAAb,MAAwB,CAAxB,IAA6BwC,IAAI,CAACxC,OAAL,CAAa,KAAb,MAAwB,CAAzD,EAA4D0C,QAAQ,GAAG,IAAX;EAC5D,UAAIF,IAAI,CAACxC,OAAL,CAAa,QAAb,MAA2B,CAA/B,EAAkC0C,QAAQ,GAAG,OAAX;EAClC,UAAIF,IAAI,CAACxC,OAAL,CAAa,SAAb,MAA4B,CAAhC,EAAmC0C,QAAQ,GAAG,QAAX;EACnC,UAAIC,UAAU,GAAGtG,QAAQ,CAACnB,aAAT,CAAuBwH,QAAvB,CAAjB;EACAC,MAAAA,UAAU,CAACC,SAAX,GAAuBJ,IAAvB;;EAEA,WAAK,IAAIL,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGQ,UAAU,CAACvH,UAAX,CAAsBf,MAA1C,EAAkD8H,CAAC,IAAI,CAAvD,EAA0D;EACxDR,QAAAA,GAAG,CAACpC,IAAJ,CAASoD,UAAU,CAACvH,UAAX,CAAsB+G,CAAtB,CAAT;EACD;EACF,KAbD,MAaO;EACLR,MAAAA,GAAG,GAAGS,GAAG,CAACC,QAAQ,CAACI,IAAT,EAAD,EAAkBH,OAAO,IAAIjG,QAA7B,CAAT;EACD,KAlB+B;;EAoBjC,GApBD,MAoBO,IAAIgG,QAAQ,CAACQ,QAAT,IAAqBR,QAAQ,KAAKxE,MAAlC,IAA4CwE,QAAQ,KAAKhG,QAA7D,EAAuE;EAC5EsF,IAAAA,GAAG,CAACpC,IAAJ,CAAS8C,QAAT;EACD,GAFM,MAEA,IAAIZ,KAAK,CAACK,OAAN,CAAcO,QAAd,CAAJ,EAA6B;EAClC,QAAIA,QAAQ,YAAYjB,IAAxB,EAA8B,OAAOiB,QAAP;EAC9BV,IAAAA,GAAG,GAAGU,QAAN;EACD;;EAED,SAAO,IAAIjB,IAAJ,CAASa,WAAW,CAACN,GAAD,CAApB,CAAP;EACD;;EAEDY,CAAC,CAACxC,EAAF,GAAOqB,IAAI,CAACnD,SAAZ;;EAEA,SAAS6E,QAAT,GAAoB;EAClB,OAAK,IAAIC,IAAI,GAAGlD,SAAS,CAACxF,MAArB,EAA6B2I,OAAO,GAAG,IAAIvB,KAAJ,CAAUsB,IAAV,CAAvC,EAAwDE,IAAI,GAAG,CAApE,EAAuEA,IAAI,GAAGF,IAA9E,EAAoFE,IAAI,EAAxF,EAA4F;EAC1FD,IAAAA,OAAO,CAACC,IAAD,CAAP,GAAgBpD,SAAS,CAACoD,IAAD,CAAzB;EACD;;EAED,MAAIC,UAAU,GAAGxB,SAAS,CAACsB,OAAO,CAACG,GAAR,CAAY,UAAUC,CAAV,EAAa;EAClD,WAAOA,CAAC,CAACC,KAAF,CAAQ,GAAR,CAAP;EACD,GAF0B,CAAD,CAA1B;EAGA,OAAKlJ,OAAL,CAAa,UAAU0H,EAAV,EAAc;EACzB,QAAIyB,aAAJ;;EAEA,KAACA,aAAa,GAAGzB,EAAE,CAAC0B,SAApB,EAA+BC,GAA/B,CAAmChE,KAAnC,CAAyC8D,aAAzC,EAAwDJ,UAAxD;EACD,GAJD;EAKA,SAAO,IAAP;EACD;;EAED,SAASO,WAAT,GAAuB;EACrB,OAAK,IAAIC,KAAK,GAAG7D,SAAS,CAACxF,MAAtB,EAA8B2I,OAAO,GAAG,IAAIvB,KAAJ,CAAUiC,KAAV,CAAxC,EAA0DC,KAAK,GAAG,CAAvE,EAA0EA,KAAK,GAAGD,KAAlF,EAAyFC,KAAK,EAA9F,EAAkG;EAChGX,IAAAA,OAAO,CAACW,KAAD,CAAP,GAAiB9D,SAAS,CAAC8D,KAAD,CAA1B;EACD;;EAED,MAAIT,UAAU,GAAGxB,SAAS,CAACsB,OAAO,CAACG,GAAR,CAAY,UAAUC,CAAV,EAAa;EAClD,WAAOA,CAAC,CAACC,KAAF,CAAQ,GAAR,CAAP;EACD,GAF0B,CAAD,CAA1B;EAGA,OAAKlJ,OAAL,CAAa,UAAU0H,EAAV,EAAc;EACzB,QAAI+B,cAAJ;;EAEA,KAACA,cAAc,GAAG/B,EAAE,CAAC0B,SAArB,EAAgCM,MAAhC,CAAuCrE,KAAvC,CAA6CoE,cAA7C,EAA6DV,UAA7D;EACD,GAJD;EAKA,SAAO,IAAP;EACD;;EAED,SAASY,WAAT,GAAuB;EACrB,OAAK,IAAIC,KAAK,GAAGlE,SAAS,CAACxF,MAAtB,EAA8B2I,OAAO,GAAG,IAAIvB,KAAJ,CAAUsC,KAAV,CAAxC,EAA0DC,KAAK,GAAG,CAAvE,EAA0EA,KAAK,GAAGD,KAAlF,EAAyFC,KAAK,EAA9F,EAAkG;EAChGhB,IAAAA,OAAO,CAACgB,KAAD,CAAP,GAAiBnE,SAAS,CAACmE,KAAD,CAA1B;EACD;;EAED,MAAId,UAAU,GAAGxB,SAAS,CAACsB,OAAO,CAACG,GAAR,CAAY,UAAUC,CAAV,EAAa;EAClD,WAAOA,CAAC,CAACC,KAAF,CAAQ,GAAR,CAAP;EACD,GAF0B,CAAD,CAA1B;EAGA,OAAKlJ,OAAL,CAAa,UAAU0H,EAAV,EAAc;EACzBqB,IAAAA,UAAU,CAAC/I,OAAX,CAAmB,UAAU8J,SAAV,EAAqB;EACtCpC,MAAAA,EAAE,CAAC0B,SAAH,CAAaW,MAAb,CAAoBD,SAApB;EACD,KAFD;EAGD,GAJD;EAKD;;EAED,SAASE,QAAT,GAAoB;EAClB,OAAK,IAAIC,KAAK,GAAGvE,SAAS,CAACxF,MAAtB,EAA8B2I,OAAO,GAAG,IAAIvB,KAAJ,CAAU2C,KAAV,CAAxC,EAA0DC,KAAK,GAAG,CAAvE,EAA0EA,KAAK,GAAGD,KAAlF,EAAyFC,KAAK,EAA9F,EAAkG;EAChGrB,IAAAA,OAAO,CAACqB,KAAD,CAAP,GAAiBxE,SAAS,CAACwE,KAAD,CAA1B;EACD;;EAED,MAAInB,UAAU,GAAGxB,SAAS,CAACsB,OAAO,CAACG,GAAR,CAAY,UAAUC,CAAV,EAAa;EAClD,WAAOA,CAAC,CAACC,KAAF,CAAQ,GAAR,CAAP;EACD,GAF0B,CAAD,CAA1B;EAGA,SAAOtB,WAAW,CAAC,IAAD,EAAO,UAAUF,EAAV,EAAc;EACrC,WAAOqB,UAAU,CAAClB,MAAX,CAAkB,UAAUiC,SAAV,EAAqB;EAC5C,aAAOpC,EAAE,CAAC0B,SAAH,CAAae,QAAb,CAAsBL,SAAtB,CAAP;EACD,KAFM,EAEJ5J,MAFI,GAEK,CAFZ;EAGD,GAJiB,CAAX,CAIJA,MAJI,GAIK,CAJZ;EAKD;;EAED,SAASkK,IAAT,CAAcC,KAAd,EAAqB9D,KAArB,EAA4B;EAC1B,MAAIb,SAAS,CAACxF,MAAV,KAAqB,CAArB,IAA0B,OAAOmK,KAAP,KAAiB,QAA/C,EAAyD;EACvD;EACA,QAAI,KAAK,CAAL,CAAJ,EAAa,OAAO,KAAK,CAAL,EAAQC,YAAR,CAAqBD,KAArB,CAAP;EACb,WAAOpE,SAAP;EACD,GALyB;;;EAQ1B,OAAK,IAAI+B,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAItC,SAAS,CAACxF,MAAV,KAAqB,CAAzB,EAA4B;EAC1B;EACA,WAAK8H,CAAL,EAAQ7G,YAAR,CAAqBkJ,KAArB,EAA4B9D,KAA5B;EACD,KAHD,MAGO;EACL;EACA,WAAK,IAAIgE,QAAT,IAAqBF,KAArB,EAA4B;EAC1B,aAAKrC,CAAL,EAAQuC,QAAR,IAAoBF,KAAK,CAACE,QAAD,CAAzB;EACA,aAAKvC,CAAL,EAAQ7G,YAAR,CAAqBoJ,QAArB,EAA+BF,KAAK,CAACE,QAAD,CAApC;EACD;EACF;EACF;;EAED,SAAO,IAAP;EACD;;EAED,SAASC,UAAT,CAAoBJ,IAApB,EAA0B;EACxB,OAAK,IAAIpC,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,SAAKA,CAAL,EAAQyC,eAAR,CAAwBL,IAAxB;EACD;;EAED,SAAO,IAAP;EACD;;EAoID,SAASM,SAAT,CAAmBA,SAAnB,EAA8B;EAC5B,OAAK,IAAI1C,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,SAAKA,CAAL,EAAQ9G,KAAR,CAAcwJ,SAAd,GAA0BA,SAA1B;EACD;;EAED,SAAO,IAAP;EACD;;EAED,SAASC,UAAT,CAAoBC,QAApB,EAA8B;EAC5B,OAAK,IAAI5C,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,SAAKA,CAAL,EAAQ9G,KAAR,CAAc2J,kBAAd,GAAmC,OAAOD,QAAP,KAAoB,QAApB,GAA+BA,QAAQ,GAAG,IAA1C,GAAiDA,QAApF;EACD;;EAED,SAAO,IAAP;EACD;;EAED,SAASE,EAAT,GAAc;EACZ,OAAK,IAAIC,KAAK,GAAGrF,SAAS,CAACxF,MAAtB,EAA8B+E,IAAI,GAAG,IAAIqC,KAAJ,CAAUyD,KAAV,CAArC,EAAuDC,KAAK,GAAG,CAApE,EAAuEA,KAAK,GAAGD,KAA/E,EAAsFC,KAAK,EAA3F,EAA+F;EAC7F/F,IAAAA,IAAI,CAAC+F,KAAD,CAAJ,GAActF,SAAS,CAACsF,KAAD,CAAvB;EACD;;EAED,MAAIC,SAAS,GAAGhG,IAAI,CAAC,CAAD,CAApB;EAAA,MACIiG,cAAc,GAAGjG,IAAI,CAAC,CAAD,CADzB;EAAA,MAEIkG,QAAQ,GAAGlG,IAAI,CAAC,CAAD,CAFnB;EAAA,MAGImG,OAAO,GAAGnG,IAAI,CAAC,CAAD,CAHlB;;EAKA,MAAI,OAAOA,IAAI,CAAC,CAAD,CAAX,KAAmB,UAAvB,EAAmC;EACjCgG,IAAAA,SAAS,GAAGhG,IAAI,CAAC,CAAD,CAAhB;EACAkG,IAAAA,QAAQ,GAAGlG,IAAI,CAAC,CAAD,CAAf;EACAmG,IAAAA,OAAO,GAAGnG,IAAI,CAAC,CAAD,CAAd;EACAiG,IAAAA,cAAc,GAAGjF,SAAjB;EACD;;EAED,MAAI,CAACmF,OAAL,EAAcA,OAAO,GAAG,KAAV;;EAEd,WAASC,eAAT,CAAyBvG,CAAzB,EAA4B;EAC1B,QAAIjF,MAAM,GAAGiF,CAAC,CAACjF,MAAf;EACA,QAAI,CAACA,MAAL,EAAa;EACb,QAAIyL,SAAS,GAAGxG,CAAC,CAACjF,MAAF,CAAS0L,aAAT,IAA0B,EAA1C;;EAEA,QAAID,SAAS,CAACzF,OAAV,CAAkBf,CAAlB,IAAuB,CAA3B,EAA8B;EAC5BwG,MAAAA,SAAS,CAACE,OAAV,CAAkB1G,CAAlB;EACD;;EAED,QAAIsD,CAAC,CAACvI,MAAD,CAAD,CAAU4L,EAAV,CAAaP,cAAb,CAAJ,EAAkCC,QAAQ,CAAC9F,KAAT,CAAexF,MAAf,EAAuByL,SAAvB,EAAlC,KAAyE;EACvE,UAAII,QAAQ,GAAGtD,CAAC,CAACvI,MAAD,CAAD,CAAU8L,OAAV,EAAf,CADuE;;;EAIvE,WAAK,IAAIC,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGF,QAAQ,CAACxL,MAA7B,EAAqC0L,CAAC,IAAI,CAA1C,EAA6C;EAC3C,YAAIxD,CAAC,CAACsD,QAAQ,CAACE,CAAD,CAAT,CAAD,CAAeH,EAAf,CAAkBP,cAAlB,CAAJ,EAAuCC,QAAQ,CAAC9F,KAAT,CAAeqG,QAAQ,CAACE,CAAD,CAAvB,EAA4BN,SAA5B;EACxC;EACF;EACF;;EAED,WAASO,WAAT,CAAqB/G,CAArB,EAAwB;EACtB,QAAIwG,SAAS,GAAGxG,CAAC,IAAIA,CAAC,CAACjF,MAAP,GAAgBiF,CAAC,CAACjF,MAAF,CAAS0L,aAAT,IAA0B,EAA1C,GAA+C,EAA/D;;EAEA,QAAID,SAAS,CAACzF,OAAV,CAAkBf,CAAlB,IAAuB,CAA3B,EAA8B;EAC5BwG,MAAAA,SAAS,CAACE,OAAV,CAAkB1G,CAAlB;EACD;;EAEDqG,IAAAA,QAAQ,CAAC9F,KAAT,CAAe,IAAf,EAAqBiG,SAArB;EACD;;EAED,MAAIQ,MAAM,GAAGb,SAAS,CAAC/B,KAAV,CAAgB,GAAhB,CAAb;EACA,MAAI6C,CAAJ;;EAEA,OAAK,IAAI/D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAIN,EAAE,GAAG,KAAKM,CAAL,CAAT;;EAEA,QAAI,CAACkD,cAAL,EAAqB;EACnB,WAAKa,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAGD,MAAM,CAAC5L,MAAvB,EAA+B6L,CAAC,IAAI,CAApC,EAAuC;EACrC,YAAIC,KAAK,GAAGF,MAAM,CAACC,CAAD,CAAlB;EACA,YAAI,CAACrE,EAAE,CAACuE,aAAR,EAAuBvE,EAAE,CAACuE,aAAH,GAAmB,EAAnB;EACvB,YAAI,CAACvE,EAAE,CAACuE,aAAH,CAAiBD,KAAjB,CAAL,EAA8BtE,EAAE,CAACuE,aAAH,CAAiBD,KAAjB,IAA0B,EAA1B;EAC9BtE,QAAAA,EAAE,CAACuE,aAAH,CAAiBD,KAAjB,EAAwB5G,IAAxB,CAA6B;EAC3B+F,UAAAA,QAAQ,EAAEA,QADiB;EAE3Be,UAAAA,aAAa,EAAEL;EAFY,SAA7B;EAIAnE,QAAAA,EAAE,CAACrH,gBAAH,CAAoB2L,KAApB,EAA2BH,WAA3B,EAAwCT,OAAxC;EACD;EACF,KAXD,MAWO;EACL;EACA,WAAKW,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAGD,MAAM,CAAC5L,MAAvB,EAA+B6L,CAAC,IAAI,CAApC,EAAuC;EACrC,YAAII,MAAM,GAAGL,MAAM,CAACC,CAAD,CAAnB;EACA,YAAI,CAACrE,EAAE,CAAC0E,iBAAR,EAA2B1E,EAAE,CAAC0E,iBAAH,GAAuB,EAAvB;EAC3B,YAAI,CAAC1E,EAAE,CAAC0E,iBAAH,CAAqBD,MAArB,CAAL,EAAmCzE,EAAE,CAAC0E,iBAAH,CAAqBD,MAArB,IAA+B,EAA/B;;EAEnCzE,QAAAA,EAAE,CAAC0E,iBAAH,CAAqBD,MAArB,EAA6B/G,IAA7B,CAAkC;EAChC+F,UAAAA,QAAQ,EAAEA,QADsB;EAEhCe,UAAAA,aAAa,EAAEb;EAFiB,SAAlC;;EAKA3D,QAAAA,EAAE,CAACrH,gBAAH,CAAoB8L,MAApB,EAA4Bd,eAA5B,EAA6CD,OAA7C;EACD;EACF;EACF;;EAED,SAAO,IAAP;EACD;;EAED,SAASiB,GAAT,GAAe;EACb,OAAK,IAAIC,KAAK,GAAG5G,SAAS,CAACxF,MAAtB,EAA8B+E,IAAI,GAAG,IAAIqC,KAAJ,CAAUgF,KAAV,CAArC,EAAuDC,KAAK,GAAG,CAApE,EAAuEA,KAAK,GAAGD,KAA/E,EAAsFC,KAAK,EAA3F,EAA+F;EAC7FtH,IAAAA,IAAI,CAACsH,KAAD,CAAJ,GAAc7G,SAAS,CAAC6G,KAAD,CAAvB;EACD;;EAED,MAAItB,SAAS,GAAGhG,IAAI,CAAC,CAAD,CAApB;EAAA,MACIiG,cAAc,GAAGjG,IAAI,CAAC,CAAD,CADzB;EAAA,MAEIkG,QAAQ,GAAGlG,IAAI,CAAC,CAAD,CAFnB;EAAA,MAGImG,OAAO,GAAGnG,IAAI,CAAC,CAAD,CAHlB;;EAKA,MAAI,OAAOA,IAAI,CAAC,CAAD,CAAX,KAAmB,UAAvB,EAAmC;EACjCgG,IAAAA,SAAS,GAAGhG,IAAI,CAAC,CAAD,CAAhB;EACAkG,IAAAA,QAAQ,GAAGlG,IAAI,CAAC,CAAD,CAAf;EACAmG,IAAAA,OAAO,GAAGnG,IAAI,CAAC,CAAD,CAAd;EACAiG,IAAAA,cAAc,GAAGjF,SAAjB;EACD;;EAED,MAAI,CAACmF,OAAL,EAAcA,OAAO,GAAG,KAAV;EACd,MAAIU,MAAM,GAAGb,SAAS,CAAC/B,KAAV,CAAgB,GAAhB,CAAb;;EAEA,OAAK,IAAIlB,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG8D,MAAM,CAAC5L,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,QAAIgE,KAAK,GAAGF,MAAM,CAAC9D,CAAD,CAAlB;;EAEA,SAAK,IAAI+D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK7L,MAAzB,EAAiC6L,CAAC,IAAI,CAAtC,EAAyC;EACvC,UAAIrE,EAAE,GAAG,KAAKqE,CAAL,CAAT;EACA,UAAIS,QAAQ,GAAG,KAAK,CAApB;;EAEA,UAAI,CAACtB,cAAD,IAAmBxD,EAAE,CAACuE,aAA1B,EAAyC;EACvCO,QAAAA,QAAQ,GAAG9E,EAAE,CAACuE,aAAH,CAAiBD,KAAjB,CAAX;EACD,OAFD,MAEO,IAAId,cAAc,IAAIxD,EAAE,CAAC0E,iBAAzB,EAA4C;EACjDI,QAAAA,QAAQ,GAAG9E,EAAE,CAAC0E,iBAAH,CAAqBJ,KAArB,CAAX;EACD;;EAED,UAAIQ,QAAQ,IAAIA,QAAQ,CAACtM,MAAzB,EAAiC;EAC/B,aAAK,IAAI0L,CAAC,GAAGY,QAAQ,CAACtM,MAAT,GAAkB,CAA/B,EAAkC0L,CAAC,IAAI,CAAvC,EAA0CA,CAAC,IAAI,CAA/C,EAAkD;EAChD,cAAIa,OAAO,GAAGD,QAAQ,CAACZ,CAAD,CAAtB;;EAEA,cAAIT,QAAQ,IAAIsB,OAAO,CAACtB,QAAR,KAAqBA,QAArC,EAA+C;EAC7CzD,YAAAA,EAAE,CAACpH,mBAAH,CAAuB0L,KAAvB,EAA8BS,OAAO,CAACP,aAAtC,EAAqDd,OAArD;EACAoB,YAAAA,QAAQ,CAACE,MAAT,CAAgBd,CAAhB,EAAmB,CAAnB;EACD,WAHD,MAGO,IAAIT,QAAQ,IAAIsB,OAAO,CAACtB,QAApB,IAAgCsB,OAAO,CAACtB,QAAR,CAAiBwB,SAAjD,IAA8DF,OAAO,CAACtB,QAAR,CAAiBwB,SAAjB,KAA+BxB,QAAjG,EAA2G;EAChHzD,YAAAA,EAAE,CAACpH,mBAAH,CAAuB0L,KAAvB,EAA8BS,OAAO,CAACP,aAAtC,EAAqDd,OAArD;EACAoB,YAAAA,QAAQ,CAACE,MAAT,CAAgBd,CAAhB,EAAmB,CAAnB;EACD,WAHM,MAGA,IAAI,CAACT,QAAL,EAAe;EACpBzD,YAAAA,EAAE,CAACpH,mBAAH,CAAuB0L,KAAvB,EAA8BS,OAAO,CAACP,aAAtC,EAAqDd,OAArD;EACAoB,YAAAA,QAAQ,CAACE,MAAT,CAAgBd,CAAhB,EAAmB,CAAnB;EACD;EACF;EACF;EACF;EACF;;EAED,SAAO,IAAP;EACD;;EAsCD,SAASgB,OAAT,GAAmB;EACjB,MAAIlJ,MAAM,GAAGF,SAAS,EAAtB;;EAEA,OAAK,IAAIqJ,KAAK,GAAGnH,SAAS,CAACxF,MAAtB,EAA8B+E,IAAI,GAAG,IAAIqC,KAAJ,CAAUuF,KAAV,CAArC,EAAuDC,KAAK,GAAG,CAApE,EAAuEA,KAAK,GAAGD,KAA/E,EAAsFC,KAAK,EAA3F,EAA+F;EAC7F7H,IAAAA,IAAI,CAAC6H,KAAD,CAAJ,GAAcpH,SAAS,CAACoH,KAAD,CAAvB;EACD;;EAED,MAAIhB,MAAM,GAAG7G,IAAI,CAAC,CAAD,CAAJ,CAAQiE,KAAR,CAAc,GAAd,CAAb;EACA,MAAIoC,SAAS,GAAGrG,IAAI,CAAC,CAAD,CAApB;;EAEA,OAAK,IAAI+C,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG8D,MAAM,CAAC5L,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,QAAIgE,KAAK,GAAGF,MAAM,CAAC9D,CAAD,CAAlB;;EAEA,SAAK,IAAI+D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK7L,MAAzB,EAAiC6L,CAAC,IAAI,CAAtC,EAAyC;EACvC,UAAIrE,EAAE,GAAG,KAAKqE,CAAL,CAAT;;EAEA,UAAIrI,MAAM,CAACf,WAAX,EAAwB;EACtB,YAAIoK,GAAG,GAAG,IAAIrJ,MAAM,CAACf,WAAX,CAAuBqJ,KAAvB,EAA8B;EACtCgB,UAAAA,MAAM,EAAE1B,SAD8B;EAEtC2B,UAAAA,OAAO,EAAE,IAF6B;EAGtCC,UAAAA,UAAU,EAAE;EAH0B,SAA9B,CAAV;EAKAxF,QAAAA,EAAE,CAAC6D,aAAH,GAAmBtG,IAAI,CAAC4C,MAAL,CAAY,UAAUsF,IAAV,EAAgBC,SAAhB,EAA2B;EACxD,iBAAOA,SAAS,GAAG,CAAnB;EACD,SAFkB,CAAnB;EAGA1F,QAAAA,EAAE,CAAC2F,aAAH,CAAiBN,GAAjB;EACArF,QAAAA,EAAE,CAAC6D,aAAH,GAAmB,EAAnB;EACA,eAAO7D,EAAE,CAAC6D,aAAV;EACD;EACF;EACF;;EAED,SAAO,IAAP;EACD;;EAED,SAAS+B,aAAT,CAAuBjK,QAAvB,EAAiC;EAC/B,MAAIkK,GAAG,GAAG,IAAV;;EAEA,WAASC,YAAT,CAAsB1I,CAAtB,EAAyB;EACvB,QAAIA,CAAC,CAACjF,MAAF,KAAa,IAAjB,EAAuB;EACvBwD,IAAAA,QAAQ,CAACwB,IAAT,CAAc,IAAd,EAAoBC,CAApB;EACAyI,IAAAA,GAAG,CAAClB,GAAJ,CAAQ,eAAR,EAAyBmB,YAAzB;EACD;;EAED,MAAInK,QAAJ,EAAc;EACZkK,IAAAA,GAAG,CAACzC,EAAJ,CAAO,eAAP,EAAwB0C,YAAxB;EACD;;EAED,SAAO,IAAP;EACD;;EAgCD,SAASC,UAAT,CAAoBC,cAApB,EAAoC;EAClC,MAAI,KAAKxN,MAAL,GAAc,CAAlB,EAAqB;EACnB,QAAIwN,cAAJ,EAAoB;EAClB,UAAIC,OAAO,GAAG,KAAKC,MAAL,EAAd;;EAEA,aAAO,KAAK,CAAL,EAAQC,WAAR,GAAsBC,UAAU,CAACH,OAAO,CAAC9K,gBAAR,CAAyB,cAAzB,CAAD,CAAhC,GAA6EiL,UAAU,CAACH,OAAO,CAAC9K,gBAAR,CAAyB,aAAzB,CAAD,CAA9F;EACD;;EAED,WAAO,KAAK,CAAL,EAAQgL,WAAf;EACD;;EAED,SAAO,IAAP;EACD;;EAgBD,SAASE,WAAT,CAAqBL,cAArB,EAAqC;EACnC,MAAI,KAAKxN,MAAL,GAAc,CAAlB,EAAqB;EACnB,QAAIwN,cAAJ,EAAoB;EAClB,UAAIM,QAAQ,GAAG,KAAKJ,MAAL,EAAf;;EAEA,aAAO,KAAK,CAAL,EAAQK,YAAR,GAAuBH,UAAU,CAACE,QAAQ,CAACnL,gBAAT,CAA0B,YAA1B,CAAD,CAAjC,GAA6EiL,UAAU,CAACE,QAAQ,CAACnL,gBAAT,CAA0B,eAA1B,CAAD,CAA9F;EACD;;EAED,WAAO,KAAK,CAAL,EAAQoL,YAAf;EACD;;EAED,SAAO,IAAP;EACD;;EAED,SAASC,MAAT,GAAkB;EAChB,MAAI,KAAKhO,MAAL,GAAc,CAAlB,EAAqB;EACnB,QAAIwD,MAAM,GAAGF,SAAS,EAAtB;EACA,QAAItB,QAAQ,GAAGF,WAAW,EAA1B;EACA,QAAI0F,EAAE,GAAG,KAAK,CAAL,CAAT;EACA,QAAIyG,GAAG,GAAGzG,EAAE,CAAC0G,qBAAH,EAAV;EACA,QAAIhO,IAAI,GAAG8B,QAAQ,CAAC9B,IAApB;EACA,QAAIiO,SAAS,GAAG3G,EAAE,CAAC2G,SAAH,IAAgBjO,IAAI,CAACiO,SAArB,IAAkC,CAAlD;EACA,QAAIC,UAAU,GAAG5G,EAAE,CAAC4G,UAAH,IAAiBlO,IAAI,CAACkO,UAAtB,IAAoC,CAArD;EACA,QAAIC,SAAS,GAAG7G,EAAE,KAAKhE,MAAP,GAAgBA,MAAM,CAAC8K,OAAvB,GAAiC9G,EAAE,CAAC6G,SAApD;EACA,QAAIE,UAAU,GAAG/G,EAAE,KAAKhE,MAAP,GAAgBA,MAAM,CAACgL,OAAvB,GAAiChH,EAAE,CAAC+G,UAArD;EACA,WAAO;EACLE,MAAAA,GAAG,EAAER,GAAG,CAACQ,GAAJ,GAAUJ,SAAV,GAAsBF,SADtB;EAELO,MAAAA,IAAI,EAAET,GAAG,CAACS,IAAJ,GAAWH,UAAX,GAAwBH;EAFzB,KAAP;EAID;;EAED,SAAO,IAAP;EACD;;EA6BD,SAASV,MAAT,GAAkB;EAChB,MAAIlK,MAAM,GAAGF,SAAS,EAAtB;EACA,MAAI,KAAK,CAAL,CAAJ,EAAa,OAAOE,MAAM,CAACd,gBAAP,CAAwB,KAAK,CAAL,CAAxB,EAAiC,IAAjC,CAAP;EACb,SAAO,EAAP;EACD;;EAED,SAASiM,GAAT,CAAaC,KAAb,EAAoBvI,KAApB,EAA2B;EACzB,MAAI7C,MAAM,GAAGF,SAAS,EAAtB;EACA,MAAIwE,CAAJ;;EAEA,MAAItC,SAAS,CAACxF,MAAV,KAAqB,CAAzB,EAA4B;EAC1B,QAAI,OAAO4O,KAAP,KAAiB,QAArB,EAA+B;EAC7B;EACA,UAAI,KAAK,CAAL,CAAJ,EAAa,OAAOpL,MAAM,CAACd,gBAAP,CAAwB,KAAK,CAAL,CAAxB,EAAiC,IAAjC,EAAuCC,gBAAvC,CAAwDiM,KAAxD,CAAP;EACd,KAHD,MAGO;EACL;EACA,WAAK9G,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAG,KAAK9H,MAArB,EAA6B8H,CAAC,IAAI,CAAlC,EAAqC;EACnC,aAAK,IAAI+G,KAAT,IAAkBD,KAAlB,EAAyB;EACvB,eAAK9G,CAAL,EAAQ9G,KAAR,CAAc6N,KAAd,IAAuBD,KAAK,CAACC,KAAD,CAA5B;EACD;EACF;;EAED,aAAO,IAAP;EACD;EACF;;EAED,MAAIrJ,SAAS,CAACxF,MAAV,KAAqB,CAArB,IAA0B,OAAO4O,KAAP,KAAiB,QAA/C,EAAyD;EACvD;EACA,SAAK9G,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAG,KAAK9H,MAArB,EAA6B8H,CAAC,IAAI,CAAlC,EAAqC;EACnC,WAAKA,CAAL,EAAQ9G,KAAR,CAAc4N,KAAd,IAAuBvI,KAAvB;EACD;;EAED,WAAO,IAAP;EACD;;EAED,SAAO,IAAP;EACD;;EAED,SAASyI,IAAT,CAAc3L,QAAd,EAAwB;EACtB,MAAI,CAACA,QAAL,EAAe,OAAO,IAAP;EACf,OAAKrD,OAAL,CAAa,UAAU0H,EAAV,EAAcuH,KAAd,EAAqB;EAChC5L,IAAAA,QAAQ,CAACgC,KAAT,CAAeqC,EAAf,EAAmB,CAACA,EAAD,EAAKuH,KAAL,CAAnB;EACD,GAFD;EAGA,SAAO,IAAP;EACD;;EAED,SAASpH,MAAT,CAAgBxE,QAAhB,EAA0B;EACxB,MAAI6L,MAAM,GAAGtH,WAAW,CAAC,IAAD,EAAOvE,QAAP,CAAxB;EACA,SAAO+E,CAAC,CAAC8G,MAAD,CAAR;EACD;;EAED,SAAS7G,IAAT,CAAcA,IAAd,EAAoB;EAClB,MAAI,OAAOA,IAAP,KAAgB,WAApB,EAAiC;EAC/B,WAAO,KAAK,CAAL,IAAU,KAAK,CAAL,EAAQI,SAAlB,GAA8B,IAArC;EACD;;EAED,OAAK,IAAIT,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,SAAKA,CAAL,EAAQS,SAAR,GAAoBJ,IAApB;EACD;;EAED,SAAO,IAAP;EACD;;EAED,SAAS8G,IAAT,CAAcA,IAAd,EAAoB;EAClB,MAAI,OAAOA,IAAP,KAAgB,WAApB,EAAiC;EAC/B,WAAO,KAAK,CAAL,IAAU,KAAK,CAAL,EAAQC,WAAR,CAAoB9G,IAApB,EAAV,GAAuC,IAA9C;EACD;;EAED,OAAK,IAAIN,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,SAAKA,CAAL,EAAQoH,WAAR,GAAsBD,IAAtB;EACD;;EAED,SAAO,IAAP;EACD;;EAED,SAAS1D,EAAT,CAAYvD,QAAZ,EAAsB;EACpB,MAAIxE,MAAM,GAAGF,SAAS,EAAtB;EACA,MAAItB,QAAQ,GAAGF,WAAW,EAA1B;EACA,MAAI0F,EAAE,GAAG,KAAK,CAAL,CAAT;EACA,MAAI2H,WAAJ;EACA,MAAIrH,CAAJ;EACA,MAAI,CAACN,EAAD,IAAO,OAAOQ,QAAP,KAAoB,WAA/B,EAA4C,OAAO,KAAP;;EAE5C,MAAI,OAAOA,QAAP,KAAoB,QAAxB,EAAkC;EAChC,QAAIR,EAAE,CAAC4H,OAAP,EAAgB,OAAO5H,EAAE,CAAC4H,OAAH,CAAWpH,QAAX,CAAP;EAChB,QAAIR,EAAE,CAAC6H,qBAAP,EAA8B,OAAO7H,EAAE,CAAC6H,qBAAH,CAAyBrH,QAAzB,CAAP;EAC9B,QAAIR,EAAE,CAAC8H,iBAAP,EAA0B,OAAO9H,EAAE,CAAC8H,iBAAH,CAAqBtH,QAArB,CAAP;EAC1BmH,IAAAA,WAAW,GAAGjH,CAAC,CAACF,QAAD,CAAf;;EAEA,SAAKF,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAGqH,WAAW,CAACnP,MAA5B,EAAoC8H,CAAC,IAAI,CAAzC,EAA4C;EAC1C,UAAIqH,WAAW,CAACrH,CAAD,CAAX,KAAmBN,EAAvB,EAA2B,OAAO,IAAP;EAC5B;;EAED,WAAO,KAAP;EACD;;EAED,MAAIQ,QAAQ,KAAKhG,QAAjB,EAA2B;EACzB,WAAOwF,EAAE,KAAKxF,QAAd;EACD;;EAED,MAAIgG,QAAQ,KAAKxE,MAAjB,EAAyB;EACvB,WAAOgE,EAAE,KAAKhE,MAAd;EACD;;EAED,MAAIwE,QAAQ,CAACQ,QAAT,IAAqBR,QAAQ,YAAYjB,IAA7C,EAAmD;EACjDoI,IAAAA,WAAW,GAAGnH,QAAQ,CAACQ,QAAT,GAAoB,CAACR,QAAD,CAApB,GAAiCA,QAA/C;;EAEA,SAAKF,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAGqH,WAAW,CAACnP,MAA5B,EAAoC8H,CAAC,IAAI,CAAzC,EAA4C;EAC1C,UAAIqH,WAAW,CAACrH,CAAD,CAAX,KAAmBN,EAAvB,EAA2B,OAAO,IAAP;EAC5B;;EAED,WAAO,KAAP;EACD;;EAED,SAAO,KAAP;EACD;;EAED,SAASuH,KAAT,GAAiB;EACf,MAAIQ,KAAK,GAAG,KAAK,CAAL,CAAZ;EACA,MAAIzH,CAAJ;;EAEA,MAAIyH,KAAJ,EAAW;EACTzH,IAAAA,CAAC,GAAG,CAAJ,CADS;;EAGT,WAAO,CAACyH,KAAK,GAAGA,KAAK,CAACC,eAAf,MAAoC,IAA3C,EAAiD;EAC/C,UAAID,KAAK,CAAC/G,QAAN,KAAmB,CAAvB,EAA0BV,CAAC,IAAI,CAAL;EAC3B;;EAED,WAAOA,CAAP;EACD;;EAED,SAAO/B,SAAP;EACD;;EAED,SAAS0J,EAAT,CAAYV,KAAZ,EAAmB;EACjB,MAAI,OAAOA,KAAP,KAAiB,WAArB,EAAkC,OAAO,IAAP;EAClC,MAAI/O,MAAM,GAAG,KAAKA,MAAlB;;EAEA,MAAI+O,KAAK,GAAG/O,MAAM,GAAG,CAArB,EAAwB;EACtB,WAAOkI,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,MAAI6G,KAAK,GAAG,CAAZ,EAAe;EACb,QAAIW,WAAW,GAAG1P,MAAM,GAAG+O,KAA3B;EACA,QAAIW,WAAW,GAAG,CAAlB,EAAqB,OAAOxH,CAAC,CAAC,EAAD,CAAR;EACrB,WAAOA,CAAC,CAAC,CAAC,KAAKwH,WAAL,CAAD,CAAD,CAAR;EACD;;EAED,SAAOxH,CAAC,CAAC,CAAC,KAAK6G,KAAL,CAAD,CAAD,CAAR;EACD;;EAED,SAASY,MAAT,GAAkB;EAChB,MAAIC,QAAJ;EACA,MAAI5N,QAAQ,GAAGF,WAAW,EAA1B;;EAEA,OAAK,IAAI4J,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGlG,SAAS,CAACxF,MAA9B,EAAsC0L,CAAC,IAAI,CAA3C,EAA8C;EAC5CkE,IAAAA,QAAQ,GAAGlE,CAAC,GAAG,CAAJ,IAASlG,SAAS,CAACxF,MAAV,IAAoB0L,CAA7B,GAAiC3F,SAAjC,GAA6CP,SAAS,CAACkG,CAAD,CAAjE;;EAEA,SAAK,IAAI5D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,UAAI,OAAO8H,QAAP,KAAoB,QAAxB,EAAkC;EAChC,YAAIC,OAAO,GAAG7N,QAAQ,CAACnB,aAAT,CAAuB,KAAvB,CAAd;EACAgP,QAAAA,OAAO,CAACtH,SAAR,GAAoBqH,QAApB;;EAEA,eAAOC,OAAO,CAACC,UAAf,EAA2B;EACzB,eAAKhI,CAAL,EAAQiI,WAAR,CAAoBF,OAAO,CAACC,UAA5B;EACD;EACF,OAPD,MAOO,IAAIF,QAAQ,YAAY7I,IAAxB,EAA8B;EACnC,aAAK,IAAI8E,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG+D,QAAQ,CAAC5P,MAA7B,EAAqC6L,CAAC,IAAI,CAA1C,EAA6C;EAC3C,eAAK/D,CAAL,EAAQiI,WAAR,CAAoBH,QAAQ,CAAC/D,CAAD,CAA5B;EACD;EACF,OAJM,MAIA;EACL,aAAK/D,CAAL,EAAQiI,WAAR,CAAoBH,QAApB;EACD;EACF;EACF;;EAED,SAAO,IAAP;EACD;;EAOD,SAASI,OAAT,CAAiBJ,QAAjB,EAA2B;EACzB,MAAI5N,QAAQ,GAAGF,WAAW,EAA1B;EACA,MAAIgG,CAAJ;EACA,MAAI+D,CAAJ;;EAEA,OAAK/D,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAG,KAAK9H,MAArB,EAA6B8H,CAAC,IAAI,CAAlC,EAAqC;EACnC,QAAI,OAAO8H,QAAP,KAAoB,QAAxB,EAAkC;EAChC,UAAIC,OAAO,GAAG7N,QAAQ,CAACnB,aAAT,CAAuB,KAAvB,CAAd;EACAgP,MAAAA,OAAO,CAACtH,SAAR,GAAoBqH,QAApB;;EAEA,WAAK/D,CAAC,GAAGgE,OAAO,CAAC9O,UAAR,CAAmBf,MAAnB,GAA4B,CAArC,EAAwC6L,CAAC,IAAI,CAA7C,EAAgDA,CAAC,IAAI,CAArD,EAAwD;EACtD,aAAK/D,CAAL,EAAQmI,YAAR,CAAqBJ,OAAO,CAAC9O,UAAR,CAAmB8K,CAAnB,CAArB,EAA4C,KAAK/D,CAAL,EAAQ/G,UAAR,CAAmB,CAAnB,CAA5C;EACD;EACF,KAPD,MAOO,IAAI6O,QAAQ,YAAY7I,IAAxB,EAA8B;EACnC,WAAK8E,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAG+D,QAAQ,CAAC5P,MAAzB,EAAiC6L,CAAC,IAAI,CAAtC,EAAyC;EACvC,aAAK/D,CAAL,EAAQmI,YAAR,CAAqBL,QAAQ,CAAC/D,CAAD,CAA7B,EAAkC,KAAK/D,CAAL,EAAQ/G,UAAR,CAAmB,CAAnB,CAAlC;EACD;EACF,KAJM,MAIA;EACL,WAAK+G,CAAL,EAAQmI,YAAR,CAAqBL,QAArB,EAA+B,KAAK9H,CAAL,EAAQ/G,UAAR,CAAmB,CAAnB,CAA/B;EACD;EACF;;EAED,SAAO,IAAP;EACD;;EAmCD,SAASmP,IAAT,CAAclI,QAAd,EAAwB;EACtB,MAAI,KAAKhI,MAAL,GAAc,CAAlB,EAAqB;EACnB,QAAIgI,QAAJ,EAAc;EACZ,UAAI,KAAK,CAAL,EAAQmI,kBAAR,IAA8BjI,CAAC,CAAC,KAAK,CAAL,EAAQiI,kBAAT,CAAD,CAA8B5E,EAA9B,CAAiCvD,QAAjC,CAAlC,EAA8E;EAC5E,eAAOE,CAAC,CAAC,CAAC,KAAK,CAAL,EAAQiI,kBAAT,CAAD,CAAR;EACD;;EAED,aAAOjI,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,QAAI,KAAK,CAAL,EAAQiI,kBAAZ,EAAgC,OAAOjI,CAAC,CAAC,CAAC,KAAK,CAAL,EAAQiI,kBAAT,CAAD,CAAR;EAChC,WAAOjI,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,SAAOA,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,SAASkI,OAAT,CAAiBpI,QAAjB,EAA2B;EACzB,MAAIqI,OAAO,GAAG,EAAd;EACA,MAAI7I,EAAE,GAAG,KAAK,CAAL,CAAT;EACA,MAAI,CAACA,EAAL,EAAS,OAAOU,CAAC,CAAC,EAAD,CAAR;;EAET,SAAOV,EAAE,CAAC2I,kBAAV,EAA8B;EAC5B,QAAIG,KAAK,GAAG9I,EAAE,CAAC2I,kBAAf,CAD4B;;EAG5B,QAAInI,QAAJ,EAAc;EACZ,UAAIE,CAAC,CAACoI,KAAD,CAAD,CAAS/E,EAAT,CAAYvD,QAAZ,CAAJ,EAA2BqI,OAAO,CAACnL,IAAR,CAAaoL,KAAb;EAC5B,KAFD,MAEOD,OAAO,CAACnL,IAAR,CAAaoL,KAAb;;EAEP9I,IAAAA,EAAE,GAAG8I,KAAL;EACD;;EAED,SAAOpI,CAAC,CAACmI,OAAD,CAAR;EACD;;EAED,SAASE,IAAT,CAAcvI,QAAd,EAAwB;EACtB,MAAI,KAAKhI,MAAL,GAAc,CAAlB,EAAqB;EACnB,QAAIwH,EAAE,GAAG,KAAK,CAAL,CAAT;;EAEA,QAAIQ,QAAJ,EAAc;EACZ,UAAIR,EAAE,CAACgJ,sBAAH,IAA6BtI,CAAC,CAACV,EAAE,CAACgJ,sBAAJ,CAAD,CAA6BjF,EAA7B,CAAgCvD,QAAhC,CAAjC,EAA4E;EAC1E,eAAOE,CAAC,CAAC,CAACV,EAAE,CAACgJ,sBAAJ,CAAD,CAAR;EACD;;EAED,aAAOtI,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,QAAIV,EAAE,CAACgJ,sBAAP,EAA+B,OAAOtI,CAAC,CAAC,CAACV,EAAE,CAACgJ,sBAAJ,CAAD,CAAR;EAC/B,WAAOtI,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,SAAOA,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,SAASuI,OAAT,CAAiBzI,QAAjB,EAA2B;EACzB,MAAI0I,OAAO,GAAG,EAAd;EACA,MAAIlJ,EAAE,GAAG,KAAK,CAAL,CAAT;EACA,MAAI,CAACA,EAAL,EAAS,OAAOU,CAAC,CAAC,EAAD,CAAR;;EAET,SAAOV,EAAE,CAACgJ,sBAAV,EAAkC;EAChC,QAAIG,KAAK,GAAGnJ,EAAE,CAACgJ,sBAAf,CADgC;;EAGhC,QAAIxI,QAAJ,EAAc;EACZ,UAAIE,CAAC,CAACyI,KAAD,CAAD,CAASpF,EAAT,CAAYvD,QAAZ,CAAJ,EAA2B0I,OAAO,CAACxL,IAAR,CAAayL,KAAb;EAC5B,KAFD,MAEOD,OAAO,CAACxL,IAAR,CAAayL,KAAb;;EAEPnJ,IAAAA,EAAE,GAAGmJ,KAAL;EACD;;EAED,SAAOzI,CAAC,CAACwI,OAAD,CAAR;EACD;;EAMD,SAASE,MAAT,CAAgB5I,QAAhB,EAA0B;EACxB,MAAIyD,OAAO,GAAG,EAAd,CADwB;;EAGxB,OAAK,IAAI3D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAI,KAAKA,CAAL,EAAQ+I,UAAR,KAAuB,IAA3B,EAAiC;EAC/B,UAAI7I,QAAJ,EAAc;EACZ,YAAIE,CAAC,CAAC,KAAKJ,CAAL,EAAQ+I,UAAT,CAAD,CAAsBtF,EAAtB,CAAyBvD,QAAzB,CAAJ,EAAwCyD,OAAO,CAACvG,IAAR,CAAa,KAAK4C,CAAL,EAAQ+I,UAArB;EACzC,OAFD,MAEO;EACLpF,QAAAA,OAAO,CAACvG,IAAR,CAAa,KAAK4C,CAAL,EAAQ+I,UAArB;EACD;EACF;EACF;;EAED,SAAO3I,CAAC,CAACuD,OAAD,CAAR;EACD;;EAED,SAASA,OAAT,CAAiBzD,QAAjB,EAA2B;EACzB,MAAIyD,OAAO,GAAG,EAAd,CADyB;;EAGzB,OAAK,IAAI3D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAIgJ,OAAO,GAAG,KAAKhJ,CAAL,EAAQ+I,UAAtB,CADuC;;EAGvC,WAAOC,OAAP,EAAgB;EACd,UAAI9I,QAAJ,EAAc;EACZ,YAAIE,CAAC,CAAC4I,OAAD,CAAD,CAAWvF,EAAX,CAAcvD,QAAd,CAAJ,EAA6ByD,OAAO,CAACvG,IAAR,CAAa4L,OAAb;EAC9B,OAFD,MAEO;EACLrF,QAAAA,OAAO,CAACvG,IAAR,CAAa4L,OAAb;EACD;;EAEDA,MAAAA,OAAO,GAAGA,OAAO,CAACD,UAAlB;EACD;EACF;;EAED,SAAO3I,CAAC,CAACuD,OAAD,CAAR;EACD;;EAED,SAASsF,OAAT,CAAiB/I,QAAjB,EAA2B;EACzB,MAAI+I,OAAO,GAAG,IAAd,CADyB;;EAGzB,MAAI,OAAO/I,QAAP,KAAoB,WAAxB,EAAqC;EACnC,WAAOE,CAAC,CAAC,EAAD,CAAR;EACD;;EAED,MAAI,CAAC6I,OAAO,CAACxF,EAAR,CAAWvD,QAAX,CAAL,EAA2B;EACzB+I,IAAAA,OAAO,GAAGA,OAAO,CAACtF,OAAR,CAAgBzD,QAAhB,EAA0ByH,EAA1B,CAA6B,CAA7B,CAAV;EACD;;EAED,SAAOsB,OAAP;EACD;;EAED,SAASC,IAAT,CAAchJ,QAAd,EAAwB;EACtB,MAAIiJ,aAAa,GAAG,EAApB;;EAEA,OAAK,IAAInJ,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAIoJ,KAAK,GAAG,KAAKpJ,CAAL,EAAQrH,gBAAR,CAAyBuH,QAAzB,CAAZ;;EAEA,SAAK,IAAI6D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGqF,KAAK,CAAClR,MAA1B,EAAkC6L,CAAC,IAAI,CAAvC,EAA0C;EACxCoF,MAAAA,aAAa,CAAC/L,IAAd,CAAmBgM,KAAK,CAACrF,CAAD,CAAxB;EACD;EACF;;EAED,SAAO3D,CAAC,CAAC+I,aAAD,CAAR;EACD;;EAED,SAASnQ,QAAT,CAAkBkH,QAAlB,EAA4B;EAC1B,MAAIlH,QAAQ,GAAG,EAAf,CAD0B;;EAG1B,OAAK,IAAIgH,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAI/G,UAAU,GAAG,KAAK+G,CAAL,EAAQhH,QAAzB;;EAEA,SAAK,IAAI+K,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG9K,UAAU,CAACf,MAA/B,EAAuC6L,CAAC,IAAI,CAA5C,EAA+C;EAC7C,UAAI,CAAC7D,QAAD,IAAaE,CAAC,CAACnH,UAAU,CAAC8K,CAAD,CAAX,CAAD,CAAiBN,EAAjB,CAAoBvD,QAApB,CAAjB,EAAgD;EAC9ClH,QAAAA,QAAQ,CAACoE,IAAT,CAAcnE,UAAU,CAAC8K,CAAD,CAAxB;EACD;EACF;EACF;;EAED,SAAO3D,CAAC,CAACpH,QAAD,CAAR;EACD;;EAED,SAAS0I,MAAT,GAAkB;EAChB,OAAK,IAAI1B,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,KAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAI,KAAKA,CAAL,EAAQ+I,UAAZ,EAAwB,KAAK/I,CAAL,EAAQ+I,UAAR,CAAmBM,WAAnB,CAA+B,KAAKrJ,CAAL,CAA/B;EACzB;;EAED,SAAO,IAAP;EACD;;EC7pCD,IAAMsJ,OAAO,GAAG;EACd3I,EAAAA,QAAQ,EAARA,QADc;EAEdW,EAAAA,WAAW,EAAXA,WAFc;EAGdU,EAAAA,QAAQ,EAARA,QAHc;EAIdL,EAAAA,WAAW,EAAXA,WAJc;EAKdS,EAAAA,IAAI,EAAJA,IALc;EAMdI,EAAAA,UAAU,EAAVA,UANc;EAOdE,EAAAA,SAAS,EAATA,SAPc;EAQdC,EAAAA,UAAU,EAAVA,UARc;EASdG,EAAAA,EAAE,EAAFA,EATc;EAUduB,EAAAA,GAAG,EAAHA,GAVc;EAWdO,EAAAA,OAAO,EAAPA,OAXc;EAYdU,EAAAA,aAAa,EAAbA,aAZc;EAadG,EAAAA,UAAU,EAAVA,UAbc;EAcdM,EAAAA,WAAW,EAAXA,WAdc;EAedH,EAAAA,MAAM,EAANA,MAfc;EAgBdM,EAAAA,MAAM,EAANA,MAhBc;EAiBdW,EAAAA,GAAG,EAAHA,GAjBc;EAkBdG,EAAAA,IAAI,EAAJA,IAlBc;EAmBd3G,EAAAA,IAAI,EAAJA,IAnBc;EAoBd8G,EAAAA,IAAI,EAAJA,IApBc;EAqBd1D,EAAAA,EAAE,EAAFA,EArBc;EAsBdwD,EAAAA,KAAK,EAALA,KAtBc;EAuBdU,EAAAA,EAAE,EAAFA,EAvBc;EAwBdE,EAAAA,MAAM,EAANA,MAxBc;EAyBdK,EAAAA,OAAO,EAAPA,OAzBc;EA0BdE,EAAAA,IAAI,EAAJA,IA1Bc;EA2BdE,EAAAA,OAAO,EAAPA,OA3Bc;EA4BdG,EAAAA,IAAI,EAAJA,IA5Bc;EA6BdE,EAAAA,OAAO,EAAPA,OA7Bc;EA8BdG,EAAAA,MAAM,EAANA,MA9Bc;EA+BdnF,EAAAA,OAAO,EAAPA,OA/Bc;EAgCdsF,EAAAA,OAAO,EAAPA,OAhCc;EAiCdC,EAAAA,IAAI,EAAJA,IAjCc;EAkCdlQ,EAAAA,QAAQ,EAARA,QAlCc;EAmCd6G,EAAAA,MAAM,EAANA,MAnCc;EAoCd6B,EAAAA,MAAM,EAANA;EApCc,CAAhB;EAuCA/J,MAAM,CAACI,IAAP,CAAYuR,OAAZ,EAAqBtR,OAArB,CAA6B,UAACuR,UAAD,EAAgB;EAC3CnJ,EAAAA,CAAC,CAACxC,EAAF,CAAK2L,UAAL,IAAmBD,OAAO,CAACC,UAAD,CAA1B;EACD,CAFD;;EC7EA,SAASC,WAAT,CAAqB/R,GAArB,EAA0B;EACxB,MAAMgS,MAAM,GAAGhS,GAAf;EACAE,EAAAA,MAAM,CAACI,IAAP,CAAY0R,MAAZ,EAAoBzR,OAApB,CAA4B,UAACC,GAAD,EAAS;EACnC,QAAI;EACFwR,MAAAA,MAAM,CAACxR,GAAD,CAAN,GAAc,IAAd;EACD,KAFD,CAEE,OAAO6E,CAAP,EAAU;EAEX;;EACD,QAAI;EACF,aAAO2M,MAAM,CAACxR,GAAD,CAAb;EACD,KAFD,CAEE,OAAO6E,CAAP,EAAU;EAEX;EACF,GAXD;EAYD;;EACD,SAAS4M,QAAT,CAAkBrO,QAAlB,EAA4BsO,KAA5B,EAAuC;EAAA,MAAXA,KAAW;EAAXA,IAAAA,KAAW,GAAH,CAAG;EAAA;;EACrC,SAAO1O,UAAU,CAACI,QAAD,EAAWsO,KAAX,CAAjB;EACD;;EACD,SAASC,GAAT,GAAe;EACb,SAAO7O,IAAI,CAAC6O,GAAL,EAAP;EACD;;EACD,SAAShP,kBAAT,CAA0B8E,EAA1B,EAA8B;EAC5B,MAAMhE,MAAM,GAAGF,SAAS,EAAxB;EACA,MAAItC,KAAJ;;EACA,MAAIwC,MAAM,CAACd,gBAAX,EAA6B;EAC3B1B,IAAAA,KAAK,GAAGwC,MAAM,CAACd,gBAAP,CAAwB8E,EAAxB,EAA4B,IAA5B,CAAR;EACD;;EACD,MAAI,CAACxG,KAAD,IAAUwG,EAAE,CAACmK,YAAjB,EAA+B;EAC7B3Q,IAAAA,KAAK,GAAGwG,EAAE,CAACmK,YAAX;EACD;;EACD,MAAI,CAAC3Q,KAAL,EAAY;EACVA,IAAAA,KAAK,GAAGwG,EAAE,CAACxG,KAAX;EACD;;EAED,SAAOA,KAAP;EACD;;EACD,SAAS4Q,YAAT,CAAsBpK,EAAtB,EAA0BqK,IAA1B,EAAsC;EAAA,MAAZA,IAAY;EAAZA,IAAAA,IAAY,GAAL,GAAK;EAAA;;EACpC,MAAMrO,MAAM,GAAGF,SAAS,EAAxB;EACA,MAAIwO,MAAJ;EACA,MAAIC,YAAJ;EACA,MAAIC,eAAJ;EAEA,MAAMC,QAAQ,GAAGvP,kBAAgB,CAAC8E,EAAD,CAAjC;;EAEA,MAAIhE,MAAM,CAAC0O,eAAX,EAA4B;EAC1BH,IAAAA,YAAY,GAAGE,QAAQ,CAACzH,SAAT,IAAsByH,QAAQ,CAACE,eAA9C;;EACA,QAAIJ,YAAY,CAAC/I,KAAb,CAAmB,GAAnB,EAAwBhJ,MAAxB,GAAiC,CAArC,EAAwC;EACtC+R,MAAAA,YAAY,GAAGA,YAAY,CACxB/I,KADY,CACN,IADM,EAEZF,GAFY,CAER,UAAC7D,CAAD;EAAA,eAAOA,CAAC,CAACmN,OAAF,CAAU,GAAV,EAAe,GAAf,CAAP;EAAA,OAFQ,EAGZC,IAHY,CAGP,IAHO,CAAf;EAID,KAPyB;EAS1B;;;EACAL,IAAAA,eAAe,GAAG,IAAIxO,MAAM,CAAC0O,eAAX,CAA2BH,YAAY,KAAK,MAAjB,GAA0B,EAA1B,GAA+BA,YAA1D,CAAlB;EACD,GAXD,MAWO;EACLC,IAAAA,eAAe,GACbC,QAAQ,CAACK,YAAT,IACAL,QAAQ,CAACM,UADT,IAEAN,QAAQ,CAACO,WAFT,IAGAP,QAAQ,CAACQ,WAHT,IAIAR,QAAQ,CAACzH,SAJT,IAKAyH,QAAQ,CAACtP,gBAAT,CAA0B,WAA1B,EAAuCyP,OAAvC,CAA+C,YAA/C,EAA6D,oBAA7D,CANF;EAOAN,IAAAA,MAAM,GAAGE,eAAe,CAACtN,QAAhB,GAA2BsE,KAA3B,CAAiC,GAAjC,CAAT;EACD;;EAED,MAAI6I,IAAI,KAAK,GAAb,EAAkB;EAChB;EACA,QAAIrO,MAAM,CAAC0O,eAAX,EAA4BH,YAAY,GAAGC,eAAe,CAACU,GAA/B,CAA5B;EAAA,SAEK,IAAIZ,MAAM,CAAC9R,MAAP,KAAkB,EAAtB,EAA0B+R,YAAY,GAAGnE,UAAU,CAACkE,MAAM,CAAC,EAAD,CAAP,CAAzB,CAA1B;EAAA,WAEAC,YAAY,GAAGnE,UAAU,CAACkE,MAAM,CAAC,CAAD,CAAP,CAAzB;EACN;;EACD,MAAID,IAAI,KAAK,GAAb,EAAkB;EAChB;EACA,QAAIrO,MAAM,CAAC0O,eAAX,EAA4BH,YAAY,GAAGC,eAAe,CAACW,GAA/B,CAA5B;EAAA,SAEK,IAAIb,MAAM,CAAC9R,MAAP,KAAkB,EAAtB,EAA0B+R,YAAY,GAAGnE,UAAU,CAACkE,MAAM,CAAC,EAAD,CAAP,CAAzB,CAA1B;EAAA,WAEAC,YAAY,GAAGnE,UAAU,CAACkE,MAAM,CAAC,CAAD,CAAP,CAAzB;EACN;;EACD,SAAOC,YAAY,IAAI,CAAvB;EACD;;EACD,SAASzS,UAAT,CAAkB0E,CAAlB,EAAqB;EACnB,SACE,OAAOA,CAAP,KAAa,QAAb,IACAA,CAAC,KAAK,IADN,IAEAA,CAAC,CAACxE,WAFF,IAGAC,MAAM,CAACmE,SAAP,CAAiBc,QAAjB,CAA0BC,IAA1B,CAA+BX,CAA/B,EAAkC4O,KAAlC,CAAwC,CAAxC,EAA2C,CAAC,CAA5C,MAAmD,QAJrD;EAMD;;EACD,SAASlT,QAAT,GAAyB;EACvB,MAAMmT,EAAE,GAAGpT,MAAM,kDAAjB;EACA,MAAMqT,QAAQ,GAAG,CAAC,WAAD,EAAc,aAAd,EAA6B,WAA7B,CAAjB;;EACA,OAAK,IAAIhL,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG,UAAK9H,MAAzB,EAAiC8H,CAAC,IAAI,CAAtC,EAAyC;EACvC,QAAMiL,UAAU,GAAQjL,CAAR,4BAAQA,CAAR,yBAAQA,CAAR,CAAhB;;EACA,QAAIiL,UAAU,KAAKhN,SAAf,IAA4BgN,UAAU,KAAK,IAA/C,EAAqD;EACnD,UAAMC,SAAS,GAAGvT,MAAM,CAACI,IAAP,CAAYJ,MAAM,CAACsT,UAAD,CAAlB,EAAgCpL,MAAhC,CAAuC,UAAC5H,GAAD;EAAA,eAAS+S,QAAQ,CAACnN,OAAT,CAAiB5F,GAAjB,IAAwB,CAAjC;EAAA,OAAvC,CAAlB;;EACA,WAAK,IAAIkT,SAAS,GAAG,CAAhB,EAAmBC,GAAG,GAAGF,SAAS,CAAChT,MAAxC,EAAgDiT,SAAS,GAAGC,GAA5D,EAAiED,SAAS,IAAI,CAA9E,EAAiF;EAC/E,YAAME,OAAO,GAAGH,SAAS,CAACC,SAAD,CAAzB;EACA,YAAMG,IAAI,GAAG3T,MAAM,CAAC4T,wBAAP,CAAgCN,UAAhC,EAA4CI,OAA5C,CAAb;;EACA,YAAIC,IAAI,KAAKrN,SAAT,IAAsBqN,IAAI,CAAC9M,UAA/B,EAA2C;EACzC,cAAIhH,UAAQ,CAACuT,EAAE,CAACM,OAAD,CAAH,CAAR,IAAyB7T,UAAQ,CAACyT,UAAU,CAACI,OAAD,CAAX,CAArC,EAA4D;EAC1D,gBAAIJ,UAAU,CAACI,OAAD,CAAV,CAAoBG,UAAxB,EAAoC;EAClCT,cAAAA,EAAE,CAACM,OAAD,CAAF,GAAcJ,UAAU,CAACI,OAAD,CAAxB;EACD,aAFD,MAEO;EACLzT,cAAAA,QAAM,CAACmT,EAAE,CAACM,OAAD,CAAH,EAAcJ,UAAU,CAACI,OAAD,CAAxB,CAAN;EACD;EACF,WAND,MAMO,IAAI,CAAC7T,UAAQ,CAACuT,EAAE,CAACM,OAAD,CAAH,CAAT,IAA0B7T,UAAQ,CAACyT,UAAU,CAACI,OAAD,CAAX,CAAtC,EAA6D;EAClEN,YAAAA,EAAE,CAACM,OAAD,CAAF,GAAc,EAAd;;EACA,gBAAIJ,UAAU,CAACI,OAAD,CAAV,CAAoBG,UAAxB,EAAoC;EAClCT,cAAAA,EAAE,CAACM,OAAD,CAAF,GAAcJ,UAAU,CAACI,OAAD,CAAxB;EACD,aAFD,MAEO;EACLzT,cAAAA,QAAM,CAACmT,EAAE,CAACM,OAAD,CAAH,EAAcJ,UAAU,CAACI,OAAD,CAAxB,CAAN;EACD;EACF,WAPM,MAOA;EACLN,YAAAA,EAAE,CAACM,OAAD,CAAF,GAAcJ,UAAU,CAACI,OAAD,CAAxB;EACD;EACF;EACF;EACF;EACF;;EACD,SAAON,EAAP;EACD;;EAED,SAASU,iBAAT,CAA2BhO,QAA3B,EAAqChG,GAArC,EAA0C;EACxCE,EAAAA,MAAM,CAACI,IAAP,CAAYN,GAAZ,EAAiBO,OAAjB,CAAyB,UAACC,GAAD,EAAS;EAChC,QAAIT,UAAQ,CAACC,GAAG,CAACQ,GAAD,CAAJ,CAAZ,EAAwB;EACtBN,MAAAA,MAAM,CAACI,IAAP,CAAYN,GAAG,CAACQ,GAAD,CAAf,EAAsBD,OAAtB,CAA8B,UAAC0T,MAAD,EAAY;EACxC,YAAI,OAAOjU,GAAG,CAACQ,GAAD,CAAH,CAASyT,MAAT,CAAP,KAA4B,UAAhC,EAA4C;EAC1CjU,UAAAA,GAAG,CAACQ,GAAD,CAAH,CAASyT,MAAT,IAAmBjU,GAAG,CAACQ,GAAD,CAAH,CAASyT,MAAT,EAAiBlO,IAAjB,CAAsBC,QAAtB,CAAnB;EACD;EACF,OAJD;EAKD;;EACDA,IAAAA,QAAQ,CAACxF,GAAD,CAAR,GAAgBR,GAAG,CAACQ,GAAD,CAAnB;EACD,GATD;EAUD;;ECzID,IAAI0T,OAAJ;;EAEA,SAASC,WAAT,GAAuB;EACrB,MAAMlQ,MAAM,GAAGF,SAAS,EAAxB;EACA,MAAMtB,QAAQ,GAAGF,WAAW,EAA5B;EAEA,SAAO;EACL6R,IAAAA,KAAK,EAAE,CAAC,EACN,kBAAkBnQ,MAAlB,IACCA,MAAM,CAACoQ,aAAP,IAAwB5R,QAAQ,YAAYwB,MAAM,CAACoQ,aAF9C,CADH;EAMLC,IAAAA,aAAa,EACX,CAAC,CAACrQ,MAAM,CAACsQ,YAAT,IACA,oBAAoBtQ,MAAM,CAACtB,SAD3B,IAEAsB,MAAM,CAACtB,SAAP,CAAiB6R,cAAjB,IAAmC,CAThC;EAWLC,IAAAA,QAAQ,EAAG,SAASC,aAAT,GAAyB;EAClC,aAAO,sBAAsBzQ,MAAtB,IAAgC,4BAA4BA,MAAnE;EACD,KAFS,EAXL;EAeL0Q,IAAAA,eAAe,EAAG,SAASC,oBAAT,GAAgC;EAChD,UAAIC,eAAe,GAAG,KAAtB;;EACA,UAAI;EACF,YAAMC,IAAI,GAAG5U,MAAM,CAACqH,cAAP,CAAsB,EAAtB,EAA0B,SAA1B,EAAqC;EAChD;EACAZ,UAAAA,GAFgD,iBAE1C;EACJkO,YAAAA,eAAe,GAAG,IAAlB;EACD;EAJ+C,SAArC,CAAb;EAMA5Q,QAAAA,MAAM,CAACrD,gBAAP,CAAwB,qBAAxB,EAA+C,IAA/C,EAAqDkU,IAArD;EACD,OARD,CAQE,OAAOzP,CAAP,EAAU;EAEX;;EACD,aAAOwP,eAAP;EACD,KAdgB,EAfZ;EA+BLE,IAAAA,QAAQ,EAAG,SAASC,aAAT,GAAyB;EAClC,aAAO,oBAAoB/Q,MAA3B;EACD,KAFS;EA/BL,GAAP;EAmCD;;EAED,SAASgR,UAAT,GAAsB;EACpB,MAAI,CAACf,OAAL,EAAc;EACZA,IAAAA,OAAO,GAAGC,WAAW,EAArB;EACD;;EACD,SAAOD,OAAP;EACD;;EC/CD,IAAIgB,MAAJ;;EAEA,SAASC,UAAT,QAAwC;EAAA,gCAAJ,EAAI;EAAA,MAAlBvS,SAAkB,QAAlBA,SAAkB;;EACtC,MAAMsR,OAAO,GAAGe,UAAU,EAA1B;EACA,MAAMhR,MAAM,GAAGF,SAAS,EAAxB;EACA,MAAMqR,QAAQ,GAAGnR,MAAM,CAACtB,SAAP,CAAiByS,QAAlC;EACA,MAAMC,EAAE,GAAGzS,SAAS,IAAIqB,MAAM,CAACtB,SAAP,CAAiBC,SAAzC;EAEA,MAAMsS,MAAM,GAAG;EACbI,IAAAA,GAAG,EAAE,KADQ;EAEbC,IAAAA,OAAO,EAAE;EAFI,GAAf;EAKA,MAAMC,WAAW,GAAGvR,MAAM,CAACV,MAAP,CAAckS,KAAlC;EACA,MAAMC,YAAY,GAAGzR,MAAM,CAACV,MAAP,CAAcoS,MAAnC;EAEA,MAAMJ,OAAO,GAAGF,EAAE,CAACO,KAAH,CAAS,6BAAT,CAAhB,CAdsC;;EAetC,MAAIC,IAAI,GAAGR,EAAE,CAACO,KAAH,CAAS,sBAAT,CAAX;EACA,MAAME,IAAI,GAAGT,EAAE,CAACO,KAAH,CAAS,yBAAT,CAAb;EACA,MAAMG,MAAM,GAAG,CAACF,IAAD,IAASR,EAAE,CAACO,KAAH,CAAS,4BAAT,CAAxB;EACA,MAAMI,OAAO,GAAGZ,QAAQ,KAAK,OAA7B;EACA,MAAIa,KAAK,GAAGb,QAAQ,KAAK,UAAzB,CAnBsC;;EAsBtC,MAAMc,WAAW,GAAG,CAClB,WADkB,EAElB,WAFkB,EAGlB,UAHkB,EAIlB,UAJkB,EAKlB,UALkB,EAMlB,UANkB,EAOlB,UAPkB,EAQlB,UARkB,EASlB,UATkB,EAUlB,UAVkB,EAWlB,UAXkB,EAYlB,UAZkB,CAApB;;EAcA,MACE,CAACL,IAAD,IACAI,KADA,IAEA/B,OAAO,CAACE,KAFR,IAGA8B,WAAW,CAAC9P,OAAZ,CAAuBoP,WAAvB,SAAsCE,YAAtC,KAAyD,CAJ3D,EAKE;EACAG,IAAAA,IAAI,GAAGR,EAAE,CAACO,KAAH,CAAS,qBAAT,CAAP;EACA,QAAI,CAACC,IAAL,EAAWA,IAAI,GAAG,CAAC,CAAD,EAAI,CAAJ,EAAO,QAAP,CAAP;EACXI,IAAAA,KAAK,GAAG,KAAR;EACD,GA7CqC;;;EAgDtC,MAAIV,OAAO,IAAI,CAACS,OAAhB,EAAyB;EACvBd,IAAAA,MAAM,CAACiB,EAAP,GAAY,SAAZ;EACAjB,IAAAA,MAAM,CAACK,OAAP,GAAiB,IAAjB;EACD;;EACD,MAAIM,IAAI,IAAIE,MAAR,IAAkBD,IAAtB,EAA4B;EAC1BZ,IAAAA,MAAM,CAACiB,EAAP,GAAY,KAAZ;EACAjB,IAAAA,MAAM,CAACI,GAAP,GAAa,IAAb;EACD,GAvDqC;;;EA0DtC,SAAOJ,MAAP;EACD;;EAED,SAASkB,SAAT,CAAmBC,SAAnB,EAAmC;EAAA,MAAhBA,SAAgB;EAAhBA,IAAAA,SAAgB,GAAJ,EAAI;EAAA;;EACjC,MAAI,CAACnB,MAAL,EAAa;EACXA,IAAAA,MAAM,GAAGC,UAAU,CAACkB,SAAD,CAAnB;EACD;;EACD,SAAOnB,MAAP;EACD;;ECrED,IAAIoB,OAAJ;;EAEA,SAASC,WAAT,GAAuB;EACrB,MAAMtS,MAAM,GAAGF,SAAS,EAAxB;;EACA,WAASyS,QAAT,GAAoB;EAClB,QAAMnB,EAAE,GAAGpR,MAAM,CAACtB,SAAP,CAAiBC,SAAjB,CAA2B6T,WAA3B,EAAX;EACA,WAAOpB,EAAE,CAACjP,OAAH,CAAW,QAAX,KAAwB,CAAxB,IAA6BiP,EAAE,CAACjP,OAAH,CAAW,QAAX,IAAuB,CAApD,IAAyDiP,EAAE,CAACjP,OAAH,CAAW,SAAX,IAAwB,CAAxF;EACD;;EACD,SAAO;EACLsQ,IAAAA,MAAM,EAAE,CAAC,CAACzS,MAAM,CAACtB,SAAP,CAAiBC,SAAjB,CAA2BgT,KAA3B,CAAiC,OAAjC,CADL;EAELY,IAAAA,QAAQ,EAAEA,QAAQ,EAFb;EAGLG,IAAAA,SAAS,EAAE,+CAA+CC,IAA/C,CAAoD3S,MAAM,CAACtB,SAAP,CAAiBC,SAArE;EAHN,GAAP;EAKD;;EAED,SAASiU,UAAT,GAAsB;EACpB,MAAI,CAACP,OAAL,EAAc;EACZA,IAAAA,OAAO,GAAGC,WAAW,EAArB;EACD;;EACD,SAAOD,OAAP;EACD;;ECnBD,IAAMQ,sBAAsB,GAAG,SAAzBA,sBAAyB,GAAM;EACnC,MAAM7S,MAAM,GAAGF,SAAS,EAAxB;EACA,SAAO,OAAOE,MAAM,CAAC8S,cAAd,KAAiC,WAAxC;EACD,CAHD;;AAKA,eAAe;EACbC,EAAAA,IAAI,EAAE,QADO;EAEb1S,EAAAA,MAFa,oBAEJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACA9W,IAAAA,QAAM,CAAC8W,MAAD,EAAS;EACbC,MAAAA,MAAM,EAAE;EACNzC,QAAAA,QAAQ,EAAE,IADJ;EAEN0C,QAAAA,cAFM,4BAEW;EACf,cAAI,CAACF,MAAD,IAAWA,MAAM,CAACG,SAAlB,IAA+B,CAACH,MAAM,CAACI,WAA3C,EAAwD;EACxDJ,UAAAA,MAAM,CAACC,MAAP,CAAczC,QAAd,GAAyB,IAAIsC,cAAJ,CAAmB,UAACO,OAAD,EAAa;EAAA,gBAC/C7B,KAD+C,GAC7BwB,MAD6B,CAC/CxB,KAD+C;EAAA,gBACxCE,MADwC,GAC7BsB,MAD6B,CACxCtB,MADwC;EAEvD,gBAAI4B,QAAQ,GAAG9B,KAAf;EACA,gBAAI+B,SAAS,GAAG7B,MAAhB;EACA2B,YAAAA,OAAO,CAAC/W,OAAR,CAAgB,gBAA6C;EAAA,kBAA1CkX,cAA0C,QAA1CA,cAA0C;EAAA,kBAA1BC,WAA0B,QAA1BA,WAA0B;EAAA,kBAAbtX,MAAa,QAAbA,MAAa;EAC3D,kBAAIA,MAAM,IAAIA,MAAM,KAAK6W,MAAM,CAAChP,EAAhC,EAAoC;EACpCsP,cAAAA,QAAQ,GAAGG,WAAW,GAClBA,WAAW,CAACjC,KADM,GAElB,CAACgC,cAAc,CAAC,CAAD,CAAd,IAAqBA,cAAtB,EAAsCE,UAF1C;EAGAH,cAAAA,SAAS,GAAGE,WAAW,GACnBA,WAAW,CAAC/B,MADO,GAEnB,CAAC8B,cAAc,CAAC,CAAD,CAAd,IAAqBA,cAAtB,EAAsCG,SAF1C;EAGD,aARD;;EASA,gBAAIL,QAAQ,KAAK9B,KAAb,IAAsB+B,SAAS,KAAK7B,MAAxC,EAAgD;EAC9CsB,cAAAA,MAAM,CAACC,MAAP,CAAcW,aAAd;EACD;EACF,WAhBwB,CAAzB;EAiBAZ,UAAAA,MAAM,CAACC,MAAP,CAAczC,QAAd,CAAuBqD,OAAvB,CAA+Bb,MAAM,CAAChP,EAAtC;EACD,SAtBK;EAuBN8P,QAAAA,cAvBM,4BAuBW;EACf,cAAId,MAAM,CAACC,MAAP,CAAczC,QAAd,IAA0BwC,MAAM,CAACC,MAAP,CAAczC,QAAd,CAAuBuD,SAAjD,IAA8Df,MAAM,CAAChP,EAAzE,EAA6E;EAC3EgP,YAAAA,MAAM,CAACC,MAAP,CAAczC,QAAd,CAAuBuD,SAAvB,CAAiCf,MAAM,CAAChP,EAAxC;EACAgP,YAAAA,MAAM,CAACC,MAAP,CAAczC,QAAd,GAAyB,IAAzB;EACD;EACF,SA5BK;EA6BNoD,QAAAA,aA7BM,2BA6BU;EACd,cAAI,CAACZ,MAAD,IAAWA,MAAM,CAACG,SAAlB,IAA+B,CAACH,MAAM,CAACI,WAA3C,EAAwD;EACxDJ,UAAAA,MAAM,CAACgB,IAAP,CAAY,cAAZ;EACAhB,UAAAA,MAAM,CAACgB,IAAP,CAAY,QAAZ;EACD,SAjCK;EAkCNC,QAAAA,wBAlCM,sCAkCqB;EACzB,cAAI,CAACjB,MAAD,IAAWA,MAAM,CAACG,SAAlB,IAA+B,CAACH,MAAM,CAACI,WAA3C,EAAwD;EACxDJ,UAAAA,MAAM,CAACgB,IAAP,CAAY,mBAAZ;EACD;EArCK;EADK,KAAT,CAAN;EAyCD,GA7CY;EA8Cb5M,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACX,UAAMhT,MAAM,GAAGF,SAAS,EAAxB;;EACA,UAAIkT,MAAM,CAACmB,MAAP,CAAcC,cAAd,IAAgCvB,sBAAsB,EAA1D,EAA8D;EAC5DG,QAAAA,MAAM,CAACC,MAAP,CAAcC,cAAd;EACA;EACD,OALU;;;EAOXlT,MAAAA,MAAM,CAACrD,gBAAP,CAAwB,QAAxB,EAAkCqW,MAAM,CAACC,MAAP,CAAcW,aAAhD,EAPW;;EAUX5T,MAAAA,MAAM,CAACrD,gBAAP,CAAwB,mBAAxB,EAA6CqW,MAAM,CAACC,MAAP,CAAcgB,wBAA3D;EACD,KAZC;EAaFI,IAAAA,OAbE,mBAaMrB,MAbN,EAac;EACd,UAAMhT,MAAM,GAAGF,SAAS,EAAxB;EACAkT,MAAAA,MAAM,CAACC,MAAP,CAAca,cAAd;EACA9T,MAAAA,MAAM,CAACpD,mBAAP,CAA2B,QAA3B,EAAqCoW,MAAM,CAACC,MAAP,CAAcW,aAAnD;EACA5T,MAAAA,MAAM,CAACpD,mBAAP,CAA2B,mBAA3B,EAAgDoW,MAAM,CAACC,MAAP,CAAcgB,wBAA9D;EACD;EAlBC;EA9CS,CAAf;;ECLA,IAAMK,QAAQ,GAAG;EACfC,EAAAA,MADe,kBACRpY,MADQ,EACAqY,OADA,EACc;EAAA,QAAdA,OAAc;EAAdA,MAAAA,OAAc,GAAJ,EAAI;EAAA;;EAC3B,QAAMxU,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAMkT,MAAM,GAAG,IAAf;EAEA,QAAMyB,YAAY,GAAGzU,MAAM,CAAC0U,gBAAP,IAA2B1U,MAAM,CAAC2U,sBAAvD;EACA,QAAMnE,QAAQ,GAAG,IAAIiE,YAAJ,CAAiB,UAACG,SAAD,EAAe;EAC/C;EACA;EACA;EACA,UAAIA,SAAS,CAACpY,MAAV,KAAqB,CAAzB,EAA4B;EAC1BwW,QAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ,EAA8BY,SAAS,CAAC,CAAD,CAAvC;EACA;EACD;;EACD,UAAMC,cAAc,GAAG,SAASA,cAAT,GAA0B;EAC/C7B,QAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ,EAA8BY,SAAS,CAAC,CAAD,CAAvC;EACD,OAFD;;EAIA,UAAI5U,MAAM,CAACN,qBAAX,EAAkC;EAChCM,QAAAA,MAAM,CAACN,qBAAP,CAA6BmV,cAA7B;EACD,OAFD,MAEO;EACL7U,QAAAA,MAAM,CAACT,UAAP,CAAkBsV,cAAlB,EAAkC,CAAlC;EACD;EACF,KAjBgB,CAAjB;EAmBArE,IAAAA,QAAQ,CAACqD,OAAT,CAAiB1X,MAAjB,EAAyB;EACvB2Y,MAAAA,UAAU,EAAE,OAAON,OAAO,CAACM,UAAf,KAA8B,WAA9B,GAA4C,IAA5C,GAAmDN,OAAO,CAACM,UADhD;EAEvBC,MAAAA,SAAS,EAAE,OAAOP,OAAO,CAACO,SAAf,KAA6B,WAA7B,GAA2C,IAA3C,GAAkDP,OAAO,CAACO,SAF9C;EAGvBC,MAAAA,aAAa,EAAE,OAAOR,OAAO,CAACQ,aAAf,KAAiC,WAAjC,GAA+C,IAA/C,GAAsDR,OAAO,CAACQ;EAHtD,KAAzB;EAMAhC,IAAAA,MAAM,CAACxC,QAAP,CAAgByE,SAAhB,CAA0BvT,IAA1B,CAA+B8O,QAA/B;EACD,GAhCc;EAiCf0D,EAAAA,IAjCe,kBAiCR;EACL,QAAMlB,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAAC/C,OAAP,CAAeO,QAAhB,IAA4B,CAACwC,MAAM,CAACmB,MAAP,CAAc3D,QAA/C,EAAyD;;EACzD,QAAIwC,MAAM,CAACmB,MAAP,CAAce,cAAlB,EAAkC;EAChC,UAAMC,gBAAgB,GAAGnC,MAAM,CAACoC,GAAP,CAAWnN,OAAX,EAAzB;;EACA,WAAK,IAAI3D,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6Q,gBAAgB,CAAC3Y,MAArC,EAA6C8H,CAAC,IAAI,CAAlD,EAAqD;EACnD0O,QAAAA,MAAM,CAACxC,QAAP,CAAgB+D,MAAhB,CAAuBY,gBAAgB,CAAC7Q,CAAD,CAAvC;EACD;EACF,KARI;;;EAUL0O,IAAAA,MAAM,CAACxC,QAAP,CAAgB+D,MAAhB,CAAuBvB,MAAM,CAACoC,GAAP,CAAW,CAAX,CAAvB,EAAsC;EACpCL,MAAAA,SAAS,EAAE/B,MAAM,CAACmB,MAAP,CAAckB;EADW,KAAtC,EAVK;;EAeLrC,IAAAA,MAAM,CAACxC,QAAP,CAAgB+D,MAAhB,CAAuBvB,MAAM,CAACsC,UAAP,CAAkB,CAAlB,CAAvB,EAA6C;EAAER,MAAAA,UAAU,EAAE;EAAd,KAA7C;EACD,GAjDc;EAkDfT,EAAAA,OAlDe,qBAkDL;EACR,QAAMrB,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAACxC,QAAP,CAAgByE,SAAhB,CAA0B3Y,OAA1B,CAAkC,UAACkU,QAAD,EAAc;EAC9CA,MAAAA,QAAQ,CAAC+E,UAAT;EACD,KAFD;EAGAvC,IAAAA,MAAM,CAACxC,QAAP,CAAgByE,SAAhB,GAA4B,EAA5B;EACD;EAxDc,CAAjB;AA2DA,mBAAe;EACblC,EAAAA,IAAI,EAAE,UADO;EAEboB,EAAAA,MAAM,EAAE;EACN3D,IAAAA,QAAQ,EAAE,KADJ;EAEN0E,IAAAA,cAAc,EAAE,KAFV;EAGNG,IAAAA,oBAAoB,EAAE;EAHhB,GAFK;EAObhV,EAAAA,MAPa,oBAOJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBxC,MAAAA,QAAQ,eACH8D,QADG;EAENW,QAAAA,SAAS,EAAE;EAFL;EADgB,KAAT,CAAjB;EAMD,GAfY;EAgBb7N,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACXA,MAAAA,MAAM,CAACxC,QAAP,CAAgB0D,IAAhB;EACD,KAHC;EAIFG,IAAAA,OAJE,mBAIMrB,MAJN,EAIc;EACdA,MAAAA,MAAM,CAACxC,QAAP,CAAgB6D,OAAhB;EACD;EANC;EAhBS,CAAf;;AC5DA,gBAAe;EACbmB,EAAAA,SADa,qBACHC,cADG,EACa;EACxB,QAAM1T,QAAQ,GAAG,IAAjB;EACA,QAAI,CAACA,QAAQ,CAAC2T,OAAd,EAAuB;EACvBzZ,IAAAA,MAAM,CAACI,IAAP,CAAY0F,QAAQ,CAAC2T,OAArB,EAA8BpZ,OAA9B,CAAsC,UAACqZ,UAAD,EAAgB;EACpD,UAAMC,MAAM,GAAG7T,QAAQ,CAAC2T,OAAT,CAAiBC,UAAjB,CAAf,CADoD;;EAGpD,UAAIC,MAAM,CAACzB,MAAX,EAAmB;EACjBjY,QAAAA,QAAM,CAACuZ,cAAD,EAAiBG,MAAM,CAACzB,MAAxB,CAAN;EACD;EACF,KAND;EAOD,GAXY;EAab0B,EAAAA,UAba,sBAaFC,aAbE,EAakB;EAAA,QAApBA,aAAoB;EAApBA,MAAAA,aAAoB,GAAJ,EAAI;EAAA;;EAC7B,QAAM/T,QAAQ,GAAG,IAAjB;EACA,QAAI,CAACA,QAAQ,CAAC2T,OAAd,EAAuB;EACvBzZ,IAAAA,MAAM,CAACI,IAAP,CAAY0F,QAAQ,CAAC2T,OAArB,EAA8BpZ,OAA9B,CAAsC,UAACqZ,UAAD,EAAgB;EACpD,UAAMC,MAAM,GAAG7T,QAAQ,CAAC2T,OAAT,CAAiBC,UAAjB,CAAf;EACA,UAAMI,YAAY,GAAGD,aAAa,CAACH,UAAD,CAAb,IAA6B,EAAlD,CAFoD;;EAKpD,UAAIC,MAAM,CAACxO,EAAP,IAAarF,QAAQ,CAACqF,EAA1B,EAA8B;EAC5BnL,QAAAA,MAAM,CAACI,IAAP,CAAYuZ,MAAM,CAACxO,EAAnB,EAAuB9K,OAAvB,CAA+B,UAAC0Z,eAAD,EAAqB;EAClDjU,UAAAA,QAAQ,CAACqF,EAAT,CAAY4O,eAAZ,EAA6BJ,MAAM,CAACxO,EAAP,CAAU4O,eAAV,CAA7B;EACD,SAFD;EAGD,OATmD;;;EAYpD,UAAIJ,MAAM,CAACvV,MAAX,EAAmB;EACjBuV,QAAAA,MAAM,CAACvV,MAAP,CAAcyB,IAAd,CAAmBC,QAAnB,EAA6BgU,YAA7B;EACD;EACF,KAfD;EAgBD;EAhCY,CAAf;;ECFA;AAEA,sBAAe;EACb3O,EAAAA,EADa,cACVgB,MADU,EACFW,OADE,EACOkN,QADP,EACiB;EAC5B,QAAM/S,IAAI,GAAG,IAAb;EACA,QAAI,OAAO6F,OAAP,KAAmB,UAAvB,EAAmC,OAAO7F,IAAP;EACnC,QAAMgT,MAAM,GAAGD,QAAQ,GAAG,SAAH,GAAe,MAAtC;EACA7N,IAAAA,MAAM,CAAC5C,KAAP,CAAa,GAAb,EAAkBlJ,OAAlB,CAA0B,UAACgM,KAAD,EAAW;EACnC,UAAI,CAACpF,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,CAAL,EAAkCpF,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,IAA8B,EAA9B;EAClCpF,MAAAA,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,EAA4B4N,MAA5B,EAAoCnN,OAApC;EACD,KAHD;EAIA,WAAO7F,IAAP;EACD,GAVY;EAYbkT,EAAAA,IAZa,gBAYRhO,MAZQ,EAYAW,OAZA,EAYSkN,QAZT,EAYmB;EAC9B,QAAM/S,IAAI,GAAG,IAAb;EACA,QAAI,OAAO6F,OAAP,KAAmB,UAAvB,EAAmC,OAAO7F,IAAP;;EACnC,aAASmT,WAAT,GAA8B;EAC5BnT,MAAAA,IAAI,CAACyF,GAAL,CAASP,MAAT,EAAiBiO,WAAjB;;EACA,UAAIA,WAAW,CAACC,cAAhB,EAAgC;EAC9B,eAAOD,WAAW,CAACC,cAAnB;EACD;;EAJ2B,wCAAN/U,IAAM;EAANA,QAAAA,IAAM;EAAA;;EAK5BwH,MAAAA,OAAO,CAACpH,KAAR,CAAcuB,IAAd,EAAoB3B,IAApB;EACD;;EACD8U,IAAAA,WAAW,CAACC,cAAZ,GAA6BvN,OAA7B;EACA,WAAO7F,IAAI,CAACkE,EAAL,CAAQgB,MAAR,EAAgBiO,WAAhB,EAA6BJ,QAA7B,CAAP;EACD,GAxBY;EA0BbM,EAAAA,KA1Ba,iBA0BPxN,OA1BO,EA0BEkN,QA1BF,EA0BY;EACvB,QAAM/S,IAAI,GAAG,IAAb;EACA,QAAI,OAAO6F,OAAP,KAAmB,UAAvB,EAAmC,OAAO7F,IAAP;EACnC,QAAMgT,MAAM,GAAGD,QAAQ,GAAG,SAAH,GAAe,MAAtC;;EACA,QAAI/S,IAAI,CAACsT,kBAAL,CAAwBrU,OAAxB,CAAgC4G,OAAhC,IAA2C,CAA/C,EAAkD;EAChD7F,MAAAA,IAAI,CAACsT,kBAAL,CAAwBN,MAAxB,EAAgCnN,OAAhC;EACD;;EACD,WAAO7F,IAAP;EACD,GAlCY;EAoCbuT,EAAAA,MApCa,kBAoCN1N,OApCM,EAoCG;EACd,QAAM7F,IAAI,GAAG,IAAb;EACA,QAAI,CAACA,IAAI,CAACsT,kBAAV,EAA8B,OAAOtT,IAAP;EAC9B,QAAMqI,KAAK,GAAGrI,IAAI,CAACsT,kBAAL,CAAwBrU,OAAxB,CAAgC4G,OAAhC,CAAd;;EACA,QAAIwC,KAAK,IAAI,CAAb,EAAgB;EACdrI,MAAAA,IAAI,CAACsT,kBAAL,CAAwBxN,MAAxB,CAA+BuC,KAA/B,EAAsC,CAAtC;EACD;;EACD,WAAOrI,IAAP;EACD,GA5CY;EA8CbyF,EAAAA,GA9Ca,eA8CTP,MA9CS,EA8CDW,OA9CC,EA8CQ;EACnB,QAAM7F,IAAI,GAAG,IAAb;EACA,QAAI,CAACA,IAAI,CAACiT,eAAV,EAA2B,OAAOjT,IAAP;EAC3BkF,IAAAA,MAAM,CAAC5C,KAAP,CAAa,GAAb,EAAkBlJ,OAAlB,CAA0B,UAACgM,KAAD,EAAW;EACnC,UAAI,OAAOS,OAAP,KAAmB,WAAvB,EAAoC;EAClC7F,QAAAA,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,IAA8B,EAA9B;EACD,OAFD,MAEO,IAAIpF,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,CAAJ,EAAiC;EACtCpF,QAAAA,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,EAA4BhM,OAA5B,CAAoC,UAACoa,YAAD,EAAenL,KAAf,EAAyB;EAC3D,cACEmL,YAAY,KAAK3N,OAAjB,IACC2N,YAAY,CAACJ,cAAb,IAA+BI,YAAY,CAACJ,cAAb,KAAgCvN,OAFlE,EAGE;EACA7F,YAAAA,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,EAA4BU,MAA5B,CAAmCuC,KAAnC,EAA0C,CAA1C;EACD;EACF,SAPD;EAQD;EACF,KAbD;EAcA,WAAOrI,IAAP;EACD,GAhEY;EAkEb8Q,EAAAA,IAlEa,kBAkEC;EACZ,QAAM9Q,IAAI,GAAG,IAAb;EACA,QAAI,CAACA,IAAI,CAACiT,eAAV,EAA2B,OAAOjT,IAAP;EAC3B,QAAIkF,MAAJ;EACA,QAAIqB,IAAJ;EACA,QAAIhF,OAAJ;;EALY,uCAANlD,IAAM;EAANA,MAAAA,IAAM;EAAA;;EAMZ,QAAI,OAAOA,IAAI,CAAC,CAAD,CAAX,KAAmB,QAAnB,IAA+BqC,KAAK,CAACK,OAAN,CAAc1C,IAAI,CAAC,CAAD,CAAlB,CAAnC,EAA2D;EACzD6G,MAAAA,MAAM,GAAG7G,IAAI,CAAC,CAAD,CAAb;EACAkI,MAAAA,IAAI,GAAGlI,IAAI,CAAC6N,KAAL,CAAW,CAAX,EAAc7N,IAAI,CAAC/E,MAAnB,CAAP;EACAiI,MAAAA,OAAO,GAAGvB,IAAV;EACD,KAJD,MAIO;EACLkF,MAAAA,MAAM,GAAG7G,IAAI,CAAC,CAAD,CAAJ,CAAQ6G,MAAjB;EACAqB,MAAAA,IAAI,GAAGlI,IAAI,CAAC,CAAD,CAAJ,CAAQkI,IAAf;EACAhF,MAAAA,OAAO,GAAGlD,IAAI,CAAC,CAAD,CAAJ,CAAQkD,OAAR,IAAmBvB,IAA7B;EACD;;EACDuG,IAAAA,IAAI,CAAC3B,OAAL,CAAarD,OAAb;EACA,QAAMkS,WAAW,GAAG/S,KAAK,CAACK,OAAN,CAAcmE,MAAd,IAAwBA,MAAxB,GAAiCA,MAAM,CAAC5C,KAAP,CAAa,GAAb,CAArD;EAEAmR,IAAAA,WAAW,CAACra,OAAZ,CAAoB,UAACgM,KAAD,EAAW;EAC7B,UAAIpF,IAAI,CAACsT,kBAAL,IAA2BtT,IAAI,CAACsT,kBAAL,CAAwBha,MAAvD,EAA+D;EAC7D0G,QAAAA,IAAI,CAACsT,kBAAL,CAAwBla,OAAxB,CAAgC,UAACoa,YAAD,EAAkB;EAChDA,UAAAA,YAAY,CAAC/U,KAAb,CAAmB8C,OAAnB,GAA6B6D,KAA7B,SAAuCmB,IAAvC;EACD,SAFD;EAGD;;EACD,UAAIvG,IAAI,CAACiT,eAAL,IAAwBjT,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,CAA5B,EAAyD;EACvDpF,QAAAA,IAAI,CAACiT,eAAL,CAAqB7N,KAArB,EAA4BhM,OAA5B,CAAoC,UAACoa,YAAD,EAAkB;EACpDA,UAAAA,YAAY,CAAC/U,KAAb,CAAmB8C,OAAnB,EAA4BgF,IAA5B;EACD,SAFD;EAGD;EACF,KAXD;EAYA,WAAOvG,IAAP;EACD;EAjGY,CAAf;;ECAe,SAAS0T,UAAT,GAAsB;EACnC,MAAM5D,MAAM,GAAG,IAAf;EACA,MAAIxB,KAAJ;EACA,MAAIE,MAAJ;EACA,MAAM0D,GAAG,GAAGpC,MAAM,CAACoC,GAAnB;;EACA,MAAI,OAAOpC,MAAM,CAACmB,MAAP,CAAc3C,KAArB,KAA+B,WAA/B,IAA8CwB,MAAM,CAACmB,MAAP,CAAc3C,KAAd,KAAwB,IAA1E,EAAgF;EAC9EA,IAAAA,KAAK,GAAGwB,MAAM,CAACmB,MAAP,CAAc3C,KAAtB;EACD,GAFD,MAEO;EACLA,IAAAA,KAAK,GAAG4D,GAAG,CAAC,CAAD,CAAH,CAAOyB,WAAf;EACD;;EACD,MAAI,OAAO7D,MAAM,CAACmB,MAAP,CAAczC,MAArB,KAAgC,WAAhC,IAA+CsB,MAAM,CAACmB,MAAP,CAAczC,MAAd,KAAyB,IAA5E,EAAkF;EAChFA,IAAAA,MAAM,GAAGsB,MAAM,CAACmB,MAAP,CAAczC,MAAvB;EACD,GAFD,MAEO;EACLA,IAAAA,MAAM,GAAG0D,GAAG,CAAC,CAAD,CAAH,CAAO0B,YAAhB;EACD;;EACD,MAAKtF,KAAK,KAAK,CAAV,IAAewB,MAAM,CAAC+D,YAAP,EAAhB,IAA2CrF,MAAM,KAAK,CAAX,IAAgBsB,MAAM,CAACgE,UAAP,EAA/D,EAAqF;EACnF;EACD,GAjBkC;;;EAoBnCxF,EAAAA,KAAK,GACHA,KAAK,GACLyF,QAAQ,CAAC7B,GAAG,CAACjK,GAAJ,CAAQ,cAAR,KAA2B,CAA5B,EAA+B,EAA/B,CADR,GAEA8L,QAAQ,CAAC7B,GAAG,CAACjK,GAAJ,CAAQ,eAAR,KAA4B,CAA7B,EAAgC,EAAhC,CAHV;EAIAuG,EAAAA,MAAM,GACJA,MAAM,GACNuF,QAAQ,CAAC7B,GAAG,CAACjK,GAAJ,CAAQ,aAAR,KAA0B,CAA3B,EAA8B,EAA9B,CADR,GAEA8L,QAAQ,CAAC7B,GAAG,CAACjK,GAAJ,CAAQ,gBAAR,KAA6B,CAA9B,EAAiC,EAAjC,CAHV;EAKA,MAAI+L,MAAM,CAACC,KAAP,CAAa3F,KAAb,CAAJ,EAAyBA,KAAK,GAAG,CAAR;EACzB,MAAI0F,MAAM,CAACC,KAAP,CAAazF,MAAb,CAAJ,EAA0BA,MAAM,GAAG,CAAT;EAE1BxV,EAAAA,QAAM,CAAC8W,MAAD,EAAS;EACbxB,IAAAA,KAAK,EAALA,KADa;EAEbE,IAAAA,MAAM,EAANA,MAFa;EAGb0F,IAAAA,IAAI,EAAEpE,MAAM,CAAC+D,YAAP,KAAwBvF,KAAxB,GAAgCE;EAHzB,GAAT,CAAN;EAKD;;ECrCc,SAAS2F,YAAT,GAAwB;EACrC,MAAMrE,MAAM,GAAG,IAAf;;EACA,MAAMsE,iBAAiB,GAAG,SAApBA,iBAAoB,CAACC,QAAD,EAAc;EACtC,QAAIvE,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB,aAAOQ,QAAP;EACD,KAHqC;;;EAKtC,WAAO;EACL,eAAS,QADJ;EAEL,oBAAc,aAFT;EAGL,wBAAkB,cAHb;EAIL,qBAAe,YAJV;EAKL,sBAAgB,eALX;EAML,sBAAgB,aANX;EAOL,uBAAiB,gBAPZ;EAQL,qBAAe;EARV,MASLA,QATK,CAAP;EAUD,GAfD;;EAgBA,MAAMC,yBAAyB,GAAG,SAA5BA,yBAA4B,CAACC,IAAD,EAAOC,KAAP,EAAiB;EACjD,WAAOtN,UAAU,CAACqN,IAAI,CAACtY,gBAAL,CAAsBmY,iBAAiB,CAACI,KAAD,CAAvC,KAAmD,CAApD,CAAjB;EACD,GAFD;;EAIA,MAAMvD,MAAM,GAAGnB,MAAM,CAACmB,MAAtB;EAtBqC,MAwB7BmB,UAxB6B,GAwBiCtC,MAxBjC,CAwB7BsC,UAxB6B;EAAA,MAwBXqC,UAxBW,GAwBiC3E,MAxBjC,CAwBjBoE,IAxBiB;EAAA,MAwBeQ,GAxBf,GAwBiC5E,MAxBjC,CAwBC6E,YAxBD;EAAA,MAwBoBC,QAxBpB,GAwBiC9E,MAxBjC,CAwBoB8E,QAxBpB;EAyBrC,MAAMC,SAAS,GAAG/E,MAAM,CAACgF,OAAP,IAAkB7D,MAAM,CAAC6D,OAAP,CAAeC,OAAnD;EACA,MAAMC,oBAAoB,GAAGH,SAAS,GAAG/E,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsB3b,MAAzB,GAAkCwW,MAAM,CAACmF,MAAP,CAAc3b,MAAtF;EACA,MAAM2b,MAAM,GAAG7C,UAAU,CAAChY,QAAX,OAAwB0V,MAAM,CAACmB,MAAP,CAAciE,UAAtC,CAAf;EACA,MAAMC,YAAY,GAAGN,SAAS,GAAG/E,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsB3b,MAAzB,GAAkC2b,MAAM,CAAC3b,MAAvE;EACA,MAAI8b,QAAQ,GAAG,EAAf;EACA,MAAMC,UAAU,GAAG,EAAnB;EACA,MAAMC,eAAe,GAAG,EAAxB;;EAEA,WAASC,eAAT,CAAyBC,OAAzB,EAAkCC,UAAlC,EAA8C;EAC5C,QAAI,CAACxE,MAAM,CAACyE,OAAZ,EAAqB,OAAO,IAAP;;EACrB,QAAID,UAAU,KAAKR,MAAM,CAAC3b,MAAP,GAAgB,CAAnC,EAAsC;EACpC,aAAO,KAAP;EACD;;EACD,WAAO,IAAP;EACD;;EAED,MAAIqc,YAAY,GAAG1E,MAAM,CAAC2E,kBAA1B;;EACA,MAAI,OAAOD,YAAP,KAAwB,UAA5B,EAAwC;EACtCA,IAAAA,YAAY,GAAG1E,MAAM,CAAC2E,kBAAP,CAA0B3X,IAA1B,CAA+B6R,MAA/B,CAAf;EACD;;EAED,MAAI+F,WAAW,GAAG5E,MAAM,CAAC6E,iBAAzB;;EACA,MAAI,OAAOD,WAAP,KAAuB,UAA3B,EAAuC;EACrCA,IAAAA,WAAW,GAAG5E,MAAM,CAAC6E,iBAAP,CAAyB7X,IAAzB,CAA8B6R,MAA9B,CAAd;EACD;;EAED,MAAMiG,sBAAsB,GAAGjG,MAAM,CAACsF,QAAP,CAAgB9b,MAA/C;EACA,MAAM0c,wBAAwB,GAAGlG,MAAM,CAACuF,UAAP,CAAkB/b,MAAnD;EAEA,MAAI2c,YAAY,GAAGhF,MAAM,CAACgF,YAA1B;EACA,MAAIC,aAAa,GAAG,CAACP,YAArB;EACA,MAAIQ,aAAa,GAAG,CAApB;EACA,MAAI9N,KAAK,GAAG,CAAZ;;EACA,MAAI,OAAOoM,UAAP,KAAsB,WAA1B,EAAuC;EACrC;EACD;;EACD,MAAI,OAAOwB,YAAP,KAAwB,QAAxB,IAAoCA,YAAY,CAAChX,OAAb,CAAqB,GAArB,KAA6B,CAArE,EAAwE;EACtEgX,IAAAA,YAAY,GAAI/O,UAAU,CAAC+O,YAAY,CAACvK,OAAb,CAAqB,GAArB,EAA0B,EAA1B,CAAD,CAAV,GAA4C,GAA7C,GAAoD+I,UAAnE;EACD;;EAED3E,EAAAA,MAAM,CAACsG,WAAP,GAAqB,CAACH,YAAtB,CAjEqC;;EAoErC,MAAIvB,GAAJ,EAASO,MAAM,CAAChN,GAAP,CAAW;EAAEoO,IAAAA,UAAU,EAAE,EAAd;EAAkBC,IAAAA,SAAS,EAAE;EAA7B,GAAX,EAAT,KACKrB,MAAM,CAAChN,GAAP,CAAW;EAAEsO,IAAAA,WAAW,EAAE,EAAf;EAAmBC,IAAAA,YAAY,EAAE;EAAjC,GAAX;EAEL,MAAIC,sBAAJ;;EACA,MAAIxF,MAAM,CAACyF,eAAP,GAAyB,CAA7B,EAAgC;EAC9B,QACEC,IAAI,CAACC,KAAL,CAAWzB,YAAY,GAAGlE,MAAM,CAACyF,eAAjC,MACAvB,YAAY,GAAGrF,MAAM,CAACmB,MAAP,CAAcyF,eAF/B,EAGE;EACAD,MAAAA,sBAAsB,GAAGtB,YAAzB;EACD,KALD,MAKO;EACLsB,MAAAA,sBAAsB,GACpBE,IAAI,CAACE,IAAL,CAAU1B,YAAY,GAAGlE,MAAM,CAACyF,eAAhC,IAAmDzF,MAAM,CAACyF,eAD5D;EAED;;EACD,QAAIzF,MAAM,CAAC6F,aAAP,KAAyB,MAAzB,IAAmC7F,MAAM,CAAC8F,mBAAP,KAA+B,KAAtE,EAA6E;EAC3EN,MAAAA,sBAAsB,GAAGE,IAAI,CAACK,GAAL,CACvBP,sBADuB,EAEvBxF,MAAM,CAAC6F,aAAP,GAAuB7F,MAAM,CAACyF,eAFP,CAAzB;EAID;EACF,GAxFoC;;;EA2FrC,MAAIO,SAAJ;EACA,MAAMP,eAAe,GAAGzF,MAAM,CAACyF,eAA/B;EACA,MAAMQ,YAAY,GAAGT,sBAAsB,GAAGC,eAA9C;EACA,MAAMS,cAAc,GAAGR,IAAI,CAACC,KAAL,CAAWzB,YAAY,GAAGlE,MAAM,CAACyF,eAAjC,CAAvB;;EACA,OAAK,IAAItV,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG+T,YAApB,EAAkC/T,CAAC,IAAI,CAAvC,EAA0C;EACxC6V,IAAAA,SAAS,GAAG,CAAZ;EACA,QAAMG,KAAK,GAAGnC,MAAM,CAAClM,EAAP,CAAU3H,CAAV,CAAd;;EACA,QAAI6P,MAAM,CAACyF,eAAP,GAAyB,CAA7B,EAAgC;EAC9B;EACA,UAAIW,kBAAkB,SAAtB;EACA,UAAIC,MAAM,SAAV;EACA,UAAIC,GAAG,SAAP;;EACA,UAAItG,MAAM,CAAC8F,mBAAP,KAA+B,KAA/B,IAAwC9F,MAAM,CAACuG,cAAP,GAAwB,CAApE,EAAuE;EACrE,YAAMC,UAAU,GAAGd,IAAI,CAACC,KAAL,CAAWxV,CAAC,IAAI6P,MAAM,CAACuG,cAAP,GAAwBvG,MAAM,CAACyF,eAAnC,CAAZ,CAAnB;EACA,YAAMgB,iBAAiB,GAAGtW,CAAC,GAAG6P,MAAM,CAACyF,eAAP,GAAyBzF,MAAM,CAACuG,cAAhC,GAAiDC,UAA/E;EACA,YAAME,cAAc,GAClBF,UAAU,KAAK,CAAf,GACIxG,MAAM,CAACuG,cADX,GAEIb,IAAI,CAACiB,GAAL,CACEjB,IAAI,CAACE,IAAL,CACE,CAAC1B,YAAY,GAAGsC,UAAU,GAAGf,eAAb,GAA+BzF,MAAM,CAACuG,cAAtD,IACEd,eAFJ,CADF,EAKEzF,MAAM,CAACuG,cALT,CAHN;EAUAD,QAAAA,GAAG,GAAGZ,IAAI,CAACC,KAAL,CAAWc,iBAAiB,GAAGC,cAA/B,CAAN;EACAL,QAAAA,MAAM,GAAGI,iBAAiB,GAAGH,GAAG,GAAGI,cAA1B,GAA2CF,UAAU,GAAGxG,MAAM,CAACuG,cAAxE;EAEAH,QAAAA,kBAAkB,GAAGC,MAAM,GAAIC,GAAG,GAAGd,sBAAP,GAAiCC,eAA/D;EACAU,QAAAA,KAAK,CAACnP,GAAN,CAAU;EACR,uCAA6BoP,kBADrB;EAER,oCAA0BA,kBAFlB;EAGR,4BAAkBA,kBAHV;EAIR,2BAAiBA,kBAJT;EAKRQ,UAAAA,KAAK,EAAER;EALC,SAAV;EAOD,OAxBD,MAwBO,IAAIpG,MAAM,CAAC8F,mBAAP,KAA+B,QAAnC,EAA6C;EAClDO,QAAAA,MAAM,GAAGX,IAAI,CAACC,KAAL,CAAWxV,CAAC,GAAGsV,eAAf,CAAT;EACAa,QAAAA,GAAG,GAAGnW,CAAC,GAAGkW,MAAM,GAAGZ,eAAnB;;EACA,YAAIY,MAAM,GAAGH,cAAT,IAA4BG,MAAM,KAAKH,cAAX,IAA6BI,GAAG,KAAKb,eAAe,GAAG,CAAvF,EAA2F;EACzFa,UAAAA,GAAG,IAAI,CAAP;;EACA,cAAIA,GAAG,IAAIb,eAAX,EAA4B;EAC1Ba,YAAAA,GAAG,GAAG,CAAN;EACAD,YAAAA,MAAM,IAAI,CAAV;EACD;EACF;EACF,OAVM,MAUA;EACLC,QAAAA,GAAG,GAAGZ,IAAI,CAACC,KAAL,CAAWxV,CAAC,GAAG8V,YAAf,CAAN;EACAI,QAAAA,MAAM,GAAGlW,CAAC,GAAGmW,GAAG,GAAGL,YAAnB;EACD;;EACDE,MAAAA,KAAK,CAACnP,GAAN,CACEmM,iBAAiB,CAAC,YAAD,CADnB,EAEEmD,GAAG,KAAK,CAAR,IAAatG,MAAM,CAACgF,YAApB,IAAuChF,MAAM,CAACgF,YAA9C,OAFF;EAID;;EACD,QAAImB,KAAK,CAACnP,GAAN,CAAU,SAAV,MAAyB,MAA7B,EAAqC,SAnDG;;EAqDxC,QAAIgJ,MAAM,CAAC6F,aAAP,KAAyB,MAA7B,EAAqC;EACnC,UAAMgB,WAAW,GAAG9b,gBAAgB,CAACob,KAAK,CAAC,CAAD,CAAN,CAApC;EACA,UAAMW,gBAAgB,GAAGX,KAAK,CAAC,CAAD,CAAL,CAAS9c,KAAT,CAAewJ,SAAxC;EACA,UAAMkU,sBAAsB,GAAGZ,KAAK,CAAC,CAAD,CAAL,CAAS9c,KAAT,CAAemR,eAA9C;;EACA,UAAIsM,gBAAJ,EAAsB;EACpBX,QAAAA,KAAK,CAAC,CAAD,CAAL,CAAS9c,KAAT,CAAewJ,SAAf,GAA2B,MAA3B;EACD;;EACD,UAAIkU,sBAAJ,EAA4B;EAC1BZ,QAAAA,KAAK,CAAC,CAAD,CAAL,CAAS9c,KAAT,CAAemR,eAAf,GAAiC,MAAjC;EACD;;EACD,UAAIwF,MAAM,CAACgH,YAAX,EAAyB;EACvBhB,QAAAA,SAAS,GAAGnH,MAAM,CAAC+D,YAAP,KAAwBuD,KAAK,CAACvQ,UAAN,CAAiB,IAAjB,CAAxB,GAAiDuQ,KAAK,CAACjQ,WAAN,CAAkB,IAAlB,CAA7D;EACD,OAFD,MAEO;EACL;EACA,YAAMmH,KAAK,GAAGgG,yBAAyB,CAACwD,WAAD,EAAc,OAAd,CAAvC;EACA,YAAMI,WAAW,GAAG5D,yBAAyB,CAACwD,WAAD,EAAc,cAAd,CAA7C;EACA,YAAMK,YAAY,GAAG7D,yBAAyB,CAACwD,WAAD,EAAc,eAAd,CAA9C;EACA,YAAMzB,UAAU,GAAG/B,yBAAyB,CAACwD,WAAD,EAAc,aAAd,CAA5C;EACA,YAAMvB,WAAW,GAAGjC,yBAAyB,CAACwD,WAAD,EAAc,cAAd,CAA7C;EACA,YAAMM,SAAS,GAAGN,WAAW,CAAC7b,gBAAZ,CAA6B,YAA7B,CAAlB;;EACA,YAAImc,SAAS,IAAIA,SAAS,KAAK,YAA/B,EAA6C;EAC3CnB,UAAAA,SAAS,GAAG3I,KAAK,GAAG+H,UAAR,GAAqBE,WAAjC;EACD,SAFD,MAEO;EAAA,wBACgCa,KAAK,CAAC,CAAD,CADrC;EAAA,cACGzD,WADH,WACGA,WADH;EAAA,cACgB1M,WADhB,WACgBA,WADhB;EAELgQ,UAAAA,SAAS,GACP3I,KAAK,GACL4J,WADA,GAEAC,YAFA,GAGA9B,UAHA,GAIAE,WAJA,IAKCtP,WAAW,GAAG0M,WALf,CADF;EAOD;EACF;;EACD,UAAIoE,gBAAJ,EAAsB;EACpBX,QAAAA,KAAK,CAAC,CAAD,CAAL,CAAS9c,KAAT,CAAewJ,SAAf,GAA2BiU,gBAA3B;EACD;;EACD,UAAIC,sBAAJ,EAA4B;EAC1BZ,QAAAA,KAAK,CAAC,CAAD,CAAL,CAAS9c,KAAT,CAAemR,eAAf,GAAiCuM,sBAAjC;EACD;;EACD,UAAI/G,MAAM,CAACgH,YAAX,EAAyBhB,SAAS,GAAGN,IAAI,CAACC,KAAL,CAAWK,SAAX,CAAZ;EAC1B,KAxCD,MAwCO;EACLA,MAAAA,SAAS,GAAG,CAACxC,UAAU,GAAG,CAACxD,MAAM,CAAC6F,aAAP,GAAuB,CAAxB,IAA6Bb,YAA3C,IAA2DhF,MAAM,CAAC6F,aAA9E;EACA,UAAI7F,MAAM,CAACgH,YAAX,EAAyBhB,SAAS,GAAGN,IAAI,CAACC,KAAL,CAAWK,SAAX,CAAZ;;EAEzB,UAAIhC,MAAM,CAAC7T,CAAD,CAAV,EAAe;EACb6T,QAAAA,MAAM,CAAC7T,CAAD,CAAN,CAAU9G,KAAV,CAAgB8Z,iBAAiB,CAAC,OAAD,CAAjC,IAAiD6C,SAAjD;EACD;EACF;;EACD,QAAIhC,MAAM,CAAC7T,CAAD,CAAV,EAAe;EACb6T,MAAAA,MAAM,CAAC7T,CAAD,CAAN,CAAUiX,eAAV,GAA4BpB,SAA5B;EACD;;EACD3B,IAAAA,eAAe,CAAC9W,IAAhB,CAAqByY,SAArB;;EAEA,QAAIhG,MAAM,CAACqH,cAAX,EAA2B;EACzBpC,MAAAA,aAAa,GAAGA,aAAa,GAAGe,SAAS,GAAG,CAA5B,GAAgCd,aAAa,GAAG,CAAhD,GAAoDF,YAApE;EACA,UAAIE,aAAa,KAAK,CAAlB,IAAuB/U,CAAC,KAAK,CAAjC,EACE8U,aAAa,GAAGA,aAAa,GAAGzB,UAAU,GAAG,CAA7B,GAAiCwB,YAAjD;EACF,UAAI7U,CAAC,KAAK,CAAV,EAAa8U,aAAa,GAAGA,aAAa,GAAGzB,UAAU,GAAG,CAA7B,GAAiCwB,YAAjD;EACb,UAAIU,IAAI,CAAC4B,GAAL,CAASrC,aAAT,IAA0B,IAAI,IAAlC,EAAwCA,aAAa,GAAG,CAAhB;EACxC,UAAIjF,MAAM,CAACgH,YAAX,EAAyB/B,aAAa,GAAGS,IAAI,CAACC,KAAL,CAAWV,aAAX,CAAhB;EACzB,UAAI7N,KAAK,GAAG4I,MAAM,CAACuG,cAAf,KAAkC,CAAtC,EAAyCpC,QAAQ,CAAC5W,IAAT,CAAc0X,aAAd;EACzCb,MAAAA,UAAU,CAAC7W,IAAX,CAAgB0X,aAAhB;EACD,KATD,MASO;EACL,UAAIjF,MAAM,CAACgH,YAAX,EAAyB/B,aAAa,GAAGS,IAAI,CAACC,KAAL,CAAWV,aAAX,CAAhB;EACzB,UACE,CAAC7N,KAAK,GAAGsO,IAAI,CAACiB,GAAL,CAAS9H,MAAM,CAACmB,MAAP,CAAcuH,kBAAvB,EAA2CnQ,KAA3C,CAAT,IACEyH,MAAM,CAACmB,MAAP,CAAcuG,cADhB,KAEA,CAHF,EAKEpC,QAAQ,CAAC5W,IAAT,CAAc0X,aAAd;EACFb,MAAAA,UAAU,CAAC7W,IAAX,CAAgB0X,aAAhB;EACAA,MAAAA,aAAa,GAAGA,aAAa,GAAGe,SAAhB,GAA4BhB,YAA5C;EACD;;EAEDnG,IAAAA,MAAM,CAACsG,WAAP,IAAsBa,SAAS,GAAGhB,YAAlC;EAEAE,IAAAA,aAAa,GAAGc,SAAhB;EAEA5O,IAAAA,KAAK,IAAI,CAAT;EACD;;EACDyH,EAAAA,MAAM,CAACsG,WAAP,GAAqBO,IAAI,CAACK,GAAL,CAASlH,MAAM,CAACsG,WAAhB,EAA6B3B,UAA7B,IAA2CoB,WAAhE;EACA,MAAI4C,aAAJ;;EAEA,MAAI/D,GAAG,IAAIE,QAAP,KAAoB3D,MAAM,CAACyH,MAAP,KAAkB,OAAlB,IAA6BzH,MAAM,CAACyH,MAAP,KAAkB,WAAnE,CAAJ,EAAqF;EACnFtG,IAAAA,UAAU,CAACnK,GAAX,CAAe;EAAEqG,MAAAA,KAAK,EAAKwB,MAAM,CAACsG,WAAP,GAAqBnF,MAAM,CAACgF,YAAjC;EAAP,KAAf;EACD;;EACD,MAAIhF,MAAM,CAAC0H,cAAX,EAA2B;EAAA;;EACzBvG,IAAAA,UAAU,CAACnK,GAAX,wCACGmM,iBAAiB,CAAC,OAAD,CADpB,IACmCtE,MAAM,CAACsG,WAAP,GAAqBnF,MAAM,CAACgF,YAD/D;EAGD;;EAED,MAAIhF,MAAM,CAACyF,eAAP,GAAyB,CAA7B,EAAgC;EAAA;;EAC9B5G,IAAAA,MAAM,CAACsG,WAAP,GAAqB,CAACa,SAAS,GAAGhG,MAAM,CAACgF,YAApB,IAAoCQ,sBAAzD;EACA3G,IAAAA,MAAM,CAACsG,WAAP,GACEO,IAAI,CAACE,IAAL,CAAU/G,MAAM,CAACsG,WAAP,GAAqBnF,MAAM,CAACyF,eAAtC,IAAyDzF,MAAM,CAACgF,YADlE;EAEA7D,IAAAA,UAAU,CAACnK,GAAX,0CACGmM,iBAAiB,CAAC,OAAD,CADpB,IACmCtE,MAAM,CAACsG,WAAP,GAAqBnF,MAAM,CAACgF,YAD/D;;EAGA,QAAIhF,MAAM,CAACqH,cAAX,EAA2B;EACzBG,MAAAA,aAAa,GAAG,EAAhB;;EACA,WAAK,IAAIrX,EAAC,GAAG,CAAb,EAAgBA,EAAC,GAAGgU,QAAQ,CAAC9b,MAA7B,EAAqC8H,EAAC,IAAI,CAA1C,EAA6C;EAC3C,YAAIwX,cAAc,GAAGxD,QAAQ,CAAChU,EAAD,CAA7B;EACA,YAAI6P,MAAM,CAACgH,YAAX,EAAyBW,cAAc,GAAGjC,IAAI,CAACC,KAAL,CAAWgC,cAAX,CAAjB;EACzB,YAAIxD,QAAQ,CAAChU,EAAD,CAAR,GAAc0O,MAAM,CAACsG,WAAP,GAAqBhB,QAAQ,CAAC,CAAD,CAA/C,EAAoDqD,aAAa,CAACja,IAAd,CAAmBoa,cAAnB;EACrD;;EACDxD,MAAAA,QAAQ,GAAGqD,aAAX;EACD;EACF,GAhQoC;;;EAmQrC,MAAI,CAACxH,MAAM,CAACqH,cAAZ,EAA4B;EAC1BG,IAAAA,aAAa,GAAG,EAAhB;;EACA,SAAK,IAAIrX,GAAC,GAAG,CAAb,EAAgBA,GAAC,GAAGgU,QAAQ,CAAC9b,MAA7B,EAAqC8H,GAAC,IAAI,CAA1C,EAA6C;EAC3C,UAAIwX,eAAc,GAAGxD,QAAQ,CAAChU,GAAD,CAA7B;EACA,UAAI6P,MAAM,CAACgH,YAAX,EAAyBW,eAAc,GAAGjC,IAAI,CAACC,KAAL,CAAWgC,eAAX,CAAjB;;EACzB,UAAIxD,QAAQ,CAAChU,GAAD,CAAR,IAAe0O,MAAM,CAACsG,WAAP,GAAqB3B,UAAxC,EAAoD;EAClDgE,QAAAA,aAAa,CAACja,IAAd,CAAmBoa,eAAnB;EACD;EACF;;EACDxD,IAAAA,QAAQ,GAAGqD,aAAX;;EAEA,QACE9B,IAAI,CAACC,KAAL,CAAW9G,MAAM,CAACsG,WAAP,GAAqB3B,UAAhC,IAA8CkC,IAAI,CAACC,KAAL,CAAWxB,QAAQ,CAACA,QAAQ,CAAC9b,MAAT,GAAkB,CAAnB,CAAnB,CAA9C,GACA,CAFF,EAGE;EACA8b,MAAAA,QAAQ,CAAC5W,IAAT,CAAcsR,MAAM,CAACsG,WAAP,GAAqB3B,UAAnC;EACD;EACF;;EACD,MAAIW,QAAQ,CAAC9b,MAAT,KAAoB,CAAxB,EAA2B8b,QAAQ,GAAG,CAAC,CAAD,CAAX;;EAE3B,MAAInE,MAAM,CAACgF,YAAP,KAAwB,CAA5B,EAA+B;EAAA;;EAC7B,QAAM5c,GAAG,GAAGyW,MAAM,CAAC+D,YAAP,MAAyBa,GAAzB,GAA+B,YAA/B,GAA8CN,iBAAiB,CAAC,aAAD,CAA3E;EACAa,IAAAA,MAAM,CAAChU,MAAP,CAAcsU,eAAd,EAA+BtN,GAA/B,8CAAsC5O,GAAtC,IAA+C4c,YAA/C;EACD;;EAED,MAAIhF,MAAM,CAACqH,cAAP,IAAyBrH,MAAM,CAAC4H,oBAApC,EAA0D;EACxD,QAAIC,aAAa,GAAG,CAApB;EACAxD,IAAAA,eAAe,CAAClc,OAAhB,CAAwB,UAAC2f,cAAD,EAAoB;EAC1CD,MAAAA,aAAa,IAAIC,cAAc,IAAI9H,MAAM,CAACgF,YAAP,GAAsBhF,MAAM,CAACgF,YAA7B,GAA4C,CAAhD,CAA/B;EACD,KAFD;EAGA6C,IAAAA,aAAa,IAAI7H,MAAM,CAACgF,YAAxB;EACA,QAAM+C,OAAO,GAAGF,aAAa,GAAGrE,UAAhC;EACAW,IAAAA,QAAQ,GAAGA,QAAQ,CAAChT,GAAT,CAAa,UAAC6W,IAAD,EAAU;EAChC,UAAIA,IAAI,GAAG,CAAX,EAAc,OAAO,CAACtD,YAAR;EACd,UAAIsD,IAAI,GAAGD,OAAX,EAAoB,OAAOA,OAAO,GAAGnD,WAAjB;EACpB,aAAOoD,IAAP;EACD,KAJU,CAAX;EAKD;;EAED,MAAIhI,MAAM,CAACiI,wBAAX,EAAqC;EACnC,QAAIJ,cAAa,GAAG,CAApB;EACAxD,IAAAA,eAAe,CAAClc,OAAhB,CAAwB,UAAC2f,cAAD,EAAoB;EAC1CD,MAAAA,cAAa,IAAIC,cAAc,IAAI9H,MAAM,CAACgF,YAAP,GAAsBhF,MAAM,CAACgF,YAA7B,GAA4C,CAAhD,CAA/B;EACD,KAFD;EAGA6C,IAAAA,cAAa,IAAI7H,MAAM,CAACgF,YAAxB;;EACA,QAAI6C,cAAa,GAAGrE,UAApB,EAAgC;EAC9B,UAAM0E,eAAe,GAAG,CAAC1E,UAAU,GAAGqE,cAAd,IAA+B,CAAvD;EACA1D,MAAAA,QAAQ,CAAChc,OAAT,CAAiB,UAAC6f,IAAD,EAAOG,SAAP,EAAqB;EACpChE,QAAAA,QAAQ,CAACgE,SAAD,CAAR,GAAsBH,IAAI,GAAGE,eAA7B;EACD,OAFD;EAGA9D,MAAAA,UAAU,CAACjc,OAAX,CAAmB,UAAC6f,IAAD,EAAOG,SAAP,EAAqB;EACtC/D,QAAAA,UAAU,CAAC+D,SAAD,CAAV,GAAwBH,IAAI,GAAGE,eAA/B;EACD,OAFD;EAGD;EACF;;EAEDngB,EAAAA,QAAM,CAAC8W,MAAD,EAAS;EACbmF,IAAAA,MAAM,EAANA,MADa;EAEbG,IAAAA,QAAQ,EAARA,QAFa;EAGbC,IAAAA,UAAU,EAAVA,UAHa;EAIbC,IAAAA,eAAe,EAAfA;EAJa,GAAT,CAAN;;EAOA,MAAIH,YAAY,KAAKH,oBAArB,EAA2C;EACzClF,IAAAA,MAAM,CAACgB,IAAP,CAAY,oBAAZ;EACD;;EACD,MAAIsE,QAAQ,CAAC9b,MAAT,KAAoByc,sBAAxB,EAAgD;EAC9C,QAAIjG,MAAM,CAACmB,MAAP,CAAcoI,aAAlB,EAAiCvJ,MAAM,CAACwJ,aAAP;EACjCxJ,IAAAA,MAAM,CAACgB,IAAP,CAAY,sBAAZ;EACD;;EACD,MAAIuE,UAAU,CAAC/b,MAAX,KAAsB0c,wBAA1B,EAAoD;EAClDlG,IAAAA,MAAM,CAACgB,IAAP,CAAY,wBAAZ;EACD;;EAED,MAAIG,MAAM,CAACsI,mBAAP,IAA8BtI,MAAM,CAACuI,qBAAzC,EAAgE;EAC9D1J,IAAAA,MAAM,CAAC2J,kBAAP;EACD;EACF;;EClVc,SAASC,gBAAT,CAA0BC,KAA1B,EAAiC;EAC9C,MAAM7J,MAAM,GAAG,IAAf;EACA,MAAM8J,YAAY,GAAG,EAArB;EACA,MAAIvJ,SAAS,GAAG,CAAhB;EACA,MAAIjP,CAAJ;;EACA,MAAI,OAAOuY,KAAP,KAAiB,QAArB,EAA+B;EAC7B7J,IAAAA,MAAM,CAAC+J,aAAP,CAAqBF,KAArB;EACD,GAFD,MAEO,IAAIA,KAAK,KAAK,IAAd,EAAoB;EACzB7J,IAAAA,MAAM,CAAC+J,aAAP,CAAqB/J,MAAM,CAACmB,MAAP,CAAc0I,KAAnC;EACD,GAT6C;;;EAW9C,MAAI7J,MAAM,CAACmB,MAAP,CAAc6F,aAAd,KAAgC,MAAhC,IAA0ChH,MAAM,CAACmB,MAAP,CAAc6F,aAAd,GAA8B,CAA5E,EAA+E;EAC7E,QAAIhH,MAAM,CAACmB,MAAP,CAAcqH,cAAlB,EAAkC;EAChCxI,MAAAA,MAAM,CAACgK,aAAP,CAAqB1R,IAArB,CAA0B,UAACgP,KAAD,EAAW;EACnCwC,QAAAA,YAAY,CAACpb,IAAb,CAAkB4Y,KAAlB;EACD,OAFD;EAGD,KAJD,MAIO;EACL,WAAKhW,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAGuV,IAAI,CAACE,IAAL,CAAU/G,MAAM,CAACmB,MAAP,CAAc6F,aAAxB,CAAhB,EAAwD1V,CAAC,IAAI,CAA7D,EAAgE;EAC9D,YAAMiH,KAAK,GAAGyH,MAAM,CAACiK,WAAP,GAAqB3Y,CAAnC;EACA,YAAIiH,KAAK,GAAGyH,MAAM,CAACmF,MAAP,CAAc3b,MAA1B,EAAkC;EAClCsgB,QAAAA,YAAY,CAACpb,IAAb,CAAkBsR,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiBV,KAAjB,EAAwB,CAAxB,CAAlB;EACD;EACF;EACF,GAZD,MAYO;EACLuR,IAAAA,YAAY,CAACpb,IAAb,CAAkBsR,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,EAAqC,CAArC,CAAlB;EACD,GAzB6C;;;EA4B9C,OAAK3Y,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAGwY,YAAY,CAACtgB,MAA7B,EAAqC8H,CAAC,IAAI,CAA1C,EAA6C;EAC3C,QAAI,OAAOwY,YAAY,CAACxY,CAAD,CAAnB,KAA2B,WAA/B,EAA4C;EAC1C,UAAMoN,MAAM,GAAGoL,YAAY,CAACxY,CAAD,CAAZ,CAAgBiG,YAA/B;EACAgJ,MAAAA,SAAS,GAAG7B,MAAM,GAAG6B,SAAT,GAAqB7B,MAArB,GAA8B6B,SAA1C;EACD;EACF,GAjC6C;;;EAoC9C,MAAIA,SAAJ,EAAeP,MAAM,CAACsC,UAAP,CAAkBnK,GAAlB,CAAsB,QAAtB,EAAmCoI,SAAnC;EAChB;;ECrCc,SAASoJ,kBAAT,GAA8B;EAC3C,MAAM3J,MAAM,GAAG,IAAf;EACA,MAAMmF,MAAM,GAAGnF,MAAM,CAACmF,MAAtB;;EACA,OAAK,IAAI7T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC6T,IAAAA,MAAM,CAAC7T,CAAD,CAAN,CAAU4Y,iBAAV,GAA8BlK,MAAM,CAAC+D,YAAP,KAC1BoB,MAAM,CAAC7T,CAAD,CAAN,CAAU6Y,UADgB,GAE1BhF,MAAM,CAAC7T,CAAD,CAAN,CAAU8Y,SAFd;EAGD;EACF;;ECNc,SAASC,oBAAT,CAA8BC,SAA9B,EAAyE;EAAA,MAA3CA,SAA2C;EAA3CA,IAAAA,SAA2C,GAA9B,QAAQ,KAAKA,SAAd,IAA4B,CAAG;EAAA;;EACtF,MAAMtK,MAAM,GAAG,IAAf;EACA,MAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAtB;EAFsF,MAI9EgE,MAJ8E,GAIhDnF,MAJgD,CAI9EmF,MAJ8E;EAAA,MAIxDP,GAJwD,GAIhD5E,MAJgD,CAItE6E,YAJsE;EAMtF,MAAIM,MAAM,CAAC3b,MAAP,KAAkB,CAAtB,EAAyB;EACzB,MAAI,OAAO2b,MAAM,CAAC,CAAD,CAAN,CAAU+E,iBAAjB,KAAuC,WAA3C,EAAwDlK,MAAM,CAAC2J,kBAAP;EAExD,MAAIY,YAAY,GAAG,CAACD,SAApB;EACA,MAAI1F,GAAJ,EAAS2F,YAAY,GAAGD,SAAf,CAV6E;;EAatFnF,EAAAA,MAAM,CAACvS,WAAP,CAAmBuO,MAAM,CAACqJ,iBAA1B;EAEAxK,EAAAA,MAAM,CAACyK,oBAAP,GAA8B,EAA9B;EACAzK,EAAAA,MAAM,CAACgK,aAAP,GAAuB,EAAvB;;EAEA,OAAK,IAAI1Y,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,QAAMgW,KAAK,GAAGnC,MAAM,CAAC7T,CAAD,CAApB;EACA,QAAMoZ,aAAa,GACjB,CAACH,YAAY,IACVpJ,MAAM,CAACqH,cAAP,GAAwBxI,MAAM,CAAC2K,YAAP,EAAxB,GAAgD,CADtC,CAAZ,GAECrD,KAAK,CAAC4C,iBAFR,KAGC5C,KAAK,CAACiB,eAAN,GAAwBpH,MAAM,CAACgF,YAHhC,CADF;;EAKA,QAAIhF,MAAM,CAACuI,qBAAP,IAAiCvI,MAAM,CAACqH,cAAP,IAAyBrH,MAAM,CAACyJ,UAArE,EAAkF;EAChF,UAAMC,WAAW,GAAG,EAAEN,YAAY,GAAGjD,KAAK,CAAC4C,iBAAvB,CAApB;EACA,UAAMY,UAAU,GAAGD,WAAW,GAAG7K,MAAM,CAACwF,eAAP,CAAuBlU,CAAvB,CAAjC;EACA,UAAMyZ,SAAS,GACZF,WAAW,IAAI,CAAf,IAAoBA,WAAW,GAAG7K,MAAM,CAACoE,IAAP,GAAc,CAAjD,IACC0G,UAAU,GAAG,CAAb,IAAkBA,UAAU,IAAI9K,MAAM,CAACoE,IADxC,IAECyG,WAAW,IAAI,CAAf,IAAoBC,UAAU,IAAI9K,MAAM,CAACoE,IAH5C;;EAIA,UAAI2G,SAAJ,EAAe;EACb/K,QAAAA,MAAM,CAACgK,aAAP,CAAqBtb,IAArB,CAA0B4Y,KAA1B;EACAtH,QAAAA,MAAM,CAACyK,oBAAP,CAA4B/b,IAA5B,CAAiC4C,CAAjC;EACA6T,QAAAA,MAAM,CAAClM,EAAP,CAAU3H,CAAV,EAAaW,QAAb,CAAsBkP,MAAM,CAACqJ,iBAA7B;EACD;EACF;;EACDlD,IAAAA,KAAK,CAAC0D,QAAN,GAAiBpG,GAAG,GAAG,CAAC8F,aAAJ,GAAoBA,aAAxC;EACD;;EACD1K,EAAAA,MAAM,CAACgK,aAAP,GAAuBtY,CAAC,CAACsO,MAAM,CAACgK,aAAR,CAAxB;EACD;;ECzCc,SAASiB,cAAT,CAAwBX,SAAxB,EAAmC;EAChD,MAAMtK,MAAM,GAAG,IAAf;;EACA,MAAI,OAAOsK,SAAP,KAAqB,WAAzB,EAAsC;EACpC,QAAMY,UAAU,GAAGlL,MAAM,CAAC6E,YAAP,GAAsB,CAAC,CAAvB,GAA2B,CAA9C,CADoC;;EAGpCyF,IAAAA,SAAS,GAAItK,MAAM,IAAIA,MAAM,CAACsK,SAAjB,IAA8BtK,MAAM,CAACsK,SAAP,GAAmBY,UAAlD,IAAiE,CAA7E;EACD;;EACD,MAAM/J,MAAM,GAAGnB,MAAM,CAACmB,MAAtB;EACA,MAAMgK,cAAc,GAAGnL,MAAM,CAACoL,YAAP,KAAwBpL,MAAM,CAAC2K,YAAP,EAA/C;EARgD,MAS1CK,QAT0C,GASThL,MATS,CAS1CgL,QAT0C;EAAA,MAShCK,WATgC,GASTrL,MATS,CAShCqL,WATgC;EAAA,MASnBC,KATmB,GASTtL,MATS,CASnBsL,KATmB;EAUhD,MAAMC,YAAY,GAAGF,WAArB;EACA,MAAMG,MAAM,GAAGF,KAAf;;EACA,MAAIH,cAAc,KAAK,CAAvB,EAA0B;EACxBH,IAAAA,QAAQ,GAAG,CAAX;EACAK,IAAAA,WAAW,GAAG,IAAd;EACAC,IAAAA,KAAK,GAAG,IAAR;EACD,GAJD,MAIO;EACLN,IAAAA,QAAQ,GAAG,CAACV,SAAS,GAAGtK,MAAM,CAAC2K,YAAP,EAAb,IAAsCQ,cAAjD;EACAE,IAAAA,WAAW,GAAGL,QAAQ,IAAI,CAA1B;EACAM,IAAAA,KAAK,GAAGN,QAAQ,IAAI,CAApB;EACD;;EACD9hB,EAAAA,QAAM,CAAC8W,MAAD,EAAS;EACbgL,IAAAA,QAAQ,EAARA,QADa;EAEbK,IAAAA,WAAW,EAAXA,WAFa;EAGbC,IAAAA,KAAK,EAALA;EAHa,GAAT,CAAN;EAMA,MACEnK,MAAM,CAACsI,mBAAP,IACAtI,MAAM,CAACuI,qBADP,IAECvI,MAAM,CAACqH,cAAP,IAAyBrH,MAAM,CAACyJ,UAHnC,EAKE5K,MAAM,CAACqK,oBAAP,CAA4BC,SAA5B;;EAEF,MAAIe,WAAW,IAAI,CAACE,YAApB,EAAkC;EAChCvL,IAAAA,MAAM,CAACgB,IAAP,CAAY,uBAAZ;EACD;;EACD,MAAIsK,KAAK,IAAI,CAACE,MAAd,EAAsB;EACpBxL,IAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ;EACD;;EACD,MAAKuK,YAAY,IAAI,CAACF,WAAlB,IAAmCG,MAAM,IAAI,CAACF,KAAlD,EAA0D;EACxDtL,IAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ;EACD;;EAEDhB,EAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ,EAAwBgK,QAAxB;EACD;;EC/Cc,SAASS,mBAAT,GAA+B;EAC5C,MAAMzL,MAAM,GAAG,IAAf;EAD4C,MAGpCmF,MAHoC,GAGmBnF,MAHnB,CAGpCmF,MAHoC;EAAA,MAG5BhE,MAH4B,GAGmBnB,MAHnB,CAG5BmB,MAH4B;EAAA,MAGpBmB,UAHoB,GAGmBtC,MAHnB,CAGpBsC,UAHoB;EAAA,MAGR2H,WAHQ,GAGmBjK,MAHnB,CAGRiK,WAHQ;EAAA,MAGKyB,SAHL,GAGmB1L,MAHnB,CAGK0L,SAHL;EAI5C,MAAM3G,SAAS,GAAG/E,MAAM,CAACgF,OAAP,IAAkB7D,MAAM,CAAC6D,OAAP,CAAeC,OAAnD;EAEAE,EAAAA,MAAM,CAACvS,WAAP,CACKuO,MAAM,CAACwK,gBADZ,SACgCxK,MAAM,CAACyK,cADvC,SACyDzK,MAAM,CAAC0K,cADhE,SACkF1K,MAAM,CAAC2K,yBADzF,SACsH3K,MAAM,CAAC4K,uBAD7H,SACwJ5K,MAAM,CAAC6K,uBAD/J;EAIA,MAAIC,WAAJ;;EACA,MAAIlH,SAAJ,EAAe;EACbkH,IAAAA,WAAW,GAAGjM,MAAM,CAACsC,UAAP,CAAkB9H,IAAlB,OACR2G,MAAM,CAACiE,UADC,mCACsC6E,WADtC,SAAd;EAGD,GAJD,MAIO;EACLgC,IAAAA,WAAW,GAAG9G,MAAM,CAAClM,EAAP,CAAUgR,WAAV,CAAd;EACD,GAjB2C;;;EAoB5CgC,EAAAA,WAAW,CAACha,QAAZ,CAAqBkP,MAAM,CAACwK,gBAA5B;;EAEA,MAAIxK,MAAM,CAAC+K,IAAX,EAAiB;EACf;EACA,QAAID,WAAW,CAAC3Y,QAAZ,CAAqB6N,MAAM,CAACgL,mBAA5B,CAAJ,EAAsD;EACpD7J,MAAAA,UAAU,CACPhY,QADH,OAEQ6W,MAAM,CAACiE,UAFf,cAEkCjE,MAAM,CAACgL,mBAFzC,oCAE0FT,SAF1F,UAIGzZ,QAJH,CAIYkP,MAAM,CAAC2K,yBAJnB;EAKD,KAND,MAMO;EACLxJ,MAAAA,UAAU,CACPhY,QADH,OAEQ6W,MAAM,CAACiE,UAFf,SAE6BjE,MAAM,CAACgL,mBAFpC,mCAEoFT,SAFpF,UAIGzZ,QAJH,CAIYkP,MAAM,CAAC2K,yBAJnB;EAKD;EACF,GArC2C;;;EAuC5C,MAAIM,SAAS,GAAGH,WAAW,CACxBrS,OADa,OACDuH,MAAM,CAACiE,UADN,EAEbnM,EAFa,CAEV,CAFU,EAGbhH,QAHa,CAGJkP,MAAM,CAACyK,cAHH,CAAhB;;EAIA,MAAIzK,MAAM,CAAC+K,IAAP,IAAeE,SAAS,CAAC5iB,MAAV,KAAqB,CAAxC,EAA2C;EACzC4iB,IAAAA,SAAS,GAAGjH,MAAM,CAAClM,EAAP,CAAU,CAAV,CAAZ;EACAmT,IAAAA,SAAS,CAACna,QAAV,CAAmBkP,MAAM,CAACyK,cAA1B;EACD,GA9C2C;;;EAgD5C,MAAIS,SAAS,GAAGJ,WAAW,CACxBhS,OADa,OACDkH,MAAM,CAACiE,UADN,EAEbnM,EAFa,CAEV,CAFU,EAGbhH,QAHa,CAGJkP,MAAM,CAAC0K,cAHH,CAAhB;;EAIA,MAAI1K,MAAM,CAAC+K,IAAP,IAAeG,SAAS,CAAC7iB,MAAV,KAAqB,CAAxC,EAA2C;EACzC6iB,IAAAA,SAAS,GAAGlH,MAAM,CAAClM,EAAP,CAAU,CAAC,CAAX,CAAZ;EACAoT,IAAAA,SAAS,CAACpa,QAAV,CAAmBkP,MAAM,CAAC0K,cAA1B;EACD;;EACD,MAAI1K,MAAM,CAAC+K,IAAX,EAAiB;EACf;EACA,QAAIE,SAAS,CAAC9Y,QAAV,CAAmB6N,MAAM,CAACgL,mBAA1B,CAAJ,EAAoD;EAClD7J,MAAAA,UAAU,CACPhY,QADH,OAEQ6W,MAAM,CAACiE,UAFf,cAGMjE,MAAM,CAACgL,mBAHb,oCAIkCC,SAAS,CAAC1Y,IAAV,CAAe,yBAAf,CAJlC,UAMGzB,QANH,CAMYkP,MAAM,CAAC4K,uBANnB;EAOD,KARD,MAQO;EACLzJ,MAAAA,UAAU,CACPhY,QADH,OAEQ6W,MAAM,CAACiE,UAFf,SAGMjE,MAAM,CAACgL,mBAHb,mCAIiCC,SAAS,CAAC1Y,IAAV,CAAe,yBAAf,CAJjC,UAMGzB,QANH,CAMYkP,MAAM,CAAC4K,uBANnB;EAOD;;EACD,QAAIM,SAAS,CAAC/Y,QAAV,CAAmB6N,MAAM,CAACgL,mBAA1B,CAAJ,EAAoD;EAClD7J,MAAAA,UAAU,CACPhY,QADH,OAEQ6W,MAAM,CAACiE,UAFf,cAGMjE,MAAM,CAACgL,mBAHb,oCAIkCE,SAAS,CAAC3Y,IAAV,CAAe,yBAAf,CAJlC,UAMGzB,QANH,CAMYkP,MAAM,CAAC6K,uBANnB;EAOD,KARD,MAQO;EACL1J,MAAAA,UAAU,CACPhY,QADH,OAEQ6W,MAAM,CAACiE,UAFf,SAGMjE,MAAM,CAACgL,mBAHb,mCAIiCE,SAAS,CAAC3Y,IAAV,CAAe,yBAAf,CAJjC,UAMGzB,QANH,CAMYkP,MAAM,CAAC6K,uBANnB;EAOD;EACF;;EACDhM,EAAAA,MAAM,CAACsM,iBAAP;EACD;;EC5Fc,SAASC,iBAAT,CAA2BC,cAA3B,EAA2C;EACxD,MAAMxM,MAAM,GAAG,IAAf;EACA,MAAMsK,SAAS,GAAGtK,MAAM,CAAC6E,YAAP,GAAsB7E,MAAM,CAACsK,SAA7B,GAAyC,CAACtK,MAAM,CAACsK,SAAnE;EAFwD,MAItD/E,UAJsD,GAUpDvF,MAVoD,CAItDuF,UAJsD;EAAA,MAKtDD,QALsD,GAUpDtF,MAVoD,CAKtDsF,QALsD;EAAA,MAMtDnE,MANsD,GAUpDnB,MAVoD,CAMtDmB,MANsD;EAAA,MAOzCsL,aAPyC,GAUpDzM,MAVoD,CAOtDiK,WAPsD;EAAA,MAQ3CyC,iBAR2C,GAUpD1M,MAVoD,CAQtD0L,SARsD;EAAA,MAS3CiB,iBAT2C,GAUpD3M,MAVoD,CAStDsJ,SATsD;EAWxD,MAAIW,WAAW,GAAGuC,cAAlB;EACA,MAAIlD,SAAJ;;EACA,MAAI,OAAOW,WAAP,KAAuB,WAA3B,EAAwC;EACtC,SAAK,IAAI3Y,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGiU,UAAU,CAAC/b,MAA/B,EAAuC8H,CAAC,IAAI,CAA5C,EAA+C;EAC7C,UAAI,OAAOiU,UAAU,CAACjU,CAAC,GAAG,CAAL,CAAjB,KAA6B,WAAjC,EAA8C;EAC5C,YACEgZ,SAAS,IAAI/E,UAAU,CAACjU,CAAD,CAAvB,IACAgZ,SAAS,GAAG/E,UAAU,CAACjU,CAAC,GAAG,CAAL,CAAV,GAAoB,CAACiU,UAAU,CAACjU,CAAC,GAAG,CAAL,CAAV,GAAoBiU,UAAU,CAACjU,CAAD,CAA/B,IAAsC,CAFxE,EAGE;EACA2Y,UAAAA,WAAW,GAAG3Y,CAAd;EACD,SALD,MAKO,IAAIgZ,SAAS,IAAI/E,UAAU,CAACjU,CAAD,CAAvB,IAA8BgZ,SAAS,GAAG/E,UAAU,CAACjU,CAAC,GAAG,CAAL,CAAxD,EAAiE;EACtE2Y,UAAAA,WAAW,GAAG3Y,CAAC,GAAG,CAAlB;EACD;EACF,OATD,MASO,IAAIgZ,SAAS,IAAI/E,UAAU,CAACjU,CAAD,CAA3B,EAAgC;EACrC2Y,QAAAA,WAAW,GAAG3Y,CAAd;EACD;EACF,KAdqC;;;EAgBtC,QAAI6P,MAAM,CAACyL,mBAAX,EAAgC;EAC9B,UAAI3C,WAAW,GAAG,CAAd,IAAmB,OAAOA,WAAP,KAAuB,WAA9C,EAA2DA,WAAW,GAAG,CAAd;EAC5D;EACF;;EACD,MAAI3E,QAAQ,CAACnW,OAAT,CAAiBmb,SAAjB,KAA+B,CAAnC,EAAsC;EACpChB,IAAAA,SAAS,GAAGhE,QAAQ,CAACnW,OAAT,CAAiBmb,SAAjB,CAAZ;EACD,GAFD,MAEO;EACL,QAAMuC,IAAI,GAAGhG,IAAI,CAACiB,GAAL,CAAS3G,MAAM,CAACuH,kBAAhB,EAAoCuB,WAApC,CAAb;EACAX,IAAAA,SAAS,GAAGuD,IAAI,GAAGhG,IAAI,CAACC,KAAL,CAAW,CAACmD,WAAW,GAAG4C,IAAf,IAAuB1L,MAAM,CAACuG,cAAzC,CAAnB;EACD;;EACD,MAAI4B,SAAS,IAAIhE,QAAQ,CAAC9b,MAA1B,EAAkC8f,SAAS,GAAGhE,QAAQ,CAAC9b,MAAT,GAAkB,CAA9B;;EAClC,MAAIygB,WAAW,KAAKwC,aAApB,EAAmC;EACjC,QAAInD,SAAS,KAAKqD,iBAAlB,EAAqC;EACnC3M,MAAAA,MAAM,CAACsJ,SAAP,GAAmBA,SAAnB;EACAtJ,MAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ;EACD;;EACD;EACD,GA9CuD;;;EAiDxD,MAAM0K,SAAS,GAAGzH,QAAQ,CACxBjE,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiBgR,WAAjB,EAA8BvW,IAA9B,CAAmC,yBAAnC,KAAiEuW,WADzC,EAExB,EAFwB,CAA1B;EAKA/gB,EAAAA,QAAM,CAAC8W,MAAD,EAAS;EACbsJ,IAAAA,SAAS,EAATA,SADa;EAEboC,IAAAA,SAAS,EAATA,SAFa;EAGbe,IAAAA,aAAa,EAAbA,aAHa;EAIbxC,IAAAA,WAAW,EAAXA;EAJa,GAAT,CAAN;EAMAjK,EAAAA,MAAM,CAACgB,IAAP,CAAY,mBAAZ;EACAhB,EAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ;;EACA,MAAI0L,iBAAiB,KAAKhB,SAA1B,EAAqC;EACnC1L,IAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ;EACD;;EACD,MAAIhB,MAAM,CAACI,WAAP,IAAsBJ,MAAM,CAACmB,MAAP,CAAc2L,kBAAxC,EAA4D;EAC1D9M,IAAAA,MAAM,CAACgB,IAAP,CAAY,aAAZ;EACD;EACF;;ECpEc,SAAS+L,kBAAT,CAA4B3e,CAA5B,EAA+B;EAC5C,MAAM4R,MAAM,GAAG,IAAf;EACA,MAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAtB;EACA,MAAMmG,KAAK,GAAG5V,CAAC,CAACtD,CAAC,CAACjF,MAAH,CAAD,CAAYoR,OAAZ,OAAwB4G,MAAM,CAACiE,UAA/B,EAA6C,CAA7C,CAAd;EACA,MAAI4H,UAAU,GAAG,KAAjB;EACA,MAAIrH,UAAJ;;EAEA,MAAI2B,KAAJ,EAAW;EACT,SAAK,IAAIhW,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG0O,MAAM,CAACmF,MAAP,CAAc3b,MAAlC,EAA0C8H,CAAC,IAAI,CAA/C,EAAkD;EAChD,UAAI0O,MAAM,CAACmF,MAAP,CAAc7T,CAAd,MAAqBgW,KAAzB,EAAgC;EAC9B0F,QAAAA,UAAU,GAAG,IAAb;EACArH,QAAAA,UAAU,GAAGrU,CAAb;EACA;EACD;EACF;EACF;;EAED,MAAIgW,KAAK,IAAI0F,UAAb,EAAyB;EACvBhN,IAAAA,MAAM,CAACiN,YAAP,GAAsB3F,KAAtB;;EACA,QAAItH,MAAM,CAACgF,OAAP,IAAkBhF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAA5C,EAAqD;EACnDjF,MAAAA,MAAM,CAACkN,YAAP,GAAsBjJ,QAAQ,CAACvS,CAAC,CAAC4V,KAAD,CAAD,CAAS5T,IAAT,CAAc,yBAAd,CAAD,EAA2C,EAA3C,CAA9B;EACD,KAFD,MAEO;EACLsM,MAAAA,MAAM,CAACkN,YAAP,GAAsBvH,UAAtB;EACD;EACF,GAPD,MAOO;EACL3F,IAAAA,MAAM,CAACiN,YAAP,GAAsB1d,SAAtB;EACAyQ,IAAAA,MAAM,CAACkN,YAAP,GAAsB3d,SAAtB;EACA;EACD;;EACD,MACE4R,MAAM,CAACgM,mBAAP,IACAnN,MAAM,CAACkN,YAAP,KAAwB3d,SADxB,IAEAyQ,MAAM,CAACkN,YAAP,KAAwBlN,MAAM,CAACiK,WAHjC,EAIE;EACAjK,IAAAA,MAAM,CAACmN,mBAAP;EACD;EACF;;AC5BD,eAAe;EACbvJ,EAAAA,UAAU,EAAVA,UADa;EAEbS,EAAAA,YAAY,EAAZA,YAFa;EAGbuF,EAAAA,gBAAgB,EAAhBA,gBAHa;EAIbD,EAAAA,kBAAkB,EAAlBA,kBAJa;EAKbU,EAAAA,oBAAoB,EAApBA,oBALa;EAMbY,EAAAA,cAAc,EAAdA,cANa;EAObQ,EAAAA,mBAAmB,EAAnBA,mBAPa;EAQbc,EAAAA,iBAAiB,EAAjBA,iBARa;EASbQ,EAAAA,kBAAkB,EAAlBA;EATa,CAAf;;ECRe,SAASK,kBAAT,CAA4B/R,IAA5B,EAAoE;EAAA,MAAxCA,IAAwC;EAAxCA,IAAAA,IAAwC,GAAjC,KAAK0I,YAAL,KAAsB,GAAtB,GAA4B,GAAK;EAAA;;EACjF,MAAM/D,MAAM,GAAG,IAAf;EADiF,MAGzEmB,MAHyE,GAGpBnB,MAHoB,CAGzEmB,MAHyE;EAAA,MAGnDyD,GAHmD,GAGpB5E,MAHoB,CAGjE6E,YAHiE;EAAA,MAG9CyF,SAH8C,GAGpBtK,MAHoB,CAG9CsK,SAH8C;EAAA,MAGnChI,UAHmC,GAGpBtC,MAHoB,CAGnCsC,UAHmC;;EAKjF,MAAInB,MAAM,CAACkM,gBAAX,EAA6B;EAC3B,WAAOzI,GAAG,GAAG,CAAC0F,SAAJ,GAAgBA,SAA1B;EACD;;EACD,MAAInJ,MAAM,CAACyE,OAAX,EAAoB;EAClB,WAAO0E,SAAP;EACD;;EAED,MAAIgD,gBAAgB,GAAGlS,YAAY,CAACkH,UAAU,CAAC,CAAD,CAAX,EAAgBjH,IAAhB,CAAnC;EACA,MAAIuJ,GAAJ,EAAS0I,gBAAgB,GAAG,CAACA,gBAApB;EAET,SAAOA,gBAAgB,IAAI,CAA3B;EACD;;EClBc,SAASC,YAAT,CAAsBjD,SAAtB,EAAiCkD,YAAjC,EAA+C;EAC5D,MAAMxN,MAAM,GAAG,IAAf;EAD4D,MAEtC4E,GAFsC,GAEW5E,MAFX,CAEpD6E,YAFoD;EAAA,MAEjC1D,MAFiC,GAEWnB,MAFX,CAEjCmB,MAFiC;EAAA,MAEzBmB,UAFyB,GAEWtC,MAFX,CAEzBsC,UAFyB;EAAA,MAEbmL,SAFa,GAEWzN,MAFX,CAEbyN,SAFa;EAAA,MAEFzC,QAFE,GAEWhL,MAFX,CAEFgL,QAFE;EAG5D,MAAI0C,CAAC,GAAG,CAAR;EACA,MAAIC,CAAC,GAAG,CAAR;EACA,MAAMC,CAAC,GAAG,CAAV;;EAEA,MAAI5N,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB2J,IAAAA,CAAC,GAAG9I,GAAG,GAAG,CAAC0F,SAAJ,GAAgBA,SAAvB;EACD,GAFD,MAEO;EACLqD,IAAAA,CAAC,GAAGrD,SAAJ;EACD;;EAED,MAAInJ,MAAM,CAACgH,YAAX,EAAyB;EACvBuF,IAAAA,CAAC,GAAG7G,IAAI,CAACC,KAAL,CAAW4G,CAAX,CAAJ;EACAC,IAAAA,CAAC,GAAG9G,IAAI,CAACC,KAAL,CAAW6G,CAAX,CAAJ;EACD;;EAED,MAAIxM,MAAM,CAACyE,OAAX,EAAoB;EAClB6H,IAAAA,SAAS,CAACzN,MAAM,CAAC+D,YAAP,KAAwB,YAAxB,GAAuC,WAAxC,CAAT,GAAgE/D,MAAM,CAAC+D,YAAP,KAAwB,CAAC2J,CAAzB,GAA6B,CAACC,CAA9F;EACD,GAFD,MAEO,IAAI,CAACxM,MAAM,CAACkM,gBAAZ,EAA8B;EACnC/K,IAAAA,UAAU,CAACtO,SAAX,kBAAoC0Z,CAApC,YAA4CC,CAA5C,YAAoDC,CAApD;EACD;;EACD5N,EAAAA,MAAM,CAAC6N,iBAAP,GAA2B7N,MAAM,CAACsK,SAAlC;EACAtK,EAAAA,MAAM,CAACsK,SAAP,GAAmBtK,MAAM,CAAC+D,YAAP,KAAwB2J,CAAxB,GAA4BC,CAA/C,CAxB4D;;EA2B5D,MAAIG,WAAJ;EACA,MAAM3C,cAAc,GAAGnL,MAAM,CAACoL,YAAP,KAAwBpL,MAAM,CAAC2K,YAAP,EAA/C;;EACA,MAAIQ,cAAc,KAAK,CAAvB,EAA0B;EACxB2C,IAAAA,WAAW,GAAG,CAAd;EACD,GAFD,MAEO;EACLA,IAAAA,WAAW,GAAG,CAACxD,SAAS,GAAGtK,MAAM,CAAC2K,YAAP,EAAb,IAAsCQ,cAApD;EACD;;EACD,MAAI2C,WAAW,KAAK9C,QAApB,EAA8B;EAC5BhL,IAAAA,MAAM,CAACiL,cAAP,CAAsBX,SAAtB;EACD;;EAEDtK,EAAAA,MAAM,CAACgB,IAAP,CAAY,cAAZ,EAA4BhB,MAAM,CAACsK,SAAnC,EAA8CkD,YAA9C;EACD;;ECvCc,SAAS7C,YAAT,GAAwB;EACrC,SAAO,CAAC,KAAKrF,QAAL,CAAc,CAAd,CAAR;EACD;;ECFc,SAAS8F,YAAT,GAAwB;EACrC,SAAO,CAAC,KAAK9F,QAAL,CAAc,KAAKA,QAAL,CAAc9b,MAAd,GAAuB,CAArC,CAAR;EACD;;ECFc,SAASukB,WAAT,CACbzD,SADa,EAEbT,KAFa,EAGbmE,YAHa,EAIbC,eAJa,EAKbC,QALa,EAMb;EAAA,MALA5D,SAKA;EALAA,IAAAA,SAKA,GALY,CAKZ;EAAA;;EAAA,MAJAT,KAIA;EAJAA,IAAAA,KAIA,GAJQ,KAAK1I,MAAL,CAAY0I,KAIpB;EAAA;;EAAA,MAHAmE,YAGA;EAHAA,IAAAA,YAGA,GAHe,IAGf;EAAA;;EAAA,MAFAC,eAEA;EAFAA,IAAAA,eAEA,GAFkB,IAElB;EAAA;;EACA,MAAMjO,MAAM,GAAG,IAAf;EADA,MAGQmB,MAHR,GAG8BnB,MAH9B,CAGQmB,MAHR;EAAA,MAGgBsM,SAHhB,GAG8BzN,MAH9B,CAGgByN,SAHhB;;EAKA,MAAIzN,MAAM,CAACmO,SAAP,IAAoBhN,MAAM,CAACiN,8BAA/B,EAA+D;EAC7D,WAAO,KAAP;EACD;;EAED,MAAMzD,YAAY,GAAG3K,MAAM,CAAC2K,YAAP,EAArB;EACA,MAAMS,YAAY,GAAGpL,MAAM,CAACoL,YAAP,EAArB;EACA,MAAIiD,YAAJ;EACA,MAAIJ,eAAe,IAAI3D,SAAS,GAAGK,YAAnC,EAAiD0D,YAAY,GAAG1D,YAAf,CAAjD,KACK,IAAIsD,eAAe,IAAI3D,SAAS,GAAGc,YAAnC,EAAiDiD,YAAY,GAAGjD,YAAf,CAAjD,KACAiD,YAAY,GAAG/D,SAAf,CAdL;;EAiBAtK,EAAAA,MAAM,CAACiL,cAAP,CAAsBoD,YAAtB;;EAEA,MAAIlN,MAAM,CAACyE,OAAX,EAAoB;EAClB,QAAM0I,GAAG,GAAGtO,MAAM,CAAC+D,YAAP,EAAZ;;EACA,QAAI8F,KAAK,KAAK,CAAd,EAAiB;EACf4D,MAAAA,SAAS,CAACa,GAAG,GAAG,YAAH,GAAkB,WAAtB,CAAT,GAA8C,CAACD,YAA/C;EACD,KAFD,MAEO;EACL;EACA,UAAIZ,SAAS,CAACc,QAAd,EAAwB;EAAA;;EACtBd,QAAAA,SAAS,CAACc,QAAV,gDACGD,GAAG,GAAG,MAAH,GAAY,KADlB,IAC0B,CAACD,YAD3B,sBAEEG,QAFF,GAEY,QAFZ;EAID,OALD,MAKO;EACLf,QAAAA,SAAS,CAACa,GAAG,GAAG,YAAH,GAAkB,WAAtB,CAAT,GAA8C,CAACD,YAA/C;EACD;EACF;;EACD,WAAO,IAAP;EACD;;EAED,MAAIxE,KAAK,KAAK,CAAd,EAAiB;EACf7J,IAAAA,MAAM,CAAC+J,aAAP,CAAqB,CAArB;EACA/J,IAAAA,MAAM,CAACuN,YAAP,CAAoBc,YAApB;;EACA,QAAIL,YAAJ,EAAkB;EAChBhO,MAAAA,MAAM,CAACgB,IAAP,CAAY,uBAAZ,EAAqC6I,KAArC,EAA4CqE,QAA5C;EACAlO,MAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ;EACD;EACF,GAPD,MAOO;EACLhB,IAAAA,MAAM,CAAC+J,aAAP,CAAqBF,KAArB;EACA7J,IAAAA,MAAM,CAACuN,YAAP,CAAoBc,YAApB;;EACA,QAAIL,YAAJ,EAAkB;EAChBhO,MAAAA,MAAM,CAACgB,IAAP,CAAY,uBAAZ,EAAqC6I,KAArC,EAA4CqE,QAA5C;EACAlO,MAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ;EACD;;EACD,QAAI,CAAChB,MAAM,CAACmO,SAAZ,EAAuB;EACrBnO,MAAAA,MAAM,CAACmO,SAAP,GAAmB,IAAnB;;EACA,UAAI,CAACnO,MAAM,CAACyO,iCAAZ,EAA+C;EAC7CzO,QAAAA,MAAM,CAACyO,iCAAP,GAA2C,SAAS7X,aAAT,CAAuBxI,CAAvB,EAA0B;EACnE,cAAI,CAAC4R,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC;EACjC,cAAI/R,CAAC,CAACjF,MAAF,KAAa,IAAjB,EAAuB;EACvB6W,UAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1Y,mBAArB,CACE,eADF,EAEEoW,MAAM,CAACyO,iCAFT;EAIAzO,UAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1Y,mBAArB,CACE,qBADF,EAEEoW,MAAM,CAACyO,iCAFT;EAIAzO,UAAAA,MAAM,CAACyO,iCAAP,GAA2C,IAA3C;EACA,iBAAOzO,MAAM,CAACyO,iCAAd;;EACA,cAAIT,YAAJ,EAAkB;EAChBhO,YAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ;EACD;EACF,SAhBD;EAiBD;;EACDhB,MAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB3Y,gBAArB,CACE,eADF,EAEEqW,MAAM,CAACyO,iCAFT;EAIAzO,MAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB3Y,gBAArB,CACE,qBADF,EAEEqW,MAAM,CAACyO,iCAFT;EAID;EACF;;EAED,SAAO,IAAP;EACD;;ACpFD,kBAAe;EACbrT,EAAAA,YAAY,EAAZA,kBADa;EAEbmS,EAAAA,YAAY,EAAZA,YAFa;EAGb5C,EAAAA,YAAY,EAAZA,YAHa;EAIbS,EAAAA,YAAY,EAAZA,YAJa;EAKb2C,EAAAA,WAAW,EAAXA;EALa,CAAf;;ECNe,SAAShE,aAAT,CAAuB7V,QAAvB,EAAiCsZ,YAAjC,EAA+C;EAC5D,MAAMxN,MAAM,GAAG,IAAf;;EAEA,MAAI,CAACA,MAAM,CAACmB,MAAP,CAAcyE,OAAnB,EAA4B;EAC1B5F,IAAAA,MAAM,CAACsC,UAAP,CAAkBrO,UAAlB,CAA6BC,QAA7B;EACD;;EAED8L,EAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ,EAA6B9M,QAA7B,EAAuCsZ,YAAvC;EACD;;ECRc,SAASkB,eAAT,CAAyBV,YAAzB,EAA8CW,SAA9C,EAAyD;EAAA,MAAhCX,YAAgC;EAAhCA,IAAAA,YAAgC,GAAjB,IAAiB;EAAA;;EACtE,MAAMhO,MAAM,GAAG,IAAf;EADsE,MAE9DiK,WAF8D,GAEvBjK,MAFuB,CAE9DiK,WAF8D;EAAA,MAEjD9I,MAFiD,GAEvBnB,MAFuB,CAEjDmB,MAFiD;EAAA,MAEzCsL,aAFyC,GAEvBzM,MAFuB,CAEzCyM,aAFyC;EAGtE,MAAItL,MAAM,CAACyE,OAAX,EAAoB;;EACpB,MAAIzE,MAAM,CAACyJ,UAAX,EAAuB;EACrB5K,IAAAA,MAAM,CAAC4J,gBAAP;EACD;;EAED,MAAIgF,GAAG,GAAGD,SAAV;;EACA,MAAI,CAACC,GAAL,EAAU;EACR,QAAI3E,WAAW,GAAGwC,aAAlB,EAAiCmC,GAAG,GAAG,MAAN,CAAjC,KACK,IAAI3E,WAAW,GAAGwC,aAAlB,EAAiCmC,GAAG,GAAG,MAAN,CAAjC,KACAA,GAAG,GAAG,OAAN;EACN;;EAED5O,EAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ;;EAEA,MAAIgN,YAAY,IAAI/D,WAAW,KAAKwC,aAApC,EAAmD;EACjD,QAAImC,GAAG,KAAK,OAAZ,EAAqB;EACnB5O,MAAAA,MAAM,CAACgB,IAAP,CAAY,2BAAZ;EACA;EACD;;EACDhB,IAAAA,MAAM,CAACgB,IAAP,CAAY,4BAAZ;;EACA,QAAI4N,GAAG,KAAK,MAAZ,EAAoB;EAClB5O,MAAAA,MAAM,CAACgB,IAAP,CAAY,0BAAZ;EACD,KAFD,MAEO;EACLhB,MAAAA,MAAM,CAACgB,IAAP,CAAY,0BAAZ;EACD;EACF;EACF;;EC7Bc,SAASpK,eAAT,CAAuBoX,YAAvB,EAA4CW,SAA5C,EAAuD;EAAA,MAAhCX,YAAgC;EAAhCA,IAAAA,YAAgC,GAAjB,IAAiB;EAAA;;EACpE,MAAMhO,MAAM,GAAG,IAAf;EADoE,MAE5DiK,WAF4D,GAErBjK,MAFqB,CAE5DiK,WAF4D;EAAA,MAE/CwC,aAF+C,GAErBzM,MAFqB,CAE/CyM,aAF+C;EAAA,MAEhCtL,MAFgC,GAErBnB,MAFqB,CAEhCmB,MAFgC;EAGpEnB,EAAAA,MAAM,CAACmO,SAAP,GAAmB,KAAnB;EACA,MAAIhN,MAAM,CAACyE,OAAX,EAAoB;EACpB5F,EAAAA,MAAM,CAAC+J,aAAP,CAAqB,CAArB;EAEA,MAAI6E,GAAG,GAAGD,SAAV;;EACA,MAAI,CAACC,GAAL,EAAU;EACR,QAAI3E,WAAW,GAAGwC,aAAlB,EAAiCmC,GAAG,GAAG,MAAN,CAAjC,KACK,IAAI3E,WAAW,GAAGwC,aAAlB,EAAiCmC,GAAG,GAAG,MAAN,CAAjC,KACAA,GAAG,GAAG,OAAN;EACN;;EAED5O,EAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ;;EAEA,MAAIgN,YAAY,IAAI/D,WAAW,KAAKwC,aAApC,EAAmD;EACjD,QAAImC,GAAG,KAAK,OAAZ,EAAqB;EACnB5O,MAAAA,MAAM,CAACgB,IAAP,CAAY,yBAAZ;EACA;EACD;;EACDhB,IAAAA,MAAM,CAACgB,IAAP,CAAY,0BAAZ;;EACA,QAAI4N,GAAG,KAAK,MAAZ,EAAoB;EAClB5O,MAAAA,MAAM,CAACgB,IAAP,CAAY,wBAAZ;EACD,KAFD,MAEO;EACLhB,MAAAA,MAAM,CAACgB,IAAP,CAAY,wBAAZ;EACD;EACF;EACF;;ACxBD,qBAAe;EACb+I,EAAAA,aAAa,EAAbA,aADa;EAEb2E,EAAAA,eAAe,EAAfA,eAFa;EAGb9X,EAAAA,aAAa,EAAbA;EAHa,CAAf;;ECJe,SAASiY,OAAT,CACbtW,KADa,EAEbsR,KAFa,EAGbmE,YAHa,EAIbE,QAJa,EAKb;EAAA,MAJA3V,KAIA;EAJAA,IAAAA,KAIA,GAJQ,CAIR;EAAA;;EAAA,MAHAsR,KAGA;EAHAA,IAAAA,KAGA,GAHQ,KAAK1I,MAAL,CAAY0I,KAGpB;EAAA;;EAAA,MAFAmE,YAEA;EAFAA,IAAAA,YAEA,GAFe,IAEf;EAAA;;EACA,MAAI,OAAOzV,KAAP,KAAiB,QAAjB,IAA6B,OAAOA,KAAP,KAAiB,QAAlD,EAA4D;EAC1D,UAAM,IAAIuW,KAAJ,8EACuE,OAAOvW,KAD9E,cAAN;EAGD;;EAED,MAAI,OAAOA,KAAP,KAAiB,QAArB,EAA+B;EAC7B;EACJ;EACA;EACA;EACI,QAAMwW,aAAa,GAAG9K,QAAQ,CAAC1L,KAAD,EAAQ,EAAR,CAA9B;EAEA;EACJ;EACA;EACA;EACA;;EACI,QAAMyW,aAAa,GAAGC,QAAQ,CAACF,aAAD,CAA9B;;EAEA,QAAI,CAACC,aAAL,EAAoB;EAClB,YAAM,IAAIF,KAAJ,yEACkEvW,KADlE,cAAN;EAGD,KAlB4B;EAqB7B;;;EACAA,IAAAA,KAAK,GAAGwW,aAAR;EACD;;EAED,MAAM/O,MAAM,GAAG,IAAf;EACA,MAAI2F,UAAU,GAAGpN,KAAjB;EACA,MAAIoN,UAAU,GAAG,CAAjB,EAAoBA,UAAU,GAAG,CAAb;EAlCpB,MAqCExE,MArCF,GA4CInB,MA5CJ,CAqCEmB,MArCF;EAAA,MAsCEmE,QAtCF,GA4CItF,MA5CJ,CAsCEsF,QAtCF;EAAA,MAuCEC,UAvCF,GA4CIvF,MA5CJ,CAuCEuF,UAvCF;EAAA,MAwCEkH,aAxCF,GA4CIzM,MA5CJ,CAwCEyM,aAxCF;EAAA,MAyCExC,WAzCF,GA4CIjK,MA5CJ,CAyCEiK,WAzCF;EAAA,MA0CgBrF,GA1ChB,GA4CI5E,MA5CJ,CA0CE6E,YA1CF;EAAA,MA2CE4I,SA3CF,GA4CIzN,MA5CJ,CA2CEyN,SA3CF;;EA6CA,MAAIzN,MAAM,CAACmO,SAAP,IAAoBhN,MAAM,CAACiN,8BAA/B,EAA+D;EAC7D,WAAO,KAAP;EACD;;EAED,MAAMvB,IAAI,GAAGhG,IAAI,CAACiB,GAAL,CAAS9H,MAAM,CAACmB,MAAP,CAAcuH,kBAAvB,EAA2C/C,UAA3C,CAAb;EACA,MAAI2D,SAAS,GAAGuD,IAAI,GAAGhG,IAAI,CAACC,KAAL,CAAW,CAACnB,UAAU,GAAGkH,IAAd,IAAsB7M,MAAM,CAACmB,MAAP,CAAcuG,cAA/C,CAAvB;EACA,MAAI4B,SAAS,IAAIhE,QAAQ,CAAC9b,MAA1B,EAAkC8f,SAAS,GAAGhE,QAAQ,CAAC9b,MAAT,GAAkB,CAA9B;;EAElC,MAAI,CAACygB,WAAW,IAAI9I,MAAM,CAAC+N,YAAtB,IAAsC,CAAvC,OAA+CzC,aAAa,IAAI,CAAhE,KAAsEuB,YAA1E,EAAwF;EACtFhO,IAAAA,MAAM,CAACgB,IAAP,CAAY,wBAAZ;EACD;;EAED,MAAMsJ,SAAS,GAAG,CAAChF,QAAQ,CAACgE,SAAD,CAA3B,CAzDA;;EA4DAtJ,EAAAA,MAAM,CAACiL,cAAP,CAAsBX,SAAtB,EA5DA;;EA+DA,MAAInJ,MAAM,CAACyL,mBAAX,EAAgC;EAC9B,SAAK,IAAItb,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGiU,UAAU,CAAC/b,MAA/B,EAAuC8H,CAAC,IAAI,CAA5C,EAA+C;EAC7C,UAAM6d,mBAAmB,GAAG,CAACtI,IAAI,CAACC,KAAL,CAAWwD,SAAS,GAAG,GAAvB,CAA7B;EACA,UAAM8E,cAAc,GAAGvI,IAAI,CAACC,KAAL,CAAWvB,UAAU,CAACjU,CAAD,CAAV,GAAgB,GAA3B,CAAvB;EACA,UAAM+d,kBAAkB,GAAGxI,IAAI,CAACC,KAAL,CAAWvB,UAAU,CAACjU,CAAC,GAAG,CAAL,CAAV,GAAoB,GAA/B,CAA3B;;EACA,UAAI,OAAOiU,UAAU,CAACjU,CAAC,GAAG,CAAL,CAAjB,KAA6B,WAAjC,EAA8C;EAC5C,YACE6d,mBAAmB,IAAIC,cAAvB,IACAD,mBAAmB,GAAGE,kBAAkB,GAAG,CAACA,kBAAkB,GAAGD,cAAtB,IAAwC,CAFrF,EAGE;EACAzJ,UAAAA,UAAU,GAAGrU,CAAb;EACD,SALD,MAKO,IACL6d,mBAAmB,IAAIC,cAAvB,IACAD,mBAAmB,GAAGE,kBAFjB,EAGL;EACA1J,UAAAA,UAAU,GAAGrU,CAAC,GAAG,CAAjB;EACD;EACF,OAZD,MAYO,IAAI6d,mBAAmB,IAAIC,cAA3B,EAA2C;EAChDzJ,QAAAA,UAAU,GAAGrU,CAAb;EACD;EACF;EACF,GApFD;;;EAsFA,MAAI0O,MAAM,CAACI,WAAP,IAAsBuF,UAAU,KAAKsE,WAAzC,EAAsD;EACpD,QACE,CAACjK,MAAM,CAACsP,cAAR,IACAhF,SAAS,GAAGtK,MAAM,CAACsK,SADnB,IAEAA,SAAS,GAAGtK,MAAM,CAAC2K,YAAP,EAHd,EAIE;EACA,aAAO,KAAP;EACD;;EACD,QACE,CAAC3K,MAAM,CAACuP,cAAR,IACAjF,SAAS,GAAGtK,MAAM,CAACsK,SADnB,IAEAA,SAAS,GAAGtK,MAAM,CAACoL,YAAP,EAHd,EAIE;EACA,UAAI,CAACnB,WAAW,IAAI,CAAhB,MAAuBtE,UAA3B,EAAuC,OAAO,KAAP;EACxC;EACF;;EAED,MAAIgJ,SAAJ;EACA,MAAIhJ,UAAU,GAAGsE,WAAjB,EAA8B0E,SAAS,GAAG,MAAZ,CAA9B,KACK,IAAIhJ,UAAU,GAAGsE,WAAjB,EAA8B0E,SAAS,GAAG,MAAZ,CAA9B,KACAA,SAAS,GAAG,OAAZ,CA1GL;;EA6GA,MAAK/J,GAAG,IAAI,CAAC0F,SAAD,KAAetK,MAAM,CAACsK,SAA9B,IAA6C,CAAC1F,GAAD,IAAQ0F,SAAS,KAAKtK,MAAM,CAACsK,SAA9E,EAA0F;EACxFtK,IAAAA,MAAM,CAACuM,iBAAP,CAAyB5G,UAAzB,EADwF;;EAGxF,QAAIxE,MAAM,CAACyJ,UAAX,EAAuB;EACrB5K,MAAAA,MAAM,CAAC4J,gBAAP;EACD;;EACD5J,IAAAA,MAAM,CAACyL,mBAAP;;EACA,QAAItK,MAAM,CAACyH,MAAP,KAAkB,OAAtB,EAA+B;EAC7B5I,MAAAA,MAAM,CAACuN,YAAP,CAAoBjD,SAApB;EACD;;EACD,QAAIqE,SAAS,KAAK,OAAlB,EAA2B;EACzB3O,MAAAA,MAAM,CAAC0O,eAAP,CAAuBV,YAAvB,EAAqCW,SAArC;EACA3O,MAAAA,MAAM,CAACpJ,aAAP,CAAqBoX,YAArB,EAAmCW,SAAnC;EACD;;EACD,WAAO,KAAP;EACD;;EACD,MAAIxN,MAAM,CAACyE,OAAX,EAAoB;EAClB,QAAM0I,GAAG,GAAGtO,MAAM,CAAC+D,YAAP,EAAZ;EACA,QAAIyL,CAAC,GAAG,CAAClF,SAAT;;EACA,QAAI1F,GAAJ,EAAS;EACP4K,MAAAA,CAAC,GAAG/B,SAAS,CAACgC,WAAV,GAAwBhC,SAAS,CAACtW,WAAlC,GAAgDqY,CAApD;EACD;;EACD,QAAI3F,KAAK,KAAK,CAAd,EAAiB;EACf4D,MAAAA,SAAS,CAACa,GAAG,GAAG,YAAH,GAAkB,WAAtB,CAAT,GAA8CkB,CAA9C;EACD,KAFD,MAEO;EACL;EACA,UAAI/B,SAAS,CAACc,QAAd,EAAwB;EAAA;;EACtBd,QAAAA,SAAS,CAACc,QAAV,gDACGD,GAAG,GAAG,MAAH,GAAY,KADlB,IAC0BkB,CAD1B,sBAEEhB,QAFF,GAEY,QAFZ;EAID,OALD,MAKO;EACLf,QAAAA,SAAS,CAACa,GAAG,GAAG,YAAH,GAAkB,WAAtB,CAAT,GAA8CkB,CAA9C;EACD;EACF;;EACD,WAAO,IAAP;EACD;;EAED,MAAI3F,KAAK,KAAK,CAAd,EAAiB;EACf7J,IAAAA,MAAM,CAAC+J,aAAP,CAAqB,CAArB;EACA/J,IAAAA,MAAM,CAACuN,YAAP,CAAoBjD,SAApB;EACAtK,IAAAA,MAAM,CAACuM,iBAAP,CAAyB5G,UAAzB;EACA3F,IAAAA,MAAM,CAACyL,mBAAP;EACAzL,IAAAA,MAAM,CAACgB,IAAP,CAAY,uBAAZ,EAAqC6I,KAArC,EAA4CqE,QAA5C;EACAlO,IAAAA,MAAM,CAAC0O,eAAP,CAAuBV,YAAvB,EAAqCW,SAArC;EACA3O,IAAAA,MAAM,CAACpJ,aAAP,CAAqBoX,YAArB,EAAmCW,SAAnC;EACD,GARD,MAQO;EACL3O,IAAAA,MAAM,CAAC+J,aAAP,CAAqBF,KAArB;EACA7J,IAAAA,MAAM,CAACuN,YAAP,CAAoBjD,SAApB;EACAtK,IAAAA,MAAM,CAACuM,iBAAP,CAAyB5G,UAAzB;EACA3F,IAAAA,MAAM,CAACyL,mBAAP;EACAzL,IAAAA,MAAM,CAACgB,IAAP,CAAY,uBAAZ,EAAqC6I,KAArC,EAA4CqE,QAA5C;EACAlO,IAAAA,MAAM,CAAC0O,eAAP,CAAuBV,YAAvB,EAAqCW,SAArC;;EACA,QAAI,CAAC3O,MAAM,CAACmO,SAAZ,EAAuB;EACrBnO,MAAAA,MAAM,CAACmO,SAAP,GAAmB,IAAnB;;EACA,UAAI,CAACnO,MAAM,CAAC0P,6BAAZ,EAA2C;EACzC1P,QAAAA,MAAM,CAAC0P,6BAAP,GAAuC,SAAS9Y,aAAT,CAAuBxI,CAAvB,EAA0B;EAC/D,cAAI,CAAC4R,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC;EACjC,cAAI/R,CAAC,CAACjF,MAAF,KAAa,IAAjB,EAAuB;EACvB6W,UAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1Y,mBAArB,CACE,eADF,EAEEoW,MAAM,CAAC0P,6BAFT;EAIA1P,UAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1Y,mBAArB,CACE,qBADF,EAEEoW,MAAM,CAAC0P,6BAFT;EAIA1P,UAAAA,MAAM,CAAC0P,6BAAP,GAAuC,IAAvC;EACA,iBAAO1P,MAAM,CAAC0P,6BAAd;EACA1P,UAAAA,MAAM,CAACpJ,aAAP,CAAqBoX,YAArB,EAAmCW,SAAnC;EACD,SAdD;EAeD;;EACD3O,MAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB3Y,gBAArB,CAAsC,eAAtC,EAAuDqW,MAAM,CAAC0P,6BAA9D;EACA1P,MAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB3Y,gBAArB,CACE,qBADF,EAEEqW,MAAM,CAAC0P,6BAFT;EAID;EACF;;EAED,SAAO,IAAP;EACD;;ECnMc,SAASC,WAAT,CACbpX,KADa,EAEbsR,KAFa,EAGbmE,YAHa,EAIbE,QAJa,EAKb;EAAA,MAJA3V,KAIA;EAJAA,IAAAA,KAIA,GAJQ,CAIR;EAAA;;EAAA,MAHAsR,KAGA;EAHAA,IAAAA,KAGA,GAHQ,KAAK1I,MAAL,CAAY0I,KAGpB;EAAA;;EAAA,MAFAmE,YAEA;EAFAA,IAAAA,YAEA,GAFe,IAEf;EAAA;;EACA,MAAMhO,MAAM,GAAG,IAAf;EACA,MAAI4P,QAAQ,GAAGrX,KAAf;;EACA,MAAIyH,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtB0D,IAAAA,QAAQ,IAAI5P,MAAM,CAAC6P,YAAnB;EACD;;EAED,SAAO7P,MAAM,CAAC6O,OAAP,CAAee,QAAf,EAAyB/F,KAAzB,EAAgCmE,YAAhC,EAA8CE,QAA9C,CAAP;EACD;;ECbD;EACe,SAAS4B,SAAT,CAAmBjG,KAAnB,EAA8CmE,YAA9C,EAAmEE,QAAnE,EAA6E;EAAA,MAA1DrE,KAA0D;EAA1DA,IAAAA,KAA0D,GAAlD,KAAK1I,MAAL,CAAY0I,KAAsC;EAAA;;EAAA,MAA/BmE,YAA+B;EAA/BA,IAAAA,YAA+B,GAAhB,IAAgB;EAAA;;EAC1F,MAAMhO,MAAM,GAAG,IAAf;EAD0F,MAElFmB,MAFkF,GAE5DnB,MAF4D,CAElFmB,MAFkF;EAAA,MAE1EgN,SAF0E,GAE5DnO,MAF4D,CAE1EmO,SAF0E;EAG1F,MAAM4B,SAAS,GAAG/P,MAAM,CAACiK,WAAP,GAAqB9I,MAAM,CAACuH,kBAA5B,GAAiD,CAAjD,GAAqDvH,MAAM,CAACuG,cAA9E;;EACA,MAAIvG,MAAM,CAAC+K,IAAX,EAAiB;EACf,QAAIiC,SAAS,IAAIhN,MAAM,CAAC6O,iBAAxB,EAA2C,OAAO,KAAP;EAC3ChQ,IAAAA,MAAM,CAACiQ,OAAP,GAFe;;EAIfjQ,IAAAA,MAAM,CAACkQ,WAAP,GAAqBlQ,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1K,UAA1C;EACD;;EACD,SAAOoI,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACiK,WAAP,GAAqB8F,SAApC,EAA+ClG,KAA/C,EAAsDmE,YAAtD,EAAoEE,QAApE,CAAP;EACD;;ECZD;EACe,SAASiC,SAAT,CAAmBtG,KAAnB,EAA8CmE,YAA9C,EAAmEE,QAAnE,EAA6E;EAAA,MAA1DrE,KAA0D;EAA1DA,IAAAA,KAA0D,GAAlD,KAAK1I,MAAL,CAAY0I,KAAsC;EAAA;;EAAA,MAA/BmE,YAA+B;EAA/BA,IAAAA,YAA+B,GAAhB,IAAgB;EAAA;;EAC1F,MAAMhO,MAAM,GAAG,IAAf;EAD0F,MAElFmB,MAFkF,GAExBnB,MAFwB,CAElFmB,MAFkF;EAAA,MAE1EgN,SAF0E,GAExBnO,MAFwB,CAE1EmO,SAF0E;EAAA,MAE/D7I,QAF+D,GAExBtF,MAFwB,CAE/DsF,QAF+D;EAAA,MAErDC,UAFqD,GAExBvF,MAFwB,CAErDuF,UAFqD;EAAA,MAEzCV,YAFyC,GAExB7E,MAFwB,CAEzC6E,YAFyC;;EAI1F,MAAI1D,MAAM,CAAC+K,IAAX,EAAiB;EACf,QAAIiC,SAAS,IAAIhN,MAAM,CAAC6O,iBAAxB,EAA2C,OAAO,KAAP;EAC3ChQ,IAAAA,MAAM,CAACiQ,OAAP,GAFe;;EAIfjQ,IAAAA,MAAM,CAACkQ,WAAP,GAAqBlQ,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1K,UAA1C;EACD;;EACD,MAAM0S,SAAS,GAAGzF,YAAY,GAAG7E,MAAM,CAACsK,SAAV,GAAsB,CAACtK,MAAM,CAACsK,SAA5D;;EACA,WAAS8F,SAAT,CAAmBC,GAAnB,EAAwB;EACtB,QAAIA,GAAG,GAAG,CAAV,EAAa,OAAO,CAACxJ,IAAI,CAACC,KAAL,CAAWD,IAAI,CAAC4B,GAAL,CAAS4H,GAAT,CAAX,CAAR;EACb,WAAOxJ,IAAI,CAACC,KAAL,CAAWuJ,GAAX,CAAP;EACD;;EACD,MAAMlB,mBAAmB,GAAGiB,SAAS,CAAC9F,SAAD,CAArC;EACA,MAAMgG,kBAAkB,GAAGhL,QAAQ,CAAChT,GAAT,CAAa,UAAC+d,GAAD;EAAA,WAASD,SAAS,CAACC,GAAD,CAAlB;EAAA,GAAb,CAA3B;EAEA,EAAoB/K,QAAQ,CAACgL,kBAAkB,CAACnhB,OAAnB,CAA2BggB,mBAA3B,CAAD;EAC5B,MAAIoB,QAAQ,GAAGjL,QAAQ,CAACgL,kBAAkB,CAACnhB,OAAnB,CAA2BggB,mBAA3B,IAAkD,CAAnD,CAAvB;;EACA,MAAI,OAAOoB,QAAP,KAAoB,WAApB,IAAmCpP,MAAM,CAACyE,OAA9C,EAAuD;EACrDN,IAAAA,QAAQ,CAAChc,OAAT,CAAiB,UAAC6f,IAAD,EAAU;EACzB,UAAI,CAACoH,QAAD,IAAapB,mBAAmB,IAAIhG,IAAxC,EAA8CoH,QAAQ,GAAGpH,IAAX;EAC/C,KAFD;EAGD;;EACD,MAAIqH,SAAJ;;EACA,MAAI,OAAOD,QAAP,KAAoB,WAAxB,EAAqC;EACnCC,IAAAA,SAAS,GAAGjL,UAAU,CAACpW,OAAX,CAAmBohB,QAAnB,CAAZ;EACA,QAAIC,SAAS,GAAG,CAAhB,EAAmBA,SAAS,GAAGxQ,MAAM,CAACiK,WAAP,GAAqB,CAAjC;EACpB;;EACD,SAAOjK,MAAM,CAAC6O,OAAP,CAAe2B,SAAf,EAA0B3G,KAA1B,EAAiCmE,YAAjC,EAA+CE,QAA/C,CAAP;EACD;;EChCD;EACe,SAASuC,UAAT,CAAoB5G,KAApB,EAA+CmE,YAA/C,EAAoEE,QAApE,EAA8E;EAAA,MAA1DrE,KAA0D;EAA1DA,IAAAA,KAA0D,GAAlD,KAAK1I,MAAL,CAAY0I,KAAsC;EAAA;;EAAA,MAA/BmE,YAA+B;EAA/BA,IAAAA,YAA+B,GAAhB,IAAgB;EAAA;;EAC3F,MAAMhO,MAAM,GAAG,IAAf;EACA,SAAOA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACiK,WAAtB,EAAmCJ,KAAnC,EAA0CmE,YAA1C,EAAwDE,QAAxD,CAAP;EACD;;ECJD;EACe,SAASwC,cAAT,CACb7G,KADa,EAEbmE,YAFa,EAGbE,QAHa,EAIbyC,SAJa,EAKb;EAAA,MAJA9G,KAIA;EAJAA,IAAAA,KAIA,GAJQ,KAAK1I,MAAL,CAAY0I,KAIpB;EAAA;;EAAA,MAHAmE,YAGA;EAHAA,IAAAA,YAGA,GAHe,IAGf;EAAA;;EAAA,MADA2C,SACA;EADAA,IAAAA,SACA,GADY,GACZ;EAAA;;EACA,MAAM3Q,MAAM,GAAG,IAAf;EACA,MAAIzH,KAAK,GAAGyH,MAAM,CAACiK,WAAnB;EACA,MAAM4C,IAAI,GAAGhG,IAAI,CAACiB,GAAL,CAAS9H,MAAM,CAACmB,MAAP,CAAcuH,kBAAvB,EAA2CnQ,KAA3C,CAAb;EACA,MAAM+Q,SAAS,GAAGuD,IAAI,GAAGhG,IAAI,CAACC,KAAL,CAAW,CAACvO,KAAK,GAAGsU,IAAT,IAAiB7M,MAAM,CAACmB,MAAP,CAAcuG,cAA1C,CAAzB;EAEA,MAAM4C,SAAS,GAAGtK,MAAM,CAAC6E,YAAP,GAAsB7E,MAAM,CAACsK,SAA7B,GAAyC,CAACtK,MAAM,CAACsK,SAAnE;;EAEA,MAAIA,SAAS,IAAItK,MAAM,CAACsF,QAAP,CAAgBgE,SAAhB,CAAjB,EAA6C;EAC3C;EACA;EACA,QAAMsH,WAAW,GAAG5Q,MAAM,CAACsF,QAAP,CAAgBgE,SAAhB,CAApB;EACA,QAAMuH,QAAQ,GAAG7Q,MAAM,CAACsF,QAAP,CAAgBgE,SAAS,GAAG,CAA5B,CAAjB;;EACA,QAAIgB,SAAS,GAAGsG,WAAZ,GAA0B,CAACC,QAAQ,GAAGD,WAAZ,IAA2BD,SAAzD,EAAoE;EAClEpY,MAAAA,KAAK,IAAIyH,MAAM,CAACmB,MAAP,CAAcuG,cAAvB;EACD;EACF,GARD,MAQO;EACL;EACA;EACA,QAAM6I,QAAQ,GAAGvQ,MAAM,CAACsF,QAAP,CAAgBgE,SAAS,GAAG,CAA5B,CAAjB;EACA,QAAMsH,YAAW,GAAG5Q,MAAM,CAACsF,QAAP,CAAgBgE,SAAhB,CAApB;;EACA,QAAIgB,SAAS,GAAGiG,QAAZ,IAAwB,CAACK,YAAW,GAAGL,QAAf,IAA2BI,SAAvD,EAAkE;EAChEpY,MAAAA,KAAK,IAAIyH,MAAM,CAACmB,MAAP,CAAcuG,cAAvB;EACD;EACF;;EACDnP,EAAAA,KAAK,GAAGsO,IAAI,CAACK,GAAL,CAAS3O,KAAT,EAAgB,CAAhB,CAAR;EACAA,EAAAA,KAAK,GAAGsO,IAAI,CAACiB,GAAL,CAASvP,KAAT,EAAgByH,MAAM,CAACuF,UAAP,CAAkB/b,MAAlB,GAA2B,CAA3C,CAAR;EAEA,SAAOwW,MAAM,CAAC6O,OAAP,CAAetW,KAAf,EAAsBsR,KAAtB,EAA6BmE,YAA7B,EAA2CE,QAA3C,CAAP;EACD;;EChCc,SAASf,mBAAT,GAA+B;EAC5C,MAAMnN,MAAM,GAAG,IAAf;EAD4C,MAEpCmB,MAFoC,GAEbnB,MAFa,CAEpCmB,MAFoC;EAAA,MAE5BmB,UAF4B,GAEbtC,MAFa,CAE5BsC,UAF4B;EAI5C,MAAM0E,aAAa,GACjB7F,MAAM,CAAC6F,aAAP,KAAyB,MAAzB,GAAkChH,MAAM,CAAC8Q,oBAAP,EAAlC,GAAkE3P,MAAM,CAAC6F,aAD3E;EAEA,MAAI+J,YAAY,GAAG/Q,MAAM,CAACkN,YAA1B;EACA,MAAIxB,SAAJ;;EACA,MAAIvK,MAAM,CAAC+K,IAAX,EAAiB;EACf,QAAIlM,MAAM,CAACmO,SAAX,EAAsB;EACtBzC,IAAAA,SAAS,GAAGzH,QAAQ,CAACvS,CAAC,CAACsO,MAAM,CAACiN,YAAR,CAAD,CAAuBvZ,IAAvB,CAA4B,yBAA5B,CAAD,EAAyD,EAAzD,CAApB;;EACA,QAAIyN,MAAM,CAACqH,cAAX,EAA2B;EACzB,UACEuI,YAAY,GAAG/Q,MAAM,CAAC6P,YAAP,GAAsB7I,aAAa,GAAG,CAArD,IACA+J,YAAY,GAAG/Q,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuBwW,MAAM,CAAC6P,YAA9B,GAA6C7I,aAAa,GAAG,CAF9E,EAGE;EACAhH,QAAAA,MAAM,CAACiQ,OAAP;EACAc,QAAAA,YAAY,GAAGzO,UAAU,CACtBhY,QADY,OAEP6W,MAAM,CAACiE,UAFA,mCAEuCsG,SAFvC,iBAE2DvK,MAAM,CAACgL,mBAFlE,QAIZlT,EAJY,CAIT,CAJS,EAKZV,KALY,EAAf;EAOAyC,QAAAA,QAAQ,CAAC,YAAM;EACbgF,UAAAA,MAAM,CAAC6O,OAAP,CAAekC,YAAf;EACD,SAFO,CAAR;EAGD,OAfD,MAeO;EACL/Q,QAAAA,MAAM,CAAC6O,OAAP,CAAekC,YAAf;EACD;EACF,KAnBD,MAmBO,IAAIA,YAAY,GAAG/Q,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuBwd,aAA1C,EAAyD;EAC9DhH,MAAAA,MAAM,CAACiQ,OAAP;EACAc,MAAAA,YAAY,GAAGzO,UAAU,CACtBhY,QADY,OAEP6W,MAAM,CAACiE,UAFA,mCAEuCsG,SAFvC,iBAE2DvK,MAAM,CAACgL,mBAFlE,QAIZlT,EAJY,CAIT,CAJS,EAKZV,KALY,EAAf;EAOAyC,MAAAA,QAAQ,CAAC,YAAM;EACbgF,QAAAA,MAAM,CAAC6O,OAAP,CAAekC,YAAf;EACD,OAFO,CAAR;EAGD,KAZM,MAYA;EACL/Q,MAAAA,MAAM,CAAC6O,OAAP,CAAekC,YAAf;EACD;EACF,GArCD,MAqCO;EACL/Q,IAAAA,MAAM,CAAC6O,OAAP,CAAekC,YAAf;EACD;EACF;;AC3CD,cAAe;EACblC,EAAAA,OAAO,EAAPA,OADa;EAEbc,EAAAA,WAAW,EAAXA,WAFa;EAGbG,EAAAA,SAAS,EAATA,SAHa;EAIbK,EAAAA,SAAS,EAATA,SAJa;EAKbM,EAAAA,UAAU,EAAVA,UALa;EAMbC,EAAAA,cAAc,EAAdA,cANa;EAObvD,EAAAA,mBAAmB,EAAnBA;EAPa,CAAf;;ECLe,SAAS6D,UAAT,GAAsB;EACnC,MAAMhR,MAAM,GAAG,IAAf;EACA,MAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EAFmC,MAG3B6V,MAH2B,GAGJnB,MAHI,CAG3BmB,MAH2B;EAAA,MAGnBmB,UAHmB,GAGJtC,MAHI,CAGnBsC,UAHmB;;EAKnCA,EAAAA,UAAU,CAAChY,QAAX,OAAwB6W,MAAM,CAACiE,UAA/B,SAA6CjE,MAAM,CAACgL,mBAApD,EAA2EnZ,MAA3E;EAEA,MAAImS,MAAM,GAAG7C,UAAU,CAAChY,QAAX,OAAwB6W,MAAM,CAACiE,UAA/B,CAAb;;EAEA,MAAIjE,MAAM,CAAC8P,sBAAX,EAAmC;EACjC,QAAMC,cAAc,GAAG/P,MAAM,CAACuG,cAAP,GAAyBvC,MAAM,CAAC3b,MAAP,GAAgB2X,MAAM,CAACuG,cAAvE;;EACA,QAAIwJ,cAAc,KAAK/P,MAAM,CAACuG,cAA9B,EAA8C;EAC5C,WAAK,IAAIpW,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG4f,cAApB,EAAoC5f,CAAC,IAAI,CAAzC,EAA4C;EAC1C,YAAM6f,SAAS,GAAGzf,CAAC,CAAClG,QAAQ,CAACnB,aAAT,CAAuB,KAAvB,CAAD,CAAD,CAAiC4H,QAAjC,CACbkP,MAAM,CAACiE,UADM,SACQjE,MAAM,CAACiQ,eADf,CAAlB;EAGA9O,QAAAA,UAAU,CAACnJ,MAAX,CAAkBgY,SAAlB;EACD;;EACDhM,MAAAA,MAAM,GAAG7C,UAAU,CAAChY,QAAX,OAAwB6W,MAAM,CAACiE,UAA/B,CAAT;EACD;EACF;;EAED,MAAIjE,MAAM,CAAC6F,aAAP,KAAyB,MAAzB,IAAmC,CAAC7F,MAAM,CAAC0O,YAA/C,EAA6D1O,MAAM,CAAC0O,YAAP,GAAsB1K,MAAM,CAAC3b,MAA7B;EAE7DwW,EAAAA,MAAM,CAAC6P,YAAP,GAAsBhJ,IAAI,CAACE,IAAL,CAAU3P,UAAU,CAAC+J,MAAM,CAAC0O,YAAP,IAAuB1O,MAAM,CAAC6F,aAA/B,EAA8C,EAA9C,CAApB,CAAtB;EACAhH,EAAAA,MAAM,CAAC6P,YAAP,IAAuB1O,MAAM,CAACkQ,oBAA9B;;EACA,MAAIrR,MAAM,CAAC6P,YAAP,GAAsB1K,MAAM,CAAC3b,MAAjC,EAAyC;EACvCwW,IAAAA,MAAM,CAAC6P,YAAP,GAAsB1K,MAAM,CAAC3b,MAA7B;EACD;;EAED,MAAM8nB,aAAa,GAAG,EAAtB;EACA,MAAMC,YAAY,GAAG,EAArB;EACApM,EAAAA,MAAM,CAAC7M,IAAP,CAAY,UAACtH,EAAD,EAAKuH,KAAL,EAAe;EACzB,QAAM+O,KAAK,GAAG5V,CAAC,CAACV,EAAD,CAAf;;EACA,QAAIuH,KAAK,GAAGyH,MAAM,CAAC6P,YAAnB,EAAiC;EAC/B0B,MAAAA,YAAY,CAAC7iB,IAAb,CAAkBsC,EAAlB;EACD;;EACD,QAAIuH,KAAK,GAAG4M,MAAM,CAAC3b,MAAf,IAAyB+O,KAAK,IAAI4M,MAAM,CAAC3b,MAAP,GAAgBwW,MAAM,CAAC6P,YAA7D,EAA2E;EACzEyB,MAAAA,aAAa,CAAC5iB,IAAd,CAAmBsC,EAAnB;EACD;;EACDsW,IAAAA,KAAK,CAAC5T,IAAN,CAAW,yBAAX,EAAsC6E,KAAtC;EACD,GATD;;EAUA,OAAK,IAAIjH,EAAC,GAAG,CAAb,EAAgBA,EAAC,GAAGigB,YAAY,CAAC/nB,MAAjC,EAAyC8H,EAAC,IAAI,CAA9C,EAAiD;EAC/CgR,IAAAA,UAAU,CAACnJ,MAAX,CAAkBzH,CAAC,CAAC6f,YAAY,CAACjgB,EAAD,CAAZ,CAAgBkgB,SAAhB,CAA0B,IAA1B,CAAD,CAAD,CAAmCvf,QAAnC,CAA4CkP,MAAM,CAACgL,mBAAnD,CAAlB;EACD;;EACD,OAAK,IAAI7a,GAAC,GAAGggB,aAAa,CAAC9nB,MAAd,GAAuB,CAApC,EAAuC8H,GAAC,IAAI,CAA5C,EAA+CA,GAAC,IAAI,CAApD,EAAuD;EACrDgR,IAAAA,UAAU,CAAC9I,OAAX,CAAmB9H,CAAC,CAAC4f,aAAa,CAAChgB,GAAD,CAAb,CAAiBkgB,SAAjB,CAA2B,IAA3B,CAAD,CAAD,CAAoCvf,QAApC,CAA6CkP,MAAM,CAACgL,mBAApD,CAAnB;EACD;EACF;;ECnDc,SAAS8D,OAAT,GAAmB;EAChC,MAAMjQ,MAAM,GAAG,IAAf;EAEAA,EAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ;EAHgC,MAM9BiJ,WAN8B,GAa5BjK,MAb4B,CAM9BiK,WAN8B;EAAA,MAO9B9E,MAP8B,GAa5BnF,MAb4B,CAO9BmF,MAP8B;EAAA,MAQ9B0K,YAR8B,GAa5B7P,MAb4B,CAQ9B6P,YAR8B;EAAA,MAS9BN,cAT8B,GAa5BvP,MAb4B,CAS9BuP,cAT8B;EAAA,MAU9BD,cAV8B,GAa5BtP,MAb4B,CAU9BsP,cAV8B;EAAA,MAW9BhK,QAX8B,GAa5BtF,MAb4B,CAW9BsF,QAX8B;EAAA,MAYhBV,GAZgB,GAa5B5E,MAb4B,CAY9B6E,YAZ8B;EAchC,MAAI+K,QAAJ;EACA5P,EAAAA,MAAM,CAACuP,cAAP,GAAwB,IAAxB;EACAvP,EAAAA,MAAM,CAACsP,cAAP,GAAwB,IAAxB;EAEA,MAAMmC,aAAa,GAAG,CAACnM,QAAQ,CAAC2E,WAAD,CAA/B;EACA,MAAMyH,IAAI,GAAGD,aAAa,GAAGzR,MAAM,CAAC5E,YAAP,EAA7B,CAnBgC;;EAsBhC,MAAI6O,WAAW,GAAG4F,YAAlB,EAAgC;EAC9BD,IAAAA,QAAQ,GAAGzK,MAAM,CAAC3b,MAAP,GAAgBqmB,YAAY,GAAG,CAA/B,GAAmC5F,WAA9C;EACA2F,IAAAA,QAAQ,IAAIC,YAAZ;EACA,QAAM8B,YAAY,GAAG3R,MAAM,CAAC6O,OAAP,CAAee,QAAf,EAAyB,CAAzB,EAA4B,KAA5B,EAAmC,IAAnC,CAArB;;EACA,QAAI+B,YAAY,IAAID,IAAI,KAAK,CAA7B,EAAgC;EAC9B1R,MAAAA,MAAM,CAACuN,YAAP,CAAoB,CAAC3I,GAAG,GAAG,CAAC5E,MAAM,CAACsK,SAAX,GAAuBtK,MAAM,CAACsK,SAAlC,IAA+CoH,IAAnE;EACD;EACF,GAPD,MAOO,IAAIzH,WAAW,IAAI9E,MAAM,CAAC3b,MAAP,GAAgBqmB,YAAnC,EAAiD;EACtD;EACAD,IAAAA,QAAQ,GAAG,CAACzK,MAAM,CAAC3b,MAAR,GAAiBygB,WAAjB,GAA+B4F,YAA1C;EACAD,IAAAA,QAAQ,IAAIC,YAAZ;;EACA,QAAM8B,aAAY,GAAG3R,MAAM,CAAC6O,OAAP,CAAee,QAAf,EAAyB,CAAzB,EAA4B,KAA5B,EAAmC,IAAnC,CAArB;;EACA,QAAI+B,aAAY,IAAID,IAAI,KAAK,CAA7B,EAAgC;EAC9B1R,MAAAA,MAAM,CAACuN,YAAP,CAAoB,CAAC3I,GAAG,GAAG,CAAC5E,MAAM,CAACsK,SAAX,GAAuBtK,MAAM,CAACsK,SAAlC,IAA+CoH,IAAnE;EACD;EACF;;EACD1R,EAAAA,MAAM,CAACuP,cAAP,GAAwBA,cAAxB;EACAvP,EAAAA,MAAM,CAACsP,cAAP,GAAwBA,cAAxB;EAEAtP,EAAAA,MAAM,CAACgB,IAAP,CAAY,SAAZ;EACD;;EC1Cc,SAAS4Q,WAAT,GAAuB;EACpC,MAAM5R,MAAM,GAAG,IAAf;EADoC,MAE5BsC,UAF4B,GAEGtC,MAFH,CAE5BsC,UAF4B;EAAA,MAEhBnB,MAFgB,GAEGnB,MAFH,CAEhBmB,MAFgB;EAAA,MAERgE,MAFQ,GAEGnF,MAFH,CAERmF,MAFQ;EAGpC7C,EAAAA,UAAU,CACPhY,QADH,OAEQ6W,MAAM,CAACiE,UAFf,SAE6BjE,MAAM,CAACgL,mBAFpC,UAE4DhL,MAAM,CAACiE,UAFnE,SAEiFjE,MAAM,CAACiQ,eAFxF,EAIGpe,MAJH;EAKAmS,EAAAA,MAAM,CAACrR,UAAP,CAAkB,yBAAlB;EACD;;ACLD,aAAe;EACbkd,EAAAA,UAAU,EAAVA,UADa;EAEbf,EAAAA,OAAO,EAAPA,OAFa;EAGb2B,EAAAA,WAAW,EAAXA;EAHa,CAAf;;ECJe,SAASC,aAAT,CAAuBC,MAAvB,EAA+B;EAC5C,MAAM9R,MAAM,GAAG,IAAf;EACA,MACEA,MAAM,CAAC/C,OAAP,CAAeE,KAAf,IACA,CAAC6C,MAAM,CAACmB,MAAP,CAAc4Q,aADf,IAEC/R,MAAM,CAACmB,MAAP,CAAcoI,aAAd,IAA+BvJ,MAAM,CAACgS,QAFvC,IAGAhS,MAAM,CAACmB,MAAP,CAAcyE,OAJhB,EAME;EACF,MAAM5U,EAAE,GAAGgP,MAAM,CAAChP,EAAlB;EACAA,EAAAA,EAAE,CAACxG,KAAH,CAASynB,MAAT,GAAkB,MAAlB;EACAjhB,EAAAA,EAAE,CAACxG,KAAH,CAASynB,MAAT,GAAkBH,MAAM,GAAG,kBAAH,GAAwB,cAAhD;EACA9gB,EAAAA,EAAE,CAACxG,KAAH,CAASynB,MAAT,GAAkBH,MAAM,GAAG,cAAH,GAAoB,WAA5C;EACA9gB,EAAAA,EAAE,CAACxG,KAAH,CAASynB,MAAT,GAAkBH,MAAM,GAAG,UAAH,GAAgB,MAAxC;EACD;;ECdc,SAASI,eAAT,GAA2B;EACxC,MAAMlS,MAAM,GAAG,IAAf;;EACA,MACEA,MAAM,CAAC/C,OAAP,CAAeE,KAAf,IACC6C,MAAM,CAACmB,MAAP,CAAcoI,aAAd,IAA+BvJ,MAAM,CAACgS,QADvC,IAEAhS,MAAM,CAACmB,MAAP,CAAcyE,OAHhB,EAIE;EACA;EACD;;EACD5F,EAAAA,MAAM,CAAChP,EAAP,CAAUxG,KAAV,CAAgBynB,MAAhB,GAAyB,EAAzB;EACD;;ACPD,mBAAe;EACbJ,EAAAA,aAAa,EAAbA,aADa;EAEbK,EAAAA,eAAe,EAAfA;EAFa,CAAf;;ECHe,SAASC,WAAT,CAAqBhN,MAArB,EAA6B;EAC1C,MAAMnF,MAAM,GAAG,IAAf;EAD0C,MAElCsC,UAFkC,GAEXtC,MAFW,CAElCsC,UAFkC;EAAA,MAEtBnB,MAFsB,GAEXnB,MAFW,CAEtBmB,MAFsB;;EAG1C,MAAIA,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAAC4R,WAAP;EACD;;EACD,MAAI,OAAOzM,MAAP,KAAkB,QAAlB,IAA8B,YAAYA,MAA9C,EAAsD;EACpD,SAAK,IAAI7T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,UAAI6T,MAAM,CAAC7T,CAAD,CAAV,EAAegR,UAAU,CAACnJ,MAAX,CAAkBgM,MAAM,CAAC7T,CAAD,CAAxB;EAChB;EACF,GAJD,MAIO;EACLgR,IAAAA,UAAU,CAACnJ,MAAX,CAAkBgM,MAAlB;EACD;;EACD,MAAIhE,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAACgR,UAAP;EACD;;EACD,MAAI,EAAE7P,MAAM,CAAC3D,QAAP,IAAmBwC,MAAM,CAAC/C,OAAP,CAAeO,QAApC,CAAJ,EAAmD;EACjDwC,IAAAA,MAAM,CAACoS,MAAP;EACD;EACF;;ECnBc,SAASC,YAAT,CAAsBlN,MAAtB,EAA8B;EAC3C,MAAMnF,MAAM,GAAG,IAAf;EAD2C,MAEnCmB,MAFmC,GAECnB,MAFD,CAEnCmB,MAFmC;EAAA,MAE3BmB,UAF2B,GAECtC,MAFD,CAE3BsC,UAF2B;EAAA,MAEf2H,WAFe,GAECjK,MAFD,CAEfiK,WAFe;;EAI3C,MAAI9I,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAAC4R,WAAP;EACD;;EACD,MAAIpF,cAAc,GAAGvC,WAAW,GAAG,CAAnC;;EACA,MAAI,OAAO9E,MAAP,KAAkB,QAAlB,IAA8B,YAAYA,MAA9C,EAAsD;EACpD,SAAK,IAAI7T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,UAAI6T,MAAM,CAAC7T,CAAD,CAAV,EAAegR,UAAU,CAAC9I,OAAX,CAAmB2L,MAAM,CAAC7T,CAAD,CAAzB;EAChB;;EACDkb,IAAAA,cAAc,GAAGvC,WAAW,GAAG9E,MAAM,CAAC3b,MAAtC;EACD,GALD,MAKO;EACL8Y,IAAAA,UAAU,CAAC9I,OAAX,CAAmB2L,MAAnB;EACD;;EACD,MAAIhE,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAACgR,UAAP;EACD;;EACD,MAAI,EAAE7P,MAAM,CAAC3D,QAAP,IAAmBwC,MAAM,CAAC/C,OAAP,CAAeO,QAApC,CAAJ,EAAmD;EACjDwC,IAAAA,MAAM,CAACoS,MAAP;EACD;;EACDpS,EAAAA,MAAM,CAAC6O,OAAP,CAAerC,cAAf,EAA+B,CAA/B,EAAkC,KAAlC;EACD;;ECvBc,SAAS8F,QAAT,CAAkB/Z,KAAlB,EAAyB4M,MAAzB,EAAiC;EAC9C,MAAMnF,MAAM,GAAG,IAAf;EAD8C,MAEtCsC,UAFsC,GAEFtC,MAFE,CAEtCsC,UAFsC;EAAA,MAE1BnB,MAF0B,GAEFnB,MAFE,CAE1BmB,MAF0B;EAAA,MAElB8I,WAFkB,GAEFjK,MAFE,CAElBiK,WAFkB;EAG9C,MAAIsI,iBAAiB,GAAGtI,WAAxB;;EACA,MAAI9I,MAAM,CAAC+K,IAAX,EAAiB;EACfqG,IAAAA,iBAAiB,IAAIvS,MAAM,CAAC6P,YAA5B;EACA7P,IAAAA,MAAM,CAAC4R,WAAP;EACA5R,IAAAA,MAAM,CAACmF,MAAP,GAAgB7C,UAAU,CAAChY,QAAX,OAAwB6W,MAAM,CAACiE,UAA/B,CAAhB;EACD;;EACD,MAAMoN,UAAU,GAAGxS,MAAM,CAACmF,MAAP,CAAc3b,MAAjC;;EACA,MAAI+O,KAAK,IAAI,CAAb,EAAgB;EACdyH,IAAAA,MAAM,CAACqS,YAAP,CAAoBlN,MAApB;EACA;EACD;;EACD,MAAI5M,KAAK,IAAIia,UAAb,EAAyB;EACvBxS,IAAAA,MAAM,CAACmS,WAAP,CAAmBhN,MAAnB;EACA;EACD;;EACD,MAAIqH,cAAc,GAAG+F,iBAAiB,GAAGha,KAApB,GAA4Bga,iBAAiB,GAAG,CAAhD,GAAoDA,iBAAzE;EAEA,MAAME,YAAY,GAAG,EAArB;;EACA,OAAK,IAAInhB,CAAC,GAAGkhB,UAAU,GAAG,CAA1B,EAA6BlhB,CAAC,IAAIiH,KAAlC,EAAyCjH,CAAC,IAAI,CAA9C,EAAiD;EAC/C,QAAMohB,YAAY,GAAG1S,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB3H,CAAjB,CAArB;EACAohB,IAAAA,YAAY,CAAC1f,MAAb;EACAyf,IAAAA,YAAY,CAAC3d,OAAb,CAAqB4d,YAArB;EACD;;EAED,MAAI,OAAOvN,MAAP,KAAkB,QAAlB,IAA8B,YAAYA,MAA9C,EAAsD;EACpD,SAAK,IAAI7T,EAAC,GAAG,CAAb,EAAgBA,EAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,EAAC,IAAI,CAAxC,EAA2C;EACzC,UAAI6T,MAAM,CAAC7T,EAAD,CAAV,EAAegR,UAAU,CAACnJ,MAAX,CAAkBgM,MAAM,CAAC7T,EAAD,CAAxB;EAChB;;EACDkb,IAAAA,cAAc,GACZ+F,iBAAiB,GAAGha,KAApB,GAA4Bga,iBAAiB,GAAGpN,MAAM,CAAC3b,MAAvD,GAAgE+oB,iBADlE;EAED,GAND,MAMO;EACLjQ,IAAAA,UAAU,CAACnJ,MAAX,CAAkBgM,MAAlB;EACD;;EAED,OAAK,IAAI7T,GAAC,GAAG,CAAb,EAAgBA,GAAC,GAAGmhB,YAAY,CAACjpB,MAAjC,EAAyC8H,GAAC,IAAI,CAA9C,EAAiD;EAC/CgR,IAAAA,UAAU,CAACnJ,MAAX,CAAkBsZ,YAAY,CAACnhB,GAAD,CAA9B;EACD;;EAED,MAAI6P,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAACgR,UAAP;EACD;;EACD,MAAI,EAAE7P,MAAM,CAAC3D,QAAP,IAAmBwC,MAAM,CAAC/C,OAAP,CAAeO,QAApC,CAAJ,EAAmD;EACjDwC,IAAAA,MAAM,CAACoS,MAAP;EACD;;EACD,MAAIjR,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAAC6O,OAAP,CAAerC,cAAc,GAAGxM,MAAM,CAAC6P,YAAvC,EAAqD,CAArD,EAAwD,KAAxD;EACD,GAFD,MAEO;EACL7P,IAAAA,MAAM,CAAC6O,OAAP,CAAerC,cAAf,EAA+B,CAA/B,EAAkC,KAAlC;EACD;EACF;;ECpDc,SAASmG,WAAT,CAAqBC,aAArB,EAAoC;EACjD,MAAM5S,MAAM,GAAG,IAAf;EADiD,MAEzCmB,MAFyC,GAELnB,MAFK,CAEzCmB,MAFyC;EAAA,MAEjCmB,UAFiC,GAELtC,MAFK,CAEjCsC,UAFiC;EAAA,MAErB2H,WAFqB,GAELjK,MAFK,CAErBiK,WAFqB;EAIjD,MAAIsI,iBAAiB,GAAGtI,WAAxB;;EACA,MAAI9I,MAAM,CAAC+K,IAAX,EAAiB;EACfqG,IAAAA,iBAAiB,IAAIvS,MAAM,CAAC6P,YAA5B;EACA7P,IAAAA,MAAM,CAAC4R,WAAP;EACA5R,IAAAA,MAAM,CAACmF,MAAP,GAAgB7C,UAAU,CAAChY,QAAX,OAAwB6W,MAAM,CAACiE,UAA/B,CAAhB;EACD;;EACD,MAAIoH,cAAc,GAAG+F,iBAArB;EACA,MAAIM,aAAJ;;EAEA,MAAI,OAAOD,aAAP,KAAyB,QAAzB,IAAqC,YAAYA,aAArD,EAAoE;EAClE,SAAK,IAAIthB,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGshB,aAAa,CAACppB,MAAlC,EAA0C8H,CAAC,IAAI,CAA/C,EAAkD;EAChDuhB,MAAAA,aAAa,GAAGD,aAAa,CAACthB,CAAD,CAA7B;EACA,UAAI0O,MAAM,CAACmF,MAAP,CAAc0N,aAAd,CAAJ,EAAkC7S,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB4Z,aAAjB,EAAgC7f,MAAhC;EAClC,UAAI6f,aAAa,GAAGrG,cAApB,EAAoCA,cAAc,IAAI,CAAlB;EACrC;;EACDA,IAAAA,cAAc,GAAG3F,IAAI,CAACK,GAAL,CAASsF,cAAT,EAAyB,CAAzB,CAAjB;EACD,GAPD,MAOO;EACLqG,IAAAA,aAAa,GAAGD,aAAhB;EACA,QAAI5S,MAAM,CAACmF,MAAP,CAAc0N,aAAd,CAAJ,EAAkC7S,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB4Z,aAAjB,EAAgC7f,MAAhC;EAClC,QAAI6f,aAAa,GAAGrG,cAApB,EAAoCA,cAAc,IAAI,CAAlB;EACpCA,IAAAA,cAAc,GAAG3F,IAAI,CAACK,GAAL,CAASsF,cAAT,EAAyB,CAAzB,CAAjB;EACD;;EAED,MAAIrL,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAACgR,UAAP;EACD;;EAED,MAAI,EAAE7P,MAAM,CAAC3D,QAAP,IAAmBwC,MAAM,CAAC/C,OAAP,CAAeO,QAApC,CAAJ,EAAmD;EACjDwC,IAAAA,MAAM,CAACoS,MAAP;EACD;;EACD,MAAIjR,MAAM,CAAC+K,IAAX,EAAiB;EACflM,IAAAA,MAAM,CAAC6O,OAAP,CAAerC,cAAc,GAAGxM,MAAM,CAAC6P,YAAvC,EAAqD,CAArD,EAAwD,KAAxD;EACD,GAFD,MAEO;EACL7P,IAAAA,MAAM,CAAC6O,OAAP,CAAerC,cAAf,EAA+B,CAA/B,EAAkC,KAAlC;EACD;EACF;;ECvCc,SAASsG,eAAT,GAA2B;EACxC,MAAM9S,MAAM,GAAG,IAAf;EAEA,MAAM4S,aAAa,GAAG,EAAtB;;EACA,OAAK,IAAIthB,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG0O,MAAM,CAACmF,MAAP,CAAc3b,MAAlC,EAA0C8H,CAAC,IAAI,CAA/C,EAAkD;EAChDshB,IAAAA,aAAa,CAAClkB,IAAd,CAAmB4C,CAAnB;EACD;;EACD0O,EAAAA,MAAM,CAAC2S,WAAP,CAAmBC,aAAnB;EACD;;ACFD,qBAAe;EACbT,EAAAA,WAAW,EAAXA,WADa;EAEbE,EAAAA,YAAY,EAAZA,YAFa;EAGbC,EAAAA,QAAQ,EAARA,QAHa;EAIbK,EAAAA,WAAW,EAAXA,WAJa;EAKbG,EAAAA,eAAe,EAAfA;EALa,CAAf;;ECFe,SAASC,YAAT,CAAsBzd,KAAtB,EAA6B;EAC1C,MAAM0K,MAAM,GAAG,IAAf;EACA,MAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EACA,MAAM0B,MAAM,GAAGF,SAAS,EAAxB;EAEA,MAAM2J,IAAI,GAAGuJ,MAAM,CAACgT,eAApB;EAL0C,MAMlC7R,MANkC,GAMdnB,MANc,CAMlCmB,MANkC;EAAA,MAM1B8R,OAN0B,GAMdjT,MANc,CAM1BiT,OAN0B;;EAQ1C,MAAIjT,MAAM,CAACmO,SAAP,IAAoBhN,MAAM,CAACiN,8BAA/B,EAA+D;EAC7D;EACD;;EACD,MAAIhgB,CAAC,GAAGkH,KAAR;EACA,MAAIlH,CAAC,CAAC8kB,aAAN,EAAqB9kB,CAAC,GAAGA,CAAC,CAAC8kB,aAAN;EACrB,MAAIC,SAAS,GAAGzhB,CAAC,CAACtD,CAAC,CAACjF,MAAH,CAAjB;;EAEA,MAAIgY,MAAM,CAACiS,iBAAP,KAA6B,SAAjC,EAA4C;EAC1C,QAAI,CAACD,SAAS,CAAC5Y,OAAV,CAAkByF,MAAM,CAACyN,SAAzB,EAAoCjkB,MAAzC,EAAiD;EAClD;;EACDiN,EAAAA,IAAI,CAAC4c,YAAL,GAAoBjlB,CAAC,CAACklB,IAAF,KAAW,YAA/B;EACA,MAAI,CAAC7c,IAAI,CAAC4c,YAAN,IAAsB,WAAWjlB,CAAjC,IAAsCA,CAAC,CAACmlB,KAAF,KAAY,CAAtD,EAAyD;EACzD,MAAI,CAAC9c,IAAI,CAAC4c,YAAN,IAAsB,YAAYjlB,CAAlC,IAAuCA,CAAC,CAAColB,MAAF,GAAW,CAAtD,EAAyD;EACzD,MAAI/c,IAAI,CAACgd,SAAL,IAAkBhd,IAAI,CAACid,OAA3B,EAAoC,OArBM;;EAwB1C,MAAMC,oBAAoB,GAAG,CAAC,CAACxS,MAAM,CAACyS,cAAT,IAA2BzS,MAAM,CAACyS,cAAP,KAA0B,EAAlF;;EACA,MAAID,oBAAoB,IAAIvlB,CAAC,CAACjF,MAA1B,IAAoCiF,CAAC,CAACjF,MAAF,CAAS0qB,UAA7C,IAA2Dve,KAAK,CAACwe,IAAjE,IAAyExe,KAAK,CAACwe,IAAN,CAAW,CAAX,CAA7E,EAA4F;EAC1FX,IAAAA,SAAS,GAAGzhB,CAAC,CAAC4D,KAAK,CAACwe,IAAN,CAAW,CAAX,CAAD,CAAb;EACD;;EAED,MACE3S,MAAM,CAAC4S,SAAP,IACAZ,SAAS,CAAC5Y,OAAV,CACE4G,MAAM,CAAC6S,iBAAP,GAA2B7S,MAAM,CAAC6S,iBAAlC,SAA0D7S,MAAM,CAACyS,cADnE,EAEE,CAFF,CAFF,EAKE;EACA5T,IAAAA,MAAM,CAACiU,UAAP,GAAoB,IAApB;EACA;EACD;;EAED,MAAI9S,MAAM,CAAC+S,YAAX,EAAyB;EACvB,QAAI,CAACf,SAAS,CAAC5Y,OAAV,CAAkB4G,MAAM,CAAC+S,YAAzB,EAAuC,CAAvC,CAAL,EAAgD;EACjD;;EAEDjB,EAAAA,OAAO,CAACkB,QAAR,GAAmB/lB,CAAC,CAACklB,IAAF,KAAW,YAAX,GAA0BllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBC,KAA7C,GAAqDjmB,CAAC,CAACimB,KAA1E;EACApB,EAAAA,OAAO,CAACqB,QAAR,GAAmBlmB,CAAC,CAACklB,IAAF,KAAW,YAAX,GAA0BllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBG,KAA7C,GAAqDnmB,CAAC,CAACmmB,KAA1E;EACA,MAAMC,MAAM,GAAGvB,OAAO,CAACkB,QAAvB;EACA,MAAMM,MAAM,GAAGxB,OAAO,CAACqB,QAAvB,CA9C0C;;EAkD1C,MAAMI,kBAAkB,GAAGvT,MAAM,CAACuT,kBAAP,IAA6BvT,MAAM,CAACwT,qBAA/D;EACA,MAAMC,kBAAkB,GAAGzT,MAAM,CAACyT,kBAAP,IAA6BzT,MAAM,CAAC0T,qBAA/D;;EACA,MACEH,kBAAkB,KACjBF,MAAM,IAAII,kBAAV,IAAgCJ,MAAM,IAAIxnB,MAAM,CAAC8nB,UAAP,GAAoBF,kBAD7C,CADpB,EAGE;EACA,QAAIF,kBAAkB,KAAK,SAA3B,EAAsC;EACpCpf,MAAAA,KAAK,CAACyf,cAAN;EACD,KAFD,MAEO;EACL;EACD;EACF;;EAED7rB,EAAAA,QAAM,CAACuN,IAAD,EAAO;EACXgd,IAAAA,SAAS,EAAE,IADA;EAEXC,IAAAA,OAAO,EAAE,KAFE;EAGXsB,IAAAA,mBAAmB,EAAE,IAHV;EAIXC,IAAAA,WAAW,EAAE1lB,SAJF;EAKX2lB,IAAAA,WAAW,EAAE3lB;EALF,GAAP,CAAN;EAQA0jB,EAAAA,OAAO,CAACuB,MAAR,GAAiBA,MAAjB;EACAvB,EAAAA,OAAO,CAACwB,MAAR,GAAiBA,MAAjB;EACAhe,EAAAA,IAAI,CAAC0e,cAAL,GAAsBja,GAAG,EAAzB;EACA8E,EAAAA,MAAM,CAACiU,UAAP,GAAoB,IAApB;EACAjU,EAAAA,MAAM,CAAC4D,UAAP;EACA5D,EAAAA,MAAM,CAACoV,cAAP,GAAwB7lB,SAAxB;EACA,MAAI4R,MAAM,CAACwP,SAAP,GAAmB,CAAvB,EAA0Bla,IAAI,CAAC4e,kBAAL,GAA0B,KAA1B;;EAC1B,MAAIjnB,CAAC,CAACklB,IAAF,KAAW,YAAf,EAA6B;EAC3B,QAAIyB,cAAc,GAAG,IAArB;EACA,QAAI5B,SAAS,CAACpe,EAAV,CAAa0B,IAAI,CAAC6e,YAAlB,CAAJ,EAAqCP,cAAc,GAAG,KAAjB;;EACrC,QACEvpB,QAAQ,CAAC3B,aAAT,IACA6H,CAAC,CAAClG,QAAQ,CAAC3B,aAAV,CAAD,CAA0BkL,EAA1B,CAA6B0B,IAAI,CAAC6e,YAAlC,CADA,IAEA9pB,QAAQ,CAAC3B,aAAT,KAA2BspB,SAAS,CAAC,CAAD,CAHtC,EAIE;EACA3nB,MAAAA,QAAQ,CAAC3B,aAAT,CAAuBC,IAAvB;EACD;;EAED,QAAMyrB,oBAAoB,GACxBR,cAAc,IAAI/U,MAAM,CAACwV,cAAzB,IAA2CrU,MAAM,CAACsU,wBADpD;;EAEA,QACE,CAACtU,MAAM,CAACuU,6BAAP,IAAwCH,oBAAzC,KACA,CAACpC,SAAS,CAAC,CAAD,CAAT,CAAawC,iBAFhB,EAGE;EACAvnB,MAAAA,CAAC,CAAC2mB,cAAF;EACD;EACF;;EACD/U,EAAAA,MAAM,CAACgB,IAAP,CAAY,YAAZ,EAA0B5S,CAA1B;EACD;;ECnGc,SAASwnB,WAAT,CAAqBtgB,KAArB,EAA4B;EACzC,MAAM9J,QAAQ,GAAGF,WAAW,EAA5B;EACA,MAAM0U,MAAM,GAAG,IAAf;EACA,MAAMvJ,IAAI,GAAGuJ,MAAM,CAACgT,eAApB;EAHyC,MAIjC7R,MAJiC,GAIMnB,MAJN,CAIjCmB,MAJiC;EAAA,MAIzB8R,OAJyB,GAIMjT,MAJN,CAIzBiT,OAJyB;EAAA,MAIFrO,GAJE,GAIM5E,MAJN,CAIhB6E,YAJgB;EAKzC,MAAIzW,CAAC,GAAGkH,KAAR;EACA,MAAIlH,CAAC,CAAC8kB,aAAN,EAAqB9kB,CAAC,GAAGA,CAAC,CAAC8kB,aAAN;;EACrB,MAAI,CAACzc,IAAI,CAACgd,SAAV,EAAqB;EACnB,QAAIhd,IAAI,CAACye,WAAL,IAAoBze,IAAI,CAACwe,WAA7B,EAA0C;EACxCjV,MAAAA,MAAM,CAACgB,IAAP,CAAY,mBAAZ,EAAiC5S,CAAjC;EACD;;EACD;EACD;;EACD,MAAIqI,IAAI,CAAC4c,YAAL,IAAqBjlB,CAAC,CAACklB,IAAF,KAAW,WAApC,EAAiD;EACjD,MAAMuC,WAAW,GACfznB,CAAC,CAACklB,IAAF,KAAW,WAAX,IAA0BllB,CAAC,CAACgmB,aAA5B,KAA8ChmB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,KAAsBhmB,CAAC,CAAC0nB,cAAF,CAAiB,CAAjB,CAApE,CADF;EAEA,MAAMzB,KAAK,GAAGjmB,CAAC,CAACklB,IAAF,KAAW,WAAX,GAAyBuC,WAAW,CAACxB,KAArC,GAA6CjmB,CAAC,CAACimB,KAA7D;EACA,MAAME,KAAK,GAAGnmB,CAAC,CAACklB,IAAF,KAAW,WAAX,GAAyBuC,WAAW,CAACtB,KAArC,GAA6CnmB,CAAC,CAACmmB,KAA7D;;EACA,MAAInmB,CAAC,CAAC2nB,uBAAN,EAA+B;EAC7B9C,IAAAA,OAAO,CAACuB,MAAR,GAAiBH,KAAjB;EACApB,IAAAA,OAAO,CAACwB,MAAR,GAAiBF,KAAjB;EACA;EACD;;EACD,MAAI,CAACvU,MAAM,CAACwV,cAAZ,EAA4B;EAC1B;EACAxV,IAAAA,MAAM,CAACiU,UAAP,GAAoB,KAApB;;EACA,QAAIxd,IAAI,CAACgd,SAAT,EAAoB;EAClBvqB,MAAAA,QAAM,CAAC+pB,OAAD,EAAU;EACduB,QAAAA,MAAM,EAAEH,KADM;EAEdI,QAAAA,MAAM,EAAEF,KAFM;EAGdJ,QAAAA,QAAQ,EAAEE,KAHI;EAIdC,QAAAA,QAAQ,EAAEC;EAJI,OAAV,CAAN;EAMA9d,MAAAA,IAAI,CAAC0e,cAAL,GAAsBja,GAAG,EAAzB;EACD;;EACD;EACD;;EACD,MAAIzE,IAAI,CAAC4c,YAAL,IAAqBlS,MAAM,CAAC6U,mBAA5B,IAAmD,CAAC7U,MAAM,CAAC+K,IAA/D,EAAqE;EACnE,QAAIlM,MAAM,CAACgE,UAAP,EAAJ,EAAyB;EACvB;EACA,UACGuQ,KAAK,GAAGtB,OAAO,CAACwB,MAAhB,IAA0BzU,MAAM,CAACsK,SAAP,IAAoBtK,MAAM,CAACoL,YAAP,EAA/C,IACCmJ,KAAK,GAAGtB,OAAO,CAACwB,MAAhB,IAA0BzU,MAAM,CAACsK,SAAP,IAAoBtK,MAAM,CAAC2K,YAAP,EAFjD,EAGE;EACAlU,QAAAA,IAAI,CAACgd,SAAL,GAAiB,KAAjB;EACAhd,QAAAA,IAAI,CAACid,OAAL,GAAe,KAAf;EACA;EACD;EACF,KAVD,MAUO,IACJW,KAAK,GAAGpB,OAAO,CAACuB,MAAhB,IAA0BxU,MAAM,CAACsK,SAAP,IAAoBtK,MAAM,CAACoL,YAAP,EAA/C,IACCiJ,KAAK,GAAGpB,OAAO,CAACuB,MAAhB,IAA0BxU,MAAM,CAACsK,SAAP,IAAoBtK,MAAM,CAAC2K,YAAP,EAF1C,EAGL;EACA;EACD;EACF;;EACD,MAAIlU,IAAI,CAAC4c,YAAL,IAAqB7nB,QAAQ,CAAC3B,aAAlC,EAAiD;EAC/C,QAAIuE,CAAC,CAACjF,MAAF,KAAaqC,QAAQ,CAAC3B,aAAtB,IAAuC6H,CAAC,CAACtD,CAAC,CAACjF,MAAH,CAAD,CAAY4L,EAAZ,CAAe0B,IAAI,CAAC6e,YAApB,CAA3C,EAA8E;EAC5E7e,MAAAA,IAAI,CAACid,OAAL,GAAe,IAAf;EACA1T,MAAAA,MAAM,CAACiU,UAAP,GAAoB,KAApB;EACA;EACD;EACF;;EACD,MAAIxd,IAAI,CAACue,mBAAT,EAA8B;EAC5BhV,IAAAA,MAAM,CAACgB,IAAP,CAAY,WAAZ,EAAyB5S,CAAzB;EACD;;EACD,MAAIA,CAAC,CAACgmB,aAAF,IAAmBhmB,CAAC,CAACgmB,aAAF,CAAgB5qB,MAAhB,GAAyB,CAAhD,EAAmD;EAEnDypB,EAAAA,OAAO,CAACkB,QAAR,GAAmBE,KAAnB;EACApB,EAAAA,OAAO,CAACqB,QAAR,GAAmBC,KAAnB;EAEA,MAAM0B,KAAK,GAAGhD,OAAO,CAACkB,QAAR,GAAmBlB,OAAO,CAACuB,MAAzC;EACA,MAAM0B,KAAK,GAAGjD,OAAO,CAACqB,QAAR,GAAmBrB,OAAO,CAACwB,MAAzC;EACA,MAAIzU,MAAM,CAACmB,MAAP,CAAcwP,SAAd,IAA2B9J,IAAI,CAACsP,IAAL,CAAU,SAAAF,KAAK,EAAI,CAAJ,CAAL,YAAaC,KAAb,EAAsB,CAAtB,CAAV,IAAqClW,MAAM,CAACmB,MAAP,CAAcwP,SAAlF,EACE;;EAEF,MAAI,OAAOla,IAAI,CAACwe,WAAZ,KAA4B,WAAhC,EAA6C;EAC3C,QAAImB,UAAJ;;EACA,QACGpW,MAAM,CAAC+D,YAAP,MAAyBkP,OAAO,CAACqB,QAAR,KAAqBrB,OAAO,CAACwB,MAAvD,IACCzU,MAAM,CAACgE,UAAP,MAAuBiP,OAAO,CAACkB,QAAR,KAAqBlB,OAAO,CAACuB,MAFvD,EAGE;EACA/d,MAAAA,IAAI,CAACwe,WAAL,GAAmB,KAAnB;EACD,KALD,MAKO;EACL;EACA,UAAIgB,KAAK,GAAGA,KAAR,GAAgBC,KAAK,GAAGA,KAAxB,IAAiC,EAArC,EAAyC;EACvCE,QAAAA,UAAU,GAAIvP,IAAI,CAACwP,KAAL,CAAWxP,IAAI,CAAC4B,GAAL,CAASyN,KAAT,CAAX,EAA4BrP,IAAI,CAAC4B,GAAL,CAASwN,KAAT,CAA5B,IAA+C,GAAhD,GAAuDpP,IAAI,CAACyP,EAAzE;EACA7f,QAAAA,IAAI,CAACwe,WAAL,GAAmBjV,MAAM,CAAC+D,YAAP,KACfqS,UAAU,GAAGjV,MAAM,CAACiV,UADL,GAEf,KAAKA,UAAL,GAAkBjV,MAAM,CAACiV,UAF7B;EAGD;EACF;EACF;;EACD,MAAI3f,IAAI,CAACwe,WAAT,EAAsB;EACpBjV,IAAAA,MAAM,CAACgB,IAAP,CAAY,mBAAZ,EAAiC5S,CAAjC;EACD;;EACD,MAAI,OAAOqI,IAAI,CAACye,WAAZ,KAA4B,WAAhC,EAA6C;EAC3C,QAAIjC,OAAO,CAACkB,QAAR,KAAqBlB,OAAO,CAACuB,MAA7B,IAAuCvB,OAAO,CAACqB,QAAR,KAAqBrB,OAAO,CAACwB,MAAxE,EAAgF;EAC9Ehe,MAAAA,IAAI,CAACye,WAAL,GAAmB,IAAnB;EACD;EACF;;EACD,MAAIze,IAAI,CAACwe,WAAT,EAAsB;EACpBxe,IAAAA,IAAI,CAACgd,SAAL,GAAiB,KAAjB;EACA;EACD;;EACD,MAAI,CAAChd,IAAI,CAACye,WAAV,EAAuB;EACrB;EACD;;EACDlV,EAAAA,MAAM,CAACiU,UAAP,GAAoB,KAApB;;EACA,MAAI,CAAC9S,MAAM,CAACyE,OAAR,IAAmBxX,CAAC,CAACoI,UAAzB,EAAqC;EACnCpI,IAAAA,CAAC,CAAC2mB,cAAF;EACD;;EACD,MAAI5T,MAAM,CAACoV,wBAAP,IAAmC,CAACpV,MAAM,CAACqV,MAA/C,EAAuD;EACrDpoB,IAAAA,CAAC,CAACqoB,eAAF;EACD;;EAED,MAAI,CAAChgB,IAAI,CAACid,OAAV,EAAmB;EACjB,QAAIvS,MAAM,CAAC+K,IAAX,EAAiB;EACflM,MAAAA,MAAM,CAACiQ,OAAP;EACD;;EACDxZ,IAAAA,IAAI,CAACigB,cAAL,GAAsB1W,MAAM,CAAC5E,YAAP,EAAtB;EACA4E,IAAAA,MAAM,CAAC+J,aAAP,CAAqB,CAArB;;EACA,QAAI/J,MAAM,CAACmO,SAAX,EAAsB;EACpBnO,MAAAA,MAAM,CAACsC,UAAP,CAAkBpM,OAAlB,CAA0B,mCAA1B;EACD;;EACDO,IAAAA,IAAI,CAACkgB,mBAAL,GAA2B,KAA3B,CATiB;;EAWjB,QAAIxV,MAAM,CAACyV,UAAP,KAAsB5W,MAAM,CAACsP,cAAP,KAA0B,IAA1B,IAAkCtP,MAAM,CAACuP,cAAP,KAA0B,IAAlF,CAAJ,EAA6F;EAC3FvP,MAAAA,MAAM,CAAC6R,aAAP,CAAqB,IAArB;EACD;;EACD7R,IAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ,EAA+B5S,CAA/B;EACD;;EACD4R,EAAAA,MAAM,CAACgB,IAAP,CAAY,YAAZ,EAA0B5S,CAA1B;EACAqI,EAAAA,IAAI,CAACid,OAAL,GAAe,IAAf;EAEA,MAAIhC,IAAI,GAAG1R,MAAM,CAAC+D,YAAP,KAAwBkS,KAAxB,GAAgCC,KAA3C;EACAjD,EAAAA,OAAO,CAACvB,IAAR,GAAeA,IAAf;EAEAA,EAAAA,IAAI,IAAIvQ,MAAM,CAAC0V,UAAf;EACA,MAAIjS,GAAJ,EAAS8M,IAAI,GAAG,CAACA,IAAR;EAET1R,EAAAA,MAAM,CAACoV,cAAP,GAAwB1D,IAAI,GAAG,CAAP,GAAW,MAAX,GAAoB,MAA5C;EACAjb,EAAAA,IAAI,CAAC6W,gBAAL,GAAwBoE,IAAI,GAAGjb,IAAI,CAACigB,cAApC;EAEA,MAAII,mBAAmB,GAAG,IAA1B;EACA,MAAIC,eAAe,GAAG5V,MAAM,CAAC4V,eAA7B;;EACA,MAAI5V,MAAM,CAAC6U,mBAAX,EAAgC;EAC9Be,IAAAA,eAAe,GAAG,CAAlB;EACD;;EACD,MAAIrF,IAAI,GAAG,CAAP,IAAYjb,IAAI,CAAC6W,gBAAL,GAAwBtN,MAAM,CAAC2K,YAAP,EAAxC,EAA+D;EAC7DmM,IAAAA,mBAAmB,GAAG,KAAtB;EACA,QAAI3V,MAAM,CAAC6V,UAAX,EACEvgB,IAAI,CAAC6W,gBAAL,GACEtN,MAAM,CAAC2K,YAAP,KACA,CADA,YAEC,CAAC3K,MAAM,CAAC2K,YAAP,EAAD,GAAyBlU,IAAI,CAACigB,cAA9B,GAA+ChF,IAFhD,EAEyDqF,eAFzD,CADF;EAIH,GAPD,MAOO,IAAIrF,IAAI,GAAG,CAAP,IAAYjb,IAAI,CAAC6W,gBAAL,GAAwBtN,MAAM,CAACoL,YAAP,EAAxC,EAA+D;EACpE0L,IAAAA,mBAAmB,GAAG,KAAtB;EACA,QAAI3V,MAAM,CAAC6V,UAAX,EACEvgB,IAAI,CAAC6W,gBAAL,GACEtN,MAAM,CAACoL,YAAP,KACA,CADA,YAECpL,MAAM,CAACoL,YAAP,KAAwB3U,IAAI,CAACigB,cAA7B,GAA8ChF,IAF/C,EAEwDqF,eAFxD,CADF;EAIH;;EAED,MAAID,mBAAJ,EAAyB;EACvB1oB,IAAAA,CAAC,CAAC2nB,uBAAF,GAA4B,IAA5B;EACD,GAtKwC;;;EAyKzC,MACE,CAAC/V,MAAM,CAACsP,cAAR,IACAtP,MAAM,CAACoV,cAAP,KAA0B,MAD1B,IAEA3e,IAAI,CAAC6W,gBAAL,GAAwB7W,IAAI,CAACigB,cAH/B,EAIE;EACAjgB,IAAAA,IAAI,CAAC6W,gBAAL,GAAwB7W,IAAI,CAACigB,cAA7B;EACD;;EACD,MACE,CAAC1W,MAAM,CAACuP,cAAR,IACAvP,MAAM,CAACoV,cAAP,KAA0B,MAD1B,IAEA3e,IAAI,CAAC6W,gBAAL,GAAwB7W,IAAI,CAACigB,cAH/B,EAIE;EACAjgB,IAAAA,IAAI,CAAC6W,gBAAL,GAAwB7W,IAAI,CAACigB,cAA7B;EACD;;EACD,MAAI,CAAC1W,MAAM,CAACuP,cAAR,IAA0B,CAACvP,MAAM,CAACsP,cAAtC,EAAsD;EACpD7Y,IAAAA,IAAI,CAAC6W,gBAAL,GAAwB7W,IAAI,CAACigB,cAA7B;EACD,GAzLwC;;;EA4LzC,MAAIvV,MAAM,CAACwP,SAAP,GAAmB,CAAvB,EAA0B;EACxB,QAAI9J,IAAI,CAAC4B,GAAL,CAASiJ,IAAT,IAAiBvQ,MAAM,CAACwP,SAAxB,IAAqCla,IAAI,CAAC4e,kBAA9C,EAAkE;EAChE,UAAI,CAAC5e,IAAI,CAAC4e,kBAAV,EAA8B;EAC5B5e,QAAAA,IAAI,CAAC4e,kBAAL,GAA0B,IAA1B;EACApC,QAAAA,OAAO,CAACuB,MAAR,GAAiBvB,OAAO,CAACkB,QAAzB;EACAlB,QAAAA,OAAO,CAACwB,MAAR,GAAiBxB,OAAO,CAACqB,QAAzB;EACA7d,QAAAA,IAAI,CAAC6W,gBAAL,GAAwB7W,IAAI,CAACigB,cAA7B;EACAzD,QAAAA,OAAO,CAACvB,IAAR,GAAe1R,MAAM,CAAC+D,YAAP,KACXkP,OAAO,CAACkB,QAAR,GAAmBlB,OAAO,CAACuB,MADhB,GAEXvB,OAAO,CAACqB,QAAR,GAAmBrB,OAAO,CAACwB,MAF/B;EAGA;EACD;EACF,KAXD,MAWO;EACLhe,MAAAA,IAAI,CAAC6W,gBAAL,GAAwB7W,IAAI,CAACigB,cAA7B;EACA;EACD;EACF;;EAED,MAAI,CAACvV,MAAM,CAAC8V,YAAR,IAAwB9V,MAAM,CAACyE,OAAnC,EAA4C,OA9MH;;EAiNzC,MAAIzE,MAAM,CAAC+V,QAAP,IAAmB/V,MAAM,CAACsI,mBAA1B,IAAiDtI,MAAM,CAACuI,qBAA5D,EAAmF;EACjF1J,IAAAA,MAAM,CAACuM,iBAAP;EACAvM,IAAAA,MAAM,CAACyL,mBAAP;EACD;;EACD,MAAItK,MAAM,CAAC+V,QAAX,EAAqB;EACnB;EACA,QAAIzgB,IAAI,CAAC0gB,UAAL,CAAgB3tB,MAAhB,KAA2B,CAA/B,EAAkC;EAChCiN,MAAAA,IAAI,CAAC0gB,UAAL,CAAgBzoB,IAAhB,CAAqB;EACnB0oB,QAAAA,QAAQ,EAAEnE,OAAO,CAACjT,MAAM,CAAC+D,YAAP,KAAwB,QAAxB,GAAmC,QAApC,CADE;EAEnBsT,QAAAA,IAAI,EAAE5gB,IAAI,CAAC0e;EAFQ,OAArB;EAID;;EACD1e,IAAAA,IAAI,CAAC0gB,UAAL,CAAgBzoB,IAAhB,CAAqB;EACnB0oB,MAAAA,QAAQ,EAAEnE,OAAO,CAACjT,MAAM,CAAC+D,YAAP,KAAwB,UAAxB,GAAqC,UAAtC,CADE;EAEnBsT,MAAAA,IAAI,EAAEnc,GAAG;EAFU,KAArB;EAID,GAjOwC;;;EAmOzC8E,EAAAA,MAAM,CAACiL,cAAP,CAAsBxU,IAAI,CAAC6W,gBAA3B,EAnOyC;;EAqOzCtN,EAAAA,MAAM,CAACuN,YAAP,CAAoB9W,IAAI,CAAC6W,gBAAzB;EACD;;ECxOc,SAASgK,UAAT,CAAoBhiB,KAApB,EAA2B;EACxC,MAAM0K,MAAM,GAAG,IAAf;EACA,MAAMvJ,IAAI,GAAGuJ,MAAM,CAACgT,eAApB;EAFwC,MAIhC7R,MAJgC,GAIyCnB,MAJzC,CAIhCmB,MAJgC;EAAA,MAIxB8R,OAJwB,GAIyCjT,MAJzC,CAIxBiT,OAJwB;EAAA,MAIDrO,GAJC,GAIyC5E,MAJzC,CAIf6E,YAJe;EAAA,MAIIvC,UAJJ,GAIyCtC,MAJzC,CAIIsC,UAJJ;EAAA,MAIgBiD,UAJhB,GAIyCvF,MAJzC,CAIgBuF,UAJhB;EAAA,MAI4BD,QAJ5B,GAIyCtF,MAJzC,CAI4BsF,QAJ5B;EAKxC,MAAIlX,CAAC,GAAGkH,KAAR;EACA,MAAIlH,CAAC,CAAC8kB,aAAN,EAAqB9kB,CAAC,GAAGA,CAAC,CAAC8kB,aAAN;;EACrB,MAAIzc,IAAI,CAACue,mBAAT,EAA8B;EAC5BhV,IAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ,EAAwB5S,CAAxB;EACD;;EACDqI,EAAAA,IAAI,CAACue,mBAAL,GAA2B,KAA3B;;EACA,MAAI,CAACve,IAAI,CAACgd,SAAV,EAAqB;EACnB,QAAIhd,IAAI,CAACid,OAAL,IAAgBvS,MAAM,CAACyV,UAA3B,EAAuC;EACrC5W,MAAAA,MAAM,CAAC6R,aAAP,CAAqB,KAArB;EACD;;EACDpb,IAAAA,IAAI,CAACid,OAAL,GAAe,KAAf;EACAjd,IAAAA,IAAI,CAACye,WAAL,GAAmB,KAAnB;EACA;EACD,GAlBuC;;;EAoBxC,MACE/T,MAAM,CAACyV,UAAP,IACAngB,IAAI,CAACid,OADL,IAEAjd,IAAI,CAACgd,SAFL,KAGCzT,MAAM,CAACsP,cAAP,KAA0B,IAA1B,IAAkCtP,MAAM,CAACuP,cAAP,KAA0B,IAH7D,CADF,EAKE;EACAvP,IAAAA,MAAM,CAAC6R,aAAP,CAAqB,KAArB;EACD,GA3BuC;;;EA8BxC,MAAM0F,YAAY,GAAGrc,GAAG,EAAxB;EACA,MAAMsc,QAAQ,GAAGD,YAAY,GAAG9gB,IAAI,CAAC0e,cAArC,CA/BwC;;EAkCxC,MAAInV,MAAM,CAACiU,UAAX,EAAuB;EACrBjU,IAAAA,MAAM,CAAC+M,kBAAP,CAA0B3e,CAA1B;EACA4R,IAAAA,MAAM,CAACgB,IAAP,CAAY,WAAZ,EAAyB5S,CAAzB;;EACA,QAAIopB,QAAQ,GAAG,GAAX,IAAkBD,YAAY,GAAG9gB,IAAI,CAACghB,aAApB,GAAoC,GAA1D,EAA+D;EAC7DzX,MAAAA,MAAM,CAACgB,IAAP,CAAY,uBAAZ,EAAqC5S,CAArC;EACD;EACF;;EAEDqI,EAAAA,IAAI,CAACghB,aAAL,GAAqBvc,GAAG,EAAxB;EACAF,EAAAA,QAAQ,CAAC,YAAM;EACb,QAAI,CAACgF,MAAM,CAACG,SAAZ,EAAuBH,MAAM,CAACiU,UAAP,GAAoB,IAApB;EACxB,GAFO,CAAR;;EAIA,MACE,CAACxd,IAAI,CAACgd,SAAN,IACA,CAAChd,IAAI,CAACid,OADN,IAEA,CAAC1T,MAAM,CAACoV,cAFR,IAGAnC,OAAO,CAACvB,IAAR,KAAiB,CAHjB,IAIAjb,IAAI,CAAC6W,gBAAL,KAA0B7W,IAAI,CAACigB,cALjC,EAME;EACAjgB,IAAAA,IAAI,CAACgd,SAAL,GAAiB,KAAjB;EACAhd,IAAAA,IAAI,CAACid,OAAL,GAAe,KAAf;EACAjd,IAAAA,IAAI,CAACye,WAAL,GAAmB,KAAnB;EACA;EACD;;EACDze,EAAAA,IAAI,CAACgd,SAAL,GAAiB,KAAjB;EACAhd,EAAAA,IAAI,CAACid,OAAL,GAAe,KAAf;EACAjd,EAAAA,IAAI,CAACye,WAAL,GAAmB,KAAnB;EAEA,MAAIwC,UAAJ;;EACA,MAAIvW,MAAM,CAAC8V,YAAX,EAAyB;EACvBS,IAAAA,UAAU,GAAG9S,GAAG,GAAG5E,MAAM,CAACsK,SAAV,GAAsB,CAACtK,MAAM,CAACsK,SAA9C;EACD,GAFD,MAEO;EACLoN,IAAAA,UAAU,GAAG,CAACjhB,IAAI,CAAC6W,gBAAnB;EACD;;EAED,MAAInM,MAAM,CAACyE,OAAX,EAAoB;EAClB;EACD;;EAED,MAAIzE,MAAM,CAAC+V,QAAX,EAAqB;EACnB,QAAIQ,UAAU,GAAG,CAAC1X,MAAM,CAAC2K,YAAP,EAAlB,EAAyC;EACvC3K,MAAAA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACiK,WAAtB;EACA;EACD;;EACD,QAAIyN,UAAU,GAAG,CAAC1X,MAAM,CAACoL,YAAP,EAAlB,EAAyC;EACvC,UAAIpL,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuB8b,QAAQ,CAAC9b,MAApC,EAA4C;EAC1CwW,QAAAA,MAAM,CAAC6O,OAAP,CAAevJ,QAAQ,CAAC9b,MAAT,GAAkB,CAAjC;EACD,OAFD,MAEO;EACLwW,QAAAA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuB,CAAtC;EACD;;EACD;EACD;;EAED,QAAI2X,MAAM,CAACwW,gBAAX,EAA6B;EAC3B,UAAIlhB,IAAI,CAAC0gB,UAAL,CAAgB3tB,MAAhB,GAAyB,CAA7B,EAAgC;EAC9B,YAAMouB,aAAa,GAAGnhB,IAAI,CAAC0gB,UAAL,CAAgBU,GAAhB,EAAtB;EACA,YAAMC,aAAa,GAAGrhB,IAAI,CAAC0gB,UAAL,CAAgBU,GAAhB,EAAtB;EAEA,YAAME,QAAQ,GAAGH,aAAa,CAACR,QAAd,GAAyBU,aAAa,CAACV,QAAxD;EACA,YAAMC,IAAI,GAAGO,aAAa,CAACP,IAAd,GAAqBS,aAAa,CAACT,IAAhD;EACArX,QAAAA,MAAM,CAACgY,QAAP,GAAkBD,QAAQ,GAAGV,IAA7B;EACArX,QAAAA,MAAM,CAACgY,QAAP,IAAmB,CAAnB;;EACA,YAAInR,IAAI,CAAC4B,GAAL,CAASzI,MAAM,CAACgY,QAAhB,IAA4B7W,MAAM,CAAC8W,uBAAvC,EAAgE;EAC9DjY,UAAAA,MAAM,CAACgY,QAAP,GAAkB,CAAlB;EACD,SAV6B;EAY9B;;;EACA,YAAIX,IAAI,GAAG,GAAP,IAAcnc,GAAG,KAAK0c,aAAa,CAACP,IAAtB,GAA6B,GAA/C,EAAoD;EAClDrX,UAAAA,MAAM,CAACgY,QAAP,GAAkB,CAAlB;EACD;EACF,OAhBD,MAgBO;EACLhY,QAAAA,MAAM,CAACgY,QAAP,GAAkB,CAAlB;EACD;;EACDhY,MAAAA,MAAM,CAACgY,QAAP,IAAmB7W,MAAM,CAAC+W,6BAA1B;EAEAzhB,MAAAA,IAAI,CAAC0gB,UAAL,CAAgB3tB,MAAhB,GAAyB,CAAzB;EACA,UAAI2uB,gBAAgB,GAAG,OAAOhX,MAAM,CAACiX,qBAArC;EACA,UAAMC,gBAAgB,GAAGrY,MAAM,CAACgY,QAAP,GAAkBG,gBAA3C;EAEA,UAAIG,WAAW,GAAGtY,MAAM,CAACsK,SAAP,GAAmB+N,gBAArC;EACA,UAAIzT,GAAJ,EAAS0T,WAAW,GAAG,CAACA,WAAf;EAET,UAAIC,QAAQ,GAAG,KAAf;EACA,UAAIC,mBAAJ;EACA,UAAMC,YAAY,GAAG5R,IAAI,CAAC4B,GAAL,CAASzI,MAAM,CAACgY,QAAhB,IAA4B,EAA5B,GAAiC7W,MAAM,CAACuX,2BAA7D;EACA,UAAIC,YAAJ;;EACA,UAAIL,WAAW,GAAGtY,MAAM,CAACoL,YAAP,EAAlB,EAAyC;EACvC,YAAIjK,MAAM,CAACyX,sBAAX,EAAmC;EACjC,cAAIN,WAAW,GAAGtY,MAAM,CAACoL,YAAP,EAAd,GAAsC,CAACqN,YAA3C,EAAyD;EACvDH,YAAAA,WAAW,GAAGtY,MAAM,CAACoL,YAAP,KAAwBqN,YAAtC;EACD;;EACDD,UAAAA,mBAAmB,GAAGxY,MAAM,CAACoL,YAAP,EAAtB;EACAmN,UAAAA,QAAQ,GAAG,IAAX;EACA9hB,UAAAA,IAAI,CAACkgB,mBAAL,GAA2B,IAA3B;EACD,SAPD,MAOO;EACL2B,UAAAA,WAAW,GAAGtY,MAAM,CAACoL,YAAP,EAAd;EACD;;EACD,YAAIjK,MAAM,CAAC+K,IAAP,IAAe/K,MAAM,CAACqH,cAA1B,EAA0CmQ,YAAY,GAAG,IAAf;EAC3C,OAZD,MAYO,IAAIL,WAAW,GAAGtY,MAAM,CAAC2K,YAAP,EAAlB,EAAyC;EAC9C,YAAIxJ,MAAM,CAACyX,sBAAX,EAAmC;EACjC,cAAIN,WAAW,GAAGtY,MAAM,CAAC2K,YAAP,EAAd,GAAsC8N,YAA1C,EAAwD;EACtDH,YAAAA,WAAW,GAAGtY,MAAM,CAAC2K,YAAP,KAAwB8N,YAAtC;EACD;;EACDD,UAAAA,mBAAmB,GAAGxY,MAAM,CAAC2K,YAAP,EAAtB;EACA4N,UAAAA,QAAQ,GAAG,IAAX;EACA9hB,UAAAA,IAAI,CAACkgB,mBAAL,GAA2B,IAA3B;EACD,SAPD,MAOO;EACL2B,UAAAA,WAAW,GAAGtY,MAAM,CAAC2K,YAAP,EAAd;EACD;;EACD,YAAIxJ,MAAM,CAAC+K,IAAP,IAAe/K,MAAM,CAACqH,cAA1B,EAA0CmQ,YAAY,GAAG,IAAf;EAC3C,OAZM,MAYA,IAAIxX,MAAM,CAAC0X,cAAX,EAA2B;EAChC,YAAIzM,SAAJ;;EACA,aAAK,IAAI/W,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGiQ,QAAQ,CAAC9b,MAA7B,EAAqC6L,CAAC,IAAI,CAA1C,EAA6C;EAC3C,cAAIiQ,QAAQ,CAACjQ,CAAD,CAAR,GAAc,CAACijB,WAAnB,EAAgC;EAC9BlM,YAAAA,SAAS,GAAG/W,CAAZ;EACA;EACD;EACF;;EAED,YACEwR,IAAI,CAAC4B,GAAL,CAASnD,QAAQ,CAAC8G,SAAD,CAAR,GAAsBkM,WAA/B,IACEzR,IAAI,CAAC4B,GAAL,CAASnD,QAAQ,CAAC8G,SAAS,GAAG,CAAb,CAAR,GAA0BkM,WAAnC,CADF,IAEAtY,MAAM,CAACoV,cAAP,KAA0B,MAH5B,EAIE;EACAkD,UAAAA,WAAW,GAAGhT,QAAQ,CAAC8G,SAAD,CAAtB;EACD,SAND,MAMO;EACLkM,UAAAA,WAAW,GAAGhT,QAAQ,CAAC8G,SAAS,GAAG,CAAb,CAAtB;EACD;;EACDkM,QAAAA,WAAW,GAAG,CAACA,WAAf;EACD;;EACD,UAAIK,YAAJ,EAAkB;EAChB3Y,QAAAA,MAAM,CAACoD,IAAP,CAAY,eAAZ,EAA6B,YAAM;EACjCpD,UAAAA,MAAM,CAACiQ,OAAP;EACD,SAFD;EAGD,OAjF0B;;;EAmF3B,UAAIjQ,MAAM,CAACgY,QAAP,KAAoB,CAAxB,EAA2B;EACzB,YAAIpT,GAAJ,EAAS;EACPuT,UAAAA,gBAAgB,GAAGtR,IAAI,CAAC4B,GAAL,CAAS,CAAC,CAAC6P,WAAD,GAAetY,MAAM,CAACsK,SAAvB,IAAoCtK,MAAM,CAACgY,QAApD,CAAnB;EACD,SAFD,MAEO;EACLG,UAAAA,gBAAgB,GAAGtR,IAAI,CAAC4B,GAAL,CAAS,CAAC6P,WAAW,GAAGtY,MAAM,CAACsK,SAAtB,IAAmCtK,MAAM,CAACgY,QAAnD,CAAnB;EACD;;EACD,YAAI7W,MAAM,CAAC0X,cAAX,EAA2B;EACzB;EACA;EACA;EACA;EACA;EACA;EACA;EACA,cAAMC,YAAY,GAAGjS,IAAI,CAAC4B,GAAL,CAAS,CAAC7D,GAAG,GAAG,CAAC0T,WAAJ,GAAkBA,WAAtB,IAAqCtY,MAAM,CAACsK,SAArD,CAArB;EACA,cAAMyO,gBAAgB,GAAG/Y,MAAM,CAACwF,eAAP,CAAuBxF,MAAM,CAACiK,WAA9B,CAAzB;;EACA,cAAI6O,YAAY,GAAGC,gBAAnB,EAAqC;EACnCZ,YAAAA,gBAAgB,GAAGhX,MAAM,CAAC0I,KAA1B;EACD,WAFD,MAEO,IAAIiP,YAAY,GAAG,IAAIC,gBAAvB,EAAyC;EAC9CZ,YAAAA,gBAAgB,GAAGhX,MAAM,CAAC0I,KAAP,GAAe,GAAlC;EACD,WAFM,MAEA;EACLsO,YAAAA,gBAAgB,GAAGhX,MAAM,CAAC0I,KAAP,GAAe,GAAlC;EACD;EACF;EACF,OAxBD,MAwBO,IAAI1I,MAAM,CAAC0X,cAAX,EAA2B;EAChC7Y,QAAAA,MAAM,CAAC0Q,cAAP;EACA;EACD;;EAED,UAAIvP,MAAM,CAACyX,sBAAP,IAAiCL,QAArC,EAA+C;EAC7CvY,QAAAA,MAAM,CAACiL,cAAP,CAAsBuN,mBAAtB;EACAxY,QAAAA,MAAM,CAAC+J,aAAP,CAAqBoO,gBAArB;EACAnY,QAAAA,MAAM,CAACuN,YAAP,CAAoB+K,WAApB;EACAtY,QAAAA,MAAM,CAAC0O,eAAP,CAAuB,IAAvB,EAA6B1O,MAAM,CAACoV,cAApC;EACApV,QAAAA,MAAM,CAACmO,SAAP,GAAmB,IAAnB;EACA7L,QAAAA,UAAU,CAAC1L,aAAX,CAAyB,YAAM;EAC7B,cAAI,CAACoJ,MAAD,IAAWA,MAAM,CAACG,SAAlB,IAA+B,CAAC1J,IAAI,CAACkgB,mBAAzC,EAA8D;EAC9D3W,UAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ;EACAhB,UAAAA,MAAM,CAAC+J,aAAP,CAAqB5I,MAAM,CAAC0I,KAA5B;EACAtd,UAAAA,UAAU,CAAC,YAAM;EACfyT,YAAAA,MAAM,CAACuN,YAAP,CAAoBiL,mBAApB;EACAlW,YAAAA,UAAU,CAAC1L,aAAX,CAAyB,YAAM;EAC7B,kBAAI,CAACoJ,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC;EACjCH,cAAAA,MAAM,CAACpJ,aAAP;EACD,aAHD;EAID,WANS,EAMP,CANO,CAAV;EAOD,SAXD;EAYD,OAlBD,MAkBO,IAAIoJ,MAAM,CAACgY,QAAX,EAAqB;EAC1BhY,QAAAA,MAAM,CAACiL,cAAP,CAAsBqN,WAAtB;EACAtY,QAAAA,MAAM,CAAC+J,aAAP,CAAqBoO,gBAArB;EACAnY,QAAAA,MAAM,CAACuN,YAAP,CAAoB+K,WAApB;EACAtY,QAAAA,MAAM,CAAC0O,eAAP,CAAuB,IAAvB,EAA6B1O,MAAM,CAACoV,cAApC;;EACA,YAAI,CAACpV,MAAM,CAACmO,SAAZ,EAAuB;EACrBnO,UAAAA,MAAM,CAACmO,SAAP,GAAmB,IAAnB;EACA7L,UAAAA,UAAU,CAAC1L,aAAX,CAAyB,YAAM;EAC7B,gBAAI,CAACoJ,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC;EACjCH,YAAAA,MAAM,CAACpJ,aAAP;EACD,WAHD;EAID;EACF,OAZM,MAYA;EACLoJ,QAAAA,MAAM,CAACgB,IAAP,CAAY,4BAAZ;EACAhB,QAAAA,MAAM,CAACiL,cAAP,CAAsBqN,WAAtB;EACD;;EAEDtY,MAAAA,MAAM,CAACuM,iBAAP;EACAvM,MAAAA,MAAM,CAACyL,mBAAP;EACD,KArJD,MAqJO,IAAItK,MAAM,CAAC0X,cAAX,EAA2B;EAChC7Y,MAAAA,MAAM,CAAC0Q,cAAP;EACA;EACD,KAHM,MAGA,IAAIvP,MAAM,CAAC+V,QAAX,EAAqB;EAC1BlX,MAAAA,MAAM,CAACgB,IAAP,CAAY,4BAAZ;EACD;;EAED,QAAI,CAACG,MAAM,CAACwW,gBAAR,IAA4BH,QAAQ,IAAIrW,MAAM,CAAC6X,YAAnD,EAAiE;EAC/DhZ,MAAAA,MAAM,CAACiL,cAAP;EACAjL,MAAAA,MAAM,CAACuM,iBAAP;EACAvM,MAAAA,MAAM,CAACyL,mBAAP;EACD;;EACD;EACD,GA1PuC;;;EA6PxC,MAAIwN,SAAS,GAAG,CAAhB;EACA,MAAIC,SAAS,GAAGlZ,MAAM,CAACwF,eAAP,CAAuB,CAAvB,CAAhB;;EACA,OACE,IAAIlU,CAAC,GAAG,CADV,EAEEA,CAAC,GAAGiU,UAAU,CAAC/b,MAFjB,EAGE8H,CAAC,IAAIA,CAAC,GAAG6P,MAAM,CAACuH,kBAAX,GAAgC,CAAhC,GAAoCvH,MAAM,CAACuG,cAHlD,EAIE;EACA,QAAMqI,UAAS,GAAGze,CAAC,GAAG6P,MAAM,CAACuH,kBAAP,GAA4B,CAAhC,GAAoC,CAApC,GAAwCvH,MAAM,CAACuG,cAAjE;;EACA,QAAI,OAAOnC,UAAU,CAACjU,CAAC,GAAGye,UAAL,CAAjB,KAAqC,WAAzC,EAAsD;EACpD,UAAI2H,UAAU,IAAInS,UAAU,CAACjU,CAAD,CAAxB,IAA+BomB,UAAU,GAAGnS,UAAU,CAACjU,CAAC,GAAGye,UAAL,CAA1D,EAA2E;EACzEkJ,QAAAA,SAAS,GAAG3nB,CAAZ;EACA4nB,QAAAA,SAAS,GAAG3T,UAAU,CAACjU,CAAC,GAAGye,UAAL,CAAV,GAA4BxK,UAAU,CAACjU,CAAD,CAAlD;EACD;EACF,KALD,MAKO,IAAIomB,UAAU,IAAInS,UAAU,CAACjU,CAAD,CAA5B,EAAiC;EACtC2nB,MAAAA,SAAS,GAAG3nB,CAAZ;EACA4nB,MAAAA,SAAS,GAAG3T,UAAU,CAACA,UAAU,CAAC/b,MAAX,GAAoB,CAArB,CAAV,GAAoC+b,UAAU,CAACA,UAAU,CAAC/b,MAAX,GAAoB,CAArB,CAA1D;EACD;EACF,GA9QuC;;;EAiRxC,MAAM2vB,KAAK,GAAG,CAACzB,UAAU,GAAGnS,UAAU,CAAC0T,SAAD,CAAxB,IAAuCC,SAArD;EACA,MAAMnJ,SAAS,GAAGkJ,SAAS,GAAG9X,MAAM,CAACuH,kBAAP,GAA4B,CAAxC,GAA4C,CAA5C,GAAgDvH,MAAM,CAACuG,cAAzE;;EAEA,MAAI8P,QAAQ,GAAGrW,MAAM,CAAC6X,YAAtB,EAAoC;EAClC;EACA,QAAI,CAAC7X,MAAM,CAACiY,UAAZ,EAAwB;EACtBpZ,MAAAA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACiK,WAAtB;EACA;EACD;;EACD,QAAIjK,MAAM,CAACoV,cAAP,KAA0B,MAA9B,EAAsC;EACpC,UAAI+D,KAAK,IAAIhY,MAAM,CAACkY,eAApB,EAAqCrZ,MAAM,CAAC6O,OAAP,CAAeoK,SAAS,GAAGlJ,SAA3B,EAArC,KACK/P,MAAM,CAAC6O,OAAP,CAAeoK,SAAf;EACN;;EACD,QAAIjZ,MAAM,CAACoV,cAAP,KAA0B,MAA9B,EAAsC;EACpC,UAAI+D,KAAK,GAAG,IAAIhY,MAAM,CAACkY,eAAvB,EAAwCrZ,MAAM,CAAC6O,OAAP,CAAeoK,SAAS,GAAGlJ,SAA3B,EAAxC,KACK/P,MAAM,CAAC6O,OAAP,CAAeoK,SAAf;EACN;EACF,GAdD,MAcO;EACL;EACA,QAAI,CAAC9X,MAAM,CAACmY,WAAZ,EAAyB;EACvBtZ,MAAAA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACiK,WAAtB;EACA;EACD;;EACD,QAAMsP,iBAAiB,GACrBvZ,MAAM,CAACwZ,UAAP,KACCprB,CAAC,CAACjF,MAAF,KAAa6W,MAAM,CAACwZ,UAAP,CAAkBC,MAA/B,IAAyCrrB,CAAC,CAACjF,MAAF,KAAa6W,MAAM,CAACwZ,UAAP,CAAkBE,MADzE,CADF;;EAGA,QAAI,CAACH,iBAAL,EAAwB;EACtB,UAAIvZ,MAAM,CAACoV,cAAP,KAA0B,MAA9B,EAAsC;EACpCpV,QAAAA,MAAM,CAAC6O,OAAP,CAAeoK,SAAS,GAAGlJ,SAA3B;EACD;;EACD,UAAI/P,MAAM,CAACoV,cAAP,KAA0B,MAA9B,EAAsC;EACpCpV,QAAAA,MAAM,CAAC6O,OAAP,CAAeoK,SAAf;EACD;EACF,KAPD,MAOO,IAAI7qB,CAAC,CAACjF,MAAF,KAAa6W,MAAM,CAACwZ,UAAP,CAAkBC,MAAnC,EAA2C;EAChDzZ,MAAAA,MAAM,CAAC6O,OAAP,CAAeoK,SAAS,GAAGlJ,SAA3B;EACD,KAFM,MAEA;EACL/P,MAAAA,MAAM,CAAC6O,OAAP,CAAeoK,SAAf;EACD;EACF;EACF;;EC1Tc,SAASU,QAAT,GAAoB;EACjC,MAAM3Z,MAAM,GAAG,IAAf;EADiC,MAGzBmB,MAHyB,GAGVnB,MAHU,CAGzBmB,MAHyB;EAAA,MAGjBnQ,EAHiB,GAGVgP,MAHU,CAGjBhP,EAHiB;EAKjC,MAAIA,EAAE,IAAIA,EAAE,CAACmG,WAAH,KAAmB,CAA7B,EAAgC,OALC;;EAQjC,MAAIgK,MAAM,CAACyY,WAAX,EAAwB;EACtB5Z,IAAAA,MAAM,CAAC6Z,aAAP;EACD,GAVgC;;;EAAA,MAazBvK,cAbyB,GAaoBtP,MAbpB,CAazBsP,cAbyB;EAAA,MAaTC,cAbS,GAaoBvP,MAbpB,CAaTuP,cAbS;EAAA,MAaOjK,QAbP,GAaoBtF,MAbpB,CAaOsF,QAbP;;EAgBjCtF,EAAAA,MAAM,CAACsP,cAAP,GAAwB,IAAxB;EACAtP,EAAAA,MAAM,CAACuP,cAAP,GAAwB,IAAxB;EAEAvP,EAAAA,MAAM,CAAC4D,UAAP;EACA5D,EAAAA,MAAM,CAACqE,YAAP;EAEArE,EAAAA,MAAM,CAACyL,mBAAP;;EACA,MACE,CAACtK,MAAM,CAAC6F,aAAP,KAAyB,MAAzB,IAAmC7F,MAAM,CAAC6F,aAAP,GAAuB,CAA3D,KACAhH,MAAM,CAACsL,KADP,IAEA,CAACtL,MAAM,CAACqL,WAFR,IAGA,CAACrL,MAAM,CAACmB,MAAP,CAAcqH,cAJjB,EAKE;EACAxI,IAAAA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuB,CAAtC,EAAyC,CAAzC,EAA4C,KAA5C,EAAmD,IAAnD;EACD,GAPD,MAOO;EACLwW,IAAAA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACiK,WAAtB,EAAmC,CAAnC,EAAsC,KAAtC,EAA6C,IAA7C;EACD;;EAED,MAAIjK,MAAM,CAAC8Z,QAAP,IAAmB9Z,MAAM,CAAC8Z,QAAP,CAAgBC,OAAnC,IAA8C/Z,MAAM,CAAC8Z,QAAP,CAAgBE,MAAlE,EAA0E;EACxEha,IAAAA,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB;EACD,GApCgC;;;EAsCjCja,EAAAA,MAAM,CAACuP,cAAP,GAAwBA,cAAxB;EACAvP,EAAAA,MAAM,CAACsP,cAAP,GAAwBA,cAAxB;;EAEA,MAAItP,MAAM,CAACmB,MAAP,CAAcoI,aAAd,IAA+BjE,QAAQ,KAAKtF,MAAM,CAACsF,QAAvD,EAAiE;EAC/DtF,IAAAA,MAAM,CAACwJ,aAAP;EACD;EACF;;EC5Cc,SAAS0Q,OAAT,CAAiB9rB,CAAjB,EAAoB;EACjC,MAAM4R,MAAM,GAAG,IAAf;;EACA,MAAI,CAACA,MAAM,CAACiU,UAAZ,EAAwB;EACtB,QAAIjU,MAAM,CAACmB,MAAP,CAAcgZ,aAAlB,EAAiC/rB,CAAC,CAAC2mB,cAAF;;EACjC,QAAI/U,MAAM,CAACmB,MAAP,CAAciZ,wBAAd,IAA0Cpa,MAAM,CAACmO,SAArD,EAAgE;EAC9D/f,MAAAA,CAAC,CAACqoB,eAAF;EACAroB,MAAAA,CAAC,CAACisB,wBAAF;EACD;EACF;EACF;;ECTc,SAASC,QAAT,GAAoB;EACjC,MAAMta,MAAM,GAAG,IAAf;EADiC,MAEzByN,SAFyB,GAEGzN,MAFH,CAEzByN,SAFyB;EAAA,MAEd5I,YAFc,GAEG7E,MAFH,CAEd6E,YAFc;EAGjC7E,EAAAA,MAAM,CAAC6N,iBAAP,GAA2B7N,MAAM,CAACsK,SAAlC;;EACA,MAAItK,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB,QAAIc,YAAJ,EAAkB;EAChB7E,MAAAA,MAAM,CAACsK,SAAP,GAAmBmD,SAAS,CAACgC,WAAV,GAAwBhC,SAAS,CAACtW,WAAlC,GAAgDsW,SAAS,CAAC1V,UAA7E;EACD,KAFD,MAEO;EACLiI,MAAAA,MAAM,CAACsK,SAAP,GAAmB,CAACmD,SAAS,CAAC1V,UAA9B;EACD;EACF,GAND,MAMO;EACLiI,IAAAA,MAAM,CAACsK,SAAP,GAAmB,CAACmD,SAAS,CAAC5V,SAA9B;EACD,GAZgC;;;EAcjC,MAAImI,MAAM,CAACsK,SAAP,KAAqB,CAAC,CAA1B,EAA6BtK,MAAM,CAACsK,SAAP,GAAmB,CAAnB;EAE7BtK,EAAAA,MAAM,CAACuM,iBAAP;EACAvM,EAAAA,MAAM,CAACyL,mBAAP;EAEA,MAAIqC,WAAJ;EACA,MAAM3C,cAAc,GAAGnL,MAAM,CAACoL,YAAP,KAAwBpL,MAAM,CAAC2K,YAAP,EAA/C;;EACA,MAAIQ,cAAc,KAAK,CAAvB,EAA0B;EACxB2C,IAAAA,WAAW,GAAG,CAAd;EACD,GAFD,MAEO;EACLA,IAAAA,WAAW,GAAG,CAAC9N,MAAM,CAACsK,SAAP,GAAmBtK,MAAM,CAAC2K,YAAP,EAApB,IAA6CQ,cAA3D;EACD;;EACD,MAAI2C,WAAW,KAAK9N,MAAM,CAACgL,QAA3B,EAAqC;EACnChL,IAAAA,MAAM,CAACiL,cAAP,CAAsBpG,YAAY,GAAG,CAAC7E,MAAM,CAACsK,SAAX,GAAuBtK,MAAM,CAACsK,SAAhE;EACD;;EAEDtK,EAAAA,MAAM,CAACgB,IAAP,CAAY,cAAZ,EAA4BhB,MAAM,CAACsK,SAAnC,EAA8C,KAA9C;EACD;;ECtBD,IAAIiQ,kBAAkB,GAAG,KAAzB;;EACA,SAASC,kBAAT,GAA8B;;EAE9B,SAASC,YAAT,GAAwB;EACtB,MAAMza,MAAM,GAAG,IAAf;EACA,MAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EAFsB,MAGd6V,MAHc,GAG0CnB,MAH1C,CAGdmB,MAHc;EAAA,MAGNuZ,WAHM,GAG0C1a,MAH1C,CAGN0a,WAHM;EAAA,MAGO1pB,EAHP,GAG0CgP,MAH1C,CAGOhP,EAHP;EAAA,MAGWyc,SAHX,GAG0CzN,MAH1C,CAGWyN,SAHX;EAAA,MAGsBxP,MAHtB,GAG0C+B,MAH1C,CAGsB/B,MAHtB;EAAA,MAG8BhB,OAH9B,GAG0C+C,MAH1C,CAG8B/C,OAH9B;EAKtB+C,EAAAA,MAAM,CAAC+S,YAAP,GAAsBA,YAAY,CAACjkB,IAAb,CAAkBkR,MAAlB,CAAtB;EACAA,EAAAA,MAAM,CAAC4V,WAAP,GAAqBA,WAAW,CAAC9mB,IAAZ,CAAiBkR,MAAjB,CAArB;EACAA,EAAAA,MAAM,CAACsX,UAAP,GAAoBA,UAAU,CAACxoB,IAAX,CAAgBkR,MAAhB,CAApB;;EACA,MAAImB,MAAM,CAACyE,OAAX,EAAoB;EAClB5F,IAAAA,MAAM,CAACsa,QAAP,GAAkBA,QAAQ,CAACxrB,IAAT,CAAckR,MAAd,CAAlB;EACD;;EAEDA,EAAAA,MAAM,CAACka,OAAP,GAAiBA,OAAO,CAACprB,IAAR,CAAakR,MAAb,CAAjB;EAEA,MAAMtL,OAAO,GAAG,CAAC,CAACyM,MAAM,CAACqV,MAAzB,CAdsB;;EAiBtB,MAAI,CAACvZ,OAAO,CAACE,KAAT,IAAkBF,OAAO,CAACI,aAA9B,EAA6C;EAC3CrM,IAAAA,EAAE,CAACrH,gBAAH,CAAoB+wB,WAAW,CAACC,KAAhC,EAAuC3a,MAAM,CAAC+S,YAA9C,EAA4D,KAA5D;EACAvnB,IAAAA,QAAQ,CAAC7B,gBAAT,CAA0B+wB,WAAW,CAACE,IAAtC,EAA4C5a,MAAM,CAAC4V,WAAnD,EAAgElhB,OAAhE;EACAlJ,IAAAA,QAAQ,CAAC7B,gBAAT,CAA0B+wB,WAAW,CAACG,GAAtC,EAA2C7a,MAAM,CAACsX,UAAlD,EAA8D,KAA9D;EACD,GAJD,MAIO;EACL,QAAIra,OAAO,CAACE,KAAZ,EAAmB;EACjB,UAAMO,eAAe,GACnBgd,WAAW,CAACC,KAAZ,KAAsB,YAAtB,IAAsC1d,OAAO,CAACS,eAA9C,IAAiEyD,MAAM,CAAC2Z,gBAAxE,GACI;EAAEC,QAAAA,OAAO,EAAE,IAAX;EAAiBrmB,QAAAA,OAAO,EAAE;EAA1B,OADJ,GAEI,KAHN;EAIA1D,MAAAA,EAAE,CAACrH,gBAAH,CAAoB+wB,WAAW,CAACC,KAAhC,EAAuC3a,MAAM,CAAC+S,YAA9C,EAA4DrV,eAA5D;EACA1M,MAAAA,EAAE,CAACrH,gBAAH,CACE+wB,WAAW,CAACE,IADd,EAEE5a,MAAM,CAAC4V,WAFT,EAGE3Y,OAAO,CAACS,eAAR,GAA0B;EAAEqd,QAAAA,OAAO,EAAE,KAAX;EAAkBrmB,QAAAA,OAAO,EAAPA;EAAlB,OAA1B,GAAwDA,OAH1D;EAKA1D,MAAAA,EAAE,CAACrH,gBAAH,CAAoB+wB,WAAW,CAACG,GAAhC,EAAqC7a,MAAM,CAACsX,UAA5C,EAAwD5Z,eAAxD;;EACA,UAAIgd,WAAW,CAACM,MAAhB,EAAwB;EACtBhqB,QAAAA,EAAE,CAACrH,gBAAH,CAAoB+wB,WAAW,CAACM,MAAhC,EAAwChb,MAAM,CAACsX,UAA/C,EAA2D5Z,eAA3D;EACD;;EACD,UAAI,CAAC6c,kBAAL,EAAyB;EACvB/uB,QAAAA,QAAQ,CAAC7B,gBAAT,CAA0B,YAA1B,EAAwC6wB,kBAAxC;EACAD,QAAAA,kBAAkB,GAAG,IAArB;EACD;EACF;;EACD,QACGpZ,MAAM,CAAC4Q,aAAP,IAAwB,CAAC9T,MAAM,CAACI,GAAhC,IAAuC,CAACJ,MAAM,CAACK,OAAhD,IACC6C,MAAM,CAAC4Q,aAAP,IAAwB,CAAC9U,OAAO,CAACE,KAAjC,IAA0Cc,MAAM,CAACI,GAFpD,EAGE;EACArN,MAAAA,EAAE,CAACrH,gBAAH,CAAoB,WAApB,EAAiCqW,MAAM,CAAC+S,YAAxC,EAAsD,KAAtD;EACAvnB,MAAAA,QAAQ,CAAC7B,gBAAT,CAA0B,WAA1B,EAAuCqW,MAAM,CAAC4V,WAA9C,EAA2DlhB,OAA3D;EACAlJ,MAAAA,QAAQ,CAAC7B,gBAAT,CAA0B,SAA1B,EAAqCqW,MAAM,CAACsX,UAA5C,EAAwD,KAAxD;EACD;EACF,GAlDqB;;;EAoDtB,MAAInW,MAAM,CAACgZ,aAAP,IAAwBhZ,MAAM,CAACiZ,wBAAnC,EAA6D;EAC3DppB,IAAAA,EAAE,CAACrH,gBAAH,CAAoB,OAApB,EAA6BqW,MAAM,CAACka,OAApC,EAA6C,IAA7C;EACD;;EACD,MAAI/Y,MAAM,CAACyE,OAAX,EAAoB;EAClB6H,IAAAA,SAAS,CAAC9jB,gBAAV,CAA2B,QAA3B,EAAqCqW,MAAM,CAACsa,QAA5C;EACD,GAzDqB;;;EA4DtB,MAAInZ,MAAM,CAAC8Z,oBAAX,EAAiC;EAC/Bjb,IAAAA,MAAM,CAAC5L,EAAP,CACE6J,MAAM,CAACI,GAAP,IAAcJ,MAAM,CAACK,OAArB,GACI,yCADJ,GAEI,uBAHN,EAIEqb,QAJF,EAKE,IALF;EAOD,GARD,MAQO;EACL3Z,IAAAA,MAAM,CAAC5L,EAAP,CAAU,gBAAV,EAA4BulB,QAA5B,EAAsC,IAAtC;EACD;EACF;;EAED,SAASuB,YAAT,GAAwB;EACtB,MAAMlb,MAAM,GAAG,IAAf;EACA,MAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EAFsB,MAId6V,MAJc,GAI0CnB,MAJ1C,CAIdmB,MAJc;EAAA,MAINuZ,WAJM,GAI0C1a,MAJ1C,CAIN0a,WAJM;EAAA,MAIO1pB,EAJP,GAI0CgP,MAJ1C,CAIOhP,EAJP;EAAA,MAIWyc,SAJX,GAI0CzN,MAJ1C,CAIWyN,SAJX;EAAA,MAIsBxP,MAJtB,GAI0C+B,MAJ1C,CAIsB/B,MAJtB;EAAA,MAI8BhB,OAJ9B,GAI0C+C,MAJ1C,CAI8B/C,OAJ9B;EAMtB,MAAMvI,OAAO,GAAG,CAAC,CAACyM,MAAM,CAACqV,MAAzB,CANsB;;EAStB,MAAI,CAACvZ,OAAO,CAACE,KAAT,IAAkBF,OAAO,CAACI,aAA9B,EAA6C;EAC3CrM,IAAAA,EAAE,CAACpH,mBAAH,CAAuB8wB,WAAW,CAACC,KAAnC,EAA0C3a,MAAM,CAAC+S,YAAjD,EAA+D,KAA/D;EACAvnB,IAAAA,QAAQ,CAAC5B,mBAAT,CAA6B8wB,WAAW,CAACE,IAAzC,EAA+C5a,MAAM,CAAC4V,WAAtD,EAAmElhB,OAAnE;EACAlJ,IAAAA,QAAQ,CAAC5B,mBAAT,CAA6B8wB,WAAW,CAACG,GAAzC,EAA8C7a,MAAM,CAACsX,UAArD,EAAiE,KAAjE;EACD,GAJD,MAIO;EACL,QAAIra,OAAO,CAACE,KAAZ,EAAmB;EACjB,UAAMO,eAAe,GACnBgd,WAAW,CAACC,KAAZ,KAAsB,cAAtB,IAAwC1d,OAAO,CAACS,eAAhD,IAAmEyD,MAAM,CAAC2Z,gBAA1E,GACI;EAAEC,QAAAA,OAAO,EAAE,IAAX;EAAiBrmB,QAAAA,OAAO,EAAE;EAA1B,OADJ,GAEI,KAHN;EAIA1D,MAAAA,EAAE,CAACpH,mBAAH,CAAuB8wB,WAAW,CAACC,KAAnC,EAA0C3a,MAAM,CAAC+S,YAAjD,EAA+DrV,eAA/D;EACA1M,MAAAA,EAAE,CAACpH,mBAAH,CAAuB8wB,WAAW,CAACE,IAAnC,EAAyC5a,MAAM,CAAC4V,WAAhD,EAA6DlhB,OAA7D;EACA1D,MAAAA,EAAE,CAACpH,mBAAH,CAAuB8wB,WAAW,CAACG,GAAnC,EAAwC7a,MAAM,CAACsX,UAA/C,EAA2D5Z,eAA3D;;EACA,UAAIgd,WAAW,CAACM,MAAhB,EAAwB;EACtBhqB,QAAAA,EAAE,CAACpH,mBAAH,CAAuB8wB,WAAW,CAACM,MAAnC,EAA2Chb,MAAM,CAACsX,UAAlD,EAA8D5Z,eAA9D;EACD;EACF;;EACD,QACGyD,MAAM,CAAC4Q,aAAP,IAAwB,CAAC9T,MAAM,CAACI,GAAhC,IAAuC,CAACJ,MAAM,CAACK,OAAhD,IACC6C,MAAM,CAAC4Q,aAAP,IAAwB,CAAC9U,OAAO,CAACE,KAAjC,IAA0Cc,MAAM,CAACI,GAFpD,EAGE;EACArN,MAAAA,EAAE,CAACpH,mBAAH,CAAuB,WAAvB,EAAoCoW,MAAM,CAAC+S,YAA3C,EAAyD,KAAzD;EACAvnB,MAAAA,QAAQ,CAAC5B,mBAAT,CAA6B,WAA7B,EAA0CoW,MAAM,CAAC4V,WAAjD,EAA8DlhB,OAA9D;EACAlJ,MAAAA,QAAQ,CAAC5B,mBAAT,CAA6B,SAA7B,EAAwCoW,MAAM,CAACsX,UAA/C,EAA2D,KAA3D;EACD;EACF,GAlCqB;;;EAoCtB,MAAInW,MAAM,CAACgZ,aAAP,IAAwBhZ,MAAM,CAACiZ,wBAAnC,EAA6D;EAC3DppB,IAAAA,EAAE,CAACpH,mBAAH,CAAuB,OAAvB,EAAgCoW,MAAM,CAACka,OAAvC,EAAgD,IAAhD;EACD;;EAED,MAAI/Y,MAAM,CAACyE,OAAX,EAAoB;EAClB6H,IAAAA,SAAS,CAAC7jB,mBAAV,CAA8B,QAA9B,EAAwCoW,MAAM,CAACsa,QAA/C;EACD,GA1CqB;;;EA6CtBta,EAAAA,MAAM,CAACrK,GAAP,CACEsI,MAAM,CAACI,GAAP,IAAcJ,MAAM,CAACK,OAArB,GACI,yCADJ,GAEI,uBAHN,EAIEqb,QAJF;EAMD;;AAED,eAAe;EACbc,EAAAA,YAAY,EAAZA,YADa;EAEbS,EAAAA,YAAY,EAAZA;EAFa,CAAf;;ECxIe,SAASrB,aAAT,GAAyB;EACtC,MAAM7Z,MAAM,GAAG,IAAf;EADsC,MAE9BiK,WAF8B,GAE8BjK,MAF9B,CAE9BiK,WAF8B;EAAA,MAEjB7J,WAFiB,GAE8BJ,MAF9B,CAEjBI,WAFiB;EAAA,6BAE8BJ,MAF9B,CAEJ6P,YAFI;EAAA,MAEJA,YAFI,qCAEW,CAFX;EAAA,MAEc1O,MAFd,GAE8BnB,MAF9B,CAEcmB,MAFd;EAAA,MAEsBiB,GAFtB,GAE8BpC,MAF9B,CAEsBoC,GAFtB;EAGtC,MAAMwX,WAAW,GAAGzY,MAAM,CAACyY,WAA3B;EACA,MAAI,CAACA,WAAD,IAAiBA,WAAW,IAAI3wB,MAAM,CAACI,IAAP,CAAYuwB,WAAZ,EAAyBpwB,MAAzB,KAAoC,CAAxE,EAA4E,OAJtC;;EAOtC,MAAM2xB,UAAU,GAAGnb,MAAM,CAACob,aAAP,CAAqBxB,WAArB,EAAkC5Z,MAAM,CAACmB,MAAP,CAAcka,eAAhD,EAAiErb,MAAM,CAAChP,EAAxE,CAAnB;;EAEA,MAAImqB,UAAU,IAAInb,MAAM,CAACsb,iBAAP,KAA6BH,UAA/C,EAA2D;EACzD,QAAMI,oBAAoB,GAAGJ,UAAU,IAAIvB,WAAd,GAA4BA,WAAW,CAACuB,UAAD,CAAvC,GAAsD5rB,SAAnF;;EACA,QAAIgsB,oBAAJ,EAA0B;EACxB,OACE,eADF,EAEE,cAFF,EAGE,gBAHF,EAIE,oBAJF,EAKE,iBALF,EAMEjyB,OANF,CAMU,UAACkyB,KAAD,EAAW;EACnB,YAAMC,UAAU,GAAGF,oBAAoB,CAACC,KAAD,CAAvC;EACA,YAAI,OAAOC,UAAP,KAAsB,WAA1B,EAAuC;;EACvC,YAAID,KAAK,KAAK,eAAV,KAA8BC,UAAU,KAAK,MAAf,IAAyBA,UAAU,KAAK,MAAtE,CAAJ,EAAmF;EACjFF,UAAAA,oBAAoB,CAACC,KAAD,CAApB,GAA8B,MAA9B;EACD,SAFD,MAEO,IAAIA,KAAK,KAAK,eAAd,EAA+B;EACpCD,UAAAA,oBAAoB,CAACC,KAAD,CAApB,GAA8BpkB,UAAU,CAACqkB,UAAD,CAAxC;EACD,SAFM,MAEA;EACLF,UAAAA,oBAAoB,CAACC,KAAD,CAApB,GAA8BvX,QAAQ,CAACwX,UAAD,EAAa,EAAb,CAAtC;EACD;EACF,OAhBD;EAiBD;;EAED,QAAMC,gBAAgB,GAAGH,oBAAoB,IAAIvb,MAAM,CAAC2b,cAAxD;EACA,QAAMC,WAAW,GAAGza,MAAM,CAACyF,eAAP,GAAyB,CAA7C;EACA,QAAMiV,UAAU,GAAGH,gBAAgB,CAAC9U,eAAjB,GAAmC,CAAtD;;EACA,QAAIgV,WAAW,IAAI,CAACC,UAApB,EAAgC;EAC9BzZ,MAAAA,GAAG,CAACxP,WAAJ,CACKuO,MAAM,CAAC2a,sBADZ,iBAC8C3a,MAAM,CAAC2a,sBADrD;EAGA9b,MAAAA,MAAM,CAAC+b,oBAAP;EACD,KALD,MAKO,IAAI,CAACH,WAAD,IAAgBC,UAApB,EAAgC;EACrCzZ,MAAAA,GAAG,CAACnQ,QAAJ,CAAgBkP,MAAM,CAAC2a,sBAAvB;;EACA,UAAIJ,gBAAgB,CAACzU,mBAAjB,KAAyC,QAA7C,EAAuD;EACrD7E,QAAAA,GAAG,CAACnQ,QAAJ,CAAgBkP,MAAM,CAAC2a,sBAAvB;EACD;;EACD9b,MAAAA,MAAM,CAAC+b,oBAAP;EACD;;EAED,QAAMC,gBAAgB,GACpBN,gBAAgB,CAAC/M,SAAjB,IAA8B+M,gBAAgB,CAAC/M,SAAjB,KAA+BxN,MAAM,CAACwN,SADtE;EAEA,QAAMsN,WAAW,GACf9a,MAAM,CAAC+K,IAAP,KAAgBwP,gBAAgB,CAAC1U,aAAjB,KAAmC7F,MAAM,CAAC6F,aAA1C,IAA2DgV,gBAA3E,CADF;;EAGA,QAAIA,gBAAgB,IAAI5b,WAAxB,EAAqC;EACnCJ,MAAAA,MAAM,CAACkc,eAAP;EACD;;EAEDhzB,IAAAA,QAAM,CAAC8W,MAAM,CAACmB,MAAR,EAAgBua,gBAAhB,CAAN;EAEAxyB,IAAAA,QAAM,CAAC8W,MAAD,EAAS;EACbwV,MAAAA,cAAc,EAAExV,MAAM,CAACmB,MAAP,CAAcqU,cADjB;EAEblG,MAAAA,cAAc,EAAEtP,MAAM,CAACmB,MAAP,CAAcmO,cAFjB;EAGbC,MAAAA,cAAc,EAAEvP,MAAM,CAACmB,MAAP,CAAcoO;EAHjB,KAAT,CAAN;EAMAvP,IAAAA,MAAM,CAACsb,iBAAP,GAA2BH,UAA3B;EAEAnb,IAAAA,MAAM,CAACgB,IAAP,CAAY,mBAAZ,EAAiC0a,gBAAjC;;EAEA,QAAIO,WAAW,IAAI7b,WAAnB,EAAgC;EAC9BJ,MAAAA,MAAM,CAAC4R,WAAP;EACA5R,MAAAA,MAAM,CAACgR,UAAP;EACAhR,MAAAA,MAAM,CAACqE,YAAP;EACArE,MAAAA,MAAM,CAAC6O,OAAP,CAAe5E,WAAW,GAAG4F,YAAd,GAA6B7P,MAAM,CAAC6P,YAAnD,EAAiE,CAAjE,EAAoE,KAApE;EACD;;EAED7P,IAAAA,MAAM,CAACgB,IAAP,CAAY,YAAZ,EAA0B0a,gBAA1B;EACD;EACF;;EC7Ec,SAASN,aAAT,CAAuBxB,WAAvB,EAAoCuC,IAApC,EAAqDC,WAArD,EAAkE;EAAA,MAA9BD,IAA8B;EAA9BA,IAAAA,IAA8B,GAAvB,QAAuB;EAAA;;EAC/E,MAAI,CAACvC,WAAD,IAAiBuC,IAAI,KAAK,WAAT,IAAwB,CAACC,WAA9C,EAA4D,OAAO7sB,SAAP;EAC5D,MAAI4rB,UAAU,GAAG,KAAjB;EAEA,MAAMnuB,MAAM,GAAGF,SAAS,EAAxB;EACA,MAAMuvB,YAAY,GAAGF,IAAI,KAAK,QAAT,GAAoBnvB,MAAM,CAAC8nB,UAA3B,GAAwCsH,WAAW,CAACvY,WAAzE;EACA,MAAMyY,aAAa,GAAGH,IAAI,KAAK,QAAT,GAAoBnvB,MAAM,CAACuvB,WAA3B,GAAyCH,WAAW,CAACtY,YAA3E;EAEA,MAAM0Y,MAAM,GAAGvzB,MAAM,CAACI,IAAP,CAAYuwB,WAAZ,EAAyBtnB,GAAzB,CAA6B,UAACmqB,KAAD,EAAW;EACrD,QAAI,OAAOA,KAAP,KAAiB,QAAjB,IAA6BA,KAAK,CAACttB,OAAN,CAAc,GAAd,MAAuB,CAAxD,EAA2D;EACzD,UAAMutB,QAAQ,GAAGtlB,UAAU,CAACqlB,KAAK,CAACE,MAAN,CAAa,CAAb,CAAD,CAA3B;EACA,UAAM9sB,KAAK,GAAGysB,aAAa,GAAGI,QAA9B;EACA,aAAO;EAAE7sB,QAAAA,KAAK,EAALA,KAAF;EAAS4sB,QAAAA,KAAK,EAALA;EAAT,OAAP;EACD;;EACD,WAAO;EAAE5sB,MAAAA,KAAK,EAAE4sB,KAAT;EAAgBA,MAAAA,KAAK,EAALA;EAAhB,KAAP;EACD,GAPc,CAAf;EASAD,EAAAA,MAAM,CAACI,IAAP,CAAY,UAACnuB,CAAD,EAAIouB,CAAJ;EAAA,WAAU5Y,QAAQ,CAACxV,CAAC,CAACoB,KAAH,EAAU,EAAV,CAAR,GAAwBoU,QAAQ,CAAC4Y,CAAC,CAAChtB,KAAH,EAAU,EAAV,CAA1C;EAAA,GAAZ;;EACA,OAAK,IAAIyB,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGkrB,MAAM,CAAChzB,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EAAA,oBAChBkrB,MAAM,CAAClrB,CAAD,CADU;EAAA,QACjCmrB,KADiC,aACjCA,KADiC;EAAA,QAC1B5sB,KAD0B,aAC1BA,KAD0B;;EAEzC,QAAIA,KAAK,IAAIwsB,YAAb,EAA2B;EACzBlB,MAAAA,UAAU,GAAGsB,KAAb;EACD;EACF;;EACD,SAAOtB,UAAU,IAAI,KAArB;EACD;;ACxBD,oBAAe;EAAEtB,EAAAA,aAAa,EAAbA,aAAF;EAAiBuB,EAAAA,aAAa,EAAbA;EAAjB,CAAf;;ECHA,SAAS0B,cAAT,CAAwBzc,OAAxB,EAAiC0c,MAAjC,EAAyC;EACvC,MAAMC,aAAa,GAAG,EAAtB;EACA3c,EAAAA,OAAO,CAAC/W,OAAR,CAAgB,UAAC2zB,IAAD,EAAU;EACxB,QAAI,OAAOA,IAAP,KAAgB,QAApB,EAA8B;EAC5Bh0B,MAAAA,MAAM,CAACI,IAAP,CAAY4zB,IAAZ,EAAkB3zB,OAAlB,CAA0B,UAAC+I,UAAD,EAAgB;EACxC,YAAI4qB,IAAI,CAAC5qB,UAAD,CAAR,EAAsB;EACpB2qB,UAAAA,aAAa,CAACtuB,IAAd,CAAmBquB,MAAM,GAAG1qB,UAA5B;EACD;EACF,OAJD;EAKD,KAND,MAMO,IAAI,OAAO4qB,IAAP,KAAgB,QAApB,EAA8B;EACnCD,MAAAA,aAAa,CAACtuB,IAAd,CAAmBquB,MAAM,GAAGE,IAA5B;EACD;EACF,GAVD;EAWA,SAAOD,aAAP;EACD;;EAEc,SAASE,UAAT,GAAsB;EACnC,MAAMld,MAAM,GAAG,IAAf;EADmC,MAE3B3N,UAF2B,GAEuB2N,MAFvB,CAE3B3N,UAF2B;EAAA,MAEf8O,MAFe,GAEuBnB,MAFvB,CAEfmB,MAFe;EAAA,MAEPyD,GAFO,GAEuB5E,MAFvB,CAEP4E,GAFO;EAAA,MAEFxC,GAFE,GAEuBpC,MAFvB,CAEFoC,GAFE;EAAA,MAEGnE,MAFH,GAEuB+B,MAFvB,CAEG/B,MAFH;EAAA,MAEWhB,OAFX,GAEuB+C,MAFvB,CAEW/C,OAFX;;EAInC,MAAMkgB,QAAQ,GAAGL,cAAc,CAAC,CAC9B,aAD8B,EAE9B3b,MAAM,CAACwN,SAFuB,EAG9B;EAAE,sBAAkB1R,OAAO,CAACI,aAAR,IAAyB,CAACJ,OAAO,CAACE;EAAtD,GAH8B,EAI9B;EAAE,iBAAagE,MAAM,CAAC+V;EAAtB,GAJ8B,EAK9B;EAAE,kBAAc/V,MAAM,CAACyJ;EAAvB,GAL8B,EAM9B;EAAE,WAAOhG;EAAT,GAN8B,EAO9B;EAAE,gBAAYzD,MAAM,CAACyF,eAAP,GAAyB;EAAvC,GAP8B,EAQ9B;EAAE,uBAAmBzF,MAAM,CAACyF,eAAP,GAAyB,CAAzB,IAA8BzF,MAAM,CAAC8F,mBAAP,KAA+B;EAAlF,GAR8B,EAS9B;EAAE,eAAWhJ,MAAM,CAACK;EAApB,GAT8B,EAU9B;EAAE,WAAOL,MAAM,CAACI;EAAhB,GAV8B,EAW9B;EAAE,gBAAY8C,MAAM,CAACyE;EAArB,GAX8B,CAAD,EAY5BzE,MAAM,CAAC2a,sBAZqB,CAA/B;EAaAzpB,EAAAA,UAAU,CAAC3D,IAAX,OAAA2D,UAAU,EAAS8qB,QAAT,CAAV;EACA/a,EAAAA,GAAG,CAACnQ,QAAJ,CAAa,UAAII,UAAJ,EAAgBwJ,IAAhB,CAAqB,GAArB,CAAb;EACAmE,EAAAA,MAAM,CAAC+b,oBAAP;EACD;;ECpCc,SAASqB,aAAT,GAAyB;EACtC,MAAMpd,MAAM,GAAG,IAAf;EADsC,MAE9BoC,GAF8B,GAEVpC,MAFU,CAE9BoC,GAF8B;EAAA,MAEzB/P,UAFyB,GAEV2N,MAFU,CAEzB3N,UAFyB;EAItC+P,EAAAA,GAAG,CAACxP,WAAJ,CAAgBP,UAAU,CAACwJ,IAAX,CAAgB,GAAhB,CAAhB;EACAmE,EAAAA,MAAM,CAAC+b,oBAAP;EACD;;ACHD,gBAAe;EAAEmB,EAAAA,UAAU,EAAVA,UAAF;EAAcE,EAAAA,aAAa,EAAbA;EAAd,CAAf;;ECAe,SAASC,SAAT,CAAmBC,OAAnB,EAA4Bl0B,GAA5B,EAAiCm0B,MAAjC,EAAyCC,KAAzC,EAAgDC,gBAAhD,EAAkE9wB,QAAlE,EAA4E;EACzF,MAAMK,MAAM,GAAGF,SAAS,EAAxB;EACA,MAAI4wB,KAAJ;;EACA,WAASC,OAAT,GAAmB;EACjB,QAAIhxB,QAAJ,EAAcA,QAAQ;EACvB;;EACD,MAAMixB,SAAS,GAAGlsB,CAAC,CAAC4rB,OAAD,CAAD,CAAWljB,MAAX,CAAkB,SAAlB,EAA6B,CAA7B,CAAlB;;EAEA,MAAI,CAACwjB,SAAD,KAAe,CAACN,OAAO,CAACO,QAAT,IAAqB,CAACJ,gBAArC,CAAJ,EAA4D;EAC1D,QAAIr0B,GAAJ,EAAS;EACPs0B,MAAAA,KAAK,GAAG,IAAI1wB,MAAM,CAACZ,KAAX,EAAR;EACAsxB,MAAAA,KAAK,CAACI,MAAN,GAAeH,OAAf;EACAD,MAAAA,KAAK,CAACK,OAAN,GAAgBJ,OAAhB;;EACA,UAAIH,KAAJ,EAAW;EACTE,QAAAA,KAAK,CAACF,KAAN,GAAcA,KAAd;EACD;;EACD,UAAID,MAAJ,EAAY;EACVG,QAAAA,KAAK,CAACH,MAAN,GAAeA,MAAf;EACD;;EACD,UAAIn0B,GAAJ,EAAS;EACPs0B,QAAAA,KAAK,CAACt0B,GAAN,GAAYA,GAAZ;EACD;EACF,KAbD,MAaO;EACLu0B,MAAAA,OAAO;EACR;EACF,GAjBD,MAiBO;EACL;EACAA,IAAAA,OAAO;EACR;EACF;;EChCc,SAASK,aAAT,GAAyB;EACtC,MAAMhe,MAAM,GAAG,IAAf;EACAA,EAAAA,MAAM,CAACie,YAAP,GAAsBje,MAAM,CAACoC,GAAP,CAAW5H,IAAX,CAAgB,KAAhB,CAAtB;;EACA,WAASmjB,OAAT,GAAmB;EACjB,QAAI,OAAO3d,MAAP,KAAkB,WAAlB,IAAiCA,MAAM,KAAK,IAA5C,IAAoD,CAACA,MAArD,IAA+DA,MAAM,CAACG,SAA1E,EAAqF;EACrF,QAAIH,MAAM,CAACke,YAAP,KAAwB3uB,SAA5B,EAAuCyQ,MAAM,CAACke,YAAP,IAAuB,CAAvB;;EACvC,QAAIle,MAAM,CAACke,YAAP,KAAwBle,MAAM,CAACie,YAAP,CAAoBz0B,MAAhD,EAAwD;EACtD,UAAIwW,MAAM,CAACmB,MAAP,CAAcgd,mBAAlB,EAAuCne,MAAM,CAACoS,MAAP;EACvCpS,MAAAA,MAAM,CAACgB,IAAP,CAAY,aAAZ;EACD;EACF;;EACD,OAAK,IAAI1P,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG0O,MAAM,CAACie,YAAP,CAAoBz0B,MAAxC,EAAgD8H,CAAC,IAAI,CAArD,EAAwD;EACtD,QAAMgsB,OAAO,GAAGtd,MAAM,CAACie,YAAP,CAAoB3sB,CAApB,CAAhB;EACA0O,IAAAA,MAAM,CAACqd,SAAP,CACEC,OADF,EAEEA,OAAO,CAACc,UAAR,IAAsBd,OAAO,CAAC1pB,YAAR,CAAqB,KAArB,CAFxB,EAGE0pB,OAAO,CAACC,MAAR,IAAkBD,OAAO,CAAC1pB,YAAR,CAAqB,QAArB,CAHpB,EAIE0pB,OAAO,CAACE,KAAR,IAAiBF,OAAO,CAAC1pB,YAAR,CAAqB,OAArB,CAJnB,EAKE,IALF,EAME+pB,OANF;EAQD;EACF;;ACnBD,eAAe;EACbN,EAAAA,SAAS,EAATA,SADa;EAEbW,EAAAA,aAAa,EAAbA;EAFa,CAAf;;ECHA,SAASxU,aAAT,GAAyB;EACvB,MAAMxJ,MAAM,GAAG,IAAf;EACA,MAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAtB;EACA,MAAMkd,SAAS,GAAGre,MAAM,CAACgS,QAAzB;EACA,MAAMsM,iBAAiB,GACrBte,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuB,CAAvB,IACA2X,MAAM,CAAC2E,kBAAP,GACE3E,MAAM,CAACgF,YAAP,IAAuBnG,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuB,CAA9C,CADF,GAEEwW,MAAM,CAACmF,MAAP,CAAc,CAAd,EAAiBhO,WAAjB,GAA+B6I,MAAM,CAACmF,MAAP,CAAc3b,MAJjD;;EAMA,MAAI2X,MAAM,CAAC2E,kBAAP,IAA6B3E,MAAM,CAAC6E,iBAApC,IAAyDsY,iBAA7D,EAAgF;EAC9Ete,IAAAA,MAAM,CAACgS,QAAP,GAAkBsM,iBAAiB,IAAIte,MAAM,CAACoE,IAA9C;EACD,GAFD,MAEO;EACLpE,IAAAA,MAAM,CAACgS,QAAP,GAAkBhS,MAAM,CAACsF,QAAP,CAAgB9b,MAAhB,KAA2B,CAA7C;EACD;;EAEDwW,EAAAA,MAAM,CAACsP,cAAP,GAAwB,CAACtP,MAAM,CAACgS,QAAhC;EACAhS,EAAAA,MAAM,CAACuP,cAAP,GAAwB,CAACvP,MAAM,CAACgS,QAAhC,CAjBuB;;EAoBvB,MAAIqM,SAAS,KAAKre,MAAM,CAACgS,QAAzB,EAAmChS,MAAM,CAACgB,IAAP,CAAYhB,MAAM,CAACgS,QAAP,GAAkB,MAAlB,GAA2B,QAAvC;;EAEnC,MAAIqM,SAAS,IAAIA,SAAS,KAAKre,MAAM,CAACgS,QAAtC,EAAgD;EAC9ChS,IAAAA,MAAM,CAACsL,KAAP,GAAe,KAAf;EACA,QAAItL,MAAM,CAACwZ,UAAX,EAAuBxZ,MAAM,CAACwZ,UAAP,CAAkBpH,MAAlB;EACxB;EACF;;AAED,wBAAe;EAAE5I,EAAAA,aAAa,EAAbA;EAAF,CAAf;;AC5BA,iBAAe;EACbtI,EAAAA,IAAI,EAAE,IADO;EAEbyN,EAAAA,SAAS,EAAE,YAFE;EAGbyE,EAAAA,iBAAiB,EAAE,WAHN;EAIblE,EAAAA,YAAY,EAAE,CAJD;EAKbrF,EAAAA,KAAK,EAAE,GALM;EAMbjE,EAAAA,OAAO,EAAE,KANI;EAObqV,EAAAA,oBAAoB,EAAE,IAPT;EAQb7Z,EAAAA,cAAc,EAAE,KARH;EASboV,EAAAA,MAAM,EAAE,KATK;EAWb;EACAhY,EAAAA,KAAK,EAAE,IAZM;EAabE,EAAAA,MAAM,EAAE,IAbK;EAeb;EACA0P,EAAAA,8BAA8B,EAAE,KAhBnB;EAkBb;EACAziB,EAAAA,SAAS,EAAE,IAnBE;EAoBb4yB,EAAAA,GAAG,EAAE,IApBQ;EAsBb;EACA7J,EAAAA,kBAAkB,EAAE,KAvBP;EAwBbE,EAAAA,kBAAkB,EAAE,EAxBP;EA0Bb;EACAsC,EAAAA,QAAQ,EAAE,KA3BG;EA4BbS,EAAAA,gBAAgB,EAAE,IA5BL;EA6BbS,EAAAA,qBAAqB,EAAE,CA7BV;EA8BbQ,EAAAA,sBAAsB,EAAE,IA9BX;EA+BbF,EAAAA,2BAA2B,EAAE,CA/BhB;EAgCbR,EAAAA,6BAA6B,EAAE,CAhClB;EAiCbW,EAAAA,cAAc,EAAE,KAjCH;EAkCbZ,EAAAA,uBAAuB,EAAE,IAlCZ;EAoCb;EACArN,EAAAA,UAAU,EAAE,KArCC;EAuCb;EACA/B,EAAAA,cAAc,EAAE,KAxCH;EA0Cb;EACAwE,EAAAA,gBAAgB,EAAE,KA3CL;EA6Cb;EACAzE,EAAAA,MAAM,EAAE,OA9CK;EA8CI;EAEjB;EACAgR,EAAAA,WAAW,EAAErqB,SAjDA;EAkDb8rB,EAAAA,eAAe,EAAE,QAlDJ;EAoDb;EACAlV,EAAAA,YAAY,EAAE,CArDD;EAsDba,EAAAA,aAAa,EAAE,CAtDF;EAuDbJ,EAAAA,eAAe,EAAE,CAvDJ;EAwDbK,EAAAA,mBAAmB,EAAE,QAxDR;EAyDbS,EAAAA,cAAc,EAAE,CAzDH;EA0DbgB,EAAAA,kBAAkB,EAAE,CA1DP;EA2DbF,EAAAA,cAAc,EAAE,KA3DH;EA4DbO,EAAAA,oBAAoB,EAAE,KA5DT;EA6DbjD,EAAAA,kBAAkB,EAAE,CA7DP;EA6DU;EACvBE,EAAAA,iBAAiB,EAAE,CA9DN;EA8DS;EACtB4G,EAAAA,mBAAmB,EAAE,IA/DR;EAgEbxD,EAAAA,wBAAwB,EAAE,KAhEb;EAkEb;EACAG,EAAAA,aAAa,EAAE,KAnEF;EAqEb;EACApB,EAAAA,YAAY,EAAE,KAtED;EAwEb;EACA0O,EAAAA,UAAU,EAAE,CAzEC;EA0EbT,EAAAA,UAAU,EAAE,EA1EC;EA2EbrE,EAAAA,aAAa,EAAE,IA3EF;EA4EbuH,EAAAA,WAAW,EAAE,IA5EA;EA6EbF,EAAAA,UAAU,EAAE,IA7EC;EA8EbC,EAAAA,eAAe,EAAE,GA9EJ;EA+EbL,EAAAA,YAAY,EAAE,GA/ED;EAgFb/B,EAAAA,YAAY,EAAE,IAhFD;EAiFbzB,EAAAA,cAAc,EAAE,IAjFH;EAkFb7E,EAAAA,SAAS,EAAE,CAlFE;EAmFb4F,EAAAA,wBAAwB,EAAE,KAnFb;EAoFbd,EAAAA,wBAAwB,EAAE,IApFb;EAqFbC,EAAAA,6BAA6B,EAAE,KArFlB;EAsFbM,EAAAA,mBAAmB,EAAE,KAtFR;EAwFb;EACAwI,EAAAA,iBAAiB,EAAE,IAzFN;EA2Fb;EACAxH,EAAAA,UAAU,EAAE,IA5FC;EA6FbD,EAAAA,eAAe,EAAE,IA7FJ;EA+Fb;EACAtN,EAAAA,mBAAmB,EAAE,KAhGR;EAiGbC,EAAAA,qBAAqB,EAAE,KAjGV;EAmGb;EACAkN,EAAAA,UAAU,EAAE,KApGC;EAsGb;EACAuD,EAAAA,aAAa,EAAE,IAvGF;EAwGbC,EAAAA,wBAAwB,EAAE,IAxGb;EAyGbjN,EAAAA,mBAAmB,EAAE,KAzGR;EA2Gb;EACA6Q,EAAAA,aAAa,EAAE,IA5GF;EA6GbG,EAAAA,mBAAmB,EAAE,IA7GR;EA+Gb;EACAjS,EAAAA,IAAI,EAAE,KAhHO;EAiHbmF,EAAAA,oBAAoB,EAAE,CAjHT;EAkHbxB,EAAAA,YAAY,EAAE,IAlHD;EAmHboB,EAAAA,sBAAsB,EAAE,KAnHX;EAoHbjB,EAAAA,iBAAiB,EAAE,IApHN;EAsHb;EACAT,EAAAA,cAAc,EAAE,IAvHH;EAwHbD,EAAAA,cAAc,EAAE,IAxHH;EAyHb4E,EAAAA,YAAY,EAAE,IAzHD;EAyHO;EACpBH,EAAAA,SAAS,EAAE,IA1HE;EA2HbH,EAAAA,cAAc,EAAE,mBA3HH;EA4HbI,EAAAA,iBAAiB,EAAE,IA5HN;EA8Hb;EACA8G,EAAAA,gBAAgB,EAAE,IA/HL;EAiIb;EACAgB,EAAAA,sBAAsB,EAAE,mBAlIX;EAkIgC;EAC7C1W,EAAAA,UAAU,EAAE,cAnIC;EAoIbgM,EAAAA,eAAe,EAAE,8BApIJ;EAqIbzF,EAAAA,gBAAgB,EAAE,qBArIL;EAsIbG,EAAAA,yBAAyB,EAAE,+BAtId;EAuIbtB,EAAAA,iBAAiB,EAAE,sBAvIN;EAwIb2B,EAAAA,mBAAmB,EAAE,wBAxIR;EAyIbP,EAAAA,cAAc,EAAE,mBAzIH;EA0IbG,EAAAA,uBAAuB,EAAE,6BA1IZ;EA2IbF,EAAAA,cAAc,EAAE,mBA3IH;EA4IbG,EAAAA,uBAAuB,EAAE,6BA5IZ;EA6IbyS,EAAAA,YAAY,EAAE,gBA7ID;EA+Ib;EACA3R,EAAAA,kBAAkB,EAAE,IAhJP;EAkJb;EACA4R,EAAAA,YAAY,EAAE;EAnJD,CAAf;;EC4BA,IAAMC,UAAU,GAAG;EACjBC,EAAAA,OAAO,EAAPA,OADiB;EAEjBC,EAAAA,aAAa,EAAbA,aAFiB;EAGjBzM,EAAAA,MAAM,EAANA,MAHiB;EAIjB9H,EAAAA,SAAS,EAATA,SAJiB;EAKjBrW,EAAAA,UAAU,EAAVA,YALiB;EAMjBqT,EAAAA,KAAK,EAALA,KANiB;EAOjB4E,EAAAA,IAAI,EAAJA,IAPiB;EAQjB0K,EAAAA,UAAU,EAAVA,UARiB;EASjBkI,EAAAA,YAAY,EAAZA,YATiB;EAUjB1pB,EAAAA,MAAM,EAANA,MAViB;EAWjBwkB,EAAAA,WAAW,EAAXA,WAXiB;EAYjBpQ,EAAAA,aAAa,EAAbA,eAZiB;EAajBrX,EAAAA,OAAO,EAAPA,OAbiB;EAcjB4sB,EAAAA,MAAM,EAANA;EAdiB,CAAnB;EAiBA,IAAMC,gBAAgB,GAAG,EAAzB;;MAEMC;EACJ,oBAAqB;EACnB,QAAIjuB,EAAJ;EACA,QAAImQ,MAAJ;;EAFmB,sCAAN5S,IAAM;EAANA,MAAAA,IAAM;EAAA;;EAGnB,QACEA,IAAI,CAAC/E,MAAL,KAAgB,CAAhB,IACA+E,IAAI,CAAC,CAAD,CAAJ,CAAQvF,WADR,IAEAC,MAAM,CAACmE,SAAP,CAAiBc,QAAjB,CAA0BC,IAA1B,CAA+BI,IAAI,CAAC,CAAD,CAAnC,EAAwC6N,KAAxC,CAA8C,CAA9C,EAAiD,CAAC,CAAlD,MAAyD,QAH3D,EAIE;EACA+E,MAAAA,MAAM,GAAG5S,IAAI,CAAC,CAAD,CAAb;EACD,KAND,MAMO;EACJyC,MAAAA,EADI,GACUzC,IADV;EACA4S,MAAAA,MADA,GACU5S,IADV;EAEN;;EACD,QAAI,CAAC4S,MAAL,EAAaA,MAAM,GAAG,EAAT;EAEbA,IAAAA,MAAM,GAAGjY,QAAM,CAAC,EAAD,EAAKiY,MAAL,CAAf;EACA,QAAInQ,EAAE,IAAI,CAACmQ,MAAM,CAACnQ,EAAlB,EAAsBmQ,MAAM,CAACnQ,EAAP,GAAYA,EAAZ;;EAEtB,QAAImQ,MAAM,CAACnQ,EAAP,IAAaU,CAAC,CAACyP,MAAM,CAACnQ,EAAR,CAAD,CAAaxH,MAAb,GAAsB,CAAvC,EAA0C;EACxC,UAAM01B,OAAO,GAAG,EAAhB;EACAxtB,MAAAA,CAAC,CAACyP,MAAM,CAACnQ,EAAR,CAAD,CAAasH,IAAb,CAAkB,UAAC8jB,WAAD,EAAiB;EACjC,YAAM+C,SAAS,GAAGj2B,QAAM,CAAC,EAAD,EAAKiY,MAAL,EAAa;EAAEnQ,UAAAA,EAAE,EAAEorB;EAAN,SAAb,CAAxB;EACA8C,QAAAA,OAAO,CAACxwB,IAAR,CAAa,IAAIuwB,MAAJ,CAAWE,SAAX,CAAb;EACD,OAHD;EAIA,aAAOD,OAAP;EACD,KAxBkB;;;EA2BnB,QAAMlf,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAAClD,UAAP,GAAoB,IAApB;EACAkD,IAAAA,MAAM,CAAC/C,OAAP,GAAiBe,UAAU,EAA3B;EACAgC,IAAAA,MAAM,CAAC/B,MAAP,GAAgBkB,SAAS,CAAC;EAAExT,MAAAA,SAAS,EAAEwV,MAAM,CAACxV;EAApB,KAAD,CAAzB;EACAqU,IAAAA,MAAM,CAACX,OAAP,GAAiBO,UAAU,EAA3B;EAEAI,IAAAA,MAAM,CAACmD,eAAP,GAAyB,EAAzB;EACAnD,IAAAA,MAAM,CAACwD,kBAAP,GAA4B,EAA5B;;EAEA,QAAI,OAAOxD,MAAM,CAAC0C,OAAd,KAA0B,WAA9B,EAA2C;EACzC1C,MAAAA,MAAM,CAAC0C,OAAP,GAAiB,EAAjB;EACD;;EACDzZ,IAAAA,MAAM,CAACI,IAAP,CAAY2W,MAAM,CAAC0C,OAAnB,EAA4BpZ,OAA5B,CAAoC,UAACqZ,UAAD,EAAgB;EAClD,UAAMC,MAAM,GAAG5C,MAAM,CAAC0C,OAAP,CAAeC,UAAf,CAAf;;EACA,UAAIC,MAAM,CAACzB,MAAX,EAAmB;EACjB,YAAMie,eAAe,GAAGn2B,MAAM,CAACI,IAAP,CAAYuZ,MAAM,CAACzB,MAAnB,EAA2B,CAA3B,CAAxB;EACA,YAAM4B,YAAY,GAAGH,MAAM,CAACzB,MAAP,CAAcie,eAAd,CAArB;EACA,YAAI,OAAOrc,YAAP,KAAwB,QAAxB,IAAoCA,YAAY,KAAK,IAAzD,EAA+D;EAC/D,YAAI,EAAEqc,eAAe,IAAIje,MAAnB,IAA6B,aAAa4B,YAA5C,CAAJ,EAA+D;;EAC/D,YAAI5B,MAAM,CAACie,eAAD,CAAN,KAA4B,IAAhC,EAAsC;EACpCje,UAAAA,MAAM,CAACie,eAAD,CAAN,GAA0B;EAAEna,YAAAA,OAAO,EAAE;EAAX,WAA1B;EACD;;EACD,YACE,OAAO9D,MAAM,CAACie,eAAD,CAAb,KAAmC,QAAnC,IACA,EAAE,aAAaje,MAAM,CAACie,eAAD,CAArB,CAFF,EAGE;EACAje,UAAAA,MAAM,CAACie,eAAD,CAAN,CAAwBna,OAAxB,GAAkC,IAAlC;EACD;;EACD,YAAI,CAAC9D,MAAM,CAACie,eAAD,CAAX,EAA8Bje,MAAM,CAACie,eAAD,CAAN,GAA0B;EAAEna,UAAAA,OAAO,EAAE;EAAX,SAA1B;EAC/B;EACF,KAlBD,EAvCmB;;EA4DnB,QAAMoa,YAAY,GAAGn2B,QAAM,CAAC,EAAD,EAAKo2B,QAAL,CAA3B;EACAtf,IAAAA,MAAM,CAACwC,SAAP,CAAiB6c,YAAjB,EA7DmB;;EAgEnBrf,IAAAA,MAAM,CAACmB,MAAP,GAAgBjY,QAAM,CAAC,EAAD,EAAKm2B,YAAL,EAAmBL,gBAAnB,EAAqC7d,MAArC,CAAtB;EACAnB,IAAAA,MAAM,CAAC2b,cAAP,GAAwBzyB,QAAM,CAAC,EAAD,EAAK8W,MAAM,CAACmB,MAAZ,CAA9B;EACAnB,IAAAA,MAAM,CAACuf,YAAP,GAAsBr2B,QAAM,CAAC,EAAD,EAAKiY,MAAL,CAA5B,CAlEmB;;EAqEnB,QAAInB,MAAM,CAACmB,MAAP,IAAiBnB,MAAM,CAACmB,MAAP,CAAc/M,EAAnC,EAAuC;EACrCnL,MAAAA,MAAM,CAACI,IAAP,CAAY2W,MAAM,CAACmB,MAAP,CAAc/M,EAA1B,EAA8B9K,OAA9B,CAAsC,UAACk2B,SAAD,EAAe;EACnDxf,QAAAA,MAAM,CAAC5L,EAAP,CAAUorB,SAAV,EAAqBxf,MAAM,CAACmB,MAAP,CAAc/M,EAAd,CAAiBorB,SAAjB,CAArB;EACD,OAFD;EAGD;;EACD,QAAIxf,MAAM,CAACmB,MAAP,IAAiBnB,MAAM,CAACmB,MAAP,CAAcoC,KAAnC,EAA0C;EACxCvD,MAAAA,MAAM,CAACuD,KAAP,CAAavD,MAAM,CAACmB,MAAP,CAAcoC,KAA3B;EACD,KA5EkB;;;EA+EnBvD,IAAAA,MAAM,CAACtO,CAAP,GAAWA,CAAX,CA/EmB;;EAkFnBxI,IAAAA,QAAM,CAAC8W,MAAD,EAAS;EACbhP,MAAAA,EAAE,EAAFA,EADa;EAGb;EACAqB,MAAAA,UAAU,EAAE,EAJC;EAMb;EACA8S,MAAAA,MAAM,EAAEzT,CAAC,EAPI;EAQb6T,MAAAA,UAAU,EAAE,EARC;EASbD,MAAAA,QAAQ,EAAE,EATG;EAUbE,MAAAA,eAAe,EAAE,EAVJ;EAYb;EACAzB,MAAAA,YAba,0BAaE;EACb,eAAO/D,MAAM,CAACmB,MAAP,CAAcwN,SAAd,KAA4B,YAAnC;EACD,OAfY;EAgBb3K,MAAAA,UAhBa,wBAgBA;EACX,eAAOhE,MAAM,CAACmB,MAAP,CAAcwN,SAAd,KAA4B,UAAnC;EACD,OAlBY;EAoBb;EACA1E,MAAAA,WAAW,EAAE,CArBA;EAsBbyB,MAAAA,SAAS,EAAE,CAtBE;EAwBb;EACAL,MAAAA,WAAW,EAAE,IAzBA;EA0BbC,MAAAA,KAAK,EAAE,KA1BM;EA4Bb;EACAhB,MAAAA,SAAS,EAAE,CA7BE;EA8BbuD,MAAAA,iBAAiB,EAAE,CA9BN;EA+Bb7C,MAAAA,QAAQ,EAAE,CA/BG;EAgCbgN,MAAAA,QAAQ,EAAE,CAhCG;EAiCb7J,MAAAA,SAAS,EAAE,KAjCE;EAmCb;EACAmB,MAAAA,cAAc,EAAEtP,MAAM,CAACmB,MAAP,CAAcmO,cApCjB;EAqCbC,MAAAA,cAAc,EAAEvP,MAAM,CAACmB,MAAP,CAAcoO,cArCjB;EAuCb;EACAmL,MAAAA,WAAW,EAAG,SAASA,WAAT,GAAuB;EACnC,YAAMvd,KAAK,GAAG,CAAC,YAAD,EAAe,WAAf,EAA4B,UAA5B,EAAwC,aAAxC,CAAd;EACA,YAAIsiB,OAAO,GAAG,CAAC,WAAD,EAAc,WAAd,EAA2B,SAA3B,CAAd;;EACA,YAAIzf,MAAM,CAAC/C,OAAP,CAAeI,aAAnB,EAAkC;EAChCoiB,UAAAA,OAAO,GAAG,CAAC,aAAD,EAAgB,aAAhB,EAA+B,WAA/B,CAAV;EACD;;EACDzf,QAAAA,MAAM,CAAC0f,gBAAP,GAA0B;EACxB/E,UAAAA,KAAK,EAAExd,KAAK,CAAC,CAAD,CADY;EAExByd,UAAAA,IAAI,EAAEzd,KAAK,CAAC,CAAD,CAFa;EAGxB0d,UAAAA,GAAG,EAAE1d,KAAK,CAAC,CAAD,CAHc;EAIxB6d,UAAAA,MAAM,EAAE7d,KAAK,CAAC,CAAD;EAJW,SAA1B;EAMA6C,QAAAA,MAAM,CAAC2f,kBAAP,GAA4B;EAC1BhF,UAAAA,KAAK,EAAE8E,OAAO,CAAC,CAAD,CADY;EAE1B7E,UAAAA,IAAI,EAAE6E,OAAO,CAAC,CAAD,CAFa;EAG1B5E,UAAAA,GAAG,EAAE4E,OAAO,CAAC,CAAD;EAHc,SAA5B;EAKA,eAAOzf,MAAM,CAAC/C,OAAP,CAAeE,KAAf,IAAwB,CAAC6C,MAAM,CAACmB,MAAP,CAAc4Q,aAAvC,GACH/R,MAAM,CAAC0f,gBADJ,GAEH1f,MAAM,CAAC2f,kBAFX;EAGD,OApBY,EAxCA;EA6Db3M,MAAAA,eAAe,EAAE;EACfS,QAAAA,SAAS,EAAElkB,SADI;EAEfmkB,QAAAA,OAAO,EAAEnkB,SAFM;EAGfylB,QAAAA,mBAAmB,EAAEzlB,SAHN;EAIf4lB,QAAAA,cAAc,EAAE5lB,SAJD;EAKf0lB,QAAAA,WAAW,EAAE1lB,SALE;EAMf+d,QAAAA,gBAAgB,EAAE/d,SANH;EAOfmnB,QAAAA,cAAc,EAAEnnB,SAPD;EAQf8lB,QAAAA,kBAAkB,EAAE9lB,SARL;EASf;EACA+lB,QAAAA,YAAY,EAAE,uDAVC;EAWf;EACAmC,QAAAA,aAAa,EAAEvc,GAAG,EAZH;EAaf0kB,QAAAA,YAAY,EAAErwB,SAbC;EAcf;EACA4nB,QAAAA,UAAU,EAAE,EAfG;EAgBfR,QAAAA,mBAAmB,EAAEpnB,SAhBN;EAiBf8jB,QAAAA,YAAY,EAAE9jB,SAjBC;EAkBf2lB,QAAAA,WAAW,EAAE3lB;EAlBE,OA7DJ;EAkFb;EACA0kB,MAAAA,UAAU,EAAE,IAnFC;EAqFb;EACAuB,MAAAA,cAAc,EAAExV,MAAM,CAACmB,MAAP,CAAcqU,cAtFjB;EAwFbvC,MAAAA,OAAO,EAAE;EACPuB,QAAAA,MAAM,EAAE,CADD;EAEPC,QAAAA,MAAM,EAAE,CAFD;EAGPN,QAAAA,QAAQ,EAAE,CAHH;EAIPG,QAAAA,QAAQ,EAAE,CAJH;EAKP5C,QAAAA,IAAI,EAAE;EALC,OAxFI;EAgGb;EACAuM,MAAAA,YAAY,EAAE,EAjGD;EAkGbC,MAAAA,YAAY,EAAE;EAlGD,KAAT,CAAN,CAlFmB;;EAwLnBle,IAAAA,MAAM,CAAC6C,UAAP;EAEA7C,IAAAA,MAAM,CAACgB,IAAP,CAAY,SAAZ,EA1LmB;;EA6LnB,QAAIhB,MAAM,CAACmB,MAAP,CAAcD,IAAlB,EAAwB;EACtBlB,MAAAA,MAAM,CAACkB,IAAP;EACD,KA/LkB;;;EAkMnB,WAAOlB,MAAP;EACD;;;;WAED+b,uBAAA,gCAAuB;EACrB,QAAM/b,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcud,YAAf,IAA+B,CAAC1e,MAAM,CAAChP,EAA3C,EAA+C;EAC/C,QAAMmB,OAAO,GAAG6N,MAAM,CAAChP,EAAP,CAAUoC,SAAV,CAAoBZ,KAApB,CAA0B,GAA1B,EAA+BrB,MAA/B,CAAsC,UAACiC,SAAD,EAAe;EACnE,aACEA,SAAS,CAACjE,OAAV,CAAkB,kBAAlB,MAA0C,CAA1C,IACAiE,SAAS,CAACjE,OAAV,CAAkB6Q,MAAM,CAACmB,MAAP,CAAc2a,sBAAhC,MAA4D,CAF9D;EAID,KALe,CAAhB;EAMA9b,IAAAA,MAAM,CAACgB,IAAP,CAAY,mBAAZ,EAAiC7O,OAAO,CAAC0J,IAAR,CAAa,GAAb,CAAjC;EACD;;WAEDgkB,kBAAA,yBAAgBna,OAAhB,EAAyB;EACvB,QAAM1F,MAAM,GAAG,IAAf;EAEA,WAAO0F,OAAO,CAACtS,SAAR,CACJZ,KADI,CACE,GADF,EAEJrB,MAFI,CAEG,UAACiC,SAAD,EAAe;EACrB,aACEA,SAAS,CAACjE,OAAV,CAAkB,cAAlB,MAAsC,CAAtC,IACAiE,SAAS,CAACjE,OAAV,CAAkB6Q,MAAM,CAACmB,MAAP,CAAciE,UAAhC,MAAgD,CAFlD;EAID,KAPI,EAQJvJ,IARI,CAQC,GARD,CAAP;EASD;;WAEDyQ,oBAAA,6BAAoB;EAClB,QAAMtM,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcud,YAAf,IAA+B,CAAC1e,MAAM,CAAChP,EAA3C,EAA+C;EAC/C,QAAM8uB,OAAO,GAAG,EAAhB;EACA9f,IAAAA,MAAM,CAACmF,MAAP,CAAc7M,IAAd,CAAmB,UAACoN,OAAD,EAAa;EAC9B,UAAMrT,UAAU,GAAG2N,MAAM,CAAC6f,eAAP,CAAuBna,OAAvB,CAAnB;EACAoa,MAAAA,OAAO,CAACpxB,IAAR,CAAa;EAAEgX,QAAAA,OAAO,EAAPA,OAAF;EAAWrT,QAAAA,UAAU,EAAVA;EAAX,OAAb;EACA2N,MAAAA,MAAM,CAACgB,IAAP,CAAY,aAAZ,EAA2B0E,OAA3B,EAAoCrT,UAApC;EACD,KAJD;EAKA2N,IAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ,EAA6B8e,OAA7B;EACD;;WAEDhP,uBAAA,gCAAuB;EACrB,QAAM9Q,MAAM,GAAG,IAAf;EADqB,QAEbmB,MAFa,GAEiDnB,MAFjD,CAEbmB,MAFa;EAAA,QAELgE,MAFK,GAEiDnF,MAFjD,CAELmF,MAFK;EAAA,QAEGI,UAFH,GAEiDvF,MAFjD,CAEGuF,UAFH;EAAA,QAEqBZ,UAFrB,GAEiD3E,MAFjD,CAEeoE,IAFf;EAAA,QAEiC6F,WAFjC,GAEiDjK,MAFjD,CAEiCiK,WAFjC;EAGrB,QAAI8V,GAAG,GAAG,CAAV;;EACA,QAAI5e,MAAM,CAACqH,cAAX,EAA2B;EACzB,UAAIrB,SAAS,GAAGhC,MAAM,CAAC8E,WAAD,CAAN,CAAoB1B,eAApC;EACA,UAAIyX,SAAJ;;EACA,WAAK,IAAI1uB,CAAC,GAAG2Y,WAAW,GAAG,CAA3B,EAA8B3Y,CAAC,GAAG6T,MAAM,CAAC3b,MAAzC,EAAiD8H,CAAC,IAAI,CAAtD,EAAyD;EACvD,YAAI6T,MAAM,CAAC7T,CAAD,CAAN,IAAa,CAAC0uB,SAAlB,EAA6B;EAC3B7Y,UAAAA,SAAS,IAAIhC,MAAM,CAAC7T,CAAD,CAAN,CAAUiX,eAAvB;EACAwX,UAAAA,GAAG,IAAI,CAAP;EACA,cAAI5Y,SAAS,GAAGxC,UAAhB,EAA4Bqb,SAAS,GAAG,IAAZ;EAC7B;EACF;;EACD,WAAK,IAAI1uB,EAAC,GAAG2Y,WAAW,GAAG,CAA3B,EAA8B3Y,EAAC,IAAI,CAAnC,EAAsCA,EAAC,IAAI,CAA3C,EAA8C;EAC5C,YAAI6T,MAAM,CAAC7T,EAAD,CAAN,IAAa,CAAC0uB,SAAlB,EAA6B;EAC3B7Y,UAAAA,SAAS,IAAIhC,MAAM,CAAC7T,EAAD,CAAN,CAAUiX,eAAvB;EACAwX,UAAAA,GAAG,IAAI,CAAP;EACA,cAAI5Y,SAAS,GAAGxC,UAAhB,EAA4Bqb,SAAS,GAAG,IAAZ;EAC7B;EACF;EACF,KAjBD,MAiBO;EACL,WAAK,IAAI1uB,GAAC,GAAG2Y,WAAW,GAAG,CAA3B,EAA8B3Y,GAAC,GAAG6T,MAAM,CAAC3b,MAAzC,EAAiD8H,GAAC,IAAI,CAAtD,EAAyD;EACvD,YAAIiU,UAAU,CAACjU,GAAD,CAAV,GAAgBiU,UAAU,CAAC0E,WAAD,CAA1B,GAA0CtF,UAA9C,EAA0D;EACxDob,UAAAA,GAAG,IAAI,CAAP;EACD;EACF;EACF;;EACD,WAAOA,GAAP;EACD;;WAED3N,SAAA,kBAAS;EACP,QAAMpS,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC;EAF1B,QAGCmF,QAHD,GAGsBtF,MAHtB,CAGCsF,QAHD;EAAA,QAGWnE,MAHX,GAGsBnB,MAHtB,CAGWmB,MAHX;;EAKP,QAAIA,MAAM,CAACyY,WAAX,EAAwB;EACtB5Z,MAAAA,MAAM,CAAC6Z,aAAP;EACD;;EACD7Z,IAAAA,MAAM,CAAC4D,UAAP;EACA5D,IAAAA,MAAM,CAACqE,YAAP;EACArE,IAAAA,MAAM,CAACiL,cAAP;EACAjL,IAAAA,MAAM,CAACyL,mBAAP;;EAEA,aAAS8B,YAAT,GAAwB;EACtB,UAAM0S,cAAc,GAAGjgB,MAAM,CAAC6E,YAAP,GAAsB7E,MAAM,CAACsK,SAAP,GAAmB,CAAC,CAA1C,GAA8CtK,MAAM,CAACsK,SAA5E;EACA,UAAM+D,YAAY,GAAGxH,IAAI,CAACiB,GAAL,CACnBjB,IAAI,CAACK,GAAL,CAAS+Y,cAAT,EAAyBjgB,MAAM,CAACoL,YAAP,EAAzB,CADmB,EAEnBpL,MAAM,CAAC2K,YAAP,EAFmB,CAArB;EAIA3K,MAAAA,MAAM,CAACuN,YAAP,CAAoBc,YAApB;EACArO,MAAAA,MAAM,CAACuM,iBAAP;EACAvM,MAAAA,MAAM,CAACyL,mBAAP;EACD;;EACD,QAAIyU,UAAJ;;EACA,QAAIlgB,MAAM,CAACmB,MAAP,CAAc+V,QAAlB,EAA4B;EAC1B3J,MAAAA,YAAY;;EACZ,UAAIvN,MAAM,CAACmB,MAAP,CAAcyJ,UAAlB,EAA8B;EAC5B5K,QAAAA,MAAM,CAAC4J,gBAAP;EACD;EACF,KALD,MAKO;EACL,UACE,CAAC5J,MAAM,CAACmB,MAAP,CAAc6F,aAAd,KAAgC,MAAhC,IAA0ChH,MAAM,CAACmB,MAAP,CAAc6F,aAAd,GAA8B,CAAzE,KACAhH,MAAM,CAACsL,KADP,IAEA,CAACtL,MAAM,CAACmB,MAAP,CAAcqH,cAHjB,EAIE;EACA0X,QAAAA,UAAU,GAAGlgB,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuB,CAAtC,EAAyC,CAAzC,EAA4C,KAA5C,EAAmD,IAAnD,CAAb;EACD,OAND,MAMO;EACL02B,QAAAA,UAAU,GAAGlgB,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACiK,WAAtB,EAAmC,CAAnC,EAAsC,KAAtC,EAA6C,IAA7C,CAAb;EACD;;EACD,UAAI,CAACiW,UAAL,EAAiB;EACf3S,QAAAA,YAAY;EACb;EACF;;EACD,QAAIpM,MAAM,CAACoI,aAAP,IAAwBjE,QAAQ,KAAKtF,MAAM,CAACsF,QAAhD,EAA0D;EACxDtF,MAAAA,MAAM,CAACwJ,aAAP;EACD;;EACDxJ,IAAAA,MAAM,CAACgB,IAAP,CAAY,QAAZ;EACD;;WAEDkb,kBAAA,yBAAgBiE,YAAhB,EAA8BC,UAA9B,EAAiD;EAAA,QAAnBA,UAAmB;EAAnBA,MAAAA,UAAmB,GAAN,IAAM;EAAA;;EAC/C,QAAMpgB,MAAM,GAAG,IAAf;EACA,QAAMqgB,gBAAgB,GAAGrgB,MAAM,CAACmB,MAAP,CAAcwN,SAAvC;;EACA,QAAI,CAACwR,YAAL,EAAmB;EACjB;EACAA,MAAAA,YAAY,GAAGE,gBAAgB,KAAK,YAArB,GAAoC,UAApC,GAAiD,YAAhE;EACD;;EACD,QACEF,YAAY,KAAKE,gBAAjB,IACCF,YAAY,KAAK,YAAjB,IAAiCA,YAAY,KAAK,UAFrD,EAGE;EACA,aAAOngB,MAAP;EACD;;EAEDA,IAAAA,MAAM,CAACoC,GAAP,CACGxP,WADH,MACkBoN,MAAM,CAACmB,MAAP,CAAc2a,sBADhC,GACyDuE,gBADzD,EAEGpuB,QAFH,MAEe+N,MAAM,CAACmB,MAAP,CAAc2a,sBAF7B,GAEsDqE,YAFtD;EAGAngB,IAAAA,MAAM,CAAC+b,oBAAP;EAEA/b,IAAAA,MAAM,CAACmB,MAAP,CAAcwN,SAAd,GAA0BwR,YAA1B;EAEAngB,IAAAA,MAAM,CAACmF,MAAP,CAAc7M,IAAd,CAAmB,UAACoN,OAAD,EAAa;EAC9B,UAAIya,YAAY,KAAK,UAArB,EAAiC;EAC/Bza,QAAAA,OAAO,CAAClb,KAAR,CAAcgU,KAAd,GAAsB,EAAtB;EACD,OAFD,MAEO;EACLkH,QAAAA,OAAO,CAAClb,KAAR,CAAckU,MAAd,GAAuB,EAAvB;EACD;EACF,KAND;EAQAsB,IAAAA,MAAM,CAACgB,IAAP,CAAY,iBAAZ;EACA,QAAIof,UAAJ,EAAgBpgB,MAAM,CAACoS,MAAP;EAEhB,WAAOpS,MAAP;EACD;;WAEDsgB,QAAA,eAAMtvB,EAAN,EAAU;EACR,QAAMgP,MAAM,GAAG,IAAf;EACA,QAAIA,MAAM,CAACugB,OAAX,EAAoB,OAAO,IAAP,CAFZ;;EAKR,QAAMne,GAAG,GAAG1Q,CAAC,CAACV,EAAE,IAAIgP,MAAM,CAACmB,MAAP,CAAcnQ,EAArB,CAAb;EACAA,IAAAA,EAAE,GAAGoR,GAAG,CAAC,CAAD,CAAR;;EAEA,QAAI,CAACpR,EAAL,EAAS;EACP,aAAO,KAAP;EACD;;EAEDA,IAAAA,EAAE,CAACgP,MAAH,GAAYA,MAAZ,CAZQ;;EAeR,QAAIsC,UAAJ;;EACA,QAAItR,EAAE,IAAIA,EAAE,CAAC6iB,UAAT,IAAuB7iB,EAAE,CAAC6iB,UAAH,CAAc7pB,aAAzC,EAAwD;EACtDsY,MAAAA,UAAU,GAAG5Q,CAAC,CAACV,EAAE,CAAC6iB,UAAH,CAAc7pB,aAAd,OAAgCgW,MAAM,CAACmB,MAAP,CAAcsd,YAA9C,CAAD,CAAd,CADsD;;EAGtDnc,MAAAA,UAAU,CAAChY,QAAX,GAAsB,UAACkX,OAAD;EAAA,eAAaY,GAAG,CAAC9X,QAAJ,CAAakX,OAAb,CAAb;EAAA,OAAtB;EACD,KAJD,MAIO;EACLc,MAAAA,UAAU,GAAGF,GAAG,CAAC9X,QAAJ,OAAiB0V,MAAM,CAACmB,MAAP,CAAcsd,YAA/B,CAAb;EACD;;EAEDv1B,IAAAA,QAAM,CAAC8W,MAAD,EAAS;EACboC,MAAAA,GAAG,EAAHA,GADa;EAEbpR,MAAAA,EAAE,EAAFA,EAFa;EAGbsR,MAAAA,UAAU,EAAVA,UAHa;EAIbmL,MAAAA,SAAS,EAAEnL,UAAU,CAAC,CAAD,CAJR;EAKbie,MAAAA,OAAO,EAAE,IALI;EAOb;EACA3b,MAAAA,GAAG,EAAE5T,EAAE,CAAC4d,GAAH,CAAOpP,WAAP,OAAyB,KAAzB,IAAkC4C,GAAG,CAACjK,GAAJ,CAAQ,WAAR,MAAyB,KARnD;EASb0M,MAAAA,YAAY,EACV7E,MAAM,CAACmB,MAAP,CAAcwN,SAAd,KAA4B,YAA5B,KACC3d,EAAE,CAAC4d,GAAH,CAAOpP,WAAP,OAAyB,KAAzB,IAAkC4C,GAAG,CAACjK,GAAJ,CAAQ,WAAR,MAAyB,KAD5D,CAVW;EAYb2M,MAAAA,QAAQ,EAAExC,UAAU,CAACnK,GAAX,CAAe,SAAf,MAA8B;EAZ3B,KAAT,CAAN;EAeA,WAAO,IAAP;EACD;;WAED+I,OAAA,cAAKlQ,EAAL,EAAS;EACP,QAAMgP,MAAM,GAAG,IAAf;EACA,QAAIA,MAAM,CAACI,WAAX,EAAwB,OAAOJ,MAAP;EAExB,QAAMugB,OAAO,GAAGvgB,MAAM,CAACsgB,KAAP,CAAatvB,EAAb,CAAhB;EACA,QAAIuvB,OAAO,KAAK,KAAhB,EAAuB,OAAOvgB,MAAP;EAEvBA,IAAAA,MAAM,CAACgB,IAAP,CAAY,YAAZ,EAPO;;EAUP,QAAIhB,MAAM,CAACmB,MAAP,CAAcyY,WAAlB,EAA+B;EAC7B5Z,MAAAA,MAAM,CAAC6Z,aAAP;EACD,KAZM;;;EAeP7Z,IAAAA,MAAM,CAACkd,UAAP,GAfO;;EAkBP,QAAIld,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtBlM,MAAAA,MAAM,CAACgR,UAAP;EACD,KApBM;;;EAuBPhR,IAAAA,MAAM,CAAC4D,UAAP,GAvBO;;EA0BP5D,IAAAA,MAAM,CAACqE,YAAP;;EAEA,QAAIrE,MAAM,CAACmB,MAAP,CAAcoI,aAAlB,EAAiC;EAC/BvJ,MAAAA,MAAM,CAACwJ,aAAP;EACD,KA9BM;;;EAiCP,QAAIxJ,MAAM,CAACmB,MAAP,CAAcyV,UAAlB,EAA8B;EAC5B5W,MAAAA,MAAM,CAAC6R,aAAP;EACD;;EAED,QAAI7R,MAAM,CAACmB,MAAP,CAAc6c,aAAlB,EAAiC;EAC/Bhe,MAAAA,MAAM,CAACge,aAAP;EACD,KAvCM;;;EA0CP,QAAIhe,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtBlM,MAAAA,MAAM,CAAC6O,OAAP,CACE7O,MAAM,CAACmB,MAAP,CAAc+N,YAAd,GAA6BlP,MAAM,CAAC6P,YADtC,EAEE,CAFF,EAGE7P,MAAM,CAACmB,MAAP,CAAc2L,kBAHhB;EAKD,KAND,MAMO;EACL9M,MAAAA,MAAM,CAAC6O,OAAP,CAAe7O,MAAM,CAACmB,MAAP,CAAc+N,YAA7B,EAA2C,CAA3C,EAA8ClP,MAAM,CAACmB,MAAP,CAAc2L,kBAA5D;EACD,KAlDM;;;EAqDP9M,IAAAA,MAAM,CAACya,YAAP,GArDO;;EAwDPza,IAAAA,MAAM,CAACI,WAAP,GAAqB,IAArB,CAxDO;;EA2DPJ,IAAAA,MAAM,CAACgB,IAAP,CAAY,MAAZ;EACAhB,IAAAA,MAAM,CAACgB,IAAP,CAAY,WAAZ;EAEA,WAAOhB,MAAP;EACD;;WAEDqB,UAAA,iBAAQmf,cAAR,EAA+BC,WAA/B,EAAmD;EAAA,QAA3CD,cAA2C;EAA3CA,MAAAA,cAA2C,GAA1B,IAA0B;EAAA;;EAAA,QAApBC,WAAoB;EAApBA,MAAAA,WAAoB,GAAN,IAAM;EAAA;;EACjD,QAAMzgB,MAAM,GAAG,IAAf;EADiD,QAEzCmB,MAFyC,GAELnB,MAFK,CAEzCmB,MAFyC;EAAA,QAEjCiB,GAFiC,GAELpC,MAFK,CAEjCoC,GAFiC;EAAA,QAE5BE,UAF4B,GAELtC,MAFK,CAE5BsC,UAF4B;EAAA,QAEhB6C,MAFgB,GAELnF,MAFK,CAEhBmF,MAFgB;;EAIjD,QAAI,OAAOnF,MAAM,CAACmB,MAAd,KAAyB,WAAzB,IAAwCnB,MAAM,CAACG,SAAnD,EAA8D;EAC5D,aAAO,IAAP;EACD;;EAEDH,IAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ,EARiD;;EAWjDhB,IAAAA,MAAM,CAACI,WAAP,GAAqB,KAArB,CAXiD;;EAcjDJ,IAAAA,MAAM,CAACkb,YAAP,GAdiD;;EAiBjD,QAAI/Z,MAAM,CAAC+K,IAAX,EAAiB;EACflM,MAAAA,MAAM,CAAC4R,WAAP;EACD,KAnBgD;;;EAsBjD,QAAI6O,WAAJ,EAAiB;EACfzgB,MAAAA,MAAM,CAACod,aAAP;EACAhb,MAAAA,GAAG,CAACtO,UAAJ,CAAe,OAAf;EACAwO,MAAAA,UAAU,CAACxO,UAAX,CAAsB,OAAtB;;EACA,UAAIqR,MAAM,IAAIA,MAAM,CAAC3b,MAArB,EAA6B;EAC3B2b,QAAAA,MAAM,CACHvS,WADH,CAEI,CACEuO,MAAM,CAACqJ,iBADT,EAEErJ,MAAM,CAACwK,gBAFT,EAGExK,MAAM,CAACyK,cAHT,EAIEzK,MAAM,CAAC0K,cAJT,EAKEhQ,IALF,CAKO,GALP,CAFJ,EASG/H,UATH,CASc,OATd,EAUGA,UAVH,CAUc,yBAVd;EAWD;EACF;;EAEDkM,IAAAA,MAAM,CAACgB,IAAP,CAAY,SAAZ,EAzCiD;;EA4CjD/X,IAAAA,MAAM,CAACI,IAAP,CAAY2W,MAAM,CAACmD,eAAnB,EAAoC7Z,OAApC,CAA4C,UAACk2B,SAAD,EAAe;EACzDxf,MAAAA,MAAM,CAACrK,GAAP,CAAW6pB,SAAX;EACD,KAFD;;EAIA,QAAIgB,cAAc,KAAK,KAAvB,EAA8B;EAC5BxgB,MAAAA,MAAM,CAACoC,GAAP,CAAW,CAAX,EAAcpC,MAAd,GAAuB,IAAvB;EACAlF,MAAAA,WAAW,CAACkF,MAAD,CAAX;EACD;;EACDA,IAAAA,MAAM,CAACG,SAAP,GAAmB,IAAnB;EAEA,WAAO,IAAP;EACD;;WAEMugB,iBAAP,wBAAsBC,WAAtB,EAAmC;EACjCz3B,IAAAA,QAAM,CAAC81B,gBAAD,EAAmB2B,WAAnB,CAAN;EACD;;WAUMC,gBAAP,uBAAqBhe,MAArB,EAA6B;EAC3B,QAAI,CAACqc,MAAM,CAAC7xB,SAAP,CAAiBsV,OAAtB,EAA+Buc,MAAM,CAAC7xB,SAAP,CAAiBsV,OAAjB,GAA2B,EAA3B;EAC/B,QAAM3C,IAAI,GAAG6C,MAAM,CAAC7C,IAAP,IAAkB9W,MAAM,CAACI,IAAP,CAAY41B,MAAM,CAAC7xB,SAAP,CAAiBsV,OAA7B,EAAsClZ,MAAxD,SAAkE0R,GAAG,EAAlF;EACA+jB,IAAAA,MAAM,CAAC7xB,SAAP,CAAiBsV,OAAjB,CAAyB3C,IAAzB,IAAiC6C,MAAjC;EACD;;WAEMie,MAAP,aAAWje,MAAX,EAAmB;EACjB,QAAIhS,KAAK,CAACK,OAAN,CAAc2R,MAAd,CAAJ,EAA2B;EACzBA,MAAAA,MAAM,CAACtZ,OAAP,CAAe,UAACw3B,CAAD;EAAA,eAAO7B,MAAM,CAAC2B,aAAP,CAAqBE,CAArB,CAAP;EAAA,OAAf;EACA,aAAO7B,MAAP;EACD;;EACDA,IAAAA,MAAM,CAAC2B,aAAP,CAAqBhe,MAArB;EACA,WAAOqc,MAAP;EACD;;;;0BArB6B;EAC5B,aAAOD,gBAAP;EACD;;;0BAEqB;EACpB,aAAOM,QAAP;EACD;;;;;;EAkBHr2B,MAAM,CAACI,IAAP,CAAYs1B,UAAZ,EAAwBr1B,OAAxB,CAAgC,UAACy3B,cAAD,EAAoB;EAClD93B,EAAAA,MAAM,CAACI,IAAP,CAAYs1B,UAAU,CAACoC,cAAD,CAAtB,EAAwCz3B,OAAxC,CAAgD,UAAC03B,WAAD,EAAiB;EAC/D/B,IAAAA,MAAM,CAAC7xB,SAAP,CAAiB4zB,WAAjB,IAAgCrC,UAAU,CAACoC,cAAD,CAAV,CAA2BC,WAA3B,CAAhC;EACD,GAFD;EAGD,CAJD;EAMA/B,MAAM,CAAC4B,GAAP,CAAW,CAACI,MAAD,EAAS3f,UAAT,CAAX;;ECjlBA,IAAM4f,OAAO,GAAG;EACd9O,EAAAA,MADc,kBACP+O,KADO,EACA;EACZ,QAAMnhB,MAAM,GAAG,IAAf;EADY,yBAE8CA,MAAM,CAACmB,MAFrD;EAAA,QAEJ6F,aAFI,kBAEJA,aAFI;EAAA,QAEWU,cAFX,kBAEWA,cAFX;EAAA,QAE2Bc,cAF3B,kBAE2BA,cAF3B;EAAA,gCAGgCxI,MAAM,CAACmB,MAAP,CAAc6D,OAH9C;EAAA,QAGJoc,eAHI,yBAGJA,eAHI;EAAA,QAGaC,cAHb,yBAGaA,cAHb;EAAA,0BAWRrhB,MAAM,CAACgF,OAXC;EAAA,QAKJsc,YALI,mBAKVC,IALU;EAAA,QAMNC,UANM,mBAMVnlB,EANU;EAAA,QAOV8I,MAPU,mBAOVA,MAPU;EAAA,QAQEsc,kBARF,mBAQVlc,UARU;EAAA,QASVmc,WATU,mBASVA,WATU;EAAA,QAUFC,cAVE,mBAUVnqB,MAVU;EAYZwI,IAAAA,MAAM,CAACuM,iBAAP;EACA,QAAMtC,WAAW,GAAGjK,MAAM,CAACiK,WAAP,IAAsB,CAA1C;EAEA,QAAI2X,UAAJ;EACA,QAAI5hB,MAAM,CAAC6E,YAAX,EAAyB+c,UAAU,GAAG,OAAb,CAAzB,KACKA,UAAU,GAAG5hB,MAAM,CAAC+D,YAAP,KAAwB,MAAxB,GAAiC,KAA9C;EAEL,QAAI8d,WAAJ;EACA,QAAIC,YAAJ;;EACA,QAAItZ,cAAJ,EAAoB;EAClBqZ,MAAAA,WAAW,GAAGhb,IAAI,CAACC,KAAL,CAAWE,aAAa,GAAG,CAA3B,IAAgCU,cAAhC,GAAiD2Z,cAA/D;EACAS,MAAAA,YAAY,GAAGjb,IAAI,CAACC,KAAL,CAAWE,aAAa,GAAG,CAA3B,IAAgCU,cAAhC,GAAiD0Z,eAAhE;EACD,KAHD,MAGO;EACLS,MAAAA,WAAW,GAAG7a,aAAa,IAAIU,cAAc,GAAG,CAArB,CAAb,GAAuC2Z,cAArD;EACAS,MAAAA,YAAY,GAAGpa,cAAc,GAAG0Z,eAAhC;EACD;;EACD,QAAMG,IAAI,GAAG1a,IAAI,CAACK,GAAL,CAAS,CAAC+C,WAAW,IAAI,CAAhB,IAAqB6X,YAA9B,EAA4C,CAA5C,CAAb;EACA,QAAMzlB,EAAE,GAAGwK,IAAI,CAACiB,GAAL,CAAS,CAACmC,WAAW,IAAI,CAAhB,IAAqB4X,WAA9B,EAA2C1c,MAAM,CAAC3b,MAAP,GAAgB,CAA3D,CAAX;EACA,QAAMgO,MAAM,GAAG,CAACwI,MAAM,CAACuF,UAAP,CAAkBgc,IAAlB,KAA2B,CAA5B,KAAkCvhB,MAAM,CAACuF,UAAP,CAAkB,CAAlB,KAAwB,CAA1D,CAAf;EAEArc,IAAAA,QAAM,CAAC8W,MAAM,CAACgF,OAAR,EAAiB;EACrBuc,MAAAA,IAAI,EAAJA,IADqB;EAErBllB,MAAAA,EAAE,EAAFA,EAFqB;EAGrB7E,MAAAA,MAAM,EAANA,MAHqB;EAIrB+N,MAAAA,UAAU,EAAEvF,MAAM,CAACuF;EAJE,KAAjB,CAAN;;EAOA,aAASwc,UAAT,GAAsB;EACpB/hB,MAAAA,MAAM,CAACqE,YAAP;EACArE,MAAAA,MAAM,CAACiL,cAAP;EACAjL,MAAAA,MAAM,CAACyL,mBAAP;;EACA,UAAIzL,MAAM,CAACgiB,IAAP,IAAehiB,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB/c,OAAtC,EAA+C;EAC7CjF,QAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACD;EACF;;EAED,QAAIX,YAAY,KAAKC,IAAjB,IAAyBC,UAAU,KAAKnlB,EAAxC,IAA8C,CAAC8kB,KAAnD,EAA0D;EACxD,UAAInhB,MAAM,CAACuF,UAAP,KAAsBkc,kBAAtB,IAA4CjqB,MAAM,KAAKmqB,cAA3D,EAA2E;EACzE3hB,QAAAA,MAAM,CAACmF,MAAP,CAAchN,GAAd,CAAkBypB,UAAlB,EAAiCpqB,MAAjC;EACD;;EACDwI,MAAAA,MAAM,CAACiL,cAAP;EACA;EACD;;EACD,QAAIjL,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBkd,cAA1B,EAA0C;EACxCliB,MAAAA,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBkd,cAAtB,CAAqC/zB,IAArC,CAA0C6R,MAA1C,EAAkD;EAChDxI,QAAAA,MAAM,EAANA,MADgD;EAEhD+pB,QAAAA,IAAI,EAAJA,IAFgD;EAGhDllB,QAAAA,EAAE,EAAFA,EAHgD;EAIhD8I,QAAAA,MAAM,EAAG,SAASgd,SAAT,GAAqB;EAC5B,cAAMC,cAAc,GAAG,EAAvB;;EACA,eAAK,IAAI9wB,CAAC,GAAGiwB,IAAb,EAAmBjwB,CAAC,IAAI+K,EAAxB,EAA4B/K,CAAC,IAAI,CAAjC,EAAoC;EAClC8wB,YAAAA,cAAc,CAAC1zB,IAAf,CAAoByW,MAAM,CAAC7T,CAAD,CAA1B;EACD;;EACD,iBAAO8wB,cAAP;EACD,SANO;EAJwC,OAAlD;;EAYA,UAAIpiB,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBqd,oBAA1B,EAAgD;EAC9CN,QAAAA,UAAU;EACX;;EACD;EACD;;EACD,QAAMO,cAAc,GAAG,EAAvB;EACA,QAAMC,aAAa,GAAG,EAAtB;;EACA,QAAIpB,KAAJ,EAAW;EACTnhB,MAAAA,MAAM,CAACsC,UAAP,CAAkB9H,IAAlB,OAA2BwF,MAAM,CAACmB,MAAP,CAAciE,UAAzC,EAAuDpS,MAAvD;EACD,KAFD,MAEO;EACL,WAAK,IAAI1B,CAAC,GAAGgwB,YAAb,EAA2BhwB,CAAC,IAAIkwB,UAAhC,EAA4ClwB,CAAC,IAAI,CAAjD,EAAoD;EAClD,YAAIA,CAAC,GAAGiwB,IAAJ,IAAYjwB,CAAC,GAAG+K,EAApB,EAAwB;EACtB2D,UAAAA,MAAM,CAACsC,UAAP,CACG9H,IADH,OACYwF,MAAM,CAACmB,MAAP,CAAciE,UAD1B,mCACiE9T,CADjE,UAEG0B,MAFH;EAGD;EACF;EACF;;EACD,SAAK,IAAI1B,EAAC,GAAG,CAAb,EAAgBA,EAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,EAAC,IAAI,CAAxC,EAA2C;EACzC,UAAIA,EAAC,IAAIiwB,IAAL,IAAajwB,EAAC,IAAI+K,EAAtB,EAA0B;EACxB,YAAI,OAAOmlB,UAAP,KAAsB,WAAtB,IAAqCL,KAAzC,EAAgD;EAC9CoB,UAAAA,aAAa,CAAC7zB,IAAd,CAAmB4C,EAAnB;EACD,SAFD,MAEO;EACL,cAAIA,EAAC,GAAGkwB,UAAR,EAAoBe,aAAa,CAAC7zB,IAAd,CAAmB4C,EAAnB;EACpB,cAAIA,EAAC,GAAGgwB,YAAR,EAAsBgB,cAAc,CAAC5zB,IAAf,CAAoB4C,EAApB;EACvB;EACF;EACF;;EACDixB,IAAAA,aAAa,CAACj5B,OAAd,CAAsB,UAACiP,KAAD,EAAW;EAC/ByH,MAAAA,MAAM,CAACsC,UAAP,CAAkBnJ,MAAlB,CAAyBuoB,WAAW,CAACvc,MAAM,CAAC5M,KAAD,CAAP,EAAgBA,KAAhB,CAApC;EACD,KAFD;EAGA+pB,IAAAA,cAAc,CACX1F,IADH,CACQ,UAACnuB,CAAD,EAAIouB,CAAJ;EAAA,aAAUA,CAAC,GAAGpuB,CAAd;EAAA,KADR,EAEGnF,OAFH,CAEW,UAACiP,KAAD,EAAW;EAClByH,MAAAA,MAAM,CAACsC,UAAP,CAAkB9I,OAAlB,CAA0BkoB,WAAW,CAACvc,MAAM,CAAC5M,KAAD,CAAP,EAAgBA,KAAhB,CAArC;EACD,KAJH;EAKAyH,IAAAA,MAAM,CAACsC,UAAP,CAAkBhY,QAAlB,CAA2B,eAA3B,EAA4C6N,GAA5C,CAAgDypB,UAAhD,EAA+DpqB,MAA/D;EACAuqB,IAAAA,UAAU;EACX,GA3Ga;EA4GdL,EAAAA,WA5Gc,uBA4GFpa,KA5GE,EA4GK/O,KA5GL,EA4GY;EACxB,QAAMyH,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAc6D,OAA7B;;EACA,QAAI7D,MAAM,CAACqhB,KAAP,IAAgBxiB,MAAM,CAACgF,OAAP,CAAewd,KAAf,CAAqBjqB,KAArB,CAApB,EAAiD;EAC/C,aAAOyH,MAAM,CAACgF,OAAP,CAAewd,KAAf,CAAqBjqB,KAArB,CAAP;EACD;;EACD,QAAMkqB,QAAQ,GAAGthB,MAAM,CAACugB,WAAP,GACbhwB,CAAC,CAACyP,MAAM,CAACugB,WAAP,CAAmBvzB,IAAnB,CAAwB6R,MAAxB,EAAgCsH,KAAhC,EAAuC/O,KAAvC,CAAD,CADY,GAEb7G,CAAC,mBACgBsO,MAAM,CAACmB,MAAP,CAAciE,UAD9B,qCACsE7M,KADtE,WACgF+O,KADhF,YAFL;EAKA,QAAI,CAACmb,QAAQ,CAAC/uB,IAAT,CAAc,yBAAd,CAAL,EAA+C+uB,QAAQ,CAAC/uB,IAAT,CAAc,yBAAd,EAAyC6E,KAAzC;EAC/C,QAAI4I,MAAM,CAACqhB,KAAX,EAAkBxiB,MAAM,CAACgF,OAAP,CAAewd,KAAf,CAAqBjqB,KAArB,IAA8BkqB,QAA9B;EAClB,WAAOA,QAAP;EACD,GA1Ha;EA2HdtQ,EAAAA,WA3Hc,uBA2HFhN,MA3HE,EA2HM;EAClB,QAAMnF,MAAM,GAAG,IAAf;;EACA,QAAI,OAAOmF,MAAP,KAAkB,QAAlB,IAA8B,YAAYA,MAA9C,EAAsD;EACpD,WAAK,IAAI7T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,YAAI6T,MAAM,CAAC7T,CAAD,CAAV,EAAe0O,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsBzW,IAAtB,CAA2ByW,MAAM,CAAC7T,CAAD,CAAjC;EAChB;EACF,KAJD,MAIO;EACL0O,MAAAA,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsBzW,IAAtB,CAA2ByW,MAA3B;EACD;;EACDnF,IAAAA,MAAM,CAACgF,OAAP,CAAeoN,MAAf,CAAsB,IAAtB;EACD,GArIa;EAsIdC,EAAAA,YAtIc,wBAsIDlN,MAtIC,EAsIO;EACnB,QAAMnF,MAAM,GAAG,IAAf;EACA,QAAMiK,WAAW,GAAGjK,MAAM,CAACiK,WAA3B;EACA,QAAIuC,cAAc,GAAGvC,WAAW,GAAG,CAAnC;EACA,QAAIyY,iBAAiB,GAAG,CAAxB;;EAEA,QAAI9xB,KAAK,CAACK,OAAN,CAAckU,MAAd,CAAJ,EAA2B;EACzB,WAAK,IAAI7T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,YAAI6T,MAAM,CAAC7T,CAAD,CAAV,EAAe0O,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsBrQ,OAAtB,CAA8BqQ,MAAM,CAAC7T,CAAD,CAApC;EAChB;;EACDkb,MAAAA,cAAc,GAAGvC,WAAW,GAAG9E,MAAM,CAAC3b,MAAtC;EACAk5B,MAAAA,iBAAiB,GAAGvd,MAAM,CAAC3b,MAA3B;EACD,KAND,MAMO;EACLwW,MAAAA,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsBrQ,OAAtB,CAA8BqQ,MAA9B;EACD;;EACD,QAAInF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBwd,KAA1B,EAAiC;EAC/B,UAAMA,KAAK,GAAGxiB,MAAM,CAACgF,OAAP,CAAewd,KAA7B;EACA,UAAMG,QAAQ,GAAG,EAAjB;EACA15B,MAAAA,MAAM,CAACI,IAAP,CAAYm5B,KAAZ,EAAmBl5B,OAAnB,CAA2B,UAACs5B,WAAD,EAAiB;EAC1C,YAAMC,SAAS,GAAGL,KAAK,CAACI,WAAD,CAAvB;EACA,YAAME,aAAa,GAAGD,SAAS,CAACnvB,IAAV,CAAe,yBAAf,CAAtB;;EACA,YAAIovB,aAAJ,EAAmB;EACjBD,UAAAA,SAAS,CAACnvB,IAAV,CAAe,yBAAf,EAA0CuQ,QAAQ,CAAC6e,aAAD,EAAgB,EAAhB,CAAR,GAA8B,CAAxE;EACD;;EACDH,QAAAA,QAAQ,CAAC1e,QAAQ,CAAC2e,WAAD,EAAc,EAAd,CAAR,GAA4BF,iBAA7B,CAAR,GAA0DG,SAA1D;EACD,OAPD;EAQA7iB,MAAAA,MAAM,CAACgF,OAAP,CAAewd,KAAf,GAAuBG,QAAvB;EACD;;EACD3iB,IAAAA,MAAM,CAACgF,OAAP,CAAeoN,MAAf,CAAsB,IAAtB;EACApS,IAAAA,MAAM,CAAC6O,OAAP,CAAerC,cAAf,EAA+B,CAA/B;EACD,GApKa;EAqKdmG,EAAAA,WArKc,uBAqKFC,aArKE,EAqKa;EACzB,QAAM5S,MAAM,GAAG,IAAf;EACA,QAAI,OAAO4S,aAAP,KAAyB,WAAzB,IAAwCA,aAAa,KAAK,IAA9D,EAAoE;EACpE,QAAI3I,WAAW,GAAGjK,MAAM,CAACiK,WAAzB;;EACA,QAAIrZ,KAAK,CAACK,OAAN,CAAc2hB,aAAd,CAAJ,EAAkC;EAChC,WAAK,IAAIthB,CAAC,GAAGshB,aAAa,CAACppB,MAAd,GAAuB,CAApC,EAAuC8H,CAAC,IAAI,CAA5C,EAA+CA,CAAC,IAAI,CAApD,EAAuD;EACrD0O,QAAAA,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsBnP,MAAtB,CAA6B4c,aAAa,CAACthB,CAAD,CAA1C,EAA+C,CAA/C;;EACA,YAAI0O,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBwd,KAA1B,EAAiC;EAC/B,iBAAOxiB,MAAM,CAACgF,OAAP,CAAewd,KAAf,CAAqB5P,aAAa,CAACthB,CAAD,CAAlC,CAAP;EACD;;EACD,YAAIshB,aAAa,CAACthB,CAAD,CAAb,GAAmB2Y,WAAvB,EAAoCA,WAAW,IAAI,CAAf;EACpCA,QAAAA,WAAW,GAAGpD,IAAI,CAACK,GAAL,CAAS+C,WAAT,EAAsB,CAAtB,CAAd;EACD;EACF,KATD,MASO;EACLjK,MAAAA,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsBnP,MAAtB,CAA6B4c,aAA7B,EAA4C,CAA5C;;EACA,UAAI5S,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBwd,KAA1B,EAAiC;EAC/B,eAAOxiB,MAAM,CAACgF,OAAP,CAAewd,KAAf,CAAqB5P,aAArB,CAAP;EACD;;EACD,UAAIA,aAAa,GAAG3I,WAApB,EAAiCA,WAAW,IAAI,CAAf;EACjCA,MAAAA,WAAW,GAAGpD,IAAI,CAACK,GAAL,CAAS+C,WAAT,EAAsB,CAAtB,CAAd;EACD;;EACDjK,IAAAA,MAAM,CAACgF,OAAP,CAAeoN,MAAf,CAAsB,IAAtB;EACApS,IAAAA,MAAM,CAAC6O,OAAP,CAAe5E,WAAf,EAA4B,CAA5B;EACD,GA5La;EA6Ld6I,EAAAA,eA7Lc,6BA6LI;EAChB,QAAM9S,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAACgF,OAAP,CAAeG,MAAf,GAAwB,EAAxB;;EACA,QAAInF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBwd,KAA1B,EAAiC;EAC/BxiB,MAAAA,MAAM,CAACgF,OAAP,CAAewd,KAAf,GAAuB,EAAvB;EACD;;EACDxiB,IAAAA,MAAM,CAACgF,OAAP,CAAeoN,MAAf,CAAsB,IAAtB;EACApS,IAAAA,MAAM,CAAC6O,OAAP,CAAe,CAAf,EAAkB,CAAlB;EACD;EArMa,CAAhB;AAwMA,kBAAe;EACb9O,EAAAA,IAAI,EAAE,SADO;EAEboB,EAAAA,MAAM,EAAE;EACN6D,IAAAA,OAAO,EAAE;EACPC,MAAAA,OAAO,EAAE,KADF;EAEPE,MAAAA,MAAM,EAAE,EAFD;EAGPqd,MAAAA,KAAK,EAAE,IAHA;EAIPd,MAAAA,WAAW,EAAE,IAJN;EAKPQ,MAAAA,cAAc,EAAE,IALT;EAMPG,MAAAA,oBAAoB,EAAE,IANf;EAOPjB,MAAAA,eAAe,EAAE,CAPV;EAQPC,MAAAA,cAAc,EAAE;EART;EADH,GAFK;EAcbh0B,EAAAA,MAda,oBAcJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBgF,MAAAA,OAAO,eACFkc,OADE;EAEL/b,QAAAA,MAAM,EAAEnF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBG,MAFzB;EAGLqd,QAAAA,KAAK,EAAE;EAHF;EADiB,KAAT,CAAjB;EAOD,GAvBY;EAwBbpuB,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EACjB,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAA3B,EAAoC;EACpCjF,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EACA,UAAMkH,eAAe,GAAG;EACtBvZ,QAAAA,mBAAmB,EAAE;EADC,OAAxB;EAGAvgB,MAAAA,QAAM,CAAC8W,MAAM,CAACmB,MAAR,EAAgB6hB,eAAhB,CAAN;EACA95B,MAAAA,QAAM,CAAC8W,MAAM,CAAC2b,cAAR,EAAwBqH,eAAxB,CAAN;;EAEA,UAAI,CAAChjB,MAAM,CAACmB,MAAP,CAAc+N,YAAnB,EAAiC;EAC/BlP,QAAAA,MAAM,CAACgF,OAAP,CAAeoN,MAAf;EACD;EACF,KAbC;EAcF7E,IAAAA,YAdE,wBAcWvN,MAdX,EAcmB;EACnB,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAA3B,EAAoC;EACpCjF,MAAAA,MAAM,CAACgF,OAAP,CAAeoN,MAAf;EACD;EAjBC;EAxBS,CAAf;;ECvMA,IAAM6Q,QAAQ,GAAG;EACfC,EAAAA,MADe,kBACR5tB,KADQ,EACD;EACZ,QAAM0K,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAMtB,QAAQ,GAAGF,WAAW,EAA5B;EAHY,QAIUsZ,GAJV,GAIkB5E,MAJlB,CAIJ6E,YAJI;EAKZ,QAAIzW,CAAC,GAAGkH,KAAR;EACA,QAAIlH,CAAC,CAAC8kB,aAAN,EAAqB9kB,CAAC,GAAGA,CAAC,CAAC8kB,aAAN,CANT;;EAOZ,QAAMiQ,EAAE,GAAG/0B,CAAC,CAACg1B,OAAF,IAAah1B,CAAC,CAACi1B,QAA1B;EACA,QAAMC,UAAU,GAAGtjB,MAAM,CAACmB,MAAP,CAAcoiB,QAAd,CAAuBD,UAA1C;EACA,QAAME,QAAQ,GAAGF,UAAU,IAAIH,EAAE,KAAK,EAAtC;EACA,QAAMM,UAAU,GAAGH,UAAU,IAAIH,EAAE,KAAK,EAAxC;EACA,QAAMO,WAAW,GAAGP,EAAE,KAAK,EAA3B;EACA,QAAMQ,YAAY,GAAGR,EAAE,KAAK,EAA5B;EACA,QAAMS,SAAS,GAAGT,EAAE,KAAK,EAAzB;EACA,QAAMU,WAAW,GAAGV,EAAE,KAAK,EAA3B,CAdY;;EAgBZ,QACE,CAACnjB,MAAM,CAACsP,cAAR,KACEtP,MAAM,CAAC+D,YAAP,MAAyB4f,YAA1B,IACE3jB,MAAM,CAACgE,UAAP,MAAuB6f,WADzB,IAECJ,UAHF,CADF,EAKE;EACA,aAAO,KAAP;EACD;;EACD,QACE,CAACzjB,MAAM,CAACuP,cAAR,KACEvP,MAAM,CAAC+D,YAAP,MAAyB2f,WAA1B,IAA2C1jB,MAAM,CAACgE,UAAP,MAAuB4f,SAAlE,IAAgFJ,QADjF,CADF,EAGE;EACA,aAAO,KAAP;EACD;;EACD,QAAIp1B,CAAC,CAAC01B,QAAF,IAAc11B,CAAC,CAAC21B,MAAhB,IAA0B31B,CAAC,CAAC41B,OAA5B,IAAuC51B,CAAC,CAAC61B,OAA7C,EAAsD;EACpD,aAAO10B,SAAP;EACD;;EACD,QACE/D,QAAQ,CAAC3B,aAAT,IACA2B,QAAQ,CAAC3B,aAAT,CAAuBE,QADvB,KAECyB,QAAQ,CAAC3B,aAAT,CAAuBE,QAAvB,CAAgCyV,WAAhC,OAAkD,OAAlD,IACChU,QAAQ,CAAC3B,aAAT,CAAuBE,QAAvB,CAAgCyV,WAAhC,OAAkD,UAHpD,CADF,EAKE;EACA,aAAOjQ,SAAP;EACD;;EACD,QACEyQ,MAAM,CAACmB,MAAP,CAAcoiB,QAAd,CAAuBW,cAAvB,KACCV,QAAQ,IAAIC,UAAZ,IAA0BC,WAA1B,IAAyCC,YAAzC,IAAyDC,SAAzD,IAAsEC,WADvE,CADF,EAGE;EACA,UAAIM,MAAM,GAAG,KAAb,CADA;;EAGA,UACEnkB,MAAM,CAACoC,GAAP,CAAWnN,OAAX,OAAuB+K,MAAM,CAACmB,MAAP,CAAciE,UAArC,EAAmD5b,MAAnD,GAA4D,CAA5D,IACAwW,MAAM,CAACoC,GAAP,CAAWnN,OAAX,OAAuB+K,MAAM,CAACmB,MAAP,CAAcwK,gBAArC,EAAyDniB,MAAzD,KAAoE,CAFtE,EAGE;EACA,eAAO+F,SAAP;EACD;;EAED,UAAM6S,GAAG,GAAGpC,MAAM,CAACoC,GAAnB;EACA,UAAMgiB,WAAW,GAAGhiB,GAAG,CAAC,CAAD,CAAH,CAAOyB,WAA3B;EACA,UAAMwgB,YAAY,GAAGjiB,GAAG,CAAC,CAAD,CAAH,CAAO0B,YAA5B;EACA,UAAMwgB,WAAW,GAAGt3B,MAAM,CAAC8nB,UAA3B;EACA,UAAMyP,YAAY,GAAGv3B,MAAM,CAACuvB,WAA5B;EACA,UAAMiI,YAAY,GAAGxkB,MAAM,CAACoC,GAAP,CAAW5K,MAAX,EAArB;EACA,UAAIoN,GAAJ,EAAS4f,YAAY,CAACtsB,IAAb,IAAqB8H,MAAM,CAACoC,GAAP,CAAW,CAAX,EAAcrK,UAAnC;EACT,UAAM0sB,WAAW,GAAG,CAClB,CAACD,YAAY,CAACtsB,IAAd,EAAoBssB,YAAY,CAACvsB,GAAjC,CADkB,EAElB,CAACusB,YAAY,CAACtsB,IAAb,GAAoBksB,WAArB,EAAkCI,YAAY,CAACvsB,GAA/C,CAFkB,EAGlB,CAACusB,YAAY,CAACtsB,IAAd,EAAoBssB,YAAY,CAACvsB,GAAb,GAAmBosB,YAAvC,CAHkB,EAIlB,CAACG,YAAY,CAACtsB,IAAb,GAAoBksB,WAArB,EAAkCI,YAAY,CAACvsB,GAAb,GAAmBosB,YAArD,CAJkB,CAApB;;EAMA,WAAK,IAAI/yB,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGmzB,WAAW,CAACj7B,MAAhC,EAAwC8H,CAAC,IAAI,CAA7C,EAAgD;EAC9C,YAAMmrB,KAAK,GAAGgI,WAAW,CAACnzB,CAAD,CAAzB;;EACA,YAAImrB,KAAK,CAAC,CAAD,CAAL,IAAY,CAAZ,IAAiBA,KAAK,CAAC,CAAD,CAAL,IAAY6H,WAA7B,IAA4C7H,KAAK,CAAC,CAAD,CAAL,IAAY,CAAxD,IAA6DA,KAAK,CAAC,CAAD,CAAL,IAAY8H,YAA7E,EAA2F;EACzF,cAAI9H,KAAK,CAAC,CAAD,CAAL,KAAa,CAAb,IAAkBA,KAAK,CAAC,CAAD,CAAL,KAAa,CAAnC,EAAsC,SADmD;;EAEzF0H,UAAAA,MAAM,GAAG,IAAT;EACD;EACF;;EACD,UAAI,CAACA,MAAL,EAAa,OAAO50B,SAAP;EACd;;EACD,QAAIyQ,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB,UAAIyf,QAAQ,IAAIC,UAAZ,IAA0BC,WAA1B,IAAyCC,YAA7C,EAA2D;EACzD,YAAIv1B,CAAC,CAAC2mB,cAAN,EAAsB3mB,CAAC,CAAC2mB,cAAF,GAAtB,KACK3mB,CAAC,CAACs2B,WAAF,GAAgB,KAAhB;EACN;;EACD,UAAK,CAACjB,UAAU,IAAIE,YAAf,KAAgC,CAAC/e,GAAlC,IAA2C,CAAC4e,QAAQ,IAAIE,WAAb,KAA6B9e,GAA5E,EACE5E,MAAM,CAAC8P,SAAP;EACF,UAAK,CAAC0T,QAAQ,IAAIE,WAAb,KAA6B,CAAC9e,GAA/B,IAAwC,CAAC6e,UAAU,IAAIE,YAAf,KAAgC/e,GAA5E,EACE5E,MAAM,CAACmQ,SAAP;EACH,KATD,MASO;EACL,UAAIqT,QAAQ,IAAIC,UAAZ,IAA0BG,SAA1B,IAAuCC,WAA3C,EAAwD;EACtD,YAAIz1B,CAAC,CAAC2mB,cAAN,EAAsB3mB,CAAC,CAAC2mB,cAAF,GAAtB,KACK3mB,CAAC,CAACs2B,WAAF,GAAgB,KAAhB;EACN;;EACD,UAAIjB,UAAU,IAAII,WAAlB,EAA+B7jB,MAAM,CAAC8P,SAAP;EAC/B,UAAI0T,QAAQ,IAAII,SAAhB,EAA2B5jB,MAAM,CAACmQ,SAAP;EAC5B;;EACDnQ,IAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ,EAAwBmiB,EAAxB;EACA,WAAO5zB,SAAP;EACD,GAhGc;EAiGfo1B,EAAAA,MAjGe,oBAiGN;EACP,QAAM3kB,MAAM,GAAG,IAAf;EACA,QAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EACA,QAAI0U,MAAM,CAACujB,QAAP,CAAgBte,OAApB,EAA6B;EAC7BvT,IAAAA,CAAC,CAAClG,QAAD,CAAD,CAAY4I,EAAZ,CAAe,SAAf,EAA0B4L,MAAM,CAACujB,QAAP,CAAgBL,MAA1C;EACAljB,IAAAA,MAAM,CAACujB,QAAP,CAAgBte,OAAhB,GAA0B,IAA1B;EACD,GAvGc;EAwGf2f,EAAAA,OAxGe,qBAwGL;EACR,QAAM5kB,MAAM,GAAG,IAAf;EACA,QAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EACA,QAAI,CAAC0U,MAAM,CAACujB,QAAP,CAAgBte,OAArB,EAA8B;EAC9BvT,IAAAA,CAAC,CAAClG,QAAD,CAAD,CAAYmK,GAAZ,CAAgB,SAAhB,EAA2BqK,MAAM,CAACujB,QAAP,CAAgBL,MAA3C;EACAljB,IAAAA,MAAM,CAACujB,QAAP,CAAgBte,OAAhB,GAA0B,KAA1B;EACD;EA9Gc,CAAjB;AAiHA,mBAAe;EACblF,EAAAA,IAAI,EAAE,UADO;EAEboB,EAAAA,MAAM,EAAE;EACNoiB,IAAAA,QAAQ,EAAE;EACRte,MAAAA,OAAO,EAAE,KADD;EAERif,MAAAA,cAAc,EAAE,IAFR;EAGRZ,MAAAA,UAAU,EAAE;EAHJ;EADJ,GAFK;EASbj2B,EAAAA,MATa,oBASJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBujB,MAAAA,QAAQ;EACNte,QAAAA,OAAO,EAAE;EADH,SAEHge,QAFG;EADgB,KAAT,CAAjB;EAMD,GAjBY;EAkBb7uB,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACX,UAAIA,MAAM,CAACmB,MAAP,CAAcoiB,QAAd,CAAuBte,OAA3B,EAAoC;EAClCjF,QAAAA,MAAM,CAACujB,QAAP,CAAgBoB,MAAhB;EACD;EACF,KALC;EAMFtjB,IAAAA,OANE,mBAMMrB,MANN,EAMc;EACd,UAAIA,MAAM,CAACujB,QAAP,CAAgBte,OAApB,EAA6B;EAC3BjF,QAAAA,MAAM,CAACujB,QAAP,CAAgBqB,OAAhB;EACD;EACF;EAVC;EAlBS,CAAf;;ECjHA,SAASC,gBAAT,GAA4B;EAC1B,MAAMr5B,QAAQ,GAAGF,WAAW,EAA5B;EACA,MAAMk0B,SAAS,GAAG,SAAlB;EACA,MAAIsF,WAAW,IAAGtF,SAAS,IAAIh0B,QAAhB,CAAf;;EAEA,MAAI,CAACs5B,WAAL,EAAkB;EAChB,QAAMC,OAAO,GAAGv5B,QAAQ,CAACnB,aAAT,CAAuB,KAAvB,CAAhB;EACA06B,IAAAA,OAAO,CAACt6B,YAAR,CAAqB+0B,SAArB,EAAgC,SAAhC;EACAsF,IAAAA,WAAW,GAAG,OAAOC,OAAO,CAACvF,SAAD,CAAd,KAA8B,UAA5C;EACD;;EAED,MACE,CAACsF,WAAD,IACAt5B,QAAQ,CAACw5B,cADT,IAEAx5B,QAAQ,CAACw5B,cAAT,CAAwBC,UAFxB;EAIA;EACAz5B,EAAAA,QAAQ,CAACw5B,cAAT,CAAwBC,UAAxB,CAAmC,EAAnC,EAAuC,EAAvC,MAA+C,IANjD,EAOE;EACA;EACAH,IAAAA,WAAW,GAAGt5B,QAAQ,CAACw5B,cAAT,CAAwBC,UAAxB,CAAmC,cAAnC,EAAmD,KAAnD,CAAd;EACD;;EAED,SAAOH,WAAP;EACD;;EACD,IAAMI,UAAU,GAAG;EACjBC,EAAAA,cAAc,EAAEjqB,GAAG,EADF;EAEjBkqB,EAAAA,mBAAmB,EAAE71B,SAFJ;EAGjB81B,EAAAA,iBAAiB,EAAE,EAHF;EAIjB/vB,EAAAA,KAJiB,mBAIT;EACN,QAAMtI,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAIE,MAAM,CAACtB,SAAP,CAAiBC,SAAjB,CAA2BwD,OAA3B,CAAmC,SAAnC,IAAgD,CAAC,CAArD,EAAwD,OAAO,gBAAP;EACxD,WAAO01B,gBAAgB,KAAK,OAAL,GAAe,YAAtC;EACD,GARgB;EASjBzU,EAAAA,SATiB,qBASPhiB,CATO,EASJ;EACX;EACA,QAAMk3B,UAAU,GAAG,EAAnB;EACA,QAAMC,WAAW,GAAG,EAApB;EACA,QAAMC,WAAW,GAAG,GAApB;EAEA,QAAIC,EAAE,GAAG,CAAT;EACA,QAAIC,EAAE,GAAG,CAAT,CAPW;;EAQX,QAAIC,EAAE,GAAG,CAAT;EACA,QAAIC,EAAE,GAAG,CAAT,CATW;EAWX;;EACA,QAAI,YAAYx3B,CAAhB,EAAmB;EACjBs3B,MAAAA,EAAE,GAAGt3B,CAAC,CAACkI,MAAP;EACD;;EACD,QAAI,gBAAgBlI,CAApB,EAAuB;EACrBs3B,MAAAA,EAAE,GAAG,CAACt3B,CAAC,CAACy3B,UAAH,GAAgB,GAArB;EACD;;EACD,QAAI,iBAAiBz3B,CAArB,EAAwB;EACtBs3B,MAAAA,EAAE,GAAG,CAACt3B,CAAC,CAAC03B,WAAH,GAAiB,GAAtB;EACD;;EACD,QAAI,iBAAiB13B,CAArB,EAAwB;EACtBq3B,MAAAA,EAAE,GAAG,CAACr3B,CAAC,CAAC23B,WAAH,GAAiB,GAAtB;EACD,KAvBU;;;EA0BX,QAAI,UAAU33B,CAAV,IAAeA,CAAC,CAACiN,IAAF,KAAWjN,CAAC,CAAC43B,eAAhC,EAAiD;EAC/CP,MAAAA,EAAE,GAAGC,EAAL;EACAA,MAAAA,EAAE,GAAG,CAAL;EACD;;EAEDC,IAAAA,EAAE,GAAGF,EAAE,GAAGH,UAAV;EACAM,IAAAA,EAAE,GAAGF,EAAE,GAAGJ,UAAV;;EAEA,QAAI,YAAYl3B,CAAhB,EAAmB;EACjBw3B,MAAAA,EAAE,GAAGx3B,CAAC,CAAC63B,MAAP;EACD;;EACD,QAAI,YAAY73B,CAAhB,EAAmB;EACjBu3B,MAAAA,EAAE,GAAGv3B,CAAC,CAAC83B,MAAP;EACD;;EAED,QAAI93B,CAAC,CAAC01B,QAAF,IAAc,CAAC6B,EAAnB,EAAuB;EACrB;EACAA,MAAAA,EAAE,GAAGC,EAAL;EACAA,MAAAA,EAAE,GAAG,CAAL;EACD;;EAED,QAAI,CAACD,EAAE,IAAIC,EAAP,KAAcx3B,CAAC,CAAC+3B,SAApB,EAA+B;EAC7B,UAAI/3B,CAAC,CAAC+3B,SAAF,KAAgB,CAApB,EAAuB;EACrB;EACAR,QAAAA,EAAE,IAAIJ,WAAN;EACAK,QAAAA,EAAE,IAAIL,WAAN;EACD,OAJD,MAIO;EACL;EACAI,QAAAA,EAAE,IAAIH,WAAN;EACAI,QAAAA,EAAE,IAAIJ,WAAN;EACD;EACF,KAzDU;;;EA4DX,QAAIG,EAAE,IAAI,CAACF,EAAX,EAAe;EACbA,MAAAA,EAAE,GAAGE,EAAE,GAAG,CAAL,GAAS,CAAC,CAAV,GAAc,CAAnB;EACD;;EACD,QAAIC,EAAE,IAAI,CAACF,EAAX,EAAe;EACbA,MAAAA,EAAE,GAAGE,EAAE,GAAG,CAAL,GAAS,CAAC,CAAV,GAAc,CAAnB;EACD;;EAED,WAAO;EACLQ,MAAAA,KAAK,EAAEX,EADF;EAELY,MAAAA,KAAK,EAAEX,EAFF;EAGLY,MAAAA,MAAM,EAAEX,EAHH;EAILY,MAAAA,MAAM,EAAEX;EAJH,KAAP;EAMD,GAlFgB;EAmFjBY,EAAAA,gBAnFiB,8BAmFE;EACjB,QAAMxmB,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAACymB,YAAP,GAAsB,IAAtB;EACD,GAtFgB;EAuFjBC,EAAAA,gBAvFiB,8BAuFE;EACjB,QAAM1mB,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAACymB,YAAP,GAAsB,KAAtB;EACD,GA1FgB;EA2FjBvD,EAAAA,MA3FiB,kBA2FV5tB,KA3FU,EA2FH;EACZ,QAAIlH,CAAC,GAAGkH,KAAR;EACA,QAAIwhB,mBAAmB,GAAG,IAA1B;EACA,QAAM9W,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcwlB,UAA7B;;EAEA,QAAI3mB,MAAM,CAACmB,MAAP,CAAcyE,OAAlB,EAA2B;EACzBxX,MAAAA,CAAC,CAAC2mB,cAAF;EACD;;EAED,QAAI5rB,MAAM,GAAG6W,MAAM,CAACoC,GAApB;;EACA,QAAIpC,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyBC,YAAzB,KAA0C,WAA9C,EAA2D;EACzDz9B,MAAAA,MAAM,GAAGuI,CAAC,CAACsO,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyBC,YAA1B,CAAV;EACD;;EACD,QAAI,CAAC5mB,MAAM,CAACymB,YAAR,IAAwB,CAACt9B,MAAM,CAAC,CAAD,CAAN,CAAUsK,QAAV,CAAmBrF,CAAC,CAACjF,MAArB,CAAzB,IAAyD,CAACgY,MAAM,CAAC0lB,cAArE,EACE,OAAO,IAAP;EAEF,QAAIz4B,CAAC,CAAC8kB,aAAN,EAAqB9kB,CAAC,GAAGA,CAAC,CAAC8kB,aAAN,CAjBT;;EAkBZ,QAAI4T,KAAK,GAAG,CAAZ;EACA,QAAMC,SAAS,GAAG/mB,MAAM,CAAC6E,YAAP,GAAsB,CAAC,CAAvB,GAA2B,CAA7C;EAEA,QAAMpO,IAAI,GAAGyuB,UAAU,CAAC9U,SAAX,CAAqBhiB,CAArB,CAAb;;EAEA,QAAI+S,MAAM,CAAC6lB,WAAX,EAAwB;EACtB,UAAIhnB,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB,YAAI8C,IAAI,CAAC4B,GAAL,CAAShS,IAAI,CAAC6vB,MAAd,IAAwBzf,IAAI,CAAC4B,GAAL,CAAShS,IAAI,CAAC8vB,MAAd,CAA5B,EAAmDO,KAAK,GAAG,CAACrwB,IAAI,CAAC6vB,MAAN,GAAeS,SAAvB,CAAnD,KACK,OAAO,IAAP;EACN,OAHD,MAGO,IAAIlgB,IAAI,CAAC4B,GAAL,CAAShS,IAAI,CAAC8vB,MAAd,IAAwB1f,IAAI,CAAC4B,GAAL,CAAShS,IAAI,CAAC6vB,MAAd,CAA5B,EAAmDQ,KAAK,GAAG,CAACrwB,IAAI,CAAC8vB,MAAd,CAAnD,KACF,OAAO,IAAP;EACN,KAND,MAMO;EACLO,MAAAA,KAAK,GACHjgB,IAAI,CAAC4B,GAAL,CAAShS,IAAI,CAAC6vB,MAAd,IAAwBzf,IAAI,CAAC4B,GAAL,CAAShS,IAAI,CAAC8vB,MAAd,CAAxB,GAAgD,CAAC9vB,IAAI,CAAC6vB,MAAN,GAAeS,SAA/D,GAA2E,CAACtwB,IAAI,CAAC8vB,MADnF;EAED;;EAED,QAAIO,KAAK,KAAK,CAAd,EAAiB,OAAO,IAAP;EAEjB,QAAI3lB,MAAM,CAAC8lB,MAAX,EAAmBH,KAAK,GAAG,CAACA,KAAT,CApCP;;EAuCZ,QAAII,SAAS,GAAGlnB,MAAM,CAAC5E,YAAP,KAAwB0rB,KAAK,GAAG3lB,MAAM,CAACgmB,WAAvD;EAEA,QAAID,SAAS,IAAIlnB,MAAM,CAAC2K,YAAP,EAAjB,EAAwCuc,SAAS,GAAGlnB,MAAM,CAAC2K,YAAP,EAAZ;EACxC,QAAIuc,SAAS,IAAIlnB,MAAM,CAACoL,YAAP,EAAjB,EAAwC8b,SAAS,GAAGlnB,MAAM,CAACoL,YAAP,EAAZ,CA1C5B;EA6CZ;EACA;EACA;EACA;EACA;EACA;;EACA0L,IAAAA,mBAAmB,GAAG9W,MAAM,CAACmB,MAAP,CAAc+K,IAAd,GAClB,IADkB,GAElB,EAAEgb,SAAS,KAAKlnB,MAAM,CAAC2K,YAAP,EAAd,IAAuCuc,SAAS,KAAKlnB,MAAM,CAACoL,YAAP,EAAvD,CAFJ;EAIA,QAAI0L,mBAAmB,IAAI9W,MAAM,CAACmB,MAAP,CAAcqV,MAAzC,EAAiDpoB,CAAC,CAACqoB,eAAF;;EAEjD,QAAI,CAACzW,MAAM,CAACmB,MAAP,CAAc+V,QAAnB,EAA6B;EAC3B;EACA,UAAMkQ,QAAQ,GAAG;EACf/P,QAAAA,IAAI,EAAEnc,GAAG,EADM;EAEf4rB,QAAAA,KAAK,EAAEjgB,IAAI,CAAC4B,GAAL,CAASqe,KAAT,CAFQ;EAGfnY,QAAAA,SAAS,EAAE9H,IAAI,CAACwgB,IAAL,CAAUP,KAAV,CAHI;EAIfQ,QAAAA,GAAG,EAAEhyB;EAJU,OAAjB,CAF2B;;EAU3B,UAAM+vB,iBAAiB,GAAGrlB,MAAM,CAAC2mB,UAAP,CAAkBtB,iBAA5C;;EACA,UAAIA,iBAAiB,CAAC77B,MAAlB,IAA4B,CAAhC,EAAmC;EACjC67B,QAAAA,iBAAiB,CAACkC,KAAlB,GADiC;EAElC;;EACD,UAAMC,SAAS,GAAGnC,iBAAiB,CAAC77B,MAAlB,GACd67B,iBAAiB,CAACA,iBAAiB,CAAC77B,MAAlB,GAA2B,CAA5B,CADH,GAEd+F,SAFJ;EAGA81B,MAAAA,iBAAiB,CAAC32B,IAAlB,CAAuB04B,QAAvB,EAjB2B;EAoB3B;EACA;EACA;EACA;EACA;;EACA,UAAII,SAAJ,EAAe;EACb,YACEJ,QAAQ,CAACzY,SAAT,KAAuB6Y,SAAS,CAAC7Y,SAAjC,IACAyY,QAAQ,CAACN,KAAT,GAAiBU,SAAS,CAACV,KAD3B,IAEAM,QAAQ,CAAC/P,IAAT,GAAgBmQ,SAAS,CAACnQ,IAAV,GAAiB,GAHnC,EAIE;EACArX,UAAAA,MAAM,CAAC2mB,UAAP,CAAkBc,aAAlB,CAAgCL,QAAhC;EACD;EACF,OARD,MAQO;EACLpnB,QAAAA,MAAM,CAAC2mB,UAAP,CAAkBc,aAAlB,CAAgCL,QAAhC;EACD,OAnC0B;EAsC3B;;;EACA,UAAIpnB,MAAM,CAAC2mB,UAAP,CAAkBe,aAAlB,CAAgCN,QAAhC,CAAJ,EAA+C;EAC7C,eAAO,IAAP;EACD;EACF,KA1CD,MA0CO;EACL;EAEA;EACA;EACA;EACA;EACA,UAAMA,SAAQ,GAAG;EACf/P,QAAAA,IAAI,EAAEnc,GAAG,EADM;EAEf4rB,QAAAA,KAAK,EAAEjgB,IAAI,CAAC4B,GAAL,CAASqe,KAAT,CAFQ;EAGfnY,QAAAA,SAAS,EAAE9H,IAAI,CAACwgB,IAAL,CAAUP,KAAV;EAHI,OAAjB;EAPK,UAYG1B,mBAZH,GAY2BplB,MAAM,CAAC2mB,UAZlC,CAYGvB,mBAZH;EAaL,UAAMuC,iBAAiB,GACrBvC,mBAAmB,IACnBgC,SAAQ,CAAC/P,IAAT,GAAgB+N,mBAAmB,CAAC/N,IAApB,GAA2B,GAD3C,IAEA+P,SAAQ,CAACN,KAAT,IAAkB1B,mBAAmB,CAAC0B,KAFtC,IAGAM,SAAQ,CAACzY,SAAT,KAAuByW,mBAAmB,CAACzW,SAJ7C;;EAKA,UAAI,CAACgZ,iBAAL,EAAwB;EACtB3nB,QAAAA,MAAM,CAAC2mB,UAAP,CAAkBvB,mBAAlB,GAAwC71B,SAAxC;;EAEA,YAAIyQ,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtBlM,UAAAA,MAAM,CAACiQ,OAAP;EACD;;EACD,YAAImH,QAAQ,GAAGpX,MAAM,CAAC5E,YAAP,KAAwB0rB,KAAK,GAAG3lB,MAAM,CAACgmB,WAAtD;EACA,YAAM5b,YAAY,GAAGvL,MAAM,CAACqL,WAA5B;EACA,YAAMG,MAAM,GAAGxL,MAAM,CAACsL,KAAtB;EAEA,YAAI8L,QAAQ,IAAIpX,MAAM,CAAC2K,YAAP,EAAhB,EAAuCyM,QAAQ,GAAGpX,MAAM,CAAC2K,YAAP,EAAX;EACvC,YAAIyM,QAAQ,IAAIpX,MAAM,CAACoL,YAAP,EAAhB,EAAuCgM,QAAQ,GAAGpX,MAAM,CAACoL,YAAP,EAAX;EAEvCpL,QAAAA,MAAM,CAAC+J,aAAP,CAAqB,CAArB;EACA/J,QAAAA,MAAM,CAACuN,YAAP,CAAoB6J,QAApB;EACApX,QAAAA,MAAM,CAACiL,cAAP;EACAjL,QAAAA,MAAM,CAACuM,iBAAP;EACAvM,QAAAA,MAAM,CAACyL,mBAAP;;EAEA,YAAK,CAACF,YAAD,IAAiBvL,MAAM,CAACqL,WAAzB,IAA0C,CAACG,MAAD,IAAWxL,MAAM,CAACsL,KAAhE,EAAwE;EACtEtL,UAAAA,MAAM,CAACyL,mBAAP;EACD;;EAED,YAAIzL,MAAM,CAACmB,MAAP,CAAc0X,cAAlB,EAAkC;EAChC;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACArsB,UAAAA,YAAY,CAACwT,MAAM,CAAC2mB,UAAP,CAAkBiB,OAAnB,CAAZ;EACA5nB,UAAAA,MAAM,CAAC2mB,UAAP,CAAkBiB,OAAlB,GAA4Br4B,SAA5B;EACA,cAAM81B,kBAAiB,GAAGrlB,MAAM,CAAC2mB,UAAP,CAAkBtB,iBAA5C;;EACA,cAAIA,kBAAiB,CAAC77B,MAAlB,IAA4B,EAAhC,EAAoC;EAClC67B,YAAAA,kBAAiB,CAACkC,KAAlB,GADkC;;EAEnC;;EACD,cAAMC,UAAS,GAAGnC,kBAAiB,CAAC77B,MAAlB,GACd67B,kBAAiB,CAACA,kBAAiB,CAAC77B,MAAlB,GAA2B,CAA5B,CADH,GAEd+F,SAFJ;;EAGA,cAAMs4B,UAAU,GAAGxC,kBAAiB,CAAC,CAAD,CAApC;;EACAA,UAAAA,kBAAiB,CAAC32B,IAAlB,CAAuB04B,SAAvB;;EACA,cACEI,UAAS,KACRJ,SAAQ,CAACN,KAAT,GAAiBU,UAAS,CAACV,KAA3B,IAAoCM,SAAQ,CAACzY,SAAT,KAAuB6Y,UAAS,CAAC7Y,SAD7D,CADX,EAGE;EACA;EACA0W,YAAAA,kBAAiB,CAACrvB,MAAlB,CAAyB,CAAzB;EACD,WAND,MAMO,IACLqvB,kBAAiB,CAAC77B,MAAlB,IAA4B,EAA5B,IACA49B,SAAQ,CAAC/P,IAAT,GAAgBwQ,UAAU,CAACxQ,IAA3B,GAAkC,GADlC,IAEAwQ,UAAU,CAACf,KAAX,GAAmBM,SAAQ,CAACN,KAA5B,IAAqC,CAFrC,IAGAM,SAAQ,CAACN,KAAT,IAAkB,CAJb,EAKL;EACA;EACA;EACA;EACA;EACA;EACA;EACA,gBAAMgB,eAAe,GAAGhB,KAAK,GAAG,CAAR,GAAY,GAAZ,GAAkB,GAA1C;EACA9mB,YAAAA,MAAM,CAAC2mB,UAAP,CAAkBvB,mBAAlB,GAAwCgC,SAAxC;;EACA/B,YAAAA,kBAAiB,CAACrvB,MAAlB,CAAyB,CAAzB;;EACAgK,YAAAA,MAAM,CAAC2mB,UAAP,CAAkBiB,OAAlB,GAA4B5sB,QAAQ,CAAC,YAAM;EACzCgF,cAAAA,MAAM,CAAC0Q,cAAP,CAAsB1Q,MAAM,CAACmB,MAAP,CAAc0I,KAApC,EAA2C,IAA3C,EAAiDta,SAAjD,EAA4Du4B,eAA5D;EACD,aAFmC,EAEjC,CAFiC,CAApC,CAVA;EAaD;;EACD,cAAI,CAAC9nB,MAAM,CAAC2mB,UAAP,CAAkBiB,OAAvB,EAAgC;EAC9B;EACA;EACA;EACA5nB,YAAAA,MAAM,CAAC2mB,UAAP,CAAkBiB,OAAlB,GAA4B5sB,QAAQ,CAAC,YAAM;EACzC,kBAAM8sB,eAAe,GAAG,GAAxB;EACA9nB,cAAAA,MAAM,CAAC2mB,UAAP,CAAkBvB,mBAAlB,GAAwCgC,SAAxC;;EACA/B,cAAAA,kBAAiB,CAACrvB,MAAlB,CAAyB,CAAzB;;EACAgK,cAAAA,MAAM,CAAC0Q,cAAP,CAAsB1Q,MAAM,CAACmB,MAAP,CAAc0I,KAApC,EAA2C,IAA3C,EAAiDta,SAAjD,EAA4Du4B,eAA5D;EACD,aALmC,EAKjC,GALiC,CAApC;EAMD;EACF,SAlFqB;;;EAqFtB,YAAI,CAACH,iBAAL,EAAwB3nB,MAAM,CAACgB,IAAP,CAAY,QAAZ,EAAsB5S,CAAtB,EArFF;;EAwFtB,YAAI4R,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,IAA0B9Z,MAAM,CAACmB,MAAP,CAAc4mB,4BAA5C,EACE/nB,MAAM,CAAC8Z,QAAP,CAAgBkO,IAAhB,GAzFoB;;EA2FtB,YAAI5Q,QAAQ,KAAKpX,MAAM,CAAC2K,YAAP,EAAb,IAAsCyM,QAAQ,KAAKpX,MAAM,CAACoL,YAAP,EAAvD,EAA8E,OAAO,IAAP;EAC/E;EACF;;EAED,QAAIhd,CAAC,CAAC2mB,cAAN,EAAsB3mB,CAAC,CAAC2mB,cAAF,GAAtB,KACK3mB,CAAC,CAACs2B,WAAF,GAAgB,KAAhB;EACL,WAAO,KAAP;EACD,GAlTgB;EAmTjB+C,EAAAA,aAnTiB,yBAmTHL,QAnTG,EAmTO;EACtB,QAAMpnB,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;;EAEA,QACE,KAAKqU,MAAL,CAAYwlB,UAAZ,CAAuBsB,cAAvB,IACAb,QAAQ,CAACN,KAAT,GAAiB,KAAK3lB,MAAL,CAAYwlB,UAAZ,CAAuBsB,cAF1C,EAGE;EACA;EACA,aAAO,KAAP;EACD;;EAED,QACE,KAAK9mB,MAAL,CAAYwlB,UAAZ,CAAuBuB,aAAvB,IACAhtB,GAAG,KAAK8E,MAAM,CAAC2mB,UAAP,CAAkBxB,cAA1B,GAA2C,KAAKhkB,MAAL,CAAYwlB,UAAZ,CAAuBuB,aAFpE,EAGE;EACA;EACA,aAAO,KAAP;EACD,KAlBqB;EAqBtB;EACA;;;EACA,QAAId,QAAQ,CAACN,KAAT,IAAkB,CAAlB,IAAuB5rB,GAAG,KAAK8E,MAAM,CAAC2mB,UAAP,CAAkBxB,cAA1B,GAA2C,EAAtE,EAA0E;EACxE;EACA,aAAO,IAAP;EACD,KA1BqB;EA4BtB;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;EACA;;;EACA,QAAIiC,QAAQ,CAACzY,SAAT,GAAqB,CAAzB,EAA4B;EAC1B,UAAI,CAAC,CAAC3O,MAAM,CAACsL,KAAR,IAAiBtL,MAAM,CAACmB,MAAP,CAAc+K,IAAhC,KAAyC,CAAClM,MAAM,CAACmO,SAArD,EAAgE;EAC9DnO,QAAAA,MAAM,CAAC8P,SAAP;EACA9P,QAAAA,MAAM,CAACgB,IAAP,CAAY,QAAZ,EAAsBomB,QAAQ,CAACE,GAA/B;EACD;EACF,KALD,MAKO,IAAI,CAAC,CAACtnB,MAAM,CAACqL,WAAR,IAAuBrL,MAAM,CAACmB,MAAP,CAAc+K,IAAtC,KAA+C,CAAClM,MAAM,CAACmO,SAA3D,EAAsE;EAC3EnO,MAAAA,MAAM,CAACmQ,SAAP;EACAnQ,MAAAA,MAAM,CAACgB,IAAP,CAAY,QAAZ,EAAsBomB,QAAQ,CAACE,GAA/B;EACD,KA/CqB;;;EAiDtBtnB,IAAAA,MAAM,CAAC2mB,UAAP,CAAkBxB,cAAlB,GAAmC,IAAIn4B,MAAM,CAACX,IAAX,GAAkB87B,OAAlB,EAAnC,CAjDsB;;EAmDtB,WAAO,KAAP;EACD,GAvWgB;EAwWjBT,EAAAA,aAxWiB,yBAwWHN,QAxWG,EAwWO;EACtB,QAAMpnB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcwlB,UAA7B;;EACA,QAAIS,QAAQ,CAACzY,SAAT,GAAqB,CAAzB,EAA4B;EAC1B,UAAI3O,MAAM,CAACsL,KAAP,IAAgB,CAACtL,MAAM,CAACmB,MAAP,CAAc+K,IAA/B,IAAuC/K,MAAM,CAAC0lB,cAAlD,EAAkE;EAChE;EACA,eAAO,IAAP;EACD;EACF,KALD,MAKO,IAAI7mB,MAAM,CAACqL,WAAP,IAAsB,CAACrL,MAAM,CAACmB,MAAP,CAAc+K,IAArC,IAA6C/K,MAAM,CAAC0lB,cAAxD,EAAwE;EAC7E;EACA,aAAO,IAAP;EACD;;EACD,WAAO,KAAP;EACD,GArXgB;EAsXjBlC,EAAAA,MAtXiB,oBAsXR;EACP,QAAM3kB,MAAM,GAAG,IAAf;EACA,QAAM1K,KAAK,GAAG4vB,UAAU,CAAC5vB,KAAX,EAAd;;EACA,QAAI0K,MAAM,CAACmB,MAAP,CAAcyE,OAAlB,EAA2B;EACzB5F,MAAAA,MAAM,CAACyN,SAAP,CAAiB7jB,mBAAjB,CAAqC0L,KAArC,EAA4C0K,MAAM,CAAC2mB,UAAP,CAAkBzD,MAA9D;EACA,aAAO,IAAP;EACD;;EACD,QAAI,CAAC5tB,KAAL,EAAY,OAAO,KAAP;EACZ,QAAI0K,MAAM,CAAC2mB,UAAP,CAAkB1hB,OAAtB,EAA+B,OAAO,KAAP;EAC/B,QAAI9b,MAAM,GAAG6W,MAAM,CAACoC,GAApB;;EACA,QAAIpC,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyBC,YAAzB,KAA0C,WAA9C,EAA2D;EACzDz9B,MAAAA,MAAM,GAAGuI,CAAC,CAACsO,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyBC,YAA1B,CAAV;EACD;;EACDz9B,IAAAA,MAAM,CAACiL,EAAP,CAAU,YAAV,EAAwB4L,MAAM,CAAC2mB,UAAP,CAAkBH,gBAA1C;EACAr9B,IAAAA,MAAM,CAACiL,EAAP,CAAU,YAAV,EAAwB4L,MAAM,CAAC2mB,UAAP,CAAkBD,gBAA1C;EACAv9B,IAAAA,MAAM,CAACiL,EAAP,CAAUkB,KAAV,EAAiB0K,MAAM,CAAC2mB,UAAP,CAAkBzD,MAAnC;EACAljB,IAAAA,MAAM,CAAC2mB,UAAP,CAAkB1hB,OAAlB,GAA4B,IAA5B;EACA,WAAO,IAAP;EACD,GAxYgB;EAyYjB2f,EAAAA,OAzYiB,qBAyYP;EACR,QAAM5kB,MAAM,GAAG,IAAf;EACA,QAAM1K,KAAK,GAAG4vB,UAAU,CAAC5vB,KAAX,EAAd;;EACA,QAAI0K,MAAM,CAACmB,MAAP,CAAcyE,OAAlB,EAA2B;EACzB5F,MAAAA,MAAM,CAACyN,SAAP,CAAiB9jB,gBAAjB,CAAkC2L,KAAlC,EAAyC0K,MAAM,CAAC2mB,UAAP,CAAkBzD,MAA3D;EACA,aAAO,IAAP;EACD;;EACD,QAAI,CAAC5tB,KAAL,EAAY,OAAO,KAAP;EACZ,QAAI,CAAC0K,MAAM,CAAC2mB,UAAP,CAAkB1hB,OAAvB,EAAgC,OAAO,KAAP;EAChC,QAAI9b,MAAM,GAAG6W,MAAM,CAACoC,GAApB;;EACA,QAAIpC,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyBC,YAAzB,KAA0C,WAA9C,EAA2D;EACzDz9B,MAAAA,MAAM,GAAGuI,CAAC,CAACsO,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyBC,YAA1B,CAAV;EACD;;EACDz9B,IAAAA,MAAM,CAACwM,GAAP,CAAWL,KAAX,EAAkB0K,MAAM,CAAC2mB,UAAP,CAAkBzD,MAApC;EACAljB,IAAAA,MAAM,CAAC2mB,UAAP,CAAkB1hB,OAAlB,GAA4B,KAA5B;EACA,WAAO,IAAP;EACD;EAzZgB,CAAnB;AA4ZA,qBAAe;EACblF,EAAAA,IAAI,EAAE,YADO;EAEboB,EAAAA,MAAM,EAAE;EACNwlB,IAAAA,UAAU,EAAE;EACV1hB,MAAAA,OAAO,EAAE,KADC;EAEV4hB,MAAAA,cAAc,EAAE,KAFN;EAGVI,MAAAA,MAAM,EAAE,KAHE;EAIVD,MAAAA,WAAW,EAAE,KAJH;EAKVG,MAAAA,WAAW,EAAE,CALH;EAMVP,MAAAA,YAAY,EAAE,WANJ;EAOVqB,MAAAA,cAAc,EAAE,IAPN;EAQVC,MAAAA,aAAa,EAAE;EARL;EADN,GAFK;EAcb76B,EAAAA,MAda,oBAcJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxB2mB,MAAAA,UAAU,EAAE;EACV1hB,QAAAA,OAAO,EAAE,KADC;EAEVkgB,QAAAA,cAAc,EAAEjqB,GAAG,EAFT;EAGVkqB,QAAAA,mBAAmB,EAAE71B,SAHX;EAIV81B,QAAAA,iBAAiB,EAAE,EAJT;EAMVV,QAAAA,MAAM,EAAEO,UAAU,CAACP,MANT;EAOVC,QAAAA,OAAO,EAAEM,UAAU,CAACN,OAPV;EAQV1B,QAAAA,MAAM,EAAEgC,UAAU,CAAChC,MART;EASVsD,QAAAA,gBAAgB,EAAEtB,UAAU,CAACsB,gBATnB;EAUVE,QAAAA,gBAAgB,EAAExB,UAAU,CAACwB,gBAVnB;EAWVe,QAAAA,aAAa,EAAEvC,UAAU,CAACuC,aAXhB;EAYVC,QAAAA,aAAa,EAAExC,UAAU,CAACwC;EAZhB;EADY,KAAT,CAAjB;EAgBD,GAhCY;EAiCbtzB,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACX,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyB1hB,OAA1B,IAAqCjF,MAAM,CAACmB,MAAP,CAAcyE,OAAvD,EAAgE;EAC9D5F,QAAAA,MAAM,CAAC2mB,UAAP,CAAkB/B,OAAlB;EACD;;EACD,UAAI5kB,MAAM,CAACmB,MAAP,CAAcwlB,UAAd,CAAyB1hB,OAA7B,EAAsCjF,MAAM,CAAC2mB,UAAP,CAAkBhC,MAAlB;EACvC,KANC;EAOFtjB,IAAAA,OAPE,mBAOMrB,MAPN,EAOc;EACd,UAAIA,MAAM,CAACmB,MAAP,CAAcyE,OAAlB,EAA2B;EACzB5F,QAAAA,MAAM,CAAC2mB,UAAP,CAAkBhC,MAAlB;EACD;;EACD,UAAI3kB,MAAM,CAAC2mB,UAAP,CAAkB1hB,OAAtB,EAA+BjF,MAAM,CAAC2mB,UAAP,CAAkB/B,OAAlB;EAChC;EAZC;EAjCS,CAAf;;ECtbA,IAAMwD,UAAU,GAAG;EACjBC,EAAAA,QADiB,oBACRjmB,GADQ,EACHkmB,QADG,EACO;EACtBlmB,IAAAA,GAAG,CAACkmB,QAAQ,GAAG,UAAH,GAAgB,aAAzB,CAAH,CAA2C,KAAKnnB,MAAL,CAAYqY,UAAZ,CAAuB+O,aAAlE;EACA,QAAInmB,GAAG,CAAC,CAAD,CAAH,IAAUA,GAAG,CAAC,CAAD,CAAH,CAAOomB,OAAP,KAAmB,QAAjC,EAA2CpmB,GAAG,CAAC,CAAD,CAAH,CAAOkmB,QAAP,GAAkBA,QAAlB;EAC5C,GAJgB;EAKjBlW,EAAAA,MALiB,oBAKR;EACP;EACA,QAAMpS,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcqY,UAA7B;EACA,QAAM6O,QAAQ,GAAGroB,MAAM,CAACwZ,UAAP,CAAkB6O,QAAnC;EAEA,QAAIroB,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EANjB,6BAOsBlM,MAAM,CAACwZ,UAP7B;EAAA,QAOCiP,OAPD,sBAOCA,OAPD;EAAA,QAOUC,OAPV,sBAOUA,OAPV;;EASP,QAAIA,OAAO,IAAIA,OAAO,CAACl/B,MAAR,GAAiB,CAAhC,EAAmC;EACjC,UAAIwW,MAAM,CAACqL,WAAX,EAAwB;EACtBgd,QAAAA,QAAQ,CAACK,OAAD,EAAU,IAAV,CAAR;EACD,OAFD,MAEO;EACLL,QAAAA,QAAQ,CAACK,OAAD,EAAU,KAAV,CAAR;EACD;;EACDA,MAAAA,OAAO,CAAC1oB,MAAM,CAACmB,MAAP,CAAcoI,aAAd,IAA+BvJ,MAAM,CAACgS,QAAtC,GAAiD,UAAjD,GAA8D,aAA/D,CAAP,CACE7Q,MAAM,CAACwnB,SADT;EAGD;;EACD,QAAIF,OAAO,IAAIA,OAAO,CAACj/B,MAAR,GAAiB,CAAhC,EAAmC;EACjC,UAAIwW,MAAM,CAACsL,KAAX,EAAkB;EAChB+c,QAAAA,QAAQ,CAACI,OAAD,EAAU,IAAV,CAAR;EACD,OAFD,MAEO;EACLJ,QAAAA,QAAQ,CAACI,OAAD,EAAU,KAAV,CAAR;EACD;;EACDA,MAAAA,OAAO,CAACzoB,MAAM,CAACmB,MAAP,CAAcoI,aAAd,IAA+BvJ,MAAM,CAACgS,QAAtC,GAAiD,UAAjD,GAA8D,aAA/D,CAAP,CACE7Q,MAAM,CAACwnB,SADT;EAGD;EACF,GAlCgB;EAmCjBC,EAAAA,WAnCiB,uBAmCLx6B,CAnCK,EAmCF;EACb,QAAM4R,MAAM,GAAG,IAAf;EACA5R,IAAAA,CAAC,CAAC2mB,cAAF;EACA,QAAI/U,MAAM,CAACqL,WAAP,IAAsB,CAACrL,MAAM,CAACmB,MAAP,CAAc+K,IAAzC,EAA+C;EAC/ClM,IAAAA,MAAM,CAACmQ,SAAP;EACD,GAxCgB;EAyCjB0Y,EAAAA,WAzCiB,uBAyCLz6B,CAzCK,EAyCF;EACb,QAAM4R,MAAM,GAAG,IAAf;EACA5R,IAAAA,CAAC,CAAC2mB,cAAF;EACA,QAAI/U,MAAM,CAACsL,KAAP,IAAgB,CAACtL,MAAM,CAACmB,MAAP,CAAc+K,IAAnC,EAAyC;EACzClM,IAAAA,MAAM,CAAC8P,SAAP;EACD,GA9CgB;EA+CjB5O,EAAAA,IA/CiB,kBA+CV;EACL,QAAMlB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcqY,UAA7B;EACA,QAAI,EAAErY,MAAM,CAACsY,MAAP,IAAiBtY,MAAM,CAACuY,MAA1B,CAAJ,EAAuC;EAEvC,QAAI+O,OAAJ;EACA,QAAIC,OAAJ;;EACA,QAAIvnB,MAAM,CAACsY,MAAX,EAAmB;EACjBgP,MAAAA,OAAO,GAAG/2B,CAAC,CAACyP,MAAM,CAACsY,MAAR,CAAX;;EACA,UACEzZ,MAAM,CAACmB,MAAP,CAAcqd,iBAAd,IACA,OAAOrd,MAAM,CAACsY,MAAd,KAAyB,QADzB,IAEAgP,OAAO,CAACj/B,MAAR,GAAiB,CAFjB,IAGAwW,MAAM,CAACoC,GAAP,CAAW5H,IAAX,CAAgB2G,MAAM,CAACsY,MAAvB,EAA+BjwB,MAA/B,KAA0C,CAJ5C,EAKE;EACAi/B,QAAAA,OAAO,GAAGzoB,MAAM,CAACoC,GAAP,CAAW5H,IAAX,CAAgB2G,MAAM,CAACsY,MAAvB,CAAV;EACD;EACF;;EACD,QAAItY,MAAM,CAACuY,MAAX,EAAmB;EACjBgP,MAAAA,OAAO,GAAGh3B,CAAC,CAACyP,MAAM,CAACuY,MAAR,CAAX;;EACA,UACE1Z,MAAM,CAACmB,MAAP,CAAcqd,iBAAd,IACA,OAAOrd,MAAM,CAACuY,MAAd,KAAyB,QADzB,IAEAgP,OAAO,CAACl/B,MAAR,GAAiB,CAFjB,IAGAwW,MAAM,CAACoC,GAAP,CAAW5H,IAAX,CAAgB2G,MAAM,CAACuY,MAAvB,EAA+BlwB,MAA/B,KAA0C,CAJ5C,EAKE;EACAk/B,QAAAA,OAAO,GAAG1oB,MAAM,CAACoC,GAAP,CAAW5H,IAAX,CAAgB2G,MAAM,CAACuY,MAAvB,CAAV;EACD;EACF;;EAED,QAAI+O,OAAO,IAAIA,OAAO,CAACj/B,MAAR,GAAiB,CAAhC,EAAmC;EACjCi/B,MAAAA,OAAO,CAACr0B,EAAR,CAAW,OAAX,EAAoB4L,MAAM,CAACwZ,UAAP,CAAkBqP,WAAtC;EACD;;EACD,QAAIH,OAAO,IAAIA,OAAO,CAACl/B,MAAR,GAAiB,CAAhC,EAAmC;EACjCk/B,MAAAA,OAAO,CAACt0B,EAAR,CAAW,OAAX,EAAoB4L,MAAM,CAACwZ,UAAP,CAAkBoP,WAAtC;EACD;;EAED1/B,IAAAA,QAAM,CAAC8W,MAAM,CAACwZ,UAAR,EAAoB;EACxBiP,MAAAA,OAAO,EAAPA,OADwB;EAExBhP,MAAAA,MAAM,EAAEgP,OAAO,IAAIA,OAAO,CAAC,CAAD,CAFF;EAGxBC,MAAAA,OAAO,EAAPA,OAHwB;EAIxBhP,MAAAA,MAAM,EAAEgP,OAAO,IAAIA,OAAO,CAAC,CAAD;EAJF,KAApB,CAAN;EAMD,GA1FgB;EA2FjBrnB,EAAAA,OA3FiB,qBA2FP;EACR,QAAMrB,MAAM,GAAG,IAAf;EADQ,8BAEqBA,MAAM,CAACwZ,UAF5B;EAAA,QAEAiP,OAFA,uBAEAA,OAFA;EAAA,QAESC,OAFT,uBAESA,OAFT;;EAGR,QAAID,OAAO,IAAIA,OAAO,CAACj/B,MAAvB,EAA+B;EAC7Bi/B,MAAAA,OAAO,CAAC9yB,GAAR,CAAY,OAAZ,EAAqBqK,MAAM,CAACwZ,UAAP,CAAkBqP,WAAvC;EACAJ,MAAAA,OAAO,CAAC71B,WAAR,CAAoBoN,MAAM,CAACmB,MAAP,CAAcqY,UAAd,CAAyB+O,aAA7C;EACD;;EACD,QAAIG,OAAO,IAAIA,OAAO,CAACl/B,MAAvB,EAA+B;EAC7Bk/B,MAAAA,OAAO,CAAC/yB,GAAR,CAAY,OAAZ,EAAqBqK,MAAM,CAACwZ,UAAP,CAAkBoP,WAAvC;EACAF,MAAAA,OAAO,CAAC91B,WAAR,CAAoBoN,MAAM,CAACmB,MAAP,CAAcqY,UAAd,CAAyB+O,aAA7C;EACD;EACF;EAtGgB,CAAnB;AAyGA,qBAAe;EACbxoB,EAAAA,IAAI,EAAE,YADO;EAEboB,EAAAA,MAAM,EAAE;EACNqY,IAAAA,UAAU,EAAE;EACVC,MAAAA,MAAM,EAAE,IADE;EAEVC,MAAAA,MAAM,EAAE,IAFE;EAIVoP,MAAAA,WAAW,EAAE,KAJH;EAKVP,MAAAA,aAAa,EAAE,wBALL;EAMVQ,MAAAA,WAAW,EAAE,sBANH;EAOVJ,MAAAA,SAAS,EAAE;EAPD;EADN,GAFK;EAabt7B,EAAAA,MAba,oBAaJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBwZ,MAAAA,UAAU,eACL4O,UADK;EADc,KAAT,CAAjB;EAKD,GApBY;EAqBbh0B,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACXA,MAAAA,MAAM,CAACwZ,UAAP,CAAkBtY,IAAlB;EACAlB,MAAAA,MAAM,CAACwZ,UAAP,CAAkBpH,MAAlB;EACD,KAJC;EAKF4W,IAAAA,MALE,kBAKKhpB,MALL,EAKa;EACbA,MAAAA,MAAM,CAACwZ,UAAP,CAAkBpH,MAAlB;EACD,KAPC;EAQF6W,IAAAA,QARE,oBAQOjpB,MARP,EAQe;EACfA,MAAAA,MAAM,CAACwZ,UAAP,CAAkBpH,MAAlB;EACD,KAVC;EAWF/Q,IAAAA,OAXE,mBAWMrB,MAXN,EAWc;EACdA,MAAAA,MAAM,CAACwZ,UAAP,CAAkBnY,OAAlB;EACD,KAbC;EAcF6nB,IAAAA,KAdE,iBAcIlpB,MAdJ,EAcY5R,CAdZ,EAce;EAAA,gCACc4R,MAAM,CAACwZ,UADrB;EAAA,UACPiP,OADO,uBACPA,OADO;EAAA,UACEC,OADF,uBACEA,OADF;EAEf,UAAMS,QAAQ,GAAG/6B,CAAC,CAACjF,MAAnB;;EACA,UACE6W,MAAM,CAACmB,MAAP,CAAcqY,UAAd,CAAyBsP,WAAzB,IACA,CAACp3B,CAAC,CAACy3B,QAAD,CAAD,CAAYp0B,EAAZ,CAAe2zB,OAAf,CADD,IAEA,CAACh3B,CAAC,CAACy3B,QAAD,CAAD,CAAYp0B,EAAZ,CAAe0zB,OAAf,CAHH,EAIE;EACA,YACEzoB,MAAM,CAACopB,UAAP,IACAppB,MAAM,CAACmB,MAAP,CAAcioB,UADd,IAEAppB,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBC,SAFzB,KAGCrpB,MAAM,CAACopB,UAAP,CAAkBp4B,EAAlB,KAAyBm4B,QAAzB,IAAqCnpB,MAAM,CAACopB,UAAP,CAAkBp4B,EAAlB,CAAqByC,QAArB,CAA8B01B,QAA9B,CAHtC,CADF,EAME;EACF,YAAIG,QAAJ;;EACA,YAAIb,OAAJ,EAAa;EACXa,UAAAA,QAAQ,GAAGb,OAAO,CAACn1B,QAAR,CAAiB0M,MAAM,CAACmB,MAAP,CAAcqY,UAAd,CAAyBuP,WAA1C,CAAX;EACD,SAFD,MAEO,IAAIL,OAAJ,EAAa;EAClBY,UAAAA,QAAQ,GAAGZ,OAAO,CAACp1B,QAAR,CAAiB0M,MAAM,CAACmB,MAAP,CAAcqY,UAAd,CAAyBuP,WAA1C,CAAX;EACD;;EACD,YAAIO,QAAQ,KAAK,IAAjB,EAAuB;EACrBtpB,UAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ;EACD,SAFD,MAEO;EACLhB,UAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ;EACD;;EACD,YAAIynB,OAAJ,EAAa;EACXA,UAAAA,OAAO,CAACx1B,WAAR,CAAoB+M,MAAM,CAACmB,MAAP,CAAcqY,UAAd,CAAyBuP,WAA7C;EACD;;EACD,YAAIL,OAAJ,EAAa;EACXA,UAAAA,OAAO,CAACz1B,WAAR,CAAoB+M,MAAM,CAACmB,MAAP,CAAcqY,UAAd,CAAyBuP,WAA7C;EACD;EACF;EACF;EA/CC;EArBS,CAAf;;ECzGA,IAAMQ,UAAU,GAAG;EACjBnX,EAAAA,MADiB,oBACR;EACP;EACA,QAAMpS,MAAM,GAAG,IAAf;EACA,QAAM4E,GAAG,GAAG5E,MAAM,CAAC4E,GAAnB;EACA,QAAMzD,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcioB,UAA7B;EACA,QACE,CAACjoB,MAAM,CAACnQ,EAAR,IACA,CAACgP,MAAM,CAACopB,UAAP,CAAkBp4B,EADnB,IAEA,CAACgP,MAAM,CAACopB,UAAP,CAAkBhnB,GAFnB,IAGApC,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsB5Y,MAAtB,KAAiC,CAJnC,EAME;EACF,QAAM6b,YAAY,GAChBrF,MAAM,CAACgF,OAAP,IAAkBhF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAAxC,GACIjF,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsB3b,MAD1B,GAEIwW,MAAM,CAACmF,MAAP,CAAc3b,MAHpB;EAIA,QAAM4Y,GAAG,GAAGpC,MAAM,CAACopB,UAAP,CAAkBhnB,GAA9B,CAhBO;;EAkBP,QAAIonB,OAAJ;EACA,QAAMC,KAAK,GAAGzpB,MAAM,CAACmB,MAAP,CAAc+K,IAAd,GACVrF,IAAI,CAACE,IAAL,CAAU,CAAC1B,YAAY,GAAGrF,MAAM,CAAC6P,YAAP,GAAsB,CAAtC,IAA2C7P,MAAM,CAACmB,MAAP,CAAcuG,cAAnE,CADU,GAEV1H,MAAM,CAACsF,QAAP,CAAgB9b,MAFpB;;EAGA,QAAIwW,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtBsd,MAAAA,OAAO,GAAG3iB,IAAI,CAACE,IAAL,CACR,CAAC/G,MAAM,CAACiK,WAAP,GAAqBjK,MAAM,CAAC6P,YAA7B,IAA6C7P,MAAM,CAACmB,MAAP,CAAcuG,cADnD,CAAV;;EAGA,UAAI8hB,OAAO,GAAGnkB,YAAY,GAAG,CAAf,GAAmBrF,MAAM,CAAC6P,YAAP,GAAsB,CAAvD,EAA0D;EACxD2Z,QAAAA,OAAO,IAAInkB,YAAY,GAAGrF,MAAM,CAAC6P,YAAP,GAAsB,CAAhD;EACD;;EACD,UAAI2Z,OAAO,GAAGC,KAAK,GAAG,CAAtB,EAAyBD,OAAO,IAAIC,KAAX;EACzB,UAAID,OAAO,GAAG,CAAV,IAAexpB,MAAM,CAACmB,MAAP,CAAcuoB,cAAd,KAAiC,SAApD,EAA+DF,OAAO,GAAGC,KAAK,GAAGD,OAAlB;EAChE,KATD,MASO,IAAI,OAAOxpB,MAAM,CAACsJ,SAAd,KAA4B,WAAhC,EAA6C;EAClDkgB,MAAAA,OAAO,GAAGxpB,MAAM,CAACsJ,SAAjB;EACD,KAFM,MAEA;EACLkgB,MAAAA,OAAO,GAAGxpB,MAAM,CAACiK,WAAP,IAAsB,CAAhC;EACD,KAnCM;;;EAqCP,QACE9I,MAAM,CAACmS,IAAP,KAAgB,SAAhB,IACAtT,MAAM,CAACopB,UAAP,CAAkBO,OADlB,IAEA3pB,MAAM,CAACopB,UAAP,CAAkBO,OAAlB,CAA0BngC,MAA1B,GAAmC,CAHrC,EAIE;EACA,UAAMmgC,OAAO,GAAG3pB,MAAM,CAACopB,UAAP,CAAkBO,OAAlC;EACA,UAAIC,UAAJ;EACA,UAAIC,SAAJ;EACA,UAAIC,QAAJ;;EACA,UAAI3oB,MAAM,CAAC4oB,cAAX,EAA2B;EACzB/pB,QAAAA,MAAM,CAACopB,UAAP,CAAkBY,UAAlB,GAA+BL,OAAO,CACnC1wB,EAD4B,CACzB,CADyB,EAE5B+G,MAAM,CAAC+D,YAAP,KAAwB,YAAxB,GAAuC,aAFX,EAE0B,IAF1B,CAA/B;EAGA3B,QAAAA,GAAG,CAACjK,GAAJ,CACE6H,MAAM,CAAC+D,YAAP,KAAwB,OAAxB,GAAkC,QADpC,EAEK/D,MAAM,CAACopB,UAAP,CAAkBY,UAAlB,IAAgC7oB,MAAM,CAAC8oB,kBAAP,GAA4B,CAA5D,CAFL;;EAIA,YAAI9oB,MAAM,CAAC8oB,kBAAP,GAA4B,CAA5B,IAAiCjqB,MAAM,CAACyM,aAAP,KAAyBld,SAA9D,EAAyE;EACvEyQ,UAAAA,MAAM,CAACopB,UAAP,CAAkBc,kBAAlB,IAAwCV,OAAO,GAAGxpB,MAAM,CAACyM,aAAzD;;EACA,cAAIzM,MAAM,CAACopB,UAAP,CAAkBc,kBAAlB,GAAuC/oB,MAAM,CAAC8oB,kBAAP,GAA4B,CAAvE,EAA0E;EACxEjqB,YAAAA,MAAM,CAACopB,UAAP,CAAkBc,kBAAlB,GAAuC/oB,MAAM,CAAC8oB,kBAAP,GAA4B,CAAnE;EACD,WAFD,MAEO,IAAIjqB,MAAM,CAACopB,UAAP,CAAkBc,kBAAlB,GAAuC,CAA3C,EAA8C;EACnDlqB,YAAAA,MAAM,CAACopB,UAAP,CAAkBc,kBAAlB,GAAuC,CAAvC;EACD;EACF;;EACDN,QAAAA,UAAU,GAAGJ,OAAO,GAAGxpB,MAAM,CAACopB,UAAP,CAAkBc,kBAAzC;EACAL,QAAAA,SAAS,GAAGD,UAAU,IAAI/iB,IAAI,CAACiB,GAAL,CAAS6hB,OAAO,CAACngC,MAAjB,EAAyB2X,MAAM,CAAC8oB,kBAAhC,IAAsD,CAA1D,CAAtB;EACAH,QAAAA,QAAQ,GAAG,CAACD,SAAS,GAAGD,UAAb,IAA2B,CAAtC;EACD;;EACDD,MAAAA,OAAO,CAAC/2B,WAAR,CACKuO,MAAM,CAACgpB,iBADZ,SACiChpB,MAAM,CAACgpB,iBADxC,cACkEhpB,MAAM,CAACgpB,iBADzE,mBACwGhpB,MAAM,CAACgpB,iBAD/G,cACyIhpB,MAAM,CAACgpB,iBADhJ,mBAC+KhpB,MAAM,CAACgpB,iBADtL;;EAGA,UAAI/nB,GAAG,CAAC5Y,MAAJ,GAAa,CAAjB,EAAoB;EAClBmgC,QAAAA,OAAO,CAACrxB,IAAR,CAAa,UAAC8xB,MAAD,EAAY;EACvB,cAAMC,OAAO,GAAG34B,CAAC,CAAC04B,MAAD,CAAjB;EACA,cAAME,WAAW,GAAGD,OAAO,CAAC9xB,KAAR,EAApB;;EACA,cAAI+xB,WAAW,KAAKd,OAApB,EAA6B;EAC3Ba,YAAAA,OAAO,CAACp4B,QAAR,CAAiBkP,MAAM,CAACgpB,iBAAxB;EACD;;EACD,cAAIhpB,MAAM,CAAC4oB,cAAX,EAA2B;EACzB,gBAAIO,WAAW,IAAIV,UAAf,IAA6BU,WAAW,IAAIT,SAAhD,EAA2D;EACzDQ,cAAAA,OAAO,CAACp4B,QAAR,CAAoBkP,MAAM,CAACgpB,iBAA3B;EACD;;EACD,gBAAIG,WAAW,KAAKV,UAApB,EAAgC;EAC9BS,cAAAA,OAAO,CACJtwB,IADH,GAEG9H,QAFH,CAEekP,MAAM,CAACgpB,iBAFtB,YAGGpwB,IAHH,GAIG9H,QAJH,CAIekP,MAAM,CAACgpB,iBAJtB;EAKD;;EACD,gBAAIG,WAAW,KAAKT,SAApB,EAA+B;EAC7BQ,cAAAA,OAAO,CACJ3wB,IADH,GAEGzH,QAFH,CAEekP,MAAM,CAACgpB,iBAFtB,YAGGzwB,IAHH,GAIGzH,QAJH,CAIekP,MAAM,CAACgpB,iBAJtB;EAKD;EACF;EACF,SAzBD;EA0BD,OA3BD,MA2BO;EACL,YAAME,OAAO,GAAGV,OAAO,CAAC1wB,EAAR,CAAWuwB,OAAX,CAAhB;EACA,YAAMc,WAAW,GAAGD,OAAO,CAAC9xB,KAAR,EAApB;EACA8xB,QAAAA,OAAO,CAACp4B,QAAR,CAAiBkP,MAAM,CAACgpB,iBAAxB;;EACA,YAAIhpB,MAAM,CAAC4oB,cAAX,EAA2B;EACzB,cAAMQ,qBAAqB,GAAGZ,OAAO,CAAC1wB,EAAR,CAAW2wB,UAAX,CAA9B;EACA,cAAMY,oBAAoB,GAAGb,OAAO,CAAC1wB,EAAR,CAAW4wB,SAAX,CAA7B;;EACA,eAAK,IAAIv4B,CAAC,GAAGs4B,UAAb,EAAyBt4B,CAAC,IAAIu4B,SAA9B,EAAyCv4B,CAAC,IAAI,CAA9C,EAAiD;EAC/Cq4B,YAAAA,OAAO,CAAC1wB,EAAR,CAAW3H,CAAX,EAAcW,QAAd,CAA0BkP,MAAM,CAACgpB,iBAAjC;EACD;;EACD,cAAInqB,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtB,gBAAIoe,WAAW,IAAIX,OAAO,CAACngC,MAAR,GAAiB2X,MAAM,CAAC8oB,kBAA3C,EAA+D;EAC7D,mBAAK,IAAI34B,EAAC,GAAG6P,MAAM,CAAC8oB,kBAApB,EAAwC34B,EAAC,IAAI,CAA7C,EAAgDA,EAAC,IAAI,CAArD,EAAwD;EACtDq4B,gBAAAA,OAAO,CAAC1wB,EAAR,CAAW0wB,OAAO,CAACngC,MAAR,GAAiB8H,EAA5B,EAA+BW,QAA/B,CAA2CkP,MAAM,CAACgpB,iBAAlD;EACD;;EACDR,cAAAA,OAAO,CACJ1wB,EADH,CACM0wB,OAAO,CAACngC,MAAR,GAAiB2X,MAAM,CAAC8oB,kBAAxB,GAA6C,CADnD,EAEGh4B,QAFH,CAEekP,MAAM,CAACgpB,iBAFtB;EAGD,aAPD,MAOO;EACLI,cAAAA,qBAAqB,CAClBxwB,IADH,GAEG9H,QAFH,CAEekP,MAAM,CAACgpB,iBAFtB,YAGGpwB,IAHH,GAIG9H,QAJH,CAIekP,MAAM,CAACgpB,iBAJtB;EAKAK,cAAAA,oBAAoB,CACjB9wB,IADH,GAEGzH,QAFH,CAEekP,MAAM,CAACgpB,iBAFtB,YAGGzwB,IAHH,GAIGzH,QAJH,CAIekP,MAAM,CAACgpB,iBAJtB;EAKD;EACF,WApBD,MAoBO;EACLI,YAAAA,qBAAqB,CAClBxwB,IADH,GAEG9H,QAFH,CAEekP,MAAM,CAACgpB,iBAFtB,YAGGpwB,IAHH,GAIG9H,QAJH,CAIekP,MAAM,CAACgpB,iBAJtB;EAKAK,YAAAA,oBAAoB,CACjB9wB,IADH,GAEGzH,QAFH,CAEekP,MAAM,CAACgpB,iBAFtB,YAGGzwB,IAHH,GAIGzH,QAJH,CAIekP,MAAM,CAACgpB,iBAJtB;EAKD;EACF;EACF;;EACD,UAAIhpB,MAAM,CAAC4oB,cAAX,EAA2B;EACzB,YAAMU,oBAAoB,GAAG5jB,IAAI,CAACiB,GAAL,CAAS6hB,OAAO,CAACngC,MAAjB,EAAyB2X,MAAM,CAAC8oB,kBAAP,GAA4B,CAArD,CAA7B;EACA,YAAMS,aAAa,GACjB,CAAC1qB,MAAM,CAACopB,UAAP,CAAkBY,UAAlB,GAA+BS,oBAA/B,GAAsDzqB,MAAM,CAACopB,UAAP,CAAkBY,UAAzE,IAAuF,CAAvF,GACAF,QAAQ,GAAG9pB,MAAM,CAACopB,UAAP,CAAkBY,UAF/B;EAGA,YAAMpI,UAAU,GAAGhd,GAAG,GAAG,OAAH,GAAa,MAAnC;EACA+kB,QAAAA,OAAO,CAACxxB,GAAR,CAAY6H,MAAM,CAAC+D,YAAP,KAAwB6d,UAAxB,GAAqC,KAAjD,EAA2D8I,aAA3D;EACD;EACF;;EACD,QAAIvpB,MAAM,CAACmS,IAAP,KAAgB,UAApB,EAAgC;EAC9BlR,MAAAA,GAAG,CAAC5H,IAAJ,OAAa2G,MAAM,CAACwpB,YAApB,EAAoClyB,IAApC,CAAyC0I,MAAM,CAACypB,qBAAP,CAA6BpB,OAAO,GAAG,CAAvC,CAAzC;EACApnB,MAAAA,GAAG,CAAC5H,IAAJ,OAAa2G,MAAM,CAAC0pB,UAApB,EAAkCpyB,IAAlC,CAAuC0I,MAAM,CAAC2pB,mBAAP,CAA2BrB,KAA3B,CAAvC;EACD;;EACD,QAAItoB,MAAM,CAACmS,IAAP,KAAgB,aAApB,EAAmC;EACjC,UAAIyX,oBAAJ;;EACA,UAAI5pB,MAAM,CAAC6pB,mBAAX,EAAgC;EAC9BD,QAAAA,oBAAoB,GAAG/qB,MAAM,CAAC+D,YAAP,KAAwB,UAAxB,GAAqC,YAA5D;EACD,OAFD,MAEO;EACLgnB,QAAAA,oBAAoB,GAAG/qB,MAAM,CAAC+D,YAAP,KAAwB,YAAxB,GAAuC,UAA9D;EACD;;EACD,UAAMknB,KAAK,GAAG,CAACzB,OAAO,GAAG,CAAX,IAAgBC,KAA9B;EACA,UAAIyB,MAAM,GAAG,CAAb;EACA,UAAIC,MAAM,GAAG,CAAb;;EACA,UAAIJ,oBAAoB,KAAK,YAA7B,EAA2C;EACzCG,QAAAA,MAAM,GAAGD,KAAT;EACD,OAFD,MAEO;EACLE,QAAAA,MAAM,GAAGF,KAAT;EACD;;EACD7oB,MAAAA,GAAG,CACA5H,IADH,OACY2G,MAAM,CAACiqB,oBADnB,EAEGp3B,SAFH,gCAE0Ck3B,MAF1C,iBAE4DC,MAF5D,QAGGl3B,UAHH,CAGc+L,MAAM,CAACmB,MAAP,CAAc0I,KAH5B;EAID;;EACD,QAAI1I,MAAM,CAACmS,IAAP,KAAgB,QAAhB,IAA4BnS,MAAM,CAACkqB,YAAvC,EAAqD;EACnDjpB,MAAAA,GAAG,CAACzQ,IAAJ,CAASwP,MAAM,CAACkqB,YAAP,CAAoBrrB,MAApB,EAA4BwpB,OAAO,GAAG,CAAtC,EAAyCC,KAAzC,CAAT;EACAzpB,MAAAA,MAAM,CAACgB,IAAP,CAAY,kBAAZ,EAAgCoB,GAAG,CAAC,CAAD,CAAnC;EACD,KAHD,MAGO;EACLpC,MAAAA,MAAM,CAACgB,IAAP,CAAY,kBAAZ,EAAgCoB,GAAG,CAAC,CAAD,CAAnC;EACD;;EACDA,IAAAA,GAAG,CAACpC,MAAM,CAACmB,MAAP,CAAcoI,aAAd,IAA+BvJ,MAAM,CAACgS,QAAtC,GAAiD,UAAjD,GAA8D,aAA/D,CAAH,CACE7Q,MAAM,CAACwnB,SADT;EAGD,GAvLgB;EAwLjB2C,EAAAA,MAxLiB,oBAwLR;EACP;EACA,QAAMtrB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcioB,UAA7B;EACA,QACE,CAACjoB,MAAM,CAACnQ,EAAR,IACA,CAACgP,MAAM,CAACopB,UAAP,CAAkBp4B,EADnB,IAEA,CAACgP,MAAM,CAACopB,UAAP,CAAkBhnB,GAFnB,IAGApC,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsB5Y,MAAtB,KAAiC,CAJnC,EAME;EACF,QAAM6b,YAAY,GAChBrF,MAAM,CAACgF,OAAP,IAAkBhF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAAxC,GACIjF,MAAM,CAACgF,OAAP,CAAeG,MAAf,CAAsB3b,MAD1B,GAEIwW,MAAM,CAACmF,MAAP,CAAc3b,MAHpB;EAKA,QAAM4Y,GAAG,GAAGpC,MAAM,CAACopB,UAAP,CAAkBhnB,GAA9B;EACA,QAAImpB,cAAc,GAAG,EAArB;;EACA,QAAIpqB,MAAM,CAACmS,IAAP,KAAgB,SAApB,EAA+B;EAC7B,UAAIkY,eAAe,GAAGxrB,MAAM,CAACmB,MAAP,CAAc+K,IAAd,GAClBrF,IAAI,CAACE,IAAL,CAAU,CAAC1B,YAAY,GAAGrF,MAAM,CAAC6P,YAAP,GAAsB,CAAtC,IAA2C7P,MAAM,CAACmB,MAAP,CAAcuG,cAAnE,CADkB,GAElB1H,MAAM,CAACsF,QAAP,CAAgB9b,MAFpB;;EAGA,UAAIwW,MAAM,CAACmB,MAAP,CAAc+V,QAAd,IAA0B,CAAClX,MAAM,CAACmB,MAAP,CAAc+K,IAAzC,IAAiDsf,eAAe,GAAGnmB,YAAvE,EAAqF;EACnFmmB,QAAAA,eAAe,GAAGnmB,YAAlB;EACD;;EACD,WAAK,IAAI/T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGk6B,eAApB,EAAqCl6B,CAAC,IAAI,CAA1C,EAA6C;EAC3C,YAAI6P,MAAM,CAACsqB,YAAX,EAAyB;EACvBF,UAAAA,cAAc,IAAIpqB,MAAM,CAACsqB,YAAP,CAAoBt9B,IAApB,CAAyB6R,MAAzB,EAAiC1O,CAAjC,EAAoC6P,MAAM,CAACuqB,WAA3C,CAAlB;EACD,SAFD,MAEO;EACLH,UAAAA,cAAc,UAAQpqB,MAAM,CAACwqB,aAAf,iBAAuCxqB,MAAM,CAACuqB,WAA9C,aAAgEvqB,MAAM,CAACwqB,aAAvE,MAAd;EACD;EACF;;EACDvpB,MAAAA,GAAG,CAACzQ,IAAJ,CAAS45B,cAAT;EACAvrB,MAAAA,MAAM,CAACopB,UAAP,CAAkBO,OAAlB,GAA4BvnB,GAAG,CAAC5H,IAAJ,OAAa2G,MAAM,CAACuqB,WAAP,CAAmB9vB,OAAnB,CAA2B,IAA3B,EAAiC,GAAjC,CAAb,CAA5B;EACD;;EACD,QAAIuF,MAAM,CAACmS,IAAP,KAAgB,UAApB,EAAgC;EAC9B,UAAInS,MAAM,CAACyqB,cAAX,EAA2B;EACzBL,QAAAA,cAAc,GAAGpqB,MAAM,CAACyqB,cAAP,CAAsBz9B,IAAtB,CAA2B6R,MAA3B,EAAmCmB,MAAM,CAACwpB,YAA1C,EAAwDxpB,MAAM,CAAC0pB,UAA/D,CAAjB;EACD,OAFD,MAEO;EACLU,QAAAA,cAAc,GACZ,mBAAgBpqB,MAAM,CAACwpB,YAAvB,kBACA,KADA,uBAEgBxpB,MAAM,CAAC0pB,UAFvB,gBADF;EAID;;EACDzoB,MAAAA,GAAG,CAACzQ,IAAJ,CAAS45B,cAAT;EACD;;EACD,QAAIpqB,MAAM,CAACmS,IAAP,KAAgB,aAApB,EAAmC;EACjC,UAAInS,MAAM,CAAC0qB,iBAAX,EAA8B;EAC5BN,QAAAA,cAAc,GAAGpqB,MAAM,CAAC0qB,iBAAP,CAAyB19B,IAAzB,CAA8B6R,MAA9B,EAAsCmB,MAAM,CAACiqB,oBAA7C,CAAjB;EACD,OAFD,MAEO;EACLG,QAAAA,cAAc,sBAAmBpqB,MAAM,CAACiqB,oBAA1B,eAAd;EACD;;EACDhpB,MAAAA,GAAG,CAACzQ,IAAJ,CAAS45B,cAAT;EACD;;EACD,QAAIpqB,MAAM,CAACmS,IAAP,KAAgB,QAApB,EAA8B;EAC5BtT,MAAAA,MAAM,CAACgB,IAAP,CAAY,kBAAZ,EAAgChB,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsB,CAAtB,CAAhC;EACD;EACF,GAjPgB;EAkPjBlB,EAAAA,IAlPiB,kBAkPV;EACL,QAAMlB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcioB,UAA7B;EACA,QAAI,CAACjoB,MAAM,CAACnQ,EAAZ,EAAgB;EAEhB,QAAIoR,GAAG,GAAG1Q,CAAC,CAACyP,MAAM,CAACnQ,EAAR,CAAX;EACA,QAAIoR,GAAG,CAAC5Y,MAAJ,KAAe,CAAnB,EAAsB;;EAEtB,QAAIwW,MAAM,CAACmB,MAAP,CAAcqd,iBAAd,IAAmC,OAAOrd,MAAM,CAACnQ,EAAd,KAAqB,QAAxD,IAAoEoR,GAAG,CAAC5Y,MAAJ,GAAa,CAArF,EAAwF;EACtF4Y,MAAAA,GAAG,GAAGpC,MAAM,CAACoC,GAAP,CAAW5H,IAAX,CAAgB2G,MAAM,CAACnQ,EAAvB,CAAN;EACD;;EAED,QAAImQ,MAAM,CAACmS,IAAP,KAAgB,SAAhB,IAA6BnS,MAAM,CAACkoB,SAAxC,EAAmD;EACjDjnB,MAAAA,GAAG,CAACnQ,QAAJ,CAAakP,MAAM,CAAC2qB,cAApB;EACD;;EAED1pB,IAAAA,GAAG,CAACnQ,QAAJ,CAAakP,MAAM,CAAC4qB,aAAP,GAAuB5qB,MAAM,CAACmS,IAA3C;;EAEA,QAAInS,MAAM,CAACmS,IAAP,KAAgB,SAAhB,IAA6BnS,MAAM,CAAC4oB,cAAxC,EAAwD;EACtD3nB,MAAAA,GAAG,CAACnQ,QAAJ,MAAgBkP,MAAM,CAAC4qB,aAAvB,GAAuC5qB,MAAM,CAACmS,IAA9C;EACAtT,MAAAA,MAAM,CAACopB,UAAP,CAAkBc,kBAAlB,GAAuC,CAAvC;;EACA,UAAI/oB,MAAM,CAAC8oB,kBAAP,GAA4B,CAAhC,EAAmC;EACjC9oB,QAAAA,MAAM,CAAC8oB,kBAAP,GAA4B,CAA5B;EACD;EACF;;EACD,QAAI9oB,MAAM,CAACmS,IAAP,KAAgB,aAAhB,IAAiCnS,MAAM,CAAC6pB,mBAA5C,EAAiE;EAC/D5oB,MAAAA,GAAG,CAACnQ,QAAJ,CAAakP,MAAM,CAAC6qB,wBAApB;EACD;;EAED,QAAI7qB,MAAM,CAACkoB,SAAX,EAAsB;EACpBjnB,MAAAA,GAAG,CAAChO,EAAJ,CAAO,OAAP,QAAoB+M,MAAM,CAACuqB,WAAP,CAAmB9vB,OAAnB,CAA2B,IAA3B,EAAiC,GAAjC,CAApB,EAA6D,SAASse,OAAT,CAAiB9rB,CAAjB,EAAoB;EAC/EA,QAAAA,CAAC,CAAC2mB,cAAF;EACA,YAAIxc,KAAK,GAAG7G,CAAC,CAAC,IAAD,CAAD,CAAQ6G,KAAR,KAAkByH,MAAM,CAACmB,MAAP,CAAcuG,cAA5C;EACA,YAAI1H,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB3T,KAAK,IAAIyH,MAAM,CAAC6P,YAAhB;EACxB7P,QAAAA,MAAM,CAAC6O,OAAP,CAAetW,KAAf;EACD,OALD;EAMD;;EAEDrP,IAAAA,QAAM,CAAC8W,MAAM,CAACopB,UAAR,EAAoB;EACxBhnB,MAAAA,GAAG,EAAHA,GADwB;EAExBpR,MAAAA,EAAE,EAAEoR,GAAG,CAAC,CAAD;EAFiB,KAApB,CAAN;EAID,GA5RgB;EA6RjBf,EAAAA,OA7RiB,qBA6RP;EACR,QAAMrB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcioB,UAA7B;EACA,QACE,CAACjoB,MAAM,CAACnQ,EAAR,IACA,CAACgP,MAAM,CAACopB,UAAP,CAAkBp4B,EADnB,IAEA,CAACgP,MAAM,CAACopB,UAAP,CAAkBhnB,GAFnB,IAGApC,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsB5Y,MAAtB,KAAiC,CAJnC,EAME;EACF,QAAM4Y,GAAG,GAAGpC,MAAM,CAACopB,UAAP,CAAkBhnB,GAA9B;EAEAA,IAAAA,GAAG,CAACxP,WAAJ,CAAgBuO,MAAM,CAAC4nB,WAAvB;EACA3mB,IAAAA,GAAG,CAACxP,WAAJ,CAAgBuO,MAAM,CAAC4qB,aAAP,GAAuB5qB,MAAM,CAACmS,IAA9C;EACA,QAAItT,MAAM,CAACopB,UAAP,CAAkBO,OAAtB,EAA+B3pB,MAAM,CAACopB,UAAP,CAAkBO,OAAlB,CAA0B/2B,WAA1B,CAAsCuO,MAAM,CAACgpB,iBAA7C;;EAC/B,QAAIhpB,MAAM,CAACkoB,SAAX,EAAsB;EACpBjnB,MAAAA,GAAG,CAACzM,GAAJ,CAAQ,OAAR,QAAqBwL,MAAM,CAACuqB,WAAP,CAAmB9vB,OAAnB,CAA2B,IAA3B,EAAiC,GAAjC,CAArB;EACD;EACF;EA/SgB,CAAnB;AAkTA,qBAAe;EACbmE,EAAAA,IAAI,EAAE,YADO;EAEboB,EAAAA,MAAM,EAAE;EACNioB,IAAAA,UAAU,EAAE;EACVp4B,MAAAA,EAAE,EAAE,IADM;EAEV26B,MAAAA,aAAa,EAAE,MAFL;EAGVtC,MAAAA,SAAS,EAAE,KAHD;EAIVP,MAAAA,WAAW,EAAE,KAJH;EAKV2C,MAAAA,YAAY,EAAE,IALJ;EAMVI,MAAAA,iBAAiB,EAAE,IANT;EAOVD,MAAAA,cAAc,EAAE,IAPN;EAQVP,MAAAA,YAAY,EAAE,IARJ;EASVL,MAAAA,mBAAmB,EAAE,KATX;EAUV1X,MAAAA,IAAI,EAAE,SAVI;EAUO;EACjByW,MAAAA,cAAc,EAAE,KAXN;EAYVE,MAAAA,kBAAkB,EAAE,CAZV;EAaVW,MAAAA,qBAAqB,EAAE,+BAACqB,MAAD;EAAA,eAAYA,MAAZ;EAAA,OAbb;EAcVnB,MAAAA,mBAAmB,EAAE,6BAACmB,MAAD;EAAA,eAAYA,MAAZ;EAAA,OAdX;EAeVP,MAAAA,WAAW,EAAE,0BAfH;EAgBVvB,MAAAA,iBAAiB,EAAE,iCAhBT;EAiBV4B,MAAAA,aAAa,EAAE,oBAjBL;EAiB2B;EACrCpB,MAAAA,YAAY,EAAE,2BAlBJ;EAmBVE,MAAAA,UAAU,EAAE,yBAnBF;EAoBV9B,MAAAA,WAAW,EAAE,0BApBH;EAqBVqC,MAAAA,oBAAoB,EAAE,oCArBZ;EAsBVY,MAAAA,wBAAwB,EAAE,wCAtBhB;EAuBVF,MAAAA,cAAc,EAAE,6BAvBN;EAuBqC;EAC/CnD,MAAAA,SAAS,EAAE;EAxBD;EADN,GAFK;EA8Bbt7B,EAAAA,MA9Ba,oBA8BJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBopB,MAAAA,UAAU;EACRc,QAAAA,kBAAkB,EAAE;EADZ,SAELX,UAFK;EADc,KAAT,CAAjB;EAMD,GAtCY;EAuCbn1B,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACXA,MAAAA,MAAM,CAACopB,UAAP,CAAkBloB,IAAlB;EACAlB,MAAAA,MAAM,CAACopB,UAAP,CAAkBkC,MAAlB;EACAtrB,MAAAA,MAAM,CAACopB,UAAP,CAAkBhX,MAAlB;EACD,KALC;EAMF8Z,IAAAA,iBANE,6BAMgBlsB,MANhB,EAMwB;EACxB,UAAIA,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtBlM,QAAAA,MAAM,CAACopB,UAAP,CAAkBhX,MAAlB;EACD,OAFD,MAEO,IAAI,OAAOpS,MAAM,CAACsJ,SAAd,KAA4B,WAAhC,EAA6C;EAClDtJ,QAAAA,MAAM,CAACopB,UAAP,CAAkBhX,MAAlB;EACD;EACF,KAZC;EAaF+Z,IAAAA,eAbE,2BAacnsB,MAbd,EAasB;EACtB,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAc+K,IAAnB,EAAyB;EACvBlM,QAAAA,MAAM,CAACopB,UAAP,CAAkBhX,MAAlB;EACD;EACF,KAjBC;EAkBFga,IAAAA,kBAlBE,8BAkBiBpsB,MAlBjB,EAkByB;EACzB,UAAIA,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtBlM,QAAAA,MAAM,CAACopB,UAAP,CAAkBkC,MAAlB;EACAtrB,QAAAA,MAAM,CAACopB,UAAP,CAAkBhX,MAAlB;EACD;EACF,KAvBC;EAwBFia,IAAAA,oBAxBE,gCAwBmBrsB,MAxBnB,EAwB2B;EAC3B,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAc+K,IAAnB,EAAyB;EACvBlM,QAAAA,MAAM,CAACopB,UAAP,CAAkBkC,MAAlB;EACAtrB,QAAAA,MAAM,CAACopB,UAAP,CAAkBhX,MAAlB;EACD;EACF,KA7BC;EA8BF/Q,IAAAA,OA9BE,mBA8BMrB,MA9BN,EA8Bc;EACdA,MAAAA,MAAM,CAACopB,UAAP,CAAkB/nB,OAAlB;EACD,KAhCC;EAiCF6nB,IAAAA,KAjCE,iBAiCIlpB,MAjCJ,EAiCY5R,CAjCZ,EAiCe;EACf,UAAM+6B,QAAQ,GAAG/6B,CAAC,CAACjF,MAAnB;;EACA,UACE6W,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBp4B,EAAzB,IACAgP,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBN,WADzB,IAEA9oB,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsB5Y,MAAtB,GAA+B,CAF/B,IAGA,CAACkI,CAAC,CAACy3B,QAAD,CAAD,CAAY71B,QAAZ,CAAqB0M,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBsC,WAA9C,CAJH,EAKE;EACA,YACE1rB,MAAM,CAACwZ,UAAP,KACExZ,MAAM,CAACwZ,UAAP,CAAkBC,MAAlB,IAA4B0P,QAAQ,KAAKnpB,MAAM,CAACwZ,UAAP,CAAkBC,MAA5D,IACEzZ,MAAM,CAACwZ,UAAP,CAAkBE,MAAlB,IAA4ByP,QAAQ,KAAKnpB,MAAM,CAACwZ,UAAP,CAAkBE,MAF9D,CADF,EAKE;EACF,YAAM4P,QAAQ,GAAGtpB,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsB9O,QAAtB,CAA+B0M,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBL,WAAxD,CAAjB;;EACA,YAAIO,QAAQ,KAAK,IAAjB,EAAuB;EACrBtpB,UAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ;EACD,SAFD,MAEO;EACLhB,UAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ;EACD;;EACDhB,QAAAA,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsBnP,WAAtB,CAAkC+M,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBL,WAA3D;EACD;EACF;EAvDC;EAvCS,CAAf;;ECjTA,IAAMuD,SAAS,GAAG;EAChB/e,EAAAA,YADgB,0BACD;EACb,QAAMvN,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBv7B,EAAzB,IAA+B,CAACgP,MAAM,CAACusB,SAAP,CAAiBv7B,EAArD,EAAyD;EAF5C,QAGLu7B,SAHK,GAGsCvsB,MAHtC,CAGLusB,SAHK;EAAA,QAGoB3nB,GAHpB,GAGsC5E,MAHtC,CAGM6E,YAHN;EAAA,QAGyBmG,QAHzB,GAGsChL,MAHtC,CAGyBgL,QAHzB;EAAA,QAILwhB,QAJK,GAIiCD,SAJjC,CAILC,QAJK;EAAA,QAIKC,SAJL,GAIiCF,SAJjC,CAIKE,SAJL;EAAA,QAIgBC,OAJhB,GAIiCH,SAJjC,CAIgBG,OAJhB;EAAA,QAIyBtqB,GAJzB,GAIiCmqB,SAJjC,CAIyBnqB,GAJzB;EAKb,QAAMjB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcorB,SAA7B;EAEA,QAAII,OAAO,GAAGH,QAAd;EACA,QAAII,MAAM,GAAG,CAACH,SAAS,GAAGD,QAAb,IAAyBxhB,QAAtC;;EACA,QAAIpG,GAAJ,EAAS;EACPgoB,MAAAA,MAAM,GAAG,CAACA,MAAV;;EACA,UAAIA,MAAM,GAAG,CAAb,EAAgB;EACdD,QAAAA,OAAO,GAAGH,QAAQ,GAAGI,MAArB;EACAA,QAAAA,MAAM,GAAG,CAAT;EACD,OAHD,MAGO,IAAI,CAACA,MAAD,GAAUJ,QAAV,GAAqBC,SAAzB,EAAoC;EACzCE,QAAAA,OAAO,GAAGF,SAAS,GAAGG,MAAtB;EACD;EACF,KARD,MAQO,IAAIA,MAAM,GAAG,CAAb,EAAgB;EACrBD,MAAAA,OAAO,GAAGH,QAAQ,GAAGI,MAArB;EACAA,MAAAA,MAAM,GAAG,CAAT;EACD,KAHM,MAGA,IAAIA,MAAM,GAAGJ,QAAT,GAAoBC,SAAxB,EAAmC;EACxCE,MAAAA,OAAO,GAAGF,SAAS,GAAGG,MAAtB;EACD;;EACD,QAAI5sB,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB2oB,MAAAA,OAAO,CAAC14B,SAAR,kBAAiC44B,MAAjC;EACAF,MAAAA,OAAO,CAAC,CAAD,CAAP,CAAWliC,KAAX,CAAiBgU,KAAjB,GAA4BmuB,OAA5B;EACD,KAHD,MAGO;EACLD,MAAAA,OAAO,CAAC14B,SAAR,uBAAsC44B,MAAtC;EACAF,MAAAA,OAAO,CAAC,CAAD,CAAP,CAAWliC,KAAX,CAAiBkU,MAAjB,GAA6BiuB,OAA7B;EACD;;EACD,QAAIxrB,MAAM,CAAC0rB,IAAX,EAAiB;EACfrgC,MAAAA,YAAY,CAACwT,MAAM,CAACusB,SAAP,CAAiB3E,OAAlB,CAAZ;EACAxlB,MAAAA,GAAG,CAAC,CAAD,CAAH,CAAO5X,KAAP,CAAasiC,OAAb,GAAuB,CAAvB;EACA9sB,MAAAA,MAAM,CAACusB,SAAP,CAAiB3E,OAAjB,GAA2Br7B,UAAU,CAAC,YAAM;EAC1C6V,QAAAA,GAAG,CAAC,CAAD,CAAH,CAAO5X,KAAP,CAAasiC,OAAb,GAAuB,CAAvB;EACA1qB,QAAAA,GAAG,CAACnO,UAAJ,CAAe,GAAf;EACD,OAHoC,EAGlC,IAHkC,CAArC;EAID;EACF,GAvCe;EAwChB8V,EAAAA,aAxCgB,yBAwCF7V,QAxCE,EAwCQ;EACtB,QAAM8L,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBv7B,EAAzB,IAA+B,CAACgP,MAAM,CAACusB,SAAP,CAAiBv7B,EAArD,EAAyD;EACzDgP,IAAAA,MAAM,CAACusB,SAAP,CAAiBG,OAAjB,CAAyBz4B,UAAzB,CAAoCC,QAApC;EACD,GA5Ce;EA6ChB0P,EAAAA,UA7CgB,wBA6CH;EACX,QAAM5D,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBv7B,EAAzB,IAA+B,CAACgP,MAAM,CAACusB,SAAP,CAAiBv7B,EAArD,EAAyD;EAF9C,QAIHu7B,SAJG,GAIWvsB,MAJX,CAIHusB,SAJG;EAAA,QAKHG,OALG,GAKcH,SALd,CAKHG,OALG;EAAA,QAKMtqB,GALN,GAKcmqB,SALd,CAKMnqB,GALN;EAOXsqB,IAAAA,OAAO,CAAC,CAAD,CAAP,CAAWliC,KAAX,CAAiBgU,KAAjB,GAAyB,EAAzB;EACAkuB,IAAAA,OAAO,CAAC,CAAD,CAAP,CAAWliC,KAAX,CAAiBkU,MAAjB,GAA0B,EAA1B;EACA,QAAM+tB,SAAS,GAAGzsB,MAAM,CAAC+D,YAAP,KAAwB3B,GAAG,CAAC,CAAD,CAAH,CAAOjL,WAA/B,GAA6CiL,GAAG,CAAC,CAAD,CAAH,CAAO7K,YAAtE;EAEA,QAAMw1B,OAAO,GAAG/sB,MAAM,CAACoE,IAAP,GAAcpE,MAAM,CAACsG,WAArC;EACA,QAAM0mB,WAAW,GAAGD,OAAO,IAAIN,SAAS,GAAGzsB,MAAM,CAACoE,IAAvB,CAA3B;EACA,QAAIooB,QAAJ;;EACA,QAAIxsB,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBC,QAAxB,KAAqC,MAAzC,EAAiD;EAC/CA,MAAAA,QAAQ,GAAGC,SAAS,GAAGM,OAAvB;EACD,KAFD,MAEO;EACLP,MAAAA,QAAQ,GAAGvoB,QAAQ,CAACjE,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBC,QAAzB,EAAmC,EAAnC,CAAnB;EACD;;EAED,QAAIxsB,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB2oB,MAAAA,OAAO,CAAC,CAAD,CAAP,CAAWliC,KAAX,CAAiBgU,KAAjB,GAA4BguB,QAA5B;EACD,KAFD,MAEO;EACLE,MAAAA,OAAO,CAAC,CAAD,CAAP,CAAWliC,KAAX,CAAiBkU,MAAjB,GAA6B8tB,QAA7B;EACD;;EAED,QAAIO,OAAO,IAAI,CAAf,EAAkB;EAChB3qB,MAAAA,GAAG,CAAC,CAAD,CAAH,CAAO5X,KAAP,CAAayiC,OAAb,GAAuB,MAAvB;EACD,KAFD,MAEO;EACL7qB,MAAAA,GAAG,CAAC,CAAD,CAAH,CAAO5X,KAAP,CAAayiC,OAAb,GAAuB,EAAvB;EACD;;EACD,QAAIjtB,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBM,IAA5B,EAAkC;EAChCzqB,MAAAA,GAAG,CAAC,CAAD,CAAH,CAAO5X,KAAP,CAAasiC,OAAb,GAAuB,CAAvB;EACD;;EACD5jC,IAAAA,QAAM,CAACqjC,SAAD,EAAY;EAChBE,MAAAA,SAAS,EAATA,SADgB;EAEhBM,MAAAA,OAAO,EAAPA,OAFgB;EAGhBC,MAAAA,WAAW,EAAXA,WAHgB;EAIhBR,MAAAA,QAAQ,EAARA;EAJgB,KAAZ,CAAN;EAMAD,IAAAA,SAAS,CAACnqB,GAAV,CAAcpC,MAAM,CAACmB,MAAP,CAAcoI,aAAd,IAA+BvJ,MAAM,CAACgS,QAAtC,GAAiD,UAAjD,GAA8D,aAA5E,EACEhS,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwB5D,SAD1B;EAGD,GAxFe;EAyFhBuE,EAAAA,kBAzFgB,8BAyFG9+B,CAzFH,EAyFM;EACpB,QAAM4R,MAAM,GAAG,IAAf;;EACA,QAAIA,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EACzB,aAAO3V,CAAC,CAACklB,IAAF,KAAW,YAAX,IAA2BllB,CAAC,CAACklB,IAAF,KAAW,WAAtC,GACHllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmB+Y,OADhB,GAEH/+B,CAAC,CAAC++B,OAFN;EAGD;;EACD,WAAO/+B,CAAC,CAACklB,IAAF,KAAW,YAAX,IAA2BllB,CAAC,CAACklB,IAAF,KAAW,WAAtC,GACHllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBgZ,OADhB,GAEHh/B,CAAC,CAACg/B,OAFN;EAGD,GAnGe;EAoGhBC,EAAAA,eApGgB,2BAoGAj/B,CApGA,EAoGG;EACjB,QAAM4R,MAAM,GAAG,IAAf;EADiB,QAETusB,SAFS,GAEwBvsB,MAFxB,CAETusB,SAFS;EAAA,QAEgB3nB,GAFhB,GAEwB5E,MAFxB,CAEE6E,YAFF;EAAA,QAGTzC,GAHS,GAGkCmqB,SAHlC,CAGTnqB,GAHS;EAAA,QAGJoqB,QAHI,GAGkCD,SAHlC,CAGJC,QAHI;EAAA,QAGMC,SAHN,GAGkCF,SAHlC,CAGME,SAHN;EAAA,QAGiBa,YAHjB,GAGkCf,SAHlC,CAGiBe,YAHjB;EAKjB,QAAIC,aAAJ;EACAA,IAAAA,aAAa,GACX,CAAChB,SAAS,CAACW,kBAAV,CAA6B9+B,CAA7B,IACCgU,GAAG,CAAC5K,MAAJ,GAAawI,MAAM,CAAC+D,YAAP,KAAwB,MAAxB,GAAiC,KAA9C,CADD,IAEEupB,YAAY,KAAK,IAAjB,GAAwBA,YAAxB,GAAuCd,QAAQ,GAAG,CAFpD,CAAD,KAGCC,SAAS,GAAGD,QAHb,CADF;EAKAe,IAAAA,aAAa,GAAG1mB,IAAI,CAACK,GAAL,CAASL,IAAI,CAACiB,GAAL,CAASylB,aAAT,EAAwB,CAAxB,CAAT,EAAqC,CAArC,CAAhB;;EACA,QAAI3oB,GAAJ,EAAS;EACP2oB,MAAAA,aAAa,GAAG,IAAIA,aAApB;EACD;;EAED,QAAMnW,QAAQ,GACZpX,MAAM,CAAC2K,YAAP,KAAwB,CAAC3K,MAAM,CAACoL,YAAP,KAAwBpL,MAAM,CAAC2K,YAAP,EAAzB,IAAkD4iB,aAD5E;EAGAvtB,IAAAA,MAAM,CAACiL,cAAP,CAAsBmM,QAAtB;EACApX,IAAAA,MAAM,CAACuN,YAAP,CAAoB6J,QAApB;EACApX,IAAAA,MAAM,CAACuM,iBAAP;EACAvM,IAAAA,MAAM,CAACyL,mBAAP;EACD,GA3He;EA4HhB+hB,EAAAA,WA5HgB,uBA4HJp/B,CA5HI,EA4HD;EACb,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcorB,SAA7B;EAFa,QAGLA,SAHK,GAGqBvsB,MAHrB,CAGLusB,SAHK;EAAA,QAGMjqB,UAHN,GAGqBtC,MAHrB,CAGMsC,UAHN;EAAA,QAILF,GAJK,GAIYmqB,SAJZ,CAILnqB,GAJK;EAAA,QAIAsqB,OAJA,GAIYH,SAJZ,CAIAG,OAJA;EAKb1sB,IAAAA,MAAM,CAACusB,SAAP,CAAiB9Y,SAAjB,GAA6B,IAA7B;EACAzT,IAAAA,MAAM,CAACusB,SAAP,CAAiBe,YAAjB,GACEl/B,CAAC,CAACjF,MAAF,KAAaujC,OAAO,CAAC,CAAD,CAApB,IAA2Bt+B,CAAC,CAACjF,MAAF,KAAaujC,OAAxC,GACIH,SAAS,CAACW,kBAAV,CAA6B9+B,CAA7B,IACAA,CAAC,CAACjF,MAAF,CAASuO,qBAAT,GAAiCsI,MAAM,CAAC+D,YAAP,KAAwB,MAAxB,GAAiC,KAAlE,CAFJ,GAGI,IAJN;EAKA3V,IAAAA,CAAC,CAAC2mB,cAAF;EACA3mB,IAAAA,CAAC,CAACqoB,eAAF;EAEAnU,IAAAA,UAAU,CAACrO,UAAX,CAAsB,GAAtB;EACAy4B,IAAAA,OAAO,CAACz4B,UAAR,CAAmB,GAAnB;EACAs4B,IAAAA,SAAS,CAACc,eAAV,CAA0Bj/B,CAA1B;EAEA5B,IAAAA,YAAY,CAACwT,MAAM,CAACusB,SAAP,CAAiBkB,WAAlB,CAAZ;EAEArrB,IAAAA,GAAG,CAACnO,UAAJ,CAAe,CAAf;;EACA,QAAIkN,MAAM,CAAC0rB,IAAX,EAAiB;EACfzqB,MAAAA,GAAG,CAACjK,GAAJ,CAAQ,SAAR,EAAmB,CAAnB;EACD;;EACD,QAAI6H,MAAM,CAACmB,MAAP,CAAcyE,OAAlB,EAA2B;EACzB5F,MAAAA,MAAM,CAACsC,UAAP,CAAkBnK,GAAlB,CAAsB,kBAAtB,EAA0C,MAA1C;EACD;;EACD6H,IAAAA,MAAM,CAACgB,IAAP,CAAY,oBAAZ,EAAkC5S,CAAlC;EACD,GAxJe;EAyJhBs/B,EAAAA,UAzJgB,sBAyJLt/B,CAzJK,EAyJF;EACZ,QAAM4R,MAAM,GAAG,IAAf;EADY,QAEJusB,SAFI,GAEsBvsB,MAFtB,CAEJusB,SAFI;EAAA,QAEOjqB,UAFP,GAEsBtC,MAFtB,CAEOsC,UAFP;EAAA,QAGJF,GAHI,GAGamqB,SAHb,CAGJnqB,GAHI;EAAA,QAGCsqB,OAHD,GAGaH,SAHb,CAGCG,OAHD;EAKZ,QAAI,CAAC1sB,MAAM,CAACusB,SAAP,CAAiB9Y,SAAtB,EAAiC;EACjC,QAAIrlB,CAAC,CAAC2mB,cAAN,EAAsB3mB,CAAC,CAAC2mB,cAAF,GAAtB,KACK3mB,CAAC,CAACs2B,WAAF,GAAgB,KAAhB;EACL6H,IAAAA,SAAS,CAACc,eAAV,CAA0Bj/B,CAA1B;EACAkU,IAAAA,UAAU,CAACrO,UAAX,CAAsB,CAAtB;EACAmO,IAAAA,GAAG,CAACnO,UAAJ,CAAe,CAAf;EACAy4B,IAAAA,OAAO,CAACz4B,UAAR,CAAmB,CAAnB;EACA+L,IAAAA,MAAM,CAACgB,IAAP,CAAY,mBAAZ,EAAiC5S,CAAjC;EACD,GAtKe;EAuKhBu/B,EAAAA,SAvKgB,qBAuKNv/B,CAvKM,EAuKH;EACX,QAAM4R,MAAM,GAAG,IAAf;EAEA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcorB,SAA7B;EAHW,QAIHA,SAJG,GAIuBvsB,MAJvB,CAIHusB,SAJG;EAAA,QAIQjqB,UAJR,GAIuBtC,MAJvB,CAIQsC,UAJR;EAAA,QAKHF,GALG,GAKKmqB,SALL,CAKHnqB,GALG;EAOX,QAAI,CAACpC,MAAM,CAACusB,SAAP,CAAiB9Y,SAAtB,EAAiC;EACjCzT,IAAAA,MAAM,CAACusB,SAAP,CAAiB9Y,SAAjB,GAA6B,KAA7B;;EACA,QAAIzT,MAAM,CAACmB,MAAP,CAAcyE,OAAlB,EAA2B;EACzB5F,MAAAA,MAAM,CAACsC,UAAP,CAAkBnK,GAAlB,CAAsB,kBAAtB,EAA0C,EAA1C;EACAmK,MAAAA,UAAU,CAACrO,UAAX,CAAsB,EAAtB;EACD;;EACD,QAAIkN,MAAM,CAAC0rB,IAAX,EAAiB;EACfrgC,MAAAA,YAAY,CAACwT,MAAM,CAACusB,SAAP,CAAiBkB,WAAlB,CAAZ;EACAztB,MAAAA,MAAM,CAACusB,SAAP,CAAiBkB,WAAjB,GAA+BzyB,QAAQ,CAAC,YAAM;EAC5CoH,QAAAA,GAAG,CAACjK,GAAJ,CAAQ,SAAR,EAAmB,CAAnB;EACAiK,QAAAA,GAAG,CAACnO,UAAJ,CAAe,GAAf;EACD,OAHsC,EAGpC,IAHoC,CAAvC;EAID;;EACD+L,IAAAA,MAAM,CAACgB,IAAP,CAAY,kBAAZ,EAAgC5S,CAAhC;;EACA,QAAI+S,MAAM,CAACysB,aAAX,EAA0B;EACxB5tB,MAAAA,MAAM,CAAC0Q,cAAP;EACD;EACF,GA/Le;EAgMhBmd,EAAAA,eAhMgB,6BAgME;EAChB,QAAM7tB,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBv7B,EAA7B,EAAiC;EACjC,QAAMxF,QAAQ,GAAGF,WAAW,EAA5B;EAHgB,QAIRihC,SAJQ,GAI6DvsB,MAJ7D,CAIRusB,SAJQ;EAAA,QAIG7M,gBAJH,GAI6D1f,MAJ7D,CAIG0f,gBAJH;EAAA,QAIqBC,kBAJrB,GAI6D3f,MAJ7D,CAIqB2f,kBAJrB;EAAA,QAIyCxe,MAJzC,GAI6DnB,MAJ7D,CAIyCmB,MAJzC;EAAA,QAIiDlE,OAJjD,GAI6D+C,MAJ7D,CAIiD/C,OAJjD;EAKhB,QAAMmF,GAAG,GAAGmqB,SAAS,CAACnqB,GAAtB;EACA,QAAMjZ,MAAM,GAAGiZ,GAAG,CAAC,CAAD,CAAlB;EACA,QAAM0rB,cAAc,GAClB7wB,OAAO,CAACS,eAAR,IAA2ByD,MAAM,CAAC2Z,gBAAlC,GACI;EAAEC,MAAAA,OAAO,EAAE,KAAX;EAAkBrmB,MAAAA,OAAO,EAAE;EAA3B,KADJ,GAEI,KAHN;EAIA,QAAMgJ,eAAe,GACnBT,OAAO,CAACS,eAAR,IAA2ByD,MAAM,CAAC2Z,gBAAlC,GACI;EAAEC,MAAAA,OAAO,EAAE,IAAX;EAAiBrmB,MAAAA,OAAO,EAAE;EAA1B,KADJ,GAEI,KAHN;EAIA,QAAI,CAACvL,MAAL,EAAa;;EACb,QAAI,CAAC8T,OAAO,CAACE,KAAb,EAAoB;EAClBhU,MAAAA,MAAM,CAACQ,gBAAP,CACEg2B,kBAAkB,CAAChF,KADrB,EAEE3a,MAAM,CAACusB,SAAP,CAAiBiB,WAFnB,EAGEM,cAHF;EAKAtiC,MAAAA,QAAQ,CAAC7B,gBAAT,CACEg2B,kBAAkB,CAAC/E,IADrB,EAEE5a,MAAM,CAACusB,SAAP,CAAiBmB,UAFnB,EAGEI,cAHF;EAKAtiC,MAAAA,QAAQ,CAAC7B,gBAAT,CACEg2B,kBAAkB,CAAC9E,GADrB,EAEE7a,MAAM,CAACusB,SAAP,CAAiBoB,SAFnB,EAGEjwB,eAHF;EAKD,KAhBD,MAgBO;EACLvU,MAAAA,MAAM,CAACQ,gBAAP,CAAwB+1B,gBAAgB,CAAC/E,KAAzC,EAAgD3a,MAAM,CAACusB,SAAP,CAAiBiB,WAAjE,EAA8EM,cAA9E;EACA3kC,MAAAA,MAAM,CAACQ,gBAAP,CAAwB+1B,gBAAgB,CAAC9E,IAAzC,EAA+C5a,MAAM,CAACusB,SAAP,CAAiBmB,UAAhE,EAA4EI,cAA5E;EACA3kC,MAAAA,MAAM,CAACQ,gBAAP,CAAwB+1B,gBAAgB,CAAC7E,GAAzC,EAA8C7a,MAAM,CAACusB,SAAP,CAAiBoB,SAA/D,EAA0EjwB,eAA1E;EACD;EACF,GArOe;EAsOhBqwB,EAAAA,gBAtOgB,8BAsOG;EACjB,QAAM/tB,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBv7B,EAA7B,EAAiC;EACjC,QAAMxF,QAAQ,GAAGF,WAAW,EAA5B;EAHiB,QAITihC,SAJS,GAI4DvsB,MAJ5D,CAITusB,SAJS;EAAA,QAIE7M,gBAJF,GAI4D1f,MAJ5D,CAIE0f,gBAJF;EAAA,QAIoBC,kBAJpB,GAI4D3f,MAJ5D,CAIoB2f,kBAJpB;EAAA,QAIwCxe,MAJxC,GAI4DnB,MAJ5D,CAIwCmB,MAJxC;EAAA,QAIgDlE,OAJhD,GAI4D+C,MAJ5D,CAIgD/C,OAJhD;EAKjB,QAAMmF,GAAG,GAAGmqB,SAAS,CAACnqB,GAAtB;EACA,QAAMjZ,MAAM,GAAGiZ,GAAG,CAAC,CAAD,CAAlB;EACA,QAAM0rB,cAAc,GAClB7wB,OAAO,CAACS,eAAR,IAA2ByD,MAAM,CAAC2Z,gBAAlC,GACI;EAAEC,MAAAA,OAAO,EAAE,KAAX;EAAkBrmB,MAAAA,OAAO,EAAE;EAA3B,KADJ,GAEI,KAHN;EAIA,QAAMgJ,eAAe,GACnBT,OAAO,CAACS,eAAR,IAA2ByD,MAAM,CAAC2Z,gBAAlC,GACI;EAAEC,MAAAA,OAAO,EAAE,IAAX;EAAiBrmB,MAAAA,OAAO,EAAE;EAA1B,KADJ,GAEI,KAHN;EAIA,QAAI,CAACvL,MAAL,EAAa;;EACb,QAAI,CAAC8T,OAAO,CAACE,KAAb,EAAoB;EAClBhU,MAAAA,MAAM,CAACS,mBAAP,CACE+1B,kBAAkB,CAAChF,KADrB,EAEE3a,MAAM,CAACusB,SAAP,CAAiBiB,WAFnB,EAGEM,cAHF;EAKAtiC,MAAAA,QAAQ,CAAC5B,mBAAT,CACE+1B,kBAAkB,CAAC/E,IADrB,EAEE5a,MAAM,CAACusB,SAAP,CAAiBmB,UAFnB,EAGEI,cAHF;EAKAtiC,MAAAA,QAAQ,CAAC5B,mBAAT,CACE+1B,kBAAkB,CAAC9E,GADrB,EAEE7a,MAAM,CAACusB,SAAP,CAAiBoB,SAFnB,EAGEjwB,eAHF;EAKD,KAhBD,MAgBO;EACLvU,MAAAA,MAAM,CAACS,mBAAP,CACE81B,gBAAgB,CAAC/E,KADnB,EAEE3a,MAAM,CAACusB,SAAP,CAAiBiB,WAFnB,EAGEM,cAHF;EAKA3kC,MAAAA,MAAM,CAACS,mBAAP,CACE81B,gBAAgB,CAAC9E,IADnB,EAEE5a,MAAM,CAACusB,SAAP,CAAiBmB,UAFnB,EAGEI,cAHF;EAKA3kC,MAAAA,MAAM,CAACS,mBAAP,CAA2B81B,gBAAgB,CAAC7E,GAA5C,EAAiD7a,MAAM,CAACusB,SAAP,CAAiBoB,SAAlE,EAA6EjwB,eAA7E;EACD;EACF,GAnRe;EAoRhBwD,EAAAA,IApRgB,kBAoRT;EACL,QAAMlB,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwBv7B,EAA7B,EAAiC;EAF5B,QAGGu7B,SAHH,GAGiCvsB,MAHjC,CAGGusB,SAHH;EAAA,QAGmByB,SAHnB,GAGiChuB,MAHjC,CAGcoC,GAHd;EAIL,QAAMjB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcorB,SAA7B;EAEA,QAAInqB,GAAG,GAAG1Q,CAAC,CAACyP,MAAM,CAACnQ,EAAR,CAAX;;EACA,QACEgP,MAAM,CAACmB,MAAP,CAAcqd,iBAAd,IACA,OAAOrd,MAAM,CAACnQ,EAAd,KAAqB,QADrB,IAEAoR,GAAG,CAAC5Y,MAAJ,GAAa,CAFb,IAGAwkC,SAAS,CAACxzB,IAAV,CAAe2G,MAAM,CAACnQ,EAAtB,EAA0BxH,MAA1B,KAAqC,CAJvC,EAKE;EACA4Y,MAAAA,GAAG,GAAG4rB,SAAS,CAACxzB,IAAV,CAAe2G,MAAM,CAACnQ,EAAtB,CAAN;EACD;;EAED,QAAI07B,OAAO,GAAGtqB,GAAG,CAAC5H,IAAJ,OAAawF,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwB0B,SAArC,CAAd;;EACA,QAAIvB,OAAO,CAACljC,MAAR,KAAmB,CAAvB,EAA0B;EACxBkjC,MAAAA,OAAO,GAAGh7B,CAAC,mBAAgBsO,MAAM,CAACmB,MAAP,CAAcorB,SAAd,CAAwB0B,SAAxC,eAAX;EACA7rB,MAAAA,GAAG,CAACjJ,MAAJ,CAAWuzB,OAAX;EACD;;EAEDxjC,IAAAA,QAAM,CAACqjC,SAAD,EAAY;EAChBnqB,MAAAA,GAAG,EAAHA,GADgB;EAEhBpR,MAAAA,EAAE,EAAEoR,GAAG,CAAC,CAAD,CAFS;EAGhBsqB,MAAAA,OAAO,EAAPA,OAHgB;EAIhBwB,MAAAA,MAAM,EAAExB,OAAO,CAAC,CAAD;EAJC,KAAZ,CAAN;;EAOA,QAAIvrB,MAAM,CAACgtB,SAAX,EAAsB;EACpB5B,MAAAA,SAAS,CAACsB,eAAV;EACD;EACF,GApTe;EAqThBxsB,EAAAA,OArTgB,qBAqTN;EACR,QAAMrB,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAACusB,SAAP,CAAiBwB,gBAAjB;EACD;EAxTe,CAAlB;AA2TA,oBAAe;EACbhuB,EAAAA,IAAI,EAAE,WADO;EAEboB,EAAAA,MAAM,EAAE;EACNorB,IAAAA,SAAS,EAAE;EACTv7B,MAAAA,EAAE,EAAE,IADK;EAETw7B,MAAAA,QAAQ,EAAE,MAFD;EAGTK,MAAAA,IAAI,EAAE,KAHG;EAITsB,MAAAA,SAAS,EAAE,KAJF;EAKTP,MAAAA,aAAa,EAAE,IALN;EAMTjF,MAAAA,SAAS,EAAE,uBANF;EAOTsF,MAAAA,SAAS,EAAE;EAPF;EADL,GAFK;EAab5gC,EAAAA,MAba,oBAaJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBusB,MAAAA,SAAS;EACP9Y,QAAAA,SAAS,EAAE,KADJ;EAEPmU,QAAAA,OAAO,EAAE,IAFF;EAGP6F,QAAAA,WAAW,EAAE;EAHN,SAIJnB,SAJI;EADe,KAAT,CAAjB;EAQD,GAvBY;EAwBbl4B,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACXA,MAAAA,MAAM,CAACusB,SAAP,CAAiBrrB,IAAjB;EACAlB,MAAAA,MAAM,CAACusB,SAAP,CAAiB3oB,UAAjB;EACA5D,MAAAA,MAAM,CAACusB,SAAP,CAAiBhf,YAAjB;EACD,KALC;EAMF6E,IAAAA,MANE,kBAMKpS,MANL,EAMa;EACbA,MAAAA,MAAM,CAACusB,SAAP,CAAiB3oB,UAAjB;EACD,KARC;EASF3D,IAAAA,MATE,kBASKD,MATL,EASa;EACbA,MAAAA,MAAM,CAACusB,SAAP,CAAiB3oB,UAAjB;EACD,KAXC;EAYF/B,IAAAA,cAZE,0BAYa7B,MAZb,EAYqB;EACrBA,MAAAA,MAAM,CAACusB,SAAP,CAAiB3oB,UAAjB;EACD,KAdC;EAeF2J,IAAAA,YAfE,wBAeWvN,MAfX,EAemB;EACnBA,MAAAA,MAAM,CAACusB,SAAP,CAAiBhf,YAAjB;EACD,KAjBC;EAkBFxD,IAAAA,aAlBE,yBAkBY/J,MAlBZ,EAkBoB9L,QAlBpB,EAkB8B;EAC9B8L,MAAAA,MAAM,CAACusB,SAAP,CAAiBxiB,aAAjB,CAA+B7V,QAA/B;EACD,KApBC;EAqBFmN,IAAAA,OArBE,mBAqBMrB,MArBN,EAqBc;EACdA,MAAAA,MAAM,CAACusB,SAAP,CAAiBlrB,OAAjB;EACD;EAvBC;EAxBS,CAAf;;EC5TA,IAAM+sB,QAAQ,GAAG;EACfC,EAAAA,YADe,wBACFr9B,EADE,EACEga,QADF,EACY;EACzB,QAAMhL,MAAM,GAAG,IAAf;EADyB,QAEjB4E,GAFiB,GAET5E,MAFS,CAEjB4E,GAFiB;EAIzB,QAAMxC,GAAG,GAAG1Q,CAAC,CAACV,EAAD,CAAb;EACA,QAAM+1B,SAAS,GAAGniB,GAAG,GAAG,CAAC,CAAJ,GAAQ,CAA7B;EAEA,QAAMhX,CAAC,GAAGwU,GAAG,CAAC1O,IAAJ,CAAS,sBAAT,KAAoC,GAA9C;EACA,QAAIga,CAAC,GAAGtL,GAAG,CAAC1O,IAAJ,CAAS,wBAAT,CAAR;EACA,QAAIia,CAAC,GAAGvL,GAAG,CAAC1O,IAAJ,CAAS,wBAAT,CAAR;EACA,QAAMu3B,KAAK,GAAG7oB,GAAG,CAAC1O,IAAJ,CAAS,4BAAT,CAAd;EACA,QAAMo5B,OAAO,GAAG1qB,GAAG,CAAC1O,IAAJ,CAAS,8BAAT,CAAhB;;EAEA,QAAIga,CAAC,IAAIC,CAAT,EAAY;EACVD,MAAAA,CAAC,GAAGA,CAAC,IAAI,GAAT;EACAC,MAAAA,CAAC,GAAGA,CAAC,IAAI,GAAT;EACD,KAHD,MAGO,IAAI3N,MAAM,CAAC+D,YAAP,EAAJ,EAA2B;EAChC2J,MAAAA,CAAC,GAAG9f,CAAJ;EACA+f,MAAAA,CAAC,GAAG,GAAJ;EACD,KAHM,MAGA;EACLA,MAAAA,CAAC,GAAG/f,CAAJ;EACA8f,MAAAA,CAAC,GAAG,GAAJ;EACD;;EAED,QAAIA,CAAC,CAACve,OAAF,CAAU,GAAV,KAAkB,CAAtB,EAAyB;EACvBue,MAAAA,CAAC,GAAMzJ,QAAQ,CAACyJ,CAAD,EAAI,EAAJ,CAAR,GAAkB1C,QAAlB,GAA6B+b,SAAnC,MAAD;EACD,KAFD,MAEO;EACLrZ,MAAAA,CAAC,GAAMA,CAAC,GAAG1C,QAAJ,GAAe+b,SAArB,OAAD;EACD;;EACD,QAAIpZ,CAAC,CAACxe,OAAF,CAAU,GAAV,KAAkB,CAAtB,EAAyB;EACvBwe,MAAAA,CAAC,GAAM1J,QAAQ,CAAC0J,CAAD,EAAI,EAAJ,CAAR,GAAkB3C,QAAxB,MAAD;EACD,KAFD,MAEO;EACL2C,MAAAA,CAAC,GAAMA,CAAC,GAAG3C,QAAV,OAAD;EACD;;EAED,QAAI,OAAO8hB,OAAP,KAAmB,WAAnB,IAAkCA,OAAO,KAAK,IAAlD,EAAwD;EACtD,UAAMwB,cAAc,GAAGxB,OAAO,GAAG,CAACA,OAAO,GAAG,CAAX,KAAiB,IAAIjmB,IAAI,CAAC4B,GAAL,CAASuC,QAAT,CAArB,CAAjC;EACA5I,MAAAA,GAAG,CAAC,CAAD,CAAH,CAAO5X,KAAP,CAAasiC,OAAb,GAAuBwB,cAAvB;EACD;;EACD,QAAI,OAAOrD,KAAP,KAAiB,WAAjB,IAAgCA,KAAK,KAAK,IAA9C,EAAoD;EAClD7oB,MAAAA,GAAG,CAACpO,SAAJ,kBAA6B0Z,CAA7B,UAAmCC,CAAnC;EACD,KAFD,MAEO;EACL,UAAM4gB,YAAY,GAAGtD,KAAK,GAAG,CAACA,KAAK,GAAG,CAAT,KAAe,IAAIpkB,IAAI,CAAC4B,GAAL,CAASuC,QAAT,CAAnB,CAA7B;EACA5I,MAAAA,GAAG,CAACpO,SAAJ,kBAA6B0Z,CAA7B,UAAmCC,CAAnC,qBAAoD4gB,YAApD;EACD;EACF,GA9Cc;EA+CfhhB,EAAAA,YA/Ce,0BA+CA;EACb,QAAMvN,MAAM,GAAG,IAAf;EADa,QAELoC,GAFK,GAE+BpC,MAF/B,CAELoC,GAFK;EAAA,QAEA+C,MAFA,GAE+BnF,MAF/B,CAEAmF,MAFA;EAAA,QAEQ6F,QAFR,GAE+BhL,MAF/B,CAEQgL,QAFR;EAAA,QAEkB1F,QAFlB,GAE+BtF,MAF/B,CAEkBsF,QAFlB;EAGblD,IAAAA,GAAG,CACA9X,QADH,CAEI,0IAFJ,EAIGgO,IAJH,CAIQ,UAACtH,EAAD,EAAQ;EACZgP,MAAAA,MAAM,CAACwuB,QAAP,CAAgBH,YAAhB,CAA6Br9B,EAA7B,EAAiCga,QAAjC;EACD,KANH;EAOA7F,IAAAA,MAAM,CAAC7M,IAAP,CAAY,UAACoN,OAAD,EAAUC,UAAV,EAAyB;EACnC,UAAI+E,aAAa,GAAGhF,OAAO,CAACsF,QAA5B;;EACA,UAAIhL,MAAM,CAACmB,MAAP,CAAcuG,cAAd,GAA+B,CAA/B,IAAoC1H,MAAM,CAACmB,MAAP,CAAc6F,aAAd,KAAgC,MAAxE,EAAgF;EAC9E0D,QAAAA,aAAa,IAAI7D,IAAI,CAACE,IAAL,CAAUpB,UAAU,GAAG,CAAvB,IAA4BqF,QAAQ,IAAI1F,QAAQ,CAAC9b,MAAT,GAAkB,CAAtB,CAArD;EACD;;EACDkhB,MAAAA,aAAa,GAAG7D,IAAI,CAACiB,GAAL,CAASjB,IAAI,CAACK,GAAL,CAASwD,aAAT,EAAwB,CAAC,CAAzB,CAAT,EAAsC,CAAtC,CAAhB;EACAhZ,MAAAA,CAAC,CAACgU,OAAD,CAAD,CACGlL,IADH,CAEI,0IAFJ,EAIGlC,IAJH,CAIQ,UAACtH,EAAD,EAAQ;EACZgP,QAAAA,MAAM,CAACwuB,QAAP,CAAgBH,YAAhB,CAA6Br9B,EAA7B,EAAiC0Z,aAAjC;EACD,OANH;EAOD,KAbD;EAcD,GAvEc;EAwEfX,EAAAA,aAxEe,yBAwED7V,QAxEC,EAwE6B;EAAA,QAA9BA,QAA8B;EAA9BA,MAAAA,QAA8B,GAAnB,KAAKiN,MAAL,CAAY0I,KAAO;EAAA;;EAC1C,QAAM7J,MAAM,GAAG,IAAf;EAD0C,QAElCoC,GAFkC,GAE1BpC,MAF0B,CAElCoC,GAFkC;EAG1CA,IAAAA,GAAG,CACA5H,IADH,CAEI,0IAFJ,EAIGlC,IAJH,CAIQ,UAACm2B,UAAD,EAAgB;EACpB,UAAMC,WAAW,GAAGh9B,CAAC,CAAC+8B,UAAD,CAArB;EACA,UAAIE,gBAAgB,GAClB1qB,QAAQ,CAACyqB,WAAW,CAACh7B,IAAZ,CAAiB,+BAAjB,CAAD,EAAoD,EAApD,CAAR,IAAmEQ,QADrE;EAEA,UAAIA,QAAQ,KAAK,CAAjB,EAAoBy6B,gBAAgB,GAAG,CAAnB;EACpBD,MAAAA,WAAW,CAACz6B,UAAZ,CAAuB06B,gBAAvB;EACD,KAVH;EAWD;EAtFc,CAAjB;AAyFA,mBAAe;EACb5uB,EAAAA,IAAI,EAAE,UADO;EAEboB,EAAAA,MAAM,EAAE;EACNqtB,IAAAA,QAAQ,EAAE;EACRvpB,MAAAA,OAAO,EAAE;EADD;EADJ,GAFK;EAOb5X,EAAAA,MAPa,oBAOJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBwuB,MAAAA,QAAQ,eACHJ,QADG;EADgB,KAAT,CAAjB;EAKD,GAdY;EAebh6B,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EACjB,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAcqtB,QAAd,CAAuBvpB,OAA5B,EAAqC;EACrCjF,MAAAA,MAAM,CAACmB,MAAP,CAAcsI,mBAAd,GAAoC,IAApC;EACAzJ,MAAAA,MAAM,CAAC2b,cAAP,CAAsBlS,mBAAtB,GAA4C,IAA5C;EACD,KALC;EAMFvI,IAAAA,IANE,gBAMGlB,MANH,EAMW;EACX,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAcqtB,QAAd,CAAuBvpB,OAA5B,EAAqC;EACrCjF,MAAAA,MAAM,CAACwuB,QAAP,CAAgBjhB,YAAhB;EACD,KATC;EAUFA,IAAAA,YAVE,wBAUWvN,MAVX,EAUmB;EACnB,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAcqtB,QAAd,CAAuBvpB,OAA5B,EAAqC;EACrCjF,MAAAA,MAAM,CAACwuB,QAAP,CAAgBjhB,YAAhB;EACD,KAbC;EAcFxD,IAAAA,aAdE,yBAcY/J,MAdZ,EAcoB9L,QAdpB,EAc8B;EAC9B,UAAI,CAAC8L,MAAM,CAACmB,MAAP,CAAcqtB,QAAd,CAAuBvpB,OAA5B,EAAqC;EACrCjF,MAAAA,MAAM,CAACwuB,QAAP,CAAgBzkB,aAAhB,CAA8B7V,QAA9B;EACD;EAjBC;EAfS,CAAf;;ECxFA,IAAM06B,IAAI,GAAG;EACX;EACAC,EAAAA,yBAFW,qCAEezgC,CAFf,EAEkB;EAC3B,QAAIA,CAAC,CAACgmB,aAAF,CAAgB5qB,MAAhB,GAAyB,CAA7B,EAAgC,OAAO,CAAP;EAChC,QAAMslC,EAAE,GAAG1gC,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBC,KAA9B;EACA,QAAM0a,EAAE,GAAG3gC,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBG,KAA9B;EACA,QAAMya,EAAE,GAAG5gC,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBC,KAA9B;EACA,QAAM4a,EAAE,GAAG7gC,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBG,KAA9B;EACA,QAAMwD,QAAQ,GAAGlR,IAAI,CAACsP,IAAL,CAAU,SAAC6Y,EAAE,GAAGF,EAAN,EAAa,CAAb,aAAkBG,EAAE,GAAGF,EAAvB,EAA8B,CAA9B,CAAV,CAAjB;EACA,WAAOhX,QAAP;EACD,GAVU;EAWX;EACAmX,EAAAA,cAZW,0BAYI9gC,CAZJ,EAYO;EAChB,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAM/C,OAAO,GAAG+C,MAAM,CAAC/C,OAAvB;EACA,QAAMkE,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcguB,IAA7B;EACA,QAAMA,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EAJgB,QAKRC,OALQ,GAKID,IALJ,CAKRC,OALQ;EAMhBD,IAAAA,IAAI,CAACE,kBAAL,GAA0B,KAA1B;EACAF,IAAAA,IAAI,CAACG,gBAAL,GAAwB,KAAxB;;EACA,QAAI,CAACryB,OAAO,CAACa,QAAb,EAAuB;EACrB,UAAI1P,CAAC,CAACklB,IAAF,KAAW,YAAX,IAA4BllB,CAAC,CAACklB,IAAF,KAAW,YAAX,IAA2BllB,CAAC,CAACgmB,aAAF,CAAgB5qB,MAAhB,GAAyB,CAApF,EAAwF;EACtF;EACD;;EACD2lC,MAAAA,IAAI,CAACE,kBAAL,GAA0B,IAA1B;EACAD,MAAAA,OAAO,CAACG,UAAR,GAAqBX,IAAI,CAACC,yBAAL,CAA+BzgC,CAA/B,CAArB;EACD;;EACD,QAAI,CAACghC,OAAO,CAAC3M,QAAT,IAAqB,CAAC2M,OAAO,CAAC3M,QAAR,CAAiBj5B,MAA3C,EAAmD;EACjD4lC,MAAAA,OAAO,CAAC3M,QAAR,GAAmB/wB,CAAC,CAACtD,CAAC,CAACjF,MAAH,CAAD,CAAYoR,OAAZ,OAAwByF,MAAM,CAACmB,MAAP,CAAciE,UAAtC,CAAnB;EACA,UAAIgqB,OAAO,CAAC3M,QAAR,CAAiBj5B,MAAjB,KAA4B,CAAhC,EAAmC4lC,OAAO,CAAC3M,QAAR,GAAmBziB,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,CAAnB;EACnCmlB,MAAAA,OAAO,CAACI,QAAR,GAAmBJ,OAAO,CAAC3M,QAAR,CAAiBjoB,IAAjB,CAAsB,gDAAtB,CAAnB;EACA40B,MAAAA,OAAO,CAACK,YAAR,GAAuBL,OAAO,CAACI,QAAR,CAAiBp1B,MAAjB,OAA4B+G,MAAM,CAACuuB,cAAnC,CAAvB;EACAN,MAAAA,OAAO,CAACO,QAAR,GAAmBP,OAAO,CAACK,YAAR,CAAqB/7B,IAArB,CAA0B,kBAA1B,KAAiDyN,MAAM,CAACwuB,QAA3E;;EACA,UAAIP,OAAO,CAACK,YAAR,CAAqBjmC,MAArB,KAAgC,CAApC,EAAuC;EACrC4lC,QAAAA,OAAO,CAACI,QAAR,GAAmBjgC,SAAnB;EACA;EACD;EACF;;EACD,QAAI6/B,OAAO,CAACI,QAAZ,EAAsB;EACpBJ,MAAAA,OAAO,CAACI,QAAR,CAAiBv7B,UAAjB,CAA4B,CAA5B;EACD;;EACD+L,IAAAA,MAAM,CAACmvB,IAAP,CAAYS,SAAZ,GAAwB,IAAxB;EACD,GA1CU;EA2CXC,EAAAA,eA3CW,2BA2CKzhC,CA3CL,EA2CQ;EACjB,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAM/C,OAAO,GAAG+C,MAAM,CAAC/C,OAAvB;EACA,QAAMkE,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcguB,IAA7B;EACA,QAAMA,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EACA,QAAMC,OAAO,GAAGD,IAAI,CAACC,OAArB;;EACA,QAAI,CAACnyB,OAAO,CAACa,QAAb,EAAuB;EACrB,UAAI1P,CAAC,CAACklB,IAAF,KAAW,WAAX,IAA2BllB,CAAC,CAACklB,IAAF,KAAW,WAAX,IAA0BllB,CAAC,CAACgmB,aAAF,CAAgB5qB,MAAhB,GAAyB,CAAlF,EAAsF;EACpF;EACD;;EACD2lC,MAAAA,IAAI,CAACG,gBAAL,GAAwB,IAAxB;EACAF,MAAAA,OAAO,CAACU,SAAR,GAAoBlB,IAAI,CAACC,yBAAL,CAA+BzgC,CAA/B,CAApB;EACD;;EAED,QAAI,CAACghC,OAAO,CAACI,QAAT,IAAqBJ,OAAO,CAACI,QAAR,CAAiBhmC,MAAjB,KAA4B,CAArD,EAAwD;EACtD,UAAI4E,CAAC,CAACklB,IAAF,KAAW,eAAf,EAAgC6b,IAAI,CAACD,cAAL,CAAoB9gC,CAApB;EAChC;EACD;;EACD,QAAI6O,OAAO,CAACa,QAAZ,EAAsB;EACpBqxB,MAAAA,IAAI,CAAClE,KAAL,GAAa78B,CAAC,CAAC68B,KAAF,GAAUkE,IAAI,CAACZ,YAA5B;EACD,KAFD,MAEO;EACLY,MAAAA,IAAI,CAAClE,KAAL,GAAcmE,OAAO,CAACU,SAAR,GAAoBV,OAAO,CAACG,UAA7B,GAA2CJ,IAAI,CAACZ,YAA7D;EACD;;EACD,QAAIY,IAAI,CAAClE,KAAL,GAAamE,OAAO,CAACO,QAAzB,EAAmC;EACjCR,MAAAA,IAAI,CAAClE,KAAL,GAAamE,OAAO,CAACO,QAAR,GAAmB,CAAnB,YAAwBR,IAAI,CAAClE,KAAL,GAAamE,OAAO,CAACO,QAArB,GAAgC,CAAxD,EAA8D,GAA9D,CAAb;EACD;;EACD,QAAIR,IAAI,CAAClE,KAAL,GAAa9pB,MAAM,CAACub,QAAxB,EAAkC;EAChCyS,MAAAA,IAAI,CAAClE,KAAL,GAAa9pB,MAAM,CAACub,QAAP,GAAkB,CAAlB,YAAuBvb,MAAM,CAACub,QAAP,GAAkByS,IAAI,CAAClE,KAAvB,GAA+B,CAAtD,EAA4D,GAA5D,CAAb;EACD;;EACDmE,IAAAA,OAAO,CAACI,QAAR,CAAiBx7B,SAAjB,+BAAuDm7B,IAAI,CAAClE,KAA5D;EACD,GAzEU;EA0EX8E,EAAAA,YA1EW,wBA0EE3hC,CA1EF,EA0EK;EACd,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAM/B,MAAM,GAAG+B,MAAM,CAAC/B,MAAtB;EACA,QAAMhB,OAAO,GAAG+C,MAAM,CAAC/C,OAAvB;EACA,QAAMkE,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcguB,IAA7B;EACA,QAAMA,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EALc,QAMNC,OANM,GAMMD,IANN,CAMNC,OANM;;EAOd,QAAI,CAACnyB,OAAO,CAACa,QAAb,EAAuB;EACrB,UAAI,CAACqxB,IAAI,CAACE,kBAAN,IAA4B,CAACF,IAAI,CAACG,gBAAtC,EAAwD;EACtD;EACD;;EACD,UACElhC,CAAC,CAACklB,IAAF,KAAW,UAAX,IACCllB,CAAC,CAACklB,IAAF,KAAW,UAAX,IAAyBllB,CAAC,CAAC0nB,cAAF,CAAiBtsB,MAAjB,GAA0B,CAAnD,IAAwD,CAACyU,MAAM,CAACK,OAFnE,EAGE;EACA;EACD;;EACD6wB,MAAAA,IAAI,CAACE,kBAAL,GAA0B,KAA1B;EACAF,MAAAA,IAAI,CAACG,gBAAL,GAAwB,KAAxB;EACD;;EACD,QAAI,CAACF,OAAO,CAACI,QAAT,IAAqBJ,OAAO,CAACI,QAAR,CAAiBhmC,MAAjB,KAA4B,CAArD,EAAwD;EACxD2lC,IAAAA,IAAI,CAAClE,KAAL,GAAapkB,IAAI,CAACK,GAAL,CAASL,IAAI,CAACiB,GAAL,CAASqnB,IAAI,CAAClE,KAAd,EAAqBmE,OAAO,CAACO,QAA7B,CAAT,EAAiDxuB,MAAM,CAACub,QAAxD,CAAb;EACA0S,IAAAA,OAAO,CAACI,QAAR,CACGv7B,UADH,CACc+L,MAAM,CAACmB,MAAP,CAAc0I,KAD5B,EAEG7V,SAFH,+BAEyCm7B,IAAI,CAAClE,KAF9C;EAGAkE,IAAAA,IAAI,CAACZ,YAAL,GAAoBY,IAAI,CAAClE,KAAzB;EACAkE,IAAAA,IAAI,CAACS,SAAL,GAAiB,KAAjB;EACA,QAAIT,IAAI,CAAClE,KAAL,KAAe,CAAnB,EAAsBmE,OAAO,CAAC3M,QAAR,GAAmBlzB,SAAnB;EACvB,GAtGU;EAuGXwjB,EAAAA,YAvGW,wBAuGE3kB,CAvGF,EAuGK;EACd,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAM/B,MAAM,GAAG+B,MAAM,CAAC/B,MAAtB;EACA,QAAMkxB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EAHc,QAINC,OAJM,GAIaD,IAJb,CAINC,OAJM;EAAA,QAIG1R,KAJH,GAIayR,IAJb,CAIGzR,KAJH;EAKd,QAAI,CAAC0R,OAAO,CAACI,QAAT,IAAqBJ,OAAO,CAACI,QAAR,CAAiBhmC,MAAjB,KAA4B,CAArD,EAAwD;EACxD,QAAIk0B,KAAK,CAACjK,SAAV,EAAqB;EACrB,QAAIxV,MAAM,CAACK,OAAP,IAAkBlQ,CAAC,CAACoI,UAAxB,EAAoCpI,CAAC,CAAC2mB,cAAF;EACpC2I,IAAAA,KAAK,CAACjK,SAAN,GAAkB,IAAlB;EACAiK,IAAAA,KAAK,CAACsS,YAAN,CAAmBtiB,CAAnB,GAAuBtf,CAAC,CAACklB,IAAF,KAAW,YAAX,GAA0BllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBC,KAA7C,GAAqDjmB,CAAC,CAACimB,KAA9E;EACAqJ,IAAAA,KAAK,CAACsS,YAAN,CAAmBriB,CAAnB,GAAuBvf,CAAC,CAACklB,IAAF,KAAW,YAAX,GAA0BllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBG,KAA7C,GAAqDnmB,CAAC,CAACmmB,KAA9E;EACD,GAlHU;EAmHXqB,EAAAA,WAnHW,uBAmHCxnB,CAnHD,EAmHI;EACb,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAMmvB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EAFa,QAGLC,OAHK,GAGwBD,IAHxB,CAGLC,OAHK;EAAA,QAGI1R,KAHJ,GAGwByR,IAHxB,CAGIzR,KAHJ;EAAA,QAGW1F,QAHX,GAGwBmX,IAHxB,CAGWnX,QAHX;EAIb,QAAI,CAACoX,OAAO,CAACI,QAAT,IAAqBJ,OAAO,CAACI,QAAR,CAAiBhmC,MAAjB,KAA4B,CAArD,EAAwD;EACxDwW,IAAAA,MAAM,CAACiU,UAAP,GAAoB,KAApB;EACA,QAAI,CAACyJ,KAAK,CAACjK,SAAP,IAAoB,CAAC2b,OAAO,CAAC3M,QAAjC,EAA2C;;EAE3C,QAAI,CAAC/E,KAAK,CAAChK,OAAX,EAAoB;EAClBgK,MAAAA,KAAK,CAAClf,KAAN,GAAc4wB,OAAO,CAACI,QAAR,CAAiB,CAAjB,EAAoBr4B,WAAlC;EACAumB,MAAAA,KAAK,CAAChf,MAAN,GAAe0wB,OAAO,CAACI,QAAR,CAAiB,CAAjB,EAAoBj4B,YAAnC;EACAmmB,MAAAA,KAAK,CAAClJ,MAAN,GAAepZ,YAAY,CAACg0B,OAAO,CAACK,YAAR,CAAqB,CAArB,CAAD,EAA0B,GAA1B,CAAZ,IAA8C,CAA7D;EACA/R,MAAAA,KAAK,CAACjJ,MAAN,GAAerZ,YAAY,CAACg0B,OAAO,CAACK,YAAR,CAAqB,CAArB,CAAD,EAA0B,GAA1B,CAAZ,IAA8C,CAA7D;EACAL,MAAAA,OAAO,CAACa,UAAR,GAAqBb,OAAO,CAAC3M,QAAR,CAAiB,CAAjB,EAAoBtrB,WAAzC;EACAi4B,MAAAA,OAAO,CAACc,WAAR,GAAsBd,OAAO,CAAC3M,QAAR,CAAiB,CAAjB,EAAoBlrB,YAA1C;EACA63B,MAAAA,OAAO,CAACK,YAAR,CAAqBx7B,UAArB,CAAgC,CAAhC;;EACA,UAAI+L,MAAM,CAAC4E,GAAX,EAAgB;EACd8Y,QAAAA,KAAK,CAAClJ,MAAN,GAAe,CAACkJ,KAAK,CAAClJ,MAAtB;EACAkJ,QAAAA,KAAK,CAACjJ,MAAN,GAAe,CAACiJ,KAAK,CAACjJ,MAAtB;EACD;EACF,KApBY;;;EAsBb,QAAM0b,WAAW,GAAGzS,KAAK,CAAClf,KAAN,GAAc2wB,IAAI,CAAClE,KAAvC;EACA,QAAMmF,YAAY,GAAG1S,KAAK,CAAChf,MAAN,GAAeywB,IAAI,CAAClE,KAAzC;EAEA,QAAIkF,WAAW,GAAGf,OAAO,CAACa,UAAtB,IAAoCG,YAAY,GAAGhB,OAAO,CAACc,WAA/D,EAA4E;EAE5ExS,IAAAA,KAAK,CAAC2S,IAAN,GAAaxpB,IAAI,CAACiB,GAAL,CAASsnB,OAAO,CAACa,UAAR,GAAqB,CAArB,GAAyBE,WAAW,GAAG,CAAhD,EAAmD,CAAnD,CAAb;EACAzS,IAAAA,KAAK,CAAC4S,IAAN,GAAa,CAAC5S,KAAK,CAAC2S,IAApB;EACA3S,IAAAA,KAAK,CAAC6S,IAAN,GAAa1pB,IAAI,CAACiB,GAAL,CAASsnB,OAAO,CAACc,WAAR,GAAsB,CAAtB,GAA0BE,YAAY,GAAG,CAAlD,EAAqD,CAArD,CAAb;EACA1S,IAAAA,KAAK,CAAC8S,IAAN,GAAa,CAAC9S,KAAK,CAAC6S,IAApB;EAEA7S,IAAAA,KAAK,CAAC+S,cAAN,CAAqB/iB,CAArB,GAAyBtf,CAAC,CAACklB,IAAF,KAAW,WAAX,GAAyBllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBC,KAA5C,GAAoDjmB,CAAC,CAACimB,KAA/E;EACAqJ,IAAAA,KAAK,CAAC+S,cAAN,CAAqB9iB,CAArB,GAAyBvf,CAAC,CAACklB,IAAF,KAAW,WAAX,GAAyBllB,CAAC,CAACgmB,aAAF,CAAgB,CAAhB,EAAmBG,KAA5C,GAAoDnmB,CAAC,CAACmmB,KAA/E;;EAEA,QAAI,CAACmJ,KAAK,CAAChK,OAAP,IAAkB,CAACyb,IAAI,CAACS,SAA5B,EAAuC;EACrC,UACE5vB,MAAM,CAAC+D,YAAP,OACE8C,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAAC2S,IAAjB,MAA2BxpB,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAAClJ,MAAjB,CAA3B,IACAkJ,KAAK,CAAC+S,cAAN,CAAqB/iB,CAArB,GAAyBgQ,KAAK,CAACsS,YAAN,CAAmBtiB,CAD7C,IAEE7G,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAAC4S,IAAjB,MAA2BzpB,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAAClJ,MAAjB,CAA3B,IACCkJ,KAAK,CAAC+S,cAAN,CAAqB/iB,CAArB,GAAyBgQ,KAAK,CAACsS,YAAN,CAAmBtiB,CAJhD,CADF,EAME;EACAgQ,QAAAA,KAAK,CAACjK,SAAN,GAAkB,KAAlB;EACA;EACD;;EACD,UACE,CAACzT,MAAM,CAAC+D,YAAP,EAAD,KACE8C,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAAC6S,IAAjB,MAA2B1pB,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAACjJ,MAAjB,CAA3B,IACAiJ,KAAK,CAAC+S,cAAN,CAAqB9iB,CAArB,GAAyB+P,KAAK,CAACsS,YAAN,CAAmBriB,CAD7C,IAEE9G,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAAC8S,IAAjB,MAA2B3pB,IAAI,CAACC,KAAL,CAAW4W,KAAK,CAACjJ,MAAjB,CAA3B,IACCiJ,KAAK,CAAC+S,cAAN,CAAqB9iB,CAArB,GAAyB+P,KAAK,CAACsS,YAAN,CAAmBriB,CAJhD,CADF,EAME;EACA+P,QAAAA,KAAK,CAACjK,SAAN,GAAkB,KAAlB;EACA;EACD;EACF;;EACD,QAAIrlB,CAAC,CAACoI,UAAN,EAAkB;EAChBpI,MAAAA,CAAC,CAAC2mB,cAAF;EACD;;EACD3mB,IAAAA,CAAC,CAACqoB,eAAF;EAEAiH,IAAAA,KAAK,CAAChK,OAAN,GAAgB,IAAhB;EACAgK,IAAAA,KAAK,CAACvJ,QAAN,GAAiBuJ,KAAK,CAAC+S,cAAN,CAAqB/iB,CAArB,GAAyBgQ,KAAK,CAACsS,YAAN,CAAmBtiB,CAA5C,GAAgDgQ,KAAK,CAAClJ,MAAvE;EACAkJ,IAAAA,KAAK,CAACpJ,QAAN,GAAiBoJ,KAAK,CAAC+S,cAAN,CAAqB9iB,CAArB,GAAyB+P,KAAK,CAACsS,YAAN,CAAmBriB,CAA5C,GAAgD+P,KAAK,CAACjJ,MAAvE;;EAEA,QAAIiJ,KAAK,CAACvJ,QAAN,GAAiBuJ,KAAK,CAAC2S,IAA3B,EAAiC;EAC/B3S,MAAAA,KAAK,CAACvJ,QAAN,GAAiBuJ,KAAK,CAAC2S,IAAN,GAAa,CAAb,YAAkB3S,KAAK,CAAC2S,IAAN,GAAa3S,KAAK,CAACvJ,QAAnB,GAA8B,CAAhD,EAAsD,GAAtD,CAAjB;EACD;;EACD,QAAIuJ,KAAK,CAACvJ,QAAN,GAAiBuJ,KAAK,CAAC4S,IAA3B,EAAiC;EAC/B5S,MAAAA,KAAK,CAACvJ,QAAN,GAAiBuJ,KAAK,CAAC4S,IAAN,GAAa,CAAb,YAAkB5S,KAAK,CAACvJ,QAAN,GAAiBuJ,KAAK,CAAC4S,IAAvB,GAA8B,CAAhD,EAAsD,GAAtD,CAAjB;EACD;;EAED,QAAI5S,KAAK,CAACpJ,QAAN,GAAiBoJ,KAAK,CAAC6S,IAA3B,EAAiC;EAC/B7S,MAAAA,KAAK,CAACpJ,QAAN,GAAiBoJ,KAAK,CAAC6S,IAAN,GAAa,CAAb,YAAkB7S,KAAK,CAAC6S,IAAN,GAAa7S,KAAK,CAACpJ,QAAnB,GAA8B,CAAhD,EAAsD,GAAtD,CAAjB;EACD;;EACD,QAAIoJ,KAAK,CAACpJ,QAAN,GAAiBoJ,KAAK,CAAC8S,IAA3B,EAAiC;EAC/B9S,MAAAA,KAAK,CAACpJ,QAAN,GAAiBoJ,KAAK,CAAC8S,IAAN,GAAa,CAAb,YAAkB9S,KAAK,CAACpJ,QAAN,GAAiBoJ,KAAK,CAAC8S,IAAvB,GAA8B,CAAhD,EAAsD,GAAtD,CAAjB;EACD,KA9EY;;;EAiFb,QAAI,CAACxY,QAAQ,CAAC0Y,aAAd,EAA6B1Y,QAAQ,CAAC0Y,aAAT,GAAyBhT,KAAK,CAAC+S,cAAN,CAAqB/iB,CAA9C;EAC7B,QAAI,CAACsK,QAAQ,CAAC2Y,aAAd,EAA6B3Y,QAAQ,CAAC2Y,aAAT,GAAyBjT,KAAK,CAAC+S,cAAN,CAAqB9iB,CAA9C;EAC7B,QAAI,CAACqK,QAAQ,CAAC4Y,QAAd,EAAwB5Y,QAAQ,CAAC4Y,QAAT,GAAoBvkC,IAAI,CAAC6O,GAAL,EAApB;EACxB8c,IAAAA,QAAQ,CAACtK,CAAT,GACE,CAACgQ,KAAK,CAAC+S,cAAN,CAAqB/iB,CAArB,GAAyBsK,QAAQ,CAAC0Y,aAAnC,KAAqDrkC,IAAI,CAAC6O,GAAL,KAAa8c,QAAQ,CAAC4Y,QAA3E,IAAuF,CADzF;EAEA5Y,IAAAA,QAAQ,CAACrK,CAAT,GACE,CAAC+P,KAAK,CAAC+S,cAAN,CAAqB9iB,CAArB,GAAyBqK,QAAQ,CAAC2Y,aAAnC,KAAqDtkC,IAAI,CAAC6O,GAAL,KAAa8c,QAAQ,CAAC4Y,QAA3E,IAAuF,CADzF;EAEA,QAAI/pB,IAAI,CAAC4B,GAAL,CAASiV,KAAK,CAAC+S,cAAN,CAAqB/iB,CAArB,GAAyBsK,QAAQ,CAAC0Y,aAA3C,IAA4D,CAAhE,EAAmE1Y,QAAQ,CAACtK,CAAT,GAAa,CAAb;EACnE,QAAI7G,IAAI,CAAC4B,GAAL,CAASiV,KAAK,CAAC+S,cAAN,CAAqB9iB,CAArB,GAAyBqK,QAAQ,CAAC2Y,aAA3C,IAA4D,CAAhE,EAAmE3Y,QAAQ,CAACrK,CAAT,GAAa,CAAb;EACnEqK,IAAAA,QAAQ,CAAC0Y,aAAT,GAAyBhT,KAAK,CAAC+S,cAAN,CAAqB/iB,CAA9C;EACAsK,IAAAA,QAAQ,CAAC2Y,aAAT,GAAyBjT,KAAK,CAAC+S,cAAN,CAAqB9iB,CAA9C;EACAqK,IAAAA,QAAQ,CAAC4Y,QAAT,GAAoBvkC,IAAI,CAAC6O,GAAL,EAApB;EAEAk0B,IAAAA,OAAO,CAACK,YAAR,CAAqBz7B,SAArB,kBAA8C0pB,KAAK,CAACvJ,QAApD,YAAmEuJ,KAAK,CAACpJ,QAAzE;EACD,GAlNU;EAmNXgD,EAAAA,UAnNW,wBAmNE;EACX,QAAMtX,MAAM,GAAG,IAAf;EACA,QAAMmvB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EAFW,QAGHC,OAHG,GAG0BD,IAH1B,CAGHC,OAHG;EAAA,QAGM1R,KAHN,GAG0ByR,IAH1B,CAGMzR,KAHN;EAAA,QAGa1F,QAHb,GAG0BmX,IAH1B,CAGanX,QAHb;EAIX,QAAI,CAACoX,OAAO,CAACI,QAAT,IAAqBJ,OAAO,CAACI,QAAR,CAAiBhmC,MAAjB,KAA4B,CAArD,EAAwD;;EACxD,QAAI,CAACk0B,KAAK,CAACjK,SAAP,IAAoB,CAACiK,KAAK,CAAChK,OAA/B,EAAwC;EACtCgK,MAAAA,KAAK,CAACjK,SAAN,GAAkB,KAAlB;EACAiK,MAAAA,KAAK,CAAChK,OAAN,GAAgB,KAAhB;EACA;EACD;;EACDgK,IAAAA,KAAK,CAACjK,SAAN,GAAkB,KAAlB;EACAiK,IAAAA,KAAK,CAAChK,OAAN,GAAgB,KAAhB;EACA,QAAImd,iBAAiB,GAAG,GAAxB;EACA,QAAIC,iBAAiB,GAAG,GAAxB;EACA,QAAMC,iBAAiB,GAAG/Y,QAAQ,CAACtK,CAAT,GAAamjB,iBAAvC;EACA,QAAMG,YAAY,GAAGtT,KAAK,CAACvJ,QAAN,GAAiB4c,iBAAtC;EACA,QAAME,iBAAiB,GAAGjZ,QAAQ,CAACrK,CAAT,GAAamjB,iBAAvC;EACA,QAAMI,YAAY,GAAGxT,KAAK,CAACpJ,QAAN,GAAiB2c,iBAAtC,CAjBW;;EAoBX,QAAIjZ,QAAQ,CAACtK,CAAT,KAAe,CAAnB,EACEmjB,iBAAiB,GAAGhqB,IAAI,CAAC4B,GAAL,CAAS,CAACuoB,YAAY,GAAGtT,KAAK,CAACvJ,QAAtB,IAAkC6D,QAAQ,CAACtK,CAApD,CAApB;EACF,QAAIsK,QAAQ,CAACrK,CAAT,KAAe,CAAnB,EACEmjB,iBAAiB,GAAGjqB,IAAI,CAAC4B,GAAL,CAAS,CAACyoB,YAAY,GAAGxT,KAAK,CAACpJ,QAAtB,IAAkC0D,QAAQ,CAACrK,CAApD,CAApB;EACF,QAAMwK,gBAAgB,GAAGtR,IAAI,CAACK,GAAL,CAAS2pB,iBAAT,EAA4BC,iBAA5B,CAAzB;EAEApT,IAAAA,KAAK,CAACvJ,QAAN,GAAiB6c,YAAjB;EACAtT,IAAAA,KAAK,CAACpJ,QAAN,GAAiB4c,YAAjB,CA3BW;;EA8BX,QAAMf,WAAW,GAAGzS,KAAK,CAAClf,KAAN,GAAc2wB,IAAI,CAAClE,KAAvC;EACA,QAAMmF,YAAY,GAAG1S,KAAK,CAAChf,MAAN,GAAeywB,IAAI,CAAClE,KAAzC;EACAvN,IAAAA,KAAK,CAAC2S,IAAN,GAAaxpB,IAAI,CAACiB,GAAL,CAASsnB,OAAO,CAACa,UAAR,GAAqB,CAArB,GAAyBE,WAAW,GAAG,CAAhD,EAAmD,CAAnD,CAAb;EACAzS,IAAAA,KAAK,CAAC4S,IAAN,GAAa,CAAC5S,KAAK,CAAC2S,IAApB;EACA3S,IAAAA,KAAK,CAAC6S,IAAN,GAAa1pB,IAAI,CAACiB,GAAL,CAASsnB,OAAO,CAACc,WAAR,GAAsB,CAAtB,GAA0BE,YAAY,GAAG,CAAlD,EAAqD,CAArD,CAAb;EACA1S,IAAAA,KAAK,CAAC8S,IAAN,GAAa,CAAC9S,KAAK,CAAC6S,IAApB;EACA7S,IAAAA,KAAK,CAACvJ,QAAN,GAAiBtN,IAAI,CAACK,GAAL,CAASL,IAAI,CAACiB,GAAL,CAAS4V,KAAK,CAACvJ,QAAf,EAAyBuJ,KAAK,CAAC4S,IAA/B,CAAT,EAA+C5S,KAAK,CAAC2S,IAArD,CAAjB;EACA3S,IAAAA,KAAK,CAACpJ,QAAN,GAAiBzN,IAAI,CAACK,GAAL,CAASL,IAAI,CAACiB,GAAL,CAAS4V,KAAK,CAACpJ,QAAf,EAAyBoJ,KAAK,CAAC8S,IAA/B,CAAT,EAA+C9S,KAAK,CAAC6S,IAArD,CAAjB;EAEAnB,IAAAA,OAAO,CAACK,YAAR,CACGx7B,UADH,CACckkB,gBADd,EAEGnkB,SAFH,kBAE4B0pB,KAAK,CAACvJ,QAFlC,YAEiDuJ,KAAK,CAACpJ,QAFvD;EAGD,GA7PU;EA8PX6c,EAAAA,eA9PW,6BA8PO;EAChB,QAAMnxB,MAAM,GAAG,IAAf;EACA,QAAMmvB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EAFgB,QAGRC,OAHQ,GAGID,IAHJ,CAGRC,OAHQ;;EAIhB,QAAIA,OAAO,CAAC3M,QAAR,IAAoBziB,MAAM,CAACyM,aAAP,KAAyBzM,MAAM,CAACiK,WAAxD,EAAqE;EACnE,UAAImlB,OAAO,CAACI,QAAZ,EAAsB;EACpBJ,QAAAA,OAAO,CAACI,QAAR,CAAiBx7B,SAAjB,CAA2B,6BAA3B;EACD;;EACD,UAAIo7B,OAAO,CAACK,YAAZ,EAA0B;EACxBL,QAAAA,OAAO,CAACK,YAAR,CAAqBz7B,SAArB,CAA+B,oBAA/B;EACD;;EAEDm7B,MAAAA,IAAI,CAAClE,KAAL,GAAa,CAAb;EACAkE,MAAAA,IAAI,CAACZ,YAAL,GAAoB,CAApB;EAEAa,MAAAA,OAAO,CAAC3M,QAAR,GAAmBlzB,SAAnB;EACA6/B,MAAAA,OAAO,CAACI,QAAR,GAAmBjgC,SAAnB;EACA6/B,MAAAA,OAAO,CAACK,YAAR,GAAuBlgC,SAAvB;EACD;EACF,GAjRU;EAkRX;EACA8D,EAAAA,MAnRW,kBAmRJjF,CAnRI,EAmRD;EACR,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAMmvB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;;EAEA,QAAIA,IAAI,CAAClE,KAAL,IAAckE,IAAI,CAAClE,KAAL,KAAe,CAAjC,EAAoC;EAClC;EACAkE,MAAAA,IAAI,CAACiC,GAAL;EACD,KAHD,MAGO;EACL;EACAjC,MAAAA,IAAI,CAACkC,EAAL,CAAQjjC,CAAR;EACD;EACF,GA9RU;EA+RXijC,EAAAA,EA/RW,eA+RRjjC,CA/RQ,EA+RL;EACJ,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;EAEA,QAAMqiC,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EACA,QAAMhuB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcguB,IAA7B;EALI,QAMIC,OANJ,GAMuBD,IANvB,CAMIC,OANJ;EAAA,QAMa1R,KANb,GAMuByR,IANvB,CAMazR,KANb;;EAQJ,QAAI,CAAC0R,OAAO,CAAC3M,QAAb,EAAuB;EACrB,UAAIziB,MAAM,CAACmB,MAAP,CAAc6D,OAAd,IAAyBhF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAA/C,IAA0DjF,MAAM,CAACgF,OAArE,EAA8E;EAC5EoqB,QAAAA,OAAO,CAAC3M,QAAR,GAAmBziB,MAAM,CAACsC,UAAP,CAAkBhY,QAAlB,OAA+B0V,MAAM,CAACmB,MAAP,CAAcwK,gBAA7C,CAAnB;EACD,OAFD,MAEO;EACLyjB,QAAAA,OAAO,CAAC3M,QAAR,GAAmBziB,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,CAAnB;EACD;;EACDmlB,MAAAA,OAAO,CAACI,QAAR,GAAmBJ,OAAO,CAAC3M,QAAR,CAAiBjoB,IAAjB,CAAsB,gDAAtB,CAAnB;EACA40B,MAAAA,OAAO,CAACK,YAAR,GAAuBL,OAAO,CAACI,QAAR,CAAiBp1B,MAAjB,OAA4B+G,MAAM,CAACuuB,cAAnC,CAAvB;EACD;;EACD,QAAI,CAACN,OAAO,CAACI,QAAT,IAAqBJ,OAAO,CAACI,QAAR,CAAiBhmC,MAAjB,KAA4B,CAArD,EAAwD;EAExD4lC,IAAAA,OAAO,CAAC3M,QAAR,CAAiBxwB,QAAjB,MAA6BkP,MAAM,CAACmwB,gBAApC;EAEA,QAAIC,MAAJ;EACA,QAAIC,MAAJ;EACA,QAAIC,OAAJ;EACA,QAAIC,OAAJ;EACA,QAAIzb,KAAJ;EACA,QAAIC,KAAJ;EACA,QAAIyb,UAAJ;EACA,QAAIC,UAAJ;EACA,QAAIC,UAAJ;EACA,QAAIC,WAAJ;EACA,QAAI3B,WAAJ;EACA,QAAIC,YAAJ;EACA,QAAI2B,aAAJ;EACA,QAAIC,aAAJ;EACA,QAAIC,aAAJ;EACA,QAAIC,aAAJ;EACA,QAAIjC,UAAJ;EACA,QAAIC,WAAJ;;EAEA,QAAI,OAAOxS,KAAK,CAACsS,YAAN,CAAmBtiB,CAA1B,KAAgC,WAAhC,IAA+Ctf,CAAnD,EAAsD;EACpDmjC,MAAAA,MAAM,GAAGnjC,CAAC,CAACklB,IAAF,KAAW,UAAX,GAAwBllB,CAAC,CAAC0nB,cAAF,CAAiB,CAAjB,EAAoBzB,KAA5C,GAAoDjmB,CAAC,CAACimB,KAA/D;EACAmd,MAAAA,MAAM,GAAGpjC,CAAC,CAACklB,IAAF,KAAW,UAAX,GAAwBllB,CAAC,CAAC0nB,cAAF,CAAiB,CAAjB,EAAoBvB,KAA5C,GAAoDnmB,CAAC,CAACmmB,KAA/D;EACD,KAHD,MAGO;EACLgd,MAAAA,MAAM,GAAG7T,KAAK,CAACsS,YAAN,CAAmBtiB,CAA5B;EACA8jB,MAAAA,MAAM,GAAG9T,KAAK,CAACsS,YAAN,CAAmBriB,CAA5B;EACD;;EAEDwhB,IAAAA,IAAI,CAAClE,KAAL,GAAamE,OAAO,CAACK,YAAR,CAAqB/7B,IAArB,CAA0B,kBAA1B,KAAiDyN,MAAM,CAACwuB,QAArE;EACAR,IAAAA,IAAI,CAACZ,YAAL,GAAoBa,OAAO,CAACK,YAAR,CAAqB/7B,IAArB,CAA0B,kBAA1B,KAAiDyN,MAAM,CAACwuB,QAA5E;;EACA,QAAIvhC,CAAJ,EAAO;EACL6hC,MAAAA,UAAU,GAAGb,OAAO,CAAC3M,QAAR,CAAiB,CAAjB,EAAoBtrB,WAAjC;EACA+4B,MAAAA,WAAW,GAAGd,OAAO,CAAC3M,QAAR,CAAiB,CAAjB,EAAoBlrB,YAAlC;EACAk6B,MAAAA,OAAO,GAAGrC,OAAO,CAAC3M,QAAR,CAAiBjrB,MAAjB,GAA0BU,IAA1B,GAAiClL,MAAM,CAACgL,OAAlD;EACA05B,MAAAA,OAAO,GAAGtC,OAAO,CAAC3M,QAAR,CAAiBjrB,MAAjB,GAA0BS,GAA1B,GAAgCjL,MAAM,CAAC8K,OAAjD;EACAme,MAAAA,KAAK,GAAGwb,OAAO,GAAGxB,UAAU,GAAG,CAAvB,GAA2BsB,MAAnC;EACArb,MAAAA,KAAK,GAAGwb,OAAO,GAAGxB,WAAW,GAAG,CAAxB,GAA4BsB,MAApC;EAEAK,MAAAA,UAAU,GAAGzC,OAAO,CAACI,QAAR,CAAiB,CAAjB,EAAoBr4B,WAAjC;EACA26B,MAAAA,WAAW,GAAG1C,OAAO,CAACI,QAAR,CAAiB,CAAjB,EAAoBj4B,YAAlC;EACA44B,MAAAA,WAAW,GAAG0B,UAAU,GAAG1C,IAAI,CAAClE,KAAhC;EACAmF,MAAAA,YAAY,GAAG0B,WAAW,GAAG3C,IAAI,CAAClE,KAAlC;EAEA8G,MAAAA,aAAa,GAAGlrB,IAAI,CAACiB,GAAL,CAASmoB,UAAU,GAAG,CAAb,GAAiBE,WAAW,GAAG,CAAxC,EAA2C,CAA3C,CAAhB;EACA6B,MAAAA,aAAa,GAAGnrB,IAAI,CAACiB,GAAL,CAASooB,WAAW,GAAG,CAAd,GAAkBE,YAAY,GAAG,CAA1C,EAA6C,CAA7C,CAAhB;EACA6B,MAAAA,aAAa,GAAG,CAACF,aAAjB;EACAG,MAAAA,aAAa,GAAG,CAACF,aAAjB;EAEAL,MAAAA,UAAU,GAAG1b,KAAK,GAAGkZ,IAAI,CAAClE,KAA1B;EACA2G,MAAAA,UAAU,GAAG1b,KAAK,GAAGiZ,IAAI,CAAClE,KAA1B;;EAEA,UAAI0G,UAAU,GAAGI,aAAjB,EAAgC;EAC9BJ,QAAAA,UAAU,GAAGI,aAAb;EACD;;EACD,UAAIJ,UAAU,GAAGM,aAAjB,EAAgC;EAC9BN,QAAAA,UAAU,GAAGM,aAAb;EACD;;EAED,UAAIL,UAAU,GAAGI,aAAjB,EAAgC;EAC9BJ,QAAAA,UAAU,GAAGI,aAAb;EACD;;EACD,UAAIJ,UAAU,GAAGM,aAAjB,EAAgC;EAC9BN,QAAAA,UAAU,GAAGM,aAAb;EACD;EACF,KAlCD,MAkCO;EACLP,MAAAA,UAAU,GAAG,CAAb;EACAC,MAAAA,UAAU,GAAG,CAAb;EACD;;EACDxC,IAAAA,OAAO,CAACK,YAAR,CACGx7B,UADH,CACc,GADd,EAEGD,SAFH,kBAE4B29B,UAF5B,YAE6CC,UAF7C;EAGAxC,IAAAA,OAAO,CAACI,QAAR,CAAiBv7B,UAAjB,CAA4B,GAA5B,EAAiCD,SAAjC,+BAAuEm7B,IAAI,CAAClE,KAA5E;EACD,GA3XU;EA4XXmG,EAAAA,GA5XW,iBA4XL;EACJ,QAAMpxB,MAAM,GAAG,IAAf;EAEA,QAAMmvB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EACA,QAAMhuB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcguB,IAA7B;EAJI,QAKIC,OALJ,GAKgBD,IALhB,CAKIC,OALJ;;EAOJ,QAAI,CAACA,OAAO,CAAC3M,QAAb,EAAuB;EACrB,UAAIziB,MAAM,CAACmB,MAAP,CAAc6D,OAAd,IAAyBhF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAA/C,IAA0DjF,MAAM,CAACgF,OAArE,EAA8E;EAC5EoqB,QAAAA,OAAO,CAAC3M,QAAR,GAAmBziB,MAAM,CAACsC,UAAP,CAAkBhY,QAAlB,OAA+B0V,MAAM,CAACmB,MAAP,CAAcwK,gBAA7C,CAAnB;EACD,OAFD,MAEO;EACLyjB,QAAAA,OAAO,CAAC3M,QAAR,GAAmBziB,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,CAAnB;EACD;;EACDmlB,MAAAA,OAAO,CAACI,QAAR,GAAmBJ,OAAO,CAAC3M,QAAR,CAAiBjoB,IAAjB,CAAsB,gDAAtB,CAAnB;EACA40B,MAAAA,OAAO,CAACK,YAAR,GAAuBL,OAAO,CAACI,QAAR,CAAiBp1B,MAAjB,OAA4B+G,MAAM,CAACuuB,cAAnC,CAAvB;EACD;;EACD,QAAI,CAACN,OAAO,CAACI,QAAT,IAAqBJ,OAAO,CAACI,QAAR,CAAiBhmC,MAAjB,KAA4B,CAArD,EAAwD;EAExD2lC,IAAAA,IAAI,CAAClE,KAAL,GAAa,CAAb;EACAkE,IAAAA,IAAI,CAACZ,YAAL,GAAoB,CAApB;EACAa,IAAAA,OAAO,CAACK,YAAR,CAAqBx7B,UAArB,CAAgC,GAAhC,EAAqCD,SAArC,CAA+C,oBAA/C;EACAo7B,IAAAA,OAAO,CAACI,QAAR,CAAiBv7B,UAAjB,CAA4B,GAA5B,EAAiCD,SAAjC,CAA2C,6BAA3C;EACAo7B,IAAAA,OAAO,CAAC3M,QAAR,CAAiB7vB,WAAjB,MAAgCuO,MAAM,CAACmwB,gBAAvC;EACAlC,IAAAA,OAAO,CAAC3M,QAAR,GAAmBlzB,SAAnB;EACD,GApZU;EAsZX4iC,EAAAA,cAtZW,0BAsZIjvB,MAtZJ,EAsZY;EACrB,QAAMlD,MAAM,GAAG,IAAf;EACA,QAAMmvB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EAFqB,QAGE39B,QAHF,GAGyC29B,IAHzC,CAGbiD,aAHa;EAAA,QAG6BrX,OAH7B,GAGyCoU,IAHzC,CAGYzxB,eAHZ;EAIrBsC,IAAAA,MAAM,CAACsC,UAAP,CAAkBY,MAAlB,EAA0B,cAA1B,EAA0C1R,QAA1C,EAAoD29B,IAAI,CAACD,cAAzD,EAAyEnU,OAAzE;EACA/a,IAAAA,MAAM,CAACsC,UAAP,CAAkBY,MAAlB,EAA0B,eAA1B,EAA2C1R,QAA3C,EAAqD29B,IAAI,CAACU,eAA1D,EAA2E9U,OAA3E;EACA/a,IAAAA,MAAM,CAACsC,UAAP,CAAkBY,MAAlB,EAA0B,YAA1B,EAAwC1R,QAAxC,EAAkD29B,IAAI,CAACY,YAAvD,EAAqEhV,OAArE;EACD,GA7ZU;EA8ZXsX,EAAAA,cA9ZW,4BA8ZM;EACf,QAAI,KAAKlD,IAAL,CAAUmD,eAAd,EAA+B;EAC/B,SAAKnD,IAAL,CAAUmD,eAAV,GAA4B,IAA5B;EACA,SAAKnD,IAAL,CAAUgD,cAAV,CAAyB,IAAzB;EACD,GAlaU;EAmaXI,EAAAA,eAnaW,6BAmaO;EAChB,QAAI,CAAC,KAAKpD,IAAL,CAAUmD,eAAf,EAAgC;EAChC,SAAKnD,IAAL,CAAUmD,eAAV,GAA4B,KAA5B;EACA,SAAKnD,IAAL,CAAUgD,cAAV,CAAyB,KAAzB;EACD,GAvaU;EAwaX;EACAxN,EAAAA,MAzaW,oBAyaF;EACP,QAAM3kB,MAAM,GAAG,IAAf;EACA,QAAM/C,OAAO,GAAG+C,MAAM,CAAC/C,OAAvB;EACA,QAAMkyB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EACA,QAAIA,IAAI,CAAClqB,OAAT,EAAkB;EAClBkqB,IAAAA,IAAI,CAAClqB,OAAL,GAAe,IAAf;EAEA,QAAMvH,eAAe,GACnBsC,MAAM,CAAC0a,WAAP,CAAmBC,KAAnB,KAA6B,YAA7B,IACA1d,OAAO,CAACS,eADR,IAEAsC,MAAM,CAACmB,MAAP,CAAc2Z,gBAFd,GAGI;EAAEC,MAAAA,OAAO,EAAE,IAAX;EAAiBrmB,MAAAA,OAAO,EAAE;EAA1B,KAHJ,GAII,KALN;EAMA,QAAM89B,yBAAyB,GAAGv1B,OAAO,CAACS,eAAR,GAC9B;EAAEqd,MAAAA,OAAO,EAAE,KAAX;EAAkBrmB,MAAAA,OAAO,EAAE;EAA3B,KAD8B,GAE9B,IAFJ;EAIA,QAAM09B,aAAa,SAAOpyB,MAAM,CAACmB,MAAP,CAAciE,UAAxC;EAEApF,IAAAA,MAAM,CAACmvB,IAAP,CAAYzxB,eAAZ,GAA8BA,eAA9B;EACAsC,IAAAA,MAAM,CAACmvB,IAAP,CAAYiD,aAAZ,GAA4BA,aAA5B,CApBO;;EAuBP,QAAIn1B,OAAO,CAACa,QAAZ,EAAsB;EACpBkC,MAAAA,MAAM,CAACsC,UAAP,CAAkBlO,EAAlB,CAAqB4L,MAAM,CAAC0a,WAAP,CAAmBC,KAAxC,EAA+C3a,MAAM,CAACmvB,IAAP,CAAYkD,cAA3D,EAA2E30B,eAA3E;EACAsC,MAAAA,MAAM,CAACsC,UAAP,CAAkBlO,EAAlB,CAAqB4L,MAAM,CAAC0a,WAAP,CAAmBG,GAAxC,EAA6C7a,MAAM,CAACmvB,IAAP,CAAYoD,eAAzD,EAA0E70B,eAA1E;EACD,KAHD,MAGO,IAAIsC,MAAM,CAAC0a,WAAP,CAAmBC,KAAnB,KAA6B,YAAjC,EAA+C;EACpD3a,MAAAA,MAAM,CAACsC,UAAP,CAAkBlO,EAAlB,CACE4L,MAAM,CAAC0a,WAAP,CAAmBC,KADrB,EAEEyX,aAFF,EAGEjD,IAAI,CAACD,cAHP,EAIExxB,eAJF;EAMAsC,MAAAA,MAAM,CAACsC,UAAP,CAAkBlO,EAAlB,CACE4L,MAAM,CAAC0a,WAAP,CAAmBE,IADrB,EAEEwX,aAFF,EAGEjD,IAAI,CAACU,eAHP,EAIE2C,yBAJF;EAMAxyB,MAAAA,MAAM,CAACsC,UAAP,CAAkBlO,EAAlB,CACE4L,MAAM,CAAC0a,WAAP,CAAmBG,GADrB,EAEEuX,aAFF,EAGEjD,IAAI,CAACY,YAHP,EAIEryB,eAJF;;EAMA,UAAIsC,MAAM,CAAC0a,WAAP,CAAmBM,MAAvB,EAA+B;EAC7Bhb,QAAAA,MAAM,CAACsC,UAAP,CAAkBlO,EAAlB,CACE4L,MAAM,CAAC0a,WAAP,CAAmBM,MADrB,EAEEoX,aAFF,EAGEjD,IAAI,CAACY,YAHP,EAIEryB,eAJF;EAMD;EACF,KArDM;;;EAwDPsC,IAAAA,MAAM,CAACsC,UAAP,CAAkBlO,EAAlB,CACE4L,MAAM,CAAC0a,WAAP,CAAmBE,IADrB,QAEM5a,MAAM,CAACmB,MAAP,CAAcguB,IAAd,CAAmBO,cAFzB,EAGEP,IAAI,CAACvZ,WAHP,EAIE4c,yBAJF;EAMD,GAveU;EAweX5N,EAAAA,OAxeW,qBAweD;EACR,QAAM5kB,MAAM,GAAG,IAAf;EACA,QAAMmvB,IAAI,GAAGnvB,MAAM,CAACmvB,IAApB;EACA,QAAI,CAACA,IAAI,CAAClqB,OAAV,EAAmB;EACnB,QAAMhI,OAAO,GAAG+C,MAAM,CAAC/C,OAAvB;EAEA+C,IAAAA,MAAM,CAACmvB,IAAP,CAAYlqB,OAAZ,GAAsB,KAAtB;EAEA,QAAMvH,eAAe,GACnBsC,MAAM,CAAC0a,WAAP,CAAmBC,KAAnB,KAA6B,YAA7B,IACA1d,OAAO,CAACS,eADR,IAEAsC,MAAM,CAACmB,MAAP,CAAc2Z,gBAFd,GAGI;EAAEC,MAAAA,OAAO,EAAE,IAAX;EAAiBrmB,MAAAA,OAAO,EAAE;EAA1B,KAHJ,GAII,KALN;EAMA,QAAM89B,yBAAyB,GAAGv1B,OAAO,CAACS,eAAR,GAC9B;EAAEqd,MAAAA,OAAO,EAAE,KAAX;EAAkBrmB,MAAAA,OAAO,EAAE;EAA3B,KAD8B,GAE9B,IAFJ;EAIA,QAAM09B,aAAa,SAAOpyB,MAAM,CAACmB,MAAP,CAAciE,UAAxC,CAlBQ;;EAqBR,QAAInI,OAAO,CAACa,QAAZ,EAAsB;EACpBkC,MAAAA,MAAM,CAACsC,UAAP,CAAkB3M,GAAlB,CAAsBqK,MAAM,CAAC0a,WAAP,CAAmBC,KAAzC,EAAgD3a,MAAM,CAACmvB,IAAP,CAAYkD,cAA5D,EAA4E30B,eAA5E;EACAsC,MAAAA,MAAM,CAACsC,UAAP,CAAkB3M,GAAlB,CAAsBqK,MAAM,CAAC0a,WAAP,CAAmBG,GAAzC,EAA8C7a,MAAM,CAACmvB,IAAP,CAAYoD,eAA1D,EAA2E70B,eAA3E;EACD,KAHD,MAGO,IAAIsC,MAAM,CAAC0a,WAAP,CAAmBC,KAAnB,KAA6B,YAAjC,EAA+C;EACpD3a,MAAAA,MAAM,CAACsC,UAAP,CAAkB3M,GAAlB,CACEqK,MAAM,CAAC0a,WAAP,CAAmBC,KADrB,EAEEyX,aAFF,EAGEjD,IAAI,CAACD,cAHP,EAIExxB,eAJF;EAMAsC,MAAAA,MAAM,CAACsC,UAAP,CAAkB3M,GAAlB,CACEqK,MAAM,CAAC0a,WAAP,CAAmBE,IADrB,EAEEwX,aAFF,EAGEjD,IAAI,CAACU,eAHP,EAIE2C,yBAJF;EAMAxyB,MAAAA,MAAM,CAACsC,UAAP,CAAkB3M,GAAlB,CACEqK,MAAM,CAAC0a,WAAP,CAAmBG,GADrB,EAEEuX,aAFF,EAGEjD,IAAI,CAACY,YAHP,EAIEryB,eAJF;;EAMA,UAAIsC,MAAM,CAAC0a,WAAP,CAAmBM,MAAvB,EAA+B;EAC7Bhb,QAAAA,MAAM,CAACsC,UAAP,CAAkB3M,GAAlB,CACEqK,MAAM,CAAC0a,WAAP,CAAmBM,MADrB,EAEEoX,aAFF,EAGEjD,IAAI,CAACY,YAHP,EAIEryB,eAJF;EAMD;EACF,KAnDO;;;EAsDRsC,IAAAA,MAAM,CAACsC,UAAP,CAAkB3M,GAAlB,CACEqK,MAAM,CAAC0a,WAAP,CAAmBE,IADrB,QAEM5a,MAAM,CAACmB,MAAP,CAAcguB,IAAd,CAAmBO,cAFzB,EAGEP,IAAI,CAACvZ,WAHP,EAIE4c,yBAJF;EAMD;EApiBU,CAAb;AAuiBA,eAAe;EACbzyB,EAAAA,IAAI,EAAE,MADO;EAEboB,EAAAA,MAAM,EAAE;EACNguB,IAAAA,IAAI,EAAE;EACJlqB,MAAAA,OAAO,EAAE,KADL;EAEJ0qB,MAAAA,QAAQ,EAAE,CAFN;EAGJjT,MAAAA,QAAQ,EAAE,CAHN;EAIJrpB,MAAAA,MAAM,EAAE,IAJJ;EAKJq8B,MAAAA,cAAc,EAAE,uBALZ;EAMJ4B,MAAAA,gBAAgB,EAAE;EANd;EADA,GAFK;EAYbjkC,EAAAA,MAZa,oBAYJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EAEAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBmvB,MAAAA,IAAI;EACFlqB,QAAAA,OAAO,EAAE,KADP;EAEFgmB,QAAAA,KAAK,EAAE,CAFL;EAGFsD,QAAAA,YAAY,EAAE,CAHZ;EAIFqB,QAAAA,SAAS,EAAE,KAJT;EAKFR,QAAAA,OAAO,EAAE;EACP3M,UAAAA,QAAQ,EAAElzB,SADH;EAEP0gC,UAAAA,UAAU,EAAE1gC,SAFL;EAGP2gC,UAAAA,WAAW,EAAE3gC,SAHN;EAIPigC,UAAAA,QAAQ,EAAEjgC,SAJH;EAKPkgC,UAAAA,YAAY,EAAElgC,SALP;EAMPogC,UAAAA,QAAQ,EAAE;EANH,SALP;EAaFjS,QAAAA,KAAK,EAAE;EACLjK,UAAAA,SAAS,EAAElkB,SADN;EAELmkB,UAAAA,OAAO,EAAEnkB,SAFJ;EAGL4kB,UAAAA,QAAQ,EAAE5kB,SAHL;EAIL+kB,UAAAA,QAAQ,EAAE/kB,SAJL;EAKL8gC,UAAAA,IAAI,EAAE9gC,SALD;EAMLghC,UAAAA,IAAI,EAAEhhC,SAND;EAOL+gC,UAAAA,IAAI,EAAE/gC,SAPD;EAQLihC,UAAAA,IAAI,EAAEjhC,SARD;EASLiP,UAAAA,KAAK,EAAEjP,SATF;EAULmP,UAAAA,MAAM,EAAEnP,SAVH;EAWLilB,UAAAA,MAAM,EAAEjlB,SAXH;EAYLklB,UAAAA,MAAM,EAAEllB,SAZH;EAaLygC,UAAAA,YAAY,EAAE,EAbT;EAcLS,UAAAA,cAAc,EAAE;EAdX,SAbL;EA6BFzY,QAAAA,QAAQ,EAAE;EACRtK,UAAAA,CAAC,EAAEne,SADK;EAERoe,UAAAA,CAAC,EAAEpe,SAFK;EAGRmhC,UAAAA,aAAa,EAAEnhC,SAHP;EAIRohC,UAAAA,aAAa,EAAEphC,SAJP;EAKRqhC,UAAAA,QAAQ,EAAErhC;EALF;EA7BR,SAoCCq/B,IApCD;EADoB,KAAT,CAAjB;EAyCA,QAAI3D,KAAK,GAAG,CAAZ;EACAhiC,IAAAA,MAAM,CAACqH,cAAP,CAAsB0P,MAAM,CAACmvB,IAA7B,EAAmC,OAAnC,EAA4C;EAC1Cz/B,MAAAA,GAD0C,iBACpC;EACJ,eAAOu7B,KAAP;EACD,OAHyC;EAI1Ct7B,MAAAA,GAJ0C,eAItCE,KAJsC,EAI/B;EACT,YAAIo7B,KAAK,KAAKp7B,KAAd,EAAqB;EACnB,cAAMytB,OAAO,GAAGtd,MAAM,CAACmvB,IAAP,CAAYC,OAAZ,CAAoBI,QAApB,GACZxvB,MAAM,CAACmvB,IAAP,CAAYC,OAAZ,CAAoBI,QAApB,CAA6B,CAA7B,CADY,GAEZjgC,SAFJ;EAGA,cAAMmW,OAAO,GAAG1F,MAAM,CAACmvB,IAAP,CAAYC,OAAZ,CAAoB3M,QAApB,GACZziB,MAAM,CAACmvB,IAAP,CAAYC,OAAZ,CAAoB3M,QAApB,CAA6B,CAA7B,CADY,GAEZlzB,SAFJ;EAGAyQ,UAAAA,MAAM,CAACgB,IAAP,CAAY,YAAZ,EAA0BnR,KAA1B,EAAiCytB,OAAjC,EAA0C5X,OAA1C;EACD;;EACDulB,QAAAA,KAAK,GAAGp7B,KAAR;EACD;EAfyC,KAA5C;EAiBD,GA1EY;EA2EbuE,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACX,UAAIA,MAAM,CAACmB,MAAP,CAAcguB,IAAd,CAAmBlqB,OAAvB,EAAgC;EAC9BjF,QAAAA,MAAM,CAACmvB,IAAP,CAAYxK,MAAZ;EACD;EACF,KALC;EAMFtjB,IAAAA,OANE,mBAMMrB,MANN,EAMc;EACdA,MAAAA,MAAM,CAACmvB,IAAP,CAAYvK,OAAZ;EACD,KARC;EASF6N,IAAAA,UATE,sBASSzyB,MATT,EASiB5R,CATjB,EASoB;EACpB,UAAI,CAAC4R,MAAM,CAACmvB,IAAP,CAAYlqB,OAAjB,EAA0B;EAC1BjF,MAAAA,MAAM,CAACmvB,IAAP,CAAYpc,YAAZ,CAAyB3kB,CAAzB;EACD,KAZC;EAaFskC,IAAAA,QAbE,oBAaO1yB,MAbP,EAae5R,CAbf,EAakB;EAClB,UAAI,CAAC4R,MAAM,CAACmvB,IAAP,CAAYlqB,OAAjB,EAA0B;EAC1BjF,MAAAA,MAAM,CAACmvB,IAAP,CAAY7X,UAAZ,CAAuBlpB,CAAvB;EACD,KAhBC;EAiBFukC,IAAAA,SAjBE,qBAiBQ3yB,MAjBR,EAiBgB5R,CAjBhB,EAiBmB;EACnB,UACE,CAAC4R,MAAM,CAACmO,SAAR,IACAnO,MAAM,CAACmB,MAAP,CAAcguB,IAAd,CAAmBlqB,OADnB,IAEAjF,MAAM,CAACmvB,IAAP,CAAYlqB,OAFZ,IAGAjF,MAAM,CAACmB,MAAP,CAAcguB,IAAd,CAAmB97B,MAJrB,EAKE;EACA2M,QAAAA,MAAM,CAACmvB,IAAP,CAAY97B,MAAZ,CAAmBjF,CAAnB;EACD;EACF,KA1BC;EA2BFwI,IAAAA,aA3BE,yBA2BYoJ,MA3BZ,EA2BoB;EACpB,UAAIA,MAAM,CAACmvB,IAAP,CAAYlqB,OAAZ,IAAuBjF,MAAM,CAACmB,MAAP,CAAcguB,IAAd,CAAmBlqB,OAA9C,EAAuD;EACrDjF,QAAAA,MAAM,CAACmvB,IAAP,CAAYgC,eAAZ;EACD;EACF,KA/BC;EAgCFyB,IAAAA,WAhCE,uBAgCU5yB,MAhCV,EAgCkB;EAClB,UAAIA,MAAM,CAACmvB,IAAP,CAAYlqB,OAAZ,IAAuBjF,MAAM,CAACmB,MAAP,CAAcguB,IAAd,CAAmBlqB,OAA1C,IAAqDjF,MAAM,CAACmB,MAAP,CAAcyE,OAAvE,EAAgF;EAC9E5F,QAAAA,MAAM,CAACmvB,IAAP,CAAYgC,eAAZ;EACD;EACF;EApCC;EA3ES,CAAf;;ECviBA,IAAM0B,IAAI,GAAG;EACXC,EAAAA,WADW,uBACCv6B,KADD,EACQw6B,eADR,EACgC;EAAA,QAAxBA,eAAwB;EAAxBA,MAAAA,eAAwB,GAAN,IAAM;EAAA;;EACzC,QAAM/yB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAc6gB,IAA7B;EACA,QAAI,OAAOzpB,KAAP,KAAiB,WAArB,EAAkC;EAClC,QAAIyH,MAAM,CAACmF,MAAP,CAAc3b,MAAd,KAAyB,CAA7B,EAAgC;EAChC,QAAMub,SAAS,GAAG/E,MAAM,CAACgF,OAAP,IAAkBhF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAA1D;EAEA,QAAMwd,QAAQ,GAAG1d,SAAS,GACtB/E,MAAM,CAACsC,UAAP,CAAkBhY,QAAlB,OACM0V,MAAM,CAACmB,MAAP,CAAciE,UADpB,mCAC2D7M,KAD3D,SADsB,GAItByH,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiBV,KAAjB,CAJJ;EAMA,QAAMy6B,OAAO,GAAGvQ,QAAQ,CAACjoB,IAAT,OACV2G,MAAM,CAAC8xB,YADG,cACkB9xB,MAAM,CAAC+xB,WADzB,eAC8C/xB,MAAM,CAACgyB,YADrD,OAAhB;;EAGA,QACE1Q,QAAQ,CAACnvB,QAAT,CAAkB6N,MAAM,CAAC8xB,YAAzB,KACA,CAACxQ,QAAQ,CAACnvB,QAAT,CAAkB6N,MAAM,CAAC+xB,WAAzB,CADD,IAEA,CAACzQ,QAAQ,CAACnvB,QAAT,CAAkB6N,MAAM,CAACgyB,YAAzB,CAHH,EAIE;EACAH,MAAAA,OAAO,CAACtkC,IAAR,CAAa+zB,QAAQ,CAAC,CAAD,CAArB;EACD;;EACD,QAAIuQ,OAAO,CAACxpC,MAAR,KAAmB,CAAvB,EAA0B;EAE1BwpC,IAAAA,OAAO,CAAC16B,IAAR,CAAa,UAACglB,OAAD,EAAa;EACxB,UAAMkS,QAAQ,GAAG99B,CAAC,CAAC4rB,OAAD,CAAlB;EACAkS,MAAAA,QAAQ,CAACv9B,QAAT,CAAkBkP,MAAM,CAACgyB,YAAzB;EAEA,UAAMC,UAAU,GAAG5D,QAAQ,CAAC97B,IAAT,CAAc,iBAAd,CAAnB;EACA,UAAMtK,GAAG,GAAGomC,QAAQ,CAAC97B,IAAT,CAAc,UAAd,CAAZ;EACA,UAAM6pB,MAAM,GAAGiS,QAAQ,CAAC97B,IAAT,CAAc,aAAd,CAAf;EACA,UAAM8pB,KAAK,GAAGgS,QAAQ,CAAC97B,IAAT,CAAc,YAAd,CAAd;EACA,UAAM2/B,UAAU,GAAG7D,QAAQ,CAACp1B,MAAT,CAAgB,SAAhB,CAAnB;EAEA4F,MAAAA,MAAM,CAACqd,SAAP,CAAiBmS,QAAQ,CAAC,CAAD,CAAzB,EAA8BpmC,GAAG,IAAIgqC,UAArC,EAAiD7V,MAAjD,EAAyDC,KAAzD,EAAgE,KAAhE,EAAuE,YAAM;EAC3E,YACE,OAAOxd,MAAP,KAAkB,WAAlB,IACAA,MAAM,KAAK,IADX,IAEA,CAACA,MAFD,IAGCA,MAAM,IAAI,CAACA,MAAM,CAACmB,MAHnB,IAIAnB,MAAM,CAACG,SALT,EAOE;;EACF,YAAIizB,UAAJ,EAAgB;EACd5D,UAAAA,QAAQ,CAACr3B,GAAT,CAAa,kBAAb,aAAyCi7B,UAAzC;EACA5D,UAAAA,QAAQ,CAAC17B,UAAT,CAAoB,iBAApB;EACD,SAHD,MAGO;EACL,cAAIypB,MAAJ,EAAY;EACViS,YAAAA,QAAQ,CAAC97B,IAAT,CAAc,QAAd,EAAwB6pB,MAAxB;EACAiS,YAAAA,QAAQ,CAAC17B,UAAT,CAAoB,aAApB;EACD;;EACD,cAAI0pB,KAAJ,EAAW;EACTgS,YAAAA,QAAQ,CAAC97B,IAAT,CAAc,OAAd,EAAuB8pB,KAAvB;EACAgS,YAAAA,QAAQ,CAAC17B,UAAT,CAAoB,YAApB;EACD;;EACD,cAAIu/B,UAAU,CAAC7pC,MAAf,EAAuB;EACrB6pC,YAAAA,UAAU,CAAC/oC,QAAX,CAAoB,QAApB,EAA8BgO,IAA9B,CAAmC,UAACg7B,QAAD,EAAc;EAC/C,kBAAMC,OAAO,GAAG7hC,CAAC,CAAC4hC,QAAD,CAAjB;;EAEA,kBAAIC,OAAO,CAAC7/B,IAAR,CAAa,aAAb,CAAJ,EAAiC;EAC/B6/B,gBAAAA,OAAO,CAAC7/B,IAAR,CAAa,QAAb,EAAuB6/B,OAAO,CAAC7/B,IAAR,CAAa,aAAb,CAAvB;EACA6/B,gBAAAA,OAAO,CAACz/B,UAAR,CAAmB,aAAnB;EACD;EACF,aAPD;EAQD;;EACD,cAAI1K,GAAJ,EAAS;EACPomC,YAAAA,QAAQ,CAAC97B,IAAT,CAAc,KAAd,EAAqBtK,GAArB;EACAomC,YAAAA,QAAQ,CAAC17B,UAAT,CAAoB,UAApB;EACD;EACF;;EAED07B,QAAAA,QAAQ,CAACv9B,QAAT,CAAkBkP,MAAM,CAAC+xB,WAAzB,EAAsCtgC,WAAtC,CAAkDuO,MAAM,CAACgyB,YAAzD;EACA1Q,QAAAA,QAAQ,CAACjoB,IAAT,OAAkB2G,MAAM,CAACqyB,cAAzB,EAA2CxgC,MAA3C;;EACA,YAAIgN,MAAM,CAACmB,MAAP,CAAc+K,IAAd,IAAsB6mB,eAA1B,EAA2C;EACzC,cAAMU,kBAAkB,GAAGhR,QAAQ,CAAC/uB,IAAT,CAAc,yBAAd,CAA3B;;EACA,cAAI+uB,QAAQ,CAACnvB,QAAT,CAAkB0M,MAAM,CAACmB,MAAP,CAAcgL,mBAAhC,CAAJ,EAA0D;EACxD,gBAAMunB,aAAa,GAAG1zB,MAAM,CAACsC,UAAP,CAAkBhY,QAAlB,iCACSmpC,kBADT,iBACsCzzB,MAAM,CAACmB,MAAP,CAAcgL,mBADpD,OAAtB;EAGAnM,YAAAA,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBY,aAAa,CAACn7B,KAAd,EAAxB,EAA+C,KAA/C;EACD,WALD,MAKO;EACL,gBAAMo7B,eAAe,GAAG3zB,MAAM,CAACsC,UAAP,CAAkBhY,QAAlB,OAClB0V,MAAM,CAACmB,MAAP,CAAcgL,mBADI,mCAC4CsnB,kBAD5C,SAAxB;EAGAzzB,YAAAA,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBa,eAAe,CAACp7B,KAAhB,EAAxB,EAAiD,KAAjD;EACD;EACF;;EACDyH,QAAAA,MAAM,CAACgB,IAAP,CAAY,gBAAZ,EAA8ByhB,QAAQ,CAAC,CAAD,CAAtC,EAA2C+M,QAAQ,CAAC,CAAD,CAAnD;;EACA,YAAIxvB,MAAM,CAACmB,MAAP,CAAcyJ,UAAlB,EAA8B;EAC5B5K,UAAAA,MAAM,CAAC4J,gBAAP;EACD;EACF,OAzDD;EA2DA5J,MAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ,EAA6ByhB,QAAQ,CAAC,CAAD,CAArC,EAA0C+M,QAAQ,CAAC,CAAD,CAAlD;EACD,KAtED;EAuED,GAjGU;EAkGXvN,EAAAA,IAlGW,kBAkGJ;EACL,QAAMjiB,MAAM,GAAG,IAAf;EADK,QAEGsC,UAFH,GAE6DtC,MAF7D,CAEGsC,UAFH;EAAA,QAEuB+c,YAFvB,GAE6Drf,MAF7D,CAEemB,MAFf;EAAA,QAEqCgE,MAFrC,GAE6DnF,MAF7D,CAEqCmF,MAFrC;EAAA,QAE6C8E,WAF7C,GAE6DjK,MAF7D,CAE6CiK,WAF7C;EAGL,QAAMlF,SAAS,GAAG/E,MAAM,CAACgF,OAAP,IAAkBqa,YAAY,CAACra,OAAb,CAAqBC,OAAzD;EACA,QAAM9D,MAAM,GAAGke,YAAY,CAAC2C,IAA5B;EAEA,QAAIhb,aAAa,GAAGqY,YAAY,CAACrY,aAAjC;;EACA,QAAIA,aAAa,KAAK,MAAtB,EAA8B;EAC5BA,MAAAA,aAAa,GAAG,CAAhB;EACD;;EAED,aAAS4sB,UAAT,CAAoBr7B,KAApB,EAA2B;EACzB,UAAIwM,SAAJ,EAAe;EACb,YACEzC,UAAU,CAAChY,QAAX,OAAwB+0B,YAAY,CAACja,UAArC,mCAA4E7M,KAA5E,UACG/O,MAFL,EAGE;EACA,iBAAO,IAAP;EACD;EACF,OAPD,MAOO,IAAI2b,MAAM,CAAC5M,KAAD,CAAV,EAAmB,OAAO,IAAP;;EAC1B,aAAO,KAAP;EACD;;EAED,aAASoN,UAAT,CAAoBD,OAApB,EAA6B;EAC3B,UAAIX,SAAJ,EAAe;EACb,eAAOrT,CAAC,CAACgU,OAAD,CAAD,CAAWhS,IAAX,CAAgB,yBAAhB,CAAP;EACD;;EACD,aAAOhC,CAAC,CAACgU,OAAD,CAAD,CAAWnN,KAAX,EAAP;EACD;;EAED,QAAI,CAACyH,MAAM,CAACgiB,IAAP,CAAY6R,kBAAjB,EAAqC7zB,MAAM,CAACgiB,IAAP,CAAY6R,kBAAZ,GAAiC,IAAjC;;EACrC,QAAI7zB,MAAM,CAACmB,MAAP,CAAcuI,qBAAlB,EAAyC;EACvCpH,MAAAA,UAAU,CAAChY,QAAX,OAAwB+0B,YAAY,CAAC7U,iBAArC,EAA0DlS,IAA1D,CAA+D,UAACoN,OAAD,EAAa;EAC1E,YAAMnN,KAAK,GAAGwM,SAAS,GAAGrT,CAAC,CAACgU,OAAD,CAAD,CAAWhS,IAAX,CAAgB,yBAAhB,CAAH,GAAgDhC,CAAC,CAACgU,OAAD,CAAD,CAAWnN,KAAX,EAAvE;EACAyH,QAAAA,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBv6B,KAAxB;EACD,OAHD;EAID,KALD,MAKO,IAAIyO,aAAa,GAAG,CAApB,EAAuB;EAC5B,WAAK,IAAI1V,CAAC,GAAG2Y,WAAb,EAA0B3Y,CAAC,GAAG2Y,WAAW,GAAGjD,aAA5C,EAA2D1V,CAAC,IAAI,CAAhE,EAAmE;EACjE,YAAIsiC,UAAU,CAACtiC,CAAD,CAAd,EAAmB0O,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBxhC,CAAxB;EACpB;EACF,KAJM,MAIA;EACL0O,MAAAA,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwB7oB,WAAxB;EACD;;EACD,QAAI9I,MAAM,CAAC2yB,YAAX,EAAyB;EACvB,UAAI9sB,aAAa,GAAG,CAAhB,IAAsB7F,MAAM,CAAC4yB,kBAAP,IAA6B5yB,MAAM,CAAC4yB,kBAAP,GAA4B,CAAnF,EAAuF;EACrF,YAAMC,MAAM,GAAG7yB,MAAM,CAAC4yB,kBAAtB;EACA,YAAMhU,GAAG,GAAG/Y,aAAZ;EACA,YAAMitB,QAAQ,GAAGptB,IAAI,CAACiB,GAAL,CAASmC,WAAW,GAAG8V,GAAd,GAAoBlZ,IAAI,CAACK,GAAL,CAAS8sB,MAAT,EAAiBjU,GAAjB,CAA7B,EAAoD5a,MAAM,CAAC3b,MAA3D,CAAjB;EACA,YAAM0qC,QAAQ,GAAGrtB,IAAI,CAACK,GAAL,CAAS+C,WAAW,GAAGpD,IAAI,CAACK,GAAL,CAAS6Y,GAAT,EAAciU,MAAd,CAAvB,EAA8C,CAA9C,CAAjB,CAJqF;;EAMrF,aAAK,IAAI1iC,EAAC,GAAG2Y,WAAW,GAAGjD,aAA3B,EAA0C1V,EAAC,GAAG2iC,QAA9C,EAAwD3iC,EAAC,IAAI,CAA7D,EAAgE;EAC9D,cAAIsiC,UAAU,CAACtiC,EAAD,CAAd,EAAmB0O,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBxhC,EAAxB;EACpB,SARoF;;;EAUrF,aAAK,IAAIA,GAAC,GAAG4iC,QAAb,EAAuB5iC,GAAC,GAAG2Y,WAA3B,EAAwC3Y,GAAC,IAAI,CAA7C,EAAgD;EAC9C,cAAIsiC,UAAU,CAACtiC,GAAD,CAAd,EAAmB0O,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBxhC,GAAxB;EACpB;EACF,OAbD,MAaO;EACL,YAAM8a,SAAS,GAAG9J,UAAU,CAAChY,QAAX,OAAwB+0B,YAAY,CAACzT,cAArC,CAAlB;EACA,YAAIQ,SAAS,CAAC5iB,MAAV,GAAmB,CAAvB,EAA0BwW,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBntB,UAAU,CAACyG,SAAD,CAAlC;EAE1B,YAAMC,SAAS,GAAG/J,UAAU,CAAChY,QAAX,OAAwB+0B,YAAY,CAACxT,cAArC,CAAlB;EACA,YAAIQ,SAAS,CAAC7iB,MAAV,GAAmB,CAAvB,EAA0BwW,MAAM,CAACgiB,IAAP,CAAY8Q,WAAZ,CAAwBntB,UAAU,CAAC0G,SAAD,CAAlC;EAC3B;EACF;EACF,GAnKU;EAoKX8nB,EAAAA,iBApKW,+BAoKS;EAClB,QAAMnnC,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAMkT,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC;EACjC,QAAMi0B,cAAc,GAAGp0B,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmBqS,gBAAnB,GACnB3iC,CAAC,CAACsO,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmBqS,gBAApB,CADkB,GAEnB3iC,CAAC,CAAC1E,MAAD,CAFL;EAGA,QAAMsnC,QAAQ,GAAGF,cAAc,CAAC,CAAD,CAAd,KAAsBpnC,MAAvC;EACA,QAAMunC,kBAAkB,GAAGD,QAAQ,GAAGtnC,MAAM,CAAC8nB,UAAV,GAAuBsf,cAAc,CAAC,CAAD,CAAd,CAAkBj9B,WAA5E;EACA,QAAMq9B,mBAAmB,GAAGF,QAAQ,GAAGtnC,MAAM,CAACuvB,WAAV,GAAwB6X,cAAc,CAAC,CAAD,CAAd,CAAkB78B,YAA9E;EACA,QAAMitB,YAAY,GAAGxkB,MAAM,CAACoC,GAAP,CAAW5K,MAAX,EAArB;EAVkB,QAWIoN,GAXJ,GAWY5E,MAXZ,CAWV6E,YAXU;EAalB,QAAIsf,MAAM,GAAG,KAAb;EAEA,QAAIvf,GAAJ,EAAS4f,YAAY,CAACtsB,IAAb,IAAqB8H,MAAM,CAACoC,GAAP,CAAW,CAAX,EAAcrK,UAAnC;EACT,QAAM0sB,WAAW,GAAG,CAClB,CAACD,YAAY,CAACtsB,IAAd,EAAoBssB,YAAY,CAACvsB,GAAjC,CADkB,EAElB,CAACusB,YAAY,CAACtsB,IAAb,GAAoB8H,MAAM,CAACxB,KAA5B,EAAmCgmB,YAAY,CAACvsB,GAAhD,CAFkB,EAGlB,CAACusB,YAAY,CAACtsB,IAAd,EAAoBssB,YAAY,CAACvsB,GAAb,GAAmB+H,MAAM,CAACtB,MAA9C,CAHkB,EAIlB,CAAC8lB,YAAY,CAACtsB,IAAb,GAAoB8H,MAAM,CAACxB,KAA5B,EAAmCgmB,YAAY,CAACvsB,GAAb,GAAmB+H,MAAM,CAACtB,MAA7D,CAJkB,CAApB;;EAMA,SAAK,IAAIpN,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGmzB,WAAW,CAACj7B,MAAhC,EAAwC8H,CAAC,IAAI,CAA7C,EAAgD;EAC9C,UAAMmrB,KAAK,GAAGgI,WAAW,CAACnzB,CAAD,CAAzB;;EACA,UACEmrB,KAAK,CAAC,CAAD,CAAL,IAAY,CAAZ,IACAA,KAAK,CAAC,CAAD,CAAL,IAAY8X,kBADZ,IAEA9X,KAAK,CAAC,CAAD,CAAL,IAAY,CAFZ,IAGAA,KAAK,CAAC,CAAD,CAAL,IAAY+X,mBAJd,EAKE;EACA,YAAI/X,KAAK,CAAC,CAAD,CAAL,KAAa,CAAb,IAAkBA,KAAK,CAAC,CAAD,CAAL,KAAa,CAAnC,EAAsC,SADtC;;EAEA0H,QAAAA,MAAM,GAAG,IAAT;EACD;EACF;;EAED,QAAIA,MAAJ,EAAY;EACVnkB,MAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACAmS,MAAAA,cAAc,CAACz+B,GAAf,CAAmB,QAAnB,EAA6BqK,MAAM,CAACgiB,IAAP,CAAYmS,iBAAzC;EACD,KAHD,MAGO,IAAI,CAACn0B,MAAM,CAACgiB,IAAP,CAAYyS,qBAAjB,EAAwC;EAC7Cz0B,MAAAA,MAAM,CAACgiB,IAAP,CAAYyS,qBAAZ,GAAoC,IAApC;EACAL,MAAAA,cAAc,CAAChgC,EAAf,CAAkB,QAAlB,EAA4B4L,MAAM,CAACgiB,IAAP,CAAYmS,iBAAxC;EACD;EACF;EA9MU,CAAb;AAiNA,eAAe;EACbp0B,EAAAA,IAAI,EAAE,MADO;EAEboB,EAAAA,MAAM,EAAE;EACN6gB,IAAAA,IAAI,EAAE;EACJ0S,MAAAA,WAAW,EAAE,KADT;EAEJzvB,MAAAA,OAAO,EAAE,KAFL;EAGJ6uB,MAAAA,YAAY,EAAE,KAHV;EAIJC,MAAAA,kBAAkB,EAAE,CAJhB;EAKJY,MAAAA,qBAAqB,EAAE,KALnB;EAMJN,MAAAA,gBAAgB,EAAE,EANd;EAQJpB,MAAAA,YAAY,EAAE,aARV;EASJE,MAAAA,YAAY,EAAE,qBATV;EAUJD,MAAAA,WAAW,EAAE,oBAVT;EAWJM,MAAAA,cAAc,EAAE;EAXZ;EADA,GAFK;EAiBbnmC,EAAAA,MAjBa,oBAiBJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBgiB,MAAAA,IAAI;EACF6R,QAAAA,kBAAkB,EAAE;EADlB,SAEChB,IAFD;EADoB,KAAT,CAAjB;EAMD,GAzBY;EA0Bbz+B,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EACjB,UAAIA,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB/c,OAAnB,IAA8BjF,MAAM,CAACmB,MAAP,CAAc6c,aAAhD,EAA+D;EAC7Dhe,QAAAA,MAAM,CAACmB,MAAP,CAAc6c,aAAd,GAA8B,KAA9B;EACD;EACF,KALC;EAMF9c,IAAAA,IANE,gBAMGlB,MANH,EAMW;EACX,UAAIA,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB/c,OAAnB,IAA8B,CAACjF,MAAM,CAACmB,MAAP,CAAc+K,IAA7C,IAAqDlM,MAAM,CAACmB,MAAP,CAAc+N,YAAd,KAA+B,CAAxF,EAA2F;EACzF,YAAIlP,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB0S,WAAvB,EAAoC;EAClC10B,UAAAA,MAAM,CAACgiB,IAAP,CAAYmS,iBAAZ;EACD,SAFD,MAEO;EACLn0B,UAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACD;EACF;EACF,KAdC;EAeF2S,IAAAA,MAfE,kBAeK50B,MAfL,EAea;EACb,UAAIA,MAAM,CAACmB,MAAP,CAAc+V,QAAd,IAA0B,CAAClX,MAAM,CAACmB,MAAP,CAAc0X,cAA7C,EAA6D;EAC3D7Y,QAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACD;EACF,KAnBC;EAoBF,2DAAuD,SAAS4S,QAAT,CAAkB70B,MAAlB,EAA0B;EAC/E,UAAIA,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB/c,OAAvB,EAAgC;EAC9BjF,QAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACD;EACF,KAxBC;EAyBFvT,IAAAA,eAzBE,2BAyBc1O,MAzBd,EAyBsB;EACtB,UAAIA,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB/c,OAAvB,EAAgC;EAC9B,YACEjF,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB2S,qBAAnB,IACC,CAAC30B,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB2S,qBAApB,IAA6C,CAAC30B,MAAM,CAACgiB,IAAP,CAAY6R,kBAF7D,EAGE;EACA7zB,UAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACD;EACF;EACF,KAlCC;EAmCFrrB,IAAAA,aAnCE,yBAmCYoJ,MAnCZ,EAmCoB;EACpB,UAAIA,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB/c,OAAnB,IAA8B,CAACjF,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB2S,qBAAtD,EAA6E;EAC3E30B,QAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACD;EACF,KAvCC;EAwCF2Q,IAAAA,WAxCE,uBAwCU5yB,MAxCV,EAwCkB;EAClB,UAAIA,MAAM,CAACmB,MAAP,CAAc6gB,IAAd,CAAmB/c,OAAnB,IAA8BjF,MAAM,CAACmB,MAAP,CAAcyE,OAAhD,EAAyD;EACvD5F,QAAAA,MAAM,CAACgiB,IAAP,CAAYC,IAAZ;EACD;EACF;EA5CC;EA1BS,CAAf;;EClNA,IAAM6S,UAAU,GAAG;EACjBC,EAAAA,YAAY,EAAE,SAASA,YAAT,CAAsBrnB,CAAtB,EAAyBC,CAAzB,EAA4B;EACxC,QAAMqnB,YAAY,GAAI,SAAS3pC,MAAT,GAAkB;EACtC,UAAI4oC,QAAJ;EACA,UAAIC,QAAJ;EACA,UAAIe,KAAJ;EACA,aAAO,UAACC,KAAD,EAAQ7kB,GAAR,EAAgB;EACrB6jB,QAAAA,QAAQ,GAAG,CAAC,CAAZ;EACAD,QAAAA,QAAQ,GAAGiB,KAAK,CAAC1rC,MAAjB;;EACA,eAAOyqC,QAAQ,GAAGC,QAAX,GAAsB,CAA7B,EAAgC;EAC9Be,UAAAA,KAAK,GAAIhB,QAAQ,GAAGC,QAAZ,IAAyB,CAAjC;;EACA,cAAIgB,KAAK,CAACD,KAAD,CAAL,IAAgB5kB,GAApB,EAAyB;EACvB6jB,YAAAA,QAAQ,GAAGe,KAAX;EACD,WAFD,MAEO;EACLhB,YAAAA,QAAQ,GAAGgB,KAAX;EACD;EACF;;EACD,eAAOhB,QAAP;EACD,OAZD;EAaD,KAjBoB,EAArB;;EAkBA,SAAKvmB,CAAL,GAASA,CAAT;EACA,SAAKC,CAAL,GAASA,CAAT;EACA,SAAKkc,SAAL,GAAiBnc,CAAC,CAAClkB,MAAF,GAAW,CAA5B,CArBwC;EAuBxC;EACA;;EACA,QAAI2rC,EAAJ;EACA,QAAIC,EAAJ;;EAEA,SAAKC,WAAL,GAAmB,SAASA,WAAT,CAAqBrG,EAArB,EAAyB;EAC1C,UAAI,CAACA,EAAL,EAAS,OAAO,CAAP,CADiC;;EAI1CoG,MAAAA,EAAE,GAAGJ,YAAY,CAAC,KAAKtnB,CAAN,EAASshB,EAAT,CAAjB;EACAmG,MAAAA,EAAE,GAAGC,EAAE,GAAG,CAAV,CAL0C;EAQ1C;;EACA,aACG,CAACpG,EAAE,GAAG,KAAKthB,CAAL,CAAOynB,EAAP,CAAN,KAAqB,KAAKxnB,CAAL,CAAOynB,EAAP,IAAa,KAAKznB,CAAL,CAAOwnB,EAAP,CAAlC,CAAD,IAAmD,KAAKznB,CAAL,CAAO0nB,EAAP,IAAa,KAAK1nB,CAAL,CAAOynB,EAAP,CAAhE,IAA8E,KAAKxnB,CAAL,CAAOwnB,EAAP,CADhF;EAGD,KAZD;;EAaA,WAAO,IAAP;EACD,GA3CgB;EA4CjB;EACAG,EAAAA,sBA7CiB,kCA6CM/iC,CA7CN,EA6CS;EACxB,QAAMyN,MAAM,GAAG,IAAf;;EACA,QAAI,CAACA,MAAM,CAACu1B,UAAP,CAAkBC,MAAvB,EAA+B;EAC7Bx1B,MAAAA,MAAM,CAACu1B,UAAP,CAAkBC,MAAlB,GAA2Bx1B,MAAM,CAACmB,MAAP,CAAc+K,IAAd,GACvB,IAAI4oB,UAAU,CAACC,YAAf,CAA4B/0B,MAAM,CAACuF,UAAnC,EAA+ChT,CAAC,CAACgT,UAAjD,CADuB,GAEvB,IAAIuvB,UAAU,CAACC,YAAf,CAA4B/0B,MAAM,CAACsF,QAAnC,EAA6C/S,CAAC,CAAC+S,QAA/C,CAFJ;EAGD;EACF,GApDgB;EAqDjBiI,EAAAA,YArDiB,wBAqDJA,aArDI,EAqDUC,YArDV,EAqDwB;EACvC,QAAMxN,MAAM,GAAG,IAAf;EACA,QAAMy1B,UAAU,GAAGz1B,MAAM,CAACu1B,UAAP,CAAkBG,OAArC;EACA,QAAIxqB,UAAJ;EACA,QAAIyqB,mBAAJ;EACA,QAAM1W,MAAM,GAAGjf,MAAM,CAAChX,WAAtB;;EACA,aAAS4sC,sBAAT,CAAgCrjC,CAAhC,EAAmC;EACjC;EACA;EACA;EACA;EACA,UAAM+X,SAAS,GAAGtK,MAAM,CAAC6E,YAAP,GAAsB,CAAC7E,MAAM,CAACsK,SAA9B,GAA0CtK,MAAM,CAACsK,SAAnE;;EACA,UAAItK,MAAM,CAACmB,MAAP,CAAco0B,UAAd,CAAyBM,EAAzB,KAAgC,OAApC,EAA6C;EAC3C71B,QAAAA,MAAM,CAACu1B,UAAP,CAAkBD,sBAAlB,CAAyC/iC,CAAzC,EAD2C;EAG3C;;EACAojC,QAAAA,mBAAmB,GAAG,CAAC31B,MAAM,CAACu1B,UAAP,CAAkBC,MAAlB,CAAyBH,WAAzB,CAAqC,CAAC/qB,SAAtC,CAAvB;EACD;;EAED,UAAI,CAACqrB,mBAAD,IAAwB31B,MAAM,CAACmB,MAAP,CAAco0B,UAAd,CAAyBM,EAAzB,KAAgC,WAA5D,EAAyE;EACvE3qB,QAAAA,UAAU,GACR,CAAC3Y,CAAC,CAAC6Y,YAAF,KAAmB7Y,CAAC,CAACoY,YAAF,EAApB,KAAyC3K,MAAM,CAACoL,YAAP,KAAwBpL,MAAM,CAAC2K,YAAP,EAAjE,CADF;EAEAgrB,QAAAA,mBAAmB,GAAG,CAACrrB,SAAS,GAAGtK,MAAM,CAAC2K,YAAP,EAAb,IAAsCO,UAAtC,GAAmD3Y,CAAC,CAACoY,YAAF,EAAzE;EACD;;EAED,UAAI3K,MAAM,CAACmB,MAAP,CAAco0B,UAAd,CAAyBO,OAA7B,EAAsC;EACpCH,QAAAA,mBAAmB,GAAGpjC,CAAC,CAAC6Y,YAAF,KAAmBuqB,mBAAzC;EACD;;EACDpjC,MAAAA,CAAC,CAAC0Y,cAAF,CAAiB0qB,mBAAjB;EACApjC,MAAAA,CAAC,CAACgb,YAAF,CAAeooB,mBAAf,EAAoC31B,MAApC;EACAzN,MAAAA,CAAC,CAACga,iBAAF;EACAha,MAAAA,CAAC,CAACkZ,mBAAF;EACD;;EACD,QAAI7a,KAAK,CAACK,OAAN,CAAcwkC,UAAd,CAAJ,EAA+B;EAC7B,WAAK,IAAInkC,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGmkC,UAAU,CAACjsC,MAA/B,EAAuC8H,CAAC,IAAI,CAA5C,EAA+C;EAC7C,YAAImkC,UAAU,CAACnkC,CAAD,CAAV,KAAkBkc,YAAlB,IAAkCioB,UAAU,CAACnkC,CAAD,CAAV,YAAyB2tB,MAA/D,EAAuE;EACrE2W,UAAAA,sBAAsB,CAACH,UAAU,CAACnkC,CAAD,CAAX,CAAtB;EACD;EACF;EACF,KAND,MAMO,IAAImkC,UAAU,YAAYxW,MAAtB,IAAgCzR,YAAY,KAAKioB,UAArD,EAAiE;EACtEG,MAAAA,sBAAsB,CAACH,UAAD,CAAtB;EACD;EACF,GA/FgB;EAgGjB1rB,EAAAA,aAhGiB,yBAgGH7V,QAhGG,EAgGOsZ,YAhGP,EAgGqB;EACpC,QAAMxN,MAAM,GAAG,IAAf;EACA,QAAMif,MAAM,GAAGjf,MAAM,CAAChX,WAAtB;EACA,QAAMysC,UAAU,GAAGz1B,MAAM,CAACu1B,UAAP,CAAkBG,OAArC;EACA,QAAIpkC,CAAJ;;EACA,aAASykC,uBAAT,CAAiCxjC,CAAjC,EAAoC;EAClCA,MAAAA,CAAC,CAACwX,aAAF,CAAgB7V,QAAhB,EAA0B8L,MAA1B;;EACA,UAAI9L,QAAQ,KAAK,CAAjB,EAAoB;EAClB3B,QAAAA,CAAC,CAACmc,eAAF;;EACA,YAAInc,CAAC,CAAC4O,MAAF,CAASyJ,UAAb,EAAyB;EACvB5P,UAAAA,QAAQ,CAAC,YAAM;EACbzI,YAAAA,CAAC,CAACqX,gBAAF;EACD,WAFO,CAAR;EAGD;;EACDrX,QAAAA,CAAC,CAAC+P,UAAF,CAAa1L,aAAb,CAA2B,YAAM;EAC/B,cAAI,CAAC6+B,UAAL,EAAiB;;EACjB,cAAIljC,CAAC,CAAC4O,MAAF,CAAS+K,IAAT,IAAiBlM,MAAM,CAACmB,MAAP,CAAco0B,UAAd,CAAyBM,EAAzB,KAAgC,OAArD,EAA8D;EAC5DtjC,YAAAA,CAAC,CAAC0d,OAAF;EACD;;EACD1d,UAAAA,CAAC,CAACqE,aAAF;EACD,SAND;EAOD;EACF;;EACD,QAAIhG,KAAK,CAACK,OAAN,CAAcwkC,UAAd,CAAJ,EAA+B;EAC7B,WAAKnkC,CAAC,GAAG,CAAT,EAAYA,CAAC,GAAGmkC,UAAU,CAACjsC,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,YAAImkC,UAAU,CAACnkC,CAAD,CAAV,KAAkBkc,YAAlB,IAAkCioB,UAAU,CAACnkC,CAAD,CAAV,YAAyB2tB,MAA/D,EAAuE;EACrE8W,UAAAA,uBAAuB,CAACN,UAAU,CAACnkC,CAAD,CAAX,CAAvB;EACD;EACF;EACF,KAND,MAMO,IAAImkC,UAAU,YAAYxW,MAAtB,IAAgCzR,YAAY,KAAKioB,UAArD,EAAiE;EACtEM,MAAAA,uBAAuB,CAACN,UAAD,CAAvB;EACD;EACF;EAhIgB,CAAnB;AAkIA,qBAAe;EACb11B,EAAAA,IAAI,EAAE,YADO;EAEboB,EAAAA,MAAM,EAAE;EACNo0B,IAAAA,UAAU,EAAE;EACVG,MAAAA,OAAO,EAAEnmC,SADC;EAEVumC,MAAAA,OAAO,EAAE,KAFC;EAGVD,MAAAA,EAAE,EAAE,OAHM;;EAAA;EADN,GAFK;EASbxoC,EAAAA,MATa,oBASJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBu1B,MAAAA,UAAU;EACRG,QAAAA,OAAO,EAAE11B,MAAM,CAACmB,MAAP,CAAco0B,UAAd,CAAyBG;EAD1B,SAELZ,UAFK;EADc,KAAT,CAAjB;EAMD,GAjBY;EAkBb1gC,EAAAA,EAAE,EAAE;EACFge,IAAAA,MADE,kBACKpS,MADL,EACa;EACb,UAAI,CAACA,MAAM,CAACu1B,UAAP,CAAkBG,OAAvB,EAAgC;;EAChC,UAAI11B,MAAM,CAACu1B,UAAP,CAAkBC,MAAtB,EAA8B;EAC5Bx1B,QAAAA,MAAM,CAACu1B,UAAP,CAAkBC,MAAlB,GAA2BjmC,SAA3B;EACA,eAAOyQ,MAAM,CAACu1B,UAAP,CAAkBC,MAAzB;EACD;EACF,KAPC;EAQFv1B,IAAAA,MARE,kBAQKD,MARL,EAQa;EACb,UAAI,CAACA,MAAM,CAACu1B,UAAP,CAAkBG,OAAvB,EAAgC;;EAChC,UAAI11B,MAAM,CAACu1B,UAAP,CAAkBC,MAAtB,EAA8B;EAC5Bx1B,QAAAA,MAAM,CAACu1B,UAAP,CAAkBC,MAAlB,GAA2BjmC,SAA3B;EACA,eAAOyQ,MAAM,CAACu1B,UAAP,CAAkBC,MAAzB;EACD;EACF,KAdC;EAeF3zB,IAAAA,cAfE,0BAea7B,MAfb,EAeqB;EACrB,UAAI,CAACA,MAAM,CAACu1B,UAAP,CAAkBG,OAAvB,EAAgC;;EAChC,UAAI11B,MAAM,CAACu1B,UAAP,CAAkBC,MAAtB,EAA8B;EAC5Bx1B,QAAAA,MAAM,CAACu1B,UAAP,CAAkBC,MAAlB,GAA2BjmC,SAA3B;EACA,eAAOyQ,MAAM,CAACu1B,UAAP,CAAkBC,MAAzB;EACD;EACF,KArBC;EAsBFjoB,IAAAA,YAtBE,wBAsBWvN,MAtBX,EAsBmBsK,SAtBnB,EAsB8BkD,YAtB9B,EAsB4C;EAC5C,UAAI,CAACxN,MAAM,CAACu1B,UAAP,CAAkBG,OAAvB,EAAgC;EAChC11B,MAAAA,MAAM,CAACu1B,UAAP,CAAkBhoB,YAAlB,CAA+BjD,SAA/B,EAA0CkD,YAA1C;EACD,KAzBC;EA0BFzD,IAAAA,aA1BE,yBA0BY/J,MA1BZ,EA0BoB9L,QA1BpB,EA0B8BsZ,YA1B9B,EA0B4C;EAC5C,UAAI,CAACxN,MAAM,CAACu1B,UAAP,CAAkBG,OAAvB,EAAgC;EAChC11B,MAAAA,MAAM,CAACu1B,UAAP,CAAkBxrB,aAAlB,CAAgC7V,QAAhC,EAA0CsZ,YAA1C;EACD;EA7BC;EAlBS,CAAf;;EClIA,IAAMwoB,IAAI,GAAG;EACXC,EAAAA,eADW,2BACK7xB,IADL,EACgB;EAAA,QAAXA,IAAW;EAAXA,MAAAA,IAAW,GAAJ,EAAI;EAAA;;EACzB,QAAM8xB,UAAU,GAAG,SAAbA,UAAa;EAAA,aAAMrvB,IAAI,CAACsvB,KAAL,CAAW,KAAKtvB,IAAI,CAACuvB,MAAL,EAAhB,EAA+BloC,QAA/B,CAAwC,EAAxC,CAAN;EAAA,KAAnB;;EACA,WAAO,IAAImoC,MAAJ,CAAWjyB,IAAX,EAAiBxI,OAAjB,CAAyB,IAAzB,EAA+Bs6B,UAA/B,CAAP;EACD,GAJU;EAKXI,EAAAA,eALW,2BAKKl0B,GALL,EAKU;EACnBA,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,UAAT,EAAqB,GAArB;EACA,WAAO0O,GAAP;EACD,GARU;EASXm0B,EAAAA,kBATW,8BASQn0B,GATR,EASa;EACtBA,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,UAAT,EAAqB,IAArB;EACA,WAAO0O,GAAP;EACD,GAZU;EAaXo0B,EAAAA,SAbW,qBAaDp0B,GAbC,EAaIq0B,IAbJ,EAaU;EACnBr0B,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,MAAT,EAAiB+iC,IAAjB;EACA,WAAOr0B,GAAP;EACD,GAhBU;EAiBXs0B,EAAAA,oBAjBW,gCAiBUt0B,GAjBV,EAiBeu0B,WAjBf,EAiB4B;EACrCv0B,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,sBAAT,EAAiCijC,WAAjC;EACA,WAAOv0B,GAAP;EACD,GApBU;EAqBXw0B,EAAAA,aArBW,yBAqBGx0B,GArBH,EAqBQy0B,QArBR,EAqBkB;EAC3Bz0B,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,eAAT,EAA0BmjC,QAA1B;EACA,WAAOz0B,GAAP;EACD,GAxBU;EAyBX00B,EAAAA,UAzBW,sBAyBA10B,GAzBA,EAyBKsC,KAzBL,EAyBY;EACrBtC,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,YAAT,EAAuBgR,KAAvB;EACA,WAAOtC,GAAP;EACD,GA5BU;EA6BX20B,EAAAA,OA7BW,mBA6BH30B,GA7BG,EA6BEvV,EA7BF,EA6BM;EACfuV,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,IAAT,EAAe7G,EAAf;EACA,WAAOuV,GAAP;EACD,GAhCU;EAiCX40B,EAAAA,SAjCW,qBAiCD50B,GAjCC,EAiCI60B,IAjCJ,EAiCU;EACnB70B,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,WAAT,EAAsBujC,IAAtB;EACA,WAAO70B,GAAP;EACD,GApCU;EAqCX80B,EAAAA,SArCW,qBAqCD90B,GArCC,EAqCI;EACbA,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,eAAT,EAA0B,IAA1B;EACA,WAAO0O,GAAP;EACD,GAxCU;EAyCX+0B,EAAAA,QAzCW,oBAyCF/0B,GAzCE,EAyCG;EACZA,IAAAA,GAAG,CAAC1O,IAAJ,CAAS,eAAT,EAA0B,KAA1B;EACA,WAAO0O,GAAP;EACD,GA5CU;EA6CXg1B,EAAAA,iBA7CW,6BA6COhpC,CA7CP,EA6CU;EACnB,QAAIA,CAAC,CAACg1B,OAAF,KAAc,EAAd,IAAoBh1B,CAAC,CAACg1B,OAAF,KAAc,EAAtC,EAA0C;EAC1C,QAAMpjB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAck2B,IAA7B;EACA,QAAMlkB,SAAS,GAAGzhB,CAAC,CAACtD,CAAC,CAACjF,MAAH,CAAnB;;EACA,QAAI6W,MAAM,CAACwZ,UAAP,IAAqBxZ,MAAM,CAACwZ,UAAP,CAAkBiP,OAAvC,IAAkDtV,SAAS,CAACpe,EAAV,CAAaiL,MAAM,CAACwZ,UAAP,CAAkBiP,OAA/B,CAAtD,EAA+F;EAC7F,UAAI,EAAEzoB,MAAM,CAACsL,KAAP,IAAgB,CAACtL,MAAM,CAACmB,MAAP,CAAc+K,IAAjC,CAAJ,EAA4C;EAC1ClM,QAAAA,MAAM,CAAC8P,SAAP;EACD;;EACD,UAAI9P,MAAM,CAACsL,KAAX,EAAkB;EAChBtL,QAAAA,MAAM,CAACq3B,IAAP,CAAYC,MAAZ,CAAmBn2B,MAAM,CAACo2B,gBAA1B;EACD,OAFD,MAEO;EACLv3B,QAAAA,MAAM,CAACq3B,IAAP,CAAYC,MAAZ,CAAmBn2B,MAAM,CAACq2B,gBAA1B;EACD;EACF;;EACD,QAAIx3B,MAAM,CAACwZ,UAAP,IAAqBxZ,MAAM,CAACwZ,UAAP,CAAkBkP,OAAvC,IAAkDvV,SAAS,CAACpe,EAAV,CAAaiL,MAAM,CAACwZ,UAAP,CAAkBkP,OAA/B,CAAtD,EAA+F;EAC7F,UAAI,EAAE1oB,MAAM,CAACqL,WAAP,IAAsB,CAACrL,MAAM,CAACmB,MAAP,CAAc+K,IAAvC,CAAJ,EAAkD;EAChDlM,QAAAA,MAAM,CAACmQ,SAAP;EACD;;EACD,UAAInQ,MAAM,CAACqL,WAAX,EAAwB;EACtBrL,QAAAA,MAAM,CAACq3B,IAAP,CAAYC,MAAZ,CAAmBn2B,MAAM,CAACs2B,iBAA1B;EACD,OAFD,MAEO;EACLz3B,QAAAA,MAAM,CAACq3B,IAAP,CAAYC,MAAZ,CAAmBn2B,MAAM,CAACu2B,gBAA1B;EACD;EACF;;EACD,QACE13B,MAAM,CAACopB,UAAP,IACAjW,SAAS,CAACpe,EAAV,OAAiBiL,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBsC,WAAzB,CAAqC9vB,OAArC,CAA6C,IAA7C,EAAmD,GAAnD,CAAjB,CAFF,EAGE;EACAuX,MAAAA,SAAS,CAAC,CAAD,CAAT,CAAa+V,KAAb;EACD;EACF,GA5EU;EA6EXoO,EAAAA,MA7EW,kBA6EJK,OA7EI,EA6EK;EACd,QAAM33B,MAAM,GAAG,IAAf;EACA,QAAM43B,YAAY,GAAG53B,MAAM,CAACq3B,IAAP,CAAYQ,UAAjC;EACA,QAAID,YAAY,CAACpuC,MAAb,KAAwB,CAA5B,EAA+B;EAC/BouC,IAAAA,YAAY,CAACjmC,IAAb,CAAkB,EAAlB;EACAimC,IAAAA,YAAY,CAACjmC,IAAb,CAAkBgmC,OAAlB;EACD,GAnFU;EAoFXG,EAAAA,gBApFW,8BAoFQ;EACjB,QAAM93B,MAAM,GAAG,IAAf;EAEA,QAAIA,MAAM,CAACmB,MAAP,CAAc+K,IAAd,IAAsB,CAAClM,MAAM,CAACwZ,UAAlC,EAA8C;EAH7B,6BAIYxZ,MAAM,CAACwZ,UAJnB;EAAA,QAITiP,OAJS,sBAITA,OAJS;EAAA,QAIAC,OAJA,sBAIAA,OAJA;;EAMjB,QAAIA,OAAO,IAAIA,OAAO,CAACl/B,MAAR,GAAiB,CAAhC,EAAmC;EACjC,UAAIwW,MAAM,CAACqL,WAAX,EAAwB;EACtBrL,QAAAA,MAAM,CAACq3B,IAAP,CAAYH,SAAZ,CAAsBxO,OAAtB;EACA1oB,QAAAA,MAAM,CAACq3B,IAAP,CAAYd,kBAAZ,CAA+B7N,OAA/B;EACD,OAHD,MAGO;EACL1oB,QAAAA,MAAM,CAACq3B,IAAP,CAAYF,QAAZ,CAAqBzO,OAArB;EACA1oB,QAAAA,MAAM,CAACq3B,IAAP,CAAYf,eAAZ,CAA4B5N,OAA5B;EACD;EACF;;EACD,QAAID,OAAO,IAAIA,OAAO,CAACj/B,MAAR,GAAiB,CAAhC,EAAmC;EACjC,UAAIwW,MAAM,CAACsL,KAAX,EAAkB;EAChBtL,QAAAA,MAAM,CAACq3B,IAAP,CAAYH,SAAZ,CAAsBzO,OAAtB;EACAzoB,QAAAA,MAAM,CAACq3B,IAAP,CAAYd,kBAAZ,CAA+B9N,OAA/B;EACD,OAHD,MAGO;EACLzoB,QAAAA,MAAM,CAACq3B,IAAP,CAAYF,QAAZ,CAAqB1O,OAArB;EACAzoB,QAAAA,MAAM,CAACq3B,IAAP,CAAYf,eAAZ,CAA4B7N,OAA5B;EACD;EACF;EACF,GA5GU;EA6GXsP,EAAAA,gBA7GW,8BA6GQ;EACjB,QAAM/3B,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAck2B,IAA7B;;EACA,QACEr3B,MAAM,CAACopB,UAAP,IACAppB,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBC,SADzB,IAEArpB,MAAM,CAACopB,UAAP,CAAkBO,OAFlB,IAGA3pB,MAAM,CAACopB,UAAP,CAAkBO,OAAlB,CAA0BngC,MAJ5B,EAKE;EACAwW,MAAAA,MAAM,CAACopB,UAAP,CAAkBO,OAAlB,CAA0BrxB,IAA1B,CAA+B,UAAC0/B,QAAD,EAAc;EAC3C,YAAMC,SAAS,GAAGvmC,CAAC,CAACsmC,QAAD,CAAnB;EACAh4B,QAAAA,MAAM,CAACq3B,IAAP,CAAYf,eAAZ,CAA4B2B,SAA5B;;EACA,YAAI,CAACj4B,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBqC,YAA9B,EAA4C;EAC1CzrB,UAAAA,MAAM,CAACq3B,IAAP,CAAYb,SAAZ,CAAsByB,SAAtB,EAAiC,QAAjC;EACAj4B,UAAAA,MAAM,CAACq3B,IAAP,CAAYP,UAAZ,CACEmB,SADF,EAEE92B,MAAM,CAAC+2B,uBAAP,CAA+Bt8B,OAA/B,CAAuC,eAAvC,EAAwDq8B,SAAS,CAAC1/B,KAAV,KAAoB,CAA5E,CAFF;EAID;EACF,OAVD;EAWD;EACF,GAlIU;EAmIX2I,EAAAA,IAnIW,kBAmIJ;EACL,QAAMlB,MAAM,GAAG,IAAf;EACA,QAAMmB,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAck2B,IAA7B;EAEAr3B,IAAAA,MAAM,CAACoC,GAAP,CAAWjJ,MAAX,CAAkB6G,MAAM,CAACq3B,IAAP,CAAYQ,UAA9B,EAJK;;EAOL,QAAMM,YAAY,GAAGn4B,MAAM,CAACoC,GAA5B;;EACA,QAAIjB,MAAM,CAACi3B,+BAAX,EAA4C;EAC1Cp4B,MAAAA,MAAM,CAACq3B,IAAP,CAAYX,oBAAZ,CAAiCyB,YAAjC,EAA+Ch3B,MAAM,CAACi3B,+BAAtD;EACD;;EACD,QAAIj3B,MAAM,CAACk3B,gBAAX,EAA6B;EAC3Br4B,MAAAA,MAAM,CAACq3B,IAAP,CAAYP,UAAZ,CAAuBqB,YAAvB,EAAqCh3B,MAAM,CAACk3B,gBAA5C;EACD,KAbI;;;EAgBL,QAAM/1B,UAAU,GAAGtC,MAAM,CAACsC,UAA1B;EACA,QAAMg2B,SAAS,GAAGh2B,UAAU,CAAC5O,IAAX,CAAgB,IAAhB,yBAA2CsM,MAAM,CAACq3B,IAAP,CAAYpB,eAAZ,CAA4B,EAA5B,CAA7D;EACA,QAAIgB,IAAJ;EACAj3B,IAAAA,MAAM,CAACq3B,IAAP,CAAYN,OAAZ,CAAoBz0B,UAApB,EAAgCg2B,SAAhC;;EAEA,QAAIt4B,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,IAA0B9Z,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB7U,OAArD,EAA8D;EAC5DgyB,MAAAA,IAAI,GAAG,KAAP;EACD,KAFD,MAEO;EACLA,MAAAA,IAAI,GAAG,QAAP;EACD;;EACDj3B,IAAAA,MAAM,CAACq3B,IAAP,CAAYL,SAAZ,CAAsB10B,UAAtB,EAAkC20B,IAAlC,EA1BK;;EA6BL,QAAI91B,MAAM,CAACo3B,0BAAX,EAAuC;EACrCv4B,MAAAA,MAAM,CAACq3B,IAAP,CAAYX,oBAAZ,CAAiChlC,CAAC,CAACsO,MAAM,CAACmF,MAAR,CAAlC,EAAmDhE,MAAM,CAACo3B,0BAA1D;EACD;;EACDv4B,IAAAA,MAAM,CAACq3B,IAAP,CAAYb,SAAZ,CAAsB9kC,CAAC,CAACsO,MAAM,CAACmF,MAAR,CAAvB,EAAwC,OAAxC;EACAnF,IAAAA,MAAM,CAACmF,MAAP,CAAc7M,IAAd,CAAmB,UAACoN,OAAD,EAAa;EAC9B,UAAM+c,QAAQ,GAAG/wB,CAAC,CAACgU,OAAD,CAAlB;EACA,UAAM8yB,gBAAgB,GAAGr3B,MAAM,CAACs3B,iBAAP,CACtB78B,OADsB,CACd,eADc,EACG6mB,QAAQ,CAAClqB,KAAT,KAAmB,CADtB,EAEtBqD,OAFsB,CAEd,sBAFc,EAEUoE,MAAM,CAACmF,MAAP,CAAc3b,MAFxB,CAAzB;EAGAwW,MAAAA,MAAM,CAACq3B,IAAP,CAAYP,UAAZ,CAAuBrU,QAAvB,EAAiC+V,gBAAjC;EACD,KAND,EAjCK;;EA0CL,QAAI/P,OAAJ;EACA,QAAIC,OAAJ;;EACA,QAAI1oB,MAAM,CAACwZ,UAAP,IAAqBxZ,MAAM,CAACwZ,UAAP,CAAkBiP,OAA3C,EAAoD;EAClDA,MAAAA,OAAO,GAAGzoB,MAAM,CAACwZ,UAAP,CAAkBiP,OAA5B;EACD;;EACD,QAAIzoB,MAAM,CAACwZ,UAAP,IAAqBxZ,MAAM,CAACwZ,UAAP,CAAkBkP,OAA3C,EAAoD;EAClDA,MAAAA,OAAO,GAAG1oB,MAAM,CAACwZ,UAAP,CAAkBkP,OAA5B;EACD;;EAED,QAAID,OAAO,IAAIA,OAAO,CAACj/B,MAAvB,EAA+B;EAC7BwW,MAAAA,MAAM,CAACq3B,IAAP,CAAYf,eAAZ,CAA4B7N,OAA5B;;EACA,UAAIA,OAAO,CAAC,CAAD,CAAP,CAAWD,OAAX,KAAuB,QAA3B,EAAqC;EACnCxoB,QAAAA,MAAM,CAACq3B,IAAP,CAAYb,SAAZ,CAAsB/N,OAAtB,EAA+B,QAA/B;EACAA,QAAAA,OAAO,CAACr0B,EAAR,CAAW,SAAX,EAAsB4L,MAAM,CAACq3B,IAAP,CAAYD,iBAAlC;EACD;;EACDp3B,MAAAA,MAAM,CAACq3B,IAAP,CAAYP,UAAZ,CAAuBrO,OAAvB,EAAgCtnB,MAAM,CAACq2B,gBAAvC;EACAx3B,MAAAA,MAAM,CAACq3B,IAAP,CAAYT,aAAZ,CAA0BnO,OAA1B,EAAmC6P,SAAnC;EACD;;EACD,QAAI5P,OAAO,IAAIA,OAAO,CAACl/B,MAAvB,EAA+B;EAC7BwW,MAAAA,MAAM,CAACq3B,IAAP,CAAYf,eAAZ,CAA4B5N,OAA5B;;EACA,UAAIA,OAAO,CAAC,CAAD,CAAP,CAAWF,OAAX,KAAuB,QAA3B,EAAqC;EACnCxoB,QAAAA,MAAM,CAACq3B,IAAP,CAAYb,SAAZ,CAAsB9N,OAAtB,EAA+B,QAA/B;EACAA,QAAAA,OAAO,CAACt0B,EAAR,CAAW,SAAX,EAAsB4L,MAAM,CAACq3B,IAAP,CAAYD,iBAAlC;EACD;;EACDp3B,MAAAA,MAAM,CAACq3B,IAAP,CAAYP,UAAZ,CAAuBpO,OAAvB,EAAgCvnB,MAAM,CAACu2B,gBAAvC;EACA13B,MAAAA,MAAM,CAACq3B,IAAP,CAAYT,aAAZ,CAA0BlO,OAA1B,EAAmC4P,SAAnC;EACD,KApEI;;;EAuEL,QACEt4B,MAAM,CAACopB,UAAP,IACAppB,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBC,SADzB,IAEArpB,MAAM,CAACopB,UAAP,CAAkBO,OAFlB,IAGA3pB,MAAM,CAACopB,UAAP,CAAkBO,OAAlB,CAA0BngC,MAJ5B,EAKE;EACAwW,MAAAA,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsBhO,EAAtB,CACE,SADF,QAEM4L,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBsC,WAAzB,CAAqC9vB,OAArC,CAA6C,IAA7C,EAAmD,GAAnD,CAFN,EAGEoE,MAAM,CAACq3B,IAAP,CAAYD,iBAHd;EAKD;EACF,GAtNU;EAuNX/1B,EAAAA,OAvNW,qBAuND;EACR,QAAMrB,MAAM,GAAG,IAAf;EACA,QAAIA,MAAM,CAACq3B,IAAP,CAAYQ,UAAZ,IAA0B73B,MAAM,CAACq3B,IAAP,CAAYQ,UAAZ,CAAuBruC,MAAvB,GAAgC,CAA9D,EACEwW,MAAM,CAACq3B,IAAP,CAAYQ,UAAZ,CAAuB7kC,MAAvB;EAEF,QAAIy1B,OAAJ;EACA,QAAIC,OAAJ;;EACA,QAAI1oB,MAAM,CAACwZ,UAAP,IAAqBxZ,MAAM,CAACwZ,UAAP,CAAkBiP,OAA3C,EAAoD;EAClDA,MAAAA,OAAO,GAAGzoB,MAAM,CAACwZ,UAAP,CAAkBiP,OAA5B;EACD;;EACD,QAAIzoB,MAAM,CAACwZ,UAAP,IAAqBxZ,MAAM,CAACwZ,UAAP,CAAkBkP,OAA3C,EAAoD;EAClDA,MAAAA,OAAO,GAAG1oB,MAAM,CAACwZ,UAAP,CAAkBkP,OAA5B;EACD;;EACD,QAAID,OAAJ,EAAa;EACXA,MAAAA,OAAO,CAAC9yB,GAAR,CAAY,SAAZ,EAAuBqK,MAAM,CAACq3B,IAAP,CAAYD,iBAAnC;EACD;;EACD,QAAI1O,OAAJ,EAAa;EACXA,MAAAA,OAAO,CAAC/yB,GAAR,CAAY,SAAZ,EAAuBqK,MAAM,CAACq3B,IAAP,CAAYD,iBAAnC;EACD,KAlBO;;;EAqBR,QACEp3B,MAAM,CAACopB,UAAP,IACAppB,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBC,SADzB,IAEArpB,MAAM,CAACopB,UAAP,CAAkBO,OAFlB,IAGA3pB,MAAM,CAACopB,UAAP,CAAkBO,OAAlB,CAA0BngC,MAJ5B,EAKE;EACAwW,MAAAA,MAAM,CAACopB,UAAP,CAAkBhnB,GAAlB,CAAsBzM,GAAtB,CACE,SADF,QAEMqK,MAAM,CAACmB,MAAP,CAAcioB,UAAd,CAAyBsC,WAAzB,CAAqC9vB,OAArC,CAA6C,IAA7C,EAAmD,GAAnD,CAFN,EAGEoE,MAAM,CAACq3B,IAAP,CAAYD,iBAHd;EAKD;EACF;EAxPU,CAAb;AA0PA,eAAe;EACbr3B,EAAAA,IAAI,EAAE,MADO;EAEboB,EAAAA,MAAM,EAAE;EACNk2B,IAAAA,IAAI,EAAE;EACJpyB,MAAAA,OAAO,EAAE,IADL;EAEJyzB,MAAAA,iBAAiB,EAAE,qBAFf;EAGJhB,MAAAA,gBAAgB,EAAE,gBAHd;EAIJF,MAAAA,gBAAgB,EAAE,YAJd;EAKJC,MAAAA,iBAAiB,EAAE,yBALf;EAMJF,MAAAA,gBAAgB,EAAE,wBANd;EAOJW,MAAAA,uBAAuB,EAAE,uBAPrB;EAQJO,MAAAA,iBAAiB,EAAE,8BARf;EASJJ,MAAAA,gBAAgB,EAAE,IATd;EAUJD,MAAAA,+BAA+B,EAAE,IAV7B;EAWJG,MAAAA,0BAA0B,EAAE;EAXxB;EADA,GAFK;EAiBblrC,EAAAA,MAjBa,oBAiBJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBq3B,MAAAA,IAAI,eACCrB,IADD;EAEF6B,QAAAA,UAAU,EAAEnmC,CAAC,oBACKsO,MAAM,CAACmB,MAAP,CAAck2B,IAAd,CAAmBqB,iBADxB;EAFX;EADoB,KAAT,CAAjB;EAQD,GA3BY;EA4BbtkC,EAAAA,EAAE,EAAE;EACFukC,IAAAA,SADE,qBACQ34B,MADR,EACgB;EAChB,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAck2B,IAAd,CAAmBpyB,OAAxB,EAAiC;EACjCjF,MAAAA,MAAM,CAACq3B,IAAP,CAAYn2B,IAAZ;EACAlB,MAAAA,MAAM,CAACq3B,IAAP,CAAYS,gBAAZ;EACD,KALC;EAMF9O,IAAAA,MANE,kBAMKhpB,MANL,EAMa;EACb,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAck2B,IAAd,CAAmBpyB,OAAxB,EAAiC;EACjCjF,MAAAA,MAAM,CAACq3B,IAAP,CAAYS,gBAAZ;EACD,KATC;EAUF7O,IAAAA,QAVE,oBAUOjpB,MAVP,EAUe;EACf,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAck2B,IAAd,CAAmBpyB,OAAxB,EAAiC;EACjCjF,MAAAA,MAAM,CAACq3B,IAAP,CAAYS,gBAAZ;EACD,KAbC;EAcFc,IAAAA,gBAdE,4BAce54B,MAdf,EAcuB;EACvB,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAck2B,IAAd,CAAmBpyB,OAAxB,EAAiC;EACjCjF,MAAAA,MAAM,CAACq3B,IAAP,CAAYU,gBAAZ;EACD,KAjBC;EAkBF12B,IAAAA,OAlBE,mBAkBMrB,MAlBN,EAkBc;EACd,UAAI,CAACA,MAAM,CAACmB,MAAP,CAAck2B,IAAd,CAAmBpyB,OAAxB,EAAiC;EACjCjF,MAAAA,MAAM,CAACq3B,IAAP,CAAYh2B,OAAZ;EACD;EArBC;EA5BS,CAAf;;EC1PA,IAAMw3B,OAAO,GAAG;EACd33B,EAAAA,IADc,kBACP;EACL,QAAMlB,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAI,CAACkT,MAAM,CAACmB,MAAP,CAAcvV,OAAnB,EAA4B;;EAC5B,QAAI,CAACoB,MAAM,CAACpB,OAAR,IAAmB,CAACoB,MAAM,CAACpB,OAAP,CAAeE,SAAvC,EAAkD;EAChDkU,MAAAA,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBqZ,OAAtB,GAAgC,KAAhC;EACAjF,MAAAA,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6B7zB,OAA7B,GAAuC,IAAvC;EACA;EACD;;EACD,QAAMrZ,OAAO,GAAGoU,MAAM,CAACpU,OAAvB;EACAA,IAAAA,OAAO,CAACwU,WAAR,GAAsB,IAAtB;EACAxU,IAAAA,OAAO,CAACmtC,KAAR,GAAgBF,OAAO,CAACG,aAAR,CAAsBh5B,MAAM,CAACmB,MAAP,CAAcod,GAApC,CAAhB;EACA,QAAI,CAAC3yB,OAAO,CAACmtC,KAAR,CAAcxvC,GAAf,IAAsB,CAACqC,OAAO,CAACmtC,KAAR,CAAclpC,KAAzC,EAAgD;EAChDjE,IAAAA,OAAO,CAACqtC,aAAR,CAAsB,CAAtB,EAAyBrtC,OAAO,CAACmtC,KAAR,CAAclpC,KAAvC,EAA8CmQ,MAAM,CAACmB,MAAP,CAAc2L,kBAA5D;;EACA,QAAI,CAAC9M,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBC,YAA3B,EAAyC;EACvCmB,MAAAA,MAAM,CAACrD,gBAAP,CAAwB,UAAxB,EAAoCqW,MAAM,CAACpU,OAAP,CAAestC,kBAAnD;EACD;EACF,GAlBa;EAmBd73B,EAAAA,OAnBc,qBAmBJ;EACR,QAAMrB,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;;EACA,QAAI,CAACkT,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBC,YAA3B,EAAyC;EACvCmB,MAAAA,MAAM,CAACpD,mBAAP,CAA2B,UAA3B,EAAuCoW,MAAM,CAACpU,OAAP,CAAestC,kBAAtD;EACD;EACF,GAzBa;EA0BdA,EAAAA,kBA1Bc,gCA0BO;EACnB,QAAMl5B,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAACpU,OAAP,CAAemtC,KAAf,GAAuBF,OAAO,CAACG,aAAR,CAAsBh5B,MAAM,CAACmB,MAAP,CAAcod,GAApC,CAAvB;EACAve,IAAAA,MAAM,CAACpU,OAAP,CAAeqtC,aAAf,CAA6Bj5B,MAAM,CAACmB,MAAP,CAAc0I,KAA3C,EAAkD7J,MAAM,CAACpU,OAAP,CAAemtC,KAAf,CAAqBlpC,KAAvE,EAA8E,KAA9E;EACD,GA9Ba;EA+BdmpC,EAAAA,aA/Bc,yBA+BAG,WA/BA,EA+Ba;EACzB,QAAMnsC,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAIjC,QAAJ;;EACA,QAAIsuC,WAAJ,EAAiB;EACftuC,MAAAA,QAAQ,GAAG,IAAIuuC,GAAJ,CAAQD,WAAR,CAAX;EACD,KAFD,MAEO;EACLtuC,MAAAA,QAAQ,GAAGmC,MAAM,CAACnC,QAAlB;EACD;;EACD,QAAMwuC,SAAS,GAAGxuC,QAAQ,CAACM,QAAT,CACfiR,KADe,CACT,CADS,EAEf5J,KAFe,CAET,GAFS,EAGfrB,MAHe,CAGR,UAACmoC,IAAD;EAAA,aAAUA,IAAI,KAAK,EAAnB;EAAA,KAHQ,CAAlB;EAIA,QAAM7P,KAAK,GAAG4P,SAAS,CAAC7vC,MAAxB;EACA,QAAMD,GAAG,GAAG8vC,SAAS,CAAC5P,KAAK,GAAG,CAAT,CAArB;EACA,QAAM55B,KAAK,GAAGwpC,SAAS,CAAC5P,KAAK,GAAG,CAAT,CAAvB;EACA,WAAO;EAAElgC,MAAAA,GAAG,EAAHA,GAAF;EAAOsG,MAAAA,KAAK,EAALA;EAAP,KAAP;EACD,GA/Ca;EAgDd0pC,EAAAA,UAhDc,sBAgDHhwC,GAhDG,EAgDEgP,KAhDF,EAgDS;EACrB,QAAMyH,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAI,CAACkT,MAAM,CAACpU,OAAP,CAAewU,WAAhB,IAA+B,CAACJ,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBqZ,OAA1D,EAAmE;EACnE,QAAIpa,QAAJ;;EACA,QAAImV,MAAM,CAACmB,MAAP,CAAcod,GAAlB,EAAuB;EACrB1zB,MAAAA,QAAQ,GAAG,IAAIuuC,GAAJ,CAAQp5B,MAAM,CAACmB,MAAP,CAAcod,GAAtB,CAAX;EACD,KAFD,MAEO;EACL1zB,MAAAA,QAAQ,GAAGmC,MAAM,CAACnC,QAAlB;EACD;;EACD,QAAMyc,KAAK,GAAGtH,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiBV,KAAjB,CAAd;EACA,QAAI1I,KAAK,GAAGgpC,OAAO,CAACW,OAAR,CAAgBlyB,KAAK,CAAC5T,IAAN,CAAW,cAAX,CAAhB,CAAZ;;EACA,QAAI,CAAC7I,QAAQ,CAACM,QAAT,CAAkBsuC,QAAlB,CAA2BlwC,GAA3B,CAAL,EAAsC;EACpCsG,MAAAA,KAAK,GAAMtG,GAAN,SAAasG,KAAlB;EACD;;EACD,QAAM6pC,YAAY,GAAG1sC,MAAM,CAACpB,OAAP,CAAe+tC,KAApC;;EACA,QAAID,YAAY,IAAIA,YAAY,CAAC7pC,KAAb,KAAuBA,KAA3C,EAAkD;EAChD;EACD;;EACD,QAAImQ,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBC,YAA1B,EAAwC;EACtCmB,MAAAA,MAAM,CAACpB,OAAP,CAAeC,YAAf,CAA4B;EAAEgE,QAAAA,KAAK,EAALA;EAAF,OAA5B,EAAuC,IAAvC,EAA6CA,KAA7C;EACD,KAFD,MAEO;EACL7C,MAAAA,MAAM,CAACpB,OAAP,CAAeE,SAAf,CAAyB;EAAE+D,QAAAA,KAAK,EAALA;EAAF,OAAzB,EAAoC,IAApC,EAA0CA,KAA1C;EACD;EACF,GAxEa;EAyEd2pC,EAAAA,OAzEc,mBAyEN/gC,IAzEM,EAyEA;EACZ,WAAOA,IAAI,CACRvK,QADI,GAEJ0N,OAFI,CAEI,MAFJ,EAEY,GAFZ,EAGJA,OAHI,CAGI,UAHJ,EAGgB,EAHhB,EAIJA,OAJI,CAII,MAJJ,EAIY,GAJZ,EAKJA,OALI,CAKI,KALJ,EAKW,EALX,EAMJA,OANI,CAMI,KANJ,EAMW,EANX,CAAP;EAOD,GAjFa;EAkFdq9B,EAAAA,aAlFc,yBAkFApvB,KAlFA,EAkFOha,KAlFP,EAkFcme,YAlFd,EAkF4B;EACxC,QAAMhO,MAAM,GAAG,IAAf;;EACA,QAAInQ,KAAJ,EAAW;EACT,WAAK,IAAIyB,CAAC,GAAG,CAAR,EAAW9H,MAAM,GAAGwW,MAAM,CAACmF,MAAP,CAAc3b,MAAvC,EAA+C8H,CAAC,GAAG9H,MAAnD,EAA2D8H,CAAC,IAAI,CAAhE,EAAmE;EACjE,YAAMgW,KAAK,GAAGtH,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB3H,CAAjB,CAAd;EACA,YAAMsoC,YAAY,GAAGf,OAAO,CAACW,OAAR,CAAgBlyB,KAAK,CAAC5T,IAAN,CAAW,cAAX,CAAhB,CAArB;;EACA,YAAIkmC,YAAY,KAAK/pC,KAAjB,IAA0B,CAACyX,KAAK,CAAChU,QAAN,CAAe0M,MAAM,CAACmB,MAAP,CAAcgL,mBAA7B,CAA/B,EAAkF;EAChF,cAAM5T,KAAK,GAAG+O,KAAK,CAAC/O,KAAN,EAAd;EACAyH,UAAAA,MAAM,CAAC6O,OAAP,CAAetW,KAAf,EAAsBsR,KAAtB,EAA6BmE,YAA7B;EACD;EACF;EACF,KATD,MASO;EACLhO,MAAAA,MAAM,CAAC6O,OAAP,CAAe,CAAf,EAAkBhF,KAAlB,EAAyBmE,YAAzB;EACD;EACF;EAhGa,CAAhB;AAmGA,kBAAe;EACbjO,EAAAA,IAAI,EAAE,SADO;EAEboB,EAAAA,MAAM,EAAE;EACNvV,IAAAA,OAAO,EAAE;EACPqZ,MAAAA,OAAO,EAAE,KADF;EAEPpZ,MAAAA,YAAY,EAAE,KAFP;EAGPtC,MAAAA,GAAG,EAAE;EAHE;EADH,GAFK;EASb8D,EAAAA,MATa,oBASJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBpU,MAAAA,OAAO,eACFitC,OADE;EADiB,KAAT,CAAjB;EAKD,GAhBY;EAiBbzkC,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACX,UAAIA,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBqZ,OAA1B,EAAmC;EACjCjF,QAAAA,MAAM,CAACpU,OAAP,CAAesV,IAAf;EACD;EACF,KALC;EAMFG,IAAAA,OANE,mBAMMrB,MANN,EAMc;EACd,UAAIA,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBqZ,OAA1B,EAAmC;EACjCjF,QAAAA,MAAM,CAACpU,OAAP,CAAeyV,OAAf;EACD;EACF,KAVC;EAWFzK,IAAAA,aAXE,yBAWYoJ,MAXZ,EAWoB;EACpB,UAAIA,MAAM,CAACpU,OAAP,CAAewU,WAAnB,EAAgC;EAC9BJ,QAAAA,MAAM,CAACpU,OAAP,CAAe2tC,UAAf,CAA0Bv5B,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBrC,GAAhD,EAAqDyW,MAAM,CAACiK,WAA5D;EACD;EACF,KAfC;EAgBF2oB,IAAAA,WAhBE,uBAgBU5yB,MAhBV,EAgBkB;EAClB,UAAIA,MAAM,CAACpU,OAAP,CAAewU,WAAf,IAA8BJ,MAAM,CAACmB,MAAP,CAAcyE,OAAhD,EAAyD;EACvD5F,QAAAA,MAAM,CAACpU,OAAP,CAAe2tC,UAAf,CAA0Bv5B,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBrC,GAAhD,EAAqDyW,MAAM,CAACiK,WAA5D;EACD;EACF;EApBC;EAjBS,CAAf;;EClGA,IAAM4vB,cAAc,GAAG;EACrBC,EAAAA,WADqB,yBACP;EACZ,QAAM95B,MAAM,GAAG,IAAf;EACA,QAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EACA0U,IAAAA,MAAM,CAACgB,IAAP,CAAY,YAAZ;EACA,QAAM+4B,OAAO,GAAGvuC,QAAQ,CAACX,QAAT,CAAkBC,IAAlB,CAAuB8Q,OAAvB,CAA+B,GAA/B,EAAoC,EAApC,CAAhB;EACA,QAAMo+B,eAAe,GAAGh6B,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,EAAqCvW,IAArC,CAA0C,WAA1C,CAAxB;;EACA,QAAIqmC,OAAO,KAAKC,eAAhB,EAAiC;EAC/B,UAAMpqB,QAAQ,GAAG5P,MAAM,CAACsC,UAAP,CACdhY,QADc,OACD0V,MAAM,CAACmB,MAAP,CAAciE,UADb,qBACsC20B,OADtC,UAEdxhC,KAFc,EAAjB;EAGA,UAAI,OAAOqX,QAAP,KAAoB,WAAxB,EAAqC;EACrC5P,MAAAA,MAAM,CAAC6O,OAAP,CAAee,QAAf;EACD;EACF,GAdoB;EAerBqqB,EAAAA,OAfqB,qBAeX;EACR,QAAMj6B,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;EACA,QAAMtB,QAAQ,GAAGF,WAAW,EAA5B;EACA,QAAI,CAAC0U,MAAM,CAAC84B,cAAP,CAAsB14B,WAAvB,IAAsC,CAACJ,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6B7zB,OAAxE,EAAiF;;EACjF,QACEjF,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6BjtC,YAA7B,IACAmB,MAAM,CAACpB,OADP,IAEAoB,MAAM,CAACpB,OAAP,CAAeC,YAHjB,EAIE;EACAmB,MAAAA,MAAM,CAACpB,OAAP,CAAeC,YAAf,CACE,IADF,EAEE,IAFF,EAGE,MAAImU,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,EAAqCvW,IAArC,CAA0C,WAA1C,CAAJ,IAAgE,EAHlE;EAKAsM,MAAAA,MAAM,CAACgB,IAAP,CAAY,SAAZ;EACD,KAXD,MAWO;EACL,UAAMsG,KAAK,GAAGtH,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,CAAd;EACA,UAAMnf,IAAI,GAAGwc,KAAK,CAAC5T,IAAN,CAAW,WAAX,KAA2B4T,KAAK,CAAC5T,IAAN,CAAW,cAAX,CAAxC;EACAlI,MAAAA,QAAQ,CAACX,QAAT,CAAkBC,IAAlB,GAAyBA,IAAI,IAAI,EAAjC;EACAkV,MAAAA,MAAM,CAACgB,IAAP,CAAY,SAAZ;EACD;EACF,GArCoB;EAsCrBE,EAAAA,IAtCqB,kBAsCd;EACL,QAAMlB,MAAM,GAAG,IAAf;EACA,QAAMxU,QAAQ,GAAGF,WAAW,EAA5B;EACA,QAAM0B,MAAM,GAAGF,SAAS,EAAxB;EACA,QACE,CAACkT,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6B7zB,OAA9B,IACCjF,MAAM,CAACmB,MAAP,CAAcvV,OAAd,IAAyBoU,MAAM,CAACmB,MAAP,CAAcvV,OAAd,CAAsBqZ,OAFlD,EAIE;EACFjF,IAAAA,MAAM,CAAC84B,cAAP,CAAsB14B,WAAtB,GAAoC,IAApC;EACA,QAAMtV,IAAI,GAAGU,QAAQ,CAACX,QAAT,CAAkBC,IAAlB,CAAuB8Q,OAAvB,CAA+B,GAA/B,EAAoC,EAApC,CAAb;;EACA,QAAI9Q,IAAJ,EAAU;EACR,UAAM+e,KAAK,GAAG,CAAd;;EACA,WAAK,IAAIvY,CAAC,GAAG,CAAR,EAAW9H,MAAM,GAAGwW,MAAM,CAACmF,MAAP,CAAc3b,MAAvC,EAA+C8H,CAAC,GAAG9H,MAAnD,EAA2D8H,CAAC,IAAI,CAAhE,EAAmE;EACjE,YAAMgW,KAAK,GAAGtH,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB3H,CAAjB,CAAd;EACA,YAAM4oC,SAAS,GAAG5yB,KAAK,CAAC5T,IAAN,CAAW,WAAX,KAA2B4T,KAAK,CAAC5T,IAAN,CAAW,cAAX,CAA7C;;EACA,YAAIwmC,SAAS,KAAKpvC,IAAd,IAAsB,CAACwc,KAAK,CAAChU,QAAN,CAAe0M,MAAM,CAACmB,MAAP,CAAcgL,mBAA7B,CAA3B,EAA8E;EAC5E,cAAM5T,KAAK,GAAG+O,KAAK,CAAC/O,KAAN,EAAd;EACAyH,UAAAA,MAAM,CAAC6O,OAAP,CAAetW,KAAf,EAAsBsR,KAAtB,EAA6B7J,MAAM,CAACmB,MAAP,CAAc2L,kBAA3C,EAA+D,IAA/D;EACD;EACF;EACF;;EACD,QAAI9M,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6BqB,UAAjC,EAA6C;EAC3CzoC,MAAAA,CAAC,CAAC1E,MAAD,CAAD,CAAUoH,EAAV,CAAa,YAAb,EAA2B4L,MAAM,CAAC84B,cAAP,CAAsBgB,WAAjD;EACD;EACF,GA/DoB;EAgErBz4B,EAAAA,OAhEqB,qBAgEX;EACR,QAAMrB,MAAM,GAAG,IAAf;EACA,QAAMhT,MAAM,GAAGF,SAAS,EAAxB;;EACA,QAAIkT,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6BqB,UAAjC,EAA6C;EAC3CzoC,MAAAA,CAAC,CAAC1E,MAAD,CAAD,CAAU2I,GAAV,CAAc,YAAd,EAA4BqK,MAAM,CAAC84B,cAAP,CAAsBgB,WAAlD;EACD;EACF;EAtEoB,CAAvB;AAwEA,yBAAe;EACb/5B,EAAAA,IAAI,EAAE,iBADO;EAEboB,EAAAA,MAAM,EAAE;EACN23B,IAAAA,cAAc,EAAE;EACd7zB,MAAAA,OAAO,EAAE,KADK;EAEdpZ,MAAAA,YAAY,EAAE,KAFA;EAGdsuC,MAAAA,UAAU,EAAE;EAHE;EADV,GAFK;EASb9sC,EAAAA,MATa,oBASJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxB84B,MAAAA,cAAc;EACZ14B,QAAAA,WAAW,EAAE;EADD,SAETy5B,cAFS;EADU,KAAT,CAAjB;EAMD,GAjBY;EAkBbzlC,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACX,UAAIA,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6B7zB,OAAjC,EAA0C;EACxCjF,QAAAA,MAAM,CAAC84B,cAAP,CAAsB53B,IAAtB;EACD;EACF,KALC;EAMFG,IAAAA,OANE,mBAMMrB,MANN,EAMc;EACd,UAAIA,MAAM,CAACmB,MAAP,CAAc23B,cAAd,CAA6B7zB,OAAjC,EAA0C;EACxCjF,QAAAA,MAAM,CAAC84B,cAAP,CAAsBz3B,OAAtB;EACD;EACF,KAVC;EAWFzK,IAAAA,aAXE,yBAWYoJ,MAXZ,EAWoB;EACpB,UAAIA,MAAM,CAAC84B,cAAP,CAAsB14B,WAA1B,EAAuC;EACrCJ,QAAAA,MAAM,CAAC84B,cAAP,CAAsBmB,OAAtB;EACD;EACF,KAfC;EAgBFrH,IAAAA,WAhBE,uBAgBU5yB,MAhBV,EAgBkB;EAClB,UAAIA,MAAM,CAAC84B,cAAP,CAAsB14B,WAAtB,IAAqCJ,MAAM,CAACmB,MAAP,CAAcyE,OAAvD,EAAgE;EAC9D5F,QAAAA,MAAM,CAAC84B,cAAP,CAAsBmB,OAAtB;EACD;EACF;EApBC;EAlBS,CAAf;;ECxEA,IAAMG,QAAQ,GAAG;EACfngB,EAAAA,GADe,iBACT;EACJ,QAAMja,MAAM,GAAG,IAAf;EACA,QAAMq6B,cAAc,GAAGr6B,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB+G,MAAM,CAACiK,WAAxB,CAAvB;EACA,QAAIhP,KAAK,GAAG+E,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB7e,KAAnC;;EACA,QAAIo/B,cAAc,CAAC3mC,IAAf,CAAoB,sBAApB,CAAJ,EAAiD;EAC/CuH,MAAAA,KAAK,GAAGo/B,cAAc,CAAC3mC,IAAf,CAAoB,sBAApB,KAA+CsM,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB7e,KAA9E;EACD;;EACDzO,IAAAA,YAAY,CAACwT,MAAM,CAAC8Z,QAAP,CAAgB8N,OAAjB,CAAZ;EACA5nB,IAAAA,MAAM,CAAC8Z,QAAP,CAAgB8N,OAAhB,GAA0B5sB,QAAQ,CAAC,YAAM;EACvC,UAAIs/B,cAAJ;;EACA,UAAIt6B,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuBygB,gBAA3B,EAA6C;EAC3C,YAAIv6B,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtBlM,UAAAA,MAAM,CAACiQ,OAAP;EACAqqB,UAAAA,cAAc,GAAGt6B,MAAM,CAACmQ,SAAP,CAAiBnQ,MAAM,CAACmB,MAAP,CAAc0I,KAA/B,EAAsC,IAAtC,EAA4C,IAA5C,CAAjB;EACA7J,UAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ;EACD,SAJD,MAIO,IAAI,CAAChB,MAAM,CAACqL,WAAZ,EAAyB;EAC9BivB,UAAAA,cAAc,GAAGt6B,MAAM,CAACmQ,SAAP,CAAiBnQ,MAAM,CAACmB,MAAP,CAAc0I,KAA/B,EAAsC,IAAtC,EAA4C,IAA5C,CAAjB;EACA7J,UAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ;EACD,SAHM,MAGA,IAAI,CAAChB,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB0gB,eAA5B,EAA6C;EAClDF,UAAAA,cAAc,GAAGt6B,MAAM,CAAC6O,OAAP,CACf7O,MAAM,CAACmF,MAAP,CAAc3b,MAAd,GAAuB,CADR,EAEfwW,MAAM,CAACmB,MAAP,CAAc0I,KAFC,EAGf,IAHe,EAIf,IAJe,CAAjB;EAMA7J,UAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ;EACD,SARM,MAQA;EACLhB,UAAAA,MAAM,CAAC8Z,QAAP,CAAgBkO,IAAhB;EACD;EACF,OAnBD,MAmBO,IAAIhoB,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EAC7BlM,QAAAA,MAAM,CAACiQ,OAAP;EACAqqB,QAAAA,cAAc,GAAGt6B,MAAM,CAAC8P,SAAP,CAAiB9P,MAAM,CAACmB,MAAP,CAAc0I,KAA/B,EAAsC,IAAtC,EAA4C,IAA5C,CAAjB;EACA7J,QAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ;EACD,OAJM,MAIA,IAAI,CAAChB,MAAM,CAACsL,KAAZ,EAAmB;EACxBgvB,QAAAA,cAAc,GAAGt6B,MAAM,CAAC8P,SAAP,CAAiB9P,MAAM,CAACmB,MAAP,CAAc0I,KAA/B,EAAsC,IAAtC,EAA4C,IAA5C,CAAjB;EACA7J,QAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ;EACD,OAHM,MAGA,IAAI,CAAChB,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB0gB,eAA5B,EAA6C;EAClDF,QAAAA,cAAc,GAAGt6B,MAAM,CAAC6O,OAAP,CAAe,CAAf,EAAkB7O,MAAM,CAACmB,MAAP,CAAc0I,KAAhC,EAAuC,IAAvC,EAA6C,IAA7C,CAAjB;EACA7J,QAAAA,MAAM,CAACgB,IAAP,CAAY,UAAZ;EACD,OAHM,MAGA;EACLhB,QAAAA,MAAM,CAAC8Z,QAAP,CAAgBkO,IAAhB;EACD;;EACD,UAAIhoB,MAAM,CAACmB,MAAP,CAAcyE,OAAd,IAAyB5F,MAAM,CAAC8Z,QAAP,CAAgBC,OAA7C,EAAsD/Z,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB,GAAtD,KACK,IAAIqgB,cAAc,KAAK,KAAvB,EAA8B;EACjCt6B,QAAAA,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB;EACD;EACF,KAtCiC,EAsC/Bhf,KAtC+B,CAAlC;EAuCD,GAhDc;EAiDf0f,EAAAA,KAjDe,mBAiDP;EACN,QAAM3a,MAAM,GAAG,IAAf;EACA,QAAI,OAAOA,MAAM,CAAC8Z,QAAP,CAAgB8N,OAAvB,KAAmC,WAAvC,EAAoD,OAAO,KAAP;EACpD,QAAI5nB,MAAM,CAAC8Z,QAAP,CAAgBC,OAApB,EAA6B,OAAO,KAAP;EAC7B/Z,IAAAA,MAAM,CAAC8Z,QAAP,CAAgBC,OAAhB,GAA0B,IAA1B;EACA/Z,IAAAA,MAAM,CAACgB,IAAP,CAAY,eAAZ;EACAhB,IAAAA,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB;EACA,WAAO,IAAP;EACD,GAzDc;EA0Df+N,EAAAA,IA1De,kBA0DR;EACL,QAAMhoB,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAAC8Z,QAAP,CAAgBC,OAArB,EAA8B,OAAO,KAAP;EAC9B,QAAI,OAAO/Z,MAAM,CAAC8Z,QAAP,CAAgB8N,OAAvB,KAAmC,WAAvC,EAAoD,OAAO,KAAP;;EAEpD,QAAI5nB,MAAM,CAAC8Z,QAAP,CAAgB8N,OAApB,EAA6B;EAC3Bp7B,MAAAA,YAAY,CAACwT,MAAM,CAAC8Z,QAAP,CAAgB8N,OAAjB,CAAZ;EACA5nB,MAAAA,MAAM,CAAC8Z,QAAP,CAAgB8N,OAAhB,GAA0Br4B,SAA1B;EACD;;EACDyQ,IAAAA,MAAM,CAAC8Z,QAAP,CAAgBC,OAAhB,GAA0B,KAA1B;EACA/Z,IAAAA,MAAM,CAACgB,IAAP,CAAY,cAAZ;EACA,WAAO,IAAP;EACD,GAtEc;EAuEfy5B,EAAAA,KAvEe,iBAuET5wB,KAvES,EAuEF;EACX,QAAM7J,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAM,CAAC8Z,QAAP,CAAgBC,OAArB,EAA8B;EAC9B,QAAI/Z,MAAM,CAAC8Z,QAAP,CAAgBE,MAApB,EAA4B;EAC5B,QAAIha,MAAM,CAAC8Z,QAAP,CAAgB8N,OAApB,EAA6Bp7B,YAAY,CAACwT,MAAM,CAAC8Z,QAAP,CAAgB8N,OAAjB,CAAZ;EAC7B5nB,IAAAA,MAAM,CAAC8Z,QAAP,CAAgBE,MAAhB,GAAyB,IAAzB;;EACA,QAAInQ,KAAK,KAAK,CAAV,IAAe,CAAC7J,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB4gB,iBAA3C,EAA8D;EAC5D16B,MAAAA,MAAM,CAAC8Z,QAAP,CAAgBE,MAAhB,GAAyB,KAAzB;EACAha,MAAAA,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB;EACD,KAHD,MAGO;EACLja,MAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB3Y,gBAArB,CAAsC,eAAtC,EAAuDqW,MAAM,CAAC8Z,QAAP,CAAgBqX,eAAvE;EACAnxB,MAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB3Y,gBAArB,CAAsC,qBAAtC,EAA6DqW,MAAM,CAAC8Z,QAAP,CAAgBqX,eAA7E;EACD;EACF,GApFc;EAqFfwJ,EAAAA,kBArFe,gCAqFM;EACnB,QAAM36B,MAAM,GAAG,IAAf;EACA,QAAMxU,QAAQ,GAAGF,WAAW,EAA5B;;EACA,QAAIE,QAAQ,CAACovC,eAAT,KAA6B,QAA7B,IAAyC56B,MAAM,CAAC8Z,QAAP,CAAgBC,OAA7D,EAAsE;EACpE/Z,MAAAA,MAAM,CAAC8Z,QAAP,CAAgB2gB,KAAhB;EACD;;EACD,QAAIjvC,QAAQ,CAACovC,eAAT,KAA6B,SAA7B,IAA0C56B,MAAM,CAAC8Z,QAAP,CAAgBE,MAA9D,EAAsE;EACpEha,MAAAA,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB;EACAja,MAAAA,MAAM,CAAC8Z,QAAP,CAAgBE,MAAhB,GAAyB,KAAzB;EACD;EACF,GA/Fc;EAgGfmX,EAAAA,eAhGe,2BAgGC/iC,CAhGD,EAgGI;EACjB,QAAM4R,MAAM,GAAG,IAAf;EACA,QAAI,CAACA,MAAD,IAAWA,MAAM,CAACG,SAAlB,IAA+B,CAACH,MAAM,CAACsC,UAA3C,EAAuD;EACvD,QAAIlU,CAAC,CAACjF,MAAF,KAAa6W,MAAM,CAACsC,UAAP,CAAkB,CAAlB,CAAjB,EAAuC;EACvCtC,IAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1Y,mBAArB,CAAyC,eAAzC,EAA0DoW,MAAM,CAAC8Z,QAAP,CAAgBqX,eAA1E;EACAnxB,IAAAA,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1Y,mBAArB,CACE,qBADF,EAEEoW,MAAM,CAAC8Z,QAAP,CAAgBqX,eAFlB;EAIAnxB,IAAAA,MAAM,CAAC8Z,QAAP,CAAgBE,MAAhB,GAAyB,KAAzB;;EACA,QAAI,CAACha,MAAM,CAAC8Z,QAAP,CAAgBC,OAArB,EAA8B;EAC5B/Z,MAAAA,MAAM,CAAC8Z,QAAP,CAAgBkO,IAAhB;EACD,KAFD,MAEO;EACLhoB,MAAAA,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB;EACD;EACF;EA/Gc,CAAjB;AAkHA,mBAAe;EACbla,EAAAA,IAAI,EAAE,UADO;EAEboB,EAAAA,MAAM,EAAE;EACN2Y,IAAAA,QAAQ,EAAE;EACR7U,MAAAA,OAAO,EAAE,KADD;EAERhK,MAAAA,KAAK,EAAE,IAFC;EAGRy/B,MAAAA,iBAAiB,EAAE,IAHX;EAIRG,MAAAA,oBAAoB,EAAE,IAJd;EAKRL,MAAAA,eAAe,EAAE,KALT;EAMRD,MAAAA,gBAAgB,EAAE;EANV;EADJ,GAFK;EAYbltC,EAAAA,MAZa,oBAYJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxB8Z,MAAAA,QAAQ,eACHsgB,QADG;EAENrgB,QAAAA,OAAO,EAAE,KAFH;EAGNC,QAAAA,MAAM,EAAE;EAHF;EADgB,KAAT,CAAjB;EAOD,GArBY;EAsBb5lB,EAAAA,EAAE,EAAE;EACF8M,IAAAA,IADE,gBACGlB,MADH,EACW;EACX,UAAIA,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB7U,OAA3B,EAAoC;EAClCjF,QAAAA,MAAM,CAAC8Z,QAAP,CAAgBa,KAAhB;EACA,YAAMnvB,QAAQ,GAAGF,WAAW,EAA5B;EACAE,QAAAA,QAAQ,CAAC7B,gBAAT,CAA0B,kBAA1B,EAA8CqW,MAAM,CAAC8Z,QAAP,CAAgB6gB,kBAA9D;EACD;EACF,KAPC;EAQFG,IAAAA,qBARE,iCAQoB96B,MARpB,EAQ4B6J,KAR5B,EAQmCqE,QARnC,EAQ6C;EAC7C,UAAIlO,MAAM,CAAC8Z,QAAP,CAAgBC,OAApB,EAA6B;EAC3B,YAAI7L,QAAQ,IAAI,CAAClO,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB+gB,oBAAxC,EAA8D;EAC5D76B,UAAAA,MAAM,CAAC8Z,QAAP,CAAgB2gB,KAAhB,CAAsB5wB,KAAtB;EACD,SAFD,MAEO;EACL7J,UAAAA,MAAM,CAAC8Z,QAAP,CAAgBkO,IAAhB;EACD;EACF;EACF,KAhBC;EAiBF+S,IAAAA,eAjBE,2BAiBc/6B,MAjBd,EAiBsB;EACtB,UAAIA,MAAM,CAAC8Z,QAAP,CAAgBC,OAApB,EAA6B;EAC3B,YAAI/Z,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB+gB,oBAA3B,EAAiD;EAC/C76B,UAAAA,MAAM,CAAC8Z,QAAP,CAAgBkO,IAAhB;EACD,SAFD,MAEO;EACLhoB,UAAAA,MAAM,CAAC8Z,QAAP,CAAgB2gB,KAAhB;EACD;EACF;EACF,KAzBC;EA0BF/H,IAAAA,QA1BE,oBA0BO1yB,MA1BP,EA0Be;EACf,UACEA,MAAM,CAACmB,MAAP,CAAcyE,OAAd,IACA5F,MAAM,CAAC8Z,QAAP,CAAgBE,MADhB,IAEA,CAACha,MAAM,CAACmB,MAAP,CAAc2Y,QAAd,CAAuB+gB,oBAH1B,EAIE;EACA76B,QAAAA,MAAM,CAAC8Z,QAAP,CAAgBG,GAAhB;EACD;EACF,KAlCC;EAmCF5Y,IAAAA,OAnCE,mBAmCMrB,MAnCN,EAmCc;EACd,UAAIA,MAAM,CAAC8Z,QAAP,CAAgBC,OAApB,EAA6B;EAC3B/Z,QAAAA,MAAM,CAAC8Z,QAAP,CAAgBkO,IAAhB;EACD;;EACD,UAAMx8B,QAAQ,GAAGF,WAAW,EAA5B;EACAE,MAAAA,QAAQ,CAAC5B,mBAAT,CAA6B,kBAA7B,EAAiDoW,MAAM,CAAC8Z,QAAP,CAAgB6gB,kBAAjE;EACD;EAzCC;EAtBS,CAAf;;ECpHA,IAAMK,IAAI,GAAG;EACXztB,EAAAA,YADW,0BACI;EACb,QAAMvN,MAAM,GAAG,IAAf;EADa,QAELmF,MAFK,GAEMnF,MAFN,CAELmF,MAFK;;EAGb,SAAK,IAAI7T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,UAAMmxB,QAAQ,GAAGziB,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiB3H,CAAjB,CAAjB;EACA,UAAMkG,MAAM,GAAGirB,QAAQ,CAAC,CAAD,CAAR,CAAYvY,iBAA3B;EACA,UAAI+wB,EAAE,GAAG,CAACzjC,MAAV;EACA,UAAI,CAACwI,MAAM,CAACmB,MAAP,CAAckM,gBAAnB,EAAqC4tB,EAAE,IAAIj7B,MAAM,CAACsK,SAAb;EACrC,UAAI4wB,EAAE,GAAG,CAAT;;EACA,UAAI,CAACl7B,MAAM,CAAC+D,YAAP,EAAL,EAA4B;EAC1Bm3B,QAAAA,EAAE,GAAGD,EAAL;EACAA,QAAAA,EAAE,GAAG,CAAL;EACD;;EACD,UAAME,YAAY,GAAGn7B,MAAM,CAACmB,MAAP,CAAci6B,UAAd,CAAyBC,SAAzB,GACjBx0B,IAAI,CAACK,GAAL,CAAS,IAAIL,IAAI,CAAC4B,GAAL,CAASga,QAAQ,CAAC,CAAD,CAAR,CAAYzX,QAArB,CAAb,EAA6C,CAA7C,CADiB,GAEjB,IAAInE,IAAI,CAACiB,GAAL,CAASjB,IAAI,CAACK,GAAL,CAASub,QAAQ,CAAC,CAAD,CAAR,CAAYzX,QAArB,EAA+B,CAAC,CAAhC,CAAT,EAA6C,CAA7C,CAFR;EAGAyX,MAAAA,QAAQ,CACLtqB,GADH,CACO;EACH20B,QAAAA,OAAO,EAAEqO;EADN,OADP,EAIGnnC,SAJH,kBAI4BinC,EAJ5B,YAIqCC,EAJrC;EAKD;EACF,GAvBU;EAwBXnxB,EAAAA,aAxBW,yBAwBG7V,QAxBH,EAwBa;EACtB,QAAM8L,MAAM,GAAG,IAAf;EADsB,QAEdmF,MAFc,GAESnF,MAFT,CAEdmF,MAFc;EAAA,QAEN7C,UAFM,GAEStC,MAFT,CAENsC,UAFM;EAGtB6C,IAAAA,MAAM,CAAClR,UAAP,CAAkBC,QAAlB;;EACA,QAAI8L,MAAM,CAACmB,MAAP,CAAckM,gBAAd,IAAkCnZ,QAAQ,KAAK,CAAnD,EAAsD;EACpD,UAAIonC,cAAc,GAAG,KAArB;EACAn2B,MAAAA,MAAM,CAACvO,aAAP,CAAqB,YAAM;EACzB,YAAI0kC,cAAJ,EAAoB;EACpB,YAAI,CAACt7B,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC;EACjCm7B,QAAAA,cAAc,GAAG,IAAjB;EACAt7B,QAAAA,MAAM,CAACmO,SAAP,GAAmB,KAAnB;EACA,YAAMotB,aAAa,GAAG,CAAC,qBAAD,EAAwB,eAAxB,CAAtB;;EACA,aAAK,IAAIjqC,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGiqC,aAAa,CAAC/xC,MAAlC,EAA0C8H,CAAC,IAAI,CAA/C,EAAkD;EAChDgR,UAAAA,UAAU,CAACpM,OAAX,CAAmBqlC,aAAa,CAACjqC,CAAD,CAAhC;EACD;EACF,OATD;EAUD;EACF;EAzCU,CAAb;AA4CA,mBAAe;EACbyO,EAAAA,IAAI,EAAE,aADO;EAEboB,EAAAA,MAAM,EAAE;EACNi6B,IAAAA,UAAU,EAAE;EACVC,MAAAA,SAAS,EAAE;EADD;EADN,GAFK;EAObhuC,EAAAA,MAPa,oBAOJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBo7B,MAAAA,UAAU,eACLJ,IADK;EADc,KAAT,CAAjB;EAKD,GAdY;EAeb5mC,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EACjB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EACA,UAAMkH,eAAe,GAAG;EACtBhc,QAAAA,aAAa,EAAE,CADO;EAEtBJ,QAAAA,eAAe,EAAE,CAFK;EAGtBc,QAAAA,cAAc,EAAE,CAHM;EAItB+B,QAAAA,mBAAmB,EAAE,IAJC;EAKtBtD,QAAAA,YAAY,EAAE,CALQ;EAMtBkH,QAAAA,gBAAgB,EAAE;EANI,OAAxB;EAQAnkB,MAAAA,QAAM,CAAC8W,MAAM,CAACmB,MAAR,EAAgB6hB,eAAhB,CAAN;EACA95B,MAAAA,QAAM,CAAC8W,MAAM,CAAC2b,cAAR,EAAwBqH,eAAxB,CAAN;EACD,KAdC;EAeFzV,IAAAA,YAfE,wBAeWvN,MAfX,EAemB;EACnB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAACo7B,UAAP,CAAkB7tB,YAAlB;EACD,KAlBC;EAmBFxD,IAAAA,aAnBE,yBAmBY/J,MAnBZ,EAmBoB9L,QAnBpB,EAmB8B;EAC9B,UAAI8L,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAACo7B,UAAP,CAAkBrxB,aAAlB,CAAgC7V,QAAhC;EACD;EAtBC;EAfS,CAAf;;EC3CA,IAAMsnC,IAAI,GAAG;EACXjuB,EAAAA,YADW,0BACI;EACb,QAAMvN,MAAM,GAAG,IAAf;EADa,QAGXoC,GAHW,GAWTpC,MAXS,CAGXoC,GAHW;EAAA,QAIXE,UAJW,GAWTtC,MAXS,CAIXsC,UAJW;EAAA,QAKX6C,MALW,GAWTnF,MAXS,CAKXmF,MALW;EAAA,QAMJif,WANI,GAWTpkB,MAXS,CAMXxB,KANW;EAAA,QAOH6lB,YAPG,GAWTrkB,MAXS,CAOXtB,MAPW;EAAA,QAQGkG,GARH,GAWT5E,MAXS,CAQX6E,YARW;EAAA,QASLF,UATK,GAWT3E,MAXS,CASXoE,IATW;EAAA,QAUX/E,OAVW,GAWTW,MAXS,CAUXX,OAVW;EAYb,QAAM8B,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAcs6B,UAA7B;EACA,QAAM13B,YAAY,GAAG/D,MAAM,CAAC+D,YAAP,EAArB;EACA,QAAMgB,SAAS,GAAG/E,MAAM,CAACgF,OAAP,IAAkBhF,MAAM,CAACmB,MAAP,CAAc6D,OAAd,CAAsBC,OAA1D;EACA,QAAIy2B,aAAa,GAAG,CAApB;EACA,QAAIC,aAAJ;;EACA,QAAIx6B,MAAM,CAACy6B,MAAX,EAAmB;EACjB,UAAI73B,YAAJ,EAAkB;EAChB43B,QAAAA,aAAa,GAAGr5B,UAAU,CAAC9H,IAAX,CAAgB,qBAAhB,CAAhB;;EACA,YAAImhC,aAAa,CAACnyC,MAAd,KAAyB,CAA7B,EAAgC;EAC9BmyC,UAAAA,aAAa,GAAGjqC,CAAC,CAAC,wCAAD,CAAjB;EACA4Q,UAAAA,UAAU,CAACnJ,MAAX,CAAkBwiC,aAAlB;EACD;;EACDA,QAAAA,aAAa,CAACxjC,GAAd,CAAkB;EAAEuG,UAAAA,MAAM,EAAK0lB,WAAL;EAAR,SAAlB;EACD,OAPD,MAOO;EACLuX,QAAAA,aAAa,GAAGv5B,GAAG,CAAC5H,IAAJ,CAAS,qBAAT,CAAhB;;EACA,YAAImhC,aAAa,CAACnyC,MAAd,KAAyB,CAA7B,EAAgC;EAC9BmyC,UAAAA,aAAa,GAAGjqC,CAAC,CAAC,wCAAD,CAAjB;EACA0Q,UAAAA,GAAG,CAACjJ,MAAJ,CAAWwiC,aAAX;EACD;EACF;EACF;;EACD,SAAK,IAAIrqC,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,UAAMmxB,QAAQ,GAAGtd,MAAM,CAAClM,EAAP,CAAU3H,CAAV,CAAjB;EACA,UAAIqU,UAAU,GAAGrU,CAAjB;;EACA,UAAIyT,SAAJ,EAAe;EACbY,QAAAA,UAAU,GAAG1B,QAAQ,CAACwe,QAAQ,CAAC/uB,IAAT,CAAc,yBAAd,CAAD,EAA2C,EAA3C,CAArB;EACD;;EACD,UAAImoC,UAAU,GAAGl2B,UAAU,GAAG,EAA9B;EACA,UAAIwwB,KAAK,GAAGtvB,IAAI,CAACC,KAAL,CAAW+0B,UAAU,GAAG,GAAxB,CAAZ;;EACA,UAAIj3B,GAAJ,EAAS;EACPi3B,QAAAA,UAAU,GAAG,CAACA,UAAd;EACA1F,QAAAA,KAAK,GAAGtvB,IAAI,CAACC,KAAL,CAAW,CAAC+0B,UAAD,GAAc,GAAzB,CAAR;EACD;;EACD,UAAM7wB,QAAQ,GAAGnE,IAAI,CAACK,GAAL,CAASL,IAAI,CAACiB,GAAL,CAAS2a,QAAQ,CAAC,CAAD,CAAR,CAAYzX,QAArB,EAA+B,CAA/B,CAAT,EAA4C,CAAC,CAA7C,CAAjB;EACA,UAAIiwB,EAAE,GAAG,CAAT;EACA,UAAIC,EAAE,GAAG,CAAT;EACA,UAAIY,EAAE,GAAG,CAAT;;EACA,UAAIn2B,UAAU,GAAG,CAAb,KAAmB,CAAvB,EAA0B;EACxBs1B,QAAAA,EAAE,GAAG,CAAC9E,KAAD,GAAS,CAAT,GAAaxxB,UAAlB;EACAm3B,QAAAA,EAAE,GAAG,CAAL;EACD,OAHD,MAGO,IAAI,CAACn2B,UAAU,GAAG,CAAd,IAAmB,CAAnB,KAAyB,CAA7B,EAAgC;EACrCs1B,QAAAA,EAAE,GAAG,CAAL;EACAa,QAAAA,EAAE,GAAG,CAAC3F,KAAD,GAAS,CAAT,GAAaxxB,UAAlB;EACD,OAHM,MAGA,IAAI,CAACgB,UAAU,GAAG,CAAd,IAAmB,CAAnB,KAAyB,CAA7B,EAAgC;EACrCs1B,QAAAA,EAAE,GAAGt2B,UAAU,GAAGwxB,KAAK,GAAG,CAAR,GAAYxxB,UAA9B;EACAm3B,QAAAA,EAAE,GAAGn3B,UAAL;EACD,OAHM,MAGA,IAAI,CAACgB,UAAU,GAAG,CAAd,IAAmB,CAAnB,KAAyB,CAA7B,EAAgC;EACrCs1B,QAAAA,EAAE,GAAG,CAACt2B,UAAN;EACAm3B,QAAAA,EAAE,GAAG,IAAIn3B,UAAJ,GAAiBA,UAAU,GAAG,CAAb,GAAiBwxB,KAAvC;EACD;;EACD,UAAIvxB,GAAJ,EAAS;EACPq2B,QAAAA,EAAE,GAAG,CAACA,EAAN;EACD;;EAED,UAAI,CAACl3B,YAAL,EAAmB;EACjBm3B,QAAAA,EAAE,GAAGD,EAAL;EACAA,QAAAA,EAAE,GAAG,CAAL;EACD;;EAED,UAAMjnC,SAAS,iBAAc+P,YAAY,GAAG,CAAH,GAAO,CAAC83B,UAAlC,uBACb93B,YAAY,GAAG83B,UAAH,GAAgB,CADf,0BAEKZ,EAFL,YAEcC,EAFd,YAEuBY,EAFvB,QAAf;;EAGA,UAAI9wB,QAAQ,IAAI,CAAZ,IAAiBA,QAAQ,GAAG,CAAC,CAAjC,EAAoC;EAClC0wB,QAAAA,aAAa,GAAG/1B,UAAU,GAAG,EAAb,GAAkBqF,QAAQ,GAAG,EAA7C;EACA,YAAIpG,GAAJ,EAAS82B,aAAa,GAAG,CAAC/1B,UAAD,GAAc,EAAd,GAAmBqF,QAAQ,GAAG,EAA9C;EACV;;EACDyX,MAAAA,QAAQ,CAACzuB,SAAT,CAAmBA,SAAnB;;EACA,UAAImN,MAAM,CAAC46B,YAAX,EAAyB;EACvB;EACA,YAAIC,YAAY,GAAGj4B,YAAY,GAC3B0e,QAAQ,CAACjoB,IAAT,CAAc,2BAAd,CAD2B,GAE3BioB,QAAQ,CAACjoB,IAAT,CAAc,0BAAd,CAFJ;EAGA,YAAIyhC,WAAW,GAAGl4B,YAAY,GAC1B0e,QAAQ,CAACjoB,IAAT,CAAc,4BAAd,CAD0B,GAE1BioB,QAAQ,CAACjoB,IAAT,CAAc,6BAAd,CAFJ;;EAGA,YAAIwhC,YAAY,CAACxyC,MAAb,KAAwB,CAA5B,EAA+B;EAC7BwyC,UAAAA,YAAY,GAAGtqC,CAAC,wCACqBqS,YAAY,GAAG,MAAH,GAAY,KAD7C,gBAAhB;EAGA0e,UAAAA,QAAQ,CAACtpB,MAAT,CAAgB6iC,YAAhB;EACD;;EACD,YAAIC,WAAW,CAACzyC,MAAZ,KAAuB,CAA3B,EAA8B;EAC5ByyC,UAAAA,WAAW,GAAGvqC,CAAC,wCACsBqS,YAAY,GAAG,OAAH,GAAa,QAD/C,gBAAf;EAGA0e,UAAAA,QAAQ,CAACtpB,MAAT,CAAgB8iC,WAAhB;EACD;;EACD,YAAID,YAAY,CAACxyC,MAAjB,EAAyBwyC,YAAY,CAAC,CAAD,CAAZ,CAAgBxxC,KAAhB,CAAsBsiC,OAAtB,GAAgCjmB,IAAI,CAACK,GAAL,CAAS,CAAC8D,QAAV,EAAoB,CAApB,CAAhC;EACzB,YAAIixB,WAAW,CAACzyC,MAAhB,EAAwByyC,WAAW,CAAC,CAAD,CAAX,CAAezxC,KAAf,CAAqBsiC,OAArB,GAA+BjmB,IAAI,CAACK,GAAL,CAAS8D,QAAT,EAAmB,CAAnB,CAA/B;EACzB;EACF;;EACD1I,IAAAA,UAAU,CAACnK,GAAX,CAAe;EACb,gDAAwCwM,UAAU,GAAG,CAArD,OADa;EAEb,6CAAqCA,UAAU,GAAG,CAAlD,OAFa;EAGb,4CAAoCA,UAAU,GAAG,CAAjD,OAHa;EAIb,wCAAgCA,UAAU,GAAG,CAA7C;EAJa,KAAf;;EAOA,QAAIxD,MAAM,CAACy6B,MAAX,EAAmB;EACjB,UAAI73B,YAAJ,EAAkB;EAChB43B,QAAAA,aAAa,CAAC3nC,SAAd,wBACsBowB,WAAW,GAAG,CAAd,GAAkBjjB,MAAM,CAAC+6B,YAD/C,aAEI,CAAC9X,WAAD,GAAe,CAFnB,+CAG4CjjB,MAAM,CAACg7B,WAHnD;EAKD,OAND,MAMO;EACL,YAAMC,WAAW,GAAGv1B,IAAI,CAAC4B,GAAL,CAASizB,aAAT,IAA0B70B,IAAI,CAACC,KAAL,CAAWD,IAAI,CAAC4B,GAAL,CAASizB,aAAT,IAA0B,EAArC,IAA2C,EAAzF;EACA,YAAMxwB,UAAU,GACd,OACCrE,IAAI,CAACw1B,GAAL,CAAUD,WAAW,GAAG,CAAd,GAAkBv1B,IAAI,CAACyP,EAAxB,GAA8B,GAAvC,IAA8C,CAA9C,GACCzP,IAAI,CAACy1B,GAAL,CAAUF,WAAW,GAAG,CAAd,GAAkBv1B,IAAI,CAACyP,EAAxB,GAA8B,GAAvC,IAA8C,CAFhD,CADF;EAIA,YAAMimB,MAAM,GAAGp7B,MAAM,CAACg7B,WAAtB;EACA,YAAMK,MAAM,GAAGr7B,MAAM,CAACg7B,WAAP,GAAqBjxB,UAApC;EACA,YAAM1T,MAAM,GAAG2J,MAAM,CAAC+6B,YAAtB;EACAP,QAAAA,aAAa,CAAC3nC,SAAd,cACauoC,MADb,aAC2BC,MAD3B,4BACuDnY,YAAY,GAAG,CAAf,GAAmB7sB,MAD1E,aAEI,CAAC6sB,YAAD,GAAgB,CAAhB,GAAoBmY,MAFxB;EAKD;EACF;;EACD,QAAMC,OAAO,GAAGp9B,OAAO,CAACE,QAAR,IAAoBF,OAAO,CAACK,SAA5B,GAAwC,CAACiF,UAAD,GAAc,CAAtD,GAA0D,CAA1E;EACArC,IAAAA,UAAU,CAACtO,SAAX,wBACuByoC,OADvB,qBAEIz8B,MAAM,CAAC+D,YAAP,KAAwB,CAAxB,GAA4B23B,aAFhC,uBAGkB17B,MAAM,CAAC+D,YAAP,KAAwB,CAAC23B,aAAzB,GAAyC,CAH3D;EAKD,GA5IU;EA6IX3xB,EAAAA,aA7IW,yBA6IG7V,QA7IH,EA6Ia;EACtB,QAAM8L,MAAM,GAAG,IAAf;EADsB,QAEdoC,GAFc,GAEEpC,MAFF,CAEdoC,GAFc;EAAA,QAET+C,MAFS,GAEEnF,MAFF,CAETmF,MAFS;EAGtBA,IAAAA,MAAM,CACHlR,UADH,CACcC,QADd,EAEGsG,IAFH,CAGI,8GAHJ,EAKGvG,UALH,CAKcC,QALd;;EAMA,QAAI8L,MAAM,CAACmB,MAAP,CAAcs6B,UAAd,CAAyBG,MAAzB,IAAmC,CAAC57B,MAAM,CAAC+D,YAAP,EAAxC,EAA+D;EAC7D3B,MAAAA,GAAG,CAAC5H,IAAJ,CAAS,qBAAT,EAAgCvG,UAAhC,CAA2CC,QAA3C;EACD;EACF;EAzJU,CAAb;AA4JA,mBAAe;EACb6L,EAAAA,IAAI,EAAE,aADO;EAEboB,EAAAA,MAAM,EAAE;EACNs6B,IAAAA,UAAU,EAAE;EACVM,MAAAA,YAAY,EAAE,IADJ;EAEVH,MAAAA,MAAM,EAAE,IAFE;EAGVM,MAAAA,YAAY,EAAE,EAHJ;EAIVC,MAAAA,WAAW,EAAE;EAJH;EADN,GAFK;EAUb9uC,EAAAA,MAVa,oBAUJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBy7B,MAAAA,UAAU,eACLD,IADK;EADc,KAAT,CAAjB;EAKD,GAjBY;EAkBbpnC,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EACjB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EACA9b,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EACA,UAAMkH,eAAe,GAAG;EACtBhc,QAAAA,aAAa,EAAE,CADO;EAEtBJ,QAAAA,eAAe,EAAE,CAFK;EAGtBc,QAAAA,cAAc,EAAE,CAHM;EAItB+B,QAAAA,mBAAmB,EAAE,IAJC;EAKtBsN,QAAAA,eAAe,EAAE,CALK;EAMtB5Q,QAAAA,YAAY,EAAE,CANQ;EAOtBqC,QAAAA,cAAc,EAAE,KAPM;EAQtB6E,QAAAA,gBAAgB,EAAE;EARI,OAAxB;EAUAnkB,MAAAA,QAAM,CAAC8W,MAAM,CAACmB,MAAR,EAAgB6hB,eAAhB,CAAN;EACA95B,MAAAA,QAAM,CAAC8W,MAAM,CAAC2b,cAAR,EAAwBqH,eAAxB,CAAN;EACD,KAjBC;EAkBFzV,IAAAA,YAlBE,wBAkBWvN,MAlBX,EAkBmB;EACnB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAACy7B,UAAP,CAAkBluB,YAAlB;EACD,KArBC;EAsBFxD,IAAAA,aAtBE,yBAsBY/J,MAtBZ,EAsBoB9L,QAtBpB,EAsB8B;EAC9B,UAAI8L,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAACy7B,UAAP,CAAkB1xB,aAAlB,CAAgC7V,QAAhC;EACD;EAzBC;EAlBS,CAAf;;EC5JA,IAAMwoC,IAAI,GAAG;EACXnvB,EAAAA,YADW,0BACI;EACb,QAAMvN,MAAM,GAAG,IAAf;EADa,QAELmF,MAFK,GAEyBnF,MAFzB,CAELmF,MAFK;EAAA,QAEiBP,GAFjB,GAEyB5E,MAFzB,CAEG6E,YAFH;;EAGb,SAAK,IAAIvT,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAG6T,MAAM,CAAC3b,MAA3B,EAAmC8H,CAAC,IAAI,CAAxC,EAA2C;EACzC,UAAMmxB,QAAQ,GAAGtd,MAAM,CAAClM,EAAP,CAAU3H,CAAV,CAAjB;EACA,UAAI0Z,QAAQ,GAAGyX,QAAQ,CAAC,CAAD,CAAR,CAAYzX,QAA3B;;EACA,UAAIhL,MAAM,CAACmB,MAAP,CAAcw7B,UAAd,CAAyBC,aAA7B,EAA4C;EAC1C5xB,QAAAA,QAAQ,GAAGnE,IAAI,CAACK,GAAL,CAASL,IAAI,CAACiB,GAAL,CAAS2a,QAAQ,CAAC,CAAD,CAAR,CAAYzX,QAArB,EAA+B,CAA/B,CAAT,EAA4C,CAAC,CAA7C,CAAX;EACD;;EACD,UAAMxT,MAAM,GAAGirB,QAAQ,CAAC,CAAD,CAAR,CAAYvY,iBAA3B;EACA,UAAM2yB,MAAM,GAAG,CAAC,GAAD,GAAO7xB,QAAtB;EACA,UAAI8xB,OAAO,GAAGD,MAAd;EACA,UAAIE,OAAO,GAAG,CAAd;EACA,UAAI9B,EAAE,GAAG,CAACzjC,MAAV;EACA,UAAI0jC,EAAE,GAAG,CAAT;;EACA,UAAI,CAACl7B,MAAM,CAAC+D,YAAP,EAAL,EAA4B;EAC1Bm3B,QAAAA,EAAE,GAAGD,EAAL;EACAA,QAAAA,EAAE,GAAG,CAAL;EACA8B,QAAAA,OAAO,GAAG,CAACD,OAAX;EACAA,QAAAA,OAAO,GAAG,CAAV;EACD,OALD,MAKO,IAAIl4B,GAAJ,EAAS;EACdk4B,QAAAA,OAAO,GAAG,CAACA,OAAX;EACD;;EAEDra,MAAAA,QAAQ,CAAC,CAAD,CAAR,CAAYj4B,KAAZ,CAAkBwyC,MAAlB,GAA2B,CAACn2B,IAAI,CAAC4B,GAAL,CAAS5B,IAAI,CAACsvB,KAAL,CAAWnrB,QAAX,CAAT,CAAD,GAAkC7F,MAAM,CAAC3b,MAApE;;EAEA,UAAIwW,MAAM,CAACmB,MAAP,CAAcw7B,UAAd,CAAyBZ,YAA7B,EAA2C;EACzC;EACA,YAAIC,YAAY,GAAGh8B,MAAM,CAAC+D,YAAP,KACf0e,QAAQ,CAACjoB,IAAT,CAAc,2BAAd,CADe,GAEfioB,QAAQ,CAACjoB,IAAT,CAAc,0BAAd,CAFJ;EAGA,YAAIyhC,WAAW,GAAGj8B,MAAM,CAAC+D,YAAP,KACd0e,QAAQ,CAACjoB,IAAT,CAAc,4BAAd,CADc,GAEdioB,QAAQ,CAACjoB,IAAT,CAAc,6BAAd,CAFJ;;EAGA,YAAIwhC,YAAY,CAACxyC,MAAb,KAAwB,CAA5B,EAA+B;EAC7BwyC,UAAAA,YAAY,GAAGtqC,CAAC,wCACqBsO,MAAM,CAAC+D,YAAP,KAAwB,MAAxB,GAAiC,KADtD,gBAAhB;EAGA0e,UAAAA,QAAQ,CAACtpB,MAAT,CAAgB6iC,YAAhB;EACD;;EACD,YAAIC,WAAW,CAACzyC,MAAZ,KAAuB,CAA3B,EAA8B;EAC5ByyC,UAAAA,WAAW,GAAGvqC,CAAC,wCACsBsO,MAAM,CAAC+D,YAAP,KAAwB,OAAxB,GAAkC,QADxD,gBAAf;EAGA0e,UAAAA,QAAQ,CAACtpB,MAAT,CAAgB8iC,WAAhB;EACD;;EACD,YAAID,YAAY,CAACxyC,MAAjB,EAAyBwyC,YAAY,CAAC,CAAD,CAAZ,CAAgBxxC,KAAhB,CAAsBsiC,OAAtB,GAAgCjmB,IAAI,CAACK,GAAL,CAAS,CAAC8D,QAAV,EAAoB,CAApB,CAAhC;EACzB,YAAIixB,WAAW,CAACzyC,MAAhB,EAAwByyC,WAAW,CAAC,CAAD,CAAX,CAAezxC,KAAf,CAAqBsiC,OAArB,GAA+BjmB,IAAI,CAACK,GAAL,CAAS8D,QAAT,EAAmB,CAAnB,CAA/B;EACzB;;EACDyX,MAAAA,QAAQ,CAACzuB,SAAT,kBACiBinC,EADjB,YAC0BC,EAD1B,yBACgD6B,OADhD,qBACuED,OADvE;EAGD;EACF,GAtDU;EAuDX/yB,EAAAA,aAvDW,yBAuDG7V,QAvDH,EAuDa;EACtB,QAAM8L,MAAM,GAAG,IAAf;EADsB,QAEdmF,MAFc,GAEsBnF,MAFtB,CAEdmF,MAFc;EAAA,QAEN8E,WAFM,GAEsBjK,MAFtB,CAENiK,WAFM;EAAA,QAEO3H,UAFP,GAEsBtC,MAFtB,CAEOsC,UAFP;EAGtB6C,IAAAA,MAAM,CACHlR,UADH,CACcC,QADd,EAEGsG,IAFH,CAGI,8GAHJ,EAKGvG,UALH,CAKcC,QALd;;EAMA,QAAI8L,MAAM,CAACmB,MAAP,CAAckM,gBAAd,IAAkCnZ,QAAQ,KAAK,CAAnD,EAAsD;EACpD,UAAIonC,cAAc,GAAG,KAArB,CADoD;;EAGpDn2B,MAAAA,MAAM,CAAClM,EAAP,CAAUgR,WAAV,EAAuBrT,aAAvB,CAAqC,SAASu6B,eAAT,GAA2B;EAC9D,YAAImK,cAAJ,EAAoB;EACpB,YAAI,CAACt7B,MAAD,IAAWA,MAAM,CAACG,SAAtB,EAAiC,OAF6B;;EAI9Dm7B,QAAAA,cAAc,GAAG,IAAjB;EACAt7B,QAAAA,MAAM,CAACmO,SAAP,GAAmB,KAAnB;EACA,YAAMotB,aAAa,GAAG,CAAC,qBAAD,EAAwB,eAAxB,CAAtB;;EACA,aAAK,IAAIjqC,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGiqC,aAAa,CAAC/xC,MAAlC,EAA0C8H,CAAC,IAAI,CAA/C,EAAkD;EAChDgR,UAAAA,UAAU,CAACpM,OAAX,CAAmBqlC,aAAa,CAACjqC,CAAD,CAAhC;EACD;EACF,OAVD;EAWD;EACF;EA/EU,CAAb;AAkFA,mBAAe;EACbyO,EAAAA,IAAI,EAAE,aADO;EAEboB,EAAAA,MAAM,EAAE;EACNw7B,IAAAA,UAAU,EAAE;EACVZ,MAAAA,YAAY,EAAE,IADJ;EAEVa,MAAAA,aAAa,EAAE;EAFL;EADN,GAFK;EAQbvvC,EAAAA,MARa,oBAQJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxB28B,MAAAA,UAAU,eACLD,IADK;EADc,KAAT,CAAjB;EAKD,GAfY;EAgBbtoC,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EACjB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EACA9b,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EACA,UAAMkH,eAAe,GAAG;EACtBhc,QAAAA,aAAa,EAAE,CADO;EAEtBJ,QAAAA,eAAe,EAAE,CAFK;EAGtBc,QAAAA,cAAc,EAAE,CAHM;EAItB+B,QAAAA,mBAAmB,EAAE,IAJC;EAKtBtD,QAAAA,YAAY,EAAE,CALQ;EAMtBkH,QAAAA,gBAAgB,EAAE;EANI,OAAxB;EAQAnkB,MAAAA,QAAM,CAAC8W,MAAM,CAACmB,MAAR,EAAgB6hB,eAAhB,CAAN;EACA95B,MAAAA,QAAM,CAAC8W,MAAM,CAAC2b,cAAR,EAAwBqH,eAAxB,CAAN;EACD,KAfC;EAgBFzV,IAAAA,YAhBE,wBAgBWvN,MAhBX,EAgBmB;EACnB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAAC28B,UAAP,CAAkBpvB,YAAlB;EACD,KAnBC;EAoBFxD,IAAAA,aApBE,yBAoBY/J,MApBZ,EAoBoB9L,QApBpB,EAoB8B;EAC9B,UAAI8L,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,MAA7B,EAAqC;EACrC5I,MAAAA,MAAM,CAAC28B,UAAP,CAAkB5yB,aAAlB,CAAgC7V,QAAhC;EACD;EAvBC;EAhBS,CAAf;;EClFA,IAAM+oC,SAAS,GAAG;EAChB1vB,EAAAA,YADgB,0BACD;EACb,QAAMvN,MAAM,GAAG,IAAf;EADa,QAEEokB,WAFF,GAEiEpkB,MAFjE,CAELxB,KAFK;EAAA,QAEuB6lB,YAFvB,GAEiErkB,MAFjE,CAEetB,MAFf;EAAA,QAEqCyG,MAFrC,GAEiEnF,MAFjE,CAEqCmF,MAFrC;EAAA,QAE6CK,eAF7C,GAEiExF,MAFjE,CAE6CwF,eAF7C;EAGb,QAAMrE,MAAM,GAAGnB,MAAM,CAACmB,MAAP,CAAc+7B,eAA7B;EACA,QAAMn5B,YAAY,GAAG/D,MAAM,CAAC+D,YAAP,EAArB;EACA,QAAM/P,SAAS,GAAGgM,MAAM,CAACsK,SAAzB;EACA,QAAM6yB,MAAM,GAAGp5B,YAAY,GAAG,CAAC/P,SAAD,GAAaowB,WAAW,GAAG,CAA9B,GAAkC,CAACpwB,SAAD,GAAaqwB,YAAY,GAAG,CAAzF;EACA,QAAMwY,MAAM,GAAG94B,YAAY,GAAG5C,MAAM,CAAC07B,MAAV,GAAmB,CAAC17B,MAAM,CAAC07B,MAAtD;EACA,QAAMvyB,SAAS,GAAGnJ,MAAM,CAACi8B,KAAzB,CARa;;EAUb,SAAK,IAAI9rC,CAAC,GAAG,CAAR,EAAW9H,MAAM,GAAG2b,MAAM,CAAC3b,MAAhC,EAAwC8H,CAAC,GAAG9H,MAA5C,EAAoD8H,CAAC,IAAI,CAAzD,EAA4D;EAC1D,UAAMmxB,QAAQ,GAAGtd,MAAM,CAAClM,EAAP,CAAU3H,CAAV,CAAjB;EACA,UAAM6V,SAAS,GAAG3B,eAAe,CAAClU,CAAD,CAAjC;EACA,UAAM+rC,WAAW,GAAG5a,QAAQ,CAAC,CAAD,CAAR,CAAYvY,iBAAhC;EACA,UAAMozB,gBAAgB,GACnB,CAACH,MAAM,GAAGE,WAAT,GAAuBl2B,SAAS,GAAG,CAApC,IAAyCA,SAA1C,GAAuDhG,MAAM,CAACo8B,QADhE;EAGA,UAAIT,OAAO,GAAG/4B,YAAY,GAAG84B,MAAM,GAAGS,gBAAZ,GAA+B,CAAzD;EACA,UAAIP,OAAO,GAAGh5B,YAAY,GAAG,CAAH,GAAO84B,MAAM,GAAGS,gBAA1C,CAR0D;;EAU1D,UAAIE,UAAU,GAAG,CAAClzB,SAAD,GAAazD,IAAI,CAAC4B,GAAL,CAAS60B,gBAAT,CAA9B;EAEA,UAAIG,OAAO,GAAGt8B,MAAM,CAACs8B,OAArB,CAZ0D;;EAc1D,UAAI,OAAOA,OAAP,KAAmB,QAAnB,IAA+BA,OAAO,CAACtuC,OAAR,CAAgB,GAAhB,MAAyB,CAAC,CAA7D,EAAgE;EAC9DsuC,QAAAA,OAAO,GAAIrmC,UAAU,CAAC+J,MAAM,CAACs8B,OAAR,CAAV,GAA6B,GAA9B,GAAqCt2B,SAA/C;EACD;;EACD,UAAIyqB,UAAU,GAAG7tB,YAAY,GAAG,CAAH,GAAO05B,OAAO,GAAGH,gBAA9C;EACA,UAAI3L,UAAU,GAAG5tB,YAAY,GAAG05B,OAAO,GAAGH,gBAAb,GAAgC,CAA7D;EAEA,UAAIrS,KAAK,GAAG,IAAI,CAAC,IAAI9pB,MAAM,CAAC8pB,KAAZ,IAAqBpkB,IAAI,CAAC4B,GAAL,CAAS60B,gBAAT,CAArC,CApB0D;;EAuB1D,UAAIz2B,IAAI,CAAC4B,GAAL,CAASkpB,UAAT,IAAuB,KAA3B,EAAkCA,UAAU,GAAG,CAAb;EAClC,UAAI9qB,IAAI,CAAC4B,GAAL,CAASmpB,UAAT,IAAuB,KAA3B,EAAkCA,UAAU,GAAG,CAAb;EAClC,UAAI/qB,IAAI,CAAC4B,GAAL,CAAS+0B,UAAT,IAAuB,KAA3B,EAAkCA,UAAU,GAAG,CAAb;EAClC,UAAI32B,IAAI,CAAC4B,GAAL,CAASq0B,OAAT,IAAoB,KAAxB,EAA+BA,OAAO,GAAG,CAAV;EAC/B,UAAIj2B,IAAI,CAAC4B,GAAL,CAASs0B,OAAT,IAAoB,KAAxB,EAA+BA,OAAO,GAAG,CAAV;EAC/B,UAAIl2B,IAAI,CAAC4B,GAAL,CAASwiB,KAAT,IAAkB,KAAtB,EAA6BA,KAAK,GAAG,CAAR;EAE7B,UAAMyS,cAAc,oBAAkB/L,UAAlB,WAAkCC,UAAlC,WAAkD4L,UAAlD,qBAA4ET,OAA5E,qBAAmGD,OAAnG,mBAAwH7R,KAAxH,MAApB;EAEAxI,MAAAA,QAAQ,CAACzuB,SAAT,CAAmB0pC,cAAnB;EACAjb,MAAAA,QAAQ,CAAC,CAAD,CAAR,CAAYj4B,KAAZ,CAAkBwyC,MAAlB,GAA2B,CAACn2B,IAAI,CAAC4B,GAAL,CAAS5B,IAAI,CAACsvB,KAAL,CAAWmH,gBAAX,CAAT,CAAD,GAA0C,CAArE;;EACA,UAAIn8B,MAAM,CAAC46B,YAAX,EAAyB;EACvB;EACA,YAAI4B,eAAe,GAAG55B,YAAY,GAC9B0e,QAAQ,CAACjoB,IAAT,CAAc,2BAAd,CAD8B,GAE9BioB,QAAQ,CAACjoB,IAAT,CAAc,0BAAd,CAFJ;EAGA,YAAIojC,cAAc,GAAG75B,YAAY,GAC7B0e,QAAQ,CAACjoB,IAAT,CAAc,4BAAd,CAD6B,GAE7BioB,QAAQ,CAACjoB,IAAT,CAAc,6BAAd,CAFJ;;EAGA,YAAImjC,eAAe,CAACn0C,MAAhB,KAA2B,CAA/B,EAAkC;EAChCm0C,UAAAA,eAAe,GAAGjsC,CAAC,wCACkBqS,YAAY,GAAG,MAAH,GAAY,KAD1C,gBAAnB;EAGA0e,UAAAA,QAAQ,CAACtpB,MAAT,CAAgBwkC,eAAhB;EACD;;EACD,YAAIC,cAAc,CAACp0C,MAAf,KAA0B,CAA9B,EAAiC;EAC/Bo0C,UAAAA,cAAc,GAAGlsC,CAAC,wCACmBqS,YAAY,GAAG,OAAH,GAAa,QAD5C,gBAAlB;EAGA0e,UAAAA,QAAQ,CAACtpB,MAAT,CAAgBykC,cAAhB;EACD;;EACD,YAAID,eAAe,CAACn0C,MAApB,EACEm0C,eAAe,CAAC,CAAD,CAAf,CAAmBnzC,KAAnB,CAAyBsiC,OAAzB,GAAmCwQ,gBAAgB,GAAG,CAAnB,GAAuBA,gBAAvB,GAA0C,CAA7E;EACF,YAAIM,cAAc,CAACp0C,MAAnB,EACEo0C,cAAc,CAAC,CAAD,CAAd,CAAkBpzC,KAAlB,CAAwBsiC,OAAxB,GAAkC,CAACwQ,gBAAD,GAAoB,CAApB,GAAwB,CAACA,gBAAzB,GAA4C,CAA9E;EACH;EACF;EACF,GAvEe;EAwEhBvzB,EAAAA,aAxEgB,yBAwEF7V,QAxEE,EAwEQ;EACtB,QAAM8L,MAAM,GAAG,IAAf;EACAA,IAAAA,MAAM,CAACmF,MAAP,CACGlR,UADH,CACcC,QADd,EAEGsG,IAFH,CAGI,8GAHJ,EAKGvG,UALH,CAKcC,QALd;EAMD;EAhFe,CAAlB;AAmFA,wBAAe;EACb6L,EAAAA,IAAI,EAAE,kBADO;EAEboB,EAAAA,MAAM,EAAE;EACN+7B,IAAAA,eAAe,EAAE;EACfL,MAAAA,MAAM,EAAE,EADO;EAEfY,MAAAA,OAAO,EAAE,CAFM;EAGfL,MAAAA,KAAK,EAAE,GAHQ;EAIfnS,MAAAA,KAAK,EAAE,CAJQ;EAKfsS,MAAAA,QAAQ,EAAE,CALK;EAMfxB,MAAAA,YAAY,EAAE;EANC;EADX,GAFK;EAYb1uC,EAAAA,MAZa,oBAYJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxBk9B,MAAAA,eAAe,eACVD,SADU;EADS,KAAT,CAAjB;EAKD,GAnBY;EAoBb7oC,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EACjB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,WAA7B,EAA0C;EAE1C5I,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EACA9b,MAAAA,MAAM,CAAC3N,UAAP,CAAkB3D,IAAlB,CAA0BsR,MAAM,CAACmB,MAAP,CAAc2a,sBAAxC;EAEA9b,MAAAA,MAAM,CAACmB,MAAP,CAAcsI,mBAAd,GAAoC,IAApC;EACAzJ,MAAAA,MAAM,CAAC2b,cAAP,CAAsBlS,mBAAtB,GAA4C,IAA5C;EACD,KATC;EAUF8D,IAAAA,YAVE,wBAUWvN,MAVX,EAUmB;EACnB,UAAIA,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,WAA7B,EAA0C;EAC1C5I,MAAAA,MAAM,CAACk9B,eAAP,CAAuB3vB,YAAvB;EACD,KAbC;EAcFxD,IAAAA,aAdE,yBAcY/J,MAdZ,EAcoB9L,QAdpB,EAc8B;EAC9B,UAAI8L,MAAM,CAACmB,MAAP,CAAcyH,MAAd,KAAyB,WAA7B,EAA0C;EAC1C5I,MAAAA,MAAM,CAACk9B,eAAP,CAAuBnzB,aAAvB,CAAqC7V,QAArC;EACD;EAjBC;EApBS,CAAf;;ECnFA,IAAM2pC,MAAM,GAAG;EACb38B,EAAAA,IADa,kBACN;EACL,QAAMlB,MAAM,GAAG,IAAf;EADK,QAEW89B,YAFX,GAE4B99B,MAAM,CAACmB,MAFnC,CAEG48B,MAFH;EAGL,QAAI/9B,MAAM,CAAC+9B,MAAP,CAAc39B,WAAlB,EAA+B,OAAO,KAAP;EAC/BJ,IAAAA,MAAM,CAAC+9B,MAAP,CAAc39B,WAAd,GAA4B,IAA5B;EACA,QAAM49B,WAAW,GAAGh+B,MAAM,CAAChX,WAA3B;;EACA,QAAI80C,YAAY,CAAC99B,MAAb,YAA+Bg+B,WAAnC,EAAgD;EAC9Ch+B,MAAAA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAd,GAAuB89B,YAAY,CAAC99B,MAApC;EACA9W,MAAAA,QAAM,CAAC8W,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAd,CAAqB2b,cAAtB,EAAsC;EAC1ClS,QAAAA,mBAAmB,EAAE,IADqB;EAE1C0D,QAAAA,mBAAmB,EAAE;EAFqB,OAAtC,CAAN;EAIAjkB,MAAAA,QAAM,CAAC8W,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAd,CAAqBmB,MAAtB,EAA8B;EAClCsI,QAAAA,mBAAmB,EAAE,IADa;EAElC0D,QAAAA,mBAAmB,EAAE;EAFa,OAA9B,CAAN;EAID,KAVD,MAUO,IAAIrkB,UAAQ,CAACg1C,YAAY,CAAC99B,MAAd,CAAZ,EAAmC;EACxCA,MAAAA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAd,GAAuB,IAAIg+B,WAAJ,CACrB90C,QAAM,CAAC,EAAD,EAAK40C,YAAY,CAAC99B,MAAlB,EAA0B;EAC9B0J,QAAAA,qBAAqB,EAAE,IADO;EAE9BD,QAAAA,mBAAmB,EAAE,IAFS;EAG9B0D,QAAAA,mBAAmB,EAAE;EAHS,OAA1B,CADe,CAAvB;EAOAnN,MAAAA,MAAM,CAAC+9B,MAAP,CAAcE,aAAd,GAA8B,IAA9B;EACD;;EACDj+B,IAAAA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAd,CAAqBoC,GAArB,CAAyBnQ,QAAzB,CAAkC+N,MAAM,CAACmB,MAAP,CAAc48B,MAAd,CAAqBG,oBAAvD;EACAl+B,IAAAA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAd,CAAqB5L,EAArB,CAAwB,KAAxB,EAA+B4L,MAAM,CAAC+9B,MAAP,CAAcI,YAA7C;EACA,WAAO,IAAP;EACD,GA9BY;EA+BbA,EAAAA,YA/Ba,0BA+BE;EACb,QAAMn+B,MAAM,GAAG,IAAf;EACA,QAAMo+B,YAAY,GAAGp+B,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnC;EACA,QAAI,CAACo+B,YAAL,EAAmB;EACnB,QAAMlxB,YAAY,GAAGkxB,YAAY,CAAClxB,YAAlC;EACA,QAAMD,YAAY,GAAGmxB,YAAY,CAACnxB,YAAlC;EACA,QAAIA,YAAY,IAAIvb,CAAC,CAACub,YAAD,CAAD,CAAgB3Z,QAAhB,CAAyB0M,MAAM,CAACmB,MAAP,CAAc48B,MAAd,CAAqBM,qBAA9C,CAApB,EACE;EACF,QAAI,OAAOnxB,YAAP,KAAwB,WAAxB,IAAuCA,YAAY,KAAK,IAA5D,EAAkE;EAClE,QAAI6D,YAAJ;;EACA,QAAIqtB,YAAY,CAACj9B,MAAb,CAAoB+K,IAAxB,EAA8B;EAC5B6E,MAAAA,YAAY,GAAG9M,QAAQ,CAACvS,CAAC,CAAC0sC,YAAY,CAACnxB,YAAd,CAAD,CAA6BvZ,IAA7B,CAAkC,yBAAlC,CAAD,EAA+D,EAA/D,CAAvB;EACD,KAFD,MAEO;EACLqd,MAAAA,YAAY,GAAG7D,YAAf;EACD;;EACD,QAAIlN,MAAM,CAACmB,MAAP,CAAc+K,IAAlB,EAAwB;EACtB,UAAIoyB,YAAY,GAAGt+B,MAAM,CAACiK,WAA1B;;EACA,UAAIjK,MAAM,CAACmF,MAAP,CAAclM,EAAd,CAAiBqlC,YAAjB,EAA+BhrC,QAA/B,CAAwC0M,MAAM,CAACmB,MAAP,CAAcgL,mBAAtD,CAAJ,EAAgF;EAC9EnM,QAAAA,MAAM,CAACiQ,OAAP,GAD8E;;EAG9EjQ,QAAAA,MAAM,CAACkQ,WAAP,GAAqBlQ,MAAM,CAACsC,UAAP,CAAkB,CAAlB,EAAqB1K,UAA1C;EACA0mC,QAAAA,YAAY,GAAGt+B,MAAM,CAACiK,WAAtB;EACD;;EACD,UAAMuG,SAAS,GAAGxQ,MAAM,CAACmF,MAAP,CACflM,EADe,CACZqlC,YADY,EAEfrkC,OAFe,iCAEsB8W,YAFtB,UAGf9X,EAHe,CAGZ,CAHY,EAIfV,KAJe,EAAlB;EAKA,UAAMkE,SAAS,GAAGuD,MAAM,CAACmF,MAAP,CACflM,EADe,CACZqlC,YADY,EAEf1kC,OAFe,iCAEsBmX,YAFtB,UAGf9X,EAHe,CAGZ,CAHY,EAIfV,KAJe,EAAlB;EAKA,UAAI,OAAOiY,SAAP,KAAqB,WAAzB,EAAsCO,YAAY,GAAGtU,SAAf,CAAtC,KACK,IAAI,OAAOA,SAAP,KAAqB,WAAzB,EAAsCsU,YAAY,GAAGP,SAAf,CAAtC,KACA,IAAI/T,SAAS,GAAG6hC,YAAZ,GAA2BA,YAAY,GAAG9tB,SAA9C,EAAyDO,YAAY,GAAGtU,SAAf,CAAzD,KACAsU,YAAY,GAAGP,SAAf;EACN;;EACDxQ,IAAAA,MAAM,CAAC6O,OAAP,CAAekC,YAAf;EACD,GAtEY;EAuEbqB,EAAAA,MAvEa,kBAuENmsB,OAvEM,EAuEG;EACd,QAAMv+B,MAAM,GAAG,IAAf;EACA,QAAMo+B,YAAY,GAAGp+B,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnC;EACA,QAAI,CAACo+B,YAAL,EAAmB;EAEnB,QAAMp3B,aAAa,GACjBo3B,YAAY,CAACj9B,MAAb,CAAoB6F,aAApB,KAAsC,MAAtC,GACIo3B,YAAY,CAACttB,oBAAb,EADJ,GAEIstB,YAAY,CAACj9B,MAAb,CAAoB6F,aAH1B;EAKA,QAAMw3B,gBAAgB,GAAGx+B,MAAM,CAACmB,MAAP,CAAc48B,MAAd,CAAqBS,gBAA9C;EACA,QAAMC,SAAS,GAAGD,gBAAgB,IAAI,CAACJ,YAAY,CAACj9B,MAAb,CAAoB+K,IAA3D;;EACA,QAAIlM,MAAM,CAAC0L,SAAP,KAAqB0yB,YAAY,CAAC1yB,SAAlC,IAA+C+yB,SAAnD,EAA8D;EAC5D,UAAIC,kBAAkB,GAAGN,YAAY,CAACn0B,WAAtC;EACA,UAAI00B,cAAJ;EACA,UAAIhwB,SAAJ;;EACA,UAAIyvB,YAAY,CAACj9B,MAAb,CAAoB+K,IAAxB,EAA8B;EAC5B,YACEkyB,YAAY,CAACj5B,MAAb,CACGlM,EADH,CACMylC,kBADN,EAEGprC,QAFH,CAEY8qC,YAAY,CAACj9B,MAAb,CAAoBgL,mBAFhC,CADF,EAIE;EACAiyB,UAAAA,YAAY,CAACnuB,OAAb,GADA;;EAGAmuB,UAAAA,YAAY,CAACluB,WAAb,GAA2BkuB,YAAY,CAAC97B,UAAb,CAAwB,CAAxB,EAA2B1K,UAAtD;EACA8mC,UAAAA,kBAAkB,GAAGN,YAAY,CAACn0B,WAAlC;EACD,SAV2B;;;EAY5B,YAAM20B,eAAe,GAAGR,YAAY,CAACj5B,MAAb,CACrBlM,EADqB,CAClBylC,kBADkB,EAErBzkC,OAFqB,iCAEgB+F,MAAM,CAAC0L,SAFvB,UAGrBzS,EAHqB,CAGlB,CAHkB,EAIrBV,KAJqB,EAAxB;EAKA,YAAMsmC,eAAe,GAAGT,YAAY,CAACj5B,MAAb,CACrBlM,EADqB,CAClBylC,kBADkB,EAErB9kC,OAFqB,iCAEgBoG,MAAM,CAAC0L,SAFvB,UAGrBzS,EAHqB,CAGlB,CAHkB,EAIrBV,KAJqB,EAAxB;EAKA,YAAI,OAAOqmC,eAAP,KAA2B,WAA/B,EAA4CD,cAAc,GAAGE,eAAjB,CAA5C,KACK,IAAI,OAAOA,eAAP,KAA2B,WAA/B,EAA4CF,cAAc,GAAGC,eAAjB,CAA5C,KACA,IAAIC,eAAe,GAAGH,kBAAlB,KAAyCA,kBAAkB,GAAGE,eAAlE,EACHD,cAAc,GAAGD,kBAAjB,CADG,KAEA,IAAIG,eAAe,GAAGH,kBAAlB,GAAuCA,kBAAkB,GAAGE,eAAhE,EACHD,cAAc,GAAGE,eAAjB,CADG,KAEAF,cAAc,GAAGC,eAAjB;EACLjwB,QAAAA,SAAS,GAAG3O,MAAM,CAACiK,WAAP,GAAqBjK,MAAM,CAACyM,aAA5B,GAA4C,MAA5C,GAAqD,MAAjE;EACD,OA9BD,MA8BO;EACLkyB,QAAAA,cAAc,GAAG3+B,MAAM,CAAC0L,SAAxB;EACAiD,QAAAA,SAAS,GAAGgwB,cAAc,GAAG3+B,MAAM,CAACyM,aAAxB,GAAwC,MAAxC,GAAiD,MAA7D;EACD;;EACD,UAAIgyB,SAAJ,EAAe;EACbE,QAAAA,cAAc,IAAIhwB,SAAS,KAAK,MAAd,GAAuB6vB,gBAAvB,GAA0C,CAAC,CAAD,GAAKA,gBAAjE;EACD;;EAED,UACEJ,YAAY,CAAC3zB,oBAAb,IACA2zB,YAAY,CAAC3zB,oBAAb,CAAkCtb,OAAlC,CAA0CwvC,cAA1C,IAA4D,CAF9D,EAGE;EACA,YAAIP,YAAY,CAACj9B,MAAb,CAAoBqH,cAAxB,EAAwC;EACtC,cAAIm2B,cAAc,GAAGD,kBAArB,EAAyC;EACvCC,YAAAA,cAAc,GAAGA,cAAc,GAAG93B,IAAI,CAACC,KAAL,CAAWE,aAAa,GAAG,CAA3B,CAAjB,GAAiD,CAAlE;EACD,WAFD,MAEO;EACL23B,YAAAA,cAAc,GAAGA,cAAc,GAAG93B,IAAI,CAACC,KAAL,CAAWE,aAAa,GAAG,CAA3B,CAAjB,GAAiD,CAAlE;EACD;EACF,SAND,MAMO,IAAI23B,cAAc,GAAGD,kBAArB,EAAyC;EAC9CC,UAAAA,cAAc,GAAGA,cAAc,GAAG33B,aAAjB,GAAiC,CAAlD;EACD;;EACDo3B,QAAAA,YAAY,CAACvvB,OAAb,CAAqB8vB,cAArB,EAAqCJ,OAAO,GAAG,CAAH,GAAOhvC,SAAnD;EACD;EACF,KArEa;;;EAwEd,QAAIuvC,gBAAgB,GAAG,CAAvB;EACA,QAAMC,gBAAgB,GAAG/+B,MAAM,CAACmB,MAAP,CAAc48B,MAAd,CAAqBM,qBAA9C;;EAEA,QAAIr+B,MAAM,CAACmB,MAAP,CAAc6F,aAAd,GAA8B,CAA9B,IAAmC,CAAChH,MAAM,CAACmB,MAAP,CAAcqH,cAAtD,EAAsE;EACpEs2B,MAAAA,gBAAgB,GAAG9+B,MAAM,CAACmB,MAAP,CAAc6F,aAAjC;EACD;;EAED,QAAI,CAAChH,MAAM,CAACmB,MAAP,CAAc48B,MAAd,CAAqBiB,oBAA1B,EAAgD;EAC9CF,MAAAA,gBAAgB,GAAG,CAAnB;EACD;;EAEDA,IAAAA,gBAAgB,GAAGj4B,IAAI,CAACC,KAAL,CAAWg4B,gBAAX,CAAnB;EAEAV,IAAAA,YAAY,CAACj5B,MAAb,CAAoBvS,WAApB,CAAgCmsC,gBAAhC;;EACA,QACEX,YAAY,CAACj9B,MAAb,CAAoB+K,IAApB,IACCkyB,YAAY,CAACj9B,MAAb,CAAoB6D,OAApB,IAA+Bo5B,YAAY,CAACj9B,MAAb,CAAoB6D,OAApB,CAA4BC,OAF9D,EAGE;EACA,WAAK,IAAI3T,CAAC,GAAG,CAAb,EAAgBA,CAAC,GAAGwtC,gBAApB,EAAsCxtC,CAAC,IAAI,CAA3C,EAA8C;EAC5C8sC,QAAAA,YAAY,CAAC97B,UAAb,CACGhY,QADH,kCACyC0V,MAAM,CAAC0L,SAAP,GAAmBpa,CAD5D,WAEGW,QAFH,CAEY8sC,gBAFZ;EAGD;EACF,KATD,MASO;EACL,WAAK,IAAIztC,EAAC,GAAG,CAAb,EAAgBA,EAAC,GAAGwtC,gBAApB,EAAsCxtC,EAAC,IAAI,CAA3C,EAA8C;EAC5C8sC,QAAAA,YAAY,CAACj5B,MAAb,CAAoBlM,EAApB,CAAuB+G,MAAM,CAAC0L,SAAP,GAAmBpa,EAA1C,EAA6CW,QAA7C,CAAsD8sC,gBAAtD;EACD;EACF;EACF;EA3KY,CAAf;AA6KA,iBAAe;EACbh/B,EAAAA,IAAI,EAAE,QADO;EAEboB,EAAAA,MAAM,EAAE;EACN48B,IAAAA,MAAM,EAAE;EACN/9B,MAAAA,MAAM,EAAE,IADF;EAENg/B,MAAAA,oBAAoB,EAAE,IAFhB;EAGNR,MAAAA,gBAAgB,EAAE,CAHZ;EAINH,MAAAA,qBAAqB,EAAE,2BAJjB;EAKNH,MAAAA,oBAAoB,EAAE;EALhB;EADF,GAFK;EAWb7wC,EAAAA,MAXa,oBAWJ;EACP,QAAM2S,MAAM,GAAG,IAAf;EACAjD,IAAAA,iBAAiB,CAACiD,MAAD,EAAS;EACxB+9B,MAAAA,MAAM;EACJ/9B,QAAAA,MAAM,EAAE,IADJ;EAEJI,QAAAA,WAAW,EAAE;EAFT,SAGDy9B,MAHC;EADkB,KAAT,CAAjB;EAOD,GApBY;EAqBbzpC,EAAAA,EAAE,EAAE;EACF2uB,IAAAA,UADE,sBACS/iB,MADT,EACiB;EAAA,UACT+9B,MADS,GACE/9B,MAAM,CAACmB,MADT,CACT48B,MADS;EAEjB,UAAI,CAACA,MAAD,IAAW,CAACA,MAAM,CAAC/9B,MAAvB,EAA+B;EAC/BA,MAAAA,MAAM,CAAC+9B,MAAP,CAAc78B,IAAd;EACAlB,MAAAA,MAAM,CAAC+9B,MAAP,CAAc3rB,MAAd,CAAqB,IAArB;EACD,KANC;EAOFwgB,IAAAA,WAPE,uBAOU5yB,MAPV,EAOkB;EAClB,UAAI,CAACA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnB,EAA2B;EAC3BA,MAAAA,MAAM,CAAC+9B,MAAP,CAAc3rB,MAAd;EACD,KAVC;EAWFA,IAAAA,MAXE,kBAWKpS,MAXL,EAWa;EACb,UAAI,CAACA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnB,EAA2B;EAC3BA,MAAAA,MAAM,CAAC+9B,MAAP,CAAc3rB,MAAd;EACD,KAdC;EAeFnS,IAAAA,MAfE,kBAeKD,MAfL,EAea;EACb,UAAI,CAACA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnB,EAA2B;EAC3BA,MAAAA,MAAM,CAAC+9B,MAAP,CAAc3rB,MAAd;EACD,KAlBC;EAmBFvQ,IAAAA,cAnBE,0BAmBa7B,MAnBb,EAmBqB;EACrB,UAAI,CAACA,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnB,EAA2B;EAC3BA,MAAAA,MAAM,CAAC+9B,MAAP,CAAc3rB,MAAd;EACD,KAtBC;EAuBFrI,IAAAA,aAvBE,yBAuBY/J,MAvBZ,EAuBoB9L,QAvBpB,EAuB8B;EAC9B,UAAMkqC,YAAY,GAAGp+B,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnC;EACA,UAAI,CAACo+B,YAAL,EAAmB;EACnBA,MAAAA,YAAY,CAACr0B,aAAb,CAA2B7V,QAA3B;EACD,KA3BC;EA4BF+qC,IAAAA,aA5BE,yBA4BYj/B,MA5BZ,EA4BoB;EACpB,UAAMo+B,YAAY,GAAGp+B,MAAM,CAAC+9B,MAAP,CAAc/9B,MAAnC;EACA,UAAI,CAACo+B,YAAL,EAAmB;;EACnB,UAAIp+B,MAAM,CAAC+9B,MAAP,CAAcE,aAAd,IAA+BG,YAAnC,EAAiD;EAC/CA,QAAAA,YAAY,CAAC/8B,OAAb;EACD;EACF;EAlCC;EArBS,CAAf;;EChLA;EAKA,IAAM69B,UAAU,GAAG,CACjBhe,SADiB,YAAA,cAAA,cAAA,cAAA,aAAA,YAAA,QAAA,QAAA,cAAA,QAAA,WAAA,kBAAA,YAAA,YAAA,YAAA,YAAA,iBAAA,UAAA,CAAnB;EAIAjC,MAAM,CAAC4B,GAAP,CAAWqe,UAAX;;;;;;;;"}